/****** Create sequences ******/
CREATE SEQUENCE ACTIONS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ALERTRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ATOMICPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ATOMICRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE datasource_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE EDGEPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE EDGERUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE FILTERS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE FUNCTIONS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ROUTINEPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ROUTINERUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE RULES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONAGGREGATIONDAILY_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONAGGREGATIONHOURLY_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIATOMICPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIDEFAULTGLOBALPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIEDGEPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIGLOBALPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIROUTINEPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UITRANPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE SESSIONRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE SESSIONSPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE WORKSPACES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE FUNCTIONEDGE_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE PARADIGMINFODETAILS_S INCREMENT BY 1 START WITH 1;

/****** Table ACTIONIDTEMP ******/
CREATE TABLE ACTIONIDTEMP ( 
  ACTIONID NUMBER);

/****** Table ACTIONS ******/
CREATE TABLE ACTIONS ( 
  ACTIONID NUMBER NOT NULL, 
  NAME VARCHAR2 (50), 
  DESCRIPTION VARCHAR2 (100), 
  TYPE VARCHAR2 (200) NOT NULL, 
  ACTIONDATA VARCHAR2 (4000), 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ACTIONS
  PRIMARY KEY ( ACTIONID ) USING INDEX);

/****** Table ACTIONTOEDGE ******/
CREATE TABLE ACTIONTOEDGE ( 
  ACTIONID NUMBER DEFAULT 0 NOT NULL, 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEFROM NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUETO NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ACTIONTOEDGE
  PRIMARY KEY ( ACTIONID, EDGEPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) USING INDEX);

/****** Table ACTIONTOROUTINE ******/
CREATE TABLE ACTIONTOROUTINE ( 
  ACTIONID NUMBER DEFAULT 0 NOT NULL, 
  ROUTINEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEFROM NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUETO NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ACTIONTOROUTINE
  PRIMARY KEY ( ACTIONID, ROUTINEPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) USING INDEX);

/****** Table ACTIONTOTRANSACTION ******/
CREATE TABLE ACTIONTOTRANSACTION ( 
  ACTIONID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEFROM NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUETO NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ACTIONTOTRANSACTION
  PRIMARY KEY ( ACTIONID, TRANSACTIONPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) USING INDEX);

/****** Table AGGREGATIONCLEANIDTEMP ******/
CREATE TABLE AGGREGATIONCLEANIDTEMP ( 
  AGGREGATIONID NUMBER DEFAULT 0 NOT NULL);

/****** Table ALERTHISTORY ******/
CREATE TABLE ALERTHISTORY ( 
  ALERTID NUMBER DEFAULT 0 NOT NULL, 
  ALERTTYPE VARCHAR2 (50)  DEFAULT '' NOT NULL, 
  ALERTCREATED NUMBER DEFAULT 0 NOT NULL, 
  ALERTDATA VARCHAR2 (4000), 
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ALERTHISTORY
  PRIMARY KEY ( ALERTID ) USING INDEX);

/****** Table ALERTRUNTIME ******/
CREATE TABLE ALERTRUNTIME ( 
  ALERTID NUMBER DEFAULT 0 NOT NULL, 
  ALERTTYPE VARCHAR2 (50)  DEFAULT '' NOT NULL, 
  ALERTCREATED NUMBER DEFAULT 0 NOT NULL, 
  ALERTDATA VARCHAR2 (4000), 
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ALERTRUNTIME
  PRIMARY KEY ( ALERTID ) USING INDEX);

/****** Table ATOMICHISTORY ******/
CREATE TABLE ATOMICHISTORY ( 
  ATOMICID NUMBER DEFAULT 0 NOT NULL, 
  ATOMICPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  ATOMICDATA VARCHAR2 (4000), 
  DATAREF VARCHAR (250),
  METADATA VARCHAR2 (1450),
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ATOMICHISTORY
  PRIMARY KEY ( ATOMICID ) USING INDEX);

/****** Table ATOMICPARADIGM ******/
CREATE TABLE ATOMICPARADIGM ( 
  PARADIGMID NUMBER NOT NULL, 
  NAME VARCHAR2 (50) DEFAULT '', 
  DESCRIPTION VARCHAR2 (100), 
  DATASOURCE VARCHAR2 (200), 
  DATASOURCEFILTER VARCHAR2 (200), 
  TYPE VARCHAR2 (50), 
  DATA VARCHAR2 (4000), 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ATOMICPARADIGM
  PRIMARY KEY ( PARADIGMID ) USING INDEX);

/****** Table ATOMICRUNTIME ******/
CREATE TABLE ATOMICRUNTIME ( 
  ATOMICID NUMBER NOT NULL, 
  ATOMICPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  ATOMICDATA VARCHAR2 (4000), 
  DATAREF VARCHAR2 (250),
  METADATA VARCHAR2 (1450), 
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ATOMICRUNTIME
  PRIMARY KEY ( ATOMICID ) USING INDEX);

/****** Table datasource ******/
CREATE TABLE datasource (
  id NUMBER NOT NULL,
  dsName VARCHAR2 (100) NOT NULL,
  dsDescription VARCHAR2 (250),
  dsNodeId VARCHAR2 (45),
  dsLbmId VARCHAR2 (250) NOT NULL,
  dsFilterId VARCHAR2 (45),
  PRIMARY KEY( id ) USING INDEX);

/****** Table DUMMYROUTINERUNTIME ******/
CREATE TABLE DUMMYROUTINERUNTIME ( 
  ROUTINEKEY VARCHAR2 (1000), 
  ROUTINEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONRUNTIME NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER);

/****** Table EDGECLEANIDTEMP ******/
CREATE TABLE EDGECLEANIDTEMP ( 
  EDGEID NUMBER DEFAULT 0 NOT NULL);

/****** Table EDGEHISTORY ******/
CREATE TABLE EDGEHISTORY ( 
  EDGEID NUMBER DEFAULT 0 NOT NULL, 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  EDGETYPE VARCHAR2 (50)  DEFAULT '' NOT NULL, 
  TRANSACTIONRUNTIMEID NUMBER, 
  RUNTIMESOURCEID NUMBER, 
  RUNTIMETARGETID NUMBER, 
  SYSTEMSTATE NUMBER, 
  EDGECOUNT NUMBER DEFAULT 1 NOT NULL, 
  CONSTRAINT PK_EDGEHISTORY
  PRIMARY KEY ( EDGEID ) USING INDEX);

/****** Table EDGEIDTEMP ******/
CREATE TABLE EDGEIDTEMP ( 
  EDGEID NUMBER DEFAULT 0 NOT NULL);

/****** Table EDGEPARADIGM ******/
CREATE TABLE EDGEPARADIGM ( 
  PARADIGMID NUMBER NOT NULL, 
  NAME VARCHAR2 (50), 
  DESCRIPTION VARCHAR2 (100), 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  SOURCEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TARGETPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TYPE VARCHAR2 (50), 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  EDGEREPEAT NUMBER DEFAULT 1 NOT NULL, 
  LOGICTYPE NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_EDGEPARADIGM
  PRIMARY KEY ( PARADIGMID ) USING INDEX);

/****** Table EDGEPARADIGMIDTEMP ******/
CREATE TABLE EDGEPARADIGMIDTEMP ( 
  PARADIGMID NUMBER);

/****** Table EDGERUNTIME ******/
CREATE TABLE EDGERUNTIME ( 
  EDGEID NUMBER NOT NULL, 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  EDGETYPE VARCHAR2 (50) DEFAULT '' NOT NULL, 
  TRANSACTIONRUNTIMEID NUMBER, 
  RUNTIMESOURCEID NUMBER, 
  RUNTIMETARGETID NUMBER, 
  SYSTEMSTATE NUMBER, 
  EDGECOUNT NUMBER DEFAULT 1 NOT NULL, 
  CONSTRAINT PK_EDGERUNTIME
  PRIMARY KEY ( EDGEID ) USING INDEX);

/****** Table FILTERS ******/
CREATE TABLE FILTERS ( 
  FILTERID NUMBER NOT NULL, 
  ATOMICPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  NAME VARCHAR2 (50) DEFAULT '' NOT NULL, 
  DESCRIPTION VARCHAR2 (100), 
  TYPE VARCHAR2 (50) DEFAULT '' NOT NULL, 
  DATA VARCHAR2 (4000), 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER  DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER	DEFAULT 0 NOT NULL, 
  ISSTATUSFILTER NUMBER, 
  ISDISPLAYFILTER NUMBER, 
  CONSTRAINT PK_FILTERS
  PRIMARY KEY ( FILTERID ) USING INDEX);

/****** Table FUNCTIONIDTEMP ******/
CREATE TABLE FUNCTIONIDTEMP ( 
  FUNCTIONID  NUMBER);

/****** Table FUNCTIONS ******/
CREATE TABLE FUNCTIONS ( 
  FUNCTIONID NUMBER NOT NULL, 
  NAME VARCHAR2 (50), 
  DESCRIPTION VARCHAR2 (100), 
  TYPE VARCHAR2 (50) DEFAULT '' NOT NULL, 
  DATA VARCHAR2 (4000) NOT NULL, 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_FUNCTIONS
  PRIMARY KEY ( FUNCTIONID ) USING INDEX);

/****** Table FUNCTIONTOEDGE ******/
CREATE TABLE FUNCTIONTOEDGE ( 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  FUNCTIONID NUMBER DEFAULT 0 NOT NULL);

/****** Table ROUTINECLEANIDTEMP ******/
CREATE TABLE ROUTINECLEANIDTEMP ( 
  ROUTINERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ROUTINECLEANIDTEMP
  PRIMARY KEY ( ROUTINERUNTIMEID ) USING INDEX);

/****** Table ATOMICCLEANIDTEMP ******/
CREATE TABLE ATOMICCLEANIDTEMP (
  ATOMICRUNTIMEID NUMBER DEFAULT 0 NOT NULL,
  PRIMARY KEY ( ATOMICRUNTIMEID ) USING INDEX);

/****** Table ROUTINEHISTORY ******/
CREATE TABLE ROUTINEHISTORY ( 
  ROUTINEID NUMBER DEFAULT 0 NOT NULL, 
  ROUTINEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONRUNTIMEID NUMBER, 
  ATOMICRUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  TIMECREATED NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ROUTINEHISTORY
  PRIMARY KEY ( ROUTINEID ) USING INDEX);

/****** Table ROUTINEIDTEMP ******/
CREATE TABLE ROUTINEIDTEMP ( 
  ROUTINERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  ATOMICRUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ROUTINEIDTEMP
  PRIMARY KEY ( ROUTINERUNTIMEID ) USING INDEX);

/****** Table ROUTINEPARADIGM ******/
CREATE TABLE ROUTINEPARADIGM ( 
  PARADIGMID NUMBER NOT NULL, 
  NAME VARCHAR2 (50) DEFAULT '' NOT NULL, 
  DESCRIPTION VARCHAR2 (100), 
  ATOMICPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  LOGICTYPE NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_ROUTINEPARADIGM
  PRIMARY KEY ( PARADIGMID ) USING INDEX);

/****** Table ROUTINEPARADIGMIDTEMP ******/
CREATE TABLE ROUTINEPARADIGMIDTEMP ( 
  PARADIGMID NUMBER NOT NULL);

/****** Table ROUTINERUNTIME ******/
CREATE TABLE ROUTINERUNTIME ( 
  ROUTINEID NUMBER NOT NULL, 
  ROUTINEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONRUNTIMEID NUMBER, 
  ATOMICRUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  ROUTINEKEY VARCHAR2 (1000), 
  TIMECREATED NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  CONSTRAINT PK_ROUTINERUNTIME
  PRIMARY KEY ( ROUTINEID ) USING INDEX);
   
/****** Table RULES ******/
CREATE TABLE RULES ( 
  RULEID NUMBER NOT NULL, 
  NAME VARCHAR2 (50), 
  DESCRIPTION VARCHAR2 (100), 
  TYPE VARCHAR2 (50) DEFAULT '' NOT NULL , 
  DATA VARCHAR2 (4000) NOT NULL, 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED  NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_RULES
  PRIMARY KEY ( RULEID ) USING INDEX);

/****** Table RULETOEDGE ******/
CREATE TABLE RULETOEDGE ( 
  RULEID NUMBER DEFAULT 0 NOT NULL, 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_RULETOEDGE
  PRIMARY KEY ( RULEID, EDGEPARADIGMID ) USING INDEX);

/****** Table RULETOTRANSACTION ******/
CREATE TABLE RULETOTRANSACTION ( 
  RULEID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_RULETOTRANSACTION
  PRIMARY KEY ( RULEID, TRANSACTIONPARADIGMID ) USING INDEX);

/****** Table STATUSAGGREGATIONDAILY ******/
CREATE TABLE STATUSAGGREGATIONDAILY ( 
  AGGREGATIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  AGGREGATIONVALUE NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSAGGREGATIONDAILY
  PRIMARY KEY ( AGGREGATIONID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSAGGREGATIONHOURLY ******/
CREATE TABLE STATUSAGGREGATIONHOURLY ( 
  AGGREGATIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  AGGREGATIONVALUE NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSAGGREGATIONHOURLY
  PRIMARY KEY ( AGGREGATIONID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSDIMENSION ******/
CREATE TABLE STATUSDIMENSION ( 
  STATUSID NUMBER DEFAULT 0 NOT NULL, 
  NAME VARCHAR2 (50) DEFAULT '' NOT NULL, 
  CONSTRAINT PK_STATUSDIMENSION
  PRIMARY KEY ( STATUSID ) USING INDEX);

/****** Table STATUSTOEDGE ******/
CREATE TABLE STATUSTOEDGE ( 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  EDGEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGE
  PRIMARY KEY ( STATUSDIMID, EDGEPARADIGMID ) USING INDEX);

/****** Table STATUSTOEDGEHISTORY ******/
CREATE TABLE STATUSTOEDGEHISTORY ( 
  EDGERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGEHISTORY
  PRIMARY KEY ( EDGERUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSTOEDGERUNTIME ******/
CREATE TABLE STATUSTOEDGERUNTIME ( 
  EDGERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGERUNTIME
  PRIMARY KEY ( EDGERUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSTOROUTINE ******/
CREATE TABLE STATUSTOROUTINE ( 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  ROUTINEPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINE
  PRIMARY KEY ( STATUSDIMID, ROUTINEPARADIGMID ) USING INDEX);

/****** Table STATUSTOROUTINEHISTORY ******/
CREATE TABLE STATUSTOROUTINEHISTORY ( 
  ROUTINERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSION NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINEHISTORY
  PRIMARY KEY ( ROUTINERUNTIMEID, STATUSDIMENSION, STATUSVALUEID ) USING INDEX);

/****** Table STATUSTOROUTINERUNTIME ******/
CREATE TABLE STATUSTOROUTINERUNTIME ( 
  ROUTINERUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSION NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINERUNTIME
  PRIMARY KEY ( ROUTINERUNTIMEID, STATUSDIMENSION, STATUSVALUEID ) USING INDEX);

/****** Table STATUSTOTRANSACTION ******/
CREATE TABLE STATUSTOTRANSACTION ( 
  STATUSID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTION
  PRIMARY KEY ( STATUSID, TRANSACTIONPARADIGMID ) USING INDEX);

/****** Table STATUSTOTRANSACTIONHISTORY ******/
CREATE TABLE STATUSTOTRANSACTIONHISTORY ( 
  TRANSACTIONRUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTIONHISTORY
  PRIMARY KEY ( TRANSACTIONRUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSTOTRANSACTIONRUNTIME ******/
CREATE TABLE STATUSTOTRANSACTIONRUNTIME ( 
  TRANSACTIONRUNTIMEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSDIMENSIONID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTIONRUNTIME
  PRIMARY KEY ( TRANSACTIONRUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) USING INDEX);

/****** Table STATUSVALUES ******/
CREATE TABLE STATUSVALUES ( 
  STATUSDIMID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUEID NUMBER DEFAULT 0 NOT NULL, 
  STATUSVALUE VARCHAR2 (50) DEFAULT '' NOT NULL, 
  CONSTRAINT PK_STATUSVALUES
  PRIMARY KEY ( STATUSDIMID, STATUSVALUEID ) USING INDEX);

/****** Table TRANSACTIONAGGREGATIONDAILY ******/
CREATE TABLE TRANSACTIONAGGREGATIONDAILY ( 
  AGGREGATIONID NUMBER NOT NULL, 
  STARTTIME NUMBER DEFAULT 0 NOT NULL, 
  ENDTIME NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TYPE NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_TRANSACTIONAGGREGATIONDAILY
  PRIMARY KEY ( AGGREGATIONID ) USING INDEX);
   
/****** Table TRANSACTIONAGGREGATIONHOURLY ******/
CREATE TABLE TRANSACTIONAGGREGATIONHOURLY ( 
  AGGREGATIONID NUMBER NOT NULL, 
  STARTTIME NUMBER DEFAULT 0 NOT NULL, 
  ENDTIME NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TYPE NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_TRANSACTIONAGGREGATIONHOUR
  PRIMARY KEY ( AGGREGATIONID ) USING INDEX);

/****** Table TRANSACTIONCLEANIDTEMP ******/
CREATE TABLE TRANSACTIONCLEANIDTEMP ( 
  TRANSACTIONID NUMBER DEFAULT 0 NOT NULL);

/****** Table TRANSACTIONERRORHISTORY ******/
CREATE TABLE TRANSACTIONERRORHISTORY ( 
  TRANSACTIONID NUMBER DEFAULT 0 NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TIMECREATED NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  APPLICATIONNAME VARCHAR2 (1000), 
  CONSTRAINT PK_TRANSACTIONERRORHISTORY
  PRIMARY KEY ( TRANSACTIONID ) USING INDEX);

/****** Table TRANSACTIONFILTERS ******/
CREATE TABLE TRANSACTIONFILTERS ( 
  TRANSACTIONPARADIGMID	NUMBER DEFAULT 0 NOT NULL,
  ROUTINEPARADIGMID	NUMBER DEFAULT 0 NOT NULL,
  FILTERID NUMBER DEFAULT 0 NOT NULL, 
  ISSTATUSFILTER NUMBER, 
  ISDISPLAYFILTER NUMBER, 
  CONSTRAINT PK_TRANSACTIONFILTERS
  PRIMARY KEY ( TRANSACTIONPARADIGMID, ROUTINEPARADIGMID, FILTERID ) USING INDEX);

/****** Table TRANSACTIONHISTORY ******/
CREATE TABLE TRANSACTIONHISTORY ( 
  TRANSACTIONID NUMBER NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TIMECREATED NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  APPLICATIONNAME VARCHAR2 (1000), 
  PARENTTRANSACTIONRUNTIMEID NUMBER, 
  CONSTRAINT PK_TRANSACTIONHISTORY
  PRIMARY KEY ( TRANSACTIONID ) USING INDEX);

/****** Table TRANSACTIONIDTEMP ******/
CREATE TABLE TRANSACTIONIDTEMP ( 
  TRANSACTIONID NUMBER DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_TRANSACTIONIDTEMP
  PRIMARY KEY ( TRANSACTIONID ) USING INDEX);

/****** Table TRANSACTIONPARADIGM ******/
CREATE TABLE TRANSACTIONPARADIGM ( 
  PARADIGMID NUMBER NOT NULL, 
  NAME VARCHAR2 (50) DEFAULT '' NOT NULL, 
  DESCRIPTION VARCHAR2 (100), 
  SYSTEMSTATE NUMBER, 
  COUNTER NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  APPLICATIONNAMEATOMICID NUMBER, 
  APPLICATIONNAMEATOMICINDEX NUMBER, 
  TYPE NUMBER DEFAULT 0,
  CONSTRAINT PK_TRANSACTIONPARADIGM
  PRIMARY KEY ( PARADIGMID ) USING INDEX);
   
/****** Table TRANSACTIONPARADIGM ******/
CREATE TABLE TRANSACTIONPARADIGMIDTEMP ( 
  PARADIGMID  NUMBER);

/****** Table  TRANSACTIONPARADIGMPERMISSIONS******/
CREATE TABLE TRANSACTIONPARADIGMPERMISSIONS ( 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  PERMISSIONTYPE  VARCHAR2 (20) DEFAULT '' NOT NULL, 
  ENTETYNAME  VARCHAR2(1000) NOT NULL);


/****** Table TRANSACTIONRUNTIME ******/
CREATE TABLE TRANSACTIONRUNTIME ( 
  TRANSACTIONID NUMBER NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL, 
  TIMECREATED NUMBER DEFAULT 0 NOT NULL, 
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL, 
  SYSTEMSTATE NUMBER, 
  APPLICATIONNAME VARCHAR2 (1000),
  SESSIONRUNTIMEID NUMBER,
  PARENTTRANSACTIONRUNTIMEID NUMBER,
  TRANSACTIONKEY VARCHAR2 (1000),
  CONSTRAINT PK_TRANSACTIONRUNTIME
  PRIMARY KEY ( TRANSACTIONID ) USING INDEX);

/****** Table UIATOMICPARADIGMPROPERTIES ******/
CREATE TABLE UIATOMICPARADIGMPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  ATOMICPARADIGMID NUMBER,
  GLOBALPROPERTYID NUMBER, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000), 
  CONSTRAINT PK_UIATOMICPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);
   
/****** Table UIDEFAULTGLOBALPROPERTIES ******/
CREATE TABLE UIDEFAULTGLOBALPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000), 
  CONSTRAINT PK_UIDEFAULTGLOBALPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);
   
/****** Table UIEDGEPARADIGMPROPERTIES ******/
CREATE TABLE UIEDGEPARADIGMPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  EDGEPARADIGMID NUMBER,
  GLOBALPROPERTYID NUMBER, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000) NOT NULL, 
  CONSTRAINT PK_UIEDGEPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);
   
/****** Table UIGLOBALPROPERTIES ******/
CREATE TABLE UIGLOBALPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000) NOT NULL, 
  CONSTRAINT PK_UIGLOBALPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);
   
/****** Table UIROUTINEPARADIGMPROPERTIES ******/
CREATE TABLE UIROUTINEPARADIGMPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  ROUTINEPARADIGMID NUMBER NOT NULL,
  GLOBALPROPERTYID NUMBER NOT NULL, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000) NOT NULL, 
  CONSTRAINT PK_UIROUTINEPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);

/****** Table UITRANSACTIONPARADIGMPROPERTIES ******/
CREATE TABLE UITRANPARADIGMPROPERTIES ( 
  PROPERTYID NUMBER NOT NULL, 
  TRANSACTIONPARADIGMID NUMBER NOT NULL,
  GLOBALPROPERTYID NUMBER NOT NULL, 
  PROPERTYTYPE VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYNAME VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYKEY VARCHAR2 (200) DEFAULT '' NOT NULL, 
  PROPERTYVALUE VARCHAR2 (3000) NOT NULL, 
  CONSTRAINT PK_UITRANPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) USING INDEX);

/****** Table SESSIONPARADIGMTOWORKSPACE ******/
CREATE TABLE SESSIONPARADIGMTOWORKSPACE (
  WORKSPACEID NUMBER DEFAULT 0 NOT NULL,
  SESSIONPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_SESSIONPARADIGMTOWORKSPACE
  PRIMARY KEY  ( WORKSPACEID,SESSIONPARADIGMID ) USING INDEX);

/****** Table SESSIONRUNTIME ******/
CREATE TABLE SESSIONRUNTIME (
  ID NUMBER NOT NULL,
  SESSIONPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  STARTTIME NUMBER DEFAULT 0 NOT NULL,
  ENDTIME NUMBER DEFAULT 0 NOT NULL,
  CREATEDTIME NUMBER DEFAULT 0 NOT NULL,
  STATE NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_SESSIONRUNTIME
  PRIMARY KEY (ID) USING INDEX);

/****** Table SESSIONSPARADIGM ******/
CREATE TABLE SESSIONSPARADIGM (
  ID NUMBER NOT NULL,
  NAME VARCHAR2 (45) DEFAULT '' NOT NULL,
  DESCRIPTION VARCHAR2 (255),
  FILTER VARCHAR2 (4000),
  CRONEXP VARCHAR2 (50),
  TIMESTAMP NUMBER DEFAULT 0 NOT NULL,
  STATE NUMBER DEFAULT 0 NOT NULL,
  HOURSTOKEEP NUMBER DEFAULT 0,
  CONSTRAINT PK_SESSIONSPARADIGM
  PRIMARY KEY (ID) USING INDEX);

/****** Table TRANSACTIONTOSESSIONPARADIGM ******/
CREATE TABLE TRANSACTIONTOSESSIONPARADIGM (
  TRANSACTIONID NUMBER DEFAULT 0 NOT NULL,
  SESSIONID NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_TRANSACTIONTOSESSIONPAR
  PRIMARY KEY ( TRANSACTIONID,SESSIONID ) USING INDEX);

/****** Table SESSIONPARADIGMPERMISSIONS ******/
CREATE TABLE SESSIONPARADIGMPERMISSIONS (
  SESSIONPARADIGMID NUMBER DEFAULT 0,
  PERMISSIONTYPE VARCHAR2 (20) DEFAULT '',
  ENTETYNAME VARCHAR2 (4000) NOT NULL);

/****** Table WORKSPACES ******/
CREATE TABLE WORKSPACES (
  ID NUMBER NOT NULL,
  WONAME VARCHAR2 (100) DEFAULT '' NOT NULL,
  WODESCRIPTION VARCHAR2 (255),
  TIMESTAMP NUMBER DEFAULT 0,
  STATE NUMBER,
  CONSTRAINT PK_WORKSPACES
  PRIMARY KEY ( ID ) USING INDEX);

/****** TABLE WORKSPACEPERMISSIONS ******/
CREATE TABLE WORKSPACEPERMISSIONS (
  WORKSPACEID NUMBER DEFAULT 0,
  PERMISSIONTYPE VARCHAR2 (20) DEFAULT '',
  ENTETYNAME VARCHAR2 (4000) NOT NULL);

/****** TABLE FUNCTIONEDGE ******/
CREATE TABLE FUNCTIONEDGE (
  PARADIGMID NUMBER NOT NULL,
  NAME VARCHAR2 (200) DEFAULT '' NOT NULL,
  DESCRIPTION VARCHAR2 (100) DEFAULT NULL,
  TRANSACTIONPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  SOURCEPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  TARGETPARADIGMID NUMBER DEFAULT 0 NOT NULL,
  TYPE VARCHAR2 (50) DEFAULT '' NOT NULL,
  SYSTEMSTATE NUMBER,
  COUNTER NUMBER DEFAULT 0 NOT NULL,
  TIMEMODIFIED NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_FUNCTIONEDGE
  PRIMARY KEY ( PARADIGMID ) USING INDEX);

/****** TABLE PARADIGMINFODETAILS ******/
CREATE TABLE PARADIGMINFODETAILS (
  INFOID NUMBER NOT NULL,
  INFONAME VARCHAR2 (200) DEFAULT '' NOT NULL,
  INFODESC VARCHAR2(200) DEFAULT '',	
  INFOKEY VARCHAR2(200) DEFAULT '' NOT NULL,
  INFOVALUE VARCHAR2 (4000) NOT NULL,
  ISDEFAULT NUMBER DEFAULT 0 NOT NULL,
  CONSTRAINT PK_PARADIGMINFODETAILS
  PRIMARY KEY ( INFOID ) USING INDEX);

/****** TABLE TRANSACTIONPARADIGMINFO ******/
CREATE TABLE TRANSACTIONPARADIGMINFO (
  TRANSACTIONPARADIGMID NUMBER,
  INFOKEY VARCHAR2 (200) DEFAULT '' NOT NULL,
  INFOVALUE VARCHAR2 (4000) NOT NULL,
  CONSTRAINT PK_TRANSACTIONPARADIGMINFO
  PRIMARY KEY ( TRANSACTIONPARADIGMID,INFOKEY ) USING INDEX);

/****** TABLE ROUTINEPARADIGMINFO ******/
CREATE TABLE ROUTINEPARADIGMINFO (
  ROUTINEPARADIGMID NUMBER,
  INFOKEY VARCHAR2 (200) DEFAULT '' NOT NULL,
  INFOVALUE VARCHAR2 (4000) NOT NULL,
  CONSTRAINT PK_ROUTINEPARADIGMINFO
  PRIMARY KEY ( ROUTINEPARADIGMID,INFOKEY ) USING INDEX);

CREATE INDEX edgert_tranrtid_idx ON edgeruntime (transactionruntimeid);
CREATE INDEX tranrt_sessionrtid ON transactionruntime (sessionruntimeid);
CREATE INDEX routinert_tranrtid ON routineruntime (transactionRuntimeId);