/****** Create sequences ******/
CREATE SEQUENCE ACTIONS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ALERTRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ATOMICPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ATOMICRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE EDGEPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE EDGERUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE FILTERS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE FUNCTIONS_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ROUTINEPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE ROUTINERUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE RULES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONAGGREGATIONDAILY_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONAGGREGATIONHOURLY_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONPARADIGM_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE TRANSACTIONRUNTIME_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIGLOBALPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIDEFAULTGLOBALPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIATOMICPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIROUTINEPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UIEDGEPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE UITRANPARADIGMPROPERTIES_S INCREMENT BY 1 START WITH 1;

/****** Table ACTIONS ******/
CREATE TABLE ACTIONS ( 
  ACTIONID      NUMBER        NOT NULL, 
  NAME          VARCHAR2 (50) , 
  DESCRIPTION   VARCHAR2 (100), 
  TYPE          VARCHAR2 (200)  NOT NULL, 
  ACTIONDATA    VARCHAR2 (4000), 
  SYSTEMSTATE   NUMBER, 
  COUNTER       NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED  NUMBER        DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ACTIONS
  PRIMARY KEY ( ACTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ACTIONIDTEMP ******/
CREATE TABLE ACTIONIDTEMP ( 
  ACTIONID  NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ACTIONTOEDGE ******/
CREATE TABLE ACTIONTOEDGE ( 
  ACTIONID         NUMBER        NOT NULL, 
  EDGEPARADIGMID   NUMBER        NOT NULL, 
  STATUSDIMID      NUMBER        NOT NULL, 
  STATUSVALUEFROM  NUMBER        NOT NULL, 
  STATUSVALUETO    NUMBER        NOT NULL, 
  CONSTRAINT PK_ACTIONTOEDGE
  PRIMARY KEY ( ACTIONID, EDGEPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ACTIONTOROUTINE ******/
CREATE TABLE ACTIONTOROUTINE ( 
  ACTIONID           NUMBER        NOT NULL, 
  ROUTINEPARADIGMID  NUMBER        NOT NULL, 
  STATUSDIMID        NUMBER        NOT NULL, 
  STATUSVALUEFROM    NUMBER        NOT NULL, 
  STATUSVALUETO      NUMBER        NOT NULL, 
  CONSTRAINT PK_ACTIONTOROUTINE
  PRIMARY KEY ( ACTIONID, ROUTINEPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ACTIONTOTRANSACTION ******/
CREATE TABLE ACTIONTOTRANSACTION ( 
  ACTIONID               NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  STATUSDIMID            NUMBER        NOT NULL, 
  STATUSVALUEFROM        NUMBER        NOT NULL, 
  STATUSVALUETO          NUMBER        NOT NULL, 
  CONSTRAINT PK_ACTIONTOTRANSACTION
  PRIMARY KEY ( ACTIONID, TRANSACTIONPARADIGMID, STATUSDIMID, STATUSVALUEFROM, STATUSVALUETO ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table AGGREGATIONCLEANIDTEMP ******/
CREATE TABLE AGGREGATIONCLEANIDTEMP ( 
  AGGREGATIONID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ALERTHISTORY ******/
CREATE TABLE ALERTHISTORY ( 
  ALERTID       NUMBER        NOT NULL, 
  ALERTTYPE     VARCHAR2 (50)  NOT NULL, 
  ALERTCREATED  NUMBER        NOT NULL, 
  ALERTDATA     VARCHAR2 (4000), 
  SYSTEMSTATE   NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ALERTRUNTIME ******/
CREATE TABLE ALERTRUNTIME ( 
  ALERTID       NUMBER        NOT NULL, 
  ALERTTYPE     VARCHAR2 (50)  NOT NULL, 
  ALERTCREATED  NUMBER        NOT NULL, 
  ALERTDATA     VARCHAR2 (4000), 
  SYSTEMSTATE   NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ATOMICHISTORY ******/
CREATE TABLE ATOMICHISTORY ( 
  ATOMICID          NUMBER        NOT NULL, 
  ATOMICPARADIGMID  NUMBER        NOT NULL, 
  ATOMICDATA        VARCHAR2 (4000), 
  METADATA          VARCHAR2 (1450),
  SYSTEMSTATE       NUMBER, 
  CONSTRAINT PK_ATOMICHISTORY
  PRIMARY KEY ( ATOMICID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ATOMICPARADIGM ******/
CREATE TABLE ATOMICPARADIGM ( 
  PARADIGMID        NUMBER        NOT NULL, 
  NAME              VARCHAR2 (50), 
  DESCRIPTION       VARCHAR2 (100), 
  DATASOURCE        VARCHAR2 (200), 
  DATASOURCEFILTER  VARCHAR2 (200), 
  TYPE              VARCHAR2 (50), 
  DATA              VARCHAR2 (4000), 
  SYSTEMSTATE       NUMBER, 
  COUNTER           NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED      NUMBER        DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ATOMICPARADIGM
  PRIMARY KEY ( PARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ATOMICRUNTIME ******/
CREATE TABLE ATOMICRUNTIME ( 
  ATOMICID          NUMBER        NOT NULL, 
  ATOMICPARADIGMID  NUMBER        NOT NULL, 
  ATOMICDATA        VARCHAR2 (4000), 
  METADATA          VARCHAR2 (1450), 
  SYSTEMSTATE       NUMBER, 
  CONSTRAINT PK_ATOMICRUNTIME
  PRIMARY KEY ( ATOMICID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table DUMMYROUTINERUNTIME ******/
CREATE TABLE DUMMYROUTINERUNTIME ( 
  ROUTINEKEY          VARCHAR2 (1000), 
  ROUTINEPARADIGMID   NUMBER        NOT NULL, 
  TRANSACTIONRUNTIME  NUMBER        NOT NULL, 
  SYSTEMSTATE         NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGECLEANIDTEMP ******/
CREATE TABLE EDGECLEANIDTEMP ( 
  EDGEID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGEHISTORY ******/
CREATE TABLE EDGEHISTORY ( 
  EDGEID                NUMBER        NOT NULL, 
  EDGEPARADIGMID        NUMBER        NOT NULL, 
  EDGETYPE              VARCHAR2 (50)  NOT NULL, 
  TRANSACTIONRUNTIMEID  NUMBER, 
  RUNTIMESOURCEID       NUMBER, 
  RUNTIMETARGETID       NUMBER, 
  SYSTEMSTATE           NUMBER, 
  EDGECOUNT             NUMBER        DEFAULT 1 NOT NULL, 
  CONSTRAINT PK_EDGEHISTORY
  PRIMARY KEY ( EDGEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGEIDTEMP ******/
CREATE TABLE EDGEIDTEMP ( 
  EDGEID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGEPARADIGMIDTEMP ******/
CREATE TABLE EDGEPARADIGMIDTEMP ( 
  PARADIGMID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGEPARADIGM ******/
CREATE TABLE EDGEPARADIGM ( 
  PARADIGMID             NUMBER        NOT NULL, 
  NAME                   VARCHAR2 (50), 
  DESCRIPTION            VARCHAR2 (100), 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  SOURCEPARADIGMID       NUMBER        NOT NULL, 
  TARGETPARADIGMID       NUMBER        NOT NULL, 
  TYPE                   VARCHAR2 (50)  NOT NULL, 
  SYSTEMSTATE            NUMBER, 
  COUNTER                NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED           NUMBER        DEFAULT 0 NOT NULL, 
  EDGEREPEAT             NUMBER        DEFAULT 1 NOT NULL, 
  CONSTRAINT PK_EDGEPARADIGM
  PRIMARY KEY ( PARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table EDGERUNTIME ******/
CREATE TABLE EDGERUNTIME ( 
  EDGEID                NUMBER        NOT NULL, 
  EDGEPARADIGMID        NUMBER        NOT NULL, 
  EDGETYPE              VARCHAR2 (50)  NOT NULL, 
  TRANSACTIONRUNTIMEID  NUMBER, 
  RUNTIMESOURCEID       NUMBER, 
  RUNTIMETARGETID       NUMBER, 
  SYSTEMSTATE           NUMBER, 
  EDGECOUNT             NUMBER        DEFAULT 1 NOT NULL, 
  CONSTRAINT PK_EDGERUNTIME
  PRIMARY KEY ( EDGEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table FILTERS ******/
CREATE TABLE FILTERS ( 
  FILTERID              NUMBER  NOT NULL, 
  ATOMICPARADIGMID    	NUMBER	NOT NULL,
  NAME          				VARCHAR2 (50), 
  DESCRIPTION   				VARCHAR2 (100), 
  TYPE          				VARCHAR2 (50), 
  DATA          				VARCHAR2 (4000), 
  SYSTEMSTATE   				NUMBER, 
  COUNTER       				NUMBER  DEFAULT 0 NOT NULL, 
  TIMEMODIFIED  				NUMBER	DEFAULT 0 NOT NULL, 
  ISSTATUSFILTER         NUMBER, 
  ISDISPLAYFILTER        NUMBER, 
  CONSTRAINT PK_FILTERS
  PRIMARY KEY ( FILTERID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONFILTERS ******/
CREATE TABLE TRANSACTIONFILTERS ( 
  TRANSACTIONPARADIGMID	NUMBER	NOT NULL,
  ROUTINEPARADIGMID			NUMBER	NOT NULL,
  FILTERID              NUMBER  NOT NULL, 
  ISSTATUSFILTER        NUMBER, 
  ISDISPLAYFILTER       NUMBER, 
  CONSTRAINT PK_TRANSACTIONFILTERS
  PRIMARY KEY ( TRANSACTIONPARADIGMID, ROUTINEPARADIGMID, FILTERID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table FUNCTIONIDTEMP ******/
CREATE TABLE FUNCTIONIDTEMP ( 
  FUNCTIONID  NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table FUNCTIONS ******/
CREATE TABLE FUNCTIONS ( 
  FUNCTIONID    NUMBER        NOT NULL, 
  NAME          VARCHAR2 (50), 
  DESCRIPTION   VARCHAR2 (100), 
  TYPE          VARCHAR2 (50), 
  DATA          VARCHAR2 (4000), 
  SYSTEMSTATE   NUMBER, 
  COUNTER       NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED  NUMBER        DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_FUNCTIONS
  PRIMARY KEY ( FUNCTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table FUNCTIONTOEDGE ******/
CREATE TABLE FUNCTIONTOEDGE ( 
  EDGEPARADIGMID  NUMBER        NOT NULL, 
  FUNCTIONID      NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINECLEANIDTEMP ******/
CREATE TABLE ROUTINECLEANIDTEMP ( 
  ROUTINERUNTIMEID  NUMBER        NOT NULL, 
  ATOMICRUNTIMEID   NUMBER        NOT NULL, 
  CONSTRAINT PK_ROUTINECLEANIDTEMP
  PRIMARY KEY ( ROUTINERUNTIMEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINEHISTORY ******/
CREATE TABLE ROUTINEHISTORY ( 
  ROUTINEID             NUMBER        NOT NULL, 
  ROUTINEPARADIGMID     NUMBER        NOT NULL, 
  TRANSACTIONRUNTIMEID  NUMBER, 
  ATOMICRUNTIMEID       NUMBER        NOT NULL, 
  TIMECREATED           NUMBER        NOT NULL, 
  SYSTEMSTATE           NUMBER, 
  CONSTRAINT PK_ROUTINEHISTORY
  PRIMARY KEY ( ROUTINEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINEIDTEMP ******/
CREATE TABLE ROUTINEIDTEMP ( 
  ROUTINERUNTIMEID  NUMBER        NOT NULL, 
  ATOMICRUNTIMEID   NUMBER        NOT NULL, 
  CONSTRAINT PK_ROUTINEIDTEMP
  PRIMARY KEY ( ROUTINERUNTIMEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINEPARADIGMIDTEMP ******/
CREATE TABLE ROUTINEPARADIGMIDTEMP ( 
  PARADIGMID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINEPARADIGM ******/
CREATE TABLE ROUTINEPARADIGM ( 
  PARADIGMID             NUMBER        NOT NULL, 
  NAME                   VARCHAR2 (50), 
  DESCRIPTION            VARCHAR2 (100), 
  ATOMICPARADIGMID       NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  SYSTEMSTATE            NUMBER, 
  COUNTER                NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED           NUMBER        DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_ROUTINEPARADIGM
  PRIMARY KEY ( PARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table ROUTINERUNTIME ******/
CREATE TABLE ROUTINERUNTIME ( 
  ROUTINEID             NUMBER        NOT NULL, 
  ROUTINEPARADIGMID     NUMBER        NOT NULL, 
  TRANSACTIONRUNTIMEID  NUMBER, 
  ATOMICRUNTIMEID       NUMBER        NOT NULL, 
  ROUTINEKEY            VARCHAR2 (1000), 
  TIMECREATED           NUMBER        NOT NULL, 
  SYSTEMSTATE           NUMBER, 
  CONSTRAINT PK_ROUTINERUNTIME
  PRIMARY KEY ( ROUTINEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table RULEIDTEMP ******/
CREATE TABLE RULEIDTEMP ( 
  RULEID  NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE;   

/****** Table RULES ******/
CREATE TABLE RULES ( 
  RULEID        NUMBER        NOT NULL, 
  NAME          VARCHAR2 (50), 
  DESCRIPTION   VARCHAR2 (100), 
  TYPE          VARCHAR2 (50), 
  DATA          VARCHAR2 (4000), 
  SYSTEMSTATE   NUMBER, 
  COUNTER       NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED  NUMBER        DEFAULT 0 NOT NULL, 
  CONSTRAINT PK_RULES
  PRIMARY KEY ( RULEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table RULETOEDGE ******/
CREATE TABLE RULETOEDGE ( 
  RULEID          NUMBER        NOT NULL, 
  EDGEPARADIGMID  NUMBER        NOT NULL, 
  CONSTRAINT PK_RULETOEDGE
  PRIMARY KEY ( RULEID, EDGEPARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table RULETOTRANSACTION ******/
CREATE TABLE RULETOTRANSACTION ( 
  RULEID                 NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  CONSTRAINT PK_RULETOTRANSACTION
  PRIMARY KEY ( RULEID, TRANSACTIONPARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSAGGREGATIONDAILY ******/
CREATE TABLE STATUSAGGREGATIONDAILY ( 
  AGGREGATIONID      NUMBER        NOT NULL, 
  STATUSDIMENSIONID  NUMBER        NOT NULL, 
  STATUSVALUEID      NUMBER        NOT NULL, 
  AGGREGATIONVALUE   NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSAGGREGATIONDAILY
  PRIMARY KEY ( AGGREGATIONID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSAGGREGATIONHOURLY ******/
CREATE TABLE STATUSAGGREGATIONHOURLY ( 
  AGGREGATIONID      NUMBER        NOT NULL, 
  STATUSDIMENSIONID  NUMBER        NOT NULL, 
  STATUSVALUEID      NUMBER        NOT NULL, 
  AGGREGATIONVALUE   NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSAGGREGATIONHOURLY
  PRIMARY KEY ( AGGREGATIONID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSDIMENSION ******/
CREATE TABLE STATUSDIMENSION ( 
  STATUSID  NUMBER        NOT NULL, 
  NAME      VARCHAR2 (50), 
  CONSTRAINT PK_STATUSDIMENSION
  PRIMARY KEY ( STATUSID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOEDGE ******/
CREATE TABLE STATUSTOEDGE ( 
  STATUSDIMID     NUMBER        NOT NULL, 
  EDGEPARADIGMID  NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGE
  PRIMARY KEY ( STATUSDIMID, EDGEPARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOEDGEHISTORY ******/
CREATE TABLE STATUSTOEDGEHISTORY ( 
  EDGERUNTIMEID      NUMBER        NOT NULL, 
  STATUSDIMENSIONID  NUMBER        NOT NULL, 
  STATUSVALUEID      NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGEHISTORY
  PRIMARY KEY ( EDGERUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOEDGERUNTIME ******/
CREATE TABLE STATUSTOEDGERUNTIME ( 
  EDGERUNTIMEID      NUMBER        NOT NULL, 
  STATUSDIMENSIONID  NUMBER        NOT NULL, 
  STATUSVALUEID      NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOEDGERUNTIME
  PRIMARY KEY ( EDGERUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOROUTINE ******/
CREATE TABLE STATUSTOROUTINE ( 
  STATUSDIMID        NUMBER        NOT NULL, 
  ROUTINEPARADIGMID  NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINE
  PRIMARY KEY ( STATUSDIMID, ROUTINEPARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOROUTINEHISTORY ******/
CREATE TABLE STATUSTOROUTINEHISTORY ( 
  ROUTINERUNTIMEID  NUMBER        NOT NULL, 
  STATUSDIMENSION   NUMBER        NOT NULL, 
  STATUSVALUEID     NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINEHISTORY
  PRIMARY KEY ( ROUTINERUNTIMEID, STATUSDIMENSION, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOROUTINERUNTIME ******/
CREATE TABLE STATUSTOROUTINERUNTIME ( 
  ROUTINERUNTIMEID  NUMBER        NOT NULL, 
  STATUSDIMENSION   NUMBER        NOT NULL, 
  STATUSVALUEID     NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOROUTINERUNTIME
  PRIMARY KEY ( ROUTINERUNTIMEID, STATUSDIMENSION, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOTRANSACTION ******/
CREATE TABLE STATUSTOTRANSACTION ( 
  STATUSID               NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTION
  PRIMARY KEY ( STATUSID, TRANSACTIONPARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOTRANSACTIONHISTORY ******/
CREATE TABLE STATUSTOTRANSACTIONHISTORY ( 
  TRANSACTIONRUNTIMEID  NUMBER        NOT NULL, 
  STATUSDIMENSIONID     NUMBER        NOT NULL, 
  STATUSVALUEID         NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTIONHISTORY
  PRIMARY KEY ( TRANSACTIONRUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSTOTRANSACTIONRUNTIME ******/
CREATE TABLE STATUSTOTRANSACTIONRUNTIME ( 
  TRANSACTIONRUNTIMEID  NUMBER        NOT NULL, 
  STATUSDIMENSIONID     NUMBER        NOT NULL, 
  STATUSVALUEID         NUMBER        NOT NULL, 
  CONSTRAINT PK_STATUSTOTRANSACTIONRUNTIME
  PRIMARY KEY ( TRANSACTIONRUNTIMEID, STATUSDIMENSIONID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table STATUSVALUES ******/
CREATE TABLE STATUSVALUES ( 
  STATUSDIMID    NUMBER        NOT NULL, 
  STATUSVALUEID  NUMBER        NOT NULL, 
  STATUSVALUE    VARCHAR2 (50), 
  CONSTRAINT PK_STATUSVALUES
  PRIMARY KEY ( STATUSDIMID, STATUSVALUEID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONAGGREGATIONDAILY ******/
CREATE TABLE TRANSACTIONAGGREGATIONDAILY ( 
  AGGREGATIONID          NUMBER        NOT NULL, 
  STARTTIME              NUMBER        NOT NULL, 
  ENDTIME                NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  TYPE                   NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table TRANSACTIONAGGREGATIONHOURLY ******/
CREATE TABLE TRANSACTIONAGGREGATIONHOURLY ( 
  AGGREGATIONID          NUMBER        NOT NULL, 
  STARTTIME              NUMBER        NOT NULL, 
  ENDTIME                NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  TYPE                   NUMBER        NOT NULL, 
  CONSTRAINT PK_TRANSACTIONAGGREGATIONHOUR
  PRIMARY KEY ( AGGREGATIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONCLEANIDTEMP ******/
CREATE TABLE TRANSACTIONCLEANIDTEMP ( 
  TRANSACTIONID  NUMBER        NOT NULL)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONERRORHISTORY ******/
CREATE TABLE TRANSACTIONERRORHISTORY ( 
  TRANSACTIONID          NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  TIMECREATED            NUMBER        NOT NULL, 
  TIMEMODIFIED           NUMBER        NOT NULL, 
  SYSTEMSTATE            NUMBER, 
  APPLICATIONNAME        VARCHAR2 (1000), 
  CONSTRAINT PK_TRANSACTIONERRORHISTORY
  PRIMARY KEY ( TRANSACTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONHISTORY ******/
CREATE TABLE TRANSACTIONHISTORY ( 
  TRANSACTIONID          NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  TIMECREATED            NUMBER        NOT NULL, 
  TIMEMODIFIED           NUMBER        NOT NULL, 
  SYSTEMSTATE            NUMBER, 
  APPLICATIONNAME        VARCHAR2 (1000), 
  CONSTRAINT PK_TRANSACTIONHISTORY
  PRIMARY KEY ( TRANSACTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONIDTEMP ******/
CREATE TABLE TRANSACTIONIDTEMP ( 
  TRANSACTIONID  NUMBER        NOT NULL, 
  CONSTRAINT PK_TRANSACTIONIDTEMP
  PRIMARY KEY ( TRANSACTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table TRANSACTIONPARADIGM ******/
CREATE TABLE TRANSACTIONPARADIGM ( 
  PARADIGMID                  NUMBER        NOT NULL, 
  NAME                        VARCHAR2 (50), 
  DESCRIPTION                 VARCHAR2 (100), 
  SYSTEMSTATE                 NUMBER, 
  COUNTER                     NUMBER        DEFAULT 0 NOT NULL, 
  TIMEMODIFIED                NUMBER        DEFAULT 0 NOT NULL, 
  APPLICATIONNAMEATOMICID     NUMBER, 
  APPLICATIONNAMEATOMICINDEX  NUMBER, 
  CONSTRAINT PK_TRANSACTIONPARADIGM
  PRIMARY KEY ( PARADIGMID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table TRANSACTIONPARADIGM ******/
CREATE TABLE TRANSACTIONPARADIGMIDTEMP ( 
  PARADIGMID  NUMBER)
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table  TRANSACTIONPARADIGMPERMISSIONS******/
CREATE TABLE TRANSACTIONPARADIGMPERMISSIONS ( 
  TRANSACTIONPARADIGMID         NUMBER        NOT NULL, 
  PERMISSIONTYPE  VARCHAR2 (20)        NOT NULL, 
  ENTETYNAME  VARCHAR2(1000)        NOT NULL,  
  CONSTRAINT PK_TRANSACTIONPARADIGMPERM
  PRIMARY KEY ( TRANSACTIONPARADIGMID, PERMISSIONTYPE, ENTETYNAME ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 


/****** Table TRANSACTIONRUNTIME ******/
CREATE TABLE TRANSACTIONRUNTIME ( 
  TRANSACTIONID          NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID  NUMBER        NOT NULL, 
  TIMECREATED            NUMBER        NOT NULL, 
  TIMEMODIFIED           NUMBER        NOT NULL, 
  SYSTEMSTATE            NUMBER, 
  APPLICATIONNAME        VARCHAR2 (1000), 
  CONSTRAINT PK_TRANSACTIONRUNTIME
  PRIMARY KEY ( TRANSACTIONID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table UIGLOBALPROPERTIES ******/
CREATE TABLE UIGLOBALPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UIGLOBALPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table UIDEFAULTGLOBALPROPERTIES ******/
CREATE TABLE UIDEFAULTGLOBALPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UIDEFAULTGLOBALPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table UIATOMICPARADIGMPROPERTIES ******/
CREATE TABLE UIATOMICPARADIGMPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  ATOMICPARADIGMID          NUMBER        NOT NULL,
  GLOBALPROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UIATOMICPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table UIROUTINEPARADIGMPROPERTIES ******/
CREATE TABLE UIROUTINEPARADIGMPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  ROUTINEPARADIGMID          NUMBER        NOT NULL,
  GLOBALPROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UIROUTINEPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Table UIEDGEPARADIGMPROPERTIES ******/
CREATE TABLE UIEDGEPARADIGMPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  EDGEPARADIGMID          NUMBER        NOT NULL,
  GLOBALPROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UIEDGEPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 
   
/****** Table UITRANSACTIONPARADIGMPROPERTIES ******/
CREATE TABLE UITRANPARADIGMPROPERTIES ( 
  PROPERTYID          NUMBER        NOT NULL, 
  TRANSACTIONPARADIGMID          NUMBER        NOT NULL,
  GLOBALPROPERTYID          NUMBER        NOT NULL, 
  PROPERTYTYPE  	  VARCHAR2 (200), 
  PROPERTYNAME        VARCHAR2 (200), 
  PROPERTYKEY         VARCHAR2 (200), 
  PROPERTYVALUE        VARCHAR2 (3000), 
  CONSTRAINT PK_UITRANPARADIGMPROPERTIES
  PRIMARY KEY ( PROPERTYID ) 
    USING INDEX 
     TABLESPACE SYSTEM PCTFREE 10
     STORAGE ( INITIAL 64K NEXT 64K PCTINCREASE 50 ))
   TABLESPACE SYSTEM NOLOGGING 
   PCTFREE 10
   PCTUSED 40
   INITRANS 1
   MAXTRANS 255
  STORAGE ( 
   INITIAL 65536
   NEXT 65536
   PCTINCREASE 50
   MINEXTENTS 1
   MAXEXTENTS 2147483645
   FREELISTS 1 FREELIST GROUPS 1 )
   NOCACHE; 

/****** Create foreign keys ******/
ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_ACTIONS
 FOREIGN KEY (ACTIONID) 
  REFERENCES ACTIONS (ACTIONID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_STATUSVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_STATUSVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_ACTIONS
 FOREIGN KEY (ACTIONID) 
  REFERENCES ACTIONS (ACTIONID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_STATVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_STATVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOTRANSACTION ADD  CONSTRAINT FK_ACTIONTOTRANS_STATUSVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOTRANSACTION ADD  CONSTRAINT FK_ACTIONTOTRANS_STATUSVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ATOMICRUNTIME ADD  CONSTRAINT FK_ATOMICRUNTIME_PARADIGM
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;

ALTER TABLE DUMMYROUTINERUNTIME ADD  CONSTRAINT FK_DUMMYROUTINERT_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE DUMMYROUTINERUNTIME ADD  CONSTRAINT FK_DUMMYROUTINERT_TRANSRT
 FOREIGN KEY (TRANSACTIONRUNTIME) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE EDGEPARADIGM ADD  CONSTRAINT FK_EDGEPARADIGM_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE EDGERUNTIME ADD  CONSTRAINT FK_EDGERUNTIME_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE EDGERUNTIME ADD  CONSTRAINT FK_EDGERUNTIME_TRANSRUNTIME
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE FILTERS ADD  CONSTRAINT FK_FILTER_ATOMICPARADIGM
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;

ALTER TABLE TRANSACTIONFILTERS ADD  CONSTRAINT FK_TRANFILTER_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE TRANSACTIONFILTERS ADD  CONSTRAINT FK_TRANFILTER_ROUTINEPARADIGM
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE FUNCTIONTOEDGE ADD  CONSTRAINT FK_FUNCTIONTOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE FUNCTIONTOEDGE ADD  CONSTRAINT FK_FUNCTIONTOEDGE_FUNCTIONS
 FOREIGN KEY (FUNCTIONID) 
  REFERENCES FUNCTIONS (FUNCTIONID) ;

ALTER TABLE ROUTINEPARADIGM ADD  CONSTRAINT FK_ROUTINEPAR_ATOMICPAR
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINEPARADIGM ADD  CONSTRAINT FK_ROUTINEPAR_TRANSPAR
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_ATOMICRT
 FOREIGN KEY (ATOMICRUNTIMEID) 
  REFERENCES ATOMICRUNTIME (ATOMICID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_ROUTINEPARADIGM
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_TRANSACTIONRT
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE RULETOEDGE ADD  CONSTRAINT FK_RULETOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE RULETOEDGE ADD  CONSTRAINT FK_RULETOEDGE_RULES
 FOREIGN KEY (RULEID) 
  REFERENCES RULES (RULEID) ;

ALTER TABLE RULETOTRANSACTION ADD  CONSTRAINT FK_RULETOTRANSACTION_RULES
 FOREIGN KEY (RULEID) 
  REFERENCES RULES (RULEID) ;

ALTER TABLE RULETOTRANSACTION ADD  CONSTRAINT FK_RULETOTRANS_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOEDGE ADD  CONSTRAINT FK_STATUSTOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOEDGE ADD  CONSTRAINT FK_STATUSTOEDGE_STATUSDIM
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOEDGERUNTIME ADD  CONSTRAINT FK_STATUSTOEDGERT_EDGERT
 FOREIGN KEY (EDGERUNTIMEID) 
  REFERENCES EDGERUNTIME (EDGEID) ;

ALTER TABLE STATUSTOEDGERUNTIME ADD  CONSTRAINT FK_STATUSTOEDGERT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSIONID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOROUTINE ADD  CONSTRAINT FK_STATUSTOROUTINE_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOROUTINE ADD  CONSTRAINT FK_STATUSTOROUTINE_STATUSDIM
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOROUTINERUNTIME ADD  CONSTRAINT FK_STATUSTOROUTINERT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSION) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTION ADD  CONSTRAINT FK_STATUSTOTRANS_STATUSDIM
 FOREIGN KEY (STATUSID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTION ADD  CONSTRAINT FK_STATUSTOTRANS_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOTRANSACTIONRUNTIME ADD  CONSTRAINT FK_STATUSTOTRANSRT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSIONID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTIONRUNTIME ADD  CONSTRAINT FK_STATUSTOTRANSRT_TRANSRT
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE STATUSVALUES ADD  CONSTRAINT FK_STATUSVALUES_STATUSDIM1
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE TRANSACTIONRUNTIME ADD  CONSTRAINT FK_TRANSRUNTIME_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
  
ALTER TABLE TRANSACTIONPARADIGMPERMISSIONS ADD  CONSTRAINT FK_TPPERM_TRANPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
  
ALTER TABLE UIATOMICPARADIGMPROPERTIES ADD  CONSTRAINT FK_ATOMICPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIATOMICPARADIGMPROPERTIES ADD  CONSTRAINT FK_ATOMICPROP_ATOMICPARADIGM
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;
  

ALTER TABLE UIROUTINEPARADIGMPROPERTIES ADD  CONSTRAINT FK_ROUTINEPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIROUTINEPARADIGMPROPERTIES ADD  CONSTRAINT FK_ROUTINEPROP_ROUTINEPARADIGM
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;
  
ALTER TABLE UIEDGEPARADIGMPROPERTIES ADD  CONSTRAINT FK_EDGEPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIEDGEPARADIGMPROPERTIES ADD  CONSTRAINT FK_EDGEPROP_ATOMICPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;
  
ALTER TABLE UITRANPARADIGMPROPERTIES ADD  CONSTRAINT FK_TRANPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UITRANPARADIGMPROPERTIES ADD  CONSTRAINT FK_TRANPROP_ATOMICPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
