CREATE TABLE actionidtemp (
  actionId integer default NULL
);
CREATE TABLE actions (
  actionId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  type varchar(200) NOT NULL default '',
  actionData text,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  PRIMARY KEY  (actionId)
);
CREATE TABLE actiontoedge (
  actionId integer NOT NULL default '0',
  edgeParadigmId integer NOT NULL default '0',
  statusDimID integer NOT NULL default '0',
  statusValueFrom integer NOT NULL default '0',
  statusValueTo integer NOT NULL default '0',
  PRIMARY KEY  (actionId,edgeParadigmId,statusDimID,statusValueFrom,statusValueTo)
);
CREATE TABLE actiontoroutine (
  actionId integer NOT NULL default '0',
  routineParadigmId integer NOT NULL default '0',
  statusDimId integer NOT NULL default '0',
  statusValueFrom integer NOT NULL default '0',
  statusValueTo integer NOT NULL default '0',
  PRIMARY KEY  (actionId,routineParadigmId,statusDimId,statusValueFrom,statusValueTo)
);
CREATE TABLE actiontotransaction (
  actionId integer NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  statusDimId integer NOT NULL default '0',
  statusValueFrom integer NOT NULL default '0',
  statusValueTo integer NOT NULL default '0',
  PRIMARY KEY  (actionId,transactionParadigmId,statusDimId,statusValueFrom,statusValueTo)
);
CREATE TABLE aggregationcleanidtemp (
  aggregationId integer NOT NULL default '0'
);
CREATE TABLE alerthistory (
  alertId bigint NOT NULL default '0',
  alertType varchar(50) NOT NULL default '',
  alertCreated bigint NOT NULL default '0',
  alertData text NOT NULL,
  systemState integer default NULL
);
CREATE TABLE alertruntime (
  alertId bigserial NOT NULL,
  alertType varchar(100) NOT NULL default '',
  alertCreated bigint NOT NULL default '0',
  alertData text NOT NULL,
  systemState integer default NULL,
  PRIMARY KEY  (alertId)
);
CREATE TABLE atomichistory (
  atomicId bigint NOT NULL default '0',
  atomicParadigmId integer NOT NULL default '0',
  atomicData text NOT NULL,
  dataRef VARCHAR(250),
  metadata text NOT NULL,
  systemState integer default NULL,
  PRIMARY KEY  (atomicId)
);
CREATE TABLE atomicparadigm (
  paradigmId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  dataSource varchar(200) default NULL,
  dataSourceFilter varchar(200) default NULL,
  Type varchar(50) default NULL,
  data text,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  PRIMARY KEY  (paradigmId)
);
CREATE TABLE atomicruntime (
  atomicId bigserial NOT NULL,
  atomicParadigmId integer NOT NULL default '0',
  atomicData text NOT NULL,
  dataRef VARCHAR(250),
  metadata text NOT NULL,
  systemState integer default NULL,
  PRIMARY KEY  (atomicId)
);
CREATE TABLE datasource (
  id serial NOT NULL,
  dsName VARCHAR(100) NOT NULL,
  dsDescription VARCHAR(250),
  dsNodeId VARCHAR(45),
  dsLbmId VARCHAR(250) NOT NULL,
  dsFilterId VARCHAR(45),
  PRIMARY KEY(id)
);
CREATE TABLE dummyroutineruntime (
  routineKey text,
  routineParadigmId integer NOT NULL default '0',
  transactionRuntime bigint NOT NULL default '0',
  systemState integer default NULL
);
CREATE TABLE edgecleanidtemp (
  edgeId bigint NOT NULL default '0',
  PRIMARY KEY  (edgeId)
);
CREATE TABLE edgehistory (
  edgeId bigint NOT NULL default '0',
  edgeParadigmId integer NOT NULL default '0',
  edgeType varchar(50) NOT NULL default '',
  transactionRuntimeId bigint default NULL,
  runtimeSourceId bigint default NULL,
  runtimeTargetId bigint default NULL,
  systemState integer default NULL,
  edgeCount integer NOT NULL default '1',
  PRIMARY KEY  (edgeId)
);
CREATE TABLE edgeidtemp (
  edgeId bigint NOT NULL default '0',
  PRIMARY KEY  (edgeId)
);
CREATE TABLE edgeparadigm (
  paradigmId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  transactionParadigmId integer NOT NULL default '0',
  sourceParadigmId integer NOT NULL default '0',
  targetParadigmId integer NOT NULL default '0',
  type varchar(50) NOT NULL default '',
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  edgeRepeat integer NOT NULL default '1',
  logicType bigint NOT NULL default '0',
  PRIMARY KEY  (paradigmId)
);
CREATE TABLE edgeparadigmidtemp (
  paradigmId integer default NULL
);
CREATE TABLE edgeruntime (
  edgeId bigserial NOT NULL,
  edgeParadigmId integer NOT NULL default '0',
  edgeType varchar(50) NOT NULL default '',
  transactionRuntimeId bigint default NULL,
  runtimeSourceId bigint default NULL,
  runtimeTargetId bigint default NULL,
  systemState integer default NULL,
  edgeCount integer NOT NULL default '1',
  PRIMARY KEY  (edgeId)
);
CREATE TABLE filters (
  filterId serial NOT NULL,
  atomicParadigmId integer NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  type varchar(50) NOT NULL default '',
  data text NOT NULL,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  isStatusFilter integer default NULL,
  isDisplayFilter integer default NULL,
  PRIMARY KEY  (filterId)
);
CREATE TABLE functionidtemp (
  functionId integer default NULL
);
CREATE TABLE functions (
  functionId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  type varchar(50) NOT NULL default '',
  data text NOT NULL,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  PRIMARY KEY  (functionId)
);
CREATE TABLE functiontoedge (
  edgeParadigmId integer NOT NULL default '0',
  functionId integer NOT NULL default '0',
  PRIMARY KEY  (edgeParadigmId,functionId)
);
CREATE TABLE routinecleanidtemp (
  routineRuntimeId bigint NOT NULL default '0',
  PRIMARY KEY  (routineRuntimeId)
);
CREATE TABLE atomiccleanidtemp (
  atomicRuntimeId bigint NOT NULL default '0',
  PRIMARY KEY  (atomicRuntimeId)
);
CREATE TABLE routinehistory (
  routineId bigint NOT NULL default '0',
  routineParadigmId integer NOT NULL default '0',
  transactionRuntimeId bigint default NULL,
  atomicRuntimeId bigint NOT NULL default '0',
  timeCreated bigint NOT NULL default '0',
  systemState integer default NULL,
  PRIMARY KEY  (routineId)
);
CREATE TABLE routineidtemp (
  routineRuntimeId bigint NOT NULL default '0',
  atomicRuntimeId bigint NOT NULL default '0',
  PRIMARY KEY  (routineRuntimeId)
);
CREATE TABLE routineparadigm (
  paradigmId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  atomicParadigmId integer NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  logicType bigint NOT NULL default '0',
  PRIMARY KEY  (paradigmId)
);
CREATE TABLE routineparadigmidtemp (
  paradigmId integer default NULL
);
CREATE TABLE routineruntime (
  routineId bigserial NOT NULL,
  routineParadigmId integer NOT NULL default '0',
  transactionRuntimeId bigint default NULL,
  atomicRuntimeId bigint NOT NULL default '0',
  routineKey text,
  timeCreated bigint NOT NULL default '0',
  systemState integer default NULL,
  PRIMARY KEY  (routineId)
);
CREATE TABLE rules (
  ruleId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  type varchar(50) NOT NULL default '',
  data text NOT NULL,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  PRIMARY KEY  (ruleId)
);
CREATE TABLE ruletoedge (
  ruleId integer NOT NULL default '0',
  edgeParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (ruleId,edgeParadigmId)
);
CREATE TABLE ruletotransaction (
  ruleId integer NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (ruleId,transactionParadigmId)
);
CREATE TABLE statusaggregationdaily (
  aggregationId integer NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  aggregationValue integer NOT NULL default '0',
  PRIMARY KEY  (aggregationId,statusDimensionId,statusValueId)
);
CREATE TABLE statusaggregationhourly (
  aggregationId integer NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  aggregationValue integer NOT NULL default '0',
  PRIMARY KEY  (aggregationId,statusDimensionId,statusValueId)
);
CREATE TABLE statusdimension (
  statusId integer NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  PRIMARY KEY  (statusId)
);
CREATE TABLE statustoedge (
  statusDimId integer NOT NULL default '0',
  edgeParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (statusDimId,edgeParadigmId)
);
CREATE TABLE statustoedgehistory (
  edgeRuntimeId bigint NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (edgeRuntimeId,statusDimensionId,statusValueId)
);
CREATE TABLE statustoedgeruntime (
  edgeRuntimeId bigint NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (edgeRuntimeId,statusDimensionId,statusValueId)
);
CREATE TABLE statustoroutine (
  statusDimId integer NOT NULL default '0',
  routineParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (statusDimId,routineParadigmId)
);
CREATE TABLE statustoroutinehistory (
  routineRuntimeId bigint NOT NULL default '0',
  statusDimension integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (routineRuntimeId,statusDimension,statusValueId)
);
CREATE TABLE statustoroutineruntime (
  routineRuntimeId bigint NOT NULL default '0',
  statusDimension integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (routineRuntimeId,statusDimension,statusValueId)
);
CREATE TABLE statustotransaction (
  statusId integer NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (statusId,transactionParadigmId)
);
CREATE TABLE statustotransactionhistory (
  transactionRuntimeId bigint NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (transactionRuntimeId,statusDimensionId,statusValueId)
);
CREATE TABLE statustotransactionruntime (
  transactionRuntimeId bigint NOT NULL default '0',
  statusDimensionId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  PRIMARY KEY  (transactionRuntimeId,statusDimensionId,statusValueId)
);
CREATE TABLE statusvalues (
  statusDimId integer NOT NULL default '0',
  statusValueId integer NOT NULL default '0',
  statusValue varchar(50) NOT NULL default '',
  PRIMARY KEY  (statusDimId,statusValueId)
);
CREATE TABLE transactionaggregationdaily (
  aggregationId serial NOT NULL,
  startTime bigint NOT NULL default '0',
  endTime bigint NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  type integer NOT NULL default '0',
  PRIMARY KEY  (aggregationId)
);
CREATE TABLE transactionaggregationhourly (
  aggregationId serial NOT NULL,
  startTime bigint NOT NULL default '0',
  endTime bigint NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  type integer NOT NULL default '0',
  PRIMARY KEY  (aggregationId)
);
CREATE TABLE transactioncleanidtemp (
  transactionId bigint NOT NULL default '0',
  PRIMARY KEY  (transactionId)
);
CREATE TABLE transactionerrorhistory (
  transactionId bigint NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  timeCreated bigint NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  systemState integer default NULL,
  applicationName text,
  PRIMARY KEY  (transactionId)
);
CREATE TABLE transactionfilters (
  transactionParadigmId integer NOT NULL default '0',
  routineParadigmId integer NOT NULL default '0',
  filterId integer NOT NULL default '0',
  isStatusFilter integer default NULL,
  isDisplayFilter integer default NULL,
  PRIMARY KEY  (transactionParadigmId,routineParadigmId,filterId)
);
CREATE TABLE transactionhistory (
  transactionId bigint NOT NULL default '0',
  transactionParadigmId integer NOT NULL default '0',
  timeCreated bigint NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  systemState integer default NULL,
  applicationName text,
  parentTransactionRuntimeId bigint default NULL,
  PRIMARY KEY  (transactionId)
);
CREATE TABLE transactionidtemp (
  transactionId bigint NOT NULL default '0',
  PRIMARY KEY  (transactionId)
);
CREATE TABLE transactionparadigm (
  paradigmId serial NOT NULL,
  name varchar(50) NOT NULL default '',
  description varchar(100) default NULL,
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  applicationNameAtomicId integer default NULL,
  applicationNameAtomicIndex integer default NULL,
  type integer default '0',
  PRIMARY KEY  (paradigmId)
);
CREATE TABLE transactionparadigmidtemp (
  paradigmId integer default NULL
);
CREATE TABLE transactionparadigmpermissions (
  transactionParadigmId integer NOT NULL default '0',
  permissionType varchar(20) NOT NULL default '',
  entetyName text NOT NULL
);
CREATE TABLE transactionruntime (
  transactionId bigserial NOT NULL,
  transactionParadigmId integer NOT NULL default '0',
  timeCreated bigint NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  systemState integer default NULL,
  applicationName text,
  sessionRuntimeId int,
  parentTransactionRuntimeId bigint default NULL,
  transactionKey text,
  PRIMARY KEY  (transactionId)
);
CREATE TABLE uiatomicparadigmproperties (
  propertyId serial NOT NULL,
  atomicParadigmId integer default NULL,
  globalPropertyId integer default NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertyId)
);
CREATE TABLE uidefaultglobalproperties (
  propertyId serial NOT NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertyId)
);
CREATE TABLE uiedgeparadigmproperties (
  propertId serial NOT NULL,
  edgeParadigmId integer default NULL,
  globalPropertyId integer default NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertId)
);
CREATE TABLE uiglobalproperties (
  propertyId serial NOT NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertyId)
);
CREATE TABLE uiroutineparadigmproperties (
  propertyId serial NOT NULL,
  routineParadigmId integer default NULL,
  globalPropertyId integer default NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertyId)
);
CREATE TABLE uitranparadigmproperties (
  propertyId serial NOT NULL,
  transactionParadigmId integer default NULL,
  globalPropertyId integer default NULL,
  propertyType varchar(200) NOT NULL default '',
  propertyName varchar(200) NOT NULL default '',
  propertyKey varchar(200) NOT NULL default '',
  propertyValue text NOT NULL,
  PRIMARY KEY  (propertyId)
);
CREATE TABLE sessionparadigmtoworkspace (
  workspaceId serial NOT NULL,
  sessionParadigmId integer NOT NULL default '0',
  PRIMARY KEY  (workspaceId,sessionParadigmId)
);
CREATE TABLE sessionruntime (
  id serial NOT NULL,
  sessionParadigmId integer NOT NULL default '0',
  startTime bigint NOT NULL default '0',
  endTime bigint NOT NULL default '0',
  createdTime bigint NOT NULL default '0',
  state integer NOT NULL default '0',
  PRIMARY KEY  (id)
);
CREATE TABLE sessionsparadigm (
  id serial NOT NULL,
  name varchar(45) NOT NULL default '',
  description varchar(255) default NULL,
  filter text default NULL,
  cronexp varchar(50) default NULL,
  timestamp bigint NOT NULL default '0',
  state integer NOT NULL default '0',
  hoursToKeep bigint default 0,
  PRIMARY KEY  (id)
);
CREATE TABLE transactiontosessionparadigm (
  transactionId integer NOT NULL default '0',
  sessionId integer NOT NULL default '0',
  PRIMARY KEY  (transactionId,sessionId)
);
CREATE TABLE sessionparadigmpermissions (
  sessionParadigmId integer default 0,
  permissionType varchar(20) default '',
  entetyName text NOT NULL
);
CREATE TABLE workspaces (
  id serial NOT NULL,
  woName varchar(100) default NULL,
  woDescription varchar(255) NOT NULL default '',
  timestamp bigint NOT NULL default '0',
  state integer default NULL,
  PRIMARY KEY  (id)
);
CREATE TABLE workspacepermissions (
  workspaceId integer default 0,
  permissionType varchar(20) default '',
  entetyName text NOT NULL
);
CREATE TABLE functionEdge (
  paradigmId serial NOT NULL,
  name varchar(200) NOT NULL default '',
  description varchar(100) default NULL,
  transactionParadigmId integer NOT NULL default '0',
  sourceParadigmId integer NOT NULL default '0',
  targetParadigmId integer NOT NULL default '0',
  type varchar(50) NOT NULL default '',
  systemState integer default NULL,
  counter integer NOT NULL default '0',
  timeModified bigint NOT NULL default '0',
  PRIMARY KEY  (paradigmId)
);
CREATE TABLE paradigminfodetails (
  infoId serial NOT NULL,
  infoName varchar(200) NOT NULL default '',
  infoDesc varchar(200) NOT NULL default '',	
  infoKey varchar(200) NOT NULL default '',
  infoValue text NOT NULL,
  isDefault integer NOT NULL default 0,
  PRIMARY KEY  (infoId)
);
CREATE TABLE transactionparadigminfo (
  transactionParadigmId integer default NULL,
  infoKey varchar(200) NOT NULL default '',
  infoValue text NOT NULL,
  PRIMARY KEY  (transactionParadigmId,infoKey)
);
CREATE TABLE routineparadigminfo (
  routineParadigmId integer default NULL,
  infoKey varchar(200) NOT NULL default '',
  infoValue text NOT NULL,
  PRIMARY KEY  (routineParadigmId,infoKey)
);
CREATE INDEX routineruntime_transactionruntimeid_idx ON routineruntime(transactionruntimeid);
CREATE INDEX edgeruntime_transactionruntimeid_idx ON edgeruntime (transactionruntimeid);
CREATE INDEX transactionruntime_sessionruntimeid ON transactionruntime (sessionruntimeid);