<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<%@page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.admin.helpers.MergeAdminHelper"%>
<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.impl.KnowledgeComputationResults"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.masks.DateMask"%>
<%@ page import="xpolog.eye.data.masks.MaskColumn"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.knowledge.common.filters.KnowledgeResultFilter"%>
<%@ page import="xpolog.eye.knowledge.helpers.KnowledgeLogHelper"%>
<%@ page import="xpolog.eye.logview.LogViewTab"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.main.MainViewModel"%>
<%@ page import="xpolog.eye.site.main.MainViewTabModel"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%@ include file="../tools/sandf/dateFilterAction.jsp" %>

<%
String ERROR_OBJ = "ERROR_OBJ";	

String modelSessionAttributeName = request.getParameter("modelSessionAttributeName");

UserEnvironment env = UserEnvironment.getUserEnvironment(request);

HealthViewModel model = null;
if(modelSessionAttributeName != null && modelSessionAttributeName.length() > 0) {
	model = (HealthViewModel)session.getAttribute(modelSessionAttributeName);
}
if (model == null){
	model = new HealthViewModel();
	ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
	DateFilter defaultDisplayDateFilter = ComputationConfigurationHelper.getDefaultDisplayDateFilter(model, computationConfiguration);

	model.setTimeFilter(defaultDisplayDateFilter);
	model.setViewBy(computationConfiguration.getViewBy());
	model.setViewType(computationConfiguration.getViewType());
	model.setViewGroupType(computationConfiguration.getViewGroupType());
	model.setShowMetrics(computationConfiguration.isShowMetrics());
	model.setViewHierarchyType(computationConfiguration.getViewHierarchyType());

	model.setCheckMissingExecutions(false);

	model.updateModel(HealthViewModel.ACTION_LOAD_DATA, env.getUserContext(), null, true, false);	
}

SiteManagment mgmt = SiteManagment.getInstance();
String lbmId = request.getParameter("lbmId");
String filterId = request.getParameter("filterId");
String isKnowledgeStr = request.getParameter("isKnowledge");
boolean isKnowledge = isKnowledgeStr != null && isKnowledgeStr.equals("true");
String isAnalyticsStr = request.getParameter("isAnalytics");
boolean isAnalytics = isAnalyticsStr != null && isAnalyticsStr.equals("true");
String hideDashboardButtonStr = request.getParameter("hideDashboardButton");
boolean hideDashboardButton = hideDashboardButtonStr != null && hideDashboardButtonStr.equals("true");

String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);

String message = "";
boolean success = false;
if (lbmId != null && lbmId.length() > 0 && filterId != null && filterId.length() > 0) {
	LogBrowsingManager lbm = null;
	try{
		MainViewModel mainViewModel = env.getMainViewModel();
		
		String [] LogsToMerge = lbmId.split(",");
	  	if (LogsToMerge.length > 1){
	  		lbm = MergeAdminHelper.getMergeLogsFromLogs(LogsToMerge,"Merge filter log","Merge filter log","mergeDashboardFilter" + System.currentTimeMillis());
	  		if (lbm != null){
	  			lbmId = LogsToMerge[0];
	  		}
	  	}else {
		  MainViewTabModel tab = mainViewModel.getOnlineTabByDataId(lbmId);
		  if (tab != null && tab instanceof LogViewTab){
			  lbm = ((LogViewTab)tab).getLbm();
		  }
		  if (lbm == null){
		  	lbm = mgmt.getLogBrowserManager(lbmId);
		  }
	  	}
		if (lbm != null){
			RecordMask mask = new RecordMask();
			DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
			MaskColumn[] cols = {dateMask};
			mask.setColumns(cols);	
			DateFilter dateFilter = createDateFilter(request,response,mask);
			if(dateFilter != null){
				dateFilter.setRoundMilliseconds(model.getMsToRound());
				dateFilter.updateMinTime();	
				dateFilter.setTimeType(-1);
				dateFilter.setTimeGap(-1);
				if (dateFilter.getMinDate() == null){
					dateFilter.setMinDate(new Date(0));
				}
				if (dateFilter.getMaxDate() == null){
					dateFilter.setMaxDate(new Date());
				}
			}
			DateFilter df = null;
			if (dateFilter != null){
				mask = lbm.getRecordMask();
				df = (DateFilter)dateFilter.clone();
				if (df != null){
					df.setColInd(mask.getDateColumnIndex());
					df.setIndexing(mask);
					df.updateMinTime();
					df.setTimeOpType(0);
					df.setTimeGap(-1);
					df.setTimeType(-1);
				}
			}
			
			if(isAnalytics) {				
				success = true;
				message = "analytics/analyticsResults.jsp?lbmId=" + lbmId + "&filterValue=" + filterId;;
			}else {
				FilterManager fMgr = lbm.getFilterManager();
				FilterCollection fc = null;
				
				String t = isKnowledge ? XpoLogObjectTypes.KNOWLEDGE_TYPE : XpoLogObjectTypes.FILTER_TYPE;
				boolean isSavedSearch = filterId.startsWith(SearchHistoryManager.SAVED_SEARCH_PREFIX);
				if(isSavedSearch) {
					FilterCollection[] filterCollections = SearchHistoryManager.getInstance().getSeverityFilterCollections(env.getUserContext(), lbmId, lbm.getRecordMask());
					if(filterCollections != null && filterCollections.length > 0) {
						for(int i = 0; i < filterCollections.length; i++) {
							if(filterCollections[i].getId().equals(filterId)) {
								fc = (FilterCollection)filterCollections[i].clone();
								fc.setName(analytics + ": " + fc.getName());
								fc.setTransientFilter(true);
								
								break;
							}
						}
					}else {
						success = false;
						message = "A configuration problem prevents the action to complete";
					}
				}else if (!isKnowledge && !filterId.endsWith(XpoLogObjectTypes.KNOWLEDGE_TYPE)){
					int ind = filterId.indexOf("@");
					if (ind != -1){
						filterId = filterId.substring(ind+1,filterId.length());
					}
					FilterCollection filterCollection = fMgr.getFilterCollectionById(filterId);
					fc = filterCollection != null ? (FilterCollection)filterCollection.clone() : new FilterCollection();
					fc.setName(analytics + ": " + fc.getName());
					fc.setTransientFilter(true);
				}else {
					ComputationResults compResults = model.getComputationResultsByTypeAndId(t, filterId, lbmId);
					if (compResults != null && compResults instanceof KnowledgeComputationResults){
						KnowledgeComputationResults knowledgeCompResults = (KnowledgeComputationResults)compResults;
						String name = knowledgeCompResults.getName();
						KnowledgeResultFilter[] filters = knowledgeCompResults.getFilters();
						fc = KnowledgeLogHelper.getFilterForResult(analytics + ": " + name, filters,lbm == null ? null : lbm.getRecordMask());
						if (fc == null){
							ErrorModel.log.error("Failed to create filter for log browsing manager for log " + lbmId);
							success = false;
							message = "Unable to load log";							
						}
					}else if (compResults == null){
						ErrorModel.log.error("Failed to get getComputationResultsByTypeAndId for log " + lbmId + " filter " + filterId);
						success = false;
						message = "Unable to load log";		
					}
				}
				
				if (!success && fc != null) {
					if(df != null){
						fc.addFilter(df);
					}
					boolean failed = false;
					try {
						
					long logStartTime = LogAdminHelper.checkForUpdateLogStartTime(lbm,false);
					if (logStartTime > 0 && dateFilter != null && dateFilter.getMaxDate() != null && dateFilter.getMaxDate().getTime() < logStartTime){
						if (ErrorModel.log.isInfoEnabled()){
						  ErrorModel.log.info("No data is exists for log " + lbmId + " in filter " + dateFilter + " and start time in log "  + new Date(logStartTime));
						}
						success = false;
						message = "The log doesn't contain matching events from the given time";
						failed = true;
					}
					}catch (Exception e){
						ErrorModel.log.error("Failed to get first time for " + lbmId  + " in filter " + dateFilter,e);
					}
					if (!failed){
					  fMgr.addFilterCollection(fc);
					  lbm.setShowDashboardInLogView(!hideDashboardButton);
					  request.getSession().setAttribute("logid",lbm.getId()); 
					  request.getSession().setAttribute("CURRENT_LOG",lbm);
					
					  String expandLogViewerStr = request.getParameter("expandLogViewer");
					  boolean expandLogViewer = expandLogViewerStr != null && expandLogViewerStr.equals("true");
					  String url = "";
					  if(expandLogViewer) {
						
						  url = "componentAction.jsp?selectedCompId=Xpolog&forward=loggers/logview.jsp?";
					  	if (!lbm.isTemporary()){
						  	url = url + "logid="+lbmId+"%26";
						  }
						  url = url + "opdirect=START%26filters="+fc.getId()+"%26addFilter=true%26calls=-1%26gotoMain=true%26timetamp=" + System.currentTimeMillis();
					  }else {
						  url = "componentAction.jsp?selectedCompId=Xpolog&forward=root.jsp?mainPage=loggers/logview.jsp%253F";
						  StringBuffer buffer = new StringBuffer();
						  buffer.append("logid=");
						  buffer.append(lbmId);
						  buffer.append("&opdirect=START");
						  buffer.append("&filters=");
						  buffer.append(fc.getId());
						  buffer.append("&addFilter=true");
						  buffer.append("&calls=-1");
						  buffer.append("&gotoMain=true");
						  buffer.append("&timetamp=");
						  buffer.append(System.currentTimeMillis());
						  String queryString = buffer.toString();
						  queryString = XpologUtil.replaceAll(queryString, "&", "%26");
						  queryString = XpologUtil.replaceAll(queryString, "%", "%25");
						  url += queryString;						
					  }
					  success = true;
					  message = url;
					}
				}
			}			
		}else {
			message = "The log doesn't exist";
		}
	}catch(Exception e){		
		ErrorModel.log.error("Failed to load log browsing manager for log " + lbmId,e);
		success = false;
		message = "Unable to load log";
	}
	
	 String xml = GridModelActionsHelper.getResultXML(success, message);

		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		
		
		out.write(xml);
		out.flush();
}
%>