<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.admin.helpers.DashboardAdminHelper"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext.HealthViewTimeContext"%>
<%@ page import="xpolog.eye.scheduler.SchedulingMgr"%>
<%@ page import="xpolog.eye.scheduler.XpoLogScheduleFactory"%>
<%@ page import="xpolog.eye.scheduler.XpoQuartzSchedMgr"%>
<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.ui.ActionJobBuilder"%>
<%@ page import="xpolog.eye.scheduler.ui.JobBuilder"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String DASHBOARD_GLOBAL_VERIFIER_BUILDER = "DASHBOARD_GLOBAL_VERIFIER_BUILDER";

ErrorModel errmod = new ErrorModel();
ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();

// general
String viewBy = request.getParameter("viewBy");
String viewType = request.getParameter("viewType");
String viewGroupType = request.getParameter("viewGroupType");
String viewHierarchyType = request.getParameter("viewHierarchyType");
String showMetricsStr = request.getParameter("showMetrics");
boolean showMetrics = showMetricsStr != null && showMetricsStr.equals("true");
computationConfiguration.setViewBy(viewBy);
computationConfiguration.setViewType(viewType);
computationConfiguration.setViewGroupType(viewGroupType);
computationConfiguration.setViewHierarchyType(viewHierarchyType);
computationConfiguration.setShowMetrics(showMetrics);

String timeInterval = request.getParameter("timeInterval");
if(timeInterval.equals(DateUtil.FIXED_INTERVAL_CUSTOM)) {
	String dashboardMinDateStr = request.getParameter("dashboardMinDateStr");
	String dashboardMaxDateStr = request.getParameter("dashboardMaxDateStr");
	String dashboardMinTimeStr = request.getParameter("dashboardMinTimeStr");
	String dashboardMaxTimeStr = request.getParameter("dashboardMaxTimeStr");
	if(dashboardMinDateStr != null && dashboardMinDateStr.length() > 0 &&
		 dashboardMaxDateStr != null && dashboardMaxDateStr.length() > 0 && 
		 dashboardMinTimeStr != null && dashboardMinTimeStr.length() > 0 &&
		 dashboardMaxTimeStr != null && dashboardMaxTimeStr.length() > 0) {
		dashboardMinDateStr += (" " + dashboardMinTimeStr);
		dashboardMaxDateStr += (" " + dashboardMaxTimeStr);
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm");
		Date newMinDate = sdf.parse(dashboardMinDateStr);
		Date newMaxDate = sdf.parse(dashboardMaxDateStr);
		
		FilterCollection defaultDisplayTimeRule = computationConfiguration.getDefaultDisplayTimeRule();
		if(defaultDisplayTimeRule == null) {
			defaultDisplayTimeRule = new FilterCollection();
			defaultDisplayTimeRule.setId(System.currentTimeMillis() + "_fc");
			defaultDisplayTimeRule.setName(ComputationConfiguration.DEFAULT_DISPLAY_TIME_RULE_NAME);
		}
		DateFilter dateFilter = null;
		List dateFilters = defaultDisplayTimeRule.getByName(DateFilter.DATE_FILTER_NAME);
		if(dateFilters != null && dateFilters.size() > 0) {
			dateFilter = (DateFilter)dateFilters.get(0);
		}else {
			dateFilter = new DateFilter();
			defaultDisplayTimeRule.addFilter(dateFilter);
		}
		dateFilter.setMinDate(newMinDate);
		dateFilter.setMaxDate(newMaxDate);
		dateFilter.setRoundMilliseconds(HealthViewTimeContext.MS_TO_ROUND);
		dateFilter.updateMinTime();
		
		computationConfiguration.setDefaultDisplayTimeRule(defaultDisplayTimeRule);
		computationConfiguration.setTimeInterval(timeInterval);
	}
}else {
	computationConfiguration.setDefaultDisplayTimeRule(null);
	computationConfiguration.setTimeInterval(timeInterval);
}

String enableDataGenerationStr = request.getParameter("enableDataGeneration");
boolean enableDataGeneration = enableDataGenerationStr != null && enableDataGenerationStr.equals("true");
String dataGenerationInterval = request.getParameter("dataGenerationInterval");
computationConfiguration.setDataGenerationInterval(dataGenerationInterval);
XpoScheduledOperation dataGenerationOps = null;
int index = dataGenerationInterval.indexOf("_");
if(index != -1) {
	//Scheduler
	String dataGenerationUnit = dataGenerationInterval.substring(0, index);
	String dataGenerationUnitType = dataGenerationInterval.substring(index + 1);
	long hourInterval = 0;
  long minInterval = 0;
	if (dataGenerationUnitType.equals("minute")){
		hourInterval = 1;
		minInterval = Integer.parseInt(dataGenerationUnit);
	}else if (dataGenerationUnitType.equals("hour")){
		hourInterval = Integer.parseInt(dataGenerationUnit);
	}
	
 	String id = computationConfiguration.getHealthReportJobId();
 	SchedulingMgr smgr = XpoLogScheduleFactory.getSchdulingManager();
 	
	ActionJobBuilder builder = null;
	
	XpoScheduledOperation op = null;
	if (id != null && id.length() > 0){
		op = smgr.getScheduedOp(id);
	}
	if (op != null){
		builder = new ActionJobBuilder(op);
		builder.updateFromOp();
		builder.resetTriggers();
		String startDate;
		String endDate;
		String hours, minutTens, minutUnit, secTen, secUnit;
		String[] montharr, dayInMonarr;
		
		startDate = request.getParameter("startDate");
		if (startDate == null) {
			startDate = "";
		}
		endDate = request.getParameter("endDate");
		if (endDate == null) {
			endDate = "";
		}
		
		montharr = new String[]{"all"};
		dayInMonarr = new String[]{"all"};
		hours = "0";
		minutTens = "0";
		minutUnit = "0";
		secTen = "0";
		secUnit = "0";
		
		builder.setStartDate(startDate);
		builder.setEndDate(endDate);
	
		builder.setSimple(false);
		builder.setCron(true);
		if (dayInMonarr != null && dayInMonarr.length > 0 && montharr != null && montharr.length > 0) {
			builder.setDayType(JobBuilder.DAY_OF_MONTH);
			Integer[] darr = new Integer[dayInMonarr.length];
	
			for (int i = 0; i < darr.length; ++i) {
				if (dayInMonarr[i].equals("all")) {
					builder.setAllDayInMonth(true);
					darr = new Integer[0];
					break;
				}
				darr[i] = new Integer(dayInMonarr[i]);
			}
			builder.setDayInMonth(darr);
			Integer[] marr = new Integer[montharr.length];
			for (int i = 0; i < marr.length; ++i) {
				if (montharr[i].equals("all")) {
					builder.setAllMonth(true);
					marr = new Integer[0];
					break;
				}
				marr[i] = new Integer(montharr[i]);
			}
			builder.setMonth(marr);
		}
	
		builder.setHours(hours);
		builder.setMinutesTen(minutTens);
		builder.setMinuteUnit(minutUnit);
		builder.setSecondTen(secTen);
		builder.setSecondUnit(secUnit);
		builder.setMinutesInterval(String.valueOf(minInterval));
		builder.setHoursInterval(String.valueOf(hourInterval));
		if (minutTens.equals("0") && minutUnit.equals("0")&& minInterval == 1) {
			builder.setEveryMinute(true);
		} else {
			builder.setEveryMinute(false);
		}
		if (hours.equals("0") && hourInterval == 1) {
			builder.setEveryHour(true);
		} else {
			builder.setEveryHour(false);
		}
	
		
		try {
			dataGenerationOps = builder.buildXpoSchedOp();
			if (enableDataGeneration) {
				dataGenerationOps.setActive();
			} else {
				dataGenerationOps.setSuspend();
			}
		} catch (IllegalArgumentException e) {
			errmod.addError("Global Scheduler - " + e.getMessage());
		} catch (Exception e1) {
			errmod.addError("Global Scheduler - Invalid time rule. Please make sure the time rule is valid and try again");
		}
	}
}
String missingDataUserPolicy = request.getParameter("missingDataUserPolicy");
if(missingDataUserPolicy == null || missingDataUserPolicy.equals("")) {
	missingDataUserPolicy = ComputationConfiguration.MISSING_DATA_USER_POLICY_ASK;
}
computationConfiguration.setMissingDataUserPolicy(missingDataUserPolicy);

// global alerts
MultiComputationVerifierBuilder builder = (MultiComputationVerifierBuilder)session.getAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER);
builder.updateBuilder();
computationConfiguration.setGlobalVerifier(builder.getMultiComputationVerifier());

// metrics settings
HashMap measurementConfigurations = DashboardAdminHelper.getHostMasurementConfigurationsFromRequest(request, errmod);
HashMap previousMeasurementConfigurations  = HostsManager.getInstance().getDefaultHostMeasurementConfigurations();
boolean dataSourceChanged = DashboardAdminHelper.dataSourceChanged(measurementConfigurations, previousMeasurementConfigurations);

// advanced
String dataDeletionIntervalStr = request.getParameter("dataDeletionInterval");
long dataDeletionInterval = -1;
try {
	dataDeletionInterval = Long.parseLong(dataDeletionIntervalStr);
}catch(Exception e) {
	errmod.addError("Invalid numeric value in 'Delete data older than' field");
}
String dataDeletionIntervalUnitStr = request.getParameter("dataDeletionIntervalUnit");
int dataDeletionIntervalUnit = Integer.parseInt(dataDeletionIntervalUnitStr);
computationConfiguration.setDataDeletionInterval(dataDeletionInterval);
computationConfiguration.setDataDeletionIntervalUnit(dataDeletionIntervalUnit);

String alertsDeletionIntervalStr = request.getParameter("alertsDeletionInterval");
long alertsDeletionInterval = -1;
try {
	alertsDeletionInterval = Long.parseLong(alertsDeletionIntervalStr);
}catch(Exception e) {
	errmod.addError("Invalid numeric value in 'Delete alerts older than' field");
}
String alertsDeletionIntervalUnitStr = request.getParameter("alertsDeletionIntervalUnit");
int alertsDeletionIntervalUnit = Integer.parseInt(alertsDeletionIntervalUnitStr);
computationConfiguration.setAlertsDeletionInterval(alertsDeletionInterval);
computationConfiguration.setAlertsDeletionIntervalUnit(alertsDeletionIntervalUnit);

String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
String xml = "";
if(errmod != null && errmod.getErrorCount() > 0) {
	//errors
	String[] errors = errmod.getErrors();
	StringBuffer sb = new StringBuffer();
	for(int i = 0; i < errors.length; i++) {
		if(sb.length() > 0) {
			sb.append("*;*");
		}
		sb.append(errors[i]);
	}
	String message = sb.toString();
	xml = GridModelActionsHelper.getResultXML(false, message);
}else{
	UserContext userContext = UserEnvironment.getUserContext(request);
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "save " + analytics + " configuration", AuditConstants.DASHBOARD, "save " + analytics + " configuration");
	
	XpoQuartzSchedMgr mgr = (XpoQuartzSchedMgr) XpoLogScheduleFactory.getSchdulingManager();
	mgr.putXpoSysScheduledOp(dataGenerationOps);
	
	computationConfiguration.save();
	
	HostsManager.getInstance().updateMeasurementConfigurations(measurementConfigurations);
	
	xml = GridModelActionsHelper.getResultXML(true, analyticsH + " Administration Saved", String.valueOf(dataSourceChanged));
}
response.setContentType("text/xml");
response.setHeader("Pragma-Control", "no-cache");
response.setHeader("Cache-Control", "no-cache");
response.setHeader("Expires", "0");
out.write(xml);
out.flush();
%>