<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.helpers.DashboardAdminHelper"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.UpdateHostInfoRequest"%>

<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.Set"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
ErrorModel errmod = new ErrorModel();

UserContext userContext = UserEnvironment.getUserContext(request);

String host = request.getParameter("host");
String displayName = request.getParameter("displayName");
String isNewStr = request.getParameter("isNew");
boolean isNew = isNewStr != null && isNewStr.equals("true");

if(host == null || host.length() == 0) {
	errmod.addError("Host is missing");
}

if(displayName == null || displayName.length() == 0) {
	errmod.addError("Display name is missing");
}

host = host.trim();
displayName = displayName.trim();

String [] serverLogs = null;
String logsList = request.getParameter("serverLogs");
if(logsList != null && logsList.length() > 0) {
	serverLogs = logsList.split(",");
}
if(serverLogs == null) {
	serverLogs = new String[0];
}

HashMap logs = new HashMap();
HashMap mods = new HashMap();
String [] modsArr = null;
String modsList = request.getParameter("serverModules");
if(modsList != null && modsList.length() > 0) {
	modsArr = modsList.split(",");
}
if(modsArr != null) {
  for(int i = 0; i < modsArr.length; i++) {
  	if(!modsArr[i].endsWith("*")) {
    	mods.put(modsArr[i],modsArr[i]);
  	}
  }
}
if(modsArr != null) {
  for(int i = 0; i < modsArr.length; i++) {
  	String id = modsArr[i];
  	if(modsArr[i].endsWith("*")) {
   		id = id.substring(0,id.length()-1);
   		ModuleMemberRenderer.addAllModuleChildren(id, mods, logs);
   	}
    mods.put(id, id);
  }
}
if(logs != null && logs.size() > 0) {
	for(int i = 0; i < serverLogs.length; i++) {
		if(logs.containsKey(serverLogs[i])) {
			logs.remove(serverLogs[i]);
		}
	}
	if(logs.size() > 0) {
	  String[] implicitLogs = (String[])logs.keySet().toArray(new String[logs.size()]);
	  String[] tmp = new String[serverLogs.length + implicitLogs.length];
	  System.arraycopy(serverLogs,0,tmp,0,serverLogs.length);
	  System.arraycopy(implicitLogs,0,tmp,serverLogs.length,implicitLogs.length);
	  serverLogs = tmp;
	}
}

if(errmod.getErrorCount() == 0) {
	if(isNew && host != null && host.length() > 0) {
		if(DashboardAdminHelper.isHostExists(host)) {
			errmod.addError("Host already exists");
		}
	}
}

String defaultAccountId = request.getParameter("serverDefaultAccountIdAccountsList");
if(defaultAccountId != null && (defaultAccountId.equals("") || defaultAccountId.equals("none"))) {
	defaultAccountId = null;
}

HashMap measurementConfigurations = null;
if(errmod.getErrorCount() == 0) {
	//metrics settings
	measurementConfigurations = DashboardAdminHelper.getHostMasurementConfigurationsFromRequest(request, errmod, host);
}

boolean dataSourceChanged = false;
if(errmod.getErrorCount() == 0) {
	UpdateHostInfoRequest updateHostInfoRequest = new UpdateHostInfoRequest();
	updateHostInfoRequest.setHost(host);
	updateHostInfoRequest.setName(displayName);
	Set logsSet = new HashSet();
	for(int i = 0; i < serverLogs.length; i++) {
		logsSet.add(serverLogs[i]);
	}
	updateHostInfoRequest.setLogIds(logsSet);
	/*if(measurementConfigurations != null) {
		String useInDashboardStr = (String)measurementConfigurations.get("useInDashboard");
		if(useInDashboardStr != null) {
			boolean useInDashboard = useInDashboardStr.equals("true");
			updateHostInfoRequest.setUseInDashboard(useInDashboard);
		}
	}*/
	updateHostInfoRequest.setDefaultAccountId(defaultAccountId);
	updateHostInfoRequest.setMeasurementConfigurations(measurementConfigurations);
	updateHostInfoRequest.setUserContext(userContext);
	
	if(!isNew) {
		HashMap previousMeasurementConfigurations = HostsManager.getInstance().getHostMeasurementConfigurations(host, false);
		dataSourceChanged = DashboardAdminHelper.dataSourceChanged(measurementConfigurations, previousMeasurementConfigurations);
	}
	HostsManager.getInstance().updateHostInfo(updateHostInfoRequest);
	
	String actionString = "edit server";
	if(isNew) {
		actionString = "add server";
	}
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, actionString, AuditConstants.DASHBOARD, actionString + " " + host + " (" + displayName + ")");
}

String resultStr = "";
if(errmod != null && errmod.getErrorCount() > 0) {
	//errors
	String[] errors = errmod.getErrors();
	StringBuffer sb = new StringBuffer();
	for(int i = 0; i < errors.length; i++) {
		if(sb.length() > 0) {
			sb.append("#");
		}
		sb.append(errors[i]);
	}
	resultStr = "SAVE_SERVER_ERROR#" + sb.toString();
}else{
	resultStr = host + "#" + dataSourceChanged;
}
response.setContentType("text/xml");
response.setHeader("Pragma-Control", "no-cache");
response.setHeader("Cache-Control", "no-cache");
response.setHeader("Expires", "0");
out.write(resultStr.trim());
out.flush();
%>