var dashboardCalendar;
function loadCalendar() {
	dashboardCalendar = new dhtmlxDblCalendarObject("dashboardCalendarTd", false, {isMonthEditable: true, isYearEditable: true});
	dashboardCalendar.setYearsRange(2000, 2040);
	dashboardCalendar.setDateFormat("%m/%d/%Y");
	dashboardCalendar.setOnClickHandler(onDashboardCalendarClick);
	
	updateCalendar();
}

function updateCalendar() {
	var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
	var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
	var dashboardMinTimeStr = document.getElementById("dashboardMinTimeStr");
	var dashboardMaxTimeStr = document.getElementById("dashboardMaxTimeStr");
	if(dashboardMinDateStr && dashboardMinDateStr.value != "" && 
	   dashboardMaxDateStr && dashboardMaxDateStr.value != "" &&
	   dashboardMinTimeStr && dashboardMinTimeStr.value != "" &&
	   dashboardMaxTimeStr && dashboardMaxTimeStr.value != "") {
		dashboardCalendar.setDate(dashboardMinDateStr.value, dashboardMaxDateStr.value);
		
		var calendarStartTime = document.getElementById("calendarStartTime");
		if(calendarStartTime) {
			calendarStartTime.value = dashboardMinTimeStr.value;
		}
		var calendarEndTime = document.getElementById("calendarEndTime");
		if(calendarEndTime) {
			calendarEndTime.value = dashboardMaxTimeStr.value;
		}
	}
}

function goDashboardCalendar() {
	var validateTimeFormatResult = validateTimeFormat('calendarStartTime', 'Start Time');
	if(validateTimeFormatResult) {
		validateTimeFormatResult = validateTimeFormat('calendarEndTime', 'End Time');
		if(validateTimeFormatResult) {
			var validateTimeOrderResult = validateTimeOrder();
			if(validateTimeOrderResult) {
				var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
				var dashboardMinTimeStr = document.getElementById("dashboardMinTimeStr");
				var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
				var dashboardMaxTimeStr = document.getElementById("dashboardMaxTimeStr");
				var calendarStartTime = document.getElementById("calendarStartTime");
				var calendarEndTime = document.getElementById("calendarEndTime");
				if(dashboardMinTimeStr && calendarStartTime && dashboardMaxTimeStr && calendarEndTime) {
					dashboardMinTimeStr.value = calendarStartTime.value;
					dashboardMaxTimeStr.value = calendarEndTime.value;
					
					closeDashboardCalendar();
					var defaultTimeIntervalCustomTextLink = document.getElementById("defaultTimeIntervalCustomTextLink");
					if(defaultTimeIntervalCustomTextLink) {
						var text = (dashboardMinDateStr.value + " " + dashboardMinTimeStr.value + " - " + dashboardMaxDateStr.value + " " + dashboardMaxTimeStr.value);
						replaceDivContent("defaultTimeIntervalCustomTextLink", text);
					}
				}
			}
		}
	}
}

function changeDefaultTimeInterval(defaultTimeInterval) {
	var isCustom = (defaultTimeInterval == FIXED_INTERVAL_CUSTOM);
	toggleDefaultTimeIntervalCustomDiv(isCustom);
}

function toggleDefaultTimeIntervalCustomDiv(isCustom) {
	var defaultTimeIntervalCustomTd = document.getElementById("defaultTimeIntervalCustomTd");
	if(defaultTimeIntervalCustomTd) {
		if(isCustom) {
			defaultTimeIntervalCustomTd.style.display = "block";
		}else {
			defaultTimeIntervalCustomTd.style.display = "none";
		}
	}
}