<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.scheduler.SchedulingMgr"%>
<%@ page import="xpolog.eye.scheduler.XpoLogScheduleFactory"%>
<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();

String[] fixedIntervals = computationConfiguration.getFixedIntervals();
String[] fixedIntervalsNames = computationConfiguration.getFixedIntervalsNames();

boolean dataGenerationEnabled = computationConfiguration.isDataGenerationEnabled();

String defaultTimeIntervalCustomTdStyleStr = "padding-left: 15px;width: 350px; text-align: left;";
if(!computationConfiguration.getTimeInterval().equals(DateUtil.FIXED_INTERVAL_CUSTOM)) {
	defaultTimeIntervalCustomTdStyleStr += "display: none";
}

String timeInterval = computationConfiguration.getTimeInterval();
HealthViewModel model = new HealthViewModel();
DateFilter dateFilter = ComputationConfigurationHelper.getDefaultDisplayDateFilter(model, computationConfiguration);

Date minDate = null;
Date maxDate = null;
long dashboardMinDate = 0;
String minDateString = "";
String minDateShortString = "";
String minTimeString = "";
long dashboardMaxDate = 0;
String maxDateString = "";
String maxDateShortString = "";
String maxTimeString = "";
String defaultTimeIntervalCustomTextLink = "";

if(dateFilter != null) {
	minDate = dateFilter.getMinDate();
	maxDate = dateFilter.getMaxDate();

	dashboardMinDate = minDate.getTime();
	minDateString = DateUtil.transformDateToString(minDate);
	int minIndex = minDateString.indexOf(" ");
	minDateShortString = minDateString.substring(0, minIndex);
	minTimeString = minDateString.substring(minIndex + 1);
	if(minTimeString.indexOf(":") != minTimeString.lastIndexOf(":")) {
		minTimeString = minTimeString.substring(0, minTimeString.lastIndexOf(":"));
	}
	
	dashboardMaxDate = maxDate.getTime();
	maxDateString = DateUtil.transformDateToString(maxDate);
	int maxIndex = maxDateString.indexOf(" ");
	maxDateShortString = maxDateString.substring(0, maxIndex);
	maxTimeString = maxDateString.substring(maxIndex + 1);
	if(maxTimeString.indexOf(":") != maxTimeString.lastIndexOf(":")) {
		maxTimeString = maxTimeString.substring(0, maxTimeString.lastIndexOf(":"));
	}
	
	defaultTimeIntervalCustomTextLink = minDateShortString + " " + minTimeString + " - " +  maxDateShortString + " " + maxTimeString;
}
%>

<input type="hidden" id="dashboardMinDate" name="dashboardMinDate" value="<%=dashboardMinDate %>">
<input type="hidden" id="dashboardMinDateStr" name="dashboardMinDateStr" value="<%=minDateShortString %>">
<input type="hidden" id="dashboardMinDateFullStr" name="dashboardMinDateFullStr" value="<%=minDateString %>">
<input type="hidden" id="dashboardMinTimeStr" name="dashboardMinTimeStr" value="<%=minTimeString %>">
<input type="hidden" id="dashboardMaxDate" name="dashboardMaxDate" value="<%=dashboardMaxDate %>">
<input type="hidden" id="dashboardMaxDateStr" name="dashboardMaxDateStr" value="<%=maxDateShortString %>">
<input type="hidden" id="dashboardMaxDateFullStr" name="dashboardMaxDateFullStr" value="<%=maxDateString %>">
<input type="hidden" id="dashboardMaxTimeStr" name="dashboardMaxTimeStr" value="<%=maxTimeString %>">

<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<tr height="10px">
		<td class="HEADER">Default View</td>
	</tr>
	<tr height="10px">
		<td>
			<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 5px;">View By:</td>
					<td style="padding-top: 5px;">
						<select id="viewBy" name="viewBy" size="1" style="width:140px">
							<option value="<%=HealthViewContext.VIEW_BY_FOLDERS %>" <%=computationConfiguration.getViewBy().equals(HealthViewContext.VIEW_BY_FOLDERS) ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_FOLDERS) %></option>
							<option value="<%=HealthViewContext.VIEW_BY_APPLICATIONS %>" <%=computationConfiguration.getViewBy().equals(HealthViewContext.VIEW_BY_APPLICATIONS) ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_APPLICATIONS) %></option>
							<option value="<%=HealthViewContext.VIEW_BY_SERVERS %>" <%=computationConfiguration.getViewBy().equals(HealthViewContext.VIEW_BY_SERVERS) ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_SERVERS) %></option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 5px;">View Type:</td>
					<td style="padding-top: 5px;">
						<select id="viewType" name="viewType" size="1" style="width:140px">
							<option value="<%=HealthViewContext.VIEW_TYPE_TOTAL %>" <%=computationConfiguration.getViewType().equals(HealthViewContext.VIEW_TYPE_TOTAL) ? "selected" : "" %>>Total</option>
							<option value="<%=HealthViewContext.VIEW_TYPE_RISK %>" <%=computationConfiguration.getViewType().equals(HealthViewContext.VIEW_TYPE_RISK) ? "selected" : "" %>>Risk</option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 5px;">Group Type:</td>
					<td style="padding-top: 5px;">
						<select id="viewGroupType" name="viewGroupType" size="1" style="width:140px">
							<option value="<%=HealthViewContext.VIEW_GROUP_TYPE_SUMMARY %>" <%=computationConfiguration.getViewGroupType().equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY) ? "selected" : "" %>>Summary View</option>
							<option value="<%=HealthViewContext.VIEW_GROUP_TYPE_SPLIT %>" <%=computationConfiguration.getViewGroupType().equals(HealthViewContext.VIEW_GROUP_TYPE_SPLIT) ? "selected" : "" %>>Split View</option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 5px;">Hierarchy Type:</td>
					<td style="padding-top: 5px;">
						<select id="viewHierarchyType" name="viewHierarchyType" size="1" style="width:140px">
							<option value="<%=HealthViewContext.VIEW_HIERARCHY_TYPE_HIERARCHIC %>" <%=computationConfiguration.getViewHierarchyType().equals(HealthViewContext.VIEW_HIERARCHY_TYPE_HIERARCHIC) ? "selected" : "" %>>Hierarchic</option>
							<option value="<%=HealthViewContext.VIEW_HIERARCHY_TYPE_FLAT %>" <%=computationConfiguration.getViewHierarchyType().equals(HealthViewContext.VIEW_HIERARCHY_TYPE_FLAT) ? "selected" : "" %>>Flat</option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 15px;">Show Metrics:</td>
					<td style="padding-top: 15px;">
						<input type="checkbox" id="showMetrics" name="showMetrics" value="true" <%=computationConfiguration.isShowMetrics() ? "checked" : "" %>>
					</td>
				</tr>
				<tr>
					<td class="REGULARTEXT" style="width:120px;padding-top: 15px;">Dates Range:</td>
					<td style="padding-top: 15px;">
						<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td style="width:120px;">
									<select id="timeInterval" name="timeInterval" size="1" style="width:140px" onChange="javascript:changeDefaultTimeInterval(this.value)">
									<%
									for(int i = 1; i < fixedIntervals.length; i++) {
									%>
										<option value="<%=fixedIntervals[i] %>" <%=fixedIntervals[i].equals(computationConfiguration.getTimeInterval()) ? "selected" : "" %>><%=fixedIntervalsNames[i] %></option>
									<% 
									}
									%>
									</select>
								</td>
								<td id="defaultTimeIntervalCustomTd" style="<%=defaultTimeIntervalCustomTdStyleStr %>">
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr>
											<td><a href="javascript:openDashboardCalendar(24, -80);" id="calendarLink"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarOpen.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarOpenOver.gif');showTooltip(dashboardTooltips['openCalendar'])" onMouseOut="javascript:setImageSource(this, 'header/calendarOpen.gif');hideTooltip()"></a></td>
											<td class="REGULARTEXT">
												<a href="javascript:openDashboardCalendar(24, -80);" class="DASHBOARD_HEADER_CALENDAR_LABEL_TEXT_LINK" id="defaultTimeIntervalCustomTextLink";><%=defaultTimeIntervalCustomTextLink %></a>
											</td>
										</tr>
									</table>
								</td>
								<td>&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10px">
		<td class="HEADER" style="padding-top: 25px;">Data Generation</td>
	</tr>
	<tr height="10px">
		<td>
			<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
				<tr>
					<td>
						<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td class="REGULARTEXT" style="width:200px;padding-top: 5px;">Enable Data Generation</td>
								<td style="padding-top: 5px;"><input type="checkbox" id="enableDataGeneration" name="enableDataGeneration" value="true" <%=dataGenerationEnabled ? "checked" : "" %>></td>
							</tr>
							<tr>
								<td class="REGULARTEXT" style="width:200px;padding-top: 5px;">Data Generation Interval:</td>
								<td style="padding-top: 5px;">
									<select id="dataGenerationInterval" name="dataGenerationInterval" size="1">
										<option value="5_minute" <%=computationConfiguration.getDataGenerationInterval().equals("5_minute") ? "selected" : "" %>>5 Minutes</option>
										<option value="10_minute" <%=computationConfiguration.getDataGenerationInterval().equals("10_minute") ? "selected" : "" %>>10 Minutes</option>
										<option value="15_minute" <%=computationConfiguration.getDataGenerationInterval().equals("15_minute") ? "selected" : "" %>>15 Minutes</option>
										<option value="30_minute" <%=computationConfiguration.getDataGenerationInterval().equals("30_minute") ? "selected" : "" %>>30 Minutes</option>
										<option value="1_hour" <%=computationConfiguration.getDataGenerationInterval().equals("1_hour") ? "selected" : "" %>>1 hour</option>
										<option value="2_hour" <%=computationConfiguration.getDataGenerationInterval().equals("2_hour") ? "selected" : "" %>>2 hours</option>
										<option value="3_hour" <%=computationConfiguration.getDataGenerationInterval().equals("3_hour") ? "selected" : "" %>>3 hours</option>
										<option value="6_hour" <%=computationConfiguration.getDataGenerationInterval().equals("6_hour") ? "selected" : "" %>>6 hours</option>
										<option value="12_hour" <%=computationConfiguration.getDataGenerationInterval().equals("12_hour") ? "selected" : "" %>>12 hours</option>
									</select>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<table border="0 width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td class="REGULARTEXT" style="padding-top: 30px;">When there is missing data while viewing the dashboard:</td>
							</tr>
							<tr>
								<td style="padding-top: 5px;">
									<input type="radio" name="missingDataUserPolicy" value="<%=ComputationConfiguration.MISSING_DATA_USER_POLICY_ASK %>" <%=computationConfiguration.getMissingDataUserPolicy().equals(ComputationConfiguration.MISSING_DATA_USER_POLICY_ASK) ? "checked" : "" %>><span class="REGULARTEXT">Ask me what to do</span>
								</td>
							</tr>
							<tr>
								<td style="padding-top: 5px;">
									<input type="radio" name="missingDataUserPolicy" value="<%=ComputationConfiguration.MISSING_DATA_USER_POLICY_COMPLETE %>" <%=computationConfiguration.getMissingDataUserPolicy().equals(ComputationConfiguration.MISSING_DATA_USER_POLICY_COMPLETE) ? "checked" : "" %>><span class="REGULARTEXT">Complete the data automatically</span>
								</td>
							</tr>
							<tr>
								<td style="padding-top: 5px;">
									<input type="radio" name="missingDataUserPolicy" value="<%=ComputationConfiguration.MISSING_DATA_USER_POLICY_IGNORE %>" <%=computationConfiguration.getMissingDataUserPolicy().equals(ComputationConfiguration.MISSING_DATA_USER_POLICY_IGNORE) ? "checked" : "" %>><span class="REGULARTEXT">Do nothing</span>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
</table>