function changeViewBy() {
	var viewBy = document.getElementById("viewBy");
	if(viewBy) {
		this.location = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationLogs.jsp?viewBy=" + viewBy.value;
	}
}

function doEnableDisable(doEnable){
  var objectId = getFirstSelectedRow(mygridLogs);
  if (objectId == "") {
    return;
  }
   
  var name = mygridLogs.cells(objectId,0).getValue();
  var objectType = mygridLogs.getUserData(objectId,"objectType");
  if(objectType == LOG_TYPE) {
   	doEnableDisable0(objectId, objectType, doEnable);
  }else {
   	var titleType = "";
   	var messageType = "";
   	if(objectType == MODULE_TYPE) {
   		titleType = "Folder";
   	  messageType = "folder";
   	}else if(objectType == META_DATA_TYPE) {
   		titleType = "Application";
   	  messageType = "application";
   	}else if(objectType == HOST_TYPE) {
   		titleType = "Server";
   	  messageType = "server";
   	}
   	var titleText = "Enable " + titleType + " Action";
  	if(!doEnable) {
   		titleText = "Disable " + titleType + " Action";
  	}
  	var msgWriter = new messageWriter("mygridLogsMessage",titleText,BASE_DIRECTORY);
    msgWriter.setYParent(document.getElementById("mygridLogs"),50);
    if(objectType == HOST_TYPE) {
   		var operationText1 = "Enable";
   		var operationText2 = "enabling";
   	   	if(!doEnable) {
   	   		operationText1 = "Disable";
   	   		operationText2 = "disabling";
   	   	}
   		msgWriter.addChbox(operationText1 + " data generation of all children logs","enableLogs","true");  
	    msgWriter.addChbox(operationText1 + " data generation of server metrics","enableMetrics","true");  
	   	msgWriter.addAction("Continue","javascript:hideLayer('mygridLogsMessage');javascript:doEnableDisable0('" + objectId + "','" +  objectType + "', " + doEnable + ")");
        msgWriter.addAction("Cancel","javascript:hideLayer('mygridLogsMessage')");
       	msgWriter.showMessage("<nobr>Please select the actions to take place when " + operationText2 + " data generation</nobr> <nobr>of " + messageType + " " + name + ":</nobr>");
    }else {
    	var operationText = "enable";
       	if(!doEnable) {
       		operationText = "disable";
       	}
    	msgWriter.addAction("Yes","javascript:hideLayer('mygridLogsMessage');javascript:doEnableDisable0('" + objectId + "','" +  objectType + "', " + doEnable + ")");
        msgWriter.addAction("No","javascript:hideLayer('mygridLogsMessage')");
       	msgWriter.showMessage("<nobr>Are you sure you want to " + operationText + "</nobr> data generation on all children of " + messageType + " " + name + "?");
    }
  }
}
 
function doEnableDisable0(objectId, objectType, doEnable) {
	var titleText = "Enable Data Generation";
 	if(doEnable == false) {
 		titleText = "Disable Data Generation";
 	}
 	var page = "logs/enableDisableObjectAction.jsp?objectId=" + objectId + "&objectType=" + objectType + "&doEnable=" + doEnable;
 	var enableLogs = document.getElementById("enableLogs");
 	if(enableLogs && enableLogs.checked){
  		page += "&enableLogs=true";
  	}
  	var enableMetrics = document.getElementById("enableMetrics");
  	if(enableMetrics && enableMetrics.checked){
  		page += "&enableMetrics=true";
  	}
  	showMessage(titleText,"Updating...",200,60);
 	sendAjaxRequest(page,function(req){
  	hideLayer('mygridLogsMessage');
    var xmldoc = req.responseXML.documentElement;            	
    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
    var message = xmldoc.getElementsByTagName('message')[0].text;
    if (result == "true"){
			var url = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationLogsXML.jsp?dataOnly=true&viewBy=" + VIEW_BY;
			mygridLogs.clearAll();
	  	mygridLogs.loadXML(url);
		}
  });
}

var currentObjectId;
var currentObjectType;
function openObjectAlerts() {
	var objectId = getFirstSelectedRow(mygridLogs);
	if (objectId == "") {
    return;
  }
  currentObjectId = objectId;
  var objectType = mygridLogs.getUserData(objectId,"objectType");
  currentObjectType = objectType;  
  var name = mygridLogs.cells(objectId,0).getValue();
  var typeText = "";
  if(objectType == LOG_TYPE) {
  	typeText = "Log";
  }else if(objectType == MODULE_TYPE) {
  	typeText = "Folder";
  }else if(objectType == META_DATA_TYPE) {
  	typeText = "Application";
  }else if(objectType == HOST_TYPE) {
  	typeText = "Server";
  }
  var divTitle = "Alerts of " + typeText + " " + name;
  var divMessage = "The following alerts will be sent for logs that belong to " + typeText + " " + name;
	if(objectType == LOG_TYPE) {
		divMessage = "The following alerts will be sent for " + typeText + " " + name;
	}
	
	openAlertsDiv(objectId, objectType, divTitle, divMessage);
}

function openGlobalAlerts() {
	var objectId = "dashboardGlobalVerifier";
	currentObjectId = objectId;
	var objectType = "Global";
	currentObjectType = objectType;  
	var divTitle = "Global Alerts";
	var divMessage = "The following alerts will be sent for any of the logs";
	
	openAlertsDiv(objectId, objectType, divTitle, divMessage);
}

function openAlertsDiv(objectId, objectType, divTitle, divMessage) {
	mygridAlerts.clearAll();
	var url = BASE_DIRECTORY + ALERTS_XML_PAGE + getCurrentObjectsQuery();
	url += "&forceNewBuilder=true";
	mygridAlerts.loadXML(url);
	hideAllAlertDivs();
	hideGeneralAdminDiv("EditServer");
	
	var generalDivTitleObjectAlerts = document.getElementById("generalDivTitleObjectAlerts");
	if (generalDivTitleObjectAlerts && divTitle){
		replaceHTML(generalDivTitleObjectAlerts, divTitle);
	}
	var objectAlertsTitleSpan = document.getElementById("objectAlertsTitleSpan");
	if(objectAlertsTitleSpan && divMessage) {
		replaceHTML(objectAlertsTitleSpan, divMessage);
	}
	showGeneralAdminDiv("ObjectAlerts");
}

function getCurrentObjectsQuery() {
	return "&objectId=" + currentObjectId + "&objectType=" + currentObjectType;
}
 
function showMessage(title,msg,width,height){
   var msgWriter = new messageWriter("mygridLogsMessage",title,BASE_DIRECTORY);
   msgWriter.setYParent(document.getElementById("mygridLogs"),50);
   msgWriter.width = width;
   msgWriter.height = height;
   msgWriter.showMessage(msg);
}
  
function doubleClick(){
 	/*var id = getFirstSelectedRow(mygridLogs);
  if (id == "") {
  	return;
  }
  var type = mygridLogs.cells(id,2).getValue();
  if (type == "Folder"){
  	if (mygridLogs.getOpenState(id)){
    	mygridLogs.closeItem(id);
    }else {
 	    mygridLogs.openItem(id);
    }
  }else {
    viewLog();
  }*/
}
  
function saveAlerts() {
	var url = "dashboardAdministrationObjectAlertsAction.jsp";
	sendAjaxRequest(url,function(req){
		var result = req.responseText;
		if (result){	
			result = result.replace(/^\s+|\s+$/g, '');
		}
		var resultStrs = result.split("#");
		if (resultStrs.length > 1 && resultStrs[0] == "SAVE_ALERT_ERROR"){
			var msg = "<ul>";
   		for (var i=1; i<resultStrs.length; i++){
   			msg = msg + "<li>" + resultStrs[i] + "</li>";
   		}
   		msg = msg + "</ul>"

    	var msgWriter = new messageWriter("saveAlertMessage","Save Alert Error",BASE_DIRECTORY);
	    msgWriter.addAction("OK","javascript:hideLayer('saveAlertMessage')");  
	    msgWriter.showMessage(msg);
		}else{
			showHideGeneralAdminDiv('ObjectAlerts');
			changeViewBy();
		}				
	});
}

function doNewServer() {
	var divTitle = "New server";
	
	editServer("", "", "", divTitle, 'true');
}

function doEditServer() {
	var objectId = getFirstSelectedRow(mygridLogs);
	if (objectId == "") {
		return;
	}
	var host = mygridLogs.getUserData(objectId,"host");
	var displayName = mygridLogs.getUserData(objectId,"displayName");
	var divTitle = "Edit server " + displayName;
	
	editServer(objectId, host, displayName, divTitle, 'false');
}

var isFirst = true;
function editServer(objectId, host, displayName, divTitle, isNew) {
	hideGeneralAdminDiv("ObjectAlerts");
	
	// update div title
	var generalDivTitleEditServer = document.getElementById("generalDivTitleEditServer");
	if (generalDivTitleEditServer && divTitle){
		replaceHTML(generalDivTitleEditServer, divTitle);
	}
	
	// update host and display name area
	var hostTd = document.getElementById("hostTd");
	if(hostTd) {
		var hostTdHtml = "<input id=\"host\" name=\"host\">";
		if(objectId != "") {
			hostTdHtml = host;
			hostTdHtml += "<input id=\"host\" name=\"host\" value=\"" + host + "\" type=\"hidden\">";
		}
		if(isNew) {
			hostTdHtml += "<input id=\"isNew\" name=\"isNew\" value=\"" + isNew + "\" type=\"hidden\">";
		}
		replaceHTML(hostTd, hostTdHtml);
	}
	var displayNameElement = document.getElementById("displayName");
	if(displayNameElement) {
		displayNameElement.value = displayName;
	}
	
	loadDivData("logsSelectionDivContentTd", "dashboardAdministrationEditServerLogs.jsp?", host);
	loadDivData("measurementsSettingsDivContentTd", "dashboardAdministrationMeasurementsSettings.jsp?host=" + host + "&isNew=" + isNew, host);
	// update logs selection div
	/*var logsSelectionDivContentTd = document.getElementById("logsSelectionDivContentTd");
	if(logsSelectionDivContentTd) {
		var url = "dashboardAdministrationEditServerLogs.jsp?";
		sendAjaxRequest(url,function(req){
			var result = req.responseText;
			if (result){	
				result = result.replace(/^\s+|\s+$/g, '');
			}
			//alert(result);
			replaceHTML(logsSelectionDivContentTd, result);
			//alert("aaa");
			loadEditServerLogsDivTree(host);
			
			showGeneralAdminDiv("EditServer");
			
			// init the tabs only in the first time
			if(isFirst) {
				initTabs();
				isFirst = false;
			}
		});
	}*/
	
	
}

var loadedDivs = new Array();
function loadDivData(divId, url, host) {
	loadedDivs[divId] = false;
	sendAjaxRequest(url,function(req){
		var result = req.responseText;
		if (result){	
			result = result.replace(/^\s+|\s+$/g, '');
		}
		onAfterDivResponseLoaded(divId, result, host);
	});
}

function onAfterDivResponseLoaded(divId, responseText, host) {
	var div = document.getElementById(divId);
	if(div) {
		if(divId == "logsSelectionDivContentTd") {
			replaceHTML(div, responseText);
			loadEditServerLogsDivTree(host);
		}else if(divId == "measurementsSettingsDivContentTd") {
			replaceHTML(div, responseText);
		}
		loadedDivs[divId] = true;
		
		// perform onAfterLaoded actions only if all divs were loaded
		if(allDivsLoaded()) {
			showGeneralAdminDiv("EditServer");
			
			// init the tabs only in the first time
			if(isFirst) {
				initTabs();
				isFirst = false;
			}else {
				tabbar.setTabActive("tab_1");
			}
		}
	}
}

function allDivsLoaded() {
	return loadedDivs["logsSelectionDivContentTd"] == true && loadedDivs["measurementsSettingsDivContentTd"];
}

var editServerLogsTree = null;
function loadEditServerLogsDivTree(host) {
	clearTreeNodes(editServerLogsTree);
	
	editServerLogsTree = new dhtmlXTreeObject("editServerLogsbox_tree","100%","100%","0");
	editServerLogsTree.setImagePath(BASE_DIRECTORY);
	editServerLogsTree.setIconSize(13,13);
	editServerLogsTree.enableTreeLines(false);
	editServerLogsTree.setOnLoadingStart(startLoading);
	editServerLogsTree.setOnLoadingEnd(endLoading);
	editServerLogsTree.enableCheckBoxes(1);
	editServerLogsTree.enableThreeStateCheckboxes(true);
	editServerLogsTree.loadingDivName = "editServerLogsDivLoading";
	editServerLogsTree.setXMLAutoLoading(BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationEditServerLogsTreeXML.jsp?host=" + host);
	editServerLogsTree.loadXML(BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationEditServerLogsTreeXML.jsp?host=" + host);
}

function updateSelectedServerLogs() {
	var list = editServerLogsTree.getAllChecked();
	var arr = list.split(",");
 	var logsStr = "";
 	var modsStr = "";
	for (var i = 0; i < arr.length; i++){
		var s = arr[i];
		var ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == "Module"){
				if (modsStr != ""){
					modsStr += ",";
				}
				modsStr += id;
				if (editServerLogsTree.hasChildren(s) && editServerLogsTree.hasChildren(s) == true){
					modsStr += "*";
				}
			}else{
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}
		}
	}
	document.access.serverModules.value = modsStr;
	document.access.serverLogs.value = logsStr;
}

function saveServer() {
	updateSelectedServerLogs();
	beforeSaveMetricsSettings();
	var analyticsHDisplayName = "Analytics";
	if (analyticsH){
		analyticsHDisplayName = analyticsH;
	} 
    
	var q = getFormElementsQueryString(document.access);
	var url = "dashboardAdministrationEditServerAction.jsp";
	sendAjaxRequest(url,function(req){
		var result = req.responseText;
		if (result){	
			result = result.replace(/^\s+|\s+$/g, '');
		}
		var resultStrs = result.split("#");
		if (resultStrs.length > 1 && resultStrs[0] == "SAVE_SERVER_ERROR"){
			var msg = "<ul>";
			for (var i=1; i<resultStrs.length; i++){
				msg = msg + "<li>" + resultStrs[i] + "</li>";
			}
			msg = msg + "</ul>"

	    	var msgWriter = new messageWriter("saveServerMessage","Save Server Error",BASE_DIRECTORY);
		    msgWriter.addAction("OK","javascript:hideLayer('saveServerMessage')");  
		    msgWriter.showMessage(msg);
		}else{
			var doContinue = false;
			if(resultStrs.length > 1) {
				var host = resultStrs[0];
				var dataSourceChanged = resultStrs[1];
				if(dataSourceChanged && dataSourceChanged == "true") {
					var msgWriter = new messageWriter("deleteMessage","Server " + analyticsHDisplayName + " Data Delete Action",BASE_DIRECTORY);
					msgWriter.setYParent(document.getElementById("mygridLogs"),50);
				    msgWriter.addAction("Yes","javascript:hideLayer('deleteMessage');javascript:doDeleteServerComputation('" + host + "')");
				    msgWriter.addAction("No","javascript:hideLayer('deleteMessage');onAfterEditServer()");  
				    msgWriter.showMessage("Metrics data source of server " + host + " has changed, do you wish to delete existing metrics analysis?");
				}else {
					doContinue = true;
				}
			}else {
				doContinue = true;
			}
			if(doContinue) {
				onAfterEditServer();
			}
		}
	}, 'POST', q);
}

function doDeleteServerComputation(host) {
	var analyticsHDisplayName = "Analytics";
	if (analyticsH){
		analyticsHDisplayName = analyticsH;
	}
    var msgWriter = new messageWriter("deleteMessage","Server " + analyticsHDisplayName + " Data Delete Action",BASE_DIRECTORY);
    msgWriter.showMessage("<nobr>Please wait while deleting server metrics analysis...</nobr>");
    var url = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationDeleteServerComputationAction.jsp?host=" + host;
	sendAjaxRequest(url,function(req) {
		hideLayer("deleteMessage");
		var xmldoc = req.responseXML.documentElement;
	    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	    if (result == "false"){
	    	var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	   		var msg = "<ul>";
	   		var errs = message.split("*;*");
	   		for (var i=0; i<errs.length; i++){
	   			msg = msg + "<li>" + errs[i] + "</li>";
	   		}
	   		msg = msg + "</ul>"

		    var msgWriter = new messageWriter("deleteMessage","Server " + analyticsHDisplayName + " Data Delete Error",BASE_DIRECTORY);
		    msgWriter.addAction("OK","javascript:hideLayer('deleteMessage')");  
		    msgWriter.showMessage(msg);
	    }else{
	    	onAfterEditServer();
	    }
	});
}

function onAfterEditServer() {
	showHideGeneralAdminDiv("EditServer");
	changeViewBy();
}

function doDeleteServer() {
	var objectId = getFirstSelectedRow(mygridLogs);
	if (objectId == "") {
		return;
	}
	doDeleteServer1(objectId);
}

  
function doDeleteServer1(id){
	if (id == "") {
    	return;
    }
	var displayName = mygridLogs.cells(id,0).getValue();
	var isEmpty = mygridLogs.getUserData(id,"isEmpty");
	var row = id;   
	var msgWriter = new messageWriter("deleteMessage","Server Delete Action",BASE_DIRECTORY);
	msgWriter.setYParent(document.getElementById("mygridLogs"),50);
	if (isEmpty && isEmpty == "true"){
	    msgWriter.addChbox("Delete metrics data","deleteMetricsData","true");  
	    msgWriter.addAction("Continue","javascript:hideLayer('deleteMessage');javascript:doDeleteServer0('" + row + "','" +  id + "')");
	    msgWriter.addAction("Cancel","javascript:hideLayer('deleteMessage')");  
	    msgWriter.showMessage("<nobr>Please select the actions to take place upon deletion of server " + displayName + ":</nobr>");
	}else{
		msgWriter.addAction("OK","javascript:hideLayer('deleteMessage')");
		msgWriter.showMessage("Server " + displayName + " cannot be deleted as it has folders and logs under it");
	}
}
  
function doDeleteServer0(row,id){
  	var url = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationDeleteServerAction.jsp?host=" + id + "&timestamp=" + new Date().getTime()
	var deleteMetricsData = document.getElementById("deleteMetricsData");
	if(deleteMetricsData && deleteMetricsData.checked){
		url += "&deleteMetricsData=true";
	}
	var msgWriter = document.getElementById("mygridDeleteMessage");
	if (!msgWriter){
		msgWriter = new messageWriter("mygridDeleteMessage","Server Delete Action",BASE_DIRECTORY);
	    msgWriter.showMessage("<nobr>Please wait while deleting server...");
	}else{
		showDisplayLayer("mygridDeleteMessage");
	}
	deleteGridRow(mygridLogs,row,url,null,"mygridDeleteMessage");
}

function onAfterDelete(divIdToHide){
	if(divIdToHide) {
		hideLayer(divIdToHide);
	}
}

function doVerifyServer() {
	var objectId = getFirstSelectedRow(mygridLogs);
	if (objectId == "") {
		return;
	}
	doVerifyServer0(objectId);
}
  
function doVerifyServer0(id){
  	var url = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationVerifyServerAction.jsp?host=" + id + "&timestamp=" + new Date().getTime()
	
  	var msgWriter = new messageWriter("mygridVerifyMessage","Server Verify Action",BASE_DIRECTORY);
    msgWriter.showMessage("<nobr>Please wait while verifying server connection...");

    sendAjaxRequest(url,function(req){
	  	hideLayer('mygridVerifyMessage');
	    var xmldoc = req.responseXML.documentElement;            	
	    var responseElement = xmldoc.getElementsByTagName("Response")[0];
		if(responseElement) {
			var status = responseElement.getAttribute("status");
			var message = responseElement.getAttribute("message");
			var msgWriter = new messageWriter("verifyResponseMessage","Server Verify Action Result",BASE_DIRECTORY);
			msgWriter.addAction("OK","javascript:hideLayer('verifyResponseMessage');");
		    var verifyResponseMessage = "";
			if(status == "error") {
				verifyResponseMessage = message;
			}else {
				msgWriter.setStyle("left");
				var resultElements = responseElement.getElementsByTagName("ResultElement");
				var resultElement;
				verifyResponseMessage += "<table>";
				for(i = 0; i < resultElements.length; i++) {
					verifyResponseMessage += "<tr>";
					verifyResponseMessage += "<td class='" + msgWriter.msgClass + "'>";
					resultElement = resultElements[i];
					verifyResponseMessage += resultElement.getAttribute("displayName");
					verifyResponseMessage += ": ";
					var isVerified = resultElement.getAttribute("isVerified");
					verifyResponseMessage += (isVerified == "true" ? "OK" : "Failed");
					verifyResponseMessage += "</td>";
					verifyResponseMessage += "</tr>";
					var errorMessage = getXMLElementValue(resultElement);
					if(errorMessage && errorMessage != "") {
						verifyResponseMessage += "<tr>";
						verifyResponseMessage += "<td style='padding-left: 15px; padding-bottom: 5px;' class='" + msgWriter.msgClass + "'>";
						verifyResponseMessage += errorMessage;
						verifyResponseMessage += "</td>";
						verifyResponseMessage += "</tr>";
					}
				}
				verifyResponseMessage += "</table>";
			}
			msgWriter.showMessage(verifyResponseMessage);
		}
	  });
	
}