<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurement"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementConfiguration"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementLogLocationInfo"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,null,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isSecurity = userContext != null && userContext.getUser() != null;

//boolean addLog = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
//boolean editLog = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION);
//boolean addModule = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
//boolean editModule = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_MODULE_PERMISSION);

String viewBy = request.getParameter("viewBy");
if(viewBy == null) {
	viewBy = ComputationConfiguration.getInstance().getViewBy();
}
boolean viewByFoldersAndLogs = viewBy != null && viewBy.equals(HealthViewContext.VIEW_BY_FOLDERS);
boolean viewByApplications = viewBy != null && viewBy.equals(HealthViewContext.VIEW_BY_APPLICATIONS);
boolean viewByServers = viewBy != null && viewBy.equals(HealthViewContext.VIEW_BY_SERVERS);

String PREFIX = "serverDefaultAccountId";

String suffix = "Logs";
%>

<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">

	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logAdministration.css" />
	<style type="text/css">
	a.MONITOR_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
	a.MONITOR_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
	a.MONITOR_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
	a.MONITOR_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
	</style>
	
	<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
	<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
	<script src="<%=BASE_DIRECTORY%>scripts/common/accounts.js" type="text/javascript"></script>

	<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	</jsp:include>
	
	<%
	HostMeasurementConfiguration defaultMeasurementConfiguration = null;
	HostMeasurementLogLocationInfo measurementLogLocationInfo = null;
	String selectedLogId = null;
	String[] measurementTypes = HostMeasurement.getMeasurementTypes();
	for(int i = 0; i < measurementTypes.length; i++) {
		defaultMeasurementConfiguration = HostsManager.getInstance().getDefaultHostMeasurementConfiguration(measurementTypes[i]);
		measurementLogLocationInfo = defaultMeasurementConfiguration.getMeasurementLocationInfo();
		if(measurementLogLocationInfo != null) {
			selectedLogId = measurementLogLocationInfo.getLbmId();
		}
		if(selectedLogId == null) {
			selectedLogId = "";
		}
		
		String selectLogSuffix = measurementTypes[i];
	%>
	<jsp:include page="../../common/selectLogHeader.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
		<jsp:param name="mode" value="logs" />
		<jsp:param name="treeOnly" value="true" />
		<jsp:param name="ignoreHeader" value="true" />
		<jsp:param name="allowNewLog" value="true" />
		<jsp:param name="logPopupMenu" value="true" />
		<jsp:param name="parameterName" value="Metrics log:" />
		<jsp:param name="openLinkName" value="select log" />
		<jsp:param name="showMonitorsModule" value="false" />
		<jsp:param name="showNewFilter" value="false" />
		<jsp:param name="paramNameWidth" value="150" />
		<jsp:param name="dummy" value="dummy" />
		<jsp:param name="suffix" value="<%=selectLogSuffix %>"/>
	</jsp:include>
	<%
	}
	%>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix%>" />
	</jsp:include>
	<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="useTree" value="true" />
	</jsp:include>
	
	
	<jsp:include page="../../common/constants.jsp" flush="true"/>

	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboard.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationLogs.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationAlerts.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationMeasurementsSettings.js"></script>
	
	<%
	//boolean showMenu = addLog || editLog || addModule || editModule;
	boolean showMenu = true;
	if(showMenu) {
		String menuIds = "enableObject,disableObject,openAlerts,editServer,deleteServer,verifyServer";
		String menuTexts = "Enable,Disable,Alerts,Edit Server,Delete Server,Verify Connection";
		String menuHrefs = "javascript:doEnableDisable(true);,javascript:doEnableDisable(false);,javascript:openObjectAlerts();,javascript:doEditServer();,javascript:doDeleteServer();,javascript:doVerifyServer()";
	%>
	  <jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		  <jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>
		<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		  <jsp:param name="showMenu" value="<%=showMenu%>" />
		  <jsp:param name="menuIds" value="<%=menuIds%>" />
		  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
		  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
		  <jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>
	<%
	}
	%>

	<script>
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
	var PREFIX = "<%=PREFIX%>";
	
	var LOG_TYPE = "<%=XpoLogObjectTypes.LOG_TYPE %>";
	var MODULE_TYPE = "<%=XpoLogObjectTypes.MODULE_TYPE %>";
	var META_DATA_TYPE = "<%=XpoLogObjectTypes.META_DATA_TYPE %>";
	var HOST_TYPE = "<%=XpoLogObjectTypes.HOST_TYPE %>";
	
	var VIEW_BY = "<%=viewBy %>";
	
	var MAIL_TASK_TYPE = "<%=MailTask.TYPE_MAIL%>";
	
	var ALERTS_XML_PAGE = "dashboard/admin/dashboardAdministrationObjectAlertsXML.jsp?dataOnly=true";
	var ALLOW_EDIT_EXTERNAL_ALERTS = false;

	var MEASUREMENT_DATA_TYPE_NONE = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_NONE %>';
	var MEASUREMENT_DATA_TYPE_INTERNAL = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL %>';
	var MEASUREMENT_DATA_TYPE_EXTERNAL = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL %>';
	
	function handleMenuItemsLogs(){
		aMenuLogs.menu.showButtons("enableObject,disableObject,openAlerts");
		var objectId = getFirstSelectedRow(mygridLogs);
		if (objectId == "") {
			return;
		}
		var host = mygridLogs.getUserData(objectId,"host");
		if(host && host != "") {
			aMenuLogs.menu.showButtons("editServer");
			aMenuLogs.menu.showButtons("deleteServer");
			aMenuLogs.menu.showButtons("verifyServer");
		}
	} 
	</script>
</head>

<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../common/addAccount.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="accDiv" value="accountId"/>
	<jsp:param name="zIndex" value="500"/>
</jsp:include>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus" + suffix + "();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0" method="POST">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
      	<tr height="10">
          <td>
          	<table border="0" cellpadding="0" cellspacing="0" bgcolor="#2a2b2f" width="100%">
							<tr height="24px">		
								<td style="padding-top:3px;padding-bottom:3px;padding-left:43px;font:bold 10pt tahoma;color:white;border-top;1 solid #3a3b3e;border-bottom;1 solid #383a40" >
									View By:&nbsp;
									<select id="viewBy" name="viewBy" onChange="javascript:changeViewBy()" style="font-size: 10pt; font-family: tahoma">
										<option value="<%=HealthViewContext.VIEW_BY_FOLDERS %>" <%=viewByFoldersAndLogs ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_FOLDERS) %></option>
										<option value="<%=HealthViewContext.VIEW_BY_APPLICATIONS %>" <%=viewByApplications ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_APPLICATIONS) %></option>
										<option value="<%=HealthViewContext.VIEW_BY_SERVERS %>" <%=viewByServers ? "selected" : "" %>><%=HealthViewModelHelper.getCurrentRootNodeName(HealthViewContext.VIEW_BY_SERVERS) %></option>
									</select>
								</td>		
							</tr>
						</table>
     			</td>
        </tr>
        <tr>                
          <td valign="top"> 
            <%                 
            			                
            String tableNames = "Enable Data Generation#Disable Data Generation";
            String tableActions = "javascript:doEnableDisable(true)#javascript:doEnableDisable(false)";
            String ids = "Enable#Disable";
            String selectTypes = "2#2";
        		
            if (tableNames.length() > 0){
          		tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          	}
            
            tableNames += "Alerts";
         		tableActions += "javascript:openObjectAlerts()";
         		ids += "Alerts";
         		selectTypes += "2";
         		
         		boolean dashboardSettings = manager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_SETTINGS_PERMISSION);
         		if (dashboardSettings){
         			tableNames += "#Global Alerts";
          		tableActions += "#javascript:openGlobalAlerts()";
          		ids += "#Global Alerts";
          		selectTypes += "#1";		              		
         		}
         		
         		if(viewByServers) {
         			tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          		
          		tableNames += "New Server#Edit Server#Delete Server#Verify Connection";
          		tableActions += "javascript:doNewServer()#javascript:doEditServer()#javascript:doDeleteServer()#javascript:doVerifyServer()";
          		ids += "New Server#Edit Server#Delete Server#Verify";
          		selectTypes += "1#3#3#3";
         		}
         		
        		String menu = showMenu ? "aMenu" + suffix : "";
        		
        		String initXML = "dashboard/admin/dashboardAdministrationLogsXML.jsp?viewBy=" + viewBy;
        		String updateXML = "dashboard/admin/dashboardAdministrationLogsXML.jsp?dataOnly=true&viewBy=" + viewBy;
            %>                               
	          <jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="<%=initXML %>" />
							<jsp:param name="updateXML" value="<%=updateXML %>" />
							<jsp:param name="expandTreeOnFilter" value="true" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="dragBehavior" value="complex" />
							<jsp:param name="newActionNames" value="" />
							<jsp:param name="newActions" value="" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Folder and Logs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="doubleClickAction" value="doubleClick" />
							<jsp:param name="suffix" value="<%=suffix %>" />
						</jsp:include>
<script>
	function updateButtonActivateLogs(rowid,id,columnType,gridType){
		if (!rowid || !mygridLogs.doesRowExist(rowid) || (gridType == 3 && columnType != 3)){
	  	disableActionButton(id);
	    return;
	  }
	  var type = mygridLogs.cells(rowid,1).getValue();
	  if (id == "Alerts" && type == "Server" && <%=String.valueOf(isSecurity && !userContext.isAdmin())%>){
      disableActionButton(id);    	
 	 	}else if ((id == "Edit Server" || id == "Delete Server" || id == "Verify") && type != "Server"){
      disableActionButton(id);    	
 	 	}else {
 	 	  enableActionButton(id); 	  	
 	 	}     	  
	}
</script>
        	</td>
        </tr>
   		</table>
	 	</td>
	</tr>
</table>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="ObjectAlerts"/> 
	<jsp:param name="includePath" value="dashboard/admin/dashboardAdministrationObjectAlerts.jsp"/>
	<jsp:param name="width" value="600px"/> 
	<jsp:param name="height" value="350px"/>
	<jsp:param name="title" value="Alerts"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlerts()#javascript:showHideGeneralAdminDiv('ObjectAlerts')"/> 
</jsp:include>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlert"/> 
	<jsp:param name="width" value="600px"/> 
	<jsp:param name="height" value="405px"/>
	<jsp:param name="title" value="Email Alert"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('MailAlert')#javascript:closeAlertDiv('MailAlert')"/> 
</jsp:include>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlertPrecondition"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="300px"/>
	<jsp:param name="title" value="XpoLog Center Mail Settings"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()#javascript:closeAlertDiv('MailAlertPrecondition')"/> 
</jsp:include>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="EditServer"/> 
	<jsp:param name="includePath" value="dashboard/admin/dashboardAdministrationEditServer.jsp"/>
	<jsp:param name="width" value="800px"/> 
	<jsp:param name="height" value="450px"/>
	<jsp:param name="title" value="Edit Server"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveServer()#javascript:showHideGeneralAdminDiv('EditServer')"/> 
</jsp:include>

<%
for(int i = 0; i < measurementTypes.length; i++) {
	String curentSuffix = "SelectLog" + measurementTypes[i];
	String actionsNames = "Close";
	String actions = "javascript:closeLogSelectionDiv" + measurementTypes[i] + "()";
%>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Metrics Data Source"/> 
	<jsp:param name="suffix" value="<%=curentSuffix %>"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>
<%
}
%>
<script>
	function updateButtonActivateAlerts(rowid,id,columnType,gridType){
		if (!id || id == "") return;

		var external = mygridAlerts.getUserData(rowid,"external");
	  if(external && external == "true") {
		  disableActionButton(id);
		  return;
	  }
		if(id == "EnableTask" || id == "DisableTask") {
			var enabled = mygridAlerts.getUserData(rowid,"enabled");
			if(enabled && enabled == "true") {
				if(id == "EnableTask") {
					disableActionButton(id);
				}else {
					enableActionButton(id);
				}
			}else {
				if(id == "EnableTask") {
					enableActionButton(id);
				}else {
					disableActionButton(id);
				}
			}
		}else {
			enableActionButton(id);
		}
	}
</script>
</form>
</body>
</html>