function toggleUseDefaultMeasurementSettings(useDefault) {
	var measurementsSettingsMainDiv = document.getElementById("measurementsSettingsMainDiv");
	if(measurementsSettingsMainDiv) {
		if(useDefault == "true") {
			measurementsSettingsMainDiv.style.display = "none";
		}else {
			measurementsSettingsMainDiv.style.display = "";
		}
	}
}

function toggleMeasurementDataType(measurementDataType, measurementType) {
	var measurementDataTypeInternal = document.getElementById("measurementDataTypeInternal" + measurementType + "Div");
	var measurementDataTypeExternal = document.getElementById("measurementDataTypeExternal" + measurementType + "Div");
	if(measurementDataTypeInternal && measurementDataTypeExternal) {
		if(measurementDataType == MEASUREMENT_DATA_TYPE_NONE) {
			measurementDataTypeInternal.style.display = "none";
			measurementDataTypeExternal.style.display = "none";
			hideGeneralAdminDiv("SelectLog" + measurementType);
		}else if(measurementDataType == MEASUREMENT_DATA_TYPE_INTERNAL) {
			measurementDataTypeInternal.style.display = "";
			measurementDataTypeExternal.style.display = "none";
			hideGeneralAdminDiv("SelectLog" + measurementType);
		}else if(measurementDataType == MEASUREMENT_DATA_TYPE_EXTERNAL) {
			measurementDataTypeInternal.style.display = "none";
			measurementDataTypeExternal.style.display = "";
		}
	}
}

function validateAlertsDuration(measurementType, samplingInterval) {
	validateAlertDuration(measurementType, samplingInterval, "high");
	validateAlertDuration(measurementType, samplingInterval, "medium");
}

function validateAlertDuration(measurementType, samplingInterval, alertType) {
	var duration = document.getElementById(alertType + measurementType + "Duration");
	if(duration) {
		var durationValue = duration.value;
		var targetDuration = getDurationFromSamplingInterval(samplingInterval);
		if(targetDuration != -1 && durationValue < targetDuration) {
			duration.value = targetDuration;
		}
	}
}

function getDurationFromSamplingInterval(samplingInterval) {
	var duration = -1;
	if(samplingInterval == "5_second") {
		duration = 5000;
	}else if(samplingInterval == "15_second") {
		duration = 15000;
	}else if(samplingInterval == "30_second") {
		duration = 30000;
	}else if(samplingInterval == "1_minute") {
		duration = 60000;
	}else if(samplingInterval == "2_minute") {
		duration = 120000;
	}else if(samplingInterval == "5_minute") {
		duration = 300000;
	}else if(samplingInterval == "15_minute") {
		duration = 900000;
	}else if(samplingInterval == "30_minute") {
		duration = 1800000;
	}else if(samplingInterval == "1_hour") {
		duration = 3600000;
	}else if(samplingInterval == "3_hour") {
		duration = 10800000;
	}else if(samplingInterval == "6_hour") {
		duration = 21600000;
	}else if(samplingInterval == "12_hour") {
		duration = 43200000;
	}else if(samplingInterval == "1_day") {
		duration = 86400000;
	}
	return duration;
}

function updateSourceForLogChangecpu(id,name){
	updateSourceForLogChange0(id, name, "cpu");
}

function updateSourceForLogChangememory(id,name){
	updateSourceForLogChange0(id, name, "memory");
}

function updateSourceForLogChangediskSpace(id,name){
	updateSourceForLogChange0(id, name, "diskSpace");
}

function updateSourceForLogChange0(id,name,measurementType){
	if(id) {
		var lbmId = "";
		if (id.indexOf("Log-") == 0){
			lbmId = id.substring(4);
		}else{
			lbmId = id;
		}
		eval("document.access.externalLogId" + measurementType).value = lbmId;
		var selectedLog = eval("tree" + measurementType).getAllCheckedAndPartiallyChecked();
		if(selectedLog == '') {
			selectedLog = lbmId;
		}
		var measurementDataTypeExternalLogDiv = document.getElementById("measurementDataTypeExternalLog" + measurementType + "Div");
		if(selectedLog == '') {
			measurementDataTypeExternalLogDiv.style.display = "none";
		}else {
			measurementDataTypeExternalLogDiv.style.display = "";
			var content = "<span class='MEDIUMTEXT'>Loading...</span>";
			replaceDivContent("measurementDataTypeExternalLog" + measurementType + "Div", content);
		}
		var filterId = "";
		var url = "externalDataSourceDiv.jsp?lbmId="+lbmId+"&measurementType="+measurementType;
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get logs list!");
				return;			
			}
			if(measurementDataTypeExternalLogDiv) {
				if(result == "NO_LOG") {
					replaceDivContent("measurementDataTypeExternalLog" + measurementType + "Div", "");
				}else {
					replaceDivContent("measurementDataTypeExternalLog" + measurementType + "Div", result);
				}
			}
		});
	}
}

function beforeSaveMetricsSettings() {
	var measurementTypes = new Array();
	measurementTypes[0] = "cpu";
	measurementTypes[1] = "memory";
	measurementTypes[2] = "diskSpace";
	for(i = 0; i < measurementTypes.length; i++) {
		var mediumcpuMaxValue = document.getElementById("medium" + measurementTypes[i] + "MaxValue");
		var highcpuMinValue = document.getElementById("high" + measurementTypes[i] + "MinValue");
		if(mediumcpuMaxValue && highcpuMinValue) {
			mediumcpuMaxValue.value = highcpuMinValue.value;
		}
	}
}