<%@ page language="java"%>

<%@ page import="java.util.HashMap"%>

<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.hosts.HostInfo"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementConfiguration"%>
<%@ page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementAlertDefinition"%>
<%@ page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementComputationLogic"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.*"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);

	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}
	String isNewStr = request.getParameter("isNew");
	boolean isNew = isNewStr != null && isNewStr.equals("true");
	String host = request.getParameter("host");
	if(host != null && host.length() == 0) {
		host = null;
	}
	boolean isHost = (host != null || isNew);
	boolean isLocalhost = isHost && host != null && host.equals("localhost");
	
	HostsManager hostsManager = HostsManager.getInstance();
	HostInfo hostInfo = null;
	HostMeasurementConfiguration measurementConfiguration = null, defaultMeasurementConfiguration = null;
	if(host != null) {
		hostInfo = hostsManager.getHostInfo(host);
	}
	
	boolean displayMainDiv = false;
	HashMap measurementConfigurations = null;
	if(isHost) {
		if(hostInfo != null) {
			measurementConfigurations = hostInfo.getHostMeasurementConfigurations();
			if(measurementConfigurations != null && !measurementConfigurations.isEmpty()) {
				displayMainDiv = true;
			}
		}
	}else {
		displayMainDiv = true;
	}
	
	String[] measurementTypes = new String[]{HostCpu.HOST_CPU_TYPE, HostMemory.HOST_MEMORY_TYPE, HostDiskSpace.HOST_DISK_SPACE_TYPE};
	String[] measurementTypesDisplayNames = new String[]{"CPU", "Memory", "Disk Space"};
	boolean[] measurementTypesDisplayUseMeasurementDeviceId = new boolean[]{true, false, true};
	String[] measurementTypesDeviceNames = new String[]{"CPU", "", "device"};
	
	String PREFIX = "serverDefaultAccountId";
	String accountId = "";
	if(hostInfo != null && hostInfo.getDefaultAccountId() != null) {
		accountId = hostInfo.getDefaultAccountId();
	}
	String locationType = "";
	if(hostInfo != null) {
		if(hostInfo.isWindows()) {
			locationType = "auth";
		}else if(hostInfo.isUnix()) {
			locationType = "ssh";
		}else {
			if(XpologSystemInfo.isWindows()) {
				locationType = "auth|ssh";
			}else {
				locationType = "ssh";
			}
		}
	}else {
		if(XpologSystemInfo.isWindows()) {
			locationType = "auth|ssh";
		}else {
			locationType = "ssh";
		}
	}
	
%>

<table border="0" cellpadding="0" cellspacing="0" width="100%" align="center">
	<tr valign="top" height="10">
		<td style="padding-left:20px;padding-right:20px" valign="top">
			<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<%
			if(isHost && !isLocalhost) {
			%>
				<tr height="10px">
					<td class="HEADER" style="padding-bottom:5px">Connection</td>
				</tr>
				<tr>
					<td style="padding-bottom:10px">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td>
									<div id="<%=PREFIX%>accountDiv"> 			                   
									<table border="0" cellpadding="0" cellspacing="0" width="100%">                                        
										<tr>
											<td width="23%"><span class="REGULARTEXT">Connection Details</span></td>
											<td width="77%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
													<tr>
														<td width="100px">
															<div id="<%=PREFIX%>accountsListDiv">
																<%
																String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
																%>
																<jsp:include flush="true" page="<%=accountsListUrl %>">
																	<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
																	<jsp:param name="ACC_ID" value="<%=accountId%>"/>
																	<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																	<jsp:param name="ON_CHANGE_ACTION" value="updateHostFromAccount()"/>
																	<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																</jsp:include> 																								
															</div>														                        
														</td>
														<%if(userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)) { %>
														<td style="padding-left:5">
															<div id="<%=PREFIX%>newAccountDiv">
																<span class="SMALLTEXT"><a href="javascript:openNewAccDiv('addAccDiv','<%=locationType %>','','new','<%=PREFIX %>AccountsList','<%=BASE_DIRECTORY %>');" class="BUTTON_MEDIUMLINK">new</a></span>
															</div>	
														</td>
														<%} %>
														<td width="*">&nbsp;</td>
													</tr>
												</table>
											</td>
										</tr>
										<tr>
											<td colspan="2" style="padding-top:3">
												<div id="<%=PREFIX%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
												</div>
											</td>
										</tr>
									</table>
									</div>  
								</td>
							</tr>
						</table>
					</td>
				</tr>
			<%
			}
			%>
			
				<tr height="10px">
					<td class="HEADER" style="padding-bottom:5px">Settings</td>
				</tr>
			<%
			if(isHost) {
			%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
			 					<td style="width: 20px"><input type="radio" id="useDefaultMeasurementSettings" name="useDefaultMeasurementSettings" value="true" onClick="javascript:toggleUseDefaultMeasurementSettings('true')" <%=displayMainDiv ? "" : "checked" %>></td>
			 					<td><span class="MEDIUMTEXT">Use the default settings</span></td>
			 				</tr>
			 				<tr>
			 					<td style="width: 20px"><input type="radio" id="useDefaultMeasurementSettings" name="useDefaultMeasurementSettings" value="false" onClick="javascript:toggleUseDefaultMeasurementSettings('false')" <%=displayMainDiv ? "checked" : "" %>></td>
			 					<td><span class="MEDIUMTEXT">Use custom settings</span></td>
			 				</tr>
						</table>
					</td>
				</tr>
			<%
			}
			%>
				<tr>
					<td style="<%=displayMainDiv ? "" : "padding-left:20px" %>">
					<div id="measurementsSettingsMainDiv" style="display:<%=displayMainDiv ? "" : "none" %>">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
						<%
						for(int i = 0; i < measurementTypes.length; i++) {
							measurementConfiguration = null;
							defaultMeasurementConfiguration = hostsManager.getDefaultHostMeasurementConfiguration(measurementTypes[i]);
							if(hostInfo != null) {
								measurementConfiguration = hostInfo.getHostMeasurementConfiguration(measurementTypes[i]);
							}
							if(measurementConfiguration == null) {
								measurementConfiguration = defaultMeasurementConfiguration;
							}
							if(measurementConfiguration == null) {
								continue;
							}
							
							String measurementDataType = measurementConfiguration.getMeasurementDataType();
							if(measurementDataType == null) {
								measurementDataType = HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL;
							}
							String measurementDataTypeInternalDivDisplay = "none";
							String measurementDataTypeExternalDivDisplay = "none";
							if(measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL)) {
								measurementDataTypeInternalDivDisplay = "";
							}else if(measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL)) {
								measurementDataTypeExternalDivDisplay = "";
							}
							
							String samplingInterval = measurementConfiguration.getSamplingInterval();
							if(samplingInterval == null) {
								samplingInterval = "30_second";
							}
							
							String externalLogId = "";
							String measurementValueColName = "";
							String filterId = "";
							String measurementIdColumnName = "";
							String hostColumnName = "";
							boolean displayExternalDiv = false;
							if(measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL)) {
								externalLogId = measurementConfiguration.getMeasurementLocationInfo().getLbmId();
								measurementValueColName = measurementConfiguration.getMeasurementLocationInfo().getMeasurementValueColName();
								filterId = measurementConfiguration.getMeasurementLocationInfo().getFilterId();
								measurementIdColumnName = measurementConfiguration.getMeasurementLocationInfo().getMeasurementIdColumnName();
								hostColumnName = measurementConfiguration.getMeasurementLocationInfo().getHostColumnName();
								displayExternalDiv = true;
							}
							
						%>
							<tr>
								<td>
									<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
										<jsp:param name="baseDirectory" value="../../" />
										<jsp:param name="suffix" value="<%=measurementTypes[i] %>" />
										<jsp:param name="headerName" value="<%=measurementTypesDisplayNames[i] %>" />
										<jsp:param name="startOpen" value="false" />
										<jsp:param name="showCheckBox" value="false" />
										<jsp:param name="closeOthers" value="false" />
										<jsp:param name="openOnClick" value="true" />
									</jsp:include>
								</td>
							</tr>
							<tr valign="top">
								<td>																										
									<table border="0" id="adminHeaderContent<%=measurementTypes[i] %>" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
										<tr valign="top" >
											<td style="padding-left:20px;border-top:1 solid white">
											<div>			  																			
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td>
															<%
															String suffix = "measurementDataSource" + measurementTypes[i];
															%>
															<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																<jsp:param name="baseDirectory" value="../../" />
																<jsp:param name="suffix" value="<%=suffix %>" />
																<jsp:param name="level" value="1" />
																<jsp:param name="headerName" value="Measurements Data Source" />
																<jsp:param name="startOpen" value="false" />
																<jsp:param name="showCheckBox" value="false" />
																<jsp:param name="closeOthers" value="false" />
																<jsp:param name="openOnClick" value="true" />
															</jsp:include>
														</td>
													</tr>
													<tr>
														<td style="padding-left:20px">																										
															<table border="0" id="adminHeaderContent<%=suffix %>" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																<tr>
						                  		<td>
						                  			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						                  				<tr>
						                  					<td style="width: 20px"><input type="radio" id="measurementDataType_<%=measurementTypes[i] %>" name="measurementDataType_<%=measurementTypes[i] %>" value="<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_NONE %>" <%=measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_NONE) ? "checked" : "" %> onClick="javascript:toggleMeasurementDataType('<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_NONE %>', '<%=measurementTypes[i] %>')"></td>
						                  					<td><span class="MEDIUMTEXT">None - no measurements will be taken</span></td>
						                  				</tr>
						                  				<tr>
						                  					<td><input type="radio" id="measurementDataType_<%=measurementTypes[i] %>" name="measurementDataType_<%=measurementTypes[i] %>" value=<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL %> <%=measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL) ? "checked" : "" %> onClick="javascript:toggleMeasurementDataType('<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL %>', '<%=measurementTypes[i] %>')"></td>
						                  					<td><span class="MEDIUMTEXT">Internal - measurements will be taken from XpoLog's monitoring engine</span></td>
						                  				</tr>
						                  				<tr id="measurementDataTypeInternal<%=measurementTypes[i] %>Div" style="display:<%=measurementDataTypeInternalDivDisplay %>">
						                  					<td>&nbsp;</td>
						                  					<td style="padding-left: 5px">
						                  					<div>
						                  						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						                  							<tr>
						                  								<td>
						                  									<span class="MEDIUMTEXT">Set the sampling interavl:</span>
						                  									<select id="samplingInterval_<%=measurementTypes[i] %>" name="samplingInterval_<%=measurementTypes[i] %>" onChange="javascript:validateAlertsDuration('<%=measurementTypes[i] %>', this.value)" class="MEDIUMTEXTBOX">
						                  										<option value="5_second" <%=samplingInterval.equals("5_second") ? "selected" : "" %>>5 seconds</option>
						                  										<option value="15_second" <%=samplingInterval.equals("15_second") ? "selected" : "" %>>15 seconds</option>
						                  										<option value="30_second" <%=samplingInterval.equals("30_second") ? "selected" : "" %>>30 seconds</option>
						                  										<option value="1_minute" <%=samplingInterval.equals("1_minute") ? "selected" : "" %>>1 minute</option>
						                  										<option value="2_minute" <%=samplingInterval.equals("2_minute") ? "selected" : "" %>>2 minutes</option>
						                  										<option value="5_minute" <%=samplingInterval.equals("5_minute") ? "selected" : "" %>>5 minutes</option>
						                  										<option value="15_minute" <%=samplingInterval.equals("15_minute") ? "selected" : "" %>>15 minutes</option>
						                  										<option value="30_minute" <%=samplingInterval.equals("30_minute") ? "selected" : "" %>>30 minutes</option>
						                  										<option value="1_hour" <%=samplingInterval.equals("1_hour") ? "selected" : "" %>>1 hour</option>
						                  										<option value="3_hour" <%=samplingInterval.equals("3_hour") ? "selected" : "" %>>3 hours</option>
						                  										<option value="6_hour" <%=samplingInterval.equals("6_hour") ? "selected" : "" %>>6 hours</option>
						                  										<option value="12_hour" <%=samplingInterval.equals("12_hour") ? "selected" : "" %>>12 hours</option>
						                  										<option value="1_day" <%=samplingInterval.equals("1_day") ? "selected" : "" %>>1 day</option>
						                  									</select>
						                  								</td>
						                  							</tr>
						                  						</table>
						                  					</div>
						                  					</td>
						                  				</tr>
						                  				<tr>
						                  					<td><input type="radio" id="measurementDataType_<%=measurementTypes[i] %>" name="measurementDataType_<%=measurementTypes[i] %>" value=<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL %> <%=measurementDataType.equals(HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL) ? "checked" : "" %> onClick="javascript:toggleMeasurementDataType('<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL %>', '<%=measurementTypes[i] %>')"></td>
						                  					<td><span class="MEDIUMTEXT">External - measurements will be taken from a log</span></td>
						                  				</tr>
						                  				<tr id="measurementDataTypeExternal<%=measurementTypes[i] %>Div" style="display:<%=measurementDataTypeExternalDivDisplay %>">
						                  					<td>&nbsp;</td>
						                  					<td style="padding-left: 5px">
						                  					<div>
						                  						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						                  							<tr>
						                  								<td>
						                  									<%
						                  									String selectLogSuffix = measurementTypes[i];
						                  									%>
						                  									<input type="hidden" id="externalLogId<%=measurementTypes[i] %>" name="externalLogId<%=measurementTypes[i] %>" value="<%=externalLogId%>">
						                  									<jsp:include page="../../common/selectLog.jsp" flush="true">
																									<jsp:param name="baseDirectory" value="../../" />
																									<jsp:param name="LBM_ID" value="<%=externalLogId%>" />
																									<jsp:param name="ignoreHeader" value="true"/>
																									<jsp:param name="noTree" value="true"/>
																									<jsp:param name="mode" value="logs" />
																									<jsp:param name="allowNewLog" value="true" />
																									<jsp:param name="logPopupMenu" value="true" />
																									<jsp:param name="parameterName" value="Metrics Log:" />
																									<jsp:param name="openLinkName" value="select log" />
																									<jsp:param name="showNewFilter" value="false" />
																									<jsp:param name="labelWidth" value="150" />
																									<jsp:param name="textBoxSize" value="30" />
																									<jsp:param name="className" value="MEDIUMTEXT" />
																									<jsp:param name="suffix" value="<%=selectLogSuffix %>"/>
																								</jsp:include>
																							</td>
						                  							</tr>
						                  							<tr>
						                  								<td>
						                  								<div id="measurementDataTypeExternalLog<%=measurementTypes[i] %>Div" style="display:<%=displayExternalDiv ? "" : "none" %>">
						                  									<jsp:include page="externalDataSourceDiv.jsp" flush="true">
																									<jsp:param name="measurementType" value="<%=measurementTypes[i]%>" />
																									<jsp:param name="lbmId" value="<%=externalLogId%>" />
																									<jsp:param name="filterId" value="<%=filterId%>" />
																									<jsp:param name="measurementValueColName" value="<%=measurementValueColName%>" />
																									<jsp:param name="measurementIdColumnName" value="<%=measurementIdColumnName%>" />
																									<jsp:param name="hostColumnName" value="<%=hostColumnName%>" />
																								</jsp:include>
						                  								</div>
						                  								</td>
						                  							</tr>
						                  						</table>
						                  					</div>
						                  					</td>
						                  				</tr>
						                  			</table>
						                  		</td>
						                 		</tr>  							
															</table>
														</td>
													</tr>																						
												</table>			
											</div>
											</td>													                      
										</tr>
										<tr valign="top" >
											<td style="padding-left:20px;border-top:1 solid white">
											<div>			  																			
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td>																										
															<%
															suffix = "rules" + measurementTypes[i];
															%>
															<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																<jsp:param name="baseDirectory" value="../../" />
																<jsp:param name="suffix" value="<%=suffix %>" />
																<jsp:param name="level" value="1" />
																<jsp:param name="headerName" value="Rules" />
																<jsp:param name="startOpen" value="false" />
																<jsp:param name="showCheckBox" value="false" />
																<jsp:param name="closeOthers" value="false" />
																<jsp:param name="openOnClick" value="true" />
															</jsp:include>
														</td>
													</tr>
													<tr>
														<td style="padding-left:20px">																										
															<table border="0" id="adminHeaderContent<%=suffix %>" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																<tr>
						                  		<td>
						                  			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						                  				<%
						                  				
						                  				HostMeasurementComputationLogic measurementComputationLogic = measurementConfiguration.getMeasurementComputationLogic();
						                  				if(measurementComputationLogic == null && defaultMeasurementConfiguration != null) {
						                  					measurementComputationLogic = defaultMeasurementConfiguration.getMeasurementComputationLogic();
						                  				}
						                  				//if(measurementComputationLogic != null) {
						                  					boolean useMeasurementDeviceId = true;
						                  					if(measurementComputationLogic != null) {
						                  						useMeasurementDeviceId = measurementComputationLogic.isUseMeasurementDeviceId();
						                  					}
							                  				for(int j = 0; j < HostMeasurementComputationLogic.alertLevels.length; j++) {
							                  					HostMeasurementAlertDefinition measurementAlertDefinition = null;
								                  				if(measurementComputationLogic != null) {
								                  					measurementAlertDefinition = measurementComputationLogic.getAlertDefinition(HostMeasurementComputationLogic.alertLevels[j] + "_" + measurementTypes[i]);
								                  				}
								                  				double minValue = -1;
								                  				long duration = -1;
								                  				if(measurementAlertDefinition != null) {
								                  					minValue = measurementAlertDefinition.getMinValue();
								                  					duration = measurementAlertDefinition.getDuration();
								                  				}
						                  				%>
						                  				<tr>
						                  					<td style="width:20px;padding-bottom:5px;"><input type="checkbox" id="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>Enabled" name="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>Enabled" value="true" <%=measurementAlertDefinition == null ? "" : "checked" %>></td>
						                  					<td style="width:225px;padding-bottom:5px;"><span class="MEDIUMTEXT"><%=HostMeasurementComputationLogic.alertLevelsTexts[j] %> Severity Problem - more than</span></td>
						                  					<td style="width:40px;padding-bottom:5px;">
						                  						<%
						                  						String maxValue = "";
						                  						if(HostMeasurementComputationLogic.alertLevels[j].equals("high")) {
						                  							maxValue = String.valueOf(Double.NaN);
						                  						}
						                  						%>
						                  						<input type="hidden" id="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>MaxValue" name="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>MaxValue" value="<%=maxValue %>">
						                  						<select id="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>MinValue" name="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>MinValue" class="MEDIUMTEXTBOX">
						                  							<option value="5" <%=minValue == 5 ? "selected" : "" %>>5%</option>
						                  							<option value="10" <%=minValue == 10 ? "selected" : "" %>>10%</option>
						                  							<option value="15" <%=minValue == 15 ? "selected" : "" %>>15%</option>
						                  							<option value="20" <%=minValue == 20 ? "selected" : "" %>>20%</option>
						                  							<option value="25" <%=minValue == 25 ? "selected" : "" %>>25%</option>
						                  							<option value="30" <%=minValue == 30 ? "selected" : "" %>>30%</option>
						                  							<option value="35" <%=minValue == 35 ? "selected" : "" %>>35%</option>
						                  							<option value="40" <%=minValue == 40 ? "selected" : "" %>>40%</option>
						                  							<option value="45" <%=minValue == 45 ? "selected" : "" %>>45%</option>
						                  							<option value="50" <%=minValue == 50 ? "selected" : "" %>>50%</option>
						                  							<option value="55" <%=minValue == 55 ? "selected" : "" %>>55%</option>
						                  							<option value="60" <%=minValue == 60 ? "selected" : "" %>>60%</option>
						                  							<option value="65" <%=minValue == 65 ? "selected" : "" %>>65%</option>
						                  							<option value="70" <%=minValue == 70 ? "selected" : "" %>>70%</option>
						                  							<option value="75" <%=minValue == 75 ? "selected" : "" %>>75%</option>
						                  							<option value="80" <%=minValue == 80 ? "selected" : "" %>>80%</option>
						                  							<option value="85" <%=minValue == 85 ? "selected" : "" %>>85%</option>
						                  							<option value="90" <%=minValue == 90 ? "selected" : "" %>>90%</option>
						                  							<option value="91" <%=minValue == 91 ? "selected" : "" %>>91%</option>
						                  							<option value="92" <%=minValue == 92 ? "selected" : "" %>>92%</option>
						                  							<option value="93" <%=minValue == 93 ? "selected" : "" %>>93%</option>
						                  							<option value="94" <%=minValue == 94 ? "selected" : "" %>>94%</option>
						                  							<option value="95" <%=minValue == 95 ? "selected" : "" %>>95%</option>
						                  							<option value="96" <%=minValue == 96 ? "selected" : "" %>>96%</option>
						                  							<option value="97" <%=minValue == 97 ? "selected" : "" %>>97%</option>
						                  							<option value="98" <%=minValue == 98 ? "selected" : "" %>>98%</option>
						                  							<option value="99" <%=minValue == 99 ? "selected" : "" %>>99%</option>
						                  							<option value="99.5" <%=minValue == 99.5 ? "selected" : "" %>>99.5%</option>
						                  						</select>
						                  					</td>
						                  					<td style="width:100px;padding-bottom:5px;"><span class="MEDIUMTEXT">&nbsp;&nbsp;for longer than&nbsp;</span></td>
						                  					<td style="width:120px;padding-bottom:5px;">
						                  						<select id="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>Duration" name="<%=HostMeasurementComputationLogic.alertLevels[j]%><%=measurementTypes[i] %>Duration" class="MEDIUMTEXTBOX">
						                  							<option value="5000" <%=duration == 5000 ? "selected" : "" %>>5 seconds</option>
						                  							<option value="15000" <%=duration == 15000 ? "selected" : "" %>>15 seconds</option>
						                  							<option value="30000" <%=duration == 30000 ? "selected" : "" %>>30 seconds</option>
						                  							<option value="60000" <%=duration == 60000 ? "selected" : "" %>>1 minute</option>
						                  							<option value="120000" <%=duration == 120000 ? "selected" : "" %>>2 minutes</option>
						                  							<option value="300000" <%=duration == 300000 ? "selected" : "" %>>5 minutes</option>
						                  							<option value="900000" <%=duration == 900000 ? "selected" : "" %>>15 minutes</option>
						                  							<option value="1800000" <%=duration == 1800000 ? "selected" : "" %>>30 minutes</option>
						                  							<option value="3600000" <%=duration == 3600000 ? "selected" : "" %>>1 hour</option>
						                  							<option value="10800000" <%=duration == 10800000 ? "selected" : "" %>>3 hours</option>
						                  							<option value="21600000" <%=duration == 21600000 ? "selected" : "" %>>6 hours</option>
						                  							<option value="43200000" <%=duration == 43200000 ? "selected" : "" %>>12 hours</option>
						                  							<option value="86400000" <%=duration == 86400000 ? "selected" : "" %>>1 day</option>
						                  						</select>
						                  					</td>
						                  					<td>&nbsp;</td>
						                  				</tr>
						                  				<%
						                  					}
							                  				if(measurementTypesDisplayUseMeasurementDeviceId[i]) {
						                  				%>
						                  				<tr>
						                  					<td colspan="6" style="padding-top:15px;">
						                  						<table border="0" cellpadding="0" cellspacing="0" width="100%">
						                  							<tr>
						                  								<td style="width:120px"><span class="MEDIUMTEXT">Identify problems:</span></td>
						                  								<td><input type="radio" id="useMeasurementDeviceId<%=measurementTypes[i] %>" name="useMeasurementDeviceId<%=measurementTypes[i] %>" value="false" <%=useMeasurementDeviceId ? "" : "checked" %>><span class="MEDIUMTEXT">&nbsp;by average of for all <%=measurementTypesDeviceNames[i] %>s</span></td>
						                  							</tr>
						                  							<tr>
						                  								<td>&nbsp;</td>
						                  								<td><input type="radio" id="useMeasurementDeviceId<%=measurementTypes[i] %>" name="useMeasurementDeviceId<%=measurementTypes[i] %>" value="true" <%=useMeasurementDeviceId ? "checked" : "" %>><span class="MEDIUMTEXT">&nbsp;per <%=measurementTypesDeviceNames[i] %></span></td>
						                  							</tr>
						                  						</table>
						                  					</td>
						                  				</tr>
						                  				<%
							                  				}
						                  				//}
						                  				%>
						                  			</table>
						                  		</td>
						                 		</tr>  							
															</table>
														</td>
													</tr>																						
												</table>			
											</div>
											</td>													                      
										</tr>
									</table>
								</td>
							</tr>
						<%
						}
						%>
						</table>
					</div>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

