
<%@ page language="java"%>

<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Collections"%>
<%@ page import="java.util.Comparator"%>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Iterator" %>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.VerifyHostResult"%>
<%@ page import="xpolog.eye.util.hosts.VerifyHostResult.VerifyHostResultElement"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String host = request.getParameter("host");
	ArrayList resultElementsList = new ArrayList();
	String status = "ok";
	String message = "";
	if (host != null) {
		//audit
		AuditManager.getInstance().write(
				AuditConstants.BASIC_AUDIT_LEVEL, userContext,
				AuditConstants.CHANGE, "verify server",
				AuditConstants.DASHBOARD, "verify server " + host);

		try {
			VerifyHostResult verifyHostResult = HostsManager.getInstance().verifyHost(host);
			HashMap resultElements = verifyHostResult.getVerifyHostResultElements();
			if(resultElements.isEmpty()) {
				status = "error";
				message = "Metrics are disabled for this server";
			}else {
				Iterator it = resultElements.values().iterator();
				VerifyHostResultElement resultElement = null;
				while(it.hasNext()) {
					resultElement = (VerifyHostResultElement)it.next();
					resultElementsList.add(resultElement);
				}
			}
		} catch (Exception e) {
			status = "error";
			message = e.getMessage();
		}
	}
	
	if(resultElementsList.size() > 1) {
		Collections.sort(resultElementsList, new Comparator() {
			public int compare(Object obj0, Object obj1) {
				VerifyHostResultElement resultElement0 = (VerifyHostResultElement)obj0;
				VerifyHostResultElement resultElement1 = (VerifyHostResultElement)obj1;
				
				if(resultElement0.getMeasurementType().equals(HostCpu.HOST_CPU_TYPE)) {
					return -1;
				}else if(resultElement0.getMeasurementType().equals(HostDiskSpace.HOST_DISK_SPACE_TYPE)) {
					return 1;
				}else {
					if(resultElement1.getMeasurementType().equals(HostCpu.HOST_CPU_TYPE)) {
						return 1;
					}else {
						return -1;
					}
				}
			}
		});
	}
	
	response.setContentType("text/xml");
%>

<VerifyServerResponse>
	<Response status="<%=status %>" message="<%=message %>">
<%
VerifyHostResult.VerifyHostResultElement resultElement = null;
for(int i = 0; i < resultElementsList.size(); i++) {
	resultElement = (VerifyHostResultElement)resultElementsList.get(i);
	String errorMessage = resultElement.getErrorMessage();
	if(errorMessage == null) {
		errorMessage = "";
	}
%>
		<ResultElement measurementType="<%=resultElement.getMeasurementType() %>" displayName="<%=resultElement.getDisplayName() %>" isVerified="<%=resultElement.isVerified() %>">
		<![CDATA[
		<%=errorMessage %>
		]]>
		</ResultElement>
<%
}
%>
	</Response>
</VerifyServerResponse>