function openDashboardCalendar(xDelta, yDelta) {
	var dashboardCalendarDiv = document.getElementById("dashboardCalendarDiv");
	if(dashboardCalendarDiv) {
		if(dashboardCalendarDiv.style.display == "block") {
			dashboardCalendarDiv.style.display = "none";
		}else {
			var calendarLink = document.getElementById("calendarLink");
			if(calendarLink) {
				var x = findPosX(calendarLink);
				var y = findPosY(calendarLink);
				if(xDelta) {
					x += xDelta;
				}
				if(yDelta) {
					y += yDelta;
				}
				
				dashboardCalendarDiv.style.left = (x + "px") ;
				dashboardCalendarDiv.style.top = (y + "px");
			}
			dashboardCalendar.draw();
			dashboardCalendar.show();
			
			updateDashboardDisplayDates();
			
			dashboardCalendarDiv.style.display = "block";
		}
	}
}

var leftDate, rightDate;
function updateDashboardDisplayDates(date, type) {
	var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
	var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
	var dashboardCalendarStartDateTd = document.getElementById("dashboardCalendarStartDateTd");
	var dashboardCalendarEndDateTd = document.getElementById("dashboardCalendarEndDateTd");
	if(dashboardMinDateStr && dashboardMaxDateStr && dashboardCalendarStartDateTd && dashboardCalendarEndDateTd) {
		replaceDivContent("dashboardCalendarStartDateTd", dashboardMinDateStr.value);
		replaceDivContent("dashboardCalendarEndDateTd", dashboardMaxDateStr.value);
	}
	if(date && type) {
		if (typeof date == "string") {
			date = new Date(date);
		}
		if(type == "left") {
			leftDate = date;
		}else if(type == "right") {
			rightDate = date;
		}
	}
}

function onDashboardCalendarClick(date, calendar, type) {
	if (typeof date == "string") {
		date = new Date(date);
	}
	var month = date.getMonth() + 1;
	if((month + "").length == 1) {
		month = "0" + month;
	}
	var day = date.getDate();
	if((day + "").length == 1) {
		day = "0" + day;
	}
	var year = date.getFullYear();
	var dateString = month + "/" + day + "/" + year;
	if(type == "left") {
		var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
		if(dashboardMinDateStr) {
			dashboardMinDateStr.value = dateString;
		}
	}else if(type == "right") {
		var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
		if(dashboardMaxDateStr) {
			dashboardMaxDateStr.value = dateString;
		}
	}
	
	updateDashboardDisplayDates(date, type);
}

function validateTimeFormat(id, text) {
	var dashboardCalendarErrorTd = document.getElementById("dashboardCalendarErrorTd");
	if(dashboardCalendarErrorTd) {
		dashboardCalendarErrorTd.innerHTML = "&nbsp;";
	}
	var isTimeFormatValidResult = isTimeFormatValid(id);
	if(!isTimeFormatValidResult) {
		if(dashboardCalendarErrorTd) {
			dashboardCalendarErrorTd.innerHTML = "Invalid " + text + ", use HH:mm format";
		}
		return false;
	}
	return isTimeFormatValidResult;
}

function isTimeFormatValid(id) {
	var timePat = /^(\d{1,2}):(\d{2})(:(\d{2}))?$/;
	
	var input = document.getElementById(id);
	if(input) {
		var timeStr = input.value;
		var matchArray = timeStr.match(timePat);
		if (matchArray == null) {
			return false;
		}
		hour = matchArray[1];
		minute = matchArray[2];
		second = matchArray[4];
		
		if(second == "") {
			second = 0;
		}
			
		if(hour < 0  || hour > 23) {
			return false;
		}
		if(minute < 0 || minute > 59) {
			return false;
		}
		if (second < 0 || second > 59) {
			return false;
		}
		var result = hour + ":" + minute + ":" + second;
		return result;
	}else {
		return false;
	}
}

function validateTimeOrder() {
	var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
	var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
	var calendarStartTime = document.getElementById("calendarStartTime");
	var calendarEndTime = document.getElementById("calendarEndTime");
	if(dashboardMinDateStr && dashboardMaxDateStr && calendarStartTime && calendarEndTime) {
		var dashboardMinDateStrValue = dashboardMinDateStr.value;
		var dashboardMaxDateStrValue = dashboardMaxDateStr.value;
		dashboardMinDateStrValue = dashboardMinDateStrValue.replace(/\//g, "");
		dashboardMaxDateStrValue = dashboardMaxDateStrValue.replace(/\//g, "");
		if(dashboardMinDateStrValue == dashboardMaxDateStrValue) {
			var calendarStartTimeValue = calendarStartTime.value;
			var calendarEndTimeValue = calendarEndTime.value;
			if(calendarStartTimeValue >= calendarEndTimeValue) {
				var dashboardCalendarErrorTd = document.getElementById("dashboardCalendarErrorTd");
				if(dashboardCalendarErrorTd) {
					dashboardCalendarErrorTd.innerHTML = "End time must be later than start time";
				}
				return false;
			}
			return true;
		}
		return true;
	}
}

function closeDashboardCalendar() {
	if(dashboardCalendar && dashboardCalendar.parent) {
		dashboardCalendar.hide();
		var dashboardCalendarDiv = document.getElementById("dashboardCalendarDiv");
		if(dashboardCalendarDiv) {
			dashboardCalendarDiv.style.display = "none";
		}
	}
}