//var dashboardLayout, dashboardBottomLayout;
var windowWidth = 1280;
var windowHeight = 768;

function showDashboardLoadingMessage(params) {
	var divIdsArr = getParamValuesArray(params, "divIds");
	if(divIdsArr) {
		for(var i = 0; i < divIdsArr.length; i++) {
			showDivLoadingImage(divIdsArr[i]);
		}
	}else {
		showDivLoadingImage(HEADER_DIV_ID);
		showDivLoadingImage(GRAPH_DIV_ID);
		showDivLoadingImage(MAIN_TABLE_DIV_ID);
		showDivLoadingImage(TOP_MESSAGES_DIV_ID);
	}
}

function getParamValuesArray(params, paramName) {
	var paramsArr = params.split("&");
	var keyValueArr;
	var paramValuesArr;
	for(var i = 0; i < paramsArr.length; i++) {
		keyValueArr = paramsArr[i].split("=");
		if(keyValueArr[0] == paramName) {
			paramValuesArr = keyValueArr[1].split("|");
			break;
		}
	}
	return paramValuesArr;
}

function doOnLoad(resetModel, preserveRunners) {
	init();
	
	loadData(resetModel, preserveRunners);
	
	loadCalendar();
}

function init() {
	initDimnesions();
}

function initDimnesions() {
	var windowSizeArr = getWidthAndHeight();
	var divWidth = document.getElementById(GRAPH_DIV_ID).clientWidth;
	if (windowSizeArr && windowSizeArr.length == 2){
		//windowWidth = windowSizeArr[0];
		windowWidth = divWidth - 20;//use graph div width instead of window width
		windowHeight = windowSizeArr[1];
	}
}

function loadData(resetModel, preserveRunners) {
	updateDashboardModel("action=loadData&resetModel=" + resetModel + "&preserveRunners=" + preserveRunners);
}

function resetModel() {
	updateDashboardModel("action=loadData&resetModel=true&preserveRunners=true");
}

function refreshData(isDataGenerationLink) {
	var params = "action=refreshData";
	if(isDataGenerationLink) {
		params += "&isDataGenerationLink=" + isDataGenerationLink
	}
	updateDashboardModel(params);
}

function updateDashboardModel(params) {
	clearTimeoutObjects();
	hideFloatingDivs();
	showDashboardLoadingMessage(params);
	var postParams = "";
	if(params) {
		postParams += params;
	}
	postParams += ("&ajaxTimestamp=" + new Date().getTime());
	sendAjaxRequest("updateDashboardModel.jsp", function(req){
    var xmldoc = req.responseXML.documentElement;
    if(xmldoc) {
      var responseElement = xmldoc.getElementsByTagName("Response")[0];
      if(responseElement) {
		var status = responseElement.getAttribute("status");
		if(status == STATUS_OK) {
			var divIds = responseElement.getAttribute("divIds");
			if(!divIds) {
				divIds = "";
			}
			var displayTopMessagesDiv = responseElement.getAttribute("displayTopMessagesDiv");
			if(displayTopMessagesDiv) {
				var displayString = "block";
				if(displayTopMessagesDiv == "false") {
					displayString = "none";
				}
				var topMessagesDiv = document.getElementById(TOP_MESSAGES_DIV_ID);
				if(topMessagesDiv) {
					topMessagesDiv.style.display = displayString;
				}
			}
			var viewBy = responseElement.getAttribute("viewBy");
			VIEW_BY = viewBy;
			var rootNodeId = responseElement.getAttribute("rootNodeId");
			var rootNodeType = responseElement.getAttribute("rootNodeType");
			var numberOfMissingExecutions = responseElement.getAttribute("numberOfMissingExecutions");
			numberOfMissingExecutions = parseInt(numberOfMissingExecutions);
			var missingDataUserPolicy = responseElement.getAttribute("missingDataUserPolicy");
			var missingExecutionsLogIds = responseElement.getAttribute("missingExecutionsLogIds");
			var errorLogIds = responseElement.getAttribute("errorLogIds");
			var missingExecutionsHostIds = responseElement.getAttribute("missingExecutionsHostIds");
			var errorHostIds = responseElement.getAttribute("errorHostIds");
			var isRunning = responseElement.getAttribute("isRunning");
			var isMissingDataReady = responseElement.getAttribute("isMissingDataReady");
			var checkSessionActivity = responseElement.getAttribute("checkSessionActivity");
			var fixedInterval = responseElement.getAttribute("fixedInterval");
			var showMetrics = responseElement.getAttribute("showMetrics");
			var preserveRunners = responseElement.getAttribute("preserveRunners");
			var numOfRunners = responseElement.getAttribute("numOfRunners");
			loadDivsData(divIds, numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners);
		}else {
			if(status == STATUS_NO_ACTION) {
				
			}else {
				alert("error in updateDashboardModel");
			}
		}
      }else {
    	var message = "dashboard.js, updateDashboardModel, responseElement, params=" + postParams;
    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
    		message += ", " + req.responseText;
    	}
		doLogJsError(BASE_DIRECTORY, message);
      }
    }else {
      var message = "dashboard.js, updateDashboardModel, xmldoc, params=" + postParams;
      if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
		message += ", " + req.responseText;
  	  }
      doLogJsError(BASE_DIRECTORY, message);
    }
  }, 'POST', postParams);
}

function hideFloatingDivs() {
	hideFloatingDiv("dashboardCalendarDiv");
	hideFloatingDiv("dashboardFilterByDiv");
	hideFloatingDiv("dashboardFilterByTypeDiv");
	hideFloatingDiv("dashboardZoomInDiv");
	hideFloatingDiv("dashboardZoomInSmallImageDiv");
	hideFloatingDiv("dashboardSearchDiv");
	hideFloatingDiv("dashboardMetricsGraphLegendDiv");
	hideGeneralAdminDiv("MissingExecutions");
	
	hideDashboardGraphTooltip();
	hideTooltip();
}

function hideFloatingDiv(divId) {
	var div = document.getElementById(divId);
	if(div) {
		div.style.display = "none";
	}
}

var loadedDivs = new Array();
function loadDivsData(divIds, numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners) {
	if(!divIds || divIds == "") {
		divIds = HEADER_DIV_ID + "|" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID
	}
	divIds = divIds.split("|");
	for(i = 0; i < divIds.length; i++) {
		loadDivData(divIds[i], '', numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners);
	}
}

function loadDivData(divId, params, numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners) {
	var postParams = "";
	if(params) {
		postParams += params;
	}
	if(divId == HEADER_DIV_ID || GRAPH_DIV_ID) {
		postParams += ("&windowWidth=" + windowWidth + "&windowHeight=" + windowHeight);
	}
	postParams += ("&divId=" + divId);
	postParams += ("&ajaxTimestamp=" + new Date().getTime());
	
	showDivLoadingImage(divId);
	loadedDivs[divId] = false;
	
	sendAjaxRequest("dashboardDivContentFetcher.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	      var responseElement = xmldoc.getElementsByTagName("Response")[0];
	      if(responseElement) {
			var responseDivId = responseElement.getAttribute("divId");
			if(responseDivId && responseDivId != "") {
				onAfterDivResponseLoaded(responseDivId, responseElement, numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners);
			}else {
				var message = "dashboard.js, loadDivData, !responseDivId, params=" + postParams;
				if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
		    		message += ", " + req.responseText;
		    	}
		    	doLogJsError(BASE_DIRECTORY, message);
		    }
	      }else {
	    	var message = "dashboard.js, loadDivData, responseElement, params=" + postParams;
	    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    		message += ", " + req.responseText;
	    	}
	    	doLogJsError(BASE_DIRECTORY, message);
	      }
		}else {
	      var message = "dashboard.js, loadDivData, xmldoc, params=" + postParams;
	      if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    	message += ", " + req.responseText;
	      }
	      doLogJsError(BASE_DIRECTORY, message);
	    }
	  }, 'POST', postParams);
}

function showDivLoadingImage(divId) {
	var div = document.getElementById(divId);
	if(div) {
		var loadingDivText = "<div id='loading" + divId + "' class='DASHBOARD_LOADING_DIV'><img src='" + BASE_DIRECTORY + "images/dashboard/loadingAnimation.gif' border='0' />&nbsp;Loading...</div>";
		replaceDivContent(divId, loadingDivText);
	}
}

function onAfterDivResponseLoaded(divId, responseElement, numberOfMissingExecutions, missingDataUserPolicy, missingExecutionsLogIds,missingExecutionsHostIds, errorLogIds,errorHostIds, isRunning, isMissingDataReady, rootNodeId, rootNodeType, checkSessionActivity, fixedInterval, showMetrics, preserveRunners, numOfRunners) {
	var div = document.getElementById(divId);
	if(div) {
		var responseText = getXMLElementValue(responseElement);
		/*if(divId == "dashboardHeaderDiv") {
			replaceDivContent(divId, responseText);
		}else if(divId == "dashboardGraphDiv") {
			replaceDivContent(divId, responseText);
		}else if(divId == "dashboardMainTableDiv") {
			replaceDivContent(divId, responseText);
		}else if(divId == "dashboardTopMessagesDiv") {
			replaceDivContent(divId, responseText);
		}*/
		replaceDivContent(divId, responseText);
		loadedDivs[divId] = true;
		
		// perform onAfterLaoded actions only if all divs were loaded
		if(allDivsLoaded()) {
			onAfterHeaderDivResponseLoaded();
			onAfterCalendarDivResponseLoaded();
			onAfterGraphDivResponseLoaded(showMetrics);
			onAfterMainTableDivResponseLoaded();

			if(numberOfMissingExecutions > 0) {
				var missingExecutionsLogIdsElement = document.getElementById("missingExecutionsLogIds");
				if(missingExecutionsLogIdsElement) {
					missingExecutionsLogIdsElement.value = missingExecutionsLogIds;
				}
				var errorLogIdsElement = document.getElementById("errorLogIds");
				if(errorLogIdsElement) {
					errorLogIdsElement.value = errorLogIds;
				}
				var missingExecutionsHostIdsElement = document.getElementById("missingExecutionsHostIds");
				if(missingExecutionsHostIdsElement) {
					missingExecutionsHostIdsElement.value = missingExecutionsHostIds;
				}
				var errorHostIdsElement = document.getElementById("errorHostIds");
				if(errorHostIdsElement) {
					errorHostIdsElement.value = errorHostIds;
				}
				var rootNodeIdElement = document.getElementById("rootNodeId");
				if(rootNodeIdElement) {
					rootNodeIdElement.value = rootNodeId;
				}
				var rootNodeTypeElement = document.getElementById("rootNodeType");
				if(rootNodeTypeElement) {
					rootNodeTypeElement.value = rootNodeType;
				}
				var missingExecutionsAll = document.getElementById("missingExecutionsAll");
				if(missingExecutionsAll) {
					missingExecutionsAll.checked = true;
				}
				if(!missingDataUserPolicy || missingDataUserPolicy == "ask") {
					showGeneralAdminDiv("MissingExecutions");
				}else {
					if(missingDataUserPolicy == "complete") {
						var missingExecutionsAll = document.getElementById("missingExecutionsAll");
						if(missingExecutionsAll) {
							missingExecutionsAll.checked = true;
						}
					}else if(missingDataUserPolicy == "ignore") {
						var missingExecutionsNone = document.getElementById("missingExecutionsNone");
						if(missingExecutionsNone) {
							missingExecutionsNone.checked = true;
						}
					}
					continueMissingExecutions();
				}
			}else if(isRunning == "true") {
				activateDataGenerationProbe();
			}else if(isMissingDataReady == "true") {
				showDataGenerationCompleted();
			}
			if(checkSessionActivity && checkSessionActivity == "true") {
				checkSessionActivityTimeoutObject = setTimeout("checkSessionActivity('" + fixedInterval + "')", 5000);
			}
			if(preserveRunners && preserveRunners == "true" && numOfRunners && parseInt(numOfRunners) > 0) {
				activateDataGenerationProbe();
			}
		}
	}
}

function allDivsLoaded() {
	return loadedDivs[HEADER_DIV_ID] == true && loadedDivs[GRAPH_DIV_ID] == true && loadedDivs[MAIN_TABLE_DIV_ID] == true && loadedDivs[TOP_MESSAGES_DIV_ID] == true;
}

function replaceDivContent(id, responseText) {
	handleInnerHTMLJQuery(id, responseText);
}

var dashboardCalendar;
function loadCalendar() {
	dashboardCalendar = new dhtmlxDblCalendarObject("dashboardCalendarTd", false, {isMonthEditable: true, isYearEditable: true});
	dashboardCalendar.setYearsRange(2000, 2040);
	dashboardCalendar.setDateFormat("%m/%d/%Y");
	dashboardCalendar.setOnClickHandler(onDashboardCalendarClick);
}



function setElementClass(elementId, className) {
	var element = document.getElementById(elementId);
	if(element) {
		element.className = className;
	}
}

function setImageSource(imageElement, imageSource) {
	imageElement.src = BASE_DIRECTORY + "images/dashboard/" + imageSource;
}

function showSlidingDiv(type, slidingDivId, referenceId, text, direction, stopPointInterval, refreshInterval, step) {
	if(type == "slide") {
		return slideDiv(slidingDivId, referenceId, text, direction, stopPointInterval, refreshInterval, step)
	}else if(type == "slideExpand") {
		return slideExpandDiv(slidingDivId, referenceId, text, direction, stopPointInterval, refreshInterval, step);
	}
}

function slideDiv(slidingDivId, referenceId, text, direction, stopPointInterval, refreshInterval, step) {
	var slidingDiv = document.getElementById(slidingDivId);
	if(slidingDiv) {
		slidingDiv.innerHTML = text;
		
		var reference = document.getElementById(referenceId);
		if(reference) {
			var left = findPosX(reference);
			var parsedLeft = parseInt(left);
			var stopPoint;
			if(direction == "right") {
				stopPoint = parsedLeft + stopPointInterval;
			}else if(direction == "left") {
				stopPoint = parsedLeft - stopPointInterval;
			}
			return setInterval("slideDiv0('" + slidingDivId + "', " + stopPoint + ", '" + direction + "', " + step + ")", refreshInterval);
		}
	}
}

function slideDiv0(slidingDivId, stopPoint, direction, step) {
	var slidingDiv = document.getElementById(slidingDivId);
	if(slidingDiv) {
		var divLeft = slidingDiv.style.left;
		var leftIndex = divLeft.indexOf("px");
		divLeft = divLeft.substring(0, leftIndex);
		var newLeft = parseInt(divLeft);
		if(direction == "right") {
			newLeft += step;
		}else if(direction == "left") {
			newLeft -= step;
		}
		if(direction == "right") {
			if(parseInt(divLeft) < parseInt(stopPoint)) {
				slidingDiv.style.left = (newLeft + "px");
			}
		}else if(direction == "left") {
			if(parseInt(divLeft) > parseInt(stopPoint)) {
				slidingDiv.style.left = (newLeft + "px");
			}
		}
	}
}

function slideExpandDiv(slidingDivId, referenceId, text, direction, stopPointInterval, refreshInterval, step) {
	var slidingDiv = document.getElementById(slidingDivId);
	if(slidingDiv) {
		slidingDiv.innerHTML = text;
		
		var reference = document.getElementById(referenceId);
		if(reference) {
			var left = findPosX(reference);
			var parsedLeft = parseInt(left);
			var stopPoint;
			if(direction == "right") {
				stopPoint = parsedLeft + stopPointInterval;
			}else if(direction == "left") {
				stopPoint = parsedLeft - stopPointInterval;
			}
			return setInterval("slideExpandDiv0('" + slidingDivId + "', " + stopPoint + ", '" + direction + "', " + step + ")", refreshInterval);
		}
	}
}

function slideExpandDiv0(slidingDivId, stopPoint, direction, step) {
	var slidingDiv = document.getElementById(slidingDivId);
	if(slidingDiv) {
		var divLeft = slidingDiv.style.left;
		var leftIndex = divLeft.indexOf("px");
		divLeft = divLeft.substring(0, leftIndex);
		var newLeft = parseInt(divLeft);
		if(direction == "left") {
			newLeft -= step;
		}
		
		var divWidth = slidingDiv.style.width;
		var widthIndex = divWidth.indexOf("px");
		divWidth = divWidth.substring(0, widthIndex);
		var newWidth = parseInt(divWidth);
		newWidth += step;
		
		var divRight = parseInt(divLeft) + parseInt(divWidth);
		
		if(direction == "right") {
			if(parseInt(divRight) < parseInt(stopPoint)) {
				slidingDiv.style.width = (newWidth + "px");
			}
		}else if(direction == "left") {
			if(parseInt(divLeft) > parseInt(stopPoint)) {
				slidingDiv.style.left = (newLeft + "px");
				slidingDiv.style.width = (newWidth + "px");
			}
		}
	}
}

var checkMissingExecutionsStatusTimeoutObject;
function continueMissingExecutions() {
	hideGeneralAdminDiv("MissingExecutions");
	
	var form = document.getElementById("missingExecutionsForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		sendAjaxRequest("dashboardMissingExecutionsAction.jsp", function(req){
	    var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	      var responseElement = xmldoc.getElementsByTagName("Response")[0];
	      if(responseElement) {
			var missingExecutionsActionType = responseElement.getAttribute("missingExecutionsActionType");
			if(!missingExecutionsActionType || missingExecutionsActionType != "ignore") {
				activateDataGenerationProbe();
			}
	      }else {
			var message = "dashboard.js, continueMissingExecutions, responseElement, params=" + params;
			if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    		message += ", " + req.responseText;
	    	}
			doLogJsError(BASE_DIRECTORY, message);
		  }
	    }else {
		  var message = "dashboard.js, continueMissingExecutions, xmldoc, params=" + params;
		  if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    	message += ", " + req.responseText;
		  }
		  doLogJsError(BASE_DIRECTORY, message);
	    }
	  }, 'POST', params);
	}
}

function activateDataGenerationProbe() {
	startDataGenerationProgressIndicator();
	checkMissingExecutionsStatusTimeoutObject = setTimeout("checkMissingExecutionsStatus()", 1000);
}

function checkMissingExecutionsStatus() {
	sendAjaxRequest("dashboardExecutionStatus.jsp", function(req){
    var xmldoc = req.responseXML.documentElement;
    if(xmldoc) {
      var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var isRunning = responseElement.getAttribute("isRunning");
				var needToRefresh = responseElement.getAttribute("needToRefresh");
				if(isRunning && isRunning == "true") {
					checkMissingExecutionsStatusTimeoutObject = setTimeout("checkMissingExecutionsStatus()", 1000);
				}else {
					stopDataGenerationProgressIndicator();
					if(needToRefresh && needToRefresh == "true") {
						refreshData("true");
					}else {
						showDataGenerationCompleted();
					}
				}
			}
		}
  });
}

var toggleDataGenerationInProgressImageIntervalObject;
function startDataGenerationProgressIndicator() {
	hideDataGenerationImages();
	initDataGenerationInProgressImage();
	toggleDataGenerationInProgressImageIntervalObject = setTimeout("toggleDataGenerationInProgressImage(0)", 1000);
}

function hideDataGenerationImages() {
	var dataGenerationInProgressTd = document.getElementById("dataGenerationInProgressTd");
	if(dataGenerationInProgressTd) {
		dataGenerationInProgressTd.style.display = "none";
	}
	var dataGenerationICompletedTd = document.getElementById("dataGenerationICompletedTd");
	if(dataGenerationICompletedTd) {
		dataGenerationICompletedTd.style.display = "none";
	}
}

function initDataGenerationInProgressImage() {
	var dataGenerationInProgressImage = document.getElementById("dataGenerationInProgressImage");
	if(dataGenerationInProgressImage) {
		setImageSource(dataGenerationInProgressImage, "header/dataGenerationInProgress.gif");
		var dataGenerationInProgressTd = document.getElementById("dataGenerationInProgressTd");
		if(dataGenerationInProgressTd) {
			dataGenerationInProgressTd.style.display = "block";
		}
	}
}

function toggleDataGenerationInProgressImage(value) {
	var dataGenerationInProgressImage = document.getElementById("dataGenerationInProgressImage");
	if(dataGenerationInProgressImage) {
		var source = "";
		var nextValue;
		if(value == 0) {
			source = "header/dataGenerationInProgressOver.gif";
			nextValue = 1;
		}else {
			source = "header/dataGenerationInProgress.gif";
			nextValue = 0;
		}
		//setImageSource(dataGenerationInProgressImage, source);
		toggleDataGenerationInProgressImageIntervalObject = setTimeout("toggleDataGenerationInProgressImage(" + nextValue + ")", 1000);
	}
}

function stopDataGenerationProgressIndicator() {
	if(toggleDataGenerationInProgressImageIntervalObject) {
		clearInterval(toggleDataGenerationInProgressImageIntervalObject);
		toggleDataGenerationInProgressImageIntervalObject = null;
	}
	hideDataGenerationImages();
}

function showDataGenerationCompleted() {
	var dataGenerationICompletedTd = document.getElementById("dataGenerationICompletedTd");
	if(dataGenerationICompletedTd) {
		dataGenerationICompletedTd.style.display = "block";
	}
}

var checkSessionActivityTimeoutObject;
function checkSessionActivity(fixedInterval) {
	sendAjaxRequest("getSessionLastActivity.jsp", function(req){
    var xmldoc = req.responseXML.documentElement;
    if(xmldoc) {
      var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var needToRefresh = responseElement.getAttribute("needToRefresh");
				if(needToRefresh && needToRefresh == "true") {
					setFixedInterval(fixedInterval, "true", "true");
				}else {
					checkSessionActivityTimeoutObject = setTimeout("checkSessionActivity('" + fixedInterval + "')", 5000);
				}
			}
		}
  });
}

function doOnUnload() {
	clearTimeoutObjects();
}

function resizeDashboardPage(){
  initDimnesions();
  loadData(false, true);
}

function clearTimeoutObjects() {
	clearCheckMissingExecutionsStatusTimeout();
	clearCheckSessionActivityTimeout();
}

function clearCheckMissingExecutionsStatusTimeout() {
	if(checkMissingExecutionsStatusTimeoutObject) {
		clearTimeout(checkMissingExecutionsStatusTimeoutObject);
	}
}

function clearCheckSessionActivityTimeout() {
	if(checkSessionActivityTimeoutObject) {
		clearTimeout(checkSessionActivityTimeoutObject);
	}
}

function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

function doCheck(e){
	if (!e) var e = window.event;
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;
	if (code == 13){
	  return false;
	}
	return true;
}

var lastOpenProblemActionsMenuSourceId;
function openProblemActionsMenu(xDelta, yDelta, sourceId, problemId, problemName, problemType, problemRisk, problemRiskText) {
	var dashboardProblemActionsDiv = document.getElementById("dashboardProblemActionsDiv");
	if(dashboardProblemActionsDiv) {
		if(dashboardProblemActionsDiv.style.display == "block" && lastOpenProblemActionsMenuSourceId != null && lastOpenProblemActionsMenuSourceId == sourceId) {
			dashboardProblemActionsDiv.style.display = "none";
		}else {
			var sourceElement = document.getElementById(sourceId);
			if(sourceElement) {
				var problemActionChangeSeverityLow = document.getElementById("problemActionChangeSeverityLow");
				problemActionChangeSeverityLow.style.display = "";
				var problemActionChangeSeverityMedium = document.getElementById("problemActionChangeSeverityMedium");
				problemActionChangeSeverityMedium.style.display = "";
				var problemActionChangeSeverityHigh = document.getElementById("problemActionChangeSeverityHigh");
				problemActionChangeSeverityHigh.style.display = "";
				if(problemRiskText == 'Low') {
					problemActionChangeSeverityLow.style.display = "none";
				}else if(problemRiskText == 'Medium') {
					problemActionChangeSeverityMedium.style.display = "none";
				}else if(problemRiskText == 'High') {
					problemActionChangeSeverityHigh.style.display = "none";
				}
				
				updateProblemActionsMenuOnClickParams = new Array();
				updateProblemActionsMenuOnClickParams['SOURCE_ID'] = sourceId;
				updateProblemActionsMenuOnClickParams['PROBLEM_ID'] = problemId;
				updateProblemActionsMenuOnClickParams['PROBLEM_NAME'] = problemName;
				updateProblemActionsMenuOnClickParams['PROBLEM_TYPE'] = problemType;
				updateProblemActionsMenuOnClickParams['PROBLEM_RISK'] = problemRisk;
				
				updateProblemActionsMenuOnClick();
				
				var x = findPosX(sourceElement);
				var y = findPosY(sourceElement);
				if(xDelta) {
					x += xDelta;
				}
				if(yDelta) {
					y += yDelta;
				}
				dashboardProblemActionsDiv.style.left = (x + "px") ;
				dashboardProblemActionsDiv.style.top = (y + "px");
				
				dashboardProblemActionsDiv.style.display = "block";
				
				lastOpenProblemActionsMenuSourceId = sourceId;
			}
		}
	}
}

var updateProblemActionsMenuOnClickParams;
var SOURCE_ID;
var PROBLEM_ID;
var PROBLEM_NAME;
var PROBLEM_TYPE;
var PROBLEM_RISK;

function updateProblemActionsMenuOnClick() {
	var problemActionChangeSeverityLow = document.getElementById("problemActionChangeSeverityLow");
	if(problemActionChangeSeverityLow) {
		SOURCE_ID = updateProblemActionsMenuOnClickParams['SOURCE_ID'];
		PROBLEM_ID = updateProblemActionsMenuOnClickParams['PROBLEM_ID'];
		PROBLEM_NAME = updateProblemActionsMenuOnClickParams['PROBLEM_NAME'];
		PROBLEM_TYPE = updateProblemActionsMenuOnClickParams['PROBLEM_TYPE'];
		PROBLEM_RISK = updateProblemActionsMenuOnClickParams['PROBLEM_RISK'];
	}
}

function doProblemActions(problemAction) {
	var matchType = "0";
	/*if(PROBLEM_TYPE == '') {
		
	}else if(PROBLEM_TYPE == '') {
		
	}*/
	
	var weight = -1;
	if(problemAction == 'low') {
		weight = 1;
		problemAction = 'changeSeverity';
	}else if(problemAction == 'medium') {
		weight = 4;
		problemAction = 'changeSeverity';
	}else if(problemAction == 'high') {
		weight = 7;
		problemAction = 'changeSeverity';
	}if(problemAction == 'exclude') {
		weight = -1;
		problemAction = 'changeSeverity';
	}
	
	var params = "";
	params += "&action=" + problemAction;
	params += "&id=" + PROBLEM_ID;
	params += "&type=" + PROBLEM_TYPE;
	params += "&term=" + PROBLEM_NAME;
	params += "&matchType=" + matchType;
	params += "&weight=" + weight;
	params += "&defaultWeight=" + PROBLEM_RISK;
	
	sendAjaxRequest("dashboardProblemsRepositoryAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var status = responseElement.getAttribute("status");
				var message = responseElement.getAttribute("message");
				var showMessage = responseElement.getAttribute("showMessage");
				if(showMessage != null && showMessage == 'true') {
					if(message != null) {
						if(message == '') {
							message = 'Problem severity operations will take effect only in future analyses';
						}
						var msgWriter = new messageWriter('dashboardProblemActionsMessage', 'Problem Action Result', BASE_DIRECTORY);
						msgWriter.setYParent(document.getElementById(SOURCE_ID),-50);
						msgWriter.addAction("OK","javascript:hideLayer('dashboardProblemActionsMessage')");
						msgWriter.showMessage(message);
					}
				}
			}
		}
	}, 'POST', params);
		
	closeProblemActionsMenu();
}

function closeProblemActionsMenu() {
	var dashboardProblemActionsDiv = document.getElementById("dashboardProblemActionsDiv");
	if(dashboardProblemActionsDiv) {
		dashboardProblemActionsDiv.style.display = "none";
	}
}

function setProblemActionsMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}