function zoomInCalendar() {
	closeDashboardCalendar();
	
	onDashboardCalendarUpdate("action=zoomInCalendar");
}

function zoomOutCalendar() {
	closeDashboardCalendar();
	
	onDashboardCalendarUpdate("action=zoomOutCalendar");
}

function changeFixedInterval(params) {
	if(!params) {
		params = "action=changeFixedInterval";
	}
	onDashboardCalendarUpdate(params);
}

function onDashboardCalendarUpdate(params) {
	var form = document.getElementById("dashboardHeaderForm");
	if(form) {
		var postParams = getFormElementsQueryString(form);
		if(postParams != "") {
			postParams += "&";
		}
		postParams += params;
		updateDashboardModel(postParams);
	}
}

function goDashboardCalendar() {
	var validateTimeFormatResult = validateTimeFormat('calendarStartTime', 'Start Time');
	if(validateTimeFormatResult) {
		validateTimeFormatResult = validateTimeFormat('calendarEndTime', 'End Time');
		if(validateTimeFormatResult) {
			var validateTimeOrderResult = validateTimeOrder();
			if(validateTimeOrderResult) {
				var dashboardMinTimeStr = document.getElementById("dashboardMinTimeStr");
				var dashboardMaxTimeStr = document.getElementById("dashboardMaxTimeStr");
				var calendarStartTime = document.getElementById("calendarStartTime");
				var calendarEndTime = document.getElementById("calendarEndTime");
				if(dashboardMinTimeStr && calendarStartTime && dashboardMaxTimeStr && calendarEndTime) {
					dashboardMinTimeStr.value = calendarStartTime.value;
					dashboardMaxTimeStr.value = calendarEndTime.value;
					
					closeDashboardCalendar();
					onDashboardCalendarUpdate("action=changeCalendar");
				}
			}
		}
	}
}

function onAfterCalendarDivResponseLoaded() {
	var dashboardMinDateStr = document.getElementById("dashboardMinDateStr");
	var dashboardMaxDateStr = document.getElementById("dashboardMaxDateStr");
	var dashboardMinTimeStr = document.getElementById("dashboardMinTimeStr");
	var dashboardMaxTimeStr = document.getElementById("dashboardMaxTimeStr");
	if(dashboardMinDateStr && dashboardMaxDateStr && dashboardMinTimeStr && dashboardMaxTimeStr) {
		dashboardCalendar.setDate(dashboardMinDateStr.value, dashboardMaxDateStr.value);
		
		var calendarStartTime = document.getElementById("calendarStartTime");
		if(calendarStartTime) {
			calendarStartTime.value = dashboardMinTimeStr.value;
		}
		var calendarEndTime = document.getElementById("calendarEndTime");
		if(calendarEndTime) {
			calendarEndTime.value = dashboardMaxTimeStr.value;
		}
	}
}

function openFixedIntervalMenu() {
	closeDashboardCalendar();
	
	var dashboardFixedIntervalDiv = document.getElementById("dashboardFixedIntervalDiv");
	if(dashboardFixedIntervalDiv) {
		if(dashboardFixedIntervalDiv.style.display == "block") {
			dashboardFixedIntervalDiv.style.display = "none";
		}else {
			dashboardFixedIntervalDiv.style.display = "block";
		}
	}
}

function closeFixedIntervalMenu() {
	var dashboardFixedIntervalDiv = document.getElementById("dashboardFixedIntervalDiv");
	if(dashboardFixedIntervalDiv) {
		dashboardFixedIntervalDiv.style.display = "none";
	}
}

function setFixedInterval(fixedInterval, evenIfTheSame, ignoreMissingExecutions) {
	var fixedIntervalElement = document.getElementById("fixedInterval");
	if(fixedIntervalElement && (fixedIntervalElement.value != fixedInterval || (evenIfTheSame && evenIfTheSame == "true")) && fixedInterval != "custom") {
		fixedIntervalElement.value = fixedInterval;
		
		var roundMinTimeToZero = false;
		var dashboardMinTimeStr = document.getElementById("dashboardMinTimeStr");
		if(dashboardMinTimeStr) {
			roundMinTimeToZero = (dashboardMinTimeStr.value == "00:00");
		}
		var params = "action=changeFixedInterval&roundMinTimeToZero=" + roundMinTimeToZero;
		if(ignoreMissingExecutions) {
			params += "&ignoreMissingExecutions=" + ignoreMissingExecutions;
		}
		changeFixedInterval(params);
	}
	closeFixedIntervalMenu();
}

function setFixedIntervalMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}