var isMouseOverDashboardGraphNode;
var isMouseOverDashboardGraphTooltip;
var isMouseOverDashboardGraphTooltipStum;
var hideDashboardGraphTooltipIfNeededTimeoutId;
var hideDashboardGrapTooltipIfNeededInterval = 500;

function onAfterGraphDivResponseLoaded(showMetrics) {
	var dashboardMetricsGraphLegendDiv = document.getElementById("dashboardMetricsGraphLegendDiv");
	var dashboardGraphDiv = document.getElementById(GRAPH_DIV_ID);
	if(dashboardMetricsGraphLegendDiv && dashboardGraphDiv) {
		if(showMetrics == "true") {
			var left = findPosX(dashboardGraphDiv);
			var top = findPosY(dashboardGraphDiv);
			var height = dashboardGraphDiv.style.height;
			var index = height.indexOf("px");
			if(index != -1) {
				height = height.substring(0, index);
			}
			height = parseInt(height);
			top += height;
			
			left += 50;
			top -= 105;
			
			dashboardMetricsGraphLegendDiv.style.left = left + "px";
			dashboardMetricsGraphLegendDiv.style.top = top + "px";
			dashboardMetricsGraphLegendDiv.style.display = "block";
		}else {
			dashboardMetricsGraphLegendDiv.style.display = "none";
		}
	}
}

function onMouseOverDashboardGraphNode(obj, event, startTimestamp, endTimestamp, elementIds, modelUpdateTime,graphType) {
	hideDashboardServerMetricsColumnTooltip();
	isMouseOverDashboardGraphTooltip = false;
	isMouseOverDashboardGraphTooltipStum = false;
	window.clearTimeout(hideDashboardGraphTooltipIfNeededTimeoutId);
	isMouseOverDashboardGraphNode = true;
	var postParams = "";
	postParams += ("startTimestamp=" + startTimestamp);
	postParams += ("&endTimestamp=" + endTimestamp);
	postParams += ("&elementIds=" + elementIds);
	postParams += ("&modelUpdateTime=" + modelUpdateTime);
	postParams += ("&graphType=" + graphType);
	postParams += ("&ajaxTimestamp=" + new Date().getTime());
	sendAjaxRequest("getGraphTooltip.jsp", function(req){
		if(isMouseOverDashboardGraphNode) {
	    showDashboardGraphTooltip(obj, event, req);
		}
	}, 'POST', postParams);
}

function showDashboardGraphTooltip(obj, event, req) {
	var xmldoc = req.responseXML.documentElement;
	if(xmldoc) {
		var responseElement = xmldoc.getElementsByTagName("Response")[0];
		if(responseElement) {
			var status = responseElement.getAttribute("status");
			if(status == STATUS_OK) {
				var bgSuffix = responseElement.getAttribute("bgSuffix");
				var dashboardGraphTooltipDiv = document.getElementById("dashboardGraphTooltipDiv");
				var dashboardGraphTooltipStumDiv = document.getElementById("dashboardGraphTooltipStumDiv");
				if(dashboardGraphTooltipDiv && dashboardGraphTooltipStumDiv) {
					var responseText = getXMLElementValue(responseElement);
					replaceDivContent("dashboardGraphTooltipDiv", responseText);
					
					var graphImage = document.getElementById('graphImage');
					if(graphImage) {
						var graphImagePosition = findPos(graphImage);
						var objPosition = findPos(obj);
						var stumWidth = 33; // taken from the width of the stum image
						var stumHeight = 28; // taken from the height of the stum image
						var tableWidth = 450; // taken from width of DASHBOARD_GRAPH_TOOLTIP_DIV class in CSS
					  
					  // get the height of the tooltip div using a trick
					  dashboardGraphTooltipDiv.style.filter = "alpha(opacity=1)"; // IE
						dashboardGraphTooltipDiv.style.opacity = 0.01; // Firefox, etc..
						dashboardGraphTooltipDiv.style.display = "block"; 
						var tableHeight = dashboardGraphTooltipDiv.offsetHeight;
						dashboardGraphTooltipDiv.style.display = "none"; 
						dashboardGraphTooltipDiv.style.filter = "alpha(opacity=100)"; // IE
						dashboardGraphTooltipDiv.style.opacity = 1; // Firefox, etc..
						
					  var winWidth = 1280;
					  var winHeight = 1024;
					  var sizeArr = getWindowSize();
					  if (sizeArr && sizeArr.length == 2){
					  	winWidth = sizeArr[0];
					  	winHeight = sizeArr[1];
					  }
						var x = (document.all ? objPosition[0] + graphImagePosition[0] : event.pageX);
						var y = (document.all ? objPosition[1] + graphImagePosition[1] : event.pageY);
						
						// check if the tooltip can be shown to the right of the mouse. if not, show on the left of the mouse
						var showOnRightSide;
						if(x < (winWidth - (tableWidth + stumWidth) - 50)) {
							showOnRightSide = true;
						}else {
							showOnRightSide = false;
						}
						if(showOnRightSide) {
							if(document.all) {
					  		x += 16;
							}else {
								x += 4;
							}
						}else {
							if(document.all) {
					  		x = x - (tableWidth + stumWidth);
							}else {
								x = x - (tableWidth + stumWidth + 7);
							}
							
						}
				  	if (x < 0){
				  		x = 0;
				  		showOnRightSide = true;
				  	}
				  	
				  	var showAbove;
				  	if(y - document.body.scrollTop > tableHeight / 2) {
							showAbove = true;
						}else {
							showAbove = false;
						}
				  	if (y < 0){
				  		y = 0;
				  	}
				  	
				  	var stumX, stumY;
				  	var bodyX, bodyY;
				  	
				  	var dashboardGraphTooltipStumImage = document.getElementById("dashboardGraphTooltipStumImage");
				  	if(showOnRightSide) {
				  		stumX = x;
				  		bodyX = (stumX + stumWidth) - 4;
				  		if(showAbove) {
				  			dashboardGraphTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumLeftBottom" + bgSuffix + ".gif";
				  		}else {
				  			dashboardGraphTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumLeftTop" + bgSuffix + ".gif";
				  		}
				  	}else {
				  		bodyX = x;
				  		stumX = (bodyX + tableWidth) - 4;
				  		if(showAbove) {
				  			dashboardGraphTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumRightBottom" + bgSuffix + ".gif";
				  		}else {
				  			dashboardGraphTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumRightTop" + bgSuffix + ".gif";
				  		}
				  	}
				  	if(showAbove) {
			  			stumY = y - 20;
			  			bodyY = stumY - (tableHeight / 2);
			  		}else {
			  			stumY = y;
			  			bodyY = stumY;
			  		}
				  	
				  	dashboardGraphTooltipDiv.style.left = (bodyX + "px");
						dashboardGraphTooltipDiv.style.top = (bodyY + "px");
						dashboardGraphTooltipDiv.style.display = "block";
						
						dashboardGraphTooltipStumDiv.style.left = (stumX + "px");
						dashboardGraphTooltipStumDiv.style.top = (stumY + "px");
						dashboardGraphTooltipStumDiv.style.display = "block";
					}
				}
			}else {
				
			}
		}
	}
}

function onMouseOutDashboardGraphNode(obj, event) {
	hideDashboardGraphTooltipIfNeededTimeoutId = setTimeout("hideDashboardGrapTooltipIfNeeded()", hideDashboardGrapTooltipIfNeededInterval);
	isMouseOverDashboardGraphNode = false;
}

function hideDashboardGrapTooltipIfNeeded() {
	if(isMouseOverDashboardGraphTooltip || isMouseOverDashboardGraphTooltipStum) {
		hideDashboardGraphTooltipIfNeededTimeoutId = window.setTimeout("hideDashboardGrapTooltipIfNeeded()", hideDashboardGrapTooltipIfNeededInterval);
	}else {
		hideDashboardGraphTooltip();
	}
}

function hideDashboardGraphTooltip() {
	var dashboardGraphTooltipDiv = document.getElementById("dashboardGraphTooltipDiv");
	if(dashboardGraphTooltipDiv) {
		dashboardGraphTooltipDiv.style.display = "none";
	}
	var dashboardGraphTooltipStumDiv = document.getElementById("dashboardGraphTooltipStumDiv");
	if(dashboardGraphTooltipStumDiv) {
		dashboardGraphTooltipStumDiv.style.display = "none";
	}
}

function onMouseOverDashboardGraphTooltip() {
	isMouseOverDashboardGraphTooltip = true;
	isMouseOverDashboardGraphTooltipStum = true;
}

function onMouseOutDashboardGraphTooltip() {
	isMouseOverDashboardGraphTooltip = false;
	isMouseOverDashboardGraphTooltipStum = false;
}

function onMouseOverZoomInGraphImage(minX, minY, maxX, maxY, startTimestamp, endTimestamp, modelUpdateTime) {
	var zoomInSmallImageWidth = 13; // 13 is the width of the image zoomIn.gif under images/dashboard/graph
	var zoomInSmallImageHeight = 12; // 12 is the height of the image zoomIn.gif under images/dashboard/graph

	var dashboardZoomInDiv = document.getElementById("dashboardZoomInDiv");
	var dashboardZoomInTopDiv = document.getElementById("dashboardZoomInTopDiv");
	if(dashboardZoomInDiv && dashboardZoomInTopDiv) {
		var graphImage = document.getElementById('graphImage');
		if(graphImage) {
			var graphImagePosition = findPos(graphImage);
			var left = minX + graphImagePosition[0];
			var top = minY + graphImagePosition[1];
			var width = maxX - minX;
			var height = maxY - minY;
			
			var zoomInDivLeft = left;
			var zoomInDivTop = top + zoomInSmallImageHeight;
			var zoomInDivWidth = width;
			var zoomInDivHeight = height - zoomInSmallImageHeight;
			
			var dashboardGraphZoomInDivImage = document.getElementById("dashboardGraphZoomInDivImage");
			if(zoomInDivWidth < 43) { // 43 is the width of the image zoomInDiv.gif under images/dashboard/graph
				dashboardGraphZoomInDivImage.width = zoomInDivWidth;
			}else {
				dashboardGraphZoomInDivImage.width = 43;
			}
			
			zoomInDivLeft += "px";
			zoomInDivTop += "px";
			zoomInDivWidth += "px";
			zoomInDivHeight += "px";
			
			dashboardZoomInDiv.style.left = zoomInDivLeft;
			dashboardZoomInDiv.style.top = zoomInDivTop;
			dashboardZoomInDiv.style.width = zoomInDivWidth;
			dashboardZoomInDiv.style.height = zoomInDivHeight;
			dashboardZoomInDiv.style.display = "block";
			
			var zoomInTopDivLeft = left + zoomInSmallImageWidth;
			var zoomInTopDivTop = top;
			var zoomInTopDivWidth = width - zoomInSmallImageWidth;
			if(zoomInTopDivWidth < 0) {
				zoomInTopDivWidth = 0;
			}
			var zoomInTopDivHeight = zoomInSmallImageHeight;
			
			zoomInTopDivLeft += "px";
			zoomInTopDivTop += "px";
			zoomInTopDivWidth += "px";
			zoomInTopDivHeight += "px";
			
			dashboardZoomInTopDiv.style.left = zoomInTopDivLeft;
			dashboardZoomInTopDiv.style.top = zoomInTopDivTop;
			dashboardZoomInTopDiv.style.width = zoomInTopDivWidth;
			dashboardZoomInTopDiv.style.height = zoomInTopDivHeight;
			dashboardZoomInTopDiv.style.display = "block";
		}
	}
}

function onMouseOutZoomInGraphImage() {
	hideZoomInGraphImage();
}

function hideZoomInGraphImage() {
	var dashboardZoomInDiv = document.getElementById("dashboardZoomInDiv");
	var dashboardZoomInTopDiv = document.getElementById("dashboardZoomInTopDiv");
	if(dashboardZoomInDiv && dashboardZoomInTopDiv) {
		dashboardZoomInDiv.style.display = "none";
		dashboardZoomInTopDiv.style.display = "none";
	}
}

function zoomInGraph(obj, startTimestamp, endTimestamp, modelUpdateTime) {
	hideZoomInGraphImage();
	var params = "action=zoomInGraph";
	params += ("&startTimestamp=" + startTimestamp);
	params += ("&endTimestamp=" + endTimestamp);
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateDashboardModel(params);
}

function zoomOutGraph() {
	var params = "action=zoomOutGraph";
	
	updateDashboardModel(params);
}

function previousGraphTime(modelUpdateTime) {
	var params = "action=previousGraphTime";
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateDashboardModel(params);
}

function nextGraphTime(modelUpdateTime) {
	var params = "action=nextGraphTime";
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateDashboardModel(params);
}