var dashboardViewBySlidingDivInterval;
var dashboardViewTypeSlidingDivInterval;
var dashboardGroupTypeSlidingDivInterval;

function onAfterHeaderDivResponseLoaded() {
	hideDashboardViewBySlidingDiv();
	hideDashboardViewTypeSlidingDiv();
	hideDashboardGroupTypeSlidingDiv();
}

function initViewByDivsPositions() {
	var dashboardViewByUpperDiv = document.getElementById("dashboardViewByUpperDiv");
	if(dashboardViewByUpperDiv) {
		var left = findPosX(dashboardViewByUpperDiv);
		var top = findPosY(dashboardViewByUpperDiv);
		top += 1;
		left = left + "px";
		top = top + "px";
		
		var dashboardViewByCoverDiv = document.getElementById("dashboardViewByCoverDiv");
		if(dashboardViewByCoverDiv) {
			dashboardViewByCoverDiv.style.left = left;
			dashboardViewByCoverDiv.style.top = top;
			dashboardViewByCoverDiv.style.display = "block";
			var dashboardViewBySlidingDiv = document.getElementById("dashboardViewBySlidingDiv");
			dashboardViewBySlidingDiv.style.left = left;
			dashboardViewBySlidingDiv.style.top = top;
			dashboardViewBySlidingDiv.style.display = "block";
		}
	}
}

function showDashboardViewBySlidingDiv(text) {
	dashboardViewBySlidingDivInterval = showSlidingDiv("slide", "dashboardViewBySlidingDiv", "dashboardViewByUpperDiv", text, "right", 145, 2, 10);
}

function hideDashboardViewBySlidingDiv() {
	if(dashboardViewBySlidingDivInterval) {
		clearInterval(dashboardViewBySlidingDivInterval);
		dashboardViewBySlidingDivInterval = null;
	}
	initViewByDivsPositions();
}

function changeViewBy(viewBy) {
	hideDashboardViewBySlidingDiv();
	
	var form = document.getElementById("dashboardHeaderForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=changeViewBy&viewBy=" + viewBy;
		updateDashboardModel(params);
	}
}

function setCurrentNode(nodeId) {
	var params = "action=setCurrentNode&id=" + nodeId;
	updateDashboardModel(params);
}

function initViewTypeDivsPositions() {
	var dashboardViewTypeUpperDiv = document.getElementById("dashboardViewTypeUpperDiv");
	if(dashboardViewTypeUpperDiv) {
		var left = findPosX(dashboardViewTypeUpperDiv);
		var top = findPosY(dashboardViewTypeUpperDiv);
		left += 48;
		top += 1;
		left = left + "px";
		top = top + "px";
		
		var dashboardViewTypeSlidingDiv = document.getElementById("dashboardViewTypeSlidingDiv");
		if(dashboardViewTypeSlidingDiv) {
			dashboardViewTypeSlidingDiv.style.left = left;
			dashboardViewTypeSlidingDiv.style.top = top;
			dashboardViewTypeSlidingDiv.style.width = "0px";
			dashboardViewTypeSlidingDiv.style.paddingTop = "";
			dashboardViewTypeSlidingDiv.style.paddingRight = "";
			dashboardViewTypeSlidingDiv.style.paddingBottom = "";
		}
	}
}

function showDashboardViewTypeSlidingDiv(text) {
	var dashboardViewTypeSlidingDiv = document.getElementById("dashboardViewTypeSlidingDiv");
	if(dashboardViewTypeSlidingDiv) {
		dashboardViewTypeSlidingDiv.style.paddingTop = "3px";
		dashboardViewTypeSlidingDiv.style.paddingRight = "10px";
		dashboardViewTypeSlidingDiv.style.paddingBottom = "3px";
		dashboardViewTypeSlidingDivInterval = showSlidingDiv("slideExpand", "dashboardViewTypeSlidingDiv", "dashboardViewTypeUpperDiv", text, "right", 170, 2, 10);
	}
}

function hideDashboardViewTypeSlidingDiv() {
	if(dashboardViewTypeSlidingDivInterval) {
		clearInterval(dashboardViewTypeSlidingDivInterval);
		dashboardViewTypeSlidingDivInterval = null;
	}
	initViewTypeDivsPositions();
}

function changeViewType(viewType) {
	hideDashboardViewTypeSlidingDiv();
	
	var form = document.getElementById("dashboardHeaderForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=changeViewType&viewType=" + viewType + "&divIds=" + HEADER_DIV_ID + "|" + GRAPH_DIV_ID;
		updateDashboardModel(params);
	}
}

function initGroupTypeDivsPositions() {
	var dashboardViewGroupTypeUpperDiv = document.getElementById("dashboardViewGroupTypeUpperDiv");
	if(dashboardViewGroupTypeUpperDiv) {
		var left = findPosX(dashboardViewGroupTypeUpperDiv);
		var top = findPosY(dashboardViewGroupTypeUpperDiv);
		if(document.all) {
			left -= 2;
			top += 1;
		}else {
			left -= 12;
			top += 1;
		}
		left = left + "px";
		top = top + "px";
		
		var dashboardGroupTypeSlidingDiv = document.getElementById("dashboardGroupTypeSlidingDiv");
		if(dashboardGroupTypeSlidingDiv) {
			dashboardGroupTypeSlidingDiv.style.left = left;
			dashboardGroupTypeSlidingDiv.style.top = top;
			dashboardGroupTypeSlidingDiv.style.width = "0px";
			dashboardGroupTypeSlidingDiv.style.paddingTop = "";
			dashboardGroupTypeSlidingDiv.style.paddingLeft = "";
			dashboardGroupTypeSlidingDiv.style.paddingBottom = "";
		}
	}
}

function showDashboardGroupTypeSlidingDiv(text) {
	var dashboardGroupTypeSlidingDiv = document.getElementById("dashboardGroupTypeSlidingDiv");
	if(dashboardGroupTypeSlidingDiv) {
		dashboardGroupTypeSlidingDiv.style.paddingTop = "3px";
		dashboardGroupTypeSlidingDiv.style.paddingLeft = "10px";
		dashboardGroupTypeSlidingDiv.style.paddingBottom = "3px";
		dashboardGroupTypeSlidingDivInterval = showSlidingDiv("slideExpand", "dashboardGroupTypeSlidingDiv", "dashboardViewGroupTypeUpperDiv", text, "left", 130, 2, 10);
	}
}

function hideDashboardGroupTypeSlidingDiv() {
	if(dashboardGroupTypeSlidingDivInterval) {
		clearInterval(dashboardGroupTypeSlidingDivInterval);
		dashboardGroupTypeSlidingDivInterval = null;
	}
	initGroupTypeDivsPositions();
}

function changeShowMetrics(showMetrics) {
	hideDashboardGroupTypeSlidingDiv();
	
	var form = document.getElementById("dashboardHeaderForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=changeShowMetrics&showMetrics=" + showMetrics + "&divIds=" + HEADER_DIV_ID + "|" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID;
		updateDashboardModel(params);
	}
}

function changeViewGroupType(viewGroupType) {
	hideDashboardGroupTypeSlidingDiv();
	
	var form = document.getElementById("dashboardHeaderForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=changeViewGroupType&viewGroupType=" + viewGroupType + "&divIds=" + HEADER_DIV_ID + "|" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID;
		updateDashboardModel(params);
	}
}

function openDashboardFilterByDiv() {
	var dashboardFilterByDiv = document.getElementById("dashboardFilterByDiv");
	if(dashboardFilterByDiv) {
		var filterByDivLink = document.getElementById("filterByDivLink");
		if(filterByDivLink) {
			var left = findPosX(filterByDivLink);
			var top = findPosY(filterByDivLink);
			
			left += 70;
			
			left += "px";
			top += "px";
			
			dashboardFilterByDiv.style.left = left;
			dashboardFilterByDiv.style.top = top;
			dashboardFilterByDiv.style.display = "block";
			
			if(!lastFilterByType) {
				lastFilterByType = VIEW_BY;
			}
			setFilterByType(lastFilterByType, true);
		}
	}
}

function goDashboardFilterBy() {
	updateSelectedNodes();
	var form = document.getElementById("dashboardFilterByForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=activateFilterBy";
		params += "&filterBy=" + document.getElementById("filterByType").value;
		//alert(params);
		updateDashboardModel(params);
	}
	
	closeDashboardFilterByDiv();
}

function updateSelectedNodes() {
	document.getElementById("filterLogs").value = "";
	document.getElementById("filterModules").value = "";
	document.getElementById("filterApplications").value = "";
	document.getElementById("filterServers").value = "";
	
	//var list = filterByContentTree.getAllCheckedAndPartiallyChecked();
	var list = filterByContentTree.getAllChecked();
	var arr = list.split(",");
	var logsStr = "";
 	var modsStr = "";
 	var applicationsStr = "";
 	var serversStr = "";
	for (var i = 0; i < arr.length; i++){
		var s = arr[i];
		var ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == "Module"){
				if (modsStr != ""){
					modsStr += ",";
				}
				modsStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					modsStr += "*";
				}
			}else if (type == "Application"){
				if (applicationsStr != ""){
					applicationsStr += ",";
				}
				applicationsStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					applicationsStr += "*";
				}
			}else if (type == "Host"){
				if (serversStr != ""){
					serversStr += ",";
				}
				serversStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					serversStr += "*";
				}
			}else{
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}
		}
	}
	document.getElementById("filterLogs").value = logsStr;
	document.getElementById("filterModules").value = modsStr;
	document.getElementById("filterApplications").value = applicationsStr;
	document.getElementById("filterServers").value = serversStr;
}

function clearDashboardFilterBy() {
	var params = "action=clearFilterBy";
	updateDashboardModel(params);
}

function closeDashboardFilterByDiv() {
	var dashboardFilterByDiv = document.getElementById("dashboardFilterByDiv");
	if(dashboardFilterByDiv) {
		dashboardFilterByDiv.style.display = "none";
	}
}

function openFilterByTypeMenu() {
	var dashboardFilterByTypeDiv = document.getElementById("dashboardFilterByTypeDiv");
	if(dashboardFilterByTypeDiv) {
		var filterByTypeMenuLink = document.getElementById("filterByTypeMenuLink");
		if(filterByTypeMenuLink) {
			var left = findPosX(filterByTypeMenuLink);
			var top = findPosY(filterByTypeMenuLink);
			
			if(document.all) {
				left -= 110;
				top += 5;
			}else {
				left -= 100;
				top += 15;
			}
			
			left += "px";
			top += "px";
			
			dashboardFilterByTypeDiv.style.left = left;
			dashboardFilterByTypeDiv.style.top = top;
			dashboardFilterByTypeDiv.style.display = "block";
		}
	}
}

function closeFilterByTypeMenu() {
	var dashboardFilterByTypeDiv = document.getElementById("dashboardFilterByTypeDiv");
	if(dashboardFilterByTypeDiv) {
		dashboardFilterByTypeDiv.style.display = "none";
	}
}

var lastFilterByType = null;
function setFilterByType(filterByType, reload) {
	var foldersContentDiv = document.getElementById("filterByFoldersContentDiv");
	var applicationsContentDiv = document.getElementById("filterByApplicationsContentDiv");
	var serversContentDiv = document.getElementById("filterByServersContentDiv");
	
	var filterByTypeElement = document.getElementById("filterByType");
	var filterByTypeTextElement = document.getElementById("filterByTypeText");
	if(filterByTypeElement && filterByTypeTextElement && (filterByTypeElement.value != filterByType || reload)) {
		loadFilterByContentDivTree(filterByType);
		lastFilterByType = filterByType;
		filterByTypeElement.value = filterByType;
		
		var text = "";
		if(filterByType == filterByFoldersAndLogsType) {
			text = filterByFoldersAndLogs;
			setImageTd(filterByFoldersAndLogsType, true);
			setImageTd(filterByApplicationsType, false);
			setImageTd(filterByServersType, false);
		}else if(filterByType == filterByApplicationsType) {
			text = filterByApplications;
			setImageTd(filterByFoldersAndLogsType, false);
			setImageTd(filterByApplicationsType, true);
			setImageTd(filterByServersType, false);
		}else if(filterByType == filterByServersType) {
			text = filterByServers;
			setImageTd(filterByFoldersAndLogsType, false);
			setImageTd(filterByApplicationsType, false);
			setImageTd(filterByServersType, true);
		}
		replaceDivContent("filterByTypeText", text);
	}
	
	closeFilterByTypeMenu();
}

function setFilterByTypeMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}

var filterByContentTree = null;
function loadFilterByContentDivTree(filterByType) {
	clearTreeNodes(filterByContentTree);
	
	filterByContentTree = new dhtmlXTreeObject("filterByContentbox_tree","100%","100%","0","hidden");
	filterByContentTree.setImagePath(BASE_DIRECTORY);
	filterByContentTree.setIconSize(13,13);
	filterByContentTree.enableTreeLines(false);
	filterByContentTree.setOnLoadingStart(startLoading);
	filterByContentTree.setOnLoadingEnd(endLoading);
	filterByContentTree.enableCheckBoxes(1);
	filterByContentTree.enableThreeStateCheckboxes(true);
	filterByContentTree.loadingDivName = "filterByContentDivLoading";
	filterByContentTree.setXMLAutoLoading(BASE_DIRECTORY + "dashboard/view/filterByContentTreeXML.jsp?filterByType=" + filterByType);
	filterByContentTree.loadXML(BASE_DIRECTORY + "dashboard/view/filterByContentTreeXML.jsp?filterByType=" + filterByType);
}

function setImageTd(id, selected) {
	var imageTd = document.getElementById(id + "ImageTd");
	if(imageTd) {
		if(selected) {
			imageTd.className = "DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL DASHBOARD_SELECTED_FILTER_BY_TYPE_MENU_ITEM";
			replaceDivContent(id + "ImageTd", "<img src='" + BASE_DIRECTORY + "images/dashboard/header/filterByTypeSelected.gif' border='0'>");
		}else {
			imageTd.className = "DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL";
			replaceDivContent(id + "ImageTd", "&nbsp;");
		}
	}
}