var dashboardViewHierarchyTypeSlidingDivInterval;
var isMouseOverDashboardServerMetricsMetricsColumn;
var isMouseOverDashboardServerMetricsColumnTooltip;
var isMouseOverDashboardServerMetricsColumnTooltipStum;
var hideDashboardServerMetricsColumnTooltipIfNeededTimeoutId;
var hideDashboardServerMetricsColumnTooltipIfNeededInterval = 500;

function onAfterMainTableDivResponseLoaded() {
	initViewHierarchyTypeDivsPositions();
}

function initViewHierarchyTypeDivsPositions() {
	var dashboardViewHierarchyTypeUpperDiv = document.getElementById("dashboardViewHierarchyTypeUpperDiv");
	if(dashboardViewHierarchyTypeUpperDiv) {
		var left = findPosX(dashboardViewHierarchyTypeUpperDiv);
		var top = findPosY(dashboardViewHierarchyTypeUpperDiv);
		if(document.all) {
			left -= 2;
			top += 1;
		}else {
			left -= 12;
			top += 1;
		}
		left = left + "px";
		top = top + "px";
		
		var dashboardViewHierarchyTypeSlidingDiv = document.getElementById("dashboardViewHierarchyTypeSlidingDiv");
		dashboardViewHierarchyTypeSlidingDiv.style.left = left;
		dashboardViewHierarchyTypeSlidingDiv.style.top = top;
		dashboardViewHierarchyTypeSlidingDiv.style.width = "0px";
		dashboardViewHierarchyTypeSlidingDiv.style.paddingTop = "";
		dashboardViewHierarchyTypeSlidingDiv.style.paddingLeft = "";
		dashboardViewHierarchyTypeSlidingDiv.style.paddingBottom = "";
	}
}

function showDashboardViewHierarchyTypeSlidingDiv(text) {
	var dashboardViewHierarchyTypeSlidingDiv = document.getElementById("dashboardViewHierarchyTypeSlidingDiv");
	dashboardViewHierarchyTypeSlidingDiv.style.paddingTop = "3px";
	dashboardViewHierarchyTypeSlidingDiv.style.paddingLeft = "10px";
	dashboardViewHierarchyTypeSlidingDiv.style.paddingBottom = "3px";
	dashboardViewHierarchyTypeSlidingDivInterval = showSlidingDiv("slideExpand", "dashboardViewHierarchyTypeSlidingDiv", "dashboardViewHierarchyTypeUpperDiv", text, "left", 130, 2, 10);
}

function hideDashboardViewHierarchyTypeSlidingDiv() {
	if(dashboardViewHierarchyTypeSlidingDivInterval) {
		clearInterval(dashboardViewHierarchyTypeSlidingDivInterval);
		dashboardViewHierarchyTypeSlidingDivInterval = null;
	}
	initViewHierarchyTypeDivsPositions();
}

function changeViewHierarchyType(viewHierarchyType) {
	hideDashboardViewHierarchyTypeSlidingDiv();
	
	var params = "action=changeViewHierarchyType&viewHierarchyType=" + viewHierarchyType + "&divIds=" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID;
	updateDashboardModel(params);
}

function zoomIntoElement(id, name, type, startTimestamp, endTimestamp, modelUpdateTime) {
	var params = "action=zoomIntoElement&id=" + id + "&name=" + name + "&type=" + type;
	if(startTimestamp && endTimestamp && modelUpdateTime) {
		params += "&startTimestamp=" + startTimestamp + "&endTimestamp=" + endTimestamp + "&modelUpdateTime=" + modelUpdateTime;
	}
	updateDashboardModel(params);
}

function zoomOutOfElement() {
	var params = "action=zoomOutOfElement";
	updateDashboardModel(params);
}

function selectMainTableNode(id, type, imageId) {
	var params = "action=selectMainTableNode&id=" + id + "&type=" + type + "&divIds=" + HEADER_DIV_ID + "|" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID;
	updateDashboardModel(params);
	
	//changeImageAttributes(imageId, "mainTable/tableRowSelected.gif", "mainTable/tableRowSelectedOver.gif");
}

function unselectMainTableNode(id, type, imageId) {
	var params = "action=unselectMainTableNode&id=" + id + "&type=" + type + "&divIds=" + HEADER_DIV_ID + "|" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID;
	updateDashboardModel(params);
	
	//changeImageAttributes(imageId, "mainTable/tableRowSelect.gif", "mainTable/tableRowSelectOver.gif");
}

function changeImageAttributes(imageId, imageSource, imageSourceOver) {
	var image = document.getElementById(imageId);
	if(image) {
		image.onMouseOver = "";
		image.onMouseOut = "";
		setImageSource(image, imageSource);
		image.onMouseOver = "javascript:setImageSource(this, '" + imageSourceOver + "')";
		image.onMouseOut = "javascript:setImageSource(this, '" + imageSource + "')";
	}
}

function openDashboardSearchDiv() {
	var dashboardSearchDiv = document.getElementById("dashboardSearchDiv");
	if(dashboardSearchDiv) {
		var dashboardSearchTextTd = document.getElementById("dashboardSearchTextTd");
		if(dashboardSearchTextTd) {
			var left = findPosX(dashboardSearchTextTd);
			var top = findPosY(dashboardSearchTextTd);
			if(document.all) {
				left += 35;
				top -= 2;
			}else {
				left += 35;
				top -= 3;
			}
			left += "px";
			top += "px";
			
			dashboardSearchDiv.style.left = left;
			dashboardSearchDiv.style.top = top;
			dashboardSearchDiv.style.display = "block";
			
			var searchBox = document.getElementById("searchTerm");
			if (searchBox){
			  searchBox.focus();
			}
		}
	}
}

function goDashboardSearch() {
	var searchTerm = document.getElementById("searchTerm");
	if(searchTerm) {
		closeDashboardSearchDiv();
		
		var params = "action=search&searchTerm=" + searchTerm.value + "&divIds=" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID;
		updateDashboardModel(params);
		searchTerm.value = "";
	}
}

function clearDashboardSearch() {
	var searchTerm = document.getElementById("searchTerm");
	if(searchTerm) {
		var params = "action=search&searchTerm=&divIds=" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID + "|" + TOP_MESSAGES_DIV_ID;
		updateDashboardModel(params);
		searchTerm.value = "";
	}
}

function closeDashboardSearchDiv() {
	var dashboardSearchDiv = document.getElementById("dashboardSearchDiv");
	if(dashboardSearchDiv) {
		dashboardSearchDiv.style.display = "none";
	}
}

function showPrevResults() {
	var params = "action=showPrevResults";
	params += "&divIds=" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID;
	updateDashboardModel(params);
}

function showNextResults() {
	var params = "action=showNextResults";
	params += "&divIds=" + GRAPH_DIV_ID + "|" + MAIN_TABLE_DIV_ID;
	updateDashboardModel(params);
}

function setMainTableRowClass(rowId, className) {
	setElementClass(rowId, className);
}

function onMouseOverServerMetricsColumn(obj, event, type, id, name, startTimestamp, endTimestamp) {
	hideDashboardGraphTooltip();
	isMouseOverDashboardServerMetricsColumnTooltip = false;
	isMouseOverDashboardServerMetricsColumnTooltipStum = false;
	window.clearTimeout(hideDashboardServerMetricsColumnTooltipIfNeededTimeoutId);
	isMouseOverDashboardServerMetricsColumn = true;
	
	var postParams = "";
	postParams += ("type=" + type);
	postParams += ("&id=" + id);
	postParams += ("&name=" + name);
	postParams += ("&startTimestamp=" + startTimestamp);
	postParams += ("&endTimestamp=" + endTimestamp);
	sendAjaxRequest("getServerMetricsColumnTooltip.jsp", function(req){
		if(isMouseOverDashboardServerMetricsColumn) {
			showDashboardServerMetricsColumnTooltip(obj, event, req);
		}
	}, 'POST', postParams);
}

function showDashboardServerMetricsColumnTooltip(obj, event, req) {
	var xmldoc = req.responseXML.documentElement;
	if(xmldoc) {
		var responseElement = xmldoc.getElementsByTagName("Response")[0];
		if(responseElement) {
			var status = responseElement.getAttribute("status");
			if(status == STATUS_OK) {
				var bgSuffix = responseElement.getAttribute("bgSuffix");
				var dashboardServerMetricsColumnTooltipDiv = document.getElementById("dashboardServerMetricsColumnTooltipDiv");
				var dashboardServerMetricsColumnTooltipStumDiv = document.getElementById("dashboardServerMetricsColumnTooltipStumDiv");
				if(dashboardServerMetricsColumnTooltipDiv && dashboardServerMetricsColumnTooltipStumDiv) {
					var responseText = getXMLElementValue(responseElement);
					replaceDivContent("dashboardServerMetricsColumnTooltipDiv", responseText);
					
					var objPosition = findPos(obj);
					var stumWidth = 33; // taken from the width of the stum image
					var stumHeight = 28; // taken from the height of the stum image
					var tableWidth = 450; // taken from width of DASHBOARD_GRAPH_TOOLTIP_DIV class in CSS
					  
					// get the height of the tooltip div using a trick
					dashboardServerMetricsColumnTooltipDiv.style.filter = "alpha(opacity=1)"; // IE
					dashboardServerMetricsColumnTooltipDiv.style.opacity = 0.01; // Firefox, etc..
					dashboardServerMetricsColumnTooltipDiv.style.display = "block"; 
					var tableHeight = dashboardServerMetricsColumnTooltipDiv.offsetHeight;
					dashboardServerMetricsColumnTooltipDiv.style.display = "none"; 
					dashboardServerMetricsColumnTooltipDiv.style.filter = "alpha(opacity=100)"; // IE
					dashboardServerMetricsColumnTooltipDiv.style.opacity = 1; // Firefox, etc..
						
					var winWidth = 1280;
					var winHeight = 1024;
					var sizeArr = getWindowSize();
					if (sizeArr && sizeArr.length == 2){
						winWidth = sizeArr[0];
					  	winHeight = sizeArr[1];
					}
					var x = (document.all ? objPosition[0] : event.pageX);
					var y = (document.all ? objPosition[1] : event.pageY);
						
					// check if the tooltip can be shown to the right of the mouse. if not, show on the left of the mouse
					var showOnRightSide;
					if(x < (winWidth - (tableWidth + stumWidth) - 50)) {
						showOnRightSide = true;
					}else {
						showOnRightSide = false;
					}
					if(showOnRightSide) {
						if(document.all) {
							x += 16;
						}else {
							x += 4;
						}
					}else {
						if(document.all) {
							x = x - (tableWidth + stumWidth);
						}else {
							x = x - (tableWidth + stumWidth + 7);
						}
						
					}
					if (x < 0){
						x = 0;
						showOnRightSide = true;
					}
			  	
					var showAbove;
					if(y - document.body.scrollTop > tableHeight / 2) {
						showAbove = true;
					}else {
						showAbove = false;
					}
					if (y < 0){
						y = 0;
					}
			  	
					var stumX, stumY;
					var bodyX, bodyY;
			  	
					var dashboardServerMetricsColumnTooltipStumImage = document.getElementById("dashboardServerMetricsColumnTooltipStumImage");
					if(showOnRightSide) {
						stumX = x;
						bodyX = (stumX + stumWidth) - 4;
						if(showAbove) {
							dashboardServerMetricsColumnTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumLeftBottom" + bgSuffix + ".gif";
						}else {
							dashboardServerMetricsColumnTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumLeftTop" + bgSuffix + ".gif";
						}
					}else {
						bodyX = x;
						stumX = (bodyX + tableWidth) - 4;
						if(showAbove) {
							dashboardServerMetricsColumnTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumRightBottom" + bgSuffix + ".gif";
						}else {
							dashboardServerMetricsColumnTooltipStumImage.src = BASE_DIRECTORY + "images/dashboard/graph/tooltipBackgrounds/stumRightTop" + bgSuffix + ".gif";
						}
					}
					if(showAbove) {
						stumY = y - 20;
						bodyY = stumY - (tableHeight / 2);
					}else {
						stumY = y;
						bodyY = stumY;
					}
					//alert("stumY=" + stumY + ", bodyY=" + bodyY);
					dashboardServerMetricsColumnTooltipDiv.style.left = (bodyX + "px");
					dashboardServerMetricsColumnTooltipDiv.style.top = (bodyY + "px");
					dashboardServerMetricsColumnTooltipDiv.style.display = "block";
					
					dashboardServerMetricsColumnTooltipStumDiv.style.left = (stumX + "px");
					dashboardServerMetricsColumnTooltipStumDiv.style.top = (stumY + "px");
					dashboardServerMetricsColumnTooltipStumDiv.style.display = "block";
				}
			}else {
				
			}
		}
	}
}

function onMouseOutDashboardServerMetricsColumn() {
	hideDashboardServerMetricsColumnTooltipIfNeededTimeoutId = setTimeout("hideDashboardServerMetricsColumnTooltipIfNeeded()", hideDashboardServerMetricsColumnTooltipIfNeededInterval);
	isMouseOverDashboardServerMetricsColumn = false;
}

function hideDashboardServerMetricsColumnTooltipIfNeeded() {
	if(isMouseOverDashboardServerMetricsColumnTooltip || isMouseOverDashboardServerMetricsColumnTooltipStum) {
		hideDashboardServerMetricsColumnTooltipIfNeededTimeoutId = window.setTimeout("hideDashboardServerMetricsColumnTooltipIfNeeded()", hideDashboardServerMetricsColumnTooltipIfNeededInterval);
	}else {
		hideDashboardServerMetricsColumnTooltip();
	}
}

function hideDashboardServerMetricsColumnTooltip() {
	var dashboardServerMetricsColumnTooltipDiv = document.getElementById("dashboardServerMetricsColumnTooltipDiv");
	if(dashboardServerMetricsColumnTooltipDiv) {
		dashboardServerMetricsColumnTooltipDiv.style.display = "none";
	}
	var dashboardServerMetricsColumnTooltipStumDiv = document.getElementById("dashboardServerMetricsColumnTooltipStumDiv");
	if(dashboardServerMetricsColumnTooltipStumDiv) {
		dashboardServerMetricsColumnTooltipStumDiv.style.display = "none";
	}
}

function onMouseOverDashboardServerMetricsColumnTooltip() {
	isMouseOverDashboardServerMetricsColumnTooltip = true;
	isMouseOverDashboardServerMetricsColumnTooltipStum = true;
}

function onMouseOutDashboardServerMetricsColumnTooltip() {
	isMouseOverDashboardServerMetricsColumnTooltip = false;
	isMouseOverDashboardServerMetricsColumnTooltipStum = false;
}


function doCheckSearch(e){
		var result = doCheck(e);
		if (!result){
			goDashboardSearch();
		}
		return result;
  }

	