<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>
<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.reports.ExecutionInfo"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewNode"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultElement"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String currentNodeName = model.getCurrentNodeName();

HealthViewResult currentResult = model.getCurrentResult();
HealthViewResultElement rootNodeResultElement = currentResult.getRootNodeResultElement();
ComputationResults rootComputationResults = rootNodeResultElement.getComputationResults();
boolean rootIsLog = rootComputationResults.getType().equals(XpoLogObjectTypes.LOG_TYPE);
List resultElements = currentResult.getResultElements();
List currentPageResultElements = currentResult.getCurrentPageResultElements();
boolean rootIsHost = rootComputationResults.getType().equals(XpoLogObjectTypes.HOST_TYPE);
boolean rootIsEmptyHost = false;
MultiHostComputationResults emptyHostComputationResults = null;
if(rootIsHost) {
	List multiHostComputationResultsList = rootNodeResultElement.getMultiHostComputationResultsList();
	MultiHostComputationResults multiHostComputationResults = null;
	if(multiHostComputationResultsList != null && multiHostComputationResultsList.size() == 1) {
		multiHostComputationResults = (MultiHostComputationResults)multiHostComputationResultsList.get(0);
		if(multiHostComputationResults.isEmpty()) {
			rootIsEmptyHost = true;
			emptyHostComputationResults = multiHostComputationResults;
		}
	}
}

String viewGroupType = model.getViewGroupType();
String viewHierarchyType = model.getViewHierarchyType();

boolean showColorGeneral = false;
if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY)) {
	showColorGeneral = HealthViewModelHelper.hasVisibleResultElements(currentResult);
}else if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SPLIT)) {
	showColorGeneral = true;
}

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

boolean showMetrics = model.isShowMetrics();
DateFilter dateFilter = model.getTimeFilter();
Date minDate = dateFilter.getMinDate();
Date maxDate = dateFilter.getMaxDate();
long startTime = minDate.getTime();
long endTime = maxDate.getTime();
%>

<form AUTOCOMPLETE="OFF" id="dashboardMainTableForm" name="dashboardMainTableForm" method="POST" class="DASHBOARD_FORM">
<table border="0" cellpadding="0" cellspacing="0" style="height:20px; width: 100%">
	<tr height="10px">
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td class="DASHBOARD_MAIN_TABLE_PATH_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td>
									<jsp:include page="dashboardPath.jsp" flush="true">
										<jsp:param name="pathClassName" value="DASHBOARD_MAIN_TABLE_PATH"/>
										<jsp:param name="pathSeparatorClassName" value="DASHBOARD_MAIN_TABLE_PATH_SEPARATOR"/>
									</jsp:include>
								</td>
								<td class="empty">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_TITLE_LEFT_CELL">&nbsp;</td>
								<td class="DASHBOARD_MAIN_TABLE_TITLE_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											if(model.getNodesList().size() > 1) {
											%>
											<td class="DASHBOARD_MAIN_TABLE_TITLE_ZOOM_OUT">
												<a href="javascript:zoomOutOfElement()" onMouseOver="javascript:showTooltip(dashboardTooltips['nodesListUp'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/nodesListUp.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/nodesListUpOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/nodesListUp.gif')"></a>
											</td>
											<%
											}else {
											%>
											<td class="DASHBOARD_MAIN_TABLE_TITLE_ZOOM_OUT_FILLER">&nbsp;</td>
											<%
											}
											%>
											<td class="DASHBOARD_MAIN_TABLE_TITLE_BIG"><nobr><%=currentNodeName %> <%=rootIsEmptyHost ? "Metrics Summary" : "Problems Summary" %></nobr></td>
											<td class="empty">&nbsp;</td>
											<%
											if(!rootIsLog) {
											%>
											<td class="DASHBOARD_MAIN_TABLE_VIEW_HIERARCHY_TYPE_CELL">
												<div id="dashboardViewHierarchyTypeUpperDiv" class="DASHBOARD_MAIN_TABLE_VIEW_HIERARCHY_TYPE_UPPER">
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr>
														<%
														if(viewHierarchyType.equals(HealthViewContext.VIEW_HIERARCHY_TYPE_FLAT)) {
														%>
														<td><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/viewHierarchyTypeFlatOver.gif" border="0" onMouseOver="javascript:showDashboardViewHierarchyTypeSlidingDiv('<nobr>Flat View</nobr>')" onMouseOut="javascript:hideDashboardViewHierarchyTypeSlidingDiv()"></td>
														<td class="empty">&nbsp;&nbsp;&nbsp;</td>
														<td><a href="javascript:changeViewHierarchyType('<%=HealthViewContext.VIEW_HIERARCHY_TYPE_HIERARCHIC %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/viewHierarchyTypeHierarchic.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/viewHierarchyTypeHierarchicOver.gif');showDashboardViewHierarchyTypeSlidingDiv('<nobr>Hierarchic View</nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/viewHierarchyTypeHierarchic.gif');hideDashboardViewHierarchyTypeSlidingDiv()"></a></td>
														<%
														}else if(viewHierarchyType.equals(HealthViewContext.VIEW_HIERARCHY_TYPE_HIERARCHIC)) {
														%>
														<td><a href="javascript:changeViewHierarchyType('<%=HealthViewContext.VIEW_HIERARCHY_TYPE_FLAT %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/viewHierarchyTypeFlat.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/viewHierarchyTypeFlatOver.gif');showDashboardViewHierarchyTypeSlidingDiv('<nobr>Flat View</nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/viewHierarchyTypeFlat.gif');hideDashboardViewHierarchyTypeSlidingDiv()"></a></td>
														<td class="empty">&nbsp;&nbsp;&nbsp;</td>
														<td><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/viewHierarchyTypeHierarchicOver.gif" border="0" onMouseOver="javascript:showDashboardViewHierarchyTypeSlidingDiv('<nobr>Hierarchic View</nobr>')" onMouseOut="javascript:hideDashboardViewHierarchyTypeSlidingDiv()"></td>
														<%
														}
														%>
													</tr>
												</table>
												</div>
												<div id="dashboardViewHierarchyTypeSlidingDiv" class="DASHBOARD_MAIN_TABLE_VIEW_HIERARCHY_TYPE_POPUP"></div>
											</td>
											<%
											}
											%>
										</tr>
									</table>
								</td>
								<td class="DASHBOARD_MAIN_TABLE_TITLE_RIGHT_CELL">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				if(rootIsEmptyHost) {
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL">Metrics Type</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 120px;">Metrics Problems</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 80px;">Severity</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 100px;">Average</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL DASHBOARD_MAIN_TABLE_GENERAL_RIGHT_CELL" style="width: 100px;">Max</td>
							</tr>
							
							<%
							if(showMetrics) {
								String cpuRiskTextClassName = null, memoryRiskTextClassName = null, diskSpaceRiskTextClassName = null;
								HostMeasurementTotals cpuMeasurementTotal = null, memoryMeasurementTotal = null, diskSpaceMeasurementTotal = null;
								HostMeasurementTotals [] diskSpaceMeasurementTotalArr = null;
								HostMeasurementTotals [] cpuMeasurementTotalArr = null;
								long cpuProblems = -1, memoryProblems = -1, diskSpaceProblems = -1;
								double cpuAvg = -1, cpuMax = -1, memoryAvg = -1, memoryMax = -1, diskSpaceAvg = -1, diskSpaceMax = -1;
								double cpuRisk = -1, memoryRisk = -1, diskSpaceRisk = -1;
								String rowClassName = null;
								String rowId = null;
								
								cpuMeasurementTotal = emptyHostComputationResults.getHostMeasurementTotals(HostCpu.HOST_CPU_TYPE);
								if(cpuMeasurementTotal != null) {
									cpuProblems = emptyHostComputationResults.getProblemsByGroupType(HostCpu.HOST_CPU_TYPE);
									cpuAvg = cpuMeasurementTotal.getValue();
									cpuMax = cpuMeasurementTotal.getMaxValue();
									cpuMeasurementTotalArr = emptyHostComputationResults.getHostMeasurementTotalsList(HostCpu.HOST_CPU_TYPE);
								}else {
									cpuAvg = -1;
									cpuMax = -1;
								}
								cpuRisk = emptyHostComputationResults.getWeightByGroupType(HostCpu.HOST_CPU_TYPE);
								if(cpuRisk == -1) {
									cpuRisk = 0;
								}
								if(cpuRisk >= 0) {
									cpuRiskTextClassName = "DASHBOARD_MAIN_TABLE_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(cpuRisk);
								}else {
									cpuRiskTextClassName = "";
								}
								
								memoryMeasurementTotal = emptyHostComputationResults.getHostMeasurementTotals(HostMemory.HOST_MEMORY_TYPE);
								if(memoryMeasurementTotal != null) {
									memoryProblems = emptyHostComputationResults.getProblemsByGroupType(HostMemory.HOST_MEMORY_TYPE);
									memoryAvg = memoryMeasurementTotal.getValue();
									memoryMax = memoryMeasurementTotal.getMaxValue();
								}else {
									memoryAvg = -1;
									memoryMax = -1;
								}
								memoryRisk = emptyHostComputationResults.getWeightByGroupType(HostMemory.HOST_MEMORY_TYPE);
								if(memoryRisk == -1) {
									memoryRisk = 0;
								}
								if(memoryRisk >= 0) {
									memoryRiskTextClassName = "DASHBOARD_MAIN_TABLE_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(memoryRisk);
								}else {
									memoryRiskTextClassName = "";
								}
								
								diskSpaceMeasurementTotal = emptyHostComputationResults.getHostMeasurementTotals(HostDiskSpace.HOST_DISK_SPACE_TYPE);
								if(diskSpaceMeasurementTotal != null) {
									diskSpaceProblems = emptyHostComputationResults.getProblemsByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
									diskSpaceAvg = diskSpaceMeasurementTotal.getValue();
									diskSpaceMax = diskSpaceMeasurementTotal.getMaxValue();
									diskSpaceMeasurementTotalArr = emptyHostComputationResults.getHostMeasurementTotalsList(HostDiskSpace.HOST_DISK_SPACE_TYPE);									
								}else {
									diskSpaceAvg = -1;
									diskSpaceMax = -1;
								}
								diskSpaceRisk = emptyHostComputationResults.getWeightByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
								if(diskSpaceRisk == -1) {
									diskSpaceRisk = 0;
								}
								if(diskSpaceRisk >= 0) {
									diskSpaceRiskTextClassName = "DASHBOARD_MAIN_TABLE_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(diskSpaceRisk);
								}else {
									diskSpaceRiskTextClassName = "";
								}
								
								if(cpuMeasurementTotal == null && memoryMeasurementTotal == null && diskSpaceMeasurementTotal == null) {
							%>
							<tr>
								<td colspan="4">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL">No metrics data was found</td>
										</tr>
									</table>
								</td>
							</tr>
							<%
								}else {
									if(cpuMeasurementTotal != null) {
										// CPU
										rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
										rowId = "mainTableRow_0";
							%>
							<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:setMainTableRowClass('<%=rowId %>', 'DASHBOARD_MAIN_TABLE_HIGHLIGHTED_ROW')" onMouseOut="javascript:setMainTableRowClass('<%=rowId %>', '<%=rowClassName %>')">
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK">CPU</td>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=cpuProblems == -1 ? "N/A" : cpuProblems + "" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=cpuRiskTextClassName %>"><%=cpuRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(cpuRisk) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=cpuAvg == -1 ? "N/A" : numberFormat.format(cpuAvg) + "%" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=cpuMax == -1 ? "N/A" : numberFormat.format(cpuMax) + "%" %></td>
							</tr>
							<%
									}
								
									
									
									if(cpuMeasurementTotalArr != null && cpuMeasurementTotalArr.length > 1) {
										// CPU List
										rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
										for (int i = 0; i < cpuMeasurementTotalArr.length;i++){
											double avg = cpuMeasurementTotalArr[i].getValue();
											double max = cpuMeasurementTotalArr[i].getMaxValue();
											String measurementName = cpuMeasurementTotalArr[i].getKey();
											if (measurementName.startsWith(HostCpu.HOST_CPU_TYPE + ":")){
												measurementName = measurementName.substring(HostCpu.HOST_CPU_TYPE.length() + 1);
											}
											
											if (measurementName.endsWith("_totals")){
												measurementName = measurementName.substring(0,measurementName.length() - 7);
											}
									%>
									<tr class="<%=rowClassName %>" height="10px">									  
										<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=measurementName%></td>
										<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL">&nbsp;</td>
    								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=diskSpaceRiskTextClassName %>">&nbsp;</td>								
										<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=avg == -1 ? "N/A" : numberFormat.format(avg) + "%" %></td>
										<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=max == -1 ? "N/A" : numberFormat.format(max) + "%" %></td>									</tr>
									<%
									}}
									
									
									
									if(memoryMeasurementTotal != null) {
										// Memory
										rowClassName = "DASHBOARD_MAIN_TABLE_REGULAR_ROW";
										rowId = "mainTableRow_1";
							%>
							<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:setMainTableRowClass('<%=rowId %>', 'DASHBOARD_MAIN_TABLE_HIGHLIGHTED_ROW')" onMouseOut="javascript:setMainTableRowClass('<%=rowId %>', '<%=rowClassName %>')">
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK">Memory</td>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=memoryProblems == -1 ? "N/A" : memoryProblems + "" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=memoryRiskTextClassName %>"><%=memoryRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(memoryRisk) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=memoryAvg == -1 ? "N/A" : numberFormat.format(memoryAvg) + "%" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=memoryMax == -1 ? "N/A" : numberFormat.format(memoryMax) + "%" %></td>
							</tr>
							<%
									}
									
									if(diskSpaceMeasurementTotal != null) {
										// Disk Space
										rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
										rowId = "mainTableRow_2";
							%>
							<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:setMainTableRowClass('<%=rowId %>', 'DASHBOARD_MAIN_TABLE_HIGHLIGHTED_ROW')" onMouseOut="javascript:setMainTableRowClass('<%=rowId %>', '<%=rowClassName %>')">
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK">Disk Space</td>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=diskSpaceProblems == -1 ? "N/A" : diskSpaceProblems + "" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=diskSpaceRiskTextClassName %>"><%=diskSpaceRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(diskSpaceRisk) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=diskSpaceAvg == -1 ? "N/A" : numberFormat.format(diskSpaceAvg) + "%" %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=diskSpaceMax == -1 ? "N/A" : numberFormat.format(diskSpaceMax) + "%" %></td>
							</tr>
							<%
									}
									
									if(diskSpaceMeasurementTotalArr != null && diskSpaceMeasurementTotalArr.length > 1) {
										// Disk Space
										rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
										for (int i = 0;i < diskSpaceMeasurementTotalArr.length;i++){
											double avg = diskSpaceMeasurementTotalArr[i].getValue();
											double max = diskSpaceMeasurementTotalArr[i].getMaxValue();
											String measurementName = diskSpaceMeasurementTotalArr[i].getKey();
											if (measurementName.startsWith(HostDiskSpace.HOST_DISK_SPACE_TYPE + ":")){
												measurementName = measurementName.substring(HostDiskSpace.HOST_DISK_SPACE_TYPE.length() + 1);
											}
											
											if (measurementName.endsWith("_totals")){
												measurementName = measurementName.substring(0,measurementName.length() - 7);
											}
									%>
									<tr class="<%=rowClassName %>" height="10px" >
										<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=measurementName%></td>
										<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL">&nbsp;</td>
    								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=diskSpaceRiskTextClassName %>">&nbsp;</td>								
										<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=avg == -1 ? "N/A" : numberFormat.format(avg) + "%" %></td>
										<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_MEASUREMENT_VALUE_CELL"><%=max == -1 ? "N/A" : numberFormat.format(max) + "%" %></td>
									</tr>
									<%
									}}
								}
							}
							%>
						</table>
					</td>
				</tr>
				<%
				}else {
					if(currentPageResultElements.size() > 0) {
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						<%
						String colspan="";
						if(showColorGeneral) {
							colspan="colspan=\"2\"";
						}
						if(rootIsLog) {
						%>
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" <%=colspan %>>Name</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 80px;">Severity</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 100px;">Type</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 100px;"># of Problems</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 140px;">% of Problems</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL DASHBOARD_MAIN_TABLE_GENERAL_RIGHT_CELL" style="width: 75px;">&nbsp;</td>
							</tr>
						<%
						}else {
						%>
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" <%=colspan %>>Name</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 90px;">Logs Status</td>
								<%if(showMetrics) { %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 90px;">Server Metrics</td>
								<%} %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 90px;">Logs Events</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 100px;">Logs Problems</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 80px;">Predefined</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 100px;">Autodetected</td>
								<%if(false) { %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 80px;">Statistical</td>
								<%} %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL" style="width: 140px;">% of Problems</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL DASHBOARD_MAIN_TABLE_GENERAL_RIGHT_CELL" style="width: 50px;">&nbsp;</td>
							</tr>
						<%
						}
						if(currentPageResultElements != null && currentPageResultElements.size() > 0) {
							long rootTotalProblems = 0;
							HealthViewResultElement resultElement = null;
							ComputationResults computationResults = null;
							for(int i = 0; i < resultElements.size(); i++) {
								resultElement = (HealthViewResultElement)resultElements.get(i);
								computationResults = resultElement.getComputationResults();
								rootTotalProblems += computationResults.getSumOfProblems();
							}
							
							HealthViewNode logNode = model.getLogNode();
							String id = null, name = null, type = null;
							boolean isVisible;
							String selectLink = null, zoomInLink = null, zoomInMmouseActionsString = null, zoomInMmouseActionsStringMessage = null, selectNodeMmouseActionsString = null;
							long total  = -1, totalFiltered = -1, totalKnowledge = -1, totalAnomaly = -1, totalProblems = -1;
							double risk;
							String riskText = null, riskTextClassName = null;
							boolean cpuIsDisabled = false, memoryIsDisabled = false, diskSpaceIsDisabled = false;
							String cpuError = null, memoryError = null, diskSpaceError = null;							
							double cpuRisk, memoryRisk, diskSpaceRisk;
							String cpuRiskBgSuffix = "0", memoryRiskBgSuffix = "0", diskSpaceRiskBgSuffix = "0";
							String rowClassName = null;
							boolean showColor;
							String rowId = null;
							String selectNodeImageId = null;
							boolean isEmpty;
							boolean isAnomaly;
							for(int i = 0; i < currentPageResultElements.size(); i++) {
								cpuIsDisabled = true;
								memoryIsDisabled = true;
								diskSpaceIsDisabled = true;
								cpuError = null;
								memoryError = null;
								diskSpaceError = null;
								
								isAnomaly = false;
								rowId = "mainTableRow_" + i;
								selectNodeImageId = "mainTableNodeSelectImage_" + i;
								
								resultElement = (HealthViewResultElement)currentPageResultElements.get(i);
								computationResults = resultElement.getComputationResults();
								
								id = computationResults.getId();
								name = computationResults.getName();
								name = XpologUtil.updateAsHtmlString(name);
								type = computationResults.getType();
								
								isVisible = resultElement.isVisible();
								if(isVisible) {
									selectLink = "javascript:unselectMainTableNode('" + id + "', '" + type + "', '" + selectNodeImageId + "')";
									selectNodeMmouseActionsString = "onMouseOver=\"javascript:showTooltip(dashboardTooltips['unselectMainTableNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
								}else {
									selectLink = "javascript:selectMainTableNode('" + id + "', '" + type + "', '" + selectNodeImageId + "')";
									selectNodeMmouseActionsString = "onMouseOver=\"javascript:showTooltip(dashboardTooltips['selectMainTableNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
								}
								if(type == null) {
									zoomInLink = null;
									zoomInMmouseActionsStringMessage = null;
								}else if((type.equals(XpoLogObjectTypes.FILTER_TYPE) ||
									  type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE)) && logNode != null) {
									boolean isKnowledge = type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE);
									zoomInLink = "javascript:openLogFromDashboard('" + BASE_DIRECTORY + "','" + logNode.getId() + "', '" + id + "', '" + isKnowledge + "', 'true',document.getElementById('" + rowId + "'),true,'HealthViewModel')";
									zoomInMmouseActionsStringMessage = "dashboardTooltips['showLog']";
								}else if(type.equals(XpoLogObjectTypes.ANOMALY_TYPE)) {
									zoomInLink = "javascript:void(0)";
									zoomInMmouseActionsStringMessage = null;
									isAnomaly = true;
								}else{
									zoomInLink = "javascript:zoomIntoElement('" + computationResults.getId() + "', '" + computationResults.getName() + "', '" + computationResults.getType() + "')";
									zoomInMmouseActionsStringMessage = "dashboardTooltips['zoomIntoMainTableNode']";
								}
								
								isEmpty = (computationResults.getTotal() == 0 || zoomInLink == null) && (type == null || !type.equals(XpoLogObjectTypes.HOST_TYPE));
								if(isEmpty) {
									zoomInLink = "javascript:void(0)";
									zoomInMmouseActionsStringMessage = "dashboardTooltips['emptyNode']";
									selectLink = "javascript:void(0)";
									selectNodeMmouseActionsString = "onMouseOver=\"javascript:showTooltip(dashboardTooltips['emptyNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
								}
								if(zoomInMmouseActionsStringMessage == null) {
									zoomInMmouseActionsString = "";
								}else {
									zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomInMmouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
								}
								
								total = computationResults.getTotal();
								totalFiltered = computationResults.getTotalFiltered();
								totalKnowledge = computationResults.getTotalKnowledgeEvents();
								totalAnomaly = computationResults.getTotalAnomalyEvents();
								totalProblems = computationResults.getSumOfProblems();
								
								if(i % 2 == 0) {
									rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
								}else {
									rowClassName = "DASHBOARD_MAIN_TABLE_REGULAR_ROW";
								}
								
								showColor = resultElement.isVisible();
								
								double percentage = 0;
								if(rootTotalProblems > 0) {
									percentage = ((double)totalProblems / (double)rootTotalProblems) * 100;
								}
								long roundedPercentage = Math.round(percentage);
								String percentageCellWidth = roundedPercentage + "px";
						%>
							<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:setMainTableRowClass('<%=rowId %>', 'DASHBOARD_MAIN_TABLE_HIGHLIGHTED_ROW')" onMouseOut="javascript:setMainTableRowClass('<%=rowId %>', '<%=rowClassName %>')">
						<%
								if(rootIsLog) {
									risk = computationResults.getWeight();
								}else {
									risk = computationResults.getMaxWeight();
								}
								riskText = HealthViewModelHelper.getFormattedRisk(risk);
								if(risk >= 0) {
									riskTextClassName = "DASHBOARD_MAIN_TABLE_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(risk);
								}else {
									riskTextClassName = "DASHBOARD_MAIN_TABLE_STATUS_CELL_0";
								}
								
								// get metrics risks
								if(showMetrics) {
									HostsManager hostsMgr = HostsManager.getInstance();
									List multiHostComputationResultsList = resultElement.getMultiHostComputationResultsList();
									MultiHostComputationResults multiHostComputationResults = null;
									HostMeasurementTotals hostMeasurementTotals = null;
									for(int j = 0; j < multiHostComputationResultsList.size(); j++) {
										multiHostComputationResults = (MultiHostComputationResults)multiHostComputationResultsList.get(j);										
										ExecutionInfo execInfo = multiHostComputationResults.getExecutionInfo();
										String errorMessage = null;
										if (execInfo != null){
											errorMessage = execInfo.getErrorMessage(startTime,endTime);											
											
											if (errorMessage != null && errorMessage.length() == 0){
												errorMessage = null;
											}
										}
										hostMeasurementTotals = multiHostComputationResults.getHostMeasurementTotals(HostCpu.HOST_CPU_TYPE);
										if(hostMeasurementTotals != null) {
											cpuIsDisabled = false;
											if (errorMessage != null){
												cpuError = errorMessage;
											}
										}
										cpuRisk = multiHostComputationResults.getWeightByGroupType(HostCpu.HOST_CPU_TYPE);
										if(cpuRisk >= 0) {
											cpuRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(cpuRisk));
										}else {
											cpuRiskBgSuffix = "0";
											if (errorMessage != null){
												cpuError = errorMessage;
												cpuIsDisabled = false;
											}
										}
										hostMeasurementTotals = multiHostComputationResults.getHostMeasurementTotals(HostMemory.HOST_MEMORY_TYPE);
										if(hostMeasurementTotals != null) {
											memoryIsDisabled = false;
											if (errorMessage != null){
												memoryError = errorMessage;
											}
										}
										memoryRisk = multiHostComputationResults.getWeightByGroupType(HostMemory.HOST_MEMORY_TYPE);
										if(memoryRisk >= 0) {
											memoryRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(memoryRisk));
										}else {
											memoryRiskBgSuffix = "0";
											if (errorMessage != null){
												memoryError = errorMessage;
												memoryIsDisabled = false;
											}
										}
										hostMeasurementTotals = multiHostComputationResults.getHostMeasurementTotals(HostDiskSpace.HOST_DISK_SPACE_TYPE);
										if(hostMeasurementTotals != null) {
											diskSpaceIsDisabled = false;
											if (errorMessage != null){
												diskSpaceError = errorMessage;
											}
										}
										diskSpaceRisk = multiHostComputationResults.getWeightByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
										if(diskSpaceRisk >= 0) {
											diskSpaceRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(diskSpaceRisk));
										}else {
											diskSpaceRiskBgSuffix = "0";
											if (errorMessage != null){
												diskSpaceError = errorMessage;
												diskSpaceIsDisabled = false;
											}
										}
									}
								}
								
								
								if(showColor) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_COLOR_OUTER_CELL">
									<table width="14px" height="14px">
										<tr>
											<td class="DASHBOARD_MAIN_TABLE_COLOR_CELL" bgcolor="<%=HealthViewModelHelper.getHexColorString(resultElement.getColor()) %>">&nbsp;</td>
										</tr>
									</table>
								</td>
						<%
									if(isEmpty || isAnomaly) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK"><%=name %></td>
						<%
									}else {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR"><a href="<%=zoomInLink %>" class="DASHBOARD_MAIN_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>><%=name %></a></td>
						<%
									}
								}else {
									if(showColorGeneral) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_COLOR_OUTER_CELL">&nbsp;</td>
						<%
										if(isEmpty || isAnomaly) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK"><%=name %></td>
						<%
										}else {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR"><a href="<%=zoomInLink %>" class="DASHBOARD_MAIN_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>><%=name %></a></td>
						<%
										}
									}else {
										if(isEmpty || isAnomaly) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR DASHBOARD_MAIN_TABLE_CELL_LINK"><%=name %></td>
						<%
										}else {
						%>
								<td class="DASHBOARD_MAIN_TABLE_NAME_CELL_WITH_COLOR"><a href="<%=zoomInLink %>" class="DASHBOARD_MAIN_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>><%=name %></a></td>
						<%
										}
									}
								}
								if(rootIsLog) {
						%>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=riskTextClassName %>"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_TYPE_CELL"><%=HealthViewModelHelper.getFormattedProblemType(type) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL DASHBOARD_MAIN_TABLE_CELL_BOLD"><%=numberFormat.format(totalProblems) %></td>
						<%
								}else {
						%>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_STATUS_CELL <%=riskTextClassName %>"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
								<%if(showMetrics) { %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_SERVER_STATUS_CELL">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td align="center"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/cpu<%=cpuError != null ? "Error" : ( cpuIsDisabled ? "Disabled" : cpuRiskBgSuffix)%>.gif" border="0" <%if(cpuIsDisabled) { %>onMouseOver="javascript:hideDashboardServerMetricsColumnTooltip()"<%}else { %>onMouseOver="javascript:onMouseOverServerMetricsColumn(this, event, '<%=resultElement.getType() %>', '<%=resultElement.getId() %>', '<%=resultElement.getName() %>', '<%=startTime %>', '<%=endTime %>')" onMouseOut="javascript:onMouseOutDashboardServerMetricsColumn()"<%} %>></td>
											<td class="empty">&nbsp;&nbsp;</td>
											<td align="center"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/memory<%=cpuError != null ? "Error" : ( memoryIsDisabled ? "Disabled" : memoryRiskBgSuffix )%>.gif" border="0" <%if(memoryIsDisabled) { %>onMouseOver="javascript:hideDashboardServerMetricsColumnTooltip()"<%}else { %>onMouseOver="javascript:onMouseOverServerMetricsColumn(this, event, '<%=resultElement.getType() %>', '<%=resultElement.getId() %>', '<%=resultElement.getName() %>', '<%=startTime %>', '<%=endTime %>')" onMouseOut="javascript:onMouseOutDashboardServerMetricsColumn()"<%} %>></td>
											<td class="empty">&nbsp;&nbsp;</td>
											<td align="center"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/disk<%=cpuError != null ? "Error" : ( diskSpaceIsDisabled ? "Disabled" : diskSpaceRiskBgSuffix )%>.gif" border="0" <%if(diskSpaceIsDisabled) { %>onMouseOver="javascript:hideDashboardServerMetricsColumnTooltip()"<%}else { %>onMouseOver="javascript:onMouseOverServerMetricsColumn(this, event, '<%=resultElement.getType() %>', '<%=resultElement.getId() %>', '<%=resultElement.getName() %>', '<%=startTime %>', '<%=endTime %>')" onMouseOut="javascript:onMouseOutDashboardServerMetricsColumn()"<%} %>></td>
										</tr>
									</table>
								</td>
								<%} %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL DASHBOARD_MAIN_TABLE_CELL_BOLD"><%=numberFormat.format(total) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL"><%=numberFormat.format(totalProblems) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL"><%=numberFormat.format(totalFiltered) %></td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL"><%=numberFormat.format(totalKnowledge) %></td>
								<%if(false) { %>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_CELL DASHBOARD_MAIN_TABLE_GENERAL_RIGHT_CELL"><%=numberFormat.format(totalAnomaly) %></td>
								<%} %>
						<%
								}
						%>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_PERCENTAGE_CELL">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
						<%
								if(roundedPercentage > 0) {
						%>
											<td class="DASHBOARD_MAIN_TABLE_PERCENTAGE_CELL_BACKGROUND" width="<%=percentageCellWidth %>"></td>
						<%
								}
						%>
						<%
								if(totalProblems > 0) {
						%>
											<td class="DASHBOARD_MAIN_TABLE_PERCENTAGE_CELL_TEXT"><%=numberFormat.format(percentage) %>%</td>
						<%
								}
						%>
											<td class="empty" width="*">&nbsp;</td>
										</tr>
									</table>
								</td>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_IMAGES_CELL">
						<%
								if(isEmpty) {
						%>
									&nbsp;
						<%
								}else if(isAnomaly) {
									if(isVisible) {
						%>
									<a href="<%=selectLink %>" <%=selectNodeMmouseActionsString %>><img id="<%=selectNodeImageId %>" src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowSelected.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowSelectedOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowSelected.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
						<%
									}else {
						%>
									<a href="<%=selectLink %>" <%=selectNodeMmouseActionsString %>><img id="<%=selectNodeImageId %>" src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowSelect.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowSelectOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowSelect.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
						<%
									}
						%>
									<a href="<%=zoomInLink %>" style="cursor:default"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowZoomSelected.gif" border="0" style="visibility:hidden" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
						<%
									if(rootIsLog) {
						%>
									<span class="DASHBOARD_PROBLEM_ACTIONS_ARROW"><a id="<%=rowId %>_problemActionsMenuLinkMainTable" href="javascript:openProblemActionsMenu(-180, 0, '<%=rowId %>_problemActionsMenuLinkMainTable', '<%=id %>', '<%=name %>', '<%=type %>', '<%=risk %>', '<%=riskText %>')" onMouseOver="javascript:showTooltip(dashboardTooltips['openPoblemActions'])" onMouseOut="javascript:hideTooltip()" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/problemActionsOpen.gif" border="0"></a></span>
						<%
									}
								}else {
									if(isVisible) {
						%>
									<a href="<%=selectLink %>" <%=selectNodeMmouseActionsString %>><img id="<%=selectNodeImageId %>" src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowSelected.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowSelectedOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowSelected.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
									<a href="<%=zoomInLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowZoomSelected.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowZoomSelectedOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowZoomSelected.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
						<%
									}else {
						%>
									<a href="<%=selectLink %>" <%=selectNodeMmouseActionsString %>><img id="<%=selectNodeImageId %>" src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowSelect.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowSelectOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowSelect.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
									<a href="<%=zoomInLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/tableRowZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/tableRowZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/tableRowZoom.gif')" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"></a>
						<%
									}
									if(rootIsLog) {
						%>
													<span class="DASHBOARD_PROBLEM_ACTIONS_ARROW"><a id="<%=rowId %>_problemActionsMenuLinkMainTable" href="javascript:openProblemActionsMenu(-180, 0, '<%=rowId %>_problemActionsMenuLinkMainTable', '<%=id %>', '<%=name %>', '<%=type %>', '<%=risk %>', '<%=riskText %>')" onMouseOver="javascript:showTooltip(dashboardTooltips['openPoblemActions'])" onMouseOut="javascript:hideTooltip()" class="DASHBOARD_MAIN_TABLE_IMAGE_LINK"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/problemActionsOpen.gif" border="0"></a></span>
						<%
									}
								}
						%>
								</td>
							</tr>
						<%
							}
						}
						%>
						</table>
					</td>
				</tr>
				<%
					}else {
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_GENERAL_CELL DASHBOARD_MAIN_TABLE_HEADER_CELL">No problems were found</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
					}
				}
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_MAIN_TABLE_FOOTER_LEFT_CELL">&nbsp;</td>
								<td class="DASHBOARD_MAIN_TABLE_FOOTER_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											String searchTerm = model.getSearchTerm();
											if(currentPageResultElements.size() > 0 || (searchTerm != null && searchTerm.length() > 0)) {
												String searchTermDisplay = searchTerm;
												if(searchTermDisplay != null && searchTermDisplay.length() > 20) {
													searchTermDisplay = searchTermDisplay.substring(0, 20) + "...";
												}
											%>
											<td class="DASHBOARD_MAIN_TABLE_SEARCH_CELL">
												<a href="javascript:openDashboardSearchDiv()"  onMouseOver="javascript:showTooltip(dashboardTooltips['search'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/search.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/searchOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/search.gif')"></a>
											</td>
											<td id="dashboardSearchTextTd" class="DASHBOARD_MAIN_TABLE_SEARCH_TEXT">
											<%
												if(searchTermDisplay != null && searchTermDisplay.length() > 0) {
											%>
												<a href="javascript:openDashboardSearchDiv()" class="DASHBOARD_MAIN_TABLE_SEARCH_TEXT_LINK">Search</a>&nbsp;(<%=searchTermDisplay %>)&nbsp;|&nbsp;<a href="javascript:clearDashboardSearch()" class="DASHBOARD_MAIN_TABLE_SEARCH_TEXT_LINK_CLEAR">Clear</a>
											<%
												}else {
											%>
												<a href="javascript:openDashboardSearchDiv()" class="DASHBOARD_MAIN_TABLE_SEARCH_TEXT_LINK">Search</a>
											<%
												}
											%>
											</td>
											<%
											}else {
											%>
											<td class="DASHBOARD_MAIN_TABLE_SEARCH_CELL">&nbsp;</td>
											<%
											}
											%>
											<td class="DASHBOARD_MAIN_TABLE_SEARCH_CELL">&nbsp;</td>
											<%
											String pagingString = "";
											if(currentResult.getResultElements().size() > 0) {
												pagingString = currentResult.getMinResultIndex() + " - " + currentResult.getMaxResultIndex() + " of " + currentResult.getResultElements().size();
											}
											%>
											<td class="DASHBOARD_MAIN_TABLE_PAGING_CELL">
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr>
														<td width="100%">&nbsp;</td>
														<td class="DASHBOARD_MAIN_TABLE_PAGING_TEXT"><nobr><%=pagingString %></nobr></td>
														<%
														if(resultElements.size() > model.getResultsPerPage()) {
														%>
														<td class="DASHBOARD_MAIN_TABLE_PAGING_ARROWS_CELL">
														<nobr>
														<%
														if(currentResult.getMinResultIndex() <= 1) {
														%>
															<img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/pagingLeftDisabled.gif" border="0">
														<%
														}else {
														%>
															<a href="javascript:showPrevResults()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/pagingLeft.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/pagingLeftOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/pagingLeft.gif')"></a>
														<%
														}
														%>
														<%
														if(currentResult.getMaxResultIndex() == currentResult.getResultElements().size()) {
														%>
															<img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/pagingRightDisabled.gif" border="0">
														<%
														}else {
														%>
															<a href="javascript:showNextResults()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/pagingRight.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/pagingRightOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/pagingRight.gif')"></a>
														<%
														}
														%>
														</nobr>
														</td>
														<%
														}
														%>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
								<td class="DASHBOARD_MAIN_TABLE_FOOTER_RIGHT_CELL">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="empty">&nbsp;</td>
	</tr>
</table>
</form>