<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.HashSet"%>

<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@ page import="xpolog.eye.computation.MultiComputationResults"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltip"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltipQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";
String STATUS_OK = "0";
String STATUS_ERROR = "1";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
if(model == null) {
	return;
}

String startTimestampStr = request.getParameter("startTimestamp");
long startTimestamp = -1;
if(startTimestampStr != null && startTimestampStr.length() > 0) {
	try {
		startTimestamp = Long.parseLong(startTimestampStr);
	}catch(Exception e) {
	}
}
String endTimestampStr = request.getParameter("endTimestamp");
long endTimestamp = -1;
if(endTimestampStr != null && endTimestampStr.length() > 0) {
	try {
		endTimestamp = Long.parseLong(endTimestampStr);
	}catch(Exception e) {
	}
}
String elementIds = request.getParameter("elementIds");
HashSet elementIdsSet = new HashSet();
if(elementIds != null && elementIds.length() > 0) {
	String[] elementIdsArr = elementIds.split("\\|");
	for(int i = 0; i < elementIdsArr.length; i++) {
		elementIdsSet.add(elementIdsArr[i]);
	}
}
String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
long modelUpdateTime = -1;
if(modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
	try {
		modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
	}catch(Exception e) {
	}
}
String graphTypeStr = request.getParameter("graphType");
int graphType = HealthViewGraphTooltipQuery.GRAPH_TYPE_PROBLEMS;
if(graphTypeStr != null && graphTypeStr.length() > 0) {
	try {
		graphType = Integer.parseInt(graphTypeStr);
	}catch(Exception e) {
	}
}
String url = "problemsGraphTooltip.jsp";
if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_CPU ||
	 graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_MEMORY) {
	url = "metricsGraphTooltip.jsp";
}
String hostMeasurementTypeStr = "";
if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_CPU) {
	hostMeasurementTypeStr = HostCpu.HOST_CPU_TYPE;
}else if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_MEMORY) {
	hostMeasurementTypeStr = HostMemory.HOST_MEMORY_TYPE;
}

HealthViewResult currentResult = model.getCurrentResult();
HealthViewGraphTooltipQuery tooltipQuery = new HealthViewGraphTooltipQuery();
tooltipQuery.setHealthViewResult(currentResult);
tooltipQuery.setStartTimestamp(startTimestamp);
tooltipQuery.setEndTimestamp(endTimestamp);
tooltipQuery.setElementIds(elementIdsSet);
tooltipQuery.setGraphType(graphType);

HealthViewGraphTooltip graphTooltip = HealthViewModelHelper.getGraphTooltip(tooltipQuery);
MultiComputationResults tooltipResults = graphTooltip.getComputationResults();
long rootTotalEvents = graphTooltip.getRootTotalEvents();
int numOfResults = tooltipResults.getMembersCount();

StringBuffer tooltipHeaderDateString = new StringBuffer();
String startDateString = DateUtil.transformDateToString(new Date(startTimestamp));
if(startDateString.indexOf(":") != startDateString.lastIndexOf(":")) {
	startDateString = startDateString.substring(0, startDateString.lastIndexOf(":"));
}
tooltipHeaderDateString.append(startDateString);
tooltipHeaderDateString.append("&nbsp;-&nbsp;");
String endDateString = DateUtil.transformDateToString(new Date(endTimestamp));
if(endDateString.indexOf(":") != endDateString.lastIndexOf(":")) {
	endDateString = endDateString.substring(0, endDateString.lastIndexOf(":"));
}
tooltipHeaderDateString.append(endDateString);

ComputationResults memberResults = null;
double maxMemberRisk = -1, memberResultsRisk;
for(int i = 0; i < numOfResults; i++) {
	memberResults = tooltipResults.getMembersResults()[i];
	if(memberResults instanceof MultiHostComputationResults) {
		memberResultsRisk = ((MultiHostComputationResults)memberResults).getWeightByGroupType(hostMeasurementTypeStr);
	}else {
		memberResultsRisk = memberResults.getMaxWeight();
	}
	if(memberResultsRisk > maxMemberRisk) {
		maxMemberRisk = memberResultsRisk;
	}
}
int riskClassNameSuffix = HealthViewModelHelper.getRiskClassNameSuffix(maxMemberRisk);
if(riskClassNameSuffix == -1) {
	riskClassNameSuffix = 0;
}
String bgSuffix = String.valueOf(riskClassNameSuffix);

request.setAttribute("tooltipResults", tooltipResults);
request.setAttribute("rootTotalEvents", new Long(rootTotalEvents));
request.setAttribute("tooltipHeaderDateString", tooltipHeaderDateString.toString());
request.setAttribute("startDateString", startDateString);
request.setAttribute("endDateString", endDateString);
request.setAttribute("bgSuffix", bgSuffix);

response.setContentType("text/xml; charset=UTF-8");
if(startTimestamp == -1 || endTimestamp == -1 || modelUpdateTime != model.getModelUpdateTime()) {
%>
	
<DashboardGrpahTooltipResponse>
		<Response status="<%=STATUS_ERROR %>">
		
		</Response>
	</DashboardGrpahTooltipResponse>
<%
}else {
	
%>
	<DashboardGrpahTooltipResponse>
		<Response status="<%=STATUS_OK %>" bgSuffix="<%=bgSuffix %>">
			<jsp:include page="<%=url %>" flush="true" >
				<jsp:param name="startTimestamp" value="<%=startTimestamp %>" />
				<jsp:param name="endTimestamp" value="<%=endTimestamp %>" />
				<jsp:param name="elementIds" value="<%=elementIds %>" />
				<jsp:param name="graphType" value="<%=graphType %>" />
				<jsp:param name="isEmbeded" value="true" />
			</jsp:include>
		</Response>
	</DashboardGrpahTooltipResponse>
<%
}
%>