<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltip"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewServerMetricsColumnTooltipQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultElement"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewServerMetricsColumnTooltip"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";
String STATUS_OK = "0";
String STATUS_ERROR = "1";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
if(model == null) {
	return;
}

String type = request.getParameter("type");
String id = request.getParameter("id");
String name = request.getParameter("name");
String startTimestampStr = request.getParameter("startTimestamp");
long startTimestamp = -1;
if(startTimestampStr != null && startTimestampStr.length() > 0) {
	try {
		startTimestamp = Long.parseLong(startTimestampStr);
	}catch(Exception e) {
	}
}
String endTimestampStr = request.getParameter("endTimestamp");
long endTimestamp = -1;
if(endTimestampStr != null && endTimestampStr.length() > 0) {
	try {
		endTimestamp = Long.parseLong(endTimestampStr);
	}catch(Exception e) {
	}
}
		
HealthViewResult currentResult = model.getCurrentResult();
HealthViewServerMetricsColumnTooltipQuery tooltipQuery = new HealthViewServerMetricsColumnTooltipQuery();
List resultElements = currentResult.getResultElements();
HealthViewResultElement resultElement = null;
for(int i = 0; i < resultElements.size(); i++) {
	resultElement = (HealthViewResultElement)resultElements.get(i);
	if(resultElement.getType().equals(type) && resultElement.getId().equals(id)) {
		tooltipQuery.setHealthViewResultElement(resultElement);
		break;
	}
}
tooltipQuery.setType(type);
tooltipQuery.setId(id);
tooltipQuery.setName(name);

String bgSuffix = "";
if(tooltipQuery.getHealthViewResultElement() != null) {
	HealthViewServerMetricsColumnTooltip serverMetricsColumnTooltip = HealthViewModelHelper.getServerMetricsColumnTooltip(tooltipQuery);
	MultiHostComputationResults tooltipResults = serverMetricsColumnTooltip.getMultiHostComputationResults();
	
	StringBuffer tooltipHeaderDateString = new StringBuffer();
	String startDateString = DateUtil.transformDateToString(new Date(startTimestamp));
	if(startDateString.indexOf(":") != startDateString.lastIndexOf(":")) {
		startDateString = startDateString.substring(0, startDateString.lastIndexOf(":"));
	}
	tooltipHeaderDateString.append(startDateString);
	tooltipHeaderDateString.append("&nbsp;-&nbsp;");
	String endDateString = DateUtil.transformDateToString(new Date(endTimestamp));
	if(endDateString.indexOf(":") != endDateString.lastIndexOf(":")) {
		endDateString = endDateString.substring(0, endDateString.lastIndexOf(":"));
	}
	tooltipHeaderDateString.append(endDateString);
	
	double maxMeasurementRisk = -1, measurementRisk;
	measurementRisk = tooltipResults.getWeightByGroupType(HostCpu.HOST_CPU_TYPE);
	if(measurementRisk > maxMeasurementRisk) {
		maxMeasurementRisk = measurementRisk;
	}
	measurementRisk = tooltipResults.getWeightByGroupType(HostMemory.HOST_MEMORY_TYPE);
	if(measurementRisk > maxMeasurementRisk) {
		maxMeasurementRisk = measurementRisk;
	}
	measurementRisk = tooltipResults.getWeightByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
	if(measurementRisk > maxMeasurementRisk) {
		maxMeasurementRisk = measurementRisk;
	}
	int riskClassNameSuffix = HealthViewModelHelper.getRiskClassNameSuffix(maxMeasurementRisk);
	if(riskClassNameSuffix == -1) {
		riskClassNameSuffix = 0;
	}
	bgSuffix = String.valueOf(riskClassNameSuffix);
	
	request.setAttribute("tooltipResults", tooltipResults);
	request.setAttribute("tooltipHeaderDateString", tooltipHeaderDateString.toString());
	request.setAttribute("startDateString", startDateString);
	request.setAttribute("endDateString", endDateString);
	request.setAttribute("bgSuffix", bgSuffix);
}else {
	ErrorModel.log.error("Failed to get server metrics column tooltip for " + type + " " + name + " (" + id + ")");
}

response.setContentType("text/xml; charset=UTF-8");
if(type == null || id == null || name == null || startTimestamp == -1 || endTimestamp == -1 || tooltipQuery.getHealthViewResultElement() == null || tooltipQuery.getHealthViewResultElement() == null) {
%>
	

<%@page import="xpolog.eye.util.DateUtil"%><DashboardGrpahTooltipResponse>
		<Response status="<%=STATUS_ERROR %>">
		
		</Response>
	</DashboardGrpahTooltipResponse>
<%
}else {
	String url = "serverMetricsColumnTooltip.jsp";
%>
	<DashboardGrpahTooltipResponse>
		<Response status="<%=STATUS_OK %>" bgSuffix="<%=bgSuffix %>">
			<jsp:include page="<%=url %>" flush="true" >
				<jsp:param name="startTimestamp" value="<%=startTimestamp %>" />
				<jsp:param name="endTimestamp" value="<%=endTimestamp %>" />
				<jsp:param name="isEmbeded" value="true" />
			</jsp:include>
		</Response>
	</DashboardGrpahTooltipResponse>
<%
}
%>