<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContextFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewNode"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultElement"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultMissingExecutions"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	String HEALTH_VIEW_MODEL = "HealthViewModel";
	String DASHBOARD_SESSION_ACTIVITY = "DashboardSessionActivity";
	String STATUS_OK = "0";
	String STATUS_NO_ACTION = "1";

	WebSecurityManager securityManager = WebSecurityManager.getInstance();

	UserSecurity user = securityManager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

	String resetModelStr = request.getParameter("resetModel");
	boolean resetModel = resetModelStr != null && resetModelStr.equals("true");
	String preserveRunnersStr = request.getParameter("preserveRunners");
	boolean preserveRunners = preserveRunnersStr != null && preserveRunnersStr.equals("true");

	boolean checkMissingExecutions = false;

	HealthViewModel model = (HealthViewModel) session.getAttribute(HEALTH_VIEW_MODEL);
	List runnerIds = null;
	int numOfRunners = 0;
	if (resetModel && model != null) {
		if (preserveRunners) {
			runnerIds = model.getRunnerIds();
		}
		model.dispose();
		model = null;
	}
	if (model == null) {
		model = new HealthViewModel();
		ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
		DateFilter defaultDisplayDateFilter = ComputationConfigurationHelper.getDefaultDisplayDateFilter(model, computationConfiguration);

		model.setTimeFilter(defaultDisplayDateFilter);
		model.setViewBy(computationConfiguration.getViewBy());
		model.setViewType(computationConfiguration.getViewType());
		model.setViewGroupType(computationConfiguration.getViewGroupType());
		model.setViewHierarchyType(computationConfiguration.getViewHierarchyType());
		model.setShowMetrics(computationConfiguration.isShowMetrics());

		if (runnerIds != null) {
			numOfRunners = runnerIds.size();
			for (int i = 0; i < runnerIds.size(); i++) {
				model.addRunnerId((String) runnerIds.get(i));
			}
		}

		session.setAttribute(HEALTH_VIEW_MODEL, model);

		if (numOfRunners == 0) {
			checkMissingExecutions = true;
		}
	}

	String status = STATUS_OK;

	boolean isRunning = model.getRunnerIdsString().length() > 0;
	
	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);

	String action = request.getParameter("action");
	if (action != null) {
		boolean doUpdateModel = false;
		boolean doUpdateCurrentResult = false;
		boolean updateVisibleByGroupType = false;
		boolean isRefresh = false;
		boolean writeAudit = true;
		if (action.equals(HealthViewModel.ACTION_LOAD_DATA)) {
			doUpdateModel = !model.hasLogsResults();
			updateVisibleByGroupType = true;
		} else if (action.equals(HealthViewModel.ACTION_REFRESH_DATA)) {
			doUpdateModel = true;
			updateVisibleByGroupType = true;
			checkMissingExecutions = false;
			isRefresh = true;
			String isDataGenerationLinkStr = request.getParameter("isDataGenerationLink");
			boolean isDataGenerationLink = isDataGenerationLinkStr != null && isDataGenerationLinkStr.equals("true");
			if (isDataGenerationLink) {
				model.setMissingDataReady(false);
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_VIEW_BY)) {
			String viewBy = request.getParameter("viewBy");
			if (viewBy != null && viewBy.length() > 0) {
				model.setViewBy(viewBy);
				doUpdateModel = true;
				updateVisibleByGroupType = true;
			}
		} else if (action.equals(HealthViewModel.ACTION_SET_CURRENT_NODE)) {
			String id = request.getParameter("id");
			if (id != null && id.length() > 0) {
				model.setCurrentNode(id);
				doUpdateCurrentResult = true;
				updateVisibleByGroupType = true;
				checkMissingExecutions = true;
			}
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_IN_CALENDAR)) {
			model.zoomInCalendar();
			doUpdateModel = true;
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_OUT_CALENDAR)) {
			model.zoomOutCalendar();
			doUpdateModel = true;
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_FIXED_INTERVAL)) {
			String fixedInterval = request.getParameter("fixedInterval");
			String roundMinTimeToZeroStr = request.getParameter("roundMinTimeToZero");
			boolean roundMinTimeToZero = roundMinTimeToZeroStr != null && roundMinTimeToZeroStr.equals("true");
			if (fixedInterval != null && fixedInterval.length() > 0) {
				model.setFixedInterval(fixedInterval, roundMinTimeToZero);
				doUpdateModel = true;
				checkMissingExecutions = true;
				model.setMissingDataReady(false);
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_CALENDAR)) {
			String dashboardMinDateStr = request.getParameter("dashboardMinDateStr");
			String dashboardMaxDateStr = request.getParameter("dashboardMaxDateStr");
			String dashboardMinTimeStr = request.getParameter("dashboardMinTimeStr");
			String dashboardMaxTimeStr = request.getParameter("dashboardMaxTimeStr");
			if (dashboardMinDateStr != null && dashboardMinDateStr.length() > 0 && dashboardMaxDateStr != null
					&& dashboardMaxDateStr.length() > 0 && dashboardMinTimeStr != null && dashboardMinTimeStr.length() > 0
					&& dashboardMaxTimeStr != null && dashboardMaxTimeStr.length() > 0) {
				dashboardMinDateStr += (" " + dashboardMinTimeStr);
				dashboardMaxDateStr += (" " + dashboardMaxTimeStr);
				model.updateTimeFilter("MM/dd/yyyy HH:mm", dashboardMinDateStr, dashboardMaxDateStr);
				doUpdateModel = true;
				checkMissingExecutions = true;
				model.setMissingDataReady(false);
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_VIEW_TYPE)) {
			String viewType = request.getParameter("viewType");
			if (viewType != null && viewType.length() > 0) {
				model.setViewType(viewType);
				writeAudit = false;
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_VIEW_GROUP_TYPE)) {
			String viewGroupType = request.getParameter("viewGroupType");
			if (viewGroupType != null && viewGroupType.length() > 0) {
				model.setViewGroupType(viewGroupType);
				doUpdateCurrentResult = true;
				writeAudit = false;
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_SHOW_METRICS)) {
			String showMetricsStr = request.getParameter("showMetrics");
			boolean showMetrics = showMetricsStr != null && showMetricsStr.equals("true");
			model.setShowMetrics(showMetrics);
			doUpdateCurrentResult = true;
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_IN_GRAPH)) {
			String startTimestampStr = request.getParameter("startTimestamp");
			String endTimestampStr = request.getParameter("endTimestamp");
			String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
			if (startTimestampStr != null && startTimestampStr.length() > 0 && endTimestampStr != null && endTimestampStr.length() > 0
					&& modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
				try {
					long modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
					if (modelUpdateTime == model.getModelUpdateTime()) {
						model.zoomInGraph(startTimestampStr, endTimestampStr);
						doUpdateModel = true;
					}
				} catch (Exception e) {
				}
			}
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_OUT_GRAPH)) {
			model.zoomOutGraph();
			doUpdateModel = true;
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_PREVIOUS_GRAPH_TIME)) {
			String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
			if (modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
				try {
					long modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
					if (modelUpdateTime == model.getModelUpdateTime()) {
						model.previousGraphTime();
						doUpdateModel = true;
						checkMissingExecutions = true;
						model.setMissingDataReady(false);
					}
				} catch (Exception e) {
				}
			}
		} else if (action.equals(HealthViewModel.ACTION_NEXT_GRAPH_TIME)) {
			String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
			if (modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
				try {
					long modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
					if (modelUpdateTime == model.getModelUpdateTime()) {
						model.nextGraphTime();
						doUpdateModel = true;
						checkMissingExecutions = true;
						model.setMissingDataReady(false);
					}
				} catch (Exception e) {
				}
			}
		} else if (action.equals(HealthViewModel.ACTION_CHANGE_VIEW_HIERARCHY_TYPE)) {
			String viewHierarchyType = request.getParameter("viewHierarchyType");
			if (viewHierarchyType != null && viewHierarchyType.length() > 0) {
				model.setViewHierarchyType(viewHierarchyType);
				doUpdateCurrentResult = true;
				updateVisibleByGroupType = true;
			}
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_SELECT_MAIN_TABLE_NODE)) {
			String id = request.getParameter("id");
			String type = request.getParameter("type");
			if (id != null && id.length() > 0 && type != null && type.length() > 0) {
				model.addSelectedNode(id, type);
				if (model.getViewGroupType().equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY)) {
					model.setViewGroupType(HealthViewContext.VIEW_GROUP_TYPE_SPLIT, false);
				}
				doUpdateCurrentResult = model.isShowMetrics();
			}
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_UNSELECT_MAIN_TABLE_NODE)) {
			String id = request.getParameter("id");
			String type = request.getParameter("type");
			if (id != null && id.length() > 0 && type != null && type.length() > 0) {
				model.removeSelectedNode(id, type);
				if (model.getNumberOfVisibleNodes() == 0) {
					model.setViewGroupType(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY, false);
				}
				doUpdateCurrentResult = model.isShowMetrics();
			}
			writeAudit = false;
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_INTO_ELEMENT)) {
			String id = request.getParameter("id");
			String name = request.getParameter("name");
			String type = request.getParameter("type");
			
			if (id != null && id.length() > 0 && name != null && name.length() > 0 && type != null && type.length() > 0) {
				HealthViewNode newNode = new HealthViewNode(id, name, type);
				model.addNode(newNode);
				doUpdateModel = true;
				updateVisibleByGroupType = true;
				String startTimestampStr = request.getParameter("startTimestamp");
				String endTimestampStr = request.getParameter("endTimestamp");
				String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
				if (startTimestampStr != null && startTimestampStr.length() > 0 && endTimestampStr != null && endTimestampStr.length() > 0
						&& modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
					try {
						long modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
						if (modelUpdateTime == model.getModelUpdateTime()) {
							model.zoomInGraph(startTimestampStr, endTimestampStr);
							doUpdateModel = true;
						}
					} catch (Exception e) {
					}
				}
				HealthViewNode rootNode = model.getCurrentResult().getRootNode();
				if(rootNode != null && rootNode.getType().equals(XpoLogObjectTypes.HOST_TYPE)) {
					if(model.getCurrentResult().getResultElements() == null || model.getCurrentResult().getResultElements().isEmpty()) {
						writeAudit = false;
					}
				}
			}
		} else if (action.equals(HealthViewModel.ACTION_ZOOM_OUT_OF_ELEMENT)) {
			model.removeLastNode();
			doUpdateCurrentResult = true;
			updateVisibleByGroupType = true;
			checkMissingExecutions = true;
		} else if (action.equals(HealthViewModel.ACTION_SEARCH)) {
			String searchTerm = request.getParameter("searchTerm");
			if (searchTerm != null && searchTerm.length() > 0) {
				model.setSearchTerm(searchTerm);
				doUpdateModel = true;
				updateVisibleByGroupType = true;
				AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
						userContext, AuditConstants.VIEW, "search " + analytics + " results", AuditConstants.DASHBOARD, "search for " + searchTerm);
			} else {
				model.setSearchTerm(null);
				doUpdateModel = true;
				updateVisibleByGroupType = true;
			}
		} else if (action.equals(HealthViewModel.ACTION_SHOW_PREV_RESULTS)) {
			model.decreaseCurrentResultsPage();
			doUpdateCurrentResult = true;
			updateVisibleByGroupType = true;
			HealthViewNode rootNode = model.getCurrentResult().getRootNode();
			if(rootNode != null && rootNode.getType().equals(XpoLogObjectTypes.LOG_TYPE)) {
				writeAudit = false;
			}
		} else if (action.equals(HealthViewModel.ACTION_SHOW_NEXT_RESULTS)) {
			model.increaseCurrentResultsPage();
			doUpdateCurrentResult = true;
			updateVisibleByGroupType = true;
			HealthViewNode rootNode = model.getCurrentResult().getRootNode();
			if(rootNode != null && rootNode.getType().equals(XpoLogObjectTypes.LOG_TYPE)) {
				writeAudit = false;
			}
		} else if (action.equals(HealthViewModel.ACTION_ACTIVATE_FILTER_BY)) {
			String filterBy = request.getParameter("filterBy");
			if(filterBy != null && filterBy.length() > 0) {
				model.setViewBy(filterBy);
			}
			HealthViewContextFilter contextFilter = HealthViewHelper.getHealthViewContextFilter(request, userContext, filterBy);
			model.setContextFilter(contextFilter);
			
			doUpdateModel = true;
			updateVisibleByGroupType = true;
		} else if (action.equals(HealthViewModel.ACTION_CLEAR_FILTER_BY)) {
			model.getContextFilter().reset();
			doUpdateModel = true;
			updateVisibleByGroupType = true;
		}

		String ignoreMissingExecutionsStr = request.getParameter("ignoreMissingExecutions");
		boolean ignoreMissingExecutions = ignoreMissingExecutionsStr != null && ignoreMissingExecutionsStr.equals("true");
		boolean isPermittedGenerateDashboard = securityManager.isHavePermission(userContext,
				ActionsPermissionConstants.DashboardPermissions.DASHBOARD_GENERATE_PERMISSION);
		ignoreMissingExecutions = ignoreMissingExecutions || !isPermittedGenerateDashboard;
		boolean modelCheckMissingExecutions = model.isCheckMissingExecutions();
		if (ignoreMissingExecutions || isRunning) {
			model.setCheckMissingExecutions(false);
			checkMissingExecutions = false;
		}

		if (doUpdateModel || model.isNeedToUpdateModel()) {
			model.updateModel(action, userContext, null, updateVisibleByGroupType, isRefresh);
		} else if (doUpdateCurrentResult) {
			model.updateCurrentResult(action, userContext, updateVisibleByGroupType);
		}

		if (ignoreMissingExecutions) {
			model.setCheckMissingExecutions(modelCheckMissingExecutions);
		}
		
		if(writeAudit) {
			String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
			SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
			String minDateStr = sdf.format(model.getTimeFilter().getMinDate());
			String maxDateStr = sdf.format(model.getTimeFilter().getMaxDate());
			String datesString = minDateStr + "-" + maxDateStr;
			HealthViewNode rootNode = model.getCurrentResult().getRootNode();
			StringBuffer auditMessage = new StringBuffer();
			if(rootNode != null && rootNode.getType().equals(XpoLogObjectTypes.LOG_TYPE)) {
				auditMessage.append(", log is " + rootNode.getName() + " (" + rootNode.getId() + ")");
			}else {
				auditMessage.append(", result elements are ");
				List resultElements = model.getCurrentResult().getCurrentPageResultElements();
				if(resultElements.size() == 0) {
					auditMessage.append("empty");
				}else {
					HealthViewResultElement resultElement = null;
					for(int i = 0; i < resultElements.size(); i++) {
						if(i > 0) {
							auditMessage.append(", ");
						}
						resultElement = (HealthViewResultElement)resultElements.get(i);
						auditMessage.append(resultElement.getType());
						auditMessage.append(" ");
						auditMessage.append(resultElement.getName());
						auditMessage.append(" (");
						auditMessage.append(resultElement.getId());
						auditMessage.append(")");
					}
				}
			}
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					userContext, AuditConstants.VIEW, "update " + analytics + " model", AuditConstants.DASHBOARD, analytics + " model was updated, action is " + action + ", dates range is " + datesString + auditMessage.toString());
			
		}
	} else {
		status = STATUS_NO_ACTION;
	}

	//mark session activity
	boolean checkSessionActivity = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean(
			"dashboard.UI.checkSessionActivity", true);
	checkSessionActivity = checkSessionActivity && ComputationConfiguration.getInstance().isDataGenerationEnabled();
	String fixedInterval = model.getFixedInterval();
	checkSessionActivity = checkSessionActivity && !fixedInterval.equals("custom");
	if (checkSessionActivity) {
		session.setAttribute(DASHBOARD_SESSION_ACTIVITY, String.valueOf(System.currentTimeMillis()));
	}
	model.setLastUserActionTimestamp(System.currentTimeMillis());

	String divIds = request.getParameter("divIds");
	if (divIds == null) {
		divIds = "";
	}

	boolean displayTopMessagesDiv = model.getLogNode() == null;
	if (displayTopMessagesDiv) {
		if (model.getCurrentResult().getRootNode().getType().equals(XpoLogObjectTypes.HOST_TYPE)
				&& model.getCurrentResult().getCurrentPageResultElements().size() == 0) {
			displayTopMessagesDiv = false;
		}
	}

	int numberOfMissingExecutions = 0;
	String missingExecutionsLogIds = "";
	String errorLogIds = "";
	String missingExecutionsHostIds = "";
	String errorHostIds = "";
	String missingDataUserPolicy = "";

	if (checkMissingExecutions) {
		HealthViewResult currentResult = model.getCurrentResult();
		HealthViewResultMissingExecutions missingExecutions = currentResult.getMissingLogsExecutions();
		if (missingExecutions != null && missingExecutions.hasMissingExecutions()) {
			List missingExecutionsList = HealthViewHelper.getMissingExecutions(model, missingExecutions);			
			if (missingExecutionsList.size() > 0) {
				numberOfMissingExecutions += missingExecutionsList.size();
				String logId;
				for (int i = 0; i < missingExecutionsList.size(); i++) {
					logId = (String) missingExecutionsList.get(i);
					missingExecutionsLogIds += (XpoLogObjectTypes.LOG_TYPE + "-" + logId);
					missingExecutionsLogIds += ",";
				}
			}
			List errorLogsList = missingExecutions.getErrorExecutions();
			if (errorLogsList != null && errorLogsList.size() > 0) {
				String logId;
				for (int i = 0; i < errorLogsList.size(); i++) {
					logId = (String) errorLogsList.get(i);
					errorLogIds += (XpoLogObjectTypes.LOG_TYPE + "-" + logId);
					errorLogIds += ",";
				}
			}
		}

		missingExecutions = currentResult.getMissingHostsExecutions();
		if (missingExecutions != null && missingExecutions.hasMissingExecutions()) {
			List missingExecutionsList = HealthViewHelper.getMissingExecutions(model, missingExecutions);			
			if (missingExecutionsList.size() > 0) {
				numberOfMissingExecutions += missingExecutionsList.size();
				String host;
				for (int i = 0; i < missingExecutionsList.size(); i++) {
					host = (String) missingExecutionsList.get(i);
					missingExecutionsHostIds += (host);
					missingExecutionsHostIds += ",";
				}
			}
			List errorLogsList = missingExecutions.getErrorExecutions();
			if (errorLogsList != null && errorLogsList.size() > 0) {
				String host;
				for (int i = 0; i < errorLogsList.size(); i++) {
					host = (String) errorLogsList.get(i);
					errorHostIds += (host);
					errorHostIds += ",";
				}
			}
			//System.out.println("###############################################################################");
			//System.out.println("jsp: numberOfMissingExecutions=" + numberOfMissingExecutions + ", logIds=" + missingExecutionsLogIds);
		}
		
		missingDataUserPolicy = ComputationConfiguration.getInstance().getMissingDataUserPolicy();
	}

	boolean showMetrics = model.isShowMetrics();
	showMetrics = showMetrics && model.getCurrentResult().getRootHostResultElement() != null;

	response.setContentType("text/xml; charset=UTF-8");
%>

<DashboardViewResponse>
	<Response status="<%=status %>" divIds="<%=divIds %>" displayTopMessagesDiv="<%=displayTopMessagesDiv %>" viewBy="<%=model.getViewBy() %>" rootNodeId="<%=model.getCurrentNode().getId() %>" rootNodeType="<%=model.getCurrentNode().getType() %>" numberOfMissingExecutions="<%=numberOfMissingExecutions %>" missingDataUserPolicy="<%=missingDataUserPolicy %>" missingExecutionsLogIds="<%=missingExecutionsLogIds %>" errorLogIds="<%=errorLogIds %>" missingExecutionsHostIds="<%=missingExecutionsHostIds %>" errorHostIds="<%=errorHostIds %>" isRunning="<%=isRunning %>" isMissingDataReady="<%=model.isMissingDataReady() %>" checkSessionActivity="<%=checkSessionActivity %>" fixedInterval="<%=fixedInterval %>" showMetrics="<%=String.valueOf(showMetrics) %>" preserveRunners="<%=preserveRunners %>" numOfRunners="<%=numOfRunners %>">
	</Response>
</DashboardViewResponse>