<%@ page language="java"%>

<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.site.problem.ProblemViewQuery"%>
<%@ page import="xpolog.eye.site.problem.ProblemViewModel"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>


<%@ include file="../tools/sandf/dateFilterAction.jsp"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
  String DIAGNOSTICS_MODEL = "diagnosticsModel";
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();

  final ProblemViewModel model = new ProblemViewModel();
  final ProblemViewQuery query = new ProblemViewQuery();
  
  RecordMask mask = new RecordMask();
  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
  MaskColumn[] cols = {dateMask};
  mask.setColumns(cols);
  //create the date and number filter
  try {
  	DateFilter dfilter = createDateFilter(request,response,mask);
  	if(dfilter != null) {  		
  		query.setTimeFilter(dfilter);
  	}
  }catch(Exception e) {	
	 errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
	 request.getSession().setAttribute(ERROR_OBJ,errmodel);
	 response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=diagnostics/diagnostics.jsp&okURL=diagnostics/diagnostics.jsp");
	 return;
  }
  WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
	}
	UserSecurity user = securityManager.getUserSecurity(request);
	List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
	boolean dashboardEnabled = false;
	for(int i=0;i<comps.size();i++) {
	  ApplicationComponent comp = (ApplicationComponent)comps.get(i);
	  if(comp != null && comp.getName().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
			dashboardEnabled = true;
	  }
	}
  
  //search terms issues
  List searchList = null;
  String searchVals = request.getParameter("searchTerms");
  if(searchVals != null && searchVals.trim().length() > 0) {
	  searchList = new ArrayList();
	  String[] arr = searchVals.split(",");
	  for(int i=0;i<arr.length;i++) {
		  searchList.add(arr[i]);
	  }	  
	  query.setSearchList(searchList);
  }else {	  
  	  query.setSearchList(new ArrayList());
  }
  
  //logs issues
  HashSet members = new HashSet();
	String[] logValues = null; //request.getParameterValues("logs");
 	String logsList = request.getParameter("logs");
 	if (logsList != null && logsList.length() > 0){
 		logValues = logsList.split(",");
 	}
	String l;
	int index;
	if (logValues != null) {
		for (int i = 0; i < logValues.length; i++) {
			l = ModuleMemberRenderer.getIdFromUniqueId(logValues[i]);
			l = XpologUtil.removeAppFromId(l);
			members.add(XpoLogObjectTypes.LOG_TYPE + "-" + l);
		} 
  }
  
  //modules
  HashMap modules = new HashMap();
  HashMap logs = new HashMap();
  String [] modsArr = null;
 	String modsList = request.getParameter("mods");
 	if (modsList != null && modsList.length() > 0){
 		modsArr = modsList.split(",");
 	}
 	String m = null;
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	if (!modsArr[i].endsWith("*")){
    		m = ModuleMemberRenderer.getIdFromUniqueId(modsArr[i]);
    		m = XpologUtil.removeAppFromId(m);
      	modules.put(m,m);
    	}
    }
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	String id = modsArr[i];
    	if (modsArr[i].endsWith("*")){
    		id = id.substring(0,id.length()-1);
    		id = ModuleMemberRenderer.getIdFromUniqueId(id);
    		id = XpologUtil.removeAppFromId(id);
    		modules.put(id,id);
    		ModuleMemberRenderer.addAllModuleChildren(id,modules,logs);
    	}
    }
  }
  Iterator it = logs.keySet().iterator();
  while (it.hasNext()){
  	String logid = (String)it.next();
  	members.add(XpoLogObjectTypes.LOG_TYPE + "-" + logid);
  }
  it = modules.keySet().iterator();
  while (it.hasNext()){
  	String modid = (String)it.next();
  	members.add(XpoLogObjectTypes.MODULE_TYPE + "-" + modid);
  }
  query.setModuleMembers(members);
  
  
  //apps issues
  HashSet appmembers = new HashSet();
	String[] appValues = null;//request.getParameterValues("Application");
 	String appsList = request.getParameter("Application");
 	if (appsList != null && appsList.length() > 0){
 		appValues = appsList.split(",");
 	}
	String a;
	if (appValues != null) {
		for (int i = 0; i < appValues.length; i++) {
			a = ModuleMemberRenderer.getIdFromUniqueId(appValues[i]);	
    	index = a.indexOf("-");
    	if (index == -1 || index == a.length()-1){
    		continue;
    	}		    		    	
    	appmembers.add(a);
		}	    		  	    
  }
  query.setApplications(appmembers);
	  
  HashSet types = new HashSet();
  if(dashboardEnabled){
  	types.add(ProblemViewModel.SYSTEM_HEALTH_TYPE);
  }
  types.add(ProblemViewModel.REPORTS_TYPE);
  types.add(ProblemViewModel.LOGS_TYPE);
  query.setTypes(types);
  model.setQuery(query);
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  final UserContext context = env.getUserContext();
  context.setDateFilter(null);
  request.getSession().setAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE,model);
  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, model.getStatus()); 

  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "diagnostics/diagnosticsResult.jsp") {
    public void run(HttpServletRequest request){
      try {
    	Thread.sleep(500);
      	model.generateResults();
      	context.setDateFilter(query.getTimeFilter());
     }catch (Exception e){
  	   ErrorModel.log.error("Failed to ugenerate reports", e);
       e.printStackTrace();
     }
    }
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
   <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
   <jsp:param name="message" value="Processing"/>
   <jsp:param name="useStatus" value="true"/>
  </jsp:include>

