<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.site.problem.*"%>
<%@ page import="xpolog.eye.site.problem.results.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>

<%!static final String BASE_DIRECTORY = "../";%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  SiteManagment mgmt = SiteManagment.getInstance();

  String [] LogsToMerge = request.getParameterValues("logs");
  //page data
  MergedLogBrowserManager lbm = null;

  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(LogsToMerge == null || LogsToMerge.length < 2) {
  	errmodel.addError("You must select at least two logs for a merge.");
  }
  
  ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);
	
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=diagnostics/diagnosticsResult.jsp");
    return;

  }

	MergedLogBrowserBuilder builder = new MergedLogBrowserBuilder();
	
	builder.setName("Diagnostics Merge Logs");
	builder.setLogDescription("");
	builder.setTimeZoneId(DataBrowsingInfo.DEFAULT);
	
	builder.setLogsToMergeIds(LogsToMerge);
	try {
		builder.updateBuilder();
	} catch (XpologBuilderException e) {
		e.printStackTrace();
	}
	lbm = builder.getMergeLogBrowser();
	BuildersColumnsInfo info = builder.initAutomaticMergeRecordMask();
	lbm.setRecordMask(info.getRecordMask());
	MergeIndexing indexing = MergeAdminHelper.getMergeIndexing(lbm);
	int size = info.getMergeIndexing().getDescriptorCount();
	MergeDescriptor[] mds = new MergeDescriptor[size];
	for (int i = 0; i < mds.length; i++) {
		mds[i] = info.getMergeIndexing().getDescriptorAt(i);
	}
	
    indexing.setDescriptors(mds);
	//create merge customization manager
    MergeCustomizationManager mcm = builder.initCustomizationManager(info.getRecordMask());
    lbm.setCustomizationManager(mcm);
    
    DefaultColorConfig defc = Configuration.getInstance().getDefColorMgr();
	String[] mc = defc.getDefMergeBgColors();
	String[] logIds = lbm.getLogBrowsersIds();
	int number = mc.length <= logIds.length ? mc.length : logIds.length; 
	for (int i = 0; i < number ; i++) {
		mcm.setLogColor(logIds[i],mc[i]);
	}
	lbm.updateLegend();
    
  LogBrowsingManager oldLbm = (LogBrowsingManager)request.getAttribute(CURRENT_LOG);
  if (oldLbm != null){
  	oldLbm.dispose();
  }
   
  lbm.setTemporary(true);
  
  ProblemViewQuery query = model == null ? null : model.getQuery();
  if (query != null){
  	FilterCollection col = ProblemViewHelper.getFilterForLog(query,lbm);
  	if (col != null){
 	 	 lbm.getFilterManager().addFilterCollection(col);
 	 }
  }
  
  
  request.getSession().setAttribute("logid",lbm.getId());    
	request.getSession().setAttribute(CURRENT_LOG,lbm);	
  response.sendRedirect(BASE_DIRECTORY + "/loggers/logview.jsp?calls=-1&timetamp=" + System.currentTimeMillis());
%>


