function displayContent() {
	if(!xpologGadget) {
		return;
	}
	
	var prefs = new _IG_Prefs();
	handleTitle(prefs);
	
	var zoomInDiv = document.getElementById("zoom_in_div");
	var zoomInDivHeight;
	if(zoomInDiv) {
		zoomInDivHeight = $("#zoom_in_div").height();
	}
	
	var contentDivId = "content_div";
	showGadgetLoadingDiv(contentDivId);
	
	var page = xpologGadget.baseUrl + xpologGadget.url;
	var params = "baseDirectory=" + xpologGadget.baseUrl;
 
	if(xpologGadget.prefsNames) {
		var keys = xpologGadget.prefsNames.split("|");
		for(var i = 0; i < keys.length;i++) {
			var val = prefs.getString(keys[i]);
			if(val) {
				params += "&" + keys[i] + "=" + encode(prefs.getString(keys[i]));
			}
		}
	}
	params += ("&ajaxTimestamp=" + new Date().getTime());
	
	var h = $("#content_div").height();
	var w = $("#content_div").width();
	if(xpologGadget.graphHeight && h < xpologGadget.graphHeight) {
		h = xpologGadget.graphHeight;
	}
	if(h && w) {
		params += ("&windowWidth=" + w);
		params += ("&windowHeight=" + h);
	}
	 
	params += ("&gadgetType=" + xpologGadget.gadgetType);
	
	if(xpologGadget.forceDataGeneration) {
		params += ("&forceDataGeneration=" + xpologGadget.forceDataGeneration);
	}
	
	sendAjaxRequest(page, function(req){
		if(req.responseXML) {
			var xmldoc = req.responseXML.documentElement;
			if(xmldoc) {
				var responseHeaderElement = xmldoc.getElementsByTagName("GadgetResponseHeader")[0];
				var responseGeneralLinkElement = xmldoc.getElementsByTagName("GadgetResponseGeneralLink")[0];
		    	var responseDataElement = xmldoc.getElementsByTagName("GadgetResponseData")[0];
		    	if(responseHeaderElement && responseDataElement) {
		    		var responseType = responseHeaderElement.getAttribute("responseType");
		    		var resultTime = responseHeaderElement.getAttribute("resultTime");
		    		var gadgetId = responseHeaderElement.getAttribute("gadgetId");
		    		if(responseType) {
		    			if(resultTime) {
		    				handleTitle(prefs, resultTime, gadgetId);
		    			}
			    		if(responseType == "table" || responseType == "events") {
				    		var responseContent = getXMLElementValue(responseDataElement);
				    		if(responseContent) {
				    			var contentDiv = document.getElementById(contentDivId);
				    			if(contentDiv) {
				    				handleInnerHTMLJQuery(contentDivId, responseContent);
				    				
			    					if(responseType == "table") {
			    						$("#widgetTable").tablesorter({widgets: ['zebra'], cancelSelection: false}).tablesorterPager({container: $("#widgetTablePager"), postRenderTableFunction: handleHeight});
			    					}else if(responseType == "events") {
			    						$("#widgetTable").tablesorter().tablesorterPager({container: $("#widgetTablePager"), borderBottom: "true", postRenderTableFunction: handleHeight});
			    					}
				    				
			    					handleGeneralLink(responseGeneralLinkElement);
			    					
				    				handleHeight();
				    			}
				    		}
			    		}else if(responseType == "chart") {
			    			var xpologChartElement = responseDataElement.getElementsByTagName("XpoLogChart")[0];
					    	if(xpologChartElement) {
					    		var divId = contentDivId;
					    		var chartType = xpologChartElement.getAttribute("chartType");
						    	var chartXml = getXMLElementValue(xpologChartElement);
						    	var chart = new FusionCharts(xpologGadget.baseUrl + "widgets/charts/swf/" + getChartType(chartType) + ".swf", "graph", w, h, "0");
						    	chart.setTransparent(true);
								chart.setDataXML(chartXml);
								chart.render(divId);
								
								handleGeneralLink(responseGeneralLinkElement);
								var div = document.getElementById(divId);
					    		if(div) {
									var divHeight = h;
									if(!zoomInDiv) {
										zoomInDiv = document.getElementById("zoom_in_div");
										if(zoomInDiv) {
											zoomInDivHeight = $("#zoom_in_div").height();
										}
									}
									if(zoomInDiv) {
										divHeight = parseInt(divHeight) + zoomInDivHeight;
									}
									// set the height of the div so handleHeight() will work
					    			//div.style.height = (divHeight + "px");
					    		}
								
								handleHeight(divHeight);
					    	}
			    		}else if(responseType == "htmlResult") {
			    			var contentDiv = document.getElementById(contentDivId);
			    			if(contentDiv) {
			    				var responseContent = getXMLElementValue(responseDataElement);
					    		if(responseContent) {
					    			var contentDiv = document.getElementById(contentDivId);
					    			var htmlContent = document.createElement("iframe");
					    			if(contentDiv && htmlContent) {
					    				sendAjaxRequest(responseContent, function(req1){
					    					var responseText = req1.responseText;
					    					htmlContent.src = responseText;
					    					
					    					handleInnerHTMLJQuery(contentDivId, htmlContent);
					    					
						    				handleHeight();
					    				});
					    			}
					    		}
			    			}
			    		}else if(responseType == "empty") {
			    			var contentDiv = document.getElementById(contentDivId);
			    			if(contentDiv) {
			    				var responseContent = getXMLElementValue(responseDataElement);
					    		if(responseContent) {
				    				handleInnerHTMLJQuery(contentDivId, responseContent);
				    				
				    				handleGeneralLink(responseGeneralLinkElement);
				    				
				    				handleHeight();
					    		}
			    			}
			    		}
		    		}
		    	}
		    }
		}
	}, "POST", params);
}

function handleGeneralLink(responseGeneralLinkElement) {
	if(responseGeneralLinkElement) {
		var generalLinkContent = getXMLElementValue(responseGeneralLinkElement);
		if(generalLinkContent && generalLinkContent != '') {
			var zoomInDiv = document.getElementById("zoom_in_div");
			var exists = true;
			if(!zoomInDiv) {
				zoomInDiv = document.createElement("div");
				exists = false;
			}
			if(zoomInDiv) {
				zoomInDiv.id = "zoom_in_div";
				zoomInDiv.className = "WIDGETS_PORTAL_GADGET_GENERAL_ZOOM_IN_DIV";
				
				var contentDiv = document.getElementById("content_div");
				if(contentDiv) {
					if(!exists) {
						contentDiv.appendChild(zoomInDiv);
					}
					handleInnerHTMLJQuery("zoom_in_div", generalLinkContent);
				}
			}
		}
	}
}
 
function handleTitle(prefs, resultTime, gadgetId) {
	if(xpologGadget.prefsNames) {
		var title = prefs.getString("xplg_title");
		if(title) {
			var maxTitleLength = 40;
			if(title.length > maxTitleLength) {
				title = title.substr(0, maxTitleLength);
				title += "...";
			}
			title = title.replace(/&/g, '&amp;').replace(/</g, '&lt;');
			if(resultTime && gadgetId) {
				title += ("&nbsp;&nbsp;&nbsp;&nbsp;<span id=\"" + gadgetId + "-title-last-refreshed\" class=\"gadgets-gadget-title-last-refreshed\">Last refreshed at " + resultTime + "</span>");
			}
			if(IS_LOCAL && IS_LOCAL == "true") {
				title = "xplg_html:" + title;
			}
			gadgets.window.setTitle(title);
		}
	}
}

function handleHeight(divHeight) {
	var contentDivHeight = $("#content_div").height();
	if(contentDivHeight < 20) {
		contentDivHeight = 20;
	}
	if(divHeight) {
		contentDivHeight = divHeight;
	}
	gadgets.window.adjustHeight(contentDivHeight);
}

function showGadgetLoadingDiv(divId) {
	var divId = "content_div";
	var div = document.getElementById(divId);
	if(div) {
		var loadingDivText = getGadgetLoadingDivText(divId);
		handleInnerHTMLJQuery(divId, loadingDivText);
		handleHeight();
	}
}

function getGadgetLoadingDivText(divId) {
	return "<div id='loading" + divId + "' class='WIDGETS_PORTAL_GADGET_LOADING_DIV'><img src='" + xpologGadget.baseUrl + "images/widgets/dashboard/gadget/loadingAnimation.gif' border='0' />&nbsp;Loading...</div>";
}

function getChartType(xplg_graphType){
	if(xplg_graphType == 'pie') {
		return "Pie2D";
	}else if(xplg_graphType == 'zoomLine') {
		return "ZoomLine";
	}else {
		return "MSCombi2D";
	}
}

function doRefreshGadget(forceDataGeneration) {
	if(forceDataGeneration) {
		xpologGadget.forceDataGeneration = forceDataGeneration;
	}else {
		xpologGadget.forceDataGeneration = null;
	}
	displayContent();
}

/*function FC_Rendered(DOMId){
	// call handleHeight after a graph is rendered
	handleHeight();
}*/

function openLogFromGadget(baseDirectory, lbmId, filterIds, newWindow, obj, hideDashboardButton, dataReference, searchMinDateFullStr, searchMaxDateFullStr) {
	openLogFromGadget0(baseDirectory, lbmId, filterIds, searchMinDateFullStr, searchMaxDateFullStr, newWindow, obj, hideDashboardButton, dataReference);
}

function openLogFromGadget0(baseDirectory, lbmId, filterIds, startTime, endTime, newWindow, obj, hideDashboardButton, dataReference) {
	var y = -1;
	if (obj){
		y = findPosY(obj);
		if (y <= 0){
			y = -1;
		}else {
			y = y - 60;
		}
	}
	
	var ind = lbmId.indexOf("@");
	if (ind != -1){
		lbmId = lbmId.substring(ind + 1, lbmId.length);
	}

	var msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
	msgWriter.setYParent(document.getElementById("mygrid"),50);
	msgWriter.width = 200;
	msgWriter.height = 60;
	msgWriter.setPosition(-1,y);
	msgWriter.showMessage("Loading Log...");     
	
	var filterName = "gadget filter";
	
	var opdirect = "ZOOM_IN_WITH_FILTER";
	if(!dataReference || dataReference == '') {
		opdirect = "START";
	}

	var params = "lbmId=" + encode(lbmId) + "&filterIds=" + filterIds + "&filterName=" + filterName + "&startTimeFullStr=" +encode(startTime) + "&endTimeFullStr=" + encode(endTime) + "&hideDashboardButton=" + hideDashboardButton + "&opdirect=" + opdirect + "&zoomInKey=" + dataReference;
	var page = baseDirectory + "gadgets/custom/showLogByGadget.jsp";
	sendAjaxRequest(page,function(req){
		hideLayer('mygridShowLogMessage');
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
			var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
			var message = xmldoc.getElementsByTagName('message')[0].text;
			if (result == "true"){			  
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	
				openShowLogWindow(baseDirectory + message,true,baseDirectory,y);        						              
			}else if (xmldoc.getElementsByTagName('message')[0].firstChild){
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
				msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
				msgWriter.addAction("OK","javascript:hideLayer('mygridShowLogMessage')");    	  	
				msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
				msgWriter.setPosition(-1,y);
				msgWriter.showMessage(message);	                
			}
		}
	},'POST',params,true);
}


function openShowLogWindow(url,showMessage,baseDirectory,y){
	var winW = 1280, winH = 1024;
	var size = getWidthAndHeight();
	if (size && size.length == 2){
		winW = size[0];
		winH = size[1];
	}
	
	var windowName = isChrome() ? "" : "_new";
	newWindow = window.open(url,windowName,"height="+winH+",width="+winW+",resizable=yes,scrollbars=yes,status=yes,left=20,top=20");
	
	if(showMessage) {
		PopupWarning.init(baseDirectory);
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
	
}

function popupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_running()) {
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
}

function afterPopupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_blocked() && showMessage) {
		var message = "Pop-up blocked. To see this pop-up click Continue.";
		msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
		msgWriter.addAction("Continue","javascript:openShowLogWindowContinue('" + url + "','" + baseDirectory + "'," + y + ")");
		msgWriter.addAction("Close","javascript:hideLayer('mygridShowLogMessage')");
		msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
		msgWriter.setPosition(-1,y);
		msgWriter.showMessage(message);
	}else {
		newWindow.focus();
	}
}

function openShowLogWindowContinue(url,baseDirectory,y){
	hideLayer('mygridShowLogMessage');
	openShowLogWindow(url,false,baseDirectory,y);
}