<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,null,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isSecurity = userContext != null && userContext.getUser() != null;

boolean addLog = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
boolean editLog = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION);
boolean addModule = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
boolean editModule = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_MODULE_PERMISSION);

final boolean SHOW_COPY_ID_MENU_ITEM = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("ui.admin.folderAndLogs.showCopyIdMenuItem",false);
final boolean ALLOW_EMBEDED_FLASH = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("snapshot.allowEmbededFlash",true);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>


<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="useTree" value="true" />
</jsp:include>
<%
boolean showMenu = addLog || editLog || addModule || editModule;
if(showMenu) {
	String menuIds = "addLog,addFolder,editFolder,editLog,duplicateLog,removeFolder,removeLog";
	String menuTexts = "Add Log,Add Folder,Edit,Edit,Duplicate,Delete,Delete";
	String menuHrefs = "javascript:addLog();,javascript:showEditModuleDiv();,javascript:editFolder0();,javascript:editLog0();,javascript:duplicateLog0();,javascript:removeFolder0();,javascript:removeLog0();";
	
	if(SHOW_COPY_ID_MENU_ITEM) {
		menuIds += ",copyId";
		menuTexts += ",Copy ID";
		menuHrefs += ",javascript:copyId();";
	}
%>
  <jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>"; 
	
	function showEditModuleDiv(){
	  var modId = "";
	  var id = getFirstSelectedRow(mygrid);	  
    if (id && id != "") {
       var type = mygrid.cells(id,2).getValue();
      if (type == "Folder"){
        modId = id;
      }
    }
    	  
	  loadModulesTree("","",modId); 
	  clearNewModuleNameError();	  
		showGeneralAdminDiv("editModule");
		document.getElementById("newModuleName").focus();							
	} 
	
	function hideEditModuleDiv(){			   
		showGeneralAdminDiv("editModule");					
	}
	
	function hideModuleSaveMessage() {
		var saveLogMsgDiv = document.getElementById("saveModuleMsgDiv");
		if(saveLogMsgDiv) {
			saveLogMsgDiv.innerHTML = "";
			saveLogMsgDiv.style.display = "none";
		}
	}
	
	function showModuleSaveMessage(message) {
		var saveLogMsgDiv = document.getElementById("saveModuleMsgDiv");
		if(saveLogMsgDiv) {
			saveLogMsgDiv.innerHTML = message;
			saveLogMsgDiv.style.display = "";
		}
	}

  function getSelectedParentModule(tree){
		var list = tree.getAllChecked();
		var arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		return modsStr;
	}

	
	var onSave = false;
	function saveModule(){
	  if (onSave) return;	
		var parentModId = getSelectedParentModule(tree);
		var newModName = document.getElementById("newModuleName").value;
		var modId = document.getElementById("moduleId").value;
		if (!newModName || newModName == ""){
			var errorElem = document.getElementById("newModuleNameErrorMsg");
			if (errorElem){
			  document.getElementById("newModuleName").className = 'ERROR_MSG_BACKGROUNDCOLOR';
			  errorElem.style.display ="";			
			  errorElem.innerHTML = "Please enter a folder name";
			  document.getElementById("newModuleNameErrorMsgTR").style.display ="";
			}
			return;
		}
		var parentModDiv = document.getElementById("adminGeneralIncludeTDeditModule");
		if (parentModDiv){
		//	parentModDiv.scrollTop = parentModDiv.scrollHeight;
		}
		showModuleSaveMessage("Saving Folder...");
	
	  onSave = true;
		var url = "<%=BASE_DIRECTORY%>common/saveParentModuleAction.jsp?newModName="+newModName+"&parentModId="+parentModId + "&modId=" + modId;
		sendAjaxRequest(url,function(req){
		  onSave = false;
			showModuleSaveMessage("");
			var xmlDoc = req.responseXML.documentElement;
			var resultElement = xmlDoc.getElementsByTagName("result")[0];
			var error = resultElement.getAttribute("error");
			if (error && error.length > 0){				
				showModuleSaveMessage(error);
				return;
			}
			
			modId = resultElement.getAttribute("modId");
			hideEditModuleDiv();	
			hideModuleSaveMessage();
			showRowId = modId; 
			updateTable();
			doRefreshMenus();
		});
	}		   
		
	
	function doEdit(){
	  var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    if (type == "Folder"){
      editFolder(id);
    }else {
      editLog(id);
    }  
  }
	
	function editFolder(id){
		var name = mygrid.getUserData(id, "name");
  	loadModulesTree(id,name,mygrid.getParentId(id));
    clearNewModuleNameError(); 
		showGeneralAdminDiv("editModule");
		document.getElementById("newModuleName").focus();
  }
	
  function editLog(id){
  	this.location = "<%=BASE_DIRECTORY%>loggers/admin/logeditaction.jsp?LOG_ID=" + id;
  }
  
  function editModule(id){
  	this.location = "moduleadmin.jsp?MODULE_ID=" + id;
  }
  
  function doLogDuplicate(id){
  	this.location = "<%=BASE_DIRECTORY%>loggers/admin/duplicatelogaction.jsp?LOG_ID=" + id;
  }
  
  function doDelete(){
	  var id = mygrid.getSelectedRowId();
    if (id == "") {
      return;
    }
	
    if (id.indexOf(",") >= 0){
      doMembersDelete(id,id);
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    var name = mygrid.cells(id,0).getValue();
    if (type == "Folder"){
      var name = mygrid.cells(id,0).getValue();
      doModuleDelete(id,id,name);
    }else {
      doLogDelete(id,id,name);
    }  
  }
  
  function doMembersDelete(row,id){   
    var msgWriter = new messageWriter("mygridMessage","Folder and Logs Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doMembersDelete0('" + row + "','" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete all selected folders and logs with all their members</nobr>" + "?");
  }
  
  function doMembersDelete0(row,id){  	
    showMessage("Folders and Logs","Deleting",200,60);
  	deleteGridRow(mygrid,row,baseDirectory + "groups/admin/removeMembersAction.jsp?ids=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doModuleDelete(row,id,name){   
    var msgWriter = new messageWriter("mygridMessage","Folder Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doModuleDelete0('" + row + "','" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete folder " + name + " and all its members </nobr>" + "?");
  }
  
  function doModuleDelete0(row,id){  	
    showMessage("Folders and Logs","Deleting",200,60);
  	deleteGridRow(mygrid,row,baseDirectory + "groups/admin/removeModuleAction.jsp?MODULE_ID=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doLogDelete(row,id,name){   
    var msgWriter = new messageWriter("mygridMessage","Log Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doLogDelete0('" + row + "','" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete log </nobr>" + name + "?");
  }
  
  function doLogDelete0(row,id){  	
    showMessage("Folders and Logs","Deleting",200,60);
  	deleteGridRow(mygrid,row,baseDirectory + "groups/admin/removeLogAction.jsp?logid=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function showMessage(title,msg,width,height){
    var msgWriter = new messageWriter("mygridMessage",title,"<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.width = width;
    msgWriter.height = height;
    msgWriter.showMessage(msg);
  }
  
  function doGenerate(id){
  	path = "reportRuntimeAction.jsp?reportId=" + id;
  	document.location = path;
  }
  
  
  function doDuplicate(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    if (type != "Log") return;
    
    doLogDuplicate(id);
  }
  
  function doLogDuplicate(id){
    var url = "loggers/admin/duplicatelogaction.jsp?LOG_ID=" + id;
  	if (url.indexOf('?') != -1){
  		url += "&DUPLICATE=true";
  	}else{
  		url += "?DUPLICATE=true";
  	}
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
 
 function gotoPermissions(){
	  var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    if (type == "Folder"){
      this.location = "modulePermissionsAction.jsp?MODULE_ID=" + id;
    }else {
      this.location="<%=BASE_DIRECTORY%>loggers/admin/logPermissionsAction.jsp?LOG_ID=" + id;
    }  
  }
   
   function doubleClick(){
      var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    if (type == "Folder"){
      if (mygrid.getOpenState(id)){
         mygrid.closeItem(id);
      }else {
        mygrid.openItem(id);
      }
    }else {
      viewLog();
    }
   }
   
   function viewLog(){
     var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var type = mygrid.cells(id,2).getValue();
    if (type != "Log") return;
    
     var url = "loggers/logviewAction.jsp?logid=" + id;
     
     path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
   }
   
  function onAfterDelete(){
    hideLayer('mygridMessage');
    doRefreshMenus();
	}

	function doRefreshMenus() {
		if(refreshMenus && parent.frames[0]!=null){
			refreshMenus();
		}
	}
	
	function handleMenuItems(){
		var editable = mygrid.getUserData(contextRowId,"editable");
		var type = mygrid.cells(contextRowId,2).getValue();  			
  	if (type == "Folder"){			  
  		<% if (addModule || editModule || addLog){%>
  			<%if (addLog){%> 
  				if (editable && editable == "true"){
  		    	aMenu.menu.showButtons("addLog");
  		    }
  		  <%}%>
  		  <%if (addModule){%>
  		  	if (editable && editable == "true"){ 
  		    	aMenu.menu.showButtons("addFolder");
  		    }
  		  <%}%>
  		  <%if (editModule){%>
  		  	if (editable && editable == "true"){
  		    	aMenu.menu.showButtons("editFolder,removeFolder");
  		    }
  		  <%}%>
	  		<%if (SHOW_COPY_ID_MENU_ITEM){%> 
	  			aMenu.menu.showButtons("copyId");
			  <%}%>
  		<%}else if(SHOW_COPY_ID_MENU_ITEM){%>
  			 aMenu.menu.showButtons("copyId");
  		<%}else {%>
  		   aMenu.menu.hideBar();
  		<%}%>  			    			  
  	}else {  		
  	  <%if (editLog){%>
  	  	if (editable && editable == "true"){
	  	    aMenu.menu.showButtons("editLog,removeLog");
  	  	} 	  
  	    aMenu.menu.showButtons("duplicateLog,copyId");
  	  <%}else if(SHOW_COPY_ID_MENU_ITEM){%>
  			 aMenu.menu.showButtons("copyId");
  		<%}else {%>
  	    aMenu.menu.hideBar();
  	  <%}%>  		
  	}
	} 
    
    function addLog(){
      this.location = "<%=BASE_DIRECTORY%>loggers/admin/logAdminGate.jsp?PARENT_MODULE=" + contextRowId;
    }
    
    function editFolder0(){
      if (contextRowId && contextRowId != ""){
        editFolder(contextRowId);
      }
    }
    
    function editLog0(){
      if (contextRowId && contextRowId != ""){
        editLog(contextRowId);
      }
    }
    
    function removeFolder0(){
      if (contextRowId && contextRowId != ""){
        var name = mygrid.cells(contextRowId,0).getValue();
        doModuleDelete(contextRowId,contextRowId,name);
      }
    }
    
    function removeLog0(){
      if (contextRowId && contextRowId != ""){
         var name = mygrid.cells(contextRowId,0).getValue();
        doLogDelete(contextRowId,contextRowId,name);
      }
    }
    
    function duplicateLog0(){
      if (contextRowId && contextRowId != ""){
        doLogDuplicate(contextRowId);
      }
    }
    
    function copyId(){
      if (contextRowId && contextRowId != ""){
    	  copyToClipboard(contextRowId);
      }
    }
    
    var flash_installed = (navigator.appName == 'Netscape') ? isFlashInstalledInBrowser() : true;
		var isAllowEmbededFlash = '<%=ALLOW_EMBEDED_FLASH%>';
		var showCopyAction = ((isAllowEmbededFlash == "true") && flash_installed) || (navigator.appName != 'Netscape');
		function copyToClipboard(dataToCopy){
    	if(window.clipboardData){
    		window.clipboardData.setData('text', dataToCopy);
    		return true;
    	}else if(showCopyAction){
         var clipboarddiv=document.getElementById('divclipboardswf');  
    		 if(clipboarddiv==null){  
            clipboarddiv=document.createElement('div');  
            clipboarddiv.setAttribute("name", "divclipboardswf");  
            clipboarddiv.setAttribute("id", "divclipboardswf");  
            document.body.appendChild(clipboarddiv);  
         }  
         clipboarddiv.innerHTML='<embed src="common/clipboard.swf" FlashVars="clipboard='+  
    		 encodeURIComponent(dataToCopy)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';
    		 return true;  			    	
    	}else{
    		//var msg = "<nobr>Problem copying selected snapshot to clipboard!</nobr>"
    		//parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
    		return false;			
      }
    }
</script>


</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
 <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
			<jsp:param name="title" value="Folder"/> 
			<jsp:param name="suffix" value="editModule"/> 
			<jsp:param name="includePath" value="groups/admin/editModuleInner.jsp"/> 			
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="300px"/>
			<jsp:param name="zIndex" value="300"/>	
			<jsp:param name="actionsNames" value="Save#Cancel"/> 
			<jsp:param name="actions" value="javascript:saveModule()#javascript:hideEditModuleDiv()"/> 
			</jsp:include> 
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
          	<jsp:include page="../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Folders and Logs" />
						</jsp:include>		
         	</td>
        </tr>
        <tr>                
        	<td valign="top"> 
          <%                 
          String addName =  addModule ? "New Folder" : "";
          String addLink = addModule ? "javascript:showEditModuleDiv()" : "";
          
          if (addLog){
          	if (addName.length() > 0){
          		addName += "#";
          		addLink += "#";
          	}
          	addName += "New Log#New Logs Directory";
          	addLink += "loggers/admin/logAdminGate.jsp#wizards/common/wizardStarter.jsp?wizardPath=scanner";
          }
          
          String tableNames = editLog || editModule ? "Edit" : "";
          String tableActions = editLog || editModule ? "javascript:doEdit()" : "";
          String ids = editLog || editModule ? "Edit" : "";
          String selectTypes = editLog || editModule ? "2" : "";
          
          if (addLog){
         	 tableNames += "#Duplicate";
        		tableActions += "#javascript:doDuplicate()";
        		ids += "#Duplicate";
        		selectTypes += "#2";
         	}
          
          if (editLog || editModule){
          	 tableNames += "#Delete";
         		tableActions += "#javascript:doDelete()";
         		ids += "#Delete";
         		selectTypes += "#3";
          }
          
          
          if (isSecurity && (editModule || editLog)){
          	 tableNames += "#Permissions";
         		tableActions += "#javascript:gotoPermissions()";
         		ids += "#permissions";
         		selectTypes += "#2";
          }
          
          if (tableNames.length() > 0){
        		tableNames += "*;*";
        		tableActions += "*;*";
        		ids += "*;*";
        		selectTypes += "*;*";
        	}               
          
          tableNames += "View Log";
      		tableActions += "javascript:viewLog()";
      		ids += "ViewLog";
      		selectTypes += "2";
      		
      		String menu = showMenu ? "aMenu" : "";
      		
      		String dragAndDrop = editModule && editLog ? "true" : "false";
          %>                               
            <jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="groups/admin/modulesViewXML.jsp" />
							<jsp:param name="updateXML" value="groups/admin/modulesViewXML.jsp?dataOnly=true" />
							<jsp:param name="expandTreeOnFilter" value="true" />
							<jsp:param name="dragAndDrop" value="<%=dragAndDrop%>" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="dragBehavior" value="complex" />
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Folder and Logs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="doubleClickAction" value="doubleClick" />
						</jsp:include>

<script>
 function gridOnDragIn(sourceId,targetId,sourceGrid,targetGrid){    
    if (!targetId) return false;
    if (!mygrid.doesRowExist(targetId)) {    
    	return false;
    }
//    var type = mygrid.cells(targetId,2).getValue();
//    if (type == "Log" && mygrid.dadmodec == 0) return false;  
     return true;
   }
   
 function gridOnDragOut(sourceId,targetId,sourceGrid,targetGrid){         
     if (!targetId) return false;
     if (!mygrid.doesRowExist(targetId)) return false;
     return false;
   }  
   
 function gridOnDrop(sourceId,targetId,dropId,sourceGrid,targetGrid,sourceColumnIndex,targetColumnIndex){
 return false;
}  

function gridOnDrag(sourceId,targetId,sourceGrid,targetGrid,sourceColumnIndex,targetColumnIndex){  
  if (!mygrid.doesRowExist(targetId)) return;
  var type = mygrid.cells(targetId,2).getValue();
  var isChild = type == "Folder" && mygrid.dadmodec == 0;
  var isOpen = mygrid.getOpenState(targetId);
 // alert(isOpen + ", " + targetId);
 // if (true) return;
	  
  showMessage("Folders and Logs","Updating",200,60);
  var params = "sourceId=" + sourceId + "&targetId=" + targetId + "&isChild=" + isChild + "&isOpen=" + isOpen;
		var page = "dragAction.jsp";
		sendAjaxRequest(page,function(req){
		  hideLayer('mygridMessage');
			 var xmldoc = req.responseXML.documentElement;            	
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].text;
      if (result == "true"){			  
         showRowId = sourceId; 
			   updateTable();		
			   if(refreshMenus && parent.frames[0]!=null){
						refreshMenus();
		}	    					   ;	   								              
			}	else if (xmldoc.getElementsByTagName('message')[0].firstChild){
			  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
			  alert(message);                
      }
		},'POST',params); 
  return false;
}

var showRowId = "";

function endLoad(){
  hideLoading();
  mygrid.setSizes();
  if (showRowId && showRowId != ""){
     var arr = showRowId.split(",");     
     for (var i = 0; i < (arr.length - 1);i++){
       if (mygrid.doesRowExist(arr[i])){
         mygrid.selectRowById(arr[i],true,true,true);
       }
     }
     if (mygrid.doesRowExist(arr[arr.length - 1])){
       mygrid.selectRowById(arr[arr.length - 1],arr.length == 1 ? "" : true,true,true);
       mygrid.showRow(arr[arr.length - 1]);
     }
     showRowId = "";
  }
}

function updateButtonActivate(rowid,id,columnType,gridType){
   if (!rowid || !mygrid.doesRowExist(rowid) || (gridType == 3 && columnType != 3)){
    
     disableActionButton(id);
     return;
   }   
   var editable = mygrid.getUserData(rowid,"editable");
   if (gridType != 3 && (id == "Duplicate" || id == "ViewLog")){     
   	var type = mygrid.cells(rowid,2).getValue();
    if (type == "Log" && (id != "Duplicate" || <%=addLog%>)){
    	enableActionButton(id);
 	 	}else {
 	  	disableActionButton(id);
 	 	}  
 	 }else if (id == "permissions"){
 	   var type = mygrid.cells(rowid,2).getValue();
     if (type == "Log"){
       <%if (editLog){%>
       	 if (editable == "true"){
         	enableActionButton(id);
         }else{
         	disableActionButton(id);
         }
       <%}else {%>
         disableActionButton(id);
       <%}%>
     }else {
       <%if (editModule){%>
				 if (editable == "true"){
          enableActionButton(id);
         }else{
          disableActionButton(id);
         }
       <%}else {%>
         disableActionButton(id);
       <%}%>
     }
   }else if (<%=isSecurity%>){ 
     var type = mygrid.cells(rowid,2).getValue();
     if (type == "Log"){
       if ((id == "Edit" || id == "Delete" || id == "permissions") && <%=editLog%> && editable == "true"){
         enableActionButton(id);
       }else {
         disableActionButton(id);
       }
     }else {
       <%if (editModule){%>
         if ((id == "Edit" || id == "Delete" || id == "permissions") && editable == "false"){
					 disableActionButton(id);
				 }else{
					 enableActionButton(id);
				 }
       <%}else {%>
         disableActionButton(id);
       <%}%>
     }
   }else {
   	if (gridType == columnType || (gridType == 2)){
 	  	 enableActionButton(id);
 	 	}else {
 	  	 disableActionButton(id);
 	 	}
 	 }
}
</script>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

</body>

</html>