<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.rules.DefaultThresholdRule"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.site.portal.UserPortalManager"%>
<%@ page import="xpolog.eye.util.ui.html.ScriptItem"%>

<%!
	static final String BASE_DIRECTORY = "";
%>
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
	}

	UserSecurity user = securityManager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	if (userContext == null){
		userContext = new UserContext();
	}
	
	boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
	boolean isPermittedViewDashboard = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_VIEW_PERMISSION);
	String mainPage = request.getParameter("mainPage");

	UserPortalManager userPortalMgr = UserPortalManager.getInstance();
	boolean constraintsOk = user != null && userPortalMgr.checkConstraints(userContext);
	String userPortalHomePage = userPortalMgr.getHomePage();
	String userPortalLeftPanelPage = userPortalMgr.getLeftPanelPage();


	if(!isDashboardValid || !isPermittedViewDashboard) {
		//redirect only if mainPage is not set and there's no userPortalHomePage
		if (!((mainPage != null && mainPage.length() > 0) ||(constraintsOk && userPortalHomePage != null && userPortalHomePage.length() > 0))){
			request.getRequestDispatcher("homePortal.jsp").forward(request, response);
			return;
		}
	}
	
	int keepAliveInterval = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("keepAliveInterval",300000);
	 
	boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
	
	userContext.setUser(user);
	String applicationId = request.getParameter("applicationId");
	if (applicationId != null){
		if (applicationId.length() > 0){
			HashSet set = new HashSet();
			if (applicationId.indexOf(",") == -1){
				set.add(applicationId);
			}else{
				String[] apps = applicationId.split(",");
				for (int i=0; i<apps.length; i++){
					set.add(apps[i]);
				}
			}
			userContext.setIncludeSet(set);
		}else{
			HashSet set = new HashSet();
			userContext.setIncludeSet(set);
		}
	}
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	env.setUserContext(userContext);	
	
	String userMessage = "";
	if (user != null) {		
		userMessage = "User: " + user.getUser().getDisplayName();		
	}
	
	boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
  boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
  boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;
  
  boolean isPermittedAddVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
  
  boolean isPermittedAddReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
  
  boolean presentQuickStart = haveQuickStart || isPermittedAddReport || isPermittedAddVerify;
	boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
  
	boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
	
  //license manager parameters
  //check if the param on session - already presented, if there are 30 or less days.
  boolean showLicenseDivProperty = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("showLicenseDiv",true);
  boolean isLicnesePermanent = XpologLicenseManager.getInstance().isPermanentLicense();
  int daysLeft = XpologLicenseManager.getInstance().getDaysLeft();
  String licenseDivPresnetedString = (String)request.getSession().getAttribute("licenseDivPresneted");
  boolean licenseDivPresneted = false;
  if(licenseDivPresnetedString != null && licenseDivPresnetedString.equalsIgnoreCase("true")) {
	  licenseDivPresneted = true;
  }
  boolean showLicenseDiv = ((showLicenseDivProperty && daysLeft <= 30 && !licenseDivPresneted && !isLicnesePermanent) || (showLicenseDivProperty && daysLeft < 0 && !isLicnesePermanent));
  
  String openQuickWizard = (String)request.getSession().getAttribute("openQuickWizard");
  
  String titleMessage = "XpoLog Center Suite";
	if(isTestingBuid) {
		titleMessage += " for Testing Environments";
	}
	if(!valid) {
		titleMessage += " - your license has expired";
	}
	if(isSiteDemo) {
		titleMessage = "Welcome to XpoLog Live Demo &nbsp;&nbsp;<a href=\"http://www.xplg.com/home/downloads/index.jsp\" class=\"HELP_HEADER_LINK\" target=\"_target\">Download free trial from www.xplg.com</a>";
	}
	
	boolean isFirstRun = FirstTimeActionsManager.getInstance().isRunning();
	
	String mailSettingsDivPresnetedString = (String)request.getSession().getAttribute("mailSettingsDivPresneted");
  boolean mailSettingsDivPresneted = false;
  if(mailSettingsDivPresnetedString != null && mailSettingsDivPresnetedString.equalsIgnoreCase("true")) {
  	mailSettingsDivPresneted = true;
  }
	
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	boolean isDemo = XpologLicenseManager.getInstance().isDemo();
	boolean isRegistered = XpologLicenseManager.getInstance().isRegistered();
	boolean showMailSettingsDiv = (host.length() == 0 || host.equals(MailConfig.DEF_SMTP_ADDRESS)) && mail.displayMailSettings();
	if (showMailSettingsDiv){
		mail.writeMailSettingsIndicatorFile();
	}
	Properties alertMessages = DashboardAlertsManager.getInstance().getAlertMessages();
	String subject = alertMessages.getProperty(DashboardAlertsManager.DASHBOARD_ALERT_SUBJECT);
	
	int defaultThreshold = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("dashboard.UI.defaultRiskValueAlert", -1);
	
	boolean isResize = request.getParameter("doResize") != null && request.getParameter("doResize").equals("true"); 
	
	String leftPanelPage = "portal/leftPanel.jsp";
	if (constraintsOk && userPortalLeftPanelPage != null && userPortalLeftPanelPage.length() > 0){
		leftPanelPage = userPortalLeftPanelPage;
	}
	ScriptItem[] scripts = userPortalMgr.getAllScriptItems();
	String inlineScript = userPortalMgr.getDisplayItemInlineScripts("");
  

%>



<%@page import="xpolog.eye.Module"%><html>
<head>
<title>XPLG Center Suite</title>
<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/portal.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>portal/tooltips.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardExt.js"></script>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dhtmlxCalendar.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>

<script type="text/javascript" src="<%=BASE_DIRECTORY%>widgets/popup/js/popup.js"></script>

<jsp:include page="common/constants.jsp" flush="true"/>

<%
if (scripts != null && scripts.length > 0){
	for (int i = 0; i < scripts.length; i++){
%>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY + scripts[i].getSrc()%>"></script>
<%}
}%>

<script>

var BASE_DIRECTORY = "<%=BASE_DIRECTORY %>";
var IS_FIRST_RUN = <%=isFirstRun && isDemo %>;
var SHOW_LICENSE_DIV = <%=showLicenseDiv %>;
var SHOW_MAIL_SETTINGS_DIV = <%=showMailSettingsDiv %>;

function init(){
	if(SHOW_MAIL_SETTINGS_DIV) {
		<%
		request.getSession().setAttribute("mailSettingsDivPresneted","true");
		%>
  	showFirstTimeDiv();
  	if(IS_FIRST_RUN) {
  		loadFirstTimeProgressDiv();
  	}else {
  		loadHomePage(false);
  	}
  }else {
	  if(IS_FIRST_RUN) {
  		loadFirstTimeProgressDiv();
  	 	firstInitStartWizard();
  	}else {
  		loadHomePage(false);
  		if(SHOW_LICENSE_DIV) {
  			<%
  			request.getSession().setAttribute("licenseDivPresneted","true");
  			%>
  			showLicenseDiv();	
  		}else {
	  		firstInitStartWizard();
  		}
  	}
  }
}

function saveMailSettings() {
	var smtpHost = document.getElementById("SMTPHost").value;
	var smtpPort = document.getElementById("SMTPProt").value;
	var userEmail = document.getElementById("userEmail").value;
	if(smtpHost == "" || smtpPort == "" || userEmail == "") {
		showMessage("Save Error","Please specify SMTP Host, SMTP Port and Your Email Address",450,60);
		return;
	}else if(smtpHost == "my.domain.com") {
		showMessage("Save Error","SMTP Host cannot be my.domain.com",300,60);
		return;
	}

	var params = "";
	params += "SMTPHost=" + smtpHost;
	params += "&SMTPProt=" + smtpPort;
	params += "&to=" + userEmail;
	params += "&subject=<%=subject %>";
	params += "&enabled=true";
	params += "&sendEventSummary=true";
	params += "&<%=DefaultThresholdRule.DEFAULT_THRESHOLD_RULE_TYPE%>_threshold=<%=defaultThreshold %>";
	sendAjaxRequest("portal/firstTimeDivAction.jsp?", function(req){
		var xmldoc = req.responseXML.documentElement;
    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
    
    if (result == "false"){
			var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
    	var msg = "<ul>";
    	var errs = message.split("*;*");
    	for (var i=0; i<errs.length; i++){
    		msg = msg + "<li>" + errs[i] + "</li>";
    	}
    	msg = msg + "</ul>"

			showMessage("Save Error",msg,300,60);
    }else{
     	hideFirstTimeDiv();
    }
	}, "POST", params);
}

var firstTimeProgressTimeout;
function loadFirstTimeProgressDiv() {
	var params = "baseDirectory=" + BASE_DIRECTORY;
	sendAjaxRequest("portal/firstTimeProgress.jsp?", function(req){
		var text = req.responseText;
		if(text) {
			replaceMainTdText(text);
			firstTimeProgressTimeout = setTimeout("updateFirstTimeProgress()", 1000);
		}
  }, "POST", params);
}

function updateFirstTimeProgress() {
	sendAjaxRequest("portal/getFirstTimeProgress.jsp?", function(req){
		var xmldoc = req.responseXML.documentElement;
    if(xmldoc) {
      var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var isFinished = responseElement.getAttribute("isFinished");
				if(isFinished && isFinished == "true") {
					if(firstTimeProgressTimeout) {
						clearTimeout(firstTimeProgressTimeout);
						firstTimeProgressTimeout = null;
					}
					loadHomePage(false);
				}else {
					var responseText = getXMLElementValue(responseElement);
					var firstTimeProgressTd = document.getElementById("firstTimeProgressTd");
					if(firstTimeProgressTd) {
						replaceElementContent(firstTimeProgressTd, responseText);
					}
					firstTimeProgressTimeout = setTimeout("updateFirstTimeProgress()", 1000);
				}
			}
		}
  });
}

function loadHomePage(useCache){
	<%if (mainPage != null && mainPage.length() > 0){%>
	loadUserPortalHomePage("<%=mainPage%>");
	<%}else if (constraintsOk && userPortalHomePage != null && userPortalHomePage.length() > 0){%>
	loadUserPortalHomePage("<%=userPortalHomePage%>");
	<%}else{%>
	loadHomePageDashboard(useCache)
	<%}%>
}

function loadUserPortalHomePage(page) {
  if (!document.getElementById("homePageMainTd")){
    return;
  }
	var tdWidth = document.getElementById("homePageMainTd").clientWidth - 40;
	var params = "baseDirectory=" + BASE_DIRECTORY;
	sendAjaxRequest(page, function(req){
		var text = req.responseText;
		if(text) {
			replaceMainTdText(text);
			var autoLoadFunc = document.getElementById("autoLoadFunction");
			if (autoLoadFunc){
				var funcName = autoLoadFunc.value
				if (funcName != ""){
					var f = eval(funcName);
				}
			}
		}
  }, "POST", params);
}

function loadHomePageDashboard(useCache) {
  if (!document.getElementById("homePageMainTd")){
    return;
  }
	var tdWidth = document.getElementById("homePageMainTd").clientWidth - 40;
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&windowWidth=" + tdWidth;
	params += "&useCache=" + useCache;
	sendAjaxRequest("portal/dashboard.jsp?", function(req){
		var xmldoc = req.responseXML.documentElement;
    if(xmldoc) {
      var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var showMetrics = responseElement.getAttribute("showMetrics");
				var text = getXMLElementValue(responseElement);
				if(text) {
					replaceMainTdText(text);
					onAfterHomePageDashboardResponseLoaded();
				}
			}
		}
  }, "POST", params);
}

function onAfterHomePageDashboardResponseLoaded(showMetrics) {
	var dashboardMetricsGraphLegendDiv = document.getElementById("dashboardMetricsGraphLegendDiv");
	var dashboardGraphTd = document.getElementById("dashboardGraphTd");
	if(dashboardMetricsGraphLegendDiv && dashboardGraphTd) {
		if(showMetrics == "true") {
			var left = findPosX(dashboardGraphTd);
			var top = findPosY(dashboardGraphTd);
			var height = dashboardGraphTd.style.height;
			var index = height.indexOf("px");
			if(index != -1) {
				height = height.substring(0, index);
			}
			height = parseInt(height);
			
			top += height;
			
			left += 50;
			top -= 105;
			
			dashboardMetricsGraphLegendDiv.style.left = left + "px";
			dashboardMetricsGraphLegendDiv.style.top = top + "px";
			dashboardMetricsGraphLegendDiv.style.display = "block";
		}else {
			dashboardMetricsGraphLegendDiv.style.display = "none";
		}
		/*if(isChrome) {
			var isUsingChrome = isChrome();
			if(isUsingChrome) {
				showChromeDiv();
			}
		}*/
	}	
}

function replaceMainTdText(text) {
	var homePageMainTd = document.getElementById("homePageMainTd");
	if(homePageMainTd) {
		replaceElementContent(homePageMainTd, text);
	}
}

function replaceElementContent(element, responseText) {
	handleInnerHTML(element, responseText, 1);
}

function firstInitStartWizard(){
  <% if (valid && presentQuickStart && (openQuickWizard == null || !openQuickWizard.equals("false"))){%>
  	initStartWizard();
  <%}%>
}

function setHomeImageSource(imageElement, imageSource) {
	imageElement.src = BASE_DIRECTORY + "images/home/" + imageSource;  
}

function showMessage(title,msg,width,height){
	var msgWriter = new messageWriter("firstTimeDivMessage",title,BASE_DIRECTORY);
  msgWriter.setYParent(document.getElementById("firstTimeDiv"),50);
  msgWriter.width = width;
  msgWriter.height = height;
  msgWriter.addAction("OK","javascript:hideLayer('firstTimeDivMessage')");
  msgWriter.showMessage(msg);
}

function showSimpleMessage(title,msg,width,height){
    var msgWriter = new messageWriter("simpleMessage",title,"<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.width = width;
    msgWriter.height = height;
    msgWriter.showMessage(msg);
  }

function hideSimpleMessage(){
  hideLayer('simpleMessage');
}

function disposeHomePage() {
	setSessionParam("<%=BASE_DIRECTORY %>", "HomePageHealthViewModel", "*REMOVE*");
}

function resizeHomePage(){
	loadHomePageDashboard(true);
}

function keepAliveBack(){
  doBackgroundAction("security/common/keepAliveBack.jsp");
  setTimeout("keepAliveBack()",<%=keepAliveInterval %>);
}

setTimeout("keepAliveBack()",<%=keepAliveInterval%>);

</script>

</head>
<body style="margin: 0; padding: 0; border-width: 0;overflow:auto" onLoad="javascript:init()" onUnload="javascript:disposeHomePage()" onResize="javascript:resizeHomePage()">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>

<jsp:include page="portal/quickStartWizard.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY %>" />
</jsp:include>

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr height="10px">
		<td valign="top" style="padding-top:5" colspan="2">
			<jsp:include page="topMenu.jsp" flush="true" >
				<jsp:param name="homePage" value="homePage"/>
				<jsp:param name="showHome" value="false"/>
				<jsp:param name="showHelp" value="false"/>
			</jsp:include>
		</td>
	</tr>
	<tr height="10px">
		<td class="HOME_PAGE_TITLE_CELL" colspan="2"><%=titleMessage %></td>
	</tr>
	<tr>
		<td id="homePageLeftPanelTd" class="HOME_PAGE_LEFT_PANEL_OUTER_CELL">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="1px;">
					<td style="font-size: 1px">&nbsp;</td>
				</tr>
				<tr>
					<td class="HOME_PAGE_LEFT_PANEL_CELL">
						<jsp:include page="<%=leftPanelPage%>" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY %>"/>
						</jsp:include>
					</td>
				</tr>
			</table>
		</td>
		<td class="HOME_PAGE_MAIN_CELL">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="10px">
					<td id="homePageMainTd">
						<%if(valid) {%>
						<div id="loadingDiv" class="HOME_PAGE_LOADING_DIV">
							<img src="<%=BASE_DIRECTORY %>images/home/loadingAnimation.gif" border="0" />&nbsp;Loading...
						</div>
						<%} %>
					</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

<form AUTOCOMPLETE="OFF" id="showLogForm" name="showLogForm" method="POST" action="<%=BASE_DIRECTORY %>common/showLog.jsp" class="HOME_PAGE_FORM">
	<input type="hidden" name="lbmId">
	<input type="hidden" name="filterId">
	<input type="hidden" name="isKnowledge">
	<input type="hidden" name="DateMinimum">
	<input type="hidden" name="DateMaximum">
	<input type="hidden" name="Dates" value="TimeLimRadio">
	<input type="hidden" name="quickDateFilter" value="true">
	<input type="hidden" name="expandLogViewer" value="false">
	<input type="hidden" name="hideDashboardButton" value="false">
	<input type="hidden" name="modelSessionAttributeName" value="HomePageHealthViewModel">
</form>

<%if(showLicenseDiv) { %>
<jsp:include page="portal/licenseDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>

<%if(showMailSettingsDiv) { %>
<jsp:include page="portal/firstTimeDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>

<%if(showLicenseDiv && isDemo && !isRegistered) { %>
<jsp:include page="portal/registerDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>

<jsp:include page="portal/chromeDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<%if (inlineScript != null){%>
<%=inlineScript %>
<%}%>

</body>
</html>
