<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="com.xpolog.logcollection.admin.helpers.ReaderAdapterHelper"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.DbPacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.SshPacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.db.DbLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.ssh.SSHLocationInfo"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.logcollection.adapters.XpologCollectionAdapter"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";
		
	CollectionUnitBuilder builder = (CollectionUnitBuilder)request.getSession().getAttribute(BUILDER);
	if (builder == null){
		return;
	}
	
  String FILE_COLLECTION_LOCATION_INFO_ID = "fileCollectionLocation";
  String DEFAULT_FILE_COLLECTION_LOCATION_INFO_ID = "defaultFileCollectionLocation";
  String DB_COLLECTION_LOCATION_INFO_ID = "dbCollectionLocation";
  String DEFAULT_DB_COLLECTION_LOCATION_INFO_ID = "defaultDbCollectionLocation";
  String SSH_COLLECTION_LOCATION_INFO_ID = "sshCollectionLocation";
  String DEFAULT_SSH_COLLECTION_LOCATION_INFO_ID = "defaultSshCollectionLocation";
  String SUFFIX = "logCollectionAdmin";

  XpologCollectionAdapter ca = null;
  ca = (XpologCollectionAdapter)builder.getCurrentCollectionAdapter();
  String lbmId = request.getParameter("lbmId");
  String lbmName = "";
  boolean filePacketWriterActive = true;
  boolean dbPacketWriterActive = false;
  boolean sshPacketWriterActive = false;
  
  String filePacketWriterTarget = null;
  String dbPacketWriterTarget = null;
  String sshPacketWriterTarget = null;
  String tblName = "";
  if (ca != null){
  	if (ca.getLbmId() != null && ca.getLbmId().length() > 0){
  		lbmId = ca.getLbmId();
  	}
  	//get file packet writer
   	FilePacketWriter filePacketWriter = ReaderAdapterHelper.getFilePacketWriter(ca);
  	filePacketWriterActive = filePacketWriter == null || filePacketWriter.isActive();
  	filePacketWriterTarget = filePacketWriter == null ? null : filePacketWriter.getTargetId();
  	FileLocationInfo fileWriterLocationInfo = ReaderAdapterHelper.getFileLocationInfo(ca);
  	request.setAttribute(FILE_COLLECTION_LOCATION_INFO_ID,fileWriterLocationInfo);
  	//get db packet writer
  	DbPacketWriter dbPacketWriter = ReaderAdapterHelper.getDbPacketWriter(ca);
  	dbPacketWriterActive = dbPacketWriter != null && dbPacketWriter.isActive();
  	dbPacketWriterTarget = dbPacketWriter == null ? null : dbPacketWriter.getTargetId();
  	DbLocationInfo dbWriterLocationInfo = ReaderAdapterHelper.getDbLocationInfo(ca);
  	tblName = dbWriterLocationInfo != null ? dbWriterLocationInfo.getTableName() : null;
  	request.setAttribute(DB_COLLECTION_LOCATION_INFO_ID,dbWriterLocationInfo);
  	//get ssh packet writer
  	SshPacketWriter sshPacketWriter = ReaderAdapterHelper.getSshPacketWriter(ca);
  	sshPacketWriterActive = sshPacketWriter != null && sshPacketWriter.isActive();
  	sshPacketWriterTarget = sshPacketWriter == null ? null : sshPacketWriter.getTargetId();
  	SSHLocationInfo sshWriterLocationInfo = ReaderAdapterHelper.getSshLocationInfo(ca);
  	request.setAttribute(SSH_COLLECTION_LOCATION_INFO_ID,sshWriterLocationInfo);
  }
  
	if (lbmId != null){
		ModuleMember mm = SiteManagment.getInstance().getModuleMember(lbmId);
		if (mm != null){
			lbmName = mm.getName();
			if(lbmName != null) {
				tblName = XpologUtil.replaceSpecialCharecters(lbmName);
				tblName = tblName.replaceAll("\\s+","_");
			}
		}
	}
  
	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	FilePacketWriter pw = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
	FileLocationInfo defaultWriterLocationInfo = pw != null ? pw.getFileLocationInfo() : null;
	if (defaultWriterLocationInfo != null){
		request.setAttribute(DEFAULT_FILE_COLLECTION_LOCATION_INFO_ID,defaultWriterLocationInfo);
	}
	
	if (filePacketWriterTarget == null) filePacketWriterTarget = "";
	if (dbPacketWriterTarget == null) dbPacketWriterTarget = "";
	if (tblName == null) tblName = "";

	String noLogDivDisplay = "";
	String hasLogDivDisplay = "";
	if(lbmId == null || lbmId.length() == 0) {
		hasLogDivDisplay = "display:none";
	}else {
		noLogDivDisplay = "display:none";
	}
%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr valign="top">
	  <td>
	    <div id="noLogDivCs" style="<%=noLogDivDisplay %>">
	    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr height="20">
						<td>&nbsp;</td>
					</tr>
					<tr valign="top">
						<td>
							<span class="REGULARTEXT" style="color:#9E5B04">* No log is selected. </span><a class="LINK" href="javascript:showModuleTree()">Select a log</a>
						</td>
					</tr>
				</table>
	    </div>
	    
	    <div id="hasLogDivCs" style="<%=hasLogDivDisplay %>">
				<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
					<tr>
						<td style="vertical-align:top;padding-top:10px">
							<div id="collectionFileLocationDiv">
							<jsp:include page="../../../logcollection/common/fileLocationInfo.jsp">
								<jsp:param name="locationInfoId" value="<%=FILE_COLLECTION_LOCATION_INFO_ID%>"/>
								<jsp:param name="suffix" value="<%=SUFFIX%>"/>
								<jsp:param name="active" value="<%=filePacketWriterActive%>"/>
								<jsp:param name="showDefault" value="true"/>
								<jsp:param name="showCheckBox" value="true"/>
								<jsp:param name="checkBoxDesc" value="Write log data to file"/>
								<jsp:param name="targetFileDirDesc" value="Enter directory path"/>
								<jsp:param name="defaultLocationInfoId" value="<%=DEFAULT_FILE_COLLECTION_LOCATION_INFO_ID%>"/>
								<jsp:param name="targetId" value="<%=filePacketWriterTarget%>"/>
								<jsp:param name="noScripts" value="true"/>
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
							</jsp:include>
							</div>
						</td>
					</tr>
					<tr>
						<td style="vertical-align:top">
							<div id="collectionDBLocationDiv">
							<jsp:include page="../../../logcollection/common/dbLocationInfo.jsp">
								<jsp:param name="locationInfoId" value="<%=DB_COLLECTION_LOCATION_INFO_ID%>"/>
								<jsp:param name="suffix" value="<%=SUFFIX%>"/>
								<jsp:param name="active" value="<%=dbPacketWriterActive%>"/>
								<jsp:param name="showCheckBox" value="true"/>
								<jsp:param name="checkBoxDesc" value="Insert log data to database table"/>
								<jsp:param name="targetDbTableDesc" value="NONE"/>
								<jsp:param name="dbTableDesc" value="Table name"/>
								<jsp:param name="tblName" value="<%=tblName%>"/>
								<jsp:param name="doOnTableChange" value="updateFromDbTable()"/>
								<jsp:param name="targetId" value="<%=dbPacketWriterTarget%>"/>
								<jsp:param name="noScripts" value="true"/>
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
							</jsp:include>
						</td>
					</tr>
					<tr height="100%">
						<td>&nbsp;</td>
					</tr>
				</table>
			</div>
		</td>
	</tr>
</table>