<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="xpolog.eye.logcollection.adapters.XpologCollectionAdapter"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.Syslog"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogHelper"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogsManager"%>
<%@ page import="xpolog.eye.logcollection.data.XpologLogLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfo"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	String CURRENT_COLLECTION_UNIT_BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";
	String CU_ID = "CU_ID";
	String LOG_ID = "LOG_ID";
	String FILTER_ID = "FILTER_ID";
  String SUFFIX = "logCollectionAdmin";

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.LogCollectionPermissions.EDIT_LOG_COLLECTOR_PERMISSION, true)) {
		return;
	}
	
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  CollectionUnitsManager cuMgr = LogCollectionManager.getInstance().getCollectionUnitsManager();

  UserContext userContext = UserEnvironment.getUserContext(request);
			
  //page data
  CollectionUnit cu = null;
  XpologCollectionAdapter ca = null;
  XpologLogLocationInfo info = null;
  String cuId      = "";
  String cuName    = "";
  String cuDesc    = "";
	String logId = request.getParameter(LOG_ID);
	String filterId = request.getParameter(FILTER_ID);
	String type = request.getParameter("type");
	String syslogId = request.getParameter("syslogId");
	Syslog syslog = null;
	String storageLbmId = null;
	
  CollectionUnitBuilder builder = new CollectionUnitBuilder();
	request.getSession().setAttribute(CURRENT_COLLECTION_UNIT_BUILDER,builder);

	String id = request.getParameter(CU_ID);
	if((id != null) && !(id.trim().equals(""))){
		cu = cuMgr.getCollectionUnit(id);
		if (cu != null){
			builder.setCu(cu);
			builder.updateFromCollectionUnit();
			ca = (XpologCollectionAdapter)builder.getCurrentCollectionAdapter();
		}
	}      

  if(cu != null){       
		//General info for all types
		type = "LogCollection";
		cuId = cu.getId();
    cuName = cu.getName();
    cuDesc = cu.getDesc();
    if (cuDesc == null){
    	cuDesc = "";
    }
    if (ca != null){
			LocationInfo locInfo = ca.getLocationInfo();
			if (locInfo != null && locInfo instanceof XpologLogLocationInfo){
				info = (XpologLogLocationInfo)locInfo;
				logId = info.getLbmId();
				filterId = info.getLbmFilterId();
				storageLbmId = ca.getStorageLbmId();
			}
    }
  }

  boolean isSyslog = type != null && type.equals("Syslog");
  if (isSyslog){
  	if (syslogId == null || syslogId.length() == 0){
    	syslogId = SyslogsManager.DEFAULT_SYSLOG_ID;
  	}
  	syslog = SyslogsManager.getInstance().getSyslog(syslogId);
  	if (syslog != null){
  		cuName = syslog.getName();
  	}
  }

	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String useSessionLogStr = request.getParameter("useSessionLog");
	boolean useSessionLog = useSessionLogStr == null || useSessionLogStr.equals("true");
	
	String useSessionBuilderStr = request.getParameter("useSessionBuilder");
	
	String headerTitle = cu != null ? "Edit Collector" : "Add Collector";

	String selectedLogId = null;
	String selectedFilterId = null;
	if (info != null){
		selectedLogId = info.getLbmId();
		selectedFilterId = info.getLbmFilterId();
	}else if (logId != null){
		selectedLogId = logId;
		selectedFilterId = filterId;
	}
	
	String rotationPolicy = "daily";
	LinearBrowsingManager lbm = null;
	if (selectedLogId != null && selectedLogId.length() > 0){
		try{
			lbm = mgmt.getLogBrowserManager(selectedLogId,true);
			if ((cuName == null || cuName.length() == 0) && lbm != null){
				if (logId != null){
					cuName = lbm.getName() + " collector";
				}
				//if (lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)){
				//	rotationPolicy = "hourly";
				//}
			}
		}catch(Exception e){
		}
	}

	if (selectedLogId == null) selectedLogId = "";
	String treeName = "tree";
	
	String logTypesToIgnore = 
		MergedLogBrowserBuilder.MERGE_LOG_TYPE + ",";// + 
		//RemoteLogBuilder.PROXY_LOG_TYPE + "," + WinEventLogBuilder.EVENT_VIEWER_TYPE;
	
	String confEntryKey = null;
	if (cu != null && SyslogHelper.isSyslogCollectionUnit(cu)){
		isSyslog = true;
		String[] syslogKeys = SyslogHelper.getSyslogKeysFromCollectionUnit(cu);
		if (syslogKeys != null && syslogKeys.length == 3){
			syslogId = syslogKeys[1];
			confEntryKey = syslogKeys[2];
		}
	}
	boolean useTempLbm = false;
	if (isSyslog && (cu == null || confEntryKey == null)){
		logId = SyslogsManager.SYSTEM_SYSLOG_LOG_ID;
		selectedLogId = logId;
		useTempLbm = true;
	}

	//String collectionPage = isSyslog && cu == null? //add new syslog collector 
	//		BASE_DIRECTORY+"logcollection/admin/syslog/syslogCollectionAdmin.jsp?suffix="+suffix+"&syslogId=" + syslogId : 
	//		"collectionSettings.jsp";
	//String collectionTabName = isSyslog && cu == null ? "Rules" : "Targets";
	String collectionPage = "collectionSettings.jsp";
	String collectionTabName = "Targets";
	String syslogRulesDivId = "";
	if (isSyslog){
		if (cu == null || confEntryKey == null){
			syslogRulesDivId = "syslogRulesDiv";
		}else{
			syslogRulesDivId = "syslogRuleDiv";
		}
	}
	
	String selectFilterString = "Select or ";
	boolean allowNewFilter = true;
	if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION)){
		allowNewFilter = false;
		selectFilterString = "Select rule ";
  }
	
	if (logId == null) logId = "";
	if (filterId == null) filterId = "";
	request.getSession().removeAttribute("TEMP_LBM");
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script language="JavaScript1" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>tasks/snmp/snmp.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>tasks/jms/jms.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/logcollection/common.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/logcollection/locations.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/logcollection/filelocationinfo.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>

<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script language="javascript">

	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";

	function init(){
		initTabs();
		initTables();
		if(typeof initChecksumLocation == 'function') {
			initChecksumLocation();
		}
	}

	function showSaveSettings(){
		showHideLayerInMiddle("saveSettingsDiv",-1,-1);
	}
 
	function saveXpologCollection(locationChanged,moveCollectedData,updateStorageLog){
		<%if (isSyslog){%>
		updateCheckedSelectors();
		<%}else{%>
		updateSelected();
		<%}%>	
	  <%if (XpologSecurityManager.getInstance().isEnabled()){%>
	  updatePermissions();
	  <%}%>
	  if (!validateSubmit()){
	  	enableButton("saveLogCollectionBtn")
	  	return;
	  }
	  msgWriter = document.getElementById("saveMessage");
	  if (!msgWriter){
	  	msgWriter = new messageWriter("saveMessage","Saving Log Collection","<%=BASE_DIRECTORY%>");
			msgWriter.showMessage("<nobr>Saving log collection. Please wait...</nobr>");
		}else{
			showDisplayLayer("saveMessage");
		}
	  var params = getFormElementsQueryString(document.access);
	  <%if (isSyslog && cu == null){%>
	  var url = "../syslog/syslogCollectionAdminAction.jsp";
	  <%}else{%>
	  var url = "logCollectionDefinitionAction.jsp";
	  <%}%>
	  if (locationChanged){
	  	params += "&locationChanged="+locationChanged;
	  }
	  if (moveCollectedData){
	  	params += "&moveCollectedData="+moveCollectedData;
	  }
	  if (updateStorageLog){
	  	params += "&updateStorageLog="+updateStorageLog;
	  }
	  sendAjaxRequest(url,function(req){
	    var xmldoc = req.responseXML.documentElement;
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
      if (result == "false"){
      	hideDisplayLayer("saveMessage");
      	//showHideLayerInMiddle2("messageDiv",300,200);
		    //document.getElementById("messageDiv").style.zIndex = 600;
	    	//var msgTitle = document.getElementById("messageTitle");
	    	//if (msgTitle){
	    	//	msgTitle.innerHTML = "Save Log Collector Error";
	    	//}
	    	//var msgText = document.getElementById("messageText");
	    	var msg = "";
	    	//if (msgText){
	    		msg = "<ul>";
	    		var errs = message.split("*;*");
	    		for (var i=0; i<errs.length; i++){
	    			msg = msg + "<li>" + errs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
	    		//msgText.innerHTML = msg;
	    	//}

				if (message == "CollectionPathChanged"){
					msgWriter = new messageWriter("mygridMessage","Collection Path Changed","<%=BASE_DIRECTORY%>");
					msgWriter.addChbox("Move collected data to new location","moveCollectedData","true");  
					msgWriter.addChbox("Update storage log","updateStorageLog","true");  
					msgWriter.addAction("Continue","javascript:hideLayer('mygridMessage');javascript:saveXpologCollection0()");
					msgWriter.addAction("Cancel","javascript:hideLayer('mygridMessage')");  
					msgWriter.showMessage("<nobr>The collection path of collector " + name + " has changed.</nobr><br><nobr>Please select the actions to take place</nobr>");
				}else{
					msgWriter = new messageWriter("mygridMessage","Save Log Collector Error","<%=BASE_DIRECTORY%>");
					msgWriter.setStyle("left");
					msgWriter.addAction("Close","javascript:hideLayer('mygridMessage')");  
					msgWriter.showMessage(msg);
				}   	
    	    	
	    	if (xmldoc.getElementsByTagName('params')[0] && xmldoc.getElementsByTagName('params')[0].firstChild){
		    	var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
		    	var pArr = params.split("*;*");
		    	for (var i=0; i<pArr.length; i++){
		    		if (eval("document.access."+ pArr[i])){
		    			setErrorColor(eval("document.access."+ pArr[i]));
		    		}
		    	}
	    	}
	    	enableButton("saveLogCollectionBtn");
      }else{
      	refreshMenus();
      	document.location = BASE_DIRECTORY + "logcollection/logCollectionsView.jsp?CU_ID=" + message;
      }


	  },"POST",params);
	}
	
	function saveXpologCollection0(){
  	var moveCollectedData = document.getElementById("moveCollectedData");
  	var updateStorageLog = document.getElementById("updateStorageLog");
  	saveXpologCollection(true,moveCollectedData.checked,updateStorageLog.checked);
 }

	function validateSubmit(){
		<%if (isSyslog){%>
			return true;
		<%}else{%>
			return validateLogCollectionSubmit();
		<%}%>
	}
	
	
	function validateLogCollectionSubmit(){
	  var result = true;
	  if (!document.getElementById("logCollectionName") || document.getElementById("logCollectionName").value == ""){
	    highlightBgColor("logCollectionName");
			document.getElementById("logCollectionNameErrorMsgTR").style.display = "";
	    document.getElementById("logCollectionNameErrorMsg").innerHTML = "Please enter a name";
	    result = false;
	  }else {
	    clearBgColor("logCollectionName");
	    document.getElementById("logCollectionNameErrorMsg").innerHTML = "";
			document.getElementById("logCollectionNameErrorMsgTR").style.display = "none";
	  }
	  var infoType = getSelectedInfoType('<%=SUFFIX%>');
	  if (infoType == "manual" && (!document.getElementById("fullPath_<%=SUFFIX%>") || document.getElementById("fullPath_<%=SUFFIX%>").value == "")){
	    highlightBgColor("fullPath_<%=SUFFIX%>");
			document.getElementById("fullPath_<%=SUFFIX%>ErrorMsgTR").style.display = "";
	    document.getElementById("fullPath_<%=SUFFIX%>ErrorMsg").innerHTML = "Please enter a path";
	    result = false;
	  }else {
	    clearBgColor("fullPath_<%=SUFFIX%>");
	    document.getElementById("fullPath_<%=SUFFIX%>ErrorMsg").innerHTML = "";
			document.getElementById("fullPath_<%=SUFFIX%>ErrorMsgTR").style.display = "none";
	  }
	  
	  if (!document.getElementById("logName") || document.getElementById("logName").value == ""){	    
	    highlightBgColor("logName");
	    document.getElementById("logErrorMsg").innerHTML = "Please select a log";
	    document.getElementById("logErrorMsg").style.display = "";
	    result = false;
	  }else {
	    clearBgColor("logName");
	    document.getElementById("logErrorMsg").innerHTML = "";
	    //document.getElementById("logErrorMsg").style.display = "none";
	  }
	  return result;
	}
	
	function logCollectionNameUpdated(name){
		if (name && name != ""){
			document.getElementById("logCollectionNameErrorMsg").innerHTML = "";
			document.getElementById("logCollectionNameErrorMsgTR").style.display = "none";
		}
	}
	
	
	function updatePermissions(){
		for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
			document.access.selectedEditMembersList.options[j].selected = true;
		}
		for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
			document.access.selectedViewMembersList.options[j].selected = true;
		}
	}

	function updateSelected(){
		if (tree){
			list = tree.getAllCheckedAndPartiallyChecked();
			arr = list.split(",");
		  var logsStr = "";
		  var filtersStr = "";
			for (var i=0; i<arr.length; i++){
				s = arr[i];
				ind = s.indexOf("-");
				if (ind == -1){
					continue;
				}else{
					type = s.substring(0,ind);
					id = s.substring(ind+1,s.length);
					if (type == "<%=XpoLogObjectTypes.LOG_TYPE%>"){
						if (logsStr != ""){
							logsStr += ",";
						}
						logsStr += id;
					}else if (type == "<%=XpoLogObjectTypes.FILTER_TYPE%>"){
						if (filtersStr != ""){
							filtersStr += ",";
						}
						filtersStr += id;
					}
				}
			}
			document.access.logs.value = logsStr;
		}
	}
	
	function updateCheckedSelectors(){
		var checkedRows = mygridSyslogConfEntries.getCheckedRows(0);
		var rulesStr = "";
		if (checkedRows){
			var arr = checkedRows.split(",");
			for (i=0; i<arr.length; i++){
				if (rulesStr != ""){
					rulesStr += "#";
				}
				var key = mygridSyslogConfEntries.getUserData(arr[i],"key");
				var action = mygridSyslogConfEntries.getUserData(arr[i],"action");
				var selector = mygridSyslogConfEntries.getUserData(arr[i],"selector");
				if (!key){
					key = "";
				}
				if (!action){
					action = "";
				}
				if (!selector){
					selector = "";
				}
				rulesStr += (key + "*;*" + selector + "*;*" + action);
			}
			
		}
		document.access.syslogRules.value = rulesStr;
	}
	
	function setErrorColor(elem){
		if (elem){
			elem.className = 'ERROR_MSG_BACKGROUNDCOLOR';
		}
	}
	
	function hideMessageDiv(){
		document.getElementById("messageDiv").style.display = "none";
	}  
	
	//syslog functions
	function addSyslogRule(){
		editSyslogRule();
	}
	
	function editRule(){
    var id;
   	id = getFirstSelectedRow(mygridSyslogConfEntries);
   	var key = mygridSyslogConfEntries.getUserData(id,"key");
   	var xpologEntry = mygridSyslogConfEntries.getUserData(id,"xpologEntry");
    if (id == "" || xpologEntry == "false") {
			showHideLayerInMiddle2("messageDiv",300,200);
			document.getElementById("messageDiv").style.zIndex = 300;
			var msgTitle = document.getElementById("messageTitle");
			if (msgTitle){
				if (id == ""){
					msgTitle.innerHTML = "No Row Selected";
				}else{
					msgTitle.innerHTML = "Non Editable Rule";
				}
			}
			var msgText = document.getElementById("messageText");
			if (msgText){
				if (id == ""){
					msgText.innerHTML = "Please select a filter to edit";
				}else{
					msgText.innerHTML = "Only XpoLog rules can be modified";
				}
			}
			return;
    }
 		editSyslogRule(key);
 	}
	
	function editSyslogRule(key){
		var url = "../syslog/syslogRuleDefinition.jsp?embedded=true&noScripts=true&suffix=SyslogRule&syslogId=<%=syslogId%>";
		if (key){
			url += "&confEntryKey="+encode(key);
		}
		//alert(url);
		showSyslogRule(url,"Rules");
	}
	
	function showSyslogRule(url,title){
		sendAjaxRequest(url,function(req){
			hideAllGeneralAdminDiv();
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not open syslog rule definition page");
				return;			
			}
			showGeneralAdminDiv("SyslogRule");
			if (title){
				var t = document.getElementById("generalDivTitleSyslogRule");
				if (t){
					t.innerHTML = title;
				}
			}
			updateGeneralAdminDiv("SyslogRule",result);
		});
	}
	
	function deleteRule(syslogId){
    var id;
   	id = getFirstSelectedRow(mygridSyslogConfEntries);
   	var key = mygridSyslogConfEntries.getUserData(id,"key");
   	var xpologEntry = mygridSyslogConfEntries.getUserData(id,"xpologEntry");
   	var selector = mygridSyslogConfEntries.getUserData(id,"selector");
   	if (!selector){
   		selector = "";
   	}
    if (id == "" || xpologEntry == "false") {
			showHideLayerInMiddle2("messageDiv",300,200);
			document.getElementById("messageDiv").style.zIndex = 300;
			var msgTitle = document.getElementById("messageTitle");
			if (msgTitle){
				if (id == ""){
					msgTitle.innerHTML = "No Row Selected";
				}else{
					msgTitle.innerHTML = "Non deletable Rule";
				}
			}
			var msgText = document.getElementById("messageText");
			if (msgText){
				if (id == ""){
					msgText.innerHTML = "Please select a rule to delete";
				}else{
					msgText.innerHTML = "Only XpoLog rules can be deleted";
				}
			}
			return;
    }else{
	    var msgWriter = new messageWriter("deleteRuleMessage","Delete Syslog Rule","<%=BASE_DIRECTORY%>");
	    msgWriter.setYParent(document.getElementById("mygrid"),50);
	   	msgWriter.addAction("Yes","javascript:hideLayer('deleteRuleMessage');deleteSyslogRule('" + key + "','" + syslogId + "')");
	    msgWriter.addAction("No","javascript:hideLayer('deleteRuleMessage')");  
	    msgWriter.showMessage("<nobr>Are you sure you want to delete rule " + selector + " ?</nobr>");
    }
 		//deleteSyslogRule(key,syslogId);
 	}
	
	function deleteSyslogRule(key,syslogId){
		var params = getFormElementsQueryString(document.access,"SyslogRule");
		if(params == "falseInput"){
			return;
		}else{
			params += "&suffix=SyslogRule&action=delete";
		}
		if (key){
			params += "&confEntryKeySyslogRule="+encode(key);
		}
		if (syslogId){
			params += "&syslogIdSyslogRule="+syslogId;
		}
		var url = "../syslog/updateSyslogRule.jsp";
		sendAjaxRequest(url,function(req){
			var result = req.responseText;
			if (result){	
				result = result.replace(/^\s+|\s+$/g, '');
			}
			var resultStrs = result.split("#");
			if (resultStrs.length > 1 && resultStrs[0] == "SAVE_RULE_SELECTOR_ERROR"){
		    showHideLayerInMiddle2("messageDiv",300,200);
		    document.getElementById("messageDiv").style.zIndex = 300;
	    	var msgTitle = document.getElementById("messageTitle");
	    	if (msgTitle){
	    		msgTitle.innerHTML = "Save Syslog Rule Error";
	    	}
	    	var msgText = document.getElementById("messageText");
	    	if (msgText){
	    		var msg = "";
	    		for (i=1; i<resultStrs.length; i++){
	    			if (msg != ""){
	    				msg = msg + "<br>";
	    			}
	    			msg = msg + resultStrs[i];
	    		}
	    		msgText.innerHTML = msg;
	    	}
			}else{
				var url = "<%=BASE_DIRECTORY%>logcollection/admin/syslog/syslogCollectionAdminXML.jsp?dataOnly=true";
		  	mygridSyslogConfEntries.clearAll();
		  	mygridSyslogConfEntries.loadXML(url);
		  	hideAllGeneralAdminDiv();
			}				
		},"POST",params);
	}
	
	function saveSyslogRule(){
		var params = getFormElementsQueryString(document.access,"SyslogRule");
		if(params == "falseInput"){
			return;
		}else{
			params += "&suffix=SyslogRule";
		}
		//alert(params)
		
	  msgWriter = document.getElementById("saveRule");
	  if (!msgWriter){
	  	msgWriter = new messageWriter("saveRule","Saving Syslog Rule","<%=BASE_DIRECTORY%>");
			msgWriter.showMessage("<nobr>Saving syslog rule. Please wait...</nobr>");
		}else{
			showDisplayLayer("saveRule");
		}
		var url = "../syslog/updateSyslogRule.jsp";
		sendAjaxRequest(url,function(req){
			hideDisplayLayer("saveRule");
			enableButton("saveSyslogRuleBtn");
			var result = req.responseText;
			if (result){	
				result = result.replace(/^\s+|\s+$/g, '');
			}
			var resultStrs = result.split("#");
			if (resultStrs.length > 1 && resultStrs[0] == "SAVE_RULE_SELECTOR_ERROR"){
		    showHideLayerInMiddle2("messageDiv",300,200);
		    document.getElementById("messageDiv").style.zIndex = 300;
	    	var msgTitle = document.getElementById("messageTitle");
	    	if (msgTitle){
	    		msgTitle.innerHTML = "Save Syslog Rule Error";
	    	}
	    	var msgText = document.getElementById("messageText");
	    	if (msgText){
	    		var msg = "";
	    		for (i=1; i<resultStrs.length; i++){
	    			if (msg != ""){
	    				msg = msg + "<br>";
	    			}
	    			msg = msg + resultStrs[i];
	    		}
	    		msgText.innerHTML = msg;
	    	}
			}else{
				var url = "<%=BASE_DIRECTORY%>logcollection/admin/syslog/syslogCollectionAdminXML.jsp?dataOnly=true";
		  	mygridSyslogConfEntries.clearAll();
		  	mygridSyslogConfEntries.loadXML(url);
		  	hideAllGeneralAdminDiv();
			}				
		},"POST",params);
	}
	
	// browser start
	function openSyslogFileBrowser(txtboxId,suffix){
	 	showHideSysFileInMiddle(150,200);
	 	if (!suffix){
	 		suffix = "";
	 	}
		var rootDir = document.getElementById(txtboxId+suffix).value;
		loadSysFilesTree(rootDir,txtboxId+suffix,"");
	}

	function doOpenSyslogFileBrowser(txtboxId,suffix,e){
		var result = syslogCheckKey(e);
  	if (result){
			openBrowser(txtboxId,suffix);
		}
	}

	function syslogCheckKey(e){
	 	if (!e) var e = window.event;
			var code = e.keyCode;
			if (code == 13 ){
				return true;
		}
	}
	// browser end
	
	//end syslog functions
	
	//database writer start
	function updateFromDbTable(lbmId){
		var accListCombo = document.access.<%=SUFFIX%>AccountsList;
		if (accListCombo){
     	var insertStmt = "";
     	var createStmt = "";
     	var insertStmtElement = document.access.insertStatement_<%=SUFFIX%>;
     	var createStmtElement = document.access.createStatement_<%=SUFFIX%>;
			if (accListCombo.selectedIndex == 0){
      	if (insertStmtElement){
      		insertStmtElement.value = insertStmt;
      	}
      	if (createStmtElement){
      		createStmtElement.value = createStmt;
      	}
				return;
			}
			var accId = accListCombo.options[accListCombo.selectedIndex].value;
			if (accId && accId != ""){
				var tblName = document.access.tableName_<%=SUFFIX%>.value;
				if (!tblName || tblName == ""){
					return;
				}
				if (document.getElementById("createStmtsMessage")){
					showDisplayLayer("createStmtsMessage");	
				}else{
					msgWriter = new messageWriter("createStmtsMessage","","<%=BASE_DIRECTORY%>");
					msgWriter.showMessage("<nobr>Creating SQL statements. Please wait...</nobr>");
				}
				if (!lbmId){
					lbmId = lastSelectedCollectionLog;
				}
				var ind = lbmId.indexOf("Log-");
				if (ind != -1){
					lbmId = lbmId.substring(ind+4);
				}
				var url = "updateFromDbTable.jsp?tableName="+tblName+"&lbmId="+lbmId+"&accId="+accId;
				//alert(url);
				sendAjaxRequest(url,function(req){
		    var xmldoc = req.responseXML.documentElement;
		    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	      var tableName = "";
      	var tableNameElement = document.access.tableName_<%=SUFFIX%>;
				hideDisplayLayer("createStmtsMessage");				
				if (result == "false"){
					var message = message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
					msgWriter = new messageWriter("createStmtsMessageError","Error creating SQL statements","<%=BASE_DIRECTORY%>");
					msgWriter.addAction("Close","javascript:hideLayer('createStmtsMessageError')");  
					msgWriter.setStyle("left");
		    	var msg = "";
	    		msg = "<ul>";
	    		var errs = message.split("*;*");
	    		for (var i=0; i<errs.length; i++){
	    			msg = msg + "<li>" + errs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
					msgWriter.showMessage(msg);
				}else{
	      	tableName = xmldoc.getElementsByTagName('tableName')[0].firstChild.nodeValue;
	      	if (tableNameElement){
	      		tableNameElement.value = tableName;
	      	}
	      	insertStmt = xmldoc.getElementsByTagName('insertStmt')[0].firstChild.nodeValue;
	      	createStmt = xmldoc.getElementsByTagName('createStmt')[0].firstChild.nodeValue;
				}
      	if (insertStmtElement){
      		insertStmtElement.value = insertStmt;
      	}
      	if (createStmtElement){
      		createStmtElement.value = createStmt;
      	}
			});
			}
		}
		/*
		*/
	}
	
	function dbAccountChanged(){
		updateFromDbTable();
	}
	
	function newAccountAdded(){
		updateFromDbTable();
	}
	//database writer end
	
	
</script>

<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%if (isSyslog){%>
<jsp:include page="../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="initXML" value="logcollection/admin/syslog/syslogCollectionAdminXML.jsp" />
	<jsp:param name="suffix" value="SyslogConfEntries" />
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="recordsText" value="Syslog Rules" />
</jsp:include>
<%}%>
<jsp:include page="../../../common/selectLogHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="../../../" />
	<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
	<jsp:param name="FILTER_ID" value="<%=selectedFilterId%>" />
	<jsp:param name="mode" value="logs" />
	<jsp:param name="treeOnly" value="true" />
	<jsp:param name="ignoreHeader" value="true" />
	<jsp:param name="allowNewLog" value="true" />
	<jsp:param name="logPopupMenu" value="true" />
	<jsp:param name="parameterName" value="Collect log:" />
	<jsp:param name="openLinkName" value="select log" />
	<jsp:param name="showCollectionsModule" value="true" />
	<jsp:param name="showNewFilter" value="false" />
	<jsp:param name="paramNameWidth" value="150" />
	<jsp:param name="dummy" value="dummy" />
	<jsp:param name="newFilterLabel" value="Match Text"/>
	<jsp:param name="LOG_TYPES_TO_IGNORE" value="<%=logTypesToIgnore%>"/>
	<jsp:param name="checkEditPermissions" value="true" />
	<jsp:param name="useTempLbm" value="<%=useTempLbm%>" />
</jsp:include>
<jsp:include page="../syslog/syslogRuleDefinition.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="embedded" value="true" />
	<jsp:param name="scriptsOnly" value="true" />
	<jsp:param name="suffix" value="SyslogRule" />
</jsp:include>
<jsp:include page="../../../common/accountsListCombo.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="ON_CHANGE_ACTION" value="dbAccountChanged()"/>
</jsp:include>
<jsp:include page="../../../logcollection/common/dbLocationInfo.jsp">
	<jsp:param name="suffix" value="<%=SUFFIX%>"/>
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="doOnTableChange" value="updateFromDbTable()"/>
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<jsp:include page="../../../logcollection/common/fileLocationInfo.jsp">
	<jsp:param name="suffix" value="<%=SUFFIX%>"/>
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
	<jsp:param name="type" value="ssh"/>
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/logcollection/locations.js" type="text/javascript"></script>
<%
String allowNewLogStr = request.getParameter("allowNewLog");
boolean allowNewLog = allowNewLogStr == null || allowNewLogStr.equals("true");
if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION)){
	allowNewLog = false;
}
String actionsNames = allowNewLog ? "Create new Log#Close" : "Close";
String actions = allowNewLog ? "javascript:openNewLogDiv()#javascript:closeLogSelectionDiv()" : "javascript:closeLogSelectionDiv()";

%>
<jsp:include page="../../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Log to Collect"/> 
	<jsp:param name="suffix" value="SelectLog"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>

<script>
	var lastSelectedCollectionLog = "<%=selectedLogId%>";
	var lastSelectetCollectionLogName = "";
	function updateSourceForLogChange(id,name){
		if (name){
			//update log collection name
			var lcName = document.getElementById("logCollectionName");
			if (lcName && 
				(lcName.value == "" || lcName.value == lastSelectetCollectionLogName || lcName.value == lastSelectetCollectionLogName + " collector")){
				lcName.value = name + " collector";
				logCollectionNameUpdated(name);
				clearBgColor("logCollectionName");
			}
			lastSelectetCollectionLogName = name;
			
			//update db table name
			var dbTblName = document.getElementById("tableName_<%=SUFFIX%>");
			var accList = document.getElementById("<%=SUFFIX%>AccountsList");
			if (dbTblName){
				dbTblName.value = name;
				if (accList && accList.selectedIndex > 0){
					updateFromDbTable(id);
				}
			}
		}
		if (id){
			var lbmId = "";
			if (id.indexOf("Log-") == 0){
				lbmId = id.substring(4);
			}else{
				lbmId = id;
			}
			document.access.logs.value = lbmId;
			var selectedLog = tree.getAllCheckedAndPartiallyChecked();
			if(selectedLog == '') {
				selectedLog = lbmId;
			}

			var noLogDivCs = document.getElementById("noLogDivCs");
			var hasLogDivCs = document.getElementById("hasLogDivCs");
			var noLogDivR = document.getElementById("noLogDivR");
			var hasLogDivR = document.getElementById("hasLogDivR");
			if(selectedLog == '') {
				noLogDivCs.style.display = "";
				hasLogDivCs.style.display = "none";
				noLogDivR.style.display = "";
				hasLogDivR.style.display = "none";
			}else {
				noLogDivCs.style.display = "none";
				hasLogDivCs.style.display = "";
				noLogDivR.style.display = "none";
				hasLogDivR.style.display = "";
			}
			var url = "filtersList.jsp?useTempLbm=<%=useTempLbm%>&isAjax=true&lbmId="+lbmId;
			if (lbmId == "<%=selectedLogId%>"){
				url += "&filterId=<%=selectedFilterId%>";
			}
			sendAjaxRequest(url,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not get logs list!");
					return;			
				}
				if (result != "NO_FILTERS"){
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = result; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT"><%=selectFilterString%></span>';
					}
				}else{
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = ""; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT" style="color:#9E5B04">* No rules are assigned to this log. </span>';
					}
					<%if(allowNewFilter) {%>
						//openNewFilterDiv(50,250);
					<%}%>
				}
			});

			lastSelectedCollectionLog = selectedLog;
		}
	}

	function updateSourceForFilterChange(lbmId,filterId){
		if (lbmId){
			var url = "filtersList.jsp?isAjax=true&useTempLbm=<%=useTempLbm%>&lbmId="+lbmId;
			var filterIds = "&filterId="+ getSelectedFilters();
			if (filterIds){
				filterIds += "," + filterId;
			}
			url += filterIds;
			document.access.logs.value = lbmId;
			sendAjaxRequest(url,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not get logs list!.");
					return;			
				}
				if (result != "NO_FILTERS"){
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = result; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT">Select or </span>';
					}
				}else{
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = ""; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT" style="color:#9E5B04">* No rules are assigned to this log. </span>';
					}
				}
			});
		}
	}
	
	function getSelectedFilters(){
		if (document.access.filters){
			var selectedFilters = "";
			var len = document.access.filters.length;
			if (!len){
				return document.access.filters.value;
			}
			for (var i=0; i<len; i++){
				if (document.access.filters[i].checked){
					selectedFilters = selectedFilters + "," + document.access.filters[i].value;
				}
			}
			return selectedFilters;
		}else{
			return "";
		}
	}
	
	function selectTabHandler(idn,ido){
		if (!idn){
			return false;
		}
		hideAllGeneralAdminDiv();
		return true;
	}
	
</script>

<title></title>
</head>

<div id="addAccDiv" style="display:none">
</div>

<body onLoad="init()" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="logCollectionDefinitionAction.jsp" style="margin:0;padding:0" method="POST">
<input type="hidden" name="doSave" value="true">
<input type="hidden" name="LOG_ID">
<input type="hidden" name="mods">
<input type="hidden" name="logs" value="<%=selectedLogId%>">
<input type="hidden" name="actions">
<%if (storageLbmId != null){%>
<input type="hidden" name="storageLbmId" value="<%=storageLbmId%>">
<%}%>
<%if (type != null && type.length() > 0){%>
<input type="hidden" name="type" value="<%=type%>">
<%}%>
<%if (syslogId != null && syslogId.length() > 0){%>
<input type="hidden" name="syslogId" value="<%=syslogId%>">
<%}%>
<%if (isSyslog){%>
<input type="hidden" name="infoType_<%=SUFFIX%>" value="default">
<input type="hidden" name="syslogRules">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="1">
		<td>
			<jsp:include page="../../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<%if (!isSyslog){%>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="logCollectionName" id="logCollectionName" size="30" value="<%=cuName%>" 
												onClick="resetBgColor(this)" onChange="logCollectionNameUpdated(this.value)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr id="logCollectionNameErrorMsgTR" style="display:none">
											<td style="padding-left:40px" style="font-size:5px">&nbsp;</td>
											<td colspan="2">
												<div id="logCollectionNameErrorMsg" class="ERROR_MSG">
												</div>
											</td>
										</tr>				
										<tr>
											<td colspan="3"><span style="font-size:5">&nbsp;</span></td>
										</tr>
										<tr>
											<td><span class="REGULARTEXT">Description:</span></td>
											<td>
												<input type="text" class="TEXTBOX" name="logCollectionDesc" size="30" value="<%=cuDesc%>"> 
											</td>
											<td>&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
										<tr height="10">
											<td valign="top" colspan="3">
												<jsp:include page="../../../common/selectLog.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../../../" />
													<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
													<jsp:param name="FILTER_ID" value="<%=selectedFilterId%>" />
													<jsp:param name="ignoreHeader" value="true"/>
													<jsp:param name="noTree" value="true"/>
													<jsp:param name="mode" value="logs" />
													<jsp:param name="allowNewLog" value="true" />
													<jsp:param name="logPopupMenu" value="true" />
													<jsp:param name="parameterName" value="Collected Log:" />
													<jsp:param name="openLinkName" value="select log" />
													<jsp:param name="showCollectionsModule" value="true" />
													<jsp:param name="showNewFilter" value="false" />
													<jsp:param name="labelWidth" value="150" />
													<jsp:param name="textBoxSize" value="30" />
													<jsp:param name="newFilterTitle" value="Create New Log Collector Rule" />
													<jsp:param name="newFilterLabel" value="Match Text" />
												</jsp:include>
											</td>
										</tr>
										<%}else{%>
										<%if (cu != null && confEntryKey != null){%>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="logCollectionName" id="logCollectionName" size="30" value="<%=cuName%>" 
												onClick="resetBgColor(this)" onChange="logCollectionNameUpdated(this.value)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr id="logCollectionNameErrorMsgTR" style="display:none">
											<td style="padding-left:40px" style="font-size:5px">&nbsp;</td>
											<td colspan="2">
												<div id="logCollectionNameErrorMsg" class="ERROR_MSG">
												</div>
											</td>
										</tr>				
										<%}else{%>
										<tr>
											<td width="100"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="" size="30" value="<%=cuName%>" readonly> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<%}%>
										<tr>
											<td valign="top" colspan="3">
												<jsp:include page="../../../common/adminGeneralDiv.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
													<jsp:param name="title" value="Create New Log Filter"/> 
													<jsp:param name="suffix" value="NewFilter"/> 
													<jsp:param name="width" value="400px"/> 
													<jsp:param name="height" value="150px"/> 
													<jsp:param name="zIndex" value="220"/>
													<jsp:param name="actionsNames" value="Save#Cancel"/> 
													<jsp:param name="actions" value="javascript:saveNewFilter()#javascript:showHideGeneralAdminDiv('NewFilter')"/> 
												</jsp:include>
											</td>
										</tr>
										<%}%>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
							<div id="collectionDiv"  style="display:none;width:100%;overflow:auto" >
							<table border="0" width="98%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="<%=collectionPage%>" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="lbmId" value="<%=logId%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="rulesDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="logCollectionRules.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="lbmId" value="<%=logId%>" />
									<jsp:param name="filterId" value="<%=filterId%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%if (isSyslog){%>
							<div id="syslogRulesDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">
								<jsp:include page="../syslog/syslogCollectionAdmin.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="suffix" value="<%=suffix%>" />
									<jsp:param name="syslogId" value="<%=syslogId%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%}%>
							<%if (isSyslog && cu != null && confEntryKey != null){%>
							<div id="syslogRuleDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="../syslog/syslogRuleDefinition.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="suffix" value="<%=suffix%>" />
									<jsp:param name="embedded" value="true" />
									<jsp:param name="readOnly" value="true" />
									<jsp:param name="syslogId" value="<%=syslogId%>" />
									<jsp:param name="confEntryKey" value="<%=confEntryKey%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%}%>
							<div id="schedulerDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="logCollectionDefinitionSched.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="advancedDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="advancedSettings.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="rotationPolicy" value="<%=rotationPolicy%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%if (XpologSecurityManager.getInstance().isEnabled()){%>
							<div id="permissionsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding:10px">							
								<jsp:include page="../../../security/common/moduleMemberPermissionsIncluder.jsp" flush="true">
									<jsp:param name="embedded" value="true" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%if (!isSyslog){%>
							<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="collectionDiv" />
								<jsp:param name="name.1" value="<%=collectionTabName%>" />
								<jsp:param name="id.2" value="rulesDiv" />
								<jsp:param name="name.2" value="Data Rules" />
								<jsp:param name="id.3" value="schedulerDiv" />
								<jsp:param name="name.3" value="Collection Scheduler" />
								<jsp:param name="id.4" value="advancedDiv" />
								<jsp:param name="name.4" value="Advanced" />
							</jsp:include>
							<%}else { //syslog collector%>
							<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="<%=syslogRulesDivId%>" />
								<jsp:param name="name.1" value="Syslog Rules" />
								<jsp:param name="id.2" value="collectionDiv" />
								<jsp:param name="name.2" value="<%=collectionTabName%>" />
								<jsp:param name="id.3" value="rulesDiv" />
								<jsp:param name="name.3" value="Data Rules" />
								<jsp:param name="id.4" value="schedulerDiv" />
								<jsp:param name="name.4" value="Collection Scheduler" />
								<jsp:param name="id.5" value="advancedDiv" />
								<jsp:param name="name.5" value="Advanced" />
							</jsp:include>
							<%}%>
							<%}else{ %>
							<%if (!isSyslog){%>
							<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="collectionDiv" />
								<jsp:param name="name.1" value="<%=collectionTabName%>" />
								<jsp:param name="id.2" value="rulesDiv" />
								<jsp:param name="name.2" value="Data Rules" />
								<jsp:param name="id.3" value="schedulerDiv" />
								<jsp:param name="name.3" value="Collection Scheduler" />
								<jsp:param name="id.4" value="advancedDiv" />
								<jsp:param name="name.4" value="Advanced" />
							</jsp:include>
							<%}else { //syslog collector%>
							<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="<%=syslogRulesDivId%>" />
								<jsp:param name="name.1" value="Syslog Rules" />
								<jsp:param name="id.2" value="collectionDiv" />
								<jsp:param name="name.2" value="<%=collectionTabName%>" />
								<jsp:param name="id.3" value="rulesDiv" />
								<jsp:param name="name.3" value="Data Rules" />
								<jsp:param name="id.4" value="schedulerDiv" />
								<jsp:param name="name.4" value="Collection Scheduler" />
								<jsp:param name="id.5" value="advancedDiv" />
								<jsp:param name="name.5" value="Advanced" />
							</jsp:include>
							<%} %>								
							<%} %>								
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save@id=saveLogCollectionBtn@disableUponClick#Back to Log Collection" />
				<jsp:param name="actions" value="javascript:saveXpologCollection()#logcollection/logCollectionsView.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>
<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=310">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="20">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
					<span class="PROGRESSTEXT" id="messageTitle"></span>
			</td>
		</tr>
		<tr height="*" style="padding:5">
			<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
			</td>
		</tr>											
		<tr height="10">
			<td align="center" style="padding:5"><nobr>
				<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
				</nobr>		  							
			</td>
		</tr>
	</table>
</div>
<div id="logCollectionDefinitionErrorMsg" class="ERROR_MSG"></div>
<jsp:include page="../../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="SyslogRule"/> 
	<jsp:param name="width" value="700px"/> 
	<jsp:param name="height" value="300px"/>
	<jsp:param name="title" value="Priorities"/> 
	<jsp:param name="actionsNames" value="Save Rule@id=saveSyslogRuleBtn@disableUponClick#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveSyslogRule()#javascript:showHideGeneralAdminDiv('SyslogRule')"/> 
</jsp:include>
</form>
</body>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</html>