<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
	String KIWI_RULE = "KIWI_RULE";

	String op = request.getParameter("op");
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	request.getSession().removeAttribute(KIWI_RULE);
	
	String ruleSeq = request.getParameter("ruleSeq");
	if (ruleSeq == null) {
		ruleSeq = "";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String headerTitle = "";
	KiwiConfiguration kiwiConf = KiwiConfigurationManager.getInstance().getKiwiConf();
	int lastSeq = kiwiConf.getLastRuleSeq(); 
	
	KiwiRule rule = ruleSeq.length() == 0 ? null : kiwiConf.getRule(ruleSeq);
	
	if (rule == null){
		headerTitle = "Add Rule";
		rule = new KiwiRule();
	}else{
		if(rule.getSeq() == null) {
			headerTitle = "Add Rule";
		}else {
			headerTitle = "Edit Rule";
		}
	}
	
	request.getSession().setAttribute(KIWI_RULE,rule);

	String ruleInfo = rule.getRuleInfo();
	String ruleName = rule.getRuleName();
	if (ruleName == null){
		ruleName = "Rule " + (++lastSeq);
	}
	
%>
<%@page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogAction"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script language="JavaScript1" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<jsp:include page="../../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<style type="text/css">
a.RULE_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.RULE_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.RULE_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.RULE_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>

<%
String sysFileBrowserUrl = "../../../../common/sysFilesBrowser.jsp";
%>
<jsp:include page="<%=sysFileBrowserUrl%>" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
</jsp:include>

<script language="javascript">

	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";

	function init(){
		initTabs();
		initTables();
	}

	function showSaveSettings(){
		showHideLayerInMiddle("saveSettingsDiv",-1,-1);
	}
 
	function saveRule(){
		document.access.submit();
	}
	
	function setErrorColor(elem){
		if (elem){
			elem.className = 'ERROR_MSG_BACKGROUNDCOLOR';
		}
	}
	
	function hideMessageDiv(){
		document.getElementById("messageDiv").style.display = "none";
	}  
	
	// actions start
	function addLogToFile(){
		editLogToFileAction();
	}
	
	function editAction(){
    var actionType;
    var seq;
   	seq = getFirstSelectedRow(mygridActions);
   	actionType = mygridActions.getUserData(seq,"actionType");
    if (seq == "") {
			showHideLayerInMiddle2("messageDiv",300,200);
			document.getElementById("messageDiv").style.zIndex = 300;
			var msgTitle = document.getElementById("messageTitle");
			if (msgTitle){
				msgTitle.innerHTML = "No Row Selected";
			}
			var msgText = document.getElementById("messageText");
			if (msgText){
				msgText.innerHTML = "Please select an action to edit";
			}
			return;
    }
    if (actionType){
    	if(actionType == "<%=SyslogAction.LOG_TO_FILE_ACTION_TYPE%>"){
    		editLogToFileAction(seq);
    	}
    }
	}
	
	function editLogToFileAction(seq){
		var url = "logToFileDefinition.jsp?embedded=true&noScripts=true&suffix=LogToFile";
		if (seq){
			url += "&seq="+seq;
		}
		showAction("LogToFile",url,"Log to File");
	}
	
	function showAction(actionType,url,title){
		sendAjaxRequest(url,function(req){
			hideAllGeneralAdminDiv();
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not open log to file definition page");
				return;			
			}
			showGeneralAdminDiv(actionType);
			if (title){
				var t = document.getElementById("generalDivTitle"+actionType);
				if (t){
					t.innerHTML = title;
				}
			}
			updateGeneralAdminDiv(actionType,result);
		});
	}
	
	function saveAction(actionType){
		var params = getFormElementsQueryString(document.access,actionType);
		if(params == "falseInput"){
			return;
		}else{
			if (actionType){
				params += "&suffix=" + actionType + "&actionType=" + actionType;
			}
		}
		
		var url = "saveAction.jsp?" + params;
		sendAjaxRequest(url,function(req){
			var result = req.responseText;
			if (result){	
				result = result.replace(/^\s+|\s+$/g, '');
			}
			var resultStrs = result.split("#");
			if (resultStrs.length > 1 && resultStrs[0] == "SAVE_ACTION_ERROR"){
		    showHideLayerInMiddle2("messageDiv",300,200);
		    document.getElementById("messageDiv").style.zIndex = 300;
	    	var msgTitle = document.getElementById("messageTitle");
	    	if (msgTitle){
	    		msgTitle.innerHTML = "Save Action Error";
	    	}
	    	var msgText = document.getElementById("messageText");
	    	if (msgText){
	    		var msg = "";
	    		for (i=1; i<resultStrs.length; i++){
	    			if (msg != ""){
	    				msg = msg + "<br>";
	    			}
	    			msg = msg + resultStrs[i];
	    		}
	    		msgText.innerHTML = msg;
	    	}
			}else{
				var url = "<%=BASE_DIRECTORY%>logcollection/admin/syslog/kiwi/ruleActionsXML.jsp?dataOnly=true";
		  	mygridActions.clearAll();
		  	mygridActions.loadXML(url);
		  	hideAllGeneralAdminDiv();
			}				
		});
	}

	
	
	// browser start
	function openKiwiBrowser(txtboxId,suffix){
	 	showHideSysFileInMiddle(150,200);
	 	if (!suffix){
	 		suffix = "";
	 	}
		var rootDir = document.getElementById(txtboxId+suffix).value;
		loadSysFilesTree(rootDir,txtboxId+suffix,"");
	}

	function doOpenKiwiBrowser(txtboxId,suffix,e){
		var result = kiwiCheckKey(e);
  	if (result){
			openBrowser(txtboxId,suffix);
		}
	}

	function kiwiCheckKey(e){
	 	if (!e) var e = window.event;
			var code = e.keyCode;
			if (code == 13 ){
				return true;
		}
	}
	// browser end
	// actions end
	
	// filters start
	function addPriorityFilter(){
		editPriorityFilter();
	}
	
	function editFilter(){
    var filterType;
    var seq;
   	seq = getFirstSelectedRow(mygridFilters);
   	filterType = mygridFilters.getUserData(seq,"filterType");
    if (seq == "") {
			showHideLayerInMiddle2("messageDiv",300,200);
			document.getElementById("messageDiv").style.zIndex = 300;
			var msgTitle = document.getElementById("messageTitle");
			if (msgTitle){
				msgTitle.innerHTML = "No Row Selected";
			}
			var msgText = document.getElementById("messageText");
			if (msgText){
				msgText.innerHTML = "Please select a filter to edit";
			}
			return;
    }
    if (filterType){
    	if(filterType == "<%=KiwiPriorityFilter.KIWI_PRIORITY_FILTER_TYPE%>"){
    		editPriorityFilter(seq);
    	}
    }
	}
	
	function editPriorityFilter(seq){
		var url = "priorityFilterDefinition.jsp?embedded=true&noScripts=true&suffix=PriorityFilter";
		if (seq){
			url += "&seq="+seq;
		}
		showFilter("PriorityFilter",url,"Priorities");
	}
	
	function showFilter(filterType,url,title){
		sendAjaxRequest(url,function(req){
			hideAllGeneralAdminDiv();
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not open priority filter definition page");
				return;			
			}
			showGeneralAdminDiv(filterType);
			if (title){
				var t = document.getElementById("generalDivTitle"+filterType);
				if (t){
					t.innerHTML = title;
				}
			}
			updateGeneralAdminDiv(filterType,result);
		});
	}
	
	function saveFilter(filterType){
		var params = getFormElementsQueryString(document.access,filterType);
		if(params == "falseInput"){
			return;
		}else{
			if (filterType){
				params += "&suffix=" + filterType + "&filterType=" + filterType;
			}
		}
		
		var url = "saveFilter.jsp?" + params;
		sendAjaxRequest(url,function(req){
			var result = req.responseText;
			if (result){	
				result = result.replace(/^\s+|\s+$/g, '');
			}
			var resultStrs = result.split("#");
			if (resultStrs.length > 1 && resultStrs[0] == "SAVE_FILTER_ERROR"){
		    showHideLayerInMiddle2("messageDiv",300,200);
		    document.getElementById("messageDiv").style.zIndex = 300;
	    	var msgTitle = document.getElementById("messageTitle");
	    	if (msgTitle){
	    		msgTitle.innerHTML = "Save Filter Error";
	    	}
	    	var msgText = document.getElementById("messageText");
	    	if (msgText){
	    		var msg = "";
	    		for (i=1; i<resultStrs.length; i++){
	    			if (msg != ""){
	    				msg = msg + "<br>";
	    			}
	    			msg = msg + resultStrs[i];
	    		}
	    		msgText.innerHTML = msg;
	    	}
			}else{
				var url = "<%=BASE_DIRECTORY%>logcollection/admin/syslog/kiwi/ruleFiltersXML.jsp?dataOnly=true";
		  	mygridFilters.clearAll();
		  	mygridFilters.loadXML(url);
		  	hideAllGeneralAdminDiv();
			}				
		});
	}
	
	// filters end
	
</script>

<jsp:include page="../../../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="initXML" value="logcollection/admin/syslog/kiwi/ruleActionsXML.jsp" />
	<jsp:param name="suffix" value="Actions" />
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="recordsText" value="Actions" />
	<jsp:param name="doubleClickAction" value="editAction" />
</jsp:include>
<jsp:include page="../../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="initXML" value="logcollection/admin/syslog/kiwi/ruleFiltersXML.jsp" />
	<jsp:param name="suffix" value="Filters" />
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="recordsText" value="Filters" />
	<jsp:param name="doubleClickAction" value="editFilter" />
</jsp:include>
<jsp:include page="priorityFilterDefinition.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="embedded" value="true" />
	<jsp:param name="scriptsOnly" value="true" />
	<jsp:param name="suffix" value="PriorityFilter" />
</jsp:include>
<script>
	function selectTabHandler(idn,ido){
		if (!idn){
			return false;
		}
		hideAllGeneralAdminDiv();
		return true;
	}
</script>

<title></title>
</head>

<div id="addAccDiv" style="display:none">
</div>

<body onLoad="init()" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="kiwiRuleAction.jsp" style="margin:0;padding:0" method="POST">
<input type="hidden" name="doSave" value="true">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="1">
		<td>
			<jsp:include page="../../../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="ruleName" size="30" value="<%=ruleName%>" onClick="resetBgColor(this)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:5">&nbsp;</span></td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
							<div id="actionsDiv"  style="padding:10;display:none;height:98%;width:98%" >
								<jsp:include page="ruleActions.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
							</div>
							<div id="filtersDiv"  style="padding:10;display:none;height:98%;width:98%" >
								<jsp:include page="ruleFilters.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
							</div>
							<jsp:include page="../../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="actionsDiv" />
								<jsp:param name="name.1" value="Actions" />
								<jsp:param name="id.2" value="filtersDiv" />
								<jsp:param name="name.2" value="Filters" />
							</jsp:include>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../../../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Rules" />
				<jsp:param name="actions" value="javascript:saveRule()#logcollection/admin/syslog/kiwi/kiwiRulesView.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>
<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=310">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="20">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
					<span class="PROGRESSTEXT" id="messageTitle"></span>
			</td>
		</tr>
		<tr height="*" style="padding:5">
			<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
			</td>
		</tr>											
		<tr height="10">
			<td align="center" style="padding:5"><nobr>
				<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
				</nobr>		  							
			</td>
		</tr>
	</table>
</div>
<jsp:include page="../../../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="LogToFile"/> 
	<jsp:param name="width" value="750px"/> 
	<jsp:param name="height" value="350px"/>
	<jsp:param name="title" value="Log to File"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAction('LogToFile')#javascript:showHideGeneralAdminDiv('LogToFile')"/> 
</jsp:include>
<jsp:include page="../../../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="PriorityFilter"/> 
	<jsp:param name="width" value="750px"/> 
	<jsp:param name="height" value="350px"/>
	<jsp:param name="title" value="Priorities"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveFilter('PriorityFilter')#javascript:showHideGeneralAdminDiv('PriorityFilter')"/> 
</jsp:include>
</form>
</body>
</html>