<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.*"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.KiwiRule"%>

<%@ page import="xpolog.eye.site.*"%>

<%!
  static final String BASE_DIRECTORY = "../../../../";
%>


<%
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prioritiyFilterLabel = request.getParameter("prioritiyFilterLabel");
	if (prioritiyFilterLabel == null || prioritiyFilterLabel.length() == 0){
		prioritiyFilterLabel = "Priority";
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	String syslogId = request.getParameter("syslogId");
	//System.out.println("syslogId"+suffix+" = " + syslogId);
	String confEntryKey = request.getParameter("confEntryKey");
	String readOnlyStr = request.getParameter("readOnly");
	boolean readOnly = readOnlyStr != null && readOnlyStr.equals("true");
	
	SyslogsManager syslogsMgr = SyslogsManager.getInstance();
	Syslog syslog = syslogsMgr.getSyslog(syslogId);
	SyslogRule rule = null;
	SyslogSelector selector = null;
	SyslogAction action = null;
	String logFilePath = "";
	String ips = "";
	if (syslog != null && confEntryKey != null){
		SyslogConfiguration syslogConfiguration = syslogsMgr.getSyslogConfiguration(syslog.getId());
		SyslogConfData syslogConfData = syslogConfiguration != null ? syslogConfiguration.getSyslogConfData() : null;
		if (syslogConfData != null){
			SyslogConfEntry entry = syslogConfData.getEntry(confEntryKey);
			Object data = entry != null ? entry.getData() : null;
			if (data != null && data instanceof SyslogRule){
				rule = (SyslogRule)data;
				selector = rule.getDefaultSyslogSelector();
				action = rule.getDefaultSyslogAction();
				if (action != null){
					logFilePath = action.getValue();
				}
				if (rule instanceof KiwiRule){
					ips = ((KiwiRule)rule).getFilteredIps();
				}
			}
		}
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String name = "";
	
	if(confEntryKey == null){
		confEntryKey = "";
	}
	Facility[] facilities = SyslogConfigurationManager.getInstance().getSyslogProperties().getFacilities();
	Priority[] priorities = SyslogConfigurationManager.getInstance().getSyslogProperties().getPrioritiesOrdered();
	
%>

<%if (!embedded){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<style type="text/css">
a.PRIORITY_FILTER_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>
<%} %>

<%if (!noScripts){%>
<script>
	function selectAllPriorities(all){
		for (var i=0; i<<%=facilities.length%>; i++){
			for (var j=0; j<<%=priorities.length%>; j++){
				var cbName = i + "-" + j + "<%=suffix%>";
				var cb = document.getElementById(cbName);
				if (cb){
					if (all){
						cb.checked = true;
					}else{
						cb.checked = false;
					}
				}
			}
		}
	}
	
</script>
<%}%>
<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="syslogId<%=suffix%>" size="50" value="<%=syslogId%>">
<input type="hidden" name="confEntryKey<%=suffix%>" size="50" value="<%=confEntryKey%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=prioritiyFilterLabel%></span></td>
			</tr>
			<%}%>
 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:20px">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<%if (!embedded){%>
					<tr>
						<td>
							<span class="REGULARTEXT">Syslog Rule Details</span>
						</td>
					</tr>
					<%}%>
					<tr>
						<td style="padding-top:5px">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" height="260px">
								<tr>
									<td width="100" nowrap><span class="REGULARTEXT"><nobr>Syslog Log File Path</nobr></span></td>
									<td style="padding-left:5px">
										<%if (readOnly){%>
										<input type="TEXT" class="TEXTBOX" name="logFilePath<%=suffix%>" id="logFilePath<%=suffix%>" size="50" value="<%=logFilePath != null ? logFilePath : ""%>" readonly>
										<%}else{%>
										<input type="TEXT" class="TEXTBOX" name="logFilePath<%=suffix%>" id="logFilePath<%=suffix%>" onKeyPress="javascript:doOpenSyslogFileBrowser('logFilePath','<%=suffix%>',event);" size="50" value="<%=logFilePath != null ? logFilePath : ""%>" onClick="javascript:clearBgColor('logFilePath<%=suffix%>');">
										<span style="padding-left:5"><input type=button value="Browse" onClick="openSyslogFileBrowser('logFilePath','<%=suffix%>')">
										<%}%>
									</td>
								</tr>		
								<tr style="padding-top:5px">
									<td width="100" nowrap><span class="REGULARTEXT"><nobr>IP's</nobr></span></td>
									<td style="padding-left:5px">
										<input type="TEXT" class="TEXTBOX" name="ipRange<%=suffix%>" id="ipRange<%=suffix%>" size="50" value="<%=ips != null ? ips : ""%>" <%=readOnly ? "readOnly" : ""%>>
									</td>
								</tr>		
								<tr>
									<td width="100" nowrap><span class="REGULARTEXT">&nbsp;</span></td>
									<td><span class="SMALLTEXT"><nobr>&nbsp;Use comma (<b>,</b>) for discrete IP values or hyphen (<b>-</b>) for IP's range</nobr></span></td>
								</tr>		
								<%if (!readOnly){%>						
								<tr>
									<td colspan="2" style="padding-top:10px">
									<table border="0" cellspacing="0" height="100%" cellpadding="0">
										<tr>
											<td>
												<jsp:include page="../../../common/ctrlButton.jsp" flush="true">
												<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
												<jsp:param name="name" value="Select All"/>
												<jsp:param name="action" value="javascript:selectAllPriorities(true)"/> 
												<jsp:param name="buttonClass" value="SMALLLINK"/>
												</jsp:include>			
											</td>
											<td style="padding-left:10">
												<jsp:include page="../../../common/ctrlButton.jsp" flush="true">
												<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
												<jsp:param name="name" value="Unselect All"/>
												<jsp:param name="action" value="javascript:selectAllPriorities(false)"/> 
												<jsp:param name="buttonClass" value="SMALLLINK"/>
												</jsp:include>			
											</td>
										</tr>
									</table>
									</td>
								</tr>	
								<%}%>							
								<tr>
									<td colspan="2" style="padding-top:5px">
									<table border="1" cellpadding="0" cellspacing="0" width="98%">
									<%
									for (int i=0; i<facilities.length; i++){
										if (i == 0){
									%>
										<tr>
											<td>&nbsp;</td>
										<%
											for (int j=0; j<priorities.length; j++){
										%>
											<td align="center"><span class="REGULARTEXT"><%=priorities[j].getName()%></span></td>
										<%}%> 
										</tr>
										<%}%>

										<tr align="left">
											<td><span class="REGULARTEXT" style="padding-left:3px"><%=facilities[i].getName()%></span></td>
										<%
										for (int j1=0; j1<priorities.length; j1++){
											boolean used = selector != null && selector.hasPriorityForFacility(facilities[i].getName(),priorities[j1].getName());
											String checked = used ? "checked" : "";
											String cbName = i + "-" + j1 + suffix;
										%>
											<td align="center">
												<input class="CHECKBOX" type="checkbox" name="<%=cbName%>" id="<%=cbName%>" <%=checked%> value="true" <%=readOnly?"disabled":""%>>
											</td>
									<%} //end priorities loop%>
									</tr>
									<%} //end facilities loop%>
									</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="101%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>