<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.storage.StorageAdapter"%>
<%@ page import="com.xpolog.logcollection.storage.StorageHandler"%>
<%@ page import="com.xpolog.logcollection.storage.StoragePolicy"%>
<%@ page import="com.xpolog.logcollection.StorageManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String systemStr = request.getParameter("system");
	boolean isSystem = systemStr != null && systemStr.equals("true");
	String shId = request.getParameter("shId");
	String saId = request.getParameter("saId");
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	StorageManager storageMgr = LogCollectionManager.getInstance().getStorageMgr();

	StorageHandler storageHandler = null;
	StorageAdapter storageAdapter = null;
	StoragePolicy policy = null;
	
	if (isSystem){
		storageHandler = sysMgr.getDefaultStorageHandler();
		storageAdapter = storageHandler != null ? storageHandler.getStorageAdapter() : null;
		policy = storageAdapter != null ? storageAdapter.getPolicy() : null;
	}else if (shId != null && shId.length() > 0 && saId != null && saId.length() > 0){
		storageHandler = storageMgr.getStorageHandlerById(shId);
		storageAdapter = storageHandler != null ? storageHandler.getStorageAdapterById(saId) : null;
		policy = storageAdapter != null ? storageAdapter.getPolicy() : null;
	}

	String archiveFilesAgeStr = "";
	String deleteFilesAgeStr = "";
	int archiveTimeUnit = Constants.TimeUnits.DAYS;
	int deleteTimeUnit = Constants.TimeUnits.MONTHS;
	if (policy != null){
		archiveFilesAgeStr = String.valueOf(policy.getArchiveFilesAge());
		archiveTimeUnit = policy.getArchiveFilesTimeUnitType();
		deleteFilesAgeStr = String.valueOf(policy.getDeleteFilesAge());
		deleteTimeUnit = policy.getDeleteFilesTimeUnitType();
	}
	int[] timeUnits = Constants.TimeUnits.getTimeUnits();
	if (archiveFilesAgeStr != null && archiveFilesAgeStr.equals("0")){
		archiveFilesAgeStr = "";
	}
	if (deleteFilesAgeStr != null && deleteFilesAgeStr.equals("0")){
		deleteFilesAgeStr = "";
	}
	
%>

<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<tr>
		<td><span class="REGULARTEXT"><nobr>Archive Files Older than: </nobr></span></td>
		<td style="padding-left:4px"><span class="REGULARTEXT"><input type="text" name="archiveFilesAge_<%=suffix%>" size="5" value="<%=archiveFilesAgeStr%>"></span></td>
		<td style="padding-left:4px">
			<select class="TEXTBOX" size="1" name="archiveAgeTimeUnitType_<%=suffix%>">
				<option value="none">&nbsp;</option>
			<%
			for (int i=0; i<timeUnits.length; i++){
				String selected = (timeUnits[i] == archiveTimeUnit ? "selected" : "");
				String unitDesc = Constants.TimeUnits.getUnitDescription(timeUnits[i]);
			%>
				<option value="<%=timeUnits[i]%>" <%=selected%>><%=unitDesc%></option>
			<%}%>
			</select>
		</td>
		<td width="100%">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="4"><span class="SMALLTEXT">Files satisfying the above rule will be moved from the storage repository to the archive repository</span></td>
	</tr>
	<tr>
		<td><span class="REGULARTEXT"><nobr>Delete Files Older than: </nobr></span></td>
		<td style="padding-left:4px"><span class="REGULARTEXT"><input type="text" name="deleteFilesAge_<%=suffix%>" size="5" value="<%=deleteFilesAgeStr%>"></span></td>
		<td style="padding-left:4px">
			<select class="TEXTBOX" size="1" name="deleteAgeTimeUnitType_<%=suffix%>">
				<option value="none">&nbsp;</option>
			<%
			for (int i=0; i<timeUnits.length; i++){
				String selected = (timeUnits[i] == deleteTimeUnit ? "selected" : "");
				String unitDesc = Constants.TimeUnits.getUnitDescription(timeUnits[i]);
			%>
				<option value="<%=timeUnits[i]%>" <%=selected%>><%=unitDesc%></option>
			<%}%>
			</select>
		</td>
		<td width="100%">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="4"><span class="SMALLTEXT">Files satisfying the above rule will be removed from the archive repository</span></td>
	</tr>
</table>