<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.data.writers.SshPacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.DatePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileNamePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileSeqIdPattern"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfoConstraints"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String type = request.getParameter("type");
	if (type == null){
		type = "";
	}
	String writerType = type.equals("ssh") ? SshPacketWriter.SSH_PACKET_WRITER_TYPE : null;
	if (writerType != null){
		suffix += writerType;
	}

	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = suffix;
	}
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
		
	String locationIndexStr = request.getParameter("locationIndex");
	int locationIndex = 0;
	if (locationIndexStr != null && locationIndexStr.length() > 0){
		locationIndex = Integer.parseInt(locationIndexStr);
	}
	String collectionSettingsDesc = request.getParameter("collectionSettingsDesc");
	if (collectionSettingsDesc == null || collectionSettingsDesc.length() == 0){
		collectionSettingsDesc = "Collection Settings";
	}
	String targetFileDirDesc = request.getParameter("targetFileDirDesc");
	if (targetFileDirDesc == null || targetFileDirDesc.length() == 0){
		targetFileDirDesc = "Target Directory";
	}
	String locationInfoId = request.getParameter("locationInfoId");
	String showConstraintsStr = request.getParameter("showConstraints");
	boolean showConstraints = showConstraintsStr != null && showConstraintsStr.equals("true");
	String defaultLocationInfoId = request.getParameter("defaultLocationInfoId");
	String showDefaultStr = request.getParameter("showDefault");
	boolean showDefault = showDefaultStr != null && showDefaultStr.equals("true");
	String showCheckBoxStr = request.getParameter("showCheckBox");
	boolean showCheckBox = showCheckBoxStr != null && showCheckBoxStr.equals("true");
	String checkBoxDesc = request.getParameter("checkBoxDesc");
	if (checkBoxDesc == null || checkBoxDesc.length() == 0){
		checkBoxDesc = "Write to file";
	}
	String activeStr = request.getParameter("active");
	boolean active = activeStr != null && activeStr.equals("true");
	String fileFilter = request.getParameter("fileFilter");
	if (fileFilter == null){
		fileFilter = "dirOnly";
	}
	
	String targetId = request.getParameter("targetId");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	FileLocationInfo fli = null;
	FileLocationInfo dfli = null;
	LocationInfoConstraints constraints = null;
	boolean useDefault = true;
	if (locationInfoId != null && locationInfoId.length() > 0){
		fli = (FileLocationInfo)request.getAttribute(locationInfoId);
		if (fli != null){
			fli = (FileLocationInfo)fli.clone();
			fli.init();
			String fliPath = fli.getPath(false,false); 
			useDefault = fliPath == null || fliPath.equals(FileLocationInfo.DEFAULT_COLLECTION_PATH);
			constraints = fli.getConstraints();
		}
		request.getSession().removeAttribute(locationInfoId);
	}
	
	Account defaultAcc = null;
	String defaultLocPath = null;
	if (showDefault && defaultLocationInfoId != null && defaultLocationInfoId.length() > 0){
		dfli = (FileLocationInfo)request.getAttribute(defaultLocationInfoId);
		if (dfli != null){
			dfli = (FileLocationInfo)dfli.clone();
			dfli.init();
			defaultLocPath = dfli.getPath(false,false);
			defaultAcc = dfli.getAccount();
		}
		if (fli == null){
			fli = dfli;
		}
		request.getSession().removeAttribute(defaultLocationInfoId);
		//constraints = dfli.getConstraints();
	}
	
	if (locationInfoId == null){
		locationInfoId = "";
	}
	Account acc = null;
	String accId = "";
	String path = "";
	String fileNamePattern = "";
	String fileNamePatternSuffix = "";
	boolean useFileNamePattern = true;
	boolean useDatePattern = false;
	boolean useSeqPattern = false;
	boolean compress = false;
	int[] sizeUnits = Constants.InformationUnits.getInformationUnits();
	long maxSize = constraints != null ? constraints.getMaxSize() : -1;
	int sizeUnit = constraints != null ? constraints.getSizeType() : -1;
	double maxPercent = constraints != null ? constraints.getMaxPercent() : -1;
	if (fli != null){
		path = fli.getPath(false,false);
		fileNamePattern = fli.getFileNamePattern();
		fileNamePatternSuffix = fli.getFilePatternSuffix();
		useDatePattern = fli.hasPatternFromType(DatePattern.DATE_PATTERN_TYPE);
		useSeqPattern = fli.hasPatternFromType(FileSeqIdPattern.FILE_SEQ_ID_PATTERN_TYPE);
		useFileNamePattern = fli.hasPatternFromType(FileNamePattern.FILE_NAME_PATTERN_TYPE);
		compress = fli.isCompress();
		acc = fli.getAccount();
		if (acc != null){
			accId = acc.getId();
		}
	}
	if (path == null || path.equals(FileLocationInfo.DEFAULT_COLLECTION_PATH)){
		path = "";
	}
	if (fileNamePattern == null){
		fileNamePattern = "";
	}
	String maxSizeStr = maxSize > 0 ? String.valueOf(maxSize) : "";
	String maxPercentStr = maxPercent > 0 ? String.valueOf(maxPercent) : "";
	String datePatternChecked = useDatePattern ? "checked" : "";
	String seqPatternChecked = useSeqPattern ? "checked" : "";
	String namePatternChecked = useFileNamePattern ? "checked" : "";
	String compressChecked = compress ? "checked" : "";
	String activeChecked = active ? "checked" : "";
	String divStyle = active ? "" : "style=\"display:none;\"";
	
  UserContext userContext = UserEnvironment.getUserContext(request);
  String accountsListId = type != null && type.length() > 0 ? prefix + "AccountsList" : "";

%>

<%if (!noScripts){%>
<script>
function showHideFileLocationInfoDiv(cb,divid){
	var d = document.getElementById(divid);
	if (divid && cb){
		if (cb.checked == true){
			d.style.display = "";
		}else{
			d.style.display = "none";
		}
	}
}

function openNewLocationAccountDiv(){
	openNewAccDiv('addAccDiv','ssh','','new','<%=prefix%>AccountsList','<%=baseDirectory%>');
}

</script>
<%}%>

<%if (!scriptsOnly){%>
<%if (targetId != null && targetId.length() > 0){%>
<input type="hidden" name="fileLocationTarget_<%=suffix%>" value="<%=targetId%>">
<%}%>
<%if (writerType != null && writerType.length() > 0){%>
<input type="hidden" name="fileLocationType_<%=suffix%>" value="<%=writerType%>">
<%}%>
<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%if (showDefault){%>
	<tr>
		<td>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%if (showCheckBox){%>
			<tr>
				<td style="padding-top:10px">
					<input type="hidden" name="fileLocationInfoCheckBox_<%=suffix%>" id="fileLocationInfoCheckBox_<%=suffix%>" value="true">
					<input type="checkbox" name="useFileLocationInfo_<%=suffix%>" id="useFileLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideFileLocationInfoDiv(this,'fileLocationInfoDiv_<%=suffix%>')">
				</td>
				<td style="padding-top:10px;padding-left:3px" width="100%">
					<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
				</td>
			</tr>
			<%}%>
			<%if (showCheckBox){%>
			<tr>
				<td>&nbsp;</td>
				<td>
				<div id="fileLocationInfoDiv_<%=suffix%>" <%=divStyle%>>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%}%>
			<tr>
				<td colspan="2" style="padding-top:5px;padding-left:5px">
					<span class="REGULARTEXT"><%=showCheckBox?"":"<b>"%><%=targetFileDirDesc%>:<%=showCheckBox?"":"</b>"%></span>
				</td>
			</tr>
			<tr>
				<td style="padding-top:5px"><input type="radio" name="infoType_<%=suffix%>" id="infoType_<%=suffix%>" value="default" <%=useDefault ? "checked" : ""%>></td>
				<td style="padding-top:5px">
					<span class="REGULARTEXT">Default <%=defaultLocPath != null ? "(" + defaultLocPath + ")" : ""%></span>
				</td>
			</tr>
			<!--  Account Start -->
			<%if (type != null && type.equals("ssh")){%>
			<tr>
				<td colspan="2" width="100%" style="padding-top:5px">
					<div id="<%=prefix%>logAccountDiv""> 			                   
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">                                        
						<tr>
							<td width="25%"><span class="REGULARTEXT">Connection Details: </span></td>
							<td width="100px" style="padding-left:3px">
								<div id="<%=prefix%>accountsListDiv" style="display">
									<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
									<jsp:param name="ACC_TYPE" value="<%=type%>"/>
									<jsp:param name="ACC_ID" value="<%=accId%>"/>
									<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
									<jsp:param name="PREFIX" value="<%=prefix%>"/>
									<jsp:param name="noScripts" value="true"/>
									</jsp:include> 																								
								</div>
							</td>
							<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
					    <td width="6">&nbsp;</td>
							<td style="padding-left:5">
								<div id="<%=prefix%>newAccountDiv">
									<span class="SMALLTEXT"><a href="javascript:openNewLocationAccountDiv('<%=baseDirectory%>')" class="BUTTON_MEDIUMLINK">new</a></span>
								</div>	
							</td>
							<%} %>
							<td width="*">&nbsp;</td>
						</tr>
						<tr>
							<td width="23%" style="font-size:1px">&nbsp;</td>
							<td colspan="4">
								<div id="<%=prefix%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
							</div>
							</td>
						</tr>																																																																																																				
					</table>
					</div>  
				</td>
			</tr>
			<%}%>
			<!-- Account end -->
			<tr>
				<td><input type="radio" name="infoType_<%=suffix%>" id="infoType_<%=suffix%>" value="manual" <%=!useDefault ? "checked" : ""%>></td>
				<td>
					<span class="REGULARTEXT">Custom </span>
					<input type="text" class="TEXTBOX" name="fullPath_<%=suffix%>" id="fullPath_<%=suffix%>" 
					onKeyPress="javascript:doOpenBrowserCollection('fullPath_<%=locationIndex%>','<%=locationIndex%>',event);" onClick="clearBgColor('fullPath_<%=suffix%>');selectManual('<%=suffix%>')" onChange="javascript:clearErr('<%=suffix%>')" size="75" value="<%=path%>">
					<input type="button" id="fileBrowseButton_<%=suffix%>" value="Browse" style="padding-left:5px"  onClick="openBrowserCollection('fullPath_<%=suffix%>','<%=accountsListId%>','<%=fileFilter%>')">
				</td>
			</tr>
			<tr id="fullPath_<%=suffix%>ErrorMsgTR" style="display:none">
				<td>&nbsp;</td>
				<td>
					<div id="fullPath_<%=suffix%>ErrorMsg" class="ERROR_MSG">
					</div>
				</td>
			</tr>
			<%if (showCheckBox){%>
				</table>
				</div>
				</td>
			</tr>
			<%}%>
			
		</table>
		</td>
	</tr>
	<%}else{%>
	<%if (showCheckBox){%>
	<tr>
		<td style="padding-top:10px">
			<input type="hidden" name="fileLocationInfoCheckBox_<%=suffix%>" id="fileLocationInfoCheckBox_<%=suffix%>" value="true">
			<input type="checkbox" name="useFileLocationInfo_<%=suffix%>" id="useFileLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideFileLocationInfoDiv(this,'fileLocationInfoDiv_<%=suffix%>')">
		</td>
		<td style="padding-top:10px;padding-left:3px" width="100%">
			<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
		</td>
	</tr>
	<%}%>
	<%if (showCheckBox){%>
	<tr>
		<td>&nbsp;</td>
		<td>
		<div id="fileLocationInfoDiv_<%=suffix%>" <%=divStyle%>>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%}%>
	<!--  Account Start -->
	<%if (type != null && type.equals("ssh")){%>
	<tr>
		<td colspan="2" width="100%" style="padding-top:5px">
			<div id="<%=prefix%>logAccountDiv""> 			                   
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">                                        
				<tr>
					<td width="25%"><span class="REGULARTEXT">Connection Details: </span></td>
					<td width="100px" style="padding-left:3px">
						<div id="<%=prefix%>accountsListDiv" style="display">
							<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
							<jsp:param name="ACC_TYPE" value="<%=type%>"/>
							<jsp:param name="ACC_ID" value="<%=accId%>"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value="<%=prefix%>"/>
							<jsp:param name="noScripts" value="true"/>
							</jsp:include> 																								
						</div>
					</td>
					<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    <td width="6">&nbsp;</td>
					<td style="padding-left:5">
						<div id="<%=prefix%>newAccountDiv">
							<span class="SMALLTEXT"><a href="javascript:openNewLocationAccountDiv('<%=baseDirectory%>')" class="BUTTON_MEDIUMLINK">new</a></span>
						</div>	
					</td>
					<%} %>
					<td width="*">&nbsp;</td>
				</tr>
				<tr>
					<td width="23%" style="font-size:1px">&nbsp;</td>
					<td colspan="4">
						<div id="<%=prefix%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
					</div>
					</td>
				</tr>																																																																																																				
			</table>
			</div>  
		</td>
	</tr>
	<%}%>
	<!-- Account end -->
	<tr>
		<td colspan="2">
			<span class="REGULARTEXT"><%=targetFileDirDesc%>: </span>
			<input type="text" class="TEXTBOX" name="fullPath_<%=suffix%>" id="fullPath_<%=suffix%>" onKeyPress="javascript:doOpenBrowserCollection('fullPath_<%=locationIndex%>','<%=locationIndex%>',event);" size="75" value="<%=path%>">
			<input type="button" id="fileBrowseButton_<%=suffix%>" value="Browse" onClick="openBrowserCollection('fullPath_<%=suffix%>','<%=accountsListId%>','<%=fileFilter%>')">
		</td>
	</tr>
	<tr id="fullPath_<%=suffix%>ErrorMsgTR" style="display:none">
		<td>&nbsp;</td>
		<td>
			<div id="fullPath_<%=suffix%>ErrorMsg" class="ERROR_MSG">
			</div>
		</td>
	</tr>
	
	<%if (showCheckBox){%>
		</table>
		</div>
		</td>
	</tr>
	<%}%>
	
	<%}%>
	<%if (showConstraints){%>
	<!-- 
	<tr>
		<td style="padding-top:5px">
			<span class="REGULARTEXT"><b>Constraints</b></span>
		</td>
	</tr>
	 -->
	<tr>
		<td style="padding-top:10px">
			<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
				<tr>
					<td>
						<span class="REGULARTEXT"><nobr>Max Disk Space: </nobr></span>
					</td>
					<td>
						<table border="0" height="100%" cellpadding="0" cellspacing="0">
							<tr>
								<td style="padding-left:3px">
									<input type="text" class="TEXTBOX" name="maxSize_<%=suffix%>" id="maxSize_<%=suffix%>" size="10" value="<%=maxSizeStr%>">
								</td>
								<td style="padding-left:4px">
									<select name="sizeUnitType_<%=suffix%>">
									<%
									for (int i=2; i<sizeUnits.length; i++){
										String selected = (sizeUnits[i] == sizeUnit || sizeUnit == -1 ? "selected" : "");
										String unitDesc = Constants.InformationUnits.getUnitDescription(sizeUnits[i]);
									%>
										<option value="<%=sizeUnits[i]%>" <%=selected%> class="TEXTBOX"><%=unitDesc%></option>
									<%}%>
									</select>
								</td>
							</tr>
						</table>
					</td>			
					<td width="100%">&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
	<%}%>
</table>
<%}%>