<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.collection.SourcePolicy"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.PacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileRotationPolicy"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.DatePattern"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.logcollection.adapters.LogSourcePolicy"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String CHECKSUM_LOCATION_INFO_ID = "ChecksumLocationInfoId";
	String DEFAULT_CHECKSUM_LOCATION_INFO_ID = "DefaultChecksumLocationInfoId";

	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String collectionSettingsDesc = request.getParameter("collectionSettingsDesc");
	if (collectionSettingsDesc == null || collectionSettingsDesc.length() == 0){
		collectionSettingsDesc = "Collection Settings";
	}
	String targetFileDirDesc = request.getParameter("targetFileDirDesc");
	if (targetFileDirDesc == null || targetFileDirDesc.length() == 0){
		targetFileDirDesc = "Target Directory";
	}
	String locationInfoId = request.getParameter("locationInfoId");
	if (locationInfoId == null){
		locationInfoId = "";
	}
	String packetWriterId = request.getParameter("packetWriterId");
	String defaultPacketWriterId = request.getParameter("defaultPacketWriterId");

	String sourcePolicyId = request.getParameter("sourcePolicyId");
	if (sourcePolicyId == null){
		sourcePolicyId = "";
	}

	String showDefaultStr = request.getParameter("showDefault");
	boolean showDefault = showDefaultStr != null && showDefaultStr.equals("true");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String mailTo = request.getParameter("mailTo");
	if (mailTo == null){
		mailTo = "";
	}
	
	String showSecurityPolicyStr = request.getParameter("showSecurityPolicy");
	boolean showSecurityPolicy = showSecurityPolicyStr == null || showSecurityPolicyStr.equals("true");
	
	//String rotationPolicy = request.getParameter("rotationPolicy");
	
	FilePacketWriter fpr = null;
	FilePacketWriter dfpr = null;
	FileLocationInfo fli = null;
	FileLocationInfo dfli = null;
	FileLocationInfo csli = null; //checksum location info 
	FileLocationInfo dcsli = null; //default checksum location info 
	LogSourcePolicy lsp = null;

	if (packetWriterId != null && packetWriterId.length() > 0){
		fpr = (FilePacketWriter)request.getAttribute(packetWriterId);
		if (fpr != null){
			fli = fpr.getFileLocationInfo();
			if (fli != null){
				fli = (FileLocationInfo)fli.clone();
				fli.init();
			}
			request.getSession().removeAttribute(packetWriterId);
		}
	}
	
	if (sourcePolicyId != null && sourcePolicyId.length() > 0){
		SourcePolicy sp = (SourcePolicy)request.getAttribute(sourcePolicyId);
		if (sp instanceof LogSourcePolicy){
			lsp = (LogSourcePolicy)sp;
			request.getSession().removeAttribute(sourcePolicyId);
		}
	}

	
	if (false && showDefault && defaultPacketWriterId != null && defaultPacketWriterId.length() > 0){
		dfpr = (FilePacketWriter)request.getAttribute(defaultPacketWriterId);
		if (dfpr != null){
			dfli = dfpr.getFileLocationInfo();
			if (dfli != null){
				dfli = (FileLocationInfo)dfli.clone();
				dfli.init();
			}
			if (fpr == null){
				fpr = dfpr;
				if (fli == null){
					fli = dfli;
				}
			}
			request.getSession().removeAttribute(defaultPacketWriterId);
			//constraints = dfli.getConstraints();
		}
	}
	csli = fpr != null ? fpr.getChecksumLocationInfo() : null;
	if (csli != null){
		request.setAttribute(CHECKSUM_LOCATION_INFO_ID,csli);
	}
	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	FileLocationInfo defaultChecksumLocationInfo = sysMgr.getDefaultChecksumLocationInfo();
	if (defaultChecksumLocationInfo != null){
		request.setAttribute(DEFAULT_CHECKSUM_LOCATION_INFO_ID,defaultChecksumLocationInfo);
	}

	
	String checkSum = fpr != null ? fpr.getCheckSumAlgorithm() : "";
	String md5Selected = checkSum != null && checkSum.equals(PacketWriter.MD5_CHECK_SUM) ? "selected" : "";
	String sha1Selected = checkSum != null && checkSum.equals(PacketWriter.SHA1_CHECK_SUM) ? "selected" : "";
	if (packetWriterId == null){
		packetWriterId = "";
	}
	FileRotationPolicy rotationPolicy = null;
	String path = "";
	String fileNamePattern = "";
	String datePattern = "";
	//String noRotation = rotationPolicy == null || rotationPolicy.length() == 0 ? "selected" : "";
	//String hourly = rotationPolicy != null && rotationPolicy.equals("hourly") ? "selected" : "";
	//String daily = rotationPolicy != null && rotationPolicy.equals("daily") ? "selected" : "";
	String noRotation = "";
	boolean byDate = true;
	boolean bySize = false;
	boolean hourly = false;
	boolean daily = true;
	long fileSize = 0;
	int fileSizeUnit = 0;
	
	boolean compress = false;
	if (fli != null){
		path = fli.getPath();
		rotationPolicy = fli.getRotationPolicy();
		fileNamePattern = fli.getFileNamePattern();
		if (rotationPolicy != null){
			if (rotationPolicy.isDateRotation()){
				byDate = true;
				bySize = false;
				if (rotationPolicy.getDateRotationType().equals(FileRotationPolicy.HOURLY)){
					hourly = true;
					daily = false;
				}else if (rotationPolicy.getDateRotationType().equals(FileRotationPolicy.DAILY)){
					hourly = false;
					daily = true;
				} 
			}else if (rotationPolicy.isSizeRotation()){
				byDate = false;
				bySize = true;
				fileSize = rotationPolicy.getFileSize();
				fileSizeUnit = rotationPolicy.getFileSizeUnit();
			}
		}else{
			byDate = false;
			bySize = false;
		}
		compress = fli.isCompress();
	}
	if (path == null){
		path = "";
	}
	if (fileNamePattern == null){
		fileNamePattern = "";
	}
	String compressChecked = compress ? "checked" : "";
	String disableIndexingChecked = lsp != null && lsp.isDisableIndexingOfSourceLogs() ? "checked" : "";
	String disableDashboardChecked = lsp != null && lsp.isDisableDashboardForSourceLogs() ? "checked" : "";
	
	String analyticsH = Configuration.getInstance().getString(xpolog.eye.util.Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>

<%if (!noScripts){%>
<script>
function changeRotationType(){
	var selectedIndex = document.access.rotateBy_<%=suffix%>.selectedIndex ;
	var byDateDiv = document.getElementById("rotateByDate_<%=suffix%>");
	var bySizeDiv = document.getElementById("rotateBySize_<%=suffix%>");
	if (selectedIndex == 0){
		byDateDiv.style.display = "none";
		bySizeDiv.style.display = "none";
	}else if (selectedIndex == 1){
		byDateDiv.style.display = "";
		bySizeDiv.style.display = "none";
	}else if (selectedIndex == 2){
		byDateDiv.style.display = "none";
		bySizeDiv.style.display = "";
	} 
}

function showHideChecksumDiv(){
	var checksumAlgElement = document.getElementById("checkSumAlgorithm_<%=suffix%>");
	var checksumAlg = checksumAlgElement.options[checksumAlgElement.selectedIndex].value;
	
	var checksumDiv = document.getElementById("checksumLocationDiv");
	if (checksumAlg == ""){
		checksumDiv.style.display = "none";
	}else{
		checksumDiv.style.display = "";
	}
}
</script>
<%}%>

<%if (!scriptsOnly){%>
<input type="hidden" name="fileNamePattern_<%=suffix%>" id="fileNamePattern_<%=suffix%>" value="<%=fileNamePattern%>">
<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<tr>
		<td style="padding-left:5px">
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					<tr>
						<td style="padding-top:10px">
							<span class="REGULARTEXT"><b>Rotation Policy</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:5px">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td>
									<span class="REGULARTEXT">Rotate file </span>
									<select name="rotateBy_<%=suffix%>" id="rotateBy_<%=suffix%>" class="TEXTBOX" onChange="changeRotationType()">
										<option value="none" <%=noRotation%>>Never (create replica)</option>
										<option value="<%=FileRotationPolicy.BY_DATE%>" <%=byDate?"selected":""%>>By date</option>
										<option value="<%=FileRotationPolicy.BY_FILE_SIZE%>" <%=bySize?"selected":""%>>By file size</option>
									</select>
								</td>
								<td style="padding-left:2px">
									<div id="rotateByDate_<%=suffix%>" <%=byDate?"":"style=\"display:none\""%>>
									<select name="dateRotation_<%=suffix%>" id="dateRotation_<%=suffix%>" class="TEXTBOX">
										<option value="<%=FileRotationPolicy.HOURLY%>" <%=hourly?"selected":""%>>Hourly</option>
										<option value="<%=FileRotationPolicy.DAILY%>" <%=daily?"selected":""%>>Daily</option>
									</select>
									</div>
								</td>
								<td style="padding-left:2px">
									<div id="rotateBySize_<%=suffix%>" <%=bySize?"":"style=\"display:none\""%>>
									<span style="padding-left:2px;padding-right=2px">
									<input name="sizeRotation_<%=suffix%>" id="sizeRotation_<%=suffix%>" type="text" size="5" value="<%=fileSize > 0?String.valueOf(fileSize):""%>">
									</span>
									<select name="sizeRotationUnit_<%=suffix%>" id="sizeRotationUnit_<%=suffix%>" class="TEXTBOX">
										<option value="<%=Constants.InformationUnits.MBYTE%>" <%=fileSizeUnit==Constants.InformationUnits.MBYTE?"selected":""%>>MB</option>
										<option value="<%=Constants.InformationUnits.GBYTE%>" <%=fileSizeUnit==Constants.InformationUnits.GBYTE?"selected":""%>>GB</option>
									</select>
									</div>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					<tr>
						<td style="padding-top:15px">
							<span class="REGULARTEXT"><b>Compression Policy</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:5px">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td>
									<span class="REGULARTEXT">Compress data </span>
									<span style="vertical-align:middle"><input type="checkbox" name="compress_<%=suffix%>" id="compress_<%=suffix%>" value="true" <%=compressChecked%>></span>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			
			<%if (showSecurityPolicy){%>
			<tr>
				<td>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					<tr>
						<td style="padding-top:15px">
							<span class="REGULARTEXT"><b>Security Policy</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:5px">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td>
									<span class="REGULARTEXT">Checksum algorithm: </span>
									<select name="checkSumAlgorithm_<%=suffix%>" id="checkSumAlgorithm_<%=suffix%>" class="TEXTBOX" onchange="javascript:showHideChecksumDiv()">
										<option value="">None</option>
										<option value="MD5" <%=md5Selected%>><%=PacketWriter.MD5_CHECK_SUM%></option>
										<option value="SHA1" <%=sha1Selected%>><%=PacketWriter.SHA1_CHECK_SUM%></option>
									</select>
								</td>
							</tr>
							<tr>
								<%
								String checksumSuffix = suffix + "Checksum";
								String checksumLocationStyle = ((md5Selected+sha1Selected).length() > 0) ? "" : "style=\"display:none\""; 
								%>
								<td style="padding-top:10px">
									<div id="checksumLocationDiv" <%=checksumLocationStyle%>>
										<table border="0" cellpadding="0" cellspacing="0">
											<tr>
												<td colspan="2">
													<jsp:include page="../../logcollection/common/checksumLocation.jsp">
														<jsp:param name="baseDirectory" value="../../../"/>
														<jsp:param name="locationInfoId" value="<%=CHECKSUM_LOCATION_INFO_ID%>"/>
														<jsp:param name="defaultLocationInfoId" value="<%=DEFAULT_CHECKSUM_LOCATION_INFO_ID%>"/>
														<jsp:param name="targetFileDirDesc" value="Default Checksums Location"/>
														<jsp:param name="active" value="true"/>
														<jsp:param name="suffix" value="<%=checksumSuffix%>"/>
													</jsp:include>
												</td>
											</tr>
										</table>
									</div>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<%}%>
			
			<tr>
				<td>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					<tr>
						<td style="padding-top:15px">
							<span class="REGULARTEXT"><b>Notifications</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:5px">
							<table border="0" cellpadding="0" cellspacing="0">
								<tr>
									<td style="padding-top:5px"><span class="REGULARTEXT">Send error notifications to: </span></td>
									<td style="padding-left: 10">
										<input type="text" name="mailTo" size="40" value="<%=mailTo%>">
										<span class="SMALLTEXT">semicolon separated list</span>
									</td>										
								</tr>
							</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			
			<tr>
				<td>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					<tr>
						<td style="padding-top:15px">
							<span class="REGULARTEXT"><b>Source (Online) Log</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:5px">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td>
									<span class="REGULARTEXT">Disable Indexing of Source Log</span>
									<span style="vertical-align:middle"><input type="checkbox" name="disableIndexing_<%=suffix%>" id="disableIndexing_<%=suffix%>" value="true" <%=disableIndexingChecked%>></span>
								</td>
							</tr>
							<tr>
								<td>
									<span class="REGULARTEXT">Disable <%=analyticsH %> for Source Log</span>
									<span style="vertical-align:middle"><input type="checkbox" name="disableDashboard_<%=suffix%>" id="disableDashboard_<%=suffix%>" value="true" <%=disableDashboardChecked%>></span>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
	
</table>
<%}%>