<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.BatchAdapter"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.ReaderAdapter"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogsManager"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.KiwiConfigurationManager"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.KiwiHelper"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogCollectionPermissions.VIEW_LOG_COLLECTION_PERMISSION,true)){
	  return;
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	boolean isAdd = manager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.EDIT_LOG_COLLECTOR_PERMISSION) && manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION);
	boolean isExecute = true;//manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EXECUTE_VERIFIER_PERMISSION);
	
	String cuId = request.getParameter("CU_ID");
	if (cuId == null){
		cuId = "";
	}
	
	String downloadPath = "";
	if (XpologSystemInfo.isWindows()){
		downloadPath = KiwiHelper.getDownloadPath();
	}
	String downloadMsg = "";
	if (downloadPath != null && downloadPath.length() > 0){
		downloadMsg = "Please download and install the syslog daemon on the XpoLog host <br>before defining a new syslog collection";
		//downloadMsg = "Please download the syslog daemon setup from <a href=\"" + downloadPath + "\">here</a> and install it.<br>";
		//downloadMsg += "Creation of new syslog collection will be enables after successfull installation of syslog";
	}
	
	LogCollectionSystemManager logCollectionSystemMgr = LogCollectionManager.getInstance().getSystemMgr();
	long[] capacity = logCollectionSystemMgr.getCapacity();
	String current = capacity[0] > 0 ? XpologUtil.formatSize(capacity[0]) : null;
	String total = capacity[1] > 0 ? XpologUtil.formatSize(capacity[1]) : null;
	String capacityStr = "";
	if (current != null){
		capacityStr = "Used storage: " + current;
		if (total != null){
			capacityStr += " / " + total;
		}
	}else if (total != null){
		capacityStr = "Max storage size: " + total;
	}

%>
<%@page import="xpolog.eye.XpoLogObjectTypes"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="useTree" value="true" />
</jsp:include>
<%
boolean showMenu = isAdd || isExecute;
if(showMenu) {
	String menuIds = "executeCollector,editCollector,removeCollector";
	String menuTexts = "Execute,Edit,Delete";
	String menuHrefs = "javascript:executeCollector0();,javascript:editCollector0();,javascript:removeCollector0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  <jsp:param name="showMenu" value="<%=showMenu%>" />
  <jsp:param name="menuIds" value="<%=menuIds%>" />
  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
  function doEdit(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
     return;
    }
    doEdit1(id);
  }
  
  function doEdit1(id) {
  var cuType = mygrid.getUserData(id,"cuType");
    var internalSyslog = mygrid.getUserData(id,"internalSyslog");
    //alert("id = " + id + ", cuType " + cuType);
    if (internalSyslog && internalSyslog == "true"){
    	editSyslog();
    }else if(cuType && cuType == "<%=ReaderAdapter.READER_TYPE%>"){
    	doEditLogCollection(id);
    }else if(cuType && cuType == "<%=BatchAdapter.BATCH_TYPE%>"){
    	doEditLogCollection(id);
    }
  }
  
  function doNewLogCollection(){
  	doEditLogCollection();
  }

	function doEditLogCollection(id){
		path = "admin/log/logCollectionDefinition.jsp";
		if (id && id != ""){
			path = path +"?CU_ID="+id;
		}
		document.location = path;
	}
	
  function doNewSyslogCollection(){
  	doEditSyslogCollection();
  }

	function doEditSyslogCollection(id){
		<% if (XpologSystemInfo.isWindows()){%>
			//setupWindowsSyslog();
			var url = baseDirectory + "logcollection/checkAvailability.jsp";
			sendAjaxRequest(url,function(req){
				var available = req.responseText;	
				available = available.replace(/^\s+|\s+$/g, '') ;
				if (available == "false"){
					downloadWindowsSyslog();
				}else{
					path = "admin/log/logCollectionDefinition.jsp?type=Syslog";
					if (id && id != ""){
						path = path +"&syslogId="+id;
					}else{
						path = path +"&syslogId=<%=SyslogsManager.DEFAULT_SYSLOG_ID%>";
					}
					document.location = path;
				}
			});
		<%}else{%>
			path = "admin/log/logCollectionDefinition.jsp?type=Syslog";
			if (id && id != ""){
				path = path +"&syslogId="+id;
			}else{
				path = path +"&syslogId=<%=SyslogsManager.DEFAULT_SYSLOG_ID%>";
			}
			document.location = path;
		<%}%>
	}
	
	function doNewFolderCollection(){
	  loadModulesTree("","",""); 
	  showGeneralAdminDiv("selectFolder");
	}
	
	function hideSelectFolderDiv(){			   
		showGeneralAdminDiv("selectFolder");					
	}
	
	function selectModule(){
		var parentModId = getSelectedParentModule(foldersTree);
		saveFolderCollection(parentModId);
	}
	
	function saveFolderCollection(folderId){
	  msgWriter = document.getElementById("saveMessage");
	  if (!msgWriter){
	  	msgWriter = new messageWriter("saveMessage","Saving Folder Collectors","<%=BASE_DIRECTORY%>");
			msgWriter.showMessage("<nobr>Creating collectors for selected folder. Please wait...</nobr>");
		}else{
			showDisplayLayer("saveMessage");
		}
	  var params = getFormElementsQueryString(document.access);
	  var url = "admin/log/folderCollectionDefinitionAction.jsp";
  	params += "&folderId="+folderId;
	  sendAjaxRequest(url,function(req){
	  	
	    var xmldoc = req.responseXML.documentElement;
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
      if (result == "false"){
      	hideSelectFolderDiv();
      	hideDisplayLayer("saveMessage");
	    	var msg = "";
    		msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"

				msgWriter = new messageWriter("mygridMessage","Save Folder Collectors Error","<%=BASE_DIRECTORY%>");
				msgWriter.setStyle("left");
				msgWriter.addAction("Close","javascript:hideLayer('mygridMessage')");  
				msgWriter.showMessage(msg);
    	    	
	    	if (xmldoc.getElementsByTagName('params')[0] && xmldoc.getElementsByTagName('params')[0].firstChild){
		    	var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
		    	var pArr = params.split("*;*");
		    	for (var i=0; i<pArr.length; i++){
		    		if (eval("document.access."+ pArr[i])){
		    			setErrorColor(eval("document.access."+ pArr[i]));
		    		}
		    	}
	    	}
      }else{
      	hideDisplayLayer("saveMessage");
      	hideSelectFolderDiv();
      	updateTableView();
      	refreshMenus();
      }
	  },"POST",params);
	}
	
	
	
  function getSelectedParentModule(tree){
		var list = tree.getAllChecked();
		var arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		return modsStr;
	}

	
	
  function doNewBatchCollection(){
  	doEditBatchCollection();
  }

	function doEditBatchCollection(id){
		path = "admin/batch/batchCollectionDefinition.jsp";
		if (id && id != ""){
			path = path +"?CU_ID="+id;
		}
		document.location = path;
	}
	
	function setupWindowsSyslog(){
    var msgWriter = new messageWriter("mygridMessage","Syslog Installation","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
   	msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:installSyslogDaemon()");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>This will setup a syslog daemon on XpoLog's host. continue? </nobr>");
	}
	
	function downloadWindowsSyslog(){
    var msgWriter = new messageWriter("mygridMessage","Syslog Daemon Installation","<%=BASE_DIRECTORY%>");
    msgWriter.setSize(500,120);
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    <%if (downloadPath != null && downloadPath.length() > 0){%>
	    msgWriter.addAction("Download","<%=downloadPath%>");  
	    msgWriter.addAction("Close","javascript:hideLayer('mygridMessage')");  
  	  msgWriter.showMessage("<%=downloadMsg%>");
    <%}else{%>
	    msgWriter.addAction("Close","javascript:hideLayer('mygridMessage')");  
	    msgWriter.showMessage("<nobr>There is no Syslog Daemon installed on XpoLog's host</nobr>");
    <%}%>
	}
	
	function installSyslogDaemon(){
		document.location = "<%=BASE_DIRECTORY%>logcollection/admin/syslog/kiwi/installKiwiDaemon.jsp";
	}
	
	function editSyslog(){
		<%if (XpologSystemInfo.isWindows()){%>
		document.location = "admin/syslog/kiwi/kiwiRulesView.jsp";
		<%}%>
	}
  
	function startSyslog(){
		<%if (XpologSystemInfo.isWindows()){%>
		var url = baseDirectory + "logcollection/admin/syslog/kiwi/kiwiServiceAction.jsp?op=start";
		sendAjaxRequest(url,function(req){
			updateTableView();
			var syslogStatus = req.responseText;	
			syslogStatus = syslogStatus.replace(/^\s+|\s+$/g, '') ;
			updateSyslogInTable(syslogStatus)
		});
		setTimeout("updateTableView()",200);
		<%}%>
	}
  
	function stopSyslog(){
		<%if (XpologSystemInfo.isWindows()){%>
		var url = baseDirectory + "logcollection/admin/syslog/kiwi/kiwiServiceAction.jsp?op=stop";
		sendAjaxRequest(url,function(req){
			updateTableView();
			var syslogStatus = req.responseText;	
			syslogStatus = syslogStatus.replace(/^\s+|\s+$/g, '') ;
			updateSyslogInTable(syslogStatus)
		});
		setTimeout("updateTableView()",200);
		<%}%>
	}
  
  function doDelete(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    doDelete1(id);
  }
  
  function doDelete1(id){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
    var hasFileWriters = mygrid.getUserData(id,"hasFileWriters");
    var name = mygrid.cells(id,0).getValue();
    var row = id;   
    var msgWriter = new messageWriter("deleteMessage","Log Collector Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    if (hasFileWriters && hasFileWriters == "true"){
	    msgWriter.addChbox("Delete storage log","deleteStorageLog","true");  
	    msgWriter.addChbox("Delete collected data","deleteCollectedData","true");  
	   	msgWriter.addAction("Continue","javascript:hideLayer('deleteMessage');javascript:doDelete0('" + row + "','" +  id + "')");
	    msgWriter.addAction("Cancel","javascript:hideLayer('deleteMessage')");  
	    msgWriter.showMessage("<nobr>Please select the actions to take place upon deletion of collector " + name + ":</nobr>");
    }else{
    	msgWriter.addAction("Yes","javascript:hideLayer('deleteMessage');javascript:doDelete0('" + row + "','" +  id + "')");
	    msgWriter.addAction("No","javascript:hideLayer('deleteMessage')");  
	    msgWriter.showMessage("<nobr>Are you sure you want to delete collector </nobr>" + name + "?");
    }
  }
  
  function doDelete0(row,id,removeChildren){
  	var url = baseDirectory + "logcollection/admin/removeLogCollectionAction.jsp?cuId=" + id + "&timestamp=" + new Date().getTime()
  	var deleteStorageLog = document.getElementById("deleteStorageLog");
  	if(deleteStorageLog && deleteStorageLog.checked){
  		url += "&deleteStorageLog=true";
  	}
  	var deleteCollectedData = document.getElementById("deleteCollectedData");
  	if(deleteCollectedData && deleteCollectedData.checked){
  		url += "&deleteCollectedData=true";
  	}
  	//alert(url);
    var msgWriter = document.getElementById("deleteStatusMsg");
    if (!msgWriter){
    	msgWriter = new messageWriter("deleteStatusMsg","Log Collector Delete Action","<%=BASE_DIRECTORY%>");
	    msgWriter.showMessage("<nobr>Please wait while deleting collector...");
    }else{
    	showDisplayLayer("deleteStatusMsg");
    }
  	deleteGridRow(mygrid,row,url);
  }
  
	function doExecute(){
		var id = getFirstSelectedRow(mygrid);
		if (id == "") {
			return;
		}
		doExecute1(id);
	}
	
	function doExecute1(id){
		var url = baseDirectory + "logcollection/logCollectionAction.jsp?op=run&cuId=" + id;
		sendAjaxRequest(url,function(req){
			updateTableStop();
		});
		setTimeout("updateTableStart();",500);
	}
	
	function updateTableStart(){
		updateTableView();
		enableActionButton("Stop");
		disableActionButton("Execute");
	}
	
	function updateTableStop(){
		updateTableView();
		disableActionButton("Stop");
		enableActionButton("Execute");
	}
	
	function doStop(){
		var id = getFirstSelectedRow(mygrid);
		if (id == "") {
			return;
		}
		doStop1(id);
	}
	
	function doStop1(id){
		var url = baseDirectory + "logcollection/logCollectionAction.jsp?op=stop&cuId=" + id;
		sendAjaxRequest(url,function(req){
			updateTableView();
		});
		setTimeout("updateTableView()",500);
		enableActionButton("Execute");
		disableActionButton("Stop");
	}
	
	//var refreshTableInterval;
	//function doRefresh(){
	//	refreshTableInterval = setInterval("updateTableView()",60000);
	//}
	
	function updateTableView(){
		refreshTable();
		updateCapacity();
	}
	
	function updateCapacity(){
		var htr = document.getElementById("headerTextRight");
		if (htr){
			var url = baseDirectory + "logcollection/getCapacity.jsp";
			sendAjaxRequest(url,function(req){
				var capacity = req.responseText;
				if (capacity){	
					capacity = capacity.replace(/^\s+|\s+$/g, '');
					htr.innerHTML = capacity;
				}
			});
		}
	}
	
	//function stopRefreshing(){
	//	if (refreshTableInterval){
	//		clearInterval(refreshTableInterval);
	//	}
	//}
  
	function gotoLog(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
     return;
    }
    var zoomInUrl = mygrid.getUserData(id,"zoomInUrl"); 
		if (!zoomInUrl || zoomInUrl == ""){
		  return;
		}    
  	path = "<%=BASE_DIRECTORY%>" + zoomInUrl;
  	window.open(path,'LogViewer');
  }	
	
	function handleMenuItems(){  
 		<% if (isAdd || isExecute){%>
 			<%if(isExecute) {%>
	    	aMenu.menu.showButtons("executeCollector");
 			<%}
 			if(isAdd) {%>
 		    aMenu.menu.showButtons("editCollector,removeCollector");		   
 			<%}
 		}else {%>
 			  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function executeCollector0(){
    if (contextRowId && contextRowId != ""){
      doExecute1(contextRowId);
    }
  }
  
  function editCollector0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function removeCollector0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
</script>
</head>

<body onLoad="initMenus();initTables();" onUnload="destroyTables();" style="margin:0;padding:0;overflow:auto;" >
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Folder"/> 
	<jsp:param name="suffix" value="selectFolder"/> 
	<jsp:param name="includePath" value="logcollection/selectModuleInner.jsp"/> 			
	<jsp:param name="width" value="500px"/> 
	<jsp:param name="height" value="300px"/>
	<jsp:param name="zIndex" value="300"/>	
	<jsp:param name="actionsNames" value="Create Collectors#Cancel"/> 
	<jsp:param name="actions" value="javascript:selectModule()#javascript:hideSelectFolderDiv()"/> 
</jsp:include> 
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
    	<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">              
				<tr height="10">
					<td>
						<jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Log Collection" />
						</jsp:include>		
					</td>
				</tr>
        <tr>                
          <td valign="top"> 
          <% 
          //String addName = isAdd ? "New Log Collection#New Folder Collection#New Batch Collection" : "";
          //String addLink = isAdd ? "javascript:doNewLogCollection()#javascript:alert('new folder collection')#javascript:alert('new batch collection')" : "";
          boolean hasSyslogReadPermissions = SyslogsManager.getInstance().hasSyslogReadPermissions();
          String addName = isAdd ? (hasSyslogReadPermissions ? "New Log Collection#New Folder Collection#New Syslog Collection" : "New Log Collection#New Folder Collection") : "";
          String addLink = isAdd ? (hasSyslogReadPermissions ? "javascript:doNewLogCollection()#javascript:doNewFolderCollection()#javascript:doNewSyslogCollection()" : "javascript:doNewLogCollection()#javascript:doNewFolderCollection()") : "";
          //String addName = isAdd ? "New Log Collector" : "";
          //String addLink = isAdd ? "javascript:doNewLogCollection()" : "";
          if (false && isAdd && !KiwiConfigurationManager.getInstance().isSyslogDaemonInstalled()){
          	addName = addName + "#Setup Syslog Daemon";
          	addLink = addLink + "#javascript:setupWindowsSyslog()";
          }
          
          String tableNames = isAdd ? "Edit#Delete" : "";
          String tableActions = isAdd ? "javascript:doEdit()#javascript:doDelete()" : "";
          String ids = isAdd ? "Edit#Delete" : "";
          String selectTypes = isAdd ? "2#2" : "";
          
          if (tableNames.length() > 0){
        		tableNames += "*;*";
        		tableActions += "*;*";
        		ids += "*;*";
        		selectTypes += "*;*";
        	}
          if (isExecute){                	
          	tableNames += "Execute#Stop";
        		tableActions += "javascript:doExecute()#javascript:doStop()";
        		ids += "Execute#Stop";
        		selectTypes += "2#2";
         		tableNames += "*;*";
        		tableActions += "*;*";
        		ids += "*;*";
        		selectTypes += "*;*";
          }
          
          String menu = showMenu ? "aMenu" : "";
          
          String collectionXMLUrl = "logcollection/logCollectionsViewXML.jsp?monitorId=";
          %>
          <jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="initXML" value="<%=collectionXMLUrl%>" />
						<jsp:param name="menu" value="<%=menu%>"/>
						<jsp:param name="newActionNames" value="<%=addName%>" />
						<jsp:param name="newActions" value="<%=addLink%>" />
						<jsp:param name="tableActionNames" value="<%=tableNames%>" />
						<jsp:param name="tableActions" value="<%=tableActions%>" />
						<jsp:param name="tableActionIds" value="<%=ids%>" />
						<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
						<jsp:param name="recordsText" value="Log Collectors" />
						<jsp:param name="style" value="main" />
						<jsp:param name="doubleClickAction" value="gotoLog" />
						<jsp:param name="headerTextRight" value="<%=capacityStr%>" />
					</jsp:include>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	  if (!id || id == "") return;
		 var runnable = mygrid.getUserData(rowid,"runnable");
	   var stoppable = mygrid.getUserData(rowid,"stoppable");
	   if ((gridType == columnType || (gridType == 2))){
	   	 if ((id == "Execute" && runnable != "true") || (id == "Stop" && stoppable != "true")){
	   	 	disableActionButton(id);
	   	 }else{
	 	   	enableActionButton(id);
	 	   }
	 	 }else {
	 	   disableActionButton(id);
	 	 }
	}

	
	var cuId = "<%=cuId%>";
	function endLoad(){
		hideLoading();
		mygrid.setSizes();        
		if (cuId && cuId != ""){
			mygrid.selectRowById(cuId,"",true,true);
			mygrid.showRow(cuId);
			cuId = "";
		}
	}
	
	function updateSyslogInTable(status){
		//alert(status);
		var rowid = "<%=LogCollectionSystemManager.DEFAULT_SYSLOG_ID%>" + "_CU";
		if(status == "STARTED"){
			mygrid.setUserData(rowid,"internalSyslogRunning","true");
		}else if (status == "STOPPED"){
			mygrid.setUserData(rowid,"internalSyslogRunning","false");
		}
		cuId = rowid;
		endLoad();
	}
	
	//override from gridActions.js
	function onAfterDelete(){
  	hideDisplayLayer("deleteStatusMsg");
		updateCapacity();
		if(refreshMenus && parent.frames[0]!=null){
			refreshMenus();
		}
	}
	
</script>
		    	</td>
		  	</tr>
			</table>
		</td>
	</tr>
</table>
</body>

</html>