<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.PacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.security.LogCollectionSecurityManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>

<%@ page import="java.util.List"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	String CHECKSUM_LOCATION_INFO_ID = "ChecksumLocationInfoId";

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	FileLocationInfo checksumLocationInfo = sysMgr.getDefaultChecksumLocationInfo();
	if (checksumLocationInfo != null){
		request.setAttribute(CHECKSUM_LOCATION_INFO_ID,checksumLocationInfo);
	}
	
	FilePacketWriter fpr = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
	String checkSum = fpr != null ? fpr.getCheckSumAlgorithm() : "";
	String md5Selected = checkSum != null && checkSum.equals(PacketWriter.MD5_CHECK_SUM) ? "selected" : "";
	String sha1Selected = checkSum != null && checkSum.equals(PacketWriter.SHA1_CHECK_SUM) ? "selected" : "";
	
	LogCollectionSecurityManager securityMgr = sysMgr.getSecurityManager();
	MailTask mailTask = null;
	String mailTo = "";
	List tasks = securityMgr != null ? securityMgr.getTasks() : null;
	if (tasks != null && tasks.size() > 0) {
		XpoTask task = (XpoTask) tasks.get(0);
		if (task instanceof MailTask) {
			mailTask = (MailTask) task;
			if (mailTask != null) {
				mailTo = mailTask.getToId();
			}
		}
	}
	
	String SUFFIX = "storageSettings";
	String PREFIX = SUFFIX;

%>

<input type="hidden" name="rootDir" id="rootDir">
<input type="hidden" name="host" id="host">
<input type="hidden" name="prefix" id="prefix" value="<%=PREFIX%>">

<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<tr>
		<td style="padding-top:20px"><span class="HEADER">Collection Security</span></td>
	</tr>

	<tr>
		<td style="padding-top:5px">
			<span class="REGULARTEXT">Checksum algorithm: </span>
			<select name="checkSumAlgorithm_<%=SUFFIX%>" id="checkSumAlgorithm_<%=SUFFIX%>" class="TEXTBOX" onchange="javascript:showHideChecksumDiv()">
				<option value="">None</option>
				<option value="MD5" <%=md5Selected%>><%=PacketWriter.MD5_CHECK_SUM%></option>
				<option value="SHA1" <%=sha1Selected%>><%=PacketWriter.SHA1_CHECK_SUM%></option>
			</select>
		</td>
	</tr>

	<tr>
		<%
		String checksumSuffix = SUFFIX + "Checksum";
		String checksumLocationStyle = ((md5Selected+sha1Selected).length() > 0) ? "" : "style=\"display:none\"";
		%>
		<td style="padding-top:10px">
			<div id="checksumLocationDiv" <%=checksumLocationStyle%>>
			<jsp:include page="../../logcollection/common/checksumLocation.jsp">
				<jsp:param name="locationInfoId" value="<%=CHECKSUM_LOCATION_INFO_ID%>"/>
				<jsp:param name="targetFileDirDesc" value="Default Checksums Location"/>
				<jsp:param name="active" value="true"/>
				<jsp:param name="suffix" value="<%=checksumSuffix%>"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20px">
			<span class="HEADER">Collection Security Checker Scheduler</span>
		</td>
	</tr>
	<tr>
		<td>
			<jsp:include page="logCollectionSecurityScheduler.jsp"/>
		</td>
	</tr>
	
	<tr>
		<td style="padding-top:5px" id="integrityMailDiv">
			<table border="0" cellpadding="0" cellspacing="0">
				<tr>
					<td style="padding-top:5px"><span class="REGULARTEXT">Send mail notification on file integrity error to: </span></td>
					<td style="padding-left: 10">
						<input type="text" name="integrityErrorsMailTo" size="40" value="<%=mailTo%>">
						<span class="SMALLTEXT">semicolon separated list</span>
					</td>										
				</tr>
			</table>
		</td>
	</tr>
	
	
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>

</table>