<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.SourcePolicy"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	String WRITER_LOCATION_INFO_ID = "WriterLocationInfoId";
	String PACKET_WRITER_ID = "PacketWriterId";
	String SOURCE_POLICY_ID = "SourcePolicyId";

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	FilePacketWriter pw = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
	if (pw != null){
		request.setAttribute(PACKET_WRITER_ID,pw);
	}
	FileLocationInfo writerLocationInfo = pw != null ? pw.getFileLocationInfo() : null;
	if (writerLocationInfo != null){
		request.setAttribute(WRITER_LOCATION_INFO_ID,writerLocationInfo);
	}
	SourcePolicy sourcePolicy = sysMgr.getSourcePolicy();
	if (sourcePolicy != null){
		request.setAttribute(SOURCE_POLICY_ID,sourcePolicy);
	}
	
	String mailTo = sysMgr.getMailRecipients();
	if (mailTo == null){
		mailTo = "";
	}
	
	String SUFFIX = "storageSettings";
	String PREFIX = SUFFIX;

%>

<input type="hidden" name="rootDir" id="rootDir">
<input type="hidden" name="host" id="host">
<input type="hidden" name="prefix" id="prefix" value="<%=PREFIX%>">

<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<tr>
		<td style="padding-top:10px"><span class="HEADER">Storage Repository</span></td>
	</tr>
	<tr>
		<td style="vertical-align:top">
			<div id="defLocationDiv">
			<jsp:include page="../../logcollection/common/fileLocationInfo.jsp">
				<jsp:param name="locationInfoId" value="<%=WRITER_LOCATION_INFO_ID%>"/>
				<jsp:param name="targetFileDirDesc" value="Default Storage Path"/>
				<jsp:param name="showConstraints" value="true"/>
				<jsp:param name="active" value="true"/>
				<jsp:param name="suffix" value="<%=SUFFIX%>"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20px">
			<span class="HEADER">Default Collection Scheduler</span>
		</td>
	</tr>
	<tr>
		<td>
			<jsp:include page="logCollectionDefaultCollectionScheduler.jsp"/>
		</td>
	</tr>
	<tr>
		<td style="padding-top:10px"><span class="HEADER">Default Collection Policy</span></td>
	</tr>
	<tr>
		<td style="vertical-align:top">
			<div id="defPolicyDiv">
			<jsp:include page="../../logcollection/common/filePacketWriterAdvanced.jsp">
				<jsp:param name="packetWriterId" value="<%=PACKET_WRITER_ID%>"/>
				<jsp:param name="sourcePolicyId" value="<%=SOURCE_POLICY_ID%>"/>
				<jsp:param name="suffix" value="<%=SUFFIX%>"/>
				<jsp:param name="mailTo" value="<%=mailTo%>"/>
				<jsp:param name="showSecurityPolicy" value="false"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>

</table>