<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String FILED_PARAM_PREF = "F_";
  ArrayList colsdata = new ArrayList();
  ArrayList colsname = new ArrayList();


  //page data
  LogBrowsingManager lbm = null;
  SimpleLogBrowserBuilder builder = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //verify data
  ErrorModel errmodel = new ErrorModel();

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder != null){
    lbm = builder.getLogBrowserManager();
  }



  String [] fieldsIds = request.getParameterValues("IDMASTER");
  int x=0;
  String data = null;
  for(int i = 0;fieldsIds != null && i < fieldsIds.length;i++){
    data = fieldsIds[i];
    ++x;
    if(data == null){
      break;
    }
    colsdata.add(data);
  }
  if(colsdata.size() == 0){
    errmodel.addError("You must select at least one column for the merged table.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  StringTokenizer tok=null;
  String delim = ";";
  String delimp = "-";
  String tstr,name,logid,indexAtLog;
  MergeDescriptor desc;
  MergeDescriptor[] intToDesc = new MergeDescriptor[colsdata.size()];
  String[] names = new String[colsdata.size()];

  for(int i=0;i<colsdata.size();++i){
    data = (String)colsdata.get(i);
    tok = new StringTokenizer(data,delim);
    name = tok.nextToken();
    desc = new MergeDescriptor();
    while(tok.hasMoreTokens()){
      tstr = tok.nextToken();
      int iti = tstr.lastIndexOf(delimp);
      logid = tstr.substring(0,iti);
      indexAtLog = tstr.substring(iti+1);
      if(desc.getIndexForLog(logid) < 0){
        desc.setLogMappingToRecord(logid,Integer.parseInt(indexAtLog));
      }else{
        errmodel.addError("You are not allowed merge two columns from the same log");
        request.getSession().setAttribute(ERROR_OBJ,errmodel);
        response.sendRedirect("errorpage.jsp");
        return;
      }
    }
    intToDesc[i]= desc;
    names[i] = name;
  }

  MaskColumn[] allcols = new MaskColumn[names.length];

  BuilderSourceInfo [] sources = builder.createBuilderSourcesInfo();
  HashMap idToMask = new HashMap();
  for(int t=0;t<sources.length;++t){
    idToMask.put(sources[t].getSourceId(),sources[t].getColumns());
  }
  Iterator iter;
  MaskColumn colToAdd = null;
  String id = null;
  int ind = -1;
  MaskColumn coltemp = null;
  for(int t=0;t<intToDesc.length;++t){
    iter = intToDesc[t].getLogIdsAssociatedWithRecord().iterator();
    while(iter.hasNext()){
      id = (String)iter.next();
      ind = intToDesc[t].getIndexForLog(id);
      if(colToAdd == null){
        colToAdd = ((MaskColumn[])idToMask.get(id))[ind].cloneMaskCol();
      }else{
        if(!(colToAdd.getType().equalsIgnoreCase(((MaskColumn[])idToMask.get(id))[ind].getType()))){
          errmodel.addError("You can not merge different column type into column -" + names[t]);
        }else{
	  colToAdd.mergeWithColumn(((MaskColumn[])idToMask.get(id))[ind]);
        }
      }
    }
    allcols[t] = colToAdd;
    allcols[t].setName(names[t]);
    colToAdd = null;
  }

  if(errmodel.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  RecordMask masker = lbm.getRecordMask();
  masker.setColumns(allcols);
  
  MergeIndexing indexing = LogAdminHelper.getMergeIndexing(lbm);
  indexing.setDescriptors(intToDesc);
  
  LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG); 
  if(oldlbm != null && LogAdminHelper.getVirtualColumnsBuilder(oldlbm) != null && builder.getVirtualColumnsBuilder() == null && (LogAdminHelper.compareMasksByMergeIndexing(oldlbm,lbm))){
     builder.setVirtualColumnsBuilder(LogAdminHelper.getVirtualColumnsBuilder(oldlbm));
      try{
   			 //for configuration reasons
   			 builder.updateBuilder();
  		}catch(Exception e){
    			errmodel.addError("Building log problem,please check patterns and path again.");
    			errmodel.addError(e.getMessage());
			    request.getSession().setAttribute(ERROR_OBJ,errmodel);
			    response.sendRedirect("errorpage.jsp");
			    return;
		  }
		  lbm = builder.getLogBrowserManager();
		  masker = lbm.getRecordMask();
		  
		  ArrayList list = new ArrayList();
		  for (int i = 0; i < allcols.length ;i++){
				  list.add(allcols[i]);
			}
			builder.addVirtualColumns(list);			
      masker.setColumns((MaskColumn[])list.toArray(new MaskColumn[list.size()]));
      
      indexing = LogAdminHelper.getMergeIndexing(lbm);
  		indexing.setDescriptors(intToDesc);
  }
  

  

  builder.initCustomizationManager(lbm,masker.getCulomnsNumber());
  
  
  
  String BASE_DIRECTORY = "../../";
  AdminUIController controller = builder.getUiController();
  String forwardPage = "logFieldAdmin.jsp";
  if (controller != null){    
    if (controller.getForwardPage() != null){
      forwardPage = BASE_DIRECTORY + controller.getForwardPage();
    }
  }
  
  response.sendRedirect(forwardPage);
 
%>


