<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%> 
<%@ page import="java.sql.*"%>
<%@page import="xpolog.config.Configuration"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String SQL_TO_VERIFY = "sqlQuery";
  String SELECTED_TABLE = "SelectedTable";
  String AdvancedPatternDefinitionLink = null;
  String logDataPattern = null;
  String verifyQuery = request.getParameter(SQL_TO_VERIFY);
  int NUM_RECORDS_TO_FETCH = 25;
  
  //page data
  LogBrowsingManager lbm = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  boolean isNew = true;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  DBSimpleLogBuilder builder = (DBSimpleLogBuilder)request.getSession().getAttribute(BUILDER);

  String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}
 
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No builder exsited in session");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    String okURL = "loggers/admin/logAdminGate.jsp?isPrevious=true&logType=db" + "&OP=" + op;
    okURL = XpologUtil.replaceAll(okURL,"?","%3f"); 
    okURL = XpologUtil.replaceAll(okURL,"&","%26"); 
    String forwardURL = BASE_DIRECTORY + "common/errorpage.jsp?okURL=" + okURL;
    response.sendRedirect(forwardURL);
    return;
  }

  boolean isOnline = builder instanceof OnlineDBSimpleLogBuilder;
  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("DBLogDataPattern.jsp");
    backwardURL = controller.getBackwardPage();
  }
  
  RecordMask oldMask = null;
  String sql = null;
  if(lbm == null){
     lbm = builder.getLogBrowserManager();	
  }else{
  	isNew = false;
  	String origQuery  =  isOnline ? DatabaseAdminHelper.getQuery(lbm) : IntervalAdminHelper.getSourceDirLocation(lbm);
		if (origQuery == null || origQuery.length() == 0){
			lbm = builder.getLogBrowserManager();	
			origQuery  =  isOnline ? DatabaseAdminHelper.getQuery(lbm) : IntervalAdminHelper.getSourceDirLocation(lbm);
		}
  	if(verifyQuery == null){
  		verifyQuery = origQuery;
  	}
  }
  
  // create the tables names list
  //DBAccount account = (DBAccount)IntervalAdminHelper.getAccount(lbm);
  DBAccount account = (DBAccount)builder.getAccount();
  //DBMedia media = (DBMedia)IntervalAdminHelper.getMedia(lbm);
  DBMedia media = (DBMedia)builder.getMedia();
  
	String errorMessage = media.getDBMediaErrorMessage();
	if (errorMessage == null){
		errorMessage = "";
	}

	if(!media.isConnected()) {
		media.setIsDuringAdministration(true);
	  media.connect(account);
	  if(!media.isConnected()) {
		ErrorModel ermod = new ErrorModel();
		ermod.addError("Unable to connect to database - Please make sure the database is up.");
	    ermod.addError("Unable to connect to database - " + media.getLastErrorMessage());
	    request.getSession().setAttribute(ERROR_OBJ,ermod);
	    String okURL = "loggers/admin/logAdminGate.jsp?isPrevious=true&logType=db" + "&OP=" + op;
	    okURL = XpologUtil.replaceAll(okURL,"?","%3f"); 
	    okURL = XpologUtil.replaceAll(okURL,"&","%26"); 
	    String forwardURL = BASE_DIRECTORY + "common/errorpage.jsp?okURL=" + okURL;
	    response.sendRedirect(forwardURL);
	    return;
	  }
	  
  }
  
  String[] tNames = {"--- Select database table ---"};
  try {
    String[] tmpTablesNames = media.getDBTablesNames();
    Arrays.sort(tmpTablesNames);
    //incase the method is not implemented in the driver.
    if(tmpTablesNames != null) {
    	tNames = new String[tmpTablesNames.length+1];
    	tNames[0] = "--- Select database table ---";
    	for(int i=0; i<tmpTablesNames.length; ++i) {
    		tNames[i+1]=tmpTablesNames[i];
    	}
    }
   }catch (Exception e) {
   }

  
  boolean runLogBrowser = true;
  
  HashSet categoriesSet = new HashSet();
  boolean useSchemaInTableNames = media.useShemaInTableNames();
  for (int i = 1; i < tNames.length;i++){
  	int index = tNames[i].indexOf(".");
  	if (index > 0 && index < tNames[i].length()-1){
  		String cat = tNames[i].substring(0,index);
  		categoriesSet.add(cat);
  	}
  }
  String [] categories = (String [])categoriesSet.toArray(new String[categoriesSet.size()]);
  if (categories.length > 1){
  	Arrays.sort(categories);
  }
  
  String selectedCat = request.getParameter("SelectedCategories");
  if (selectedCat == null || selectedCat.length() == 0){
  	selectedCat = "all";
  }
  
  String selectedTable = request.getParameter(SELECTED_TABLE);
  if(selectedTable == null){
  	if(tNames != null && tNames.length > 0){
  		selectedTable = tNames[0];
  	}else{
  		selectedTable = "";
  		runLogBrowser = false;
  	}
  }
  
  boolean isQueryIdentical = false;
  String query = builder.getSourceLocation();
  if (query == null || query.length() == 0){
	  if(verifyQuery != null && !verifyQuery.equals("")) {
	  	query = verifyQuery;
	  }else {
	  	query = "SELECT * FROM " + selectedTable;
	  }
  }
  query = query.trim();
  if(query.equals(builder.getSourceLocation())) { 
  	isQueryIdentical = true; 
  }

  String oid = media.getSqlProperties().getDbRowIdName();
  boolean useOid = false;
  if (query != null && query.toLowerCase().indexOf("select database table") == -1 && oid != null && oid.length() > 0){
  	useOid = media.isUsingDatabaseOID(query);
  }

  if (media != null){
  	media.close();
  }
  
  String errorQuery = "";
  boolean queryOk = true;
  
  logDataPattern =  isOnline ? DatabaseAdminHelper.getXpologPattern(lbm) :  LogAdminHelper.getXpologPattern(lbm);
  String logDataPatternUpdatedStr = request.getParameter("logDataPatternUpdated");
  boolean logDataPatternUpdated = logDataPatternUpdatedStr != null && logDataPatternUpdatedStr.equals("true");
  
  if(logDataPattern != null && !logDataPattern.equals("") && !logDataPatternUpdated) {
		if(!logDataPattern.equals("{string}")){
		  	runLogBrowser = true;
		}
  }
  
  boolean isForward = builder.isQueryForward();
  int maxRows = builder.getMaxRows();
  boolean isUnique = builder.isUnique();
  boolean addDataBaseOID = builder.isAddDataBaseOID();
  String noneChecked = isUnique ? "" : "checked";
  String uniqueChecked = isUnique && !addDataBaseOID ? "checked" : "";
  String uniqueAndOidChecked = isUnique && addDataBaseOID ? "checked" : "";
  String orderBySetStr = request.getParameter("orderBySet");
  boolean orderBySet = orderBySetStr != null && orderBySetStr.equals("true");
  if (isNew && !orderBySet){
 		noneChecked = "checked";
 	  uniqueChecked = "";
 		uniqueAndOidChecked = "";
  }
 
 
  String[] pattern = builder.getColumnsPattern();
  String check = "";
  String fieldName = "";
  String patternFromFields = "";
  
  
  // check if there are null values and we are in edit
  check = request.getParameter("FieldPattren_0");
  //get the old pattern from the log
  //check if need to assamble new pattern

  if(pattern != null && pattern.length > 0 && check != null && !check.equals("")) {
	  for(int i=0; i< pattern.length; ++i) {
	  	fieldName = "FieldPattren_"+String.valueOf(i);
	  	check = "";
	  	check = request.getParameter(fieldName);
	  	if(check == null || check.equals("")) {
	  		pattern[i] = "{string}";
	  	}else {
	  		pattern[i] = check;
	  	}
	  }
  }
  if(isQueryIdentical){
  	if(logDataPattern.equals(builder.BuildColumnsPattern())){
  		oldMask = lbm.getRecordMask();
  	} 
  }else{
  	if(!query.equalsIgnoreCase(DBMedia.BASE_QUERY)) {
  		runLogBrowser = true;
  	}
  }
  
  try{
  	//if query not valid default pattern exists
    lbm = builder.getLogBrowserManager();
    //check if the query is executable
	 	if(!media.verifyQuery()){
	    queryOk = false;
	  	errorQuery = media.getLastErrorMessage();
	  	runLogBrowser = false;
    }
    
    if (oldMask != null){
      lbm.setRecordMask(oldMask);
    } 
  }catch(Exception e){
    	errorQuery = e.getMessage();
    	queryOk = false;
  }

  //for the first time presentation.
  
  if(query != null && query.equalsIgnoreCase(DBMedia.BASE_QUERY)) {
  	runLogBrowser = false;
		query = "";
		queryOk = true;
  }

  String html = "";
 
  if(runLogBrowser){
	  //log table example
	  RecordsMaskTableModel model = lbm.getFirstEntries(10);
	  if(errorMessage != null && errorMessage.length() > 0){
	  	html = errorMessage;
	  	html = "<span class=\"REGULARTEXT\" style=\"color:#FF0000\"><br>" + html + "</span>";
	  }else if(queryOk){
	    //html creation
	    LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
	 		// don't use priority coloring in admin
	    lem.getCustomizationManager().setUsePriorityBgColor(false);
	    OHtmlTable tab =  new OHtmlTable(lem);
	    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
	    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
	    tab.setRowRenderer(rr);
	    tab.setCellRenderer(cr);
	    tab.render();
	    html = tab.getHtml();
	  }
   }
  
 	String[] patternForFields = builder.getColumnsPattern();
 	String[] names = builder.buildColumnNameFromQuery();
 	int [] seqColumns = null;
 	if(names == null || names.length == 0) {
 		seqColumns = new int[0];
 	}else {
 		seqColumns = builder.getSeqColumns();
 	}
  String sequenceMessage = "sequence columns should be selected";
	StringBuffer sb = new StringBuffer();
	for(int i=0;seqColumns != null && i<seqColumns.length;++i){
		boolean isSeq = false;
		String name = names[seqColumns[i]];
		if (sb.length() > 0){
			sb.append(",");
		}
		sb.append(name);
	}
	if (sb.length() > 0){
		sequenceMessage = sb.toString();
	}

	String logAdminScreenWidth = (String)request.getSession().getAttribute("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600";
	}else {
		int w = -1;
		try {
			w = Integer.parseInt(logAdminScreenWidth);
			logAdminScreenWidth = "" + (w - 8);
		}catch (Exception e){			
		}
		
	}

%>

<%@page import="xpolog.eye.util.XpologUtil"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script language="javascript">
	function tableSelection(){
	    document.access.sqlQuery.value="";
  	    //document.access.action = "DBLogDataPattern.jsp";
  	    document.access.action = "DBPresentStatusAction.jsp";
  	    document.access.submit();
    }
    
    function tableCutomSelection(){
	    var selCombo = document.getElementById("SelectedTable");
	    var customCombo = document.getElementById("SelectedCustomTable");
	    var selIndex = customCombo.selectedIndex;
	    if (selIndex == -1){
	      selCombo.selectedIndex = 0;
	    }else {
	      var selVal = customCombo.options[selIndex].value;
	      for (var i = 1; i < selCombo.options.length;i++){
	        if (selCombo.options[i].value == selVal){
	          selCombo.selectedIndex = i;
	          break;
	        }
	      }
	    }
	    tableSelection();  
    }
    
    function categoriesSelection(){
    	var selCombo = document.getElementById("SelectedCategories");
    	var cat = "all";
    	var selIndex = selCombo.selectedIndex;
	    if (selIndex > 0){
	      cat = selCombo.options[selIndex].value;
	    }
	    var selCombo = document.getElementById("SelectedTable");
	    var customCombo = document.getElementById("SelectedCustomTable");
	    customCombo.options.length = 0;
	    if (cat == "all"){
  	    customCombo.style.display = "none";
	      selCombo.style.display = "";
	    }else {
	      for (var i = 0; i < selCombo.options.length;i++){
	        if (i == 0 || selCombo.options[i].value.indexOf(cat) == 0){
	        	var name = selCombo.options[i].value;
	        	var ind = name.indexOf(".");
	        	if (ind > 0){
	        		name = name.substring(ind+1);
	        	}
	          customCombo.options[customCombo.options.length] = new Option(name,selCombo.options[i].value);
	        } 
	      }
	      selCombo.style.display = "none";
	      customCombo.style.display = "";	      
	    }
    		
    }
	
		function doNext(){
			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
			  document.access.CustomizedColSelect.options[i].selected = true;
			}
    	document.access.action = "DBLogDataPatternAction.jsp?isNext=true";
      document.access.submit();
		}
	   	 
   	function doVerify(){
			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
			  document.access.CustomizedColSelect.options[i].selected = true;
			}
 	    document.access.action = "DBPresentStatusAction.jsp";
 	    document.access.submit();
    }
    
    function doSave(){
			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
			  document.access.CustomizedColSelect.options[i].selected = true;
			}
      document.access.action = "DBLogDataPatternAction.jsp?isNext=false";
 	    document.access.submit();
		}
   
    
    function shownHideAdv(){
    	show = document.getElementById("defShowLink").style.display == "";
    	if(show){
    		document.getElementById("advanced").style.display  = "";
    		document.getElementById("defShowLink").style.display="none";
    		document.getElementById("defHideLink").style.display="";    		
    	}else{
    		document.getElementById("advanced").style.display  = "none";
    		document.getElementById("defShowLink").style.display="";
    		document.getElementById("defHideLink").style.display="none";
    	}	
    }
    
    function showHideOrderBy(){
      if (document.getElementById("orderByDiv").style.display == ""){
    		updateSequenceMessage();
      }
    	showHideLayerInMiddle2("orderByDiv",200,125);
    }
    
    function maxRowsChanged(cmb){      
      if (!cmb || cmb.selectedIndex == -1) return;
      if (cmb.options[cmb.selectedIndex].value == -1){        
      
        document.getElementById("forwardSpan").style.display = "none";
        document.getElementById("unlimitSpan").style.display = "";
        show = document.getElementById("defShowLink").style.display == "";       
      }else {
        document.getElementById("unlimitSpan").style.display = "none";
        document.getElementById("forwardSpan").style.display = "";        
      }
    }
    
    function updateSequenceMessage(){
    	var orderCols = "";
			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
				if (orderCols != ""){
					orderCols += ",";
				}
			  orderCols += document.access.CustomizedColSelect.options[i].text;
			}
			var e = document.getElementById("unlimitSpan");
			var txt = "";
			if (orderCols != ""){
				txt = "(" + orderCols + ").";
			}else{
				txt = "(sequence columns should be selected).";
			}
			e.innerHTML = "<a href=\"javascript:showHideOrderBy()\" class=\"LINK\">order by</a>&nbsp;&nbsp;" + txt;
    }
    
    function addToCust(){
  		if(document.access.RealColSelect.selectedIndex == -1){
    		return;
  		}
  		for(var j=0;j<document.access.RealColSelect.options.length;j++){
    		if (document.access.RealColSelect.options[j].selected){
      			var name = document.access.RealColSelect.options[j].text;
      			var value = document.access.RealColSelect.options[j].value;
      			var found = false;
      			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
        			if(document.access.CustomizedColSelect.options[i].value == value){
          				alert("One or more of the selected columns is already presented. Please modify the selection!");
          				return;
        			}
      			}
        		var option0 = new Option(name,value);
        		document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
    		}
  		}
		}

		function removeFromCust(){
		  if(document.access.CustomizedColSelect.selectedIndex == -1){
		    return;
		  }
		
		  for(var i= document.access.CustomizedColSelect.options.length ; --i >= 0;){
		    if(document.access.CustomizedColSelect.options[i].selected){
		       document.access.CustomizedColSelect.options[i] = null;
		    }
		  }
		}
  

		function moveUpinCust(){
	    if(document.access.CustomizedColSelect.selectedIndex == -1){
	      return;
	    }
	    index = document.access.CustomizedColSelect.selectedIndex;
	    if(index == 0){
	    	return;
	    }
	    document.access.CustomizedColSelect.selectedIndex = index - 1;
	    moveDowninCust();
	    document.access.CustomizedColSelect.selectedIndex = index;
	  }

		function moveDowninCust(){
      if(document.access.CustomizedColSelect.selectedIndex == -1){
        return;
      }
      index = document.access.CustomizedColSelect.selectedIndex;
      if(index == (document.access.CustomizedColSelect.options.length-1) || document.access.CustomizedColSelect.options.length == 1){
        return;
      }
	   	var options = new Array();
	   	for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      	if(i == index){
     	  	var option0 = new Option(document.access.CustomizedColSelect.options[i+1].text,document.access.CustomizedColSelect.options[i+1].value);
      		options[i] = option0;
      		option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
      		options[i+1] = option0;
      		i = i+1;
     	  }else{
     	    var option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
     		 options[i] = option0;
     	  }
      }
      for(var i=0;i<options.length;i++){
      	document.access.CustomizedColSelect.options[i] = null;
      }
      for(var i=0;i<options.length;i++){
        document.access.CustomizedColSelect.options[i] = options[i];
      }

      document.access.CustomizedColSelect.selectedIndex = index + 1;
    }


    
    
</script>
</head>

<body onLoad="javascript:maxRowsChanged(document.access.maximumRows)" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" style="padding:0;margin:0">
<input type="hidden" name="useSchemaInTableNames" value="<%=useSchemaInTableNames%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
          <tr>
            <td>
            <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
            	<tr height="10">
								<td colspan="3">
									<jsp:include page="../../../common/pageHeader.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="headerTitle" value="Database Query Administration" />
									</jsp:include>											
								</td>
							</tr>
              <tr>
                <td colspan="3" style="padding-top:10;padding-left:10" valign=top">
                <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
                  <tr height="18">
                    <td width="15%"><span class="HEADER">Database Tables List</span></td>
                  </tr>
                  <tr height="18">
                    <td width="15%"><span class="SMALLTEXT">The list of the available 
                      schemas and tables in the databse you specified.</span></td>
                  </tr>
                  <tr height="25">
                    <td width="55%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                    <tr>
                    <td width="100" style="padding-right:10">
                      <select size="1" name="SelectedCategories" id="SelectedCategories" onchange="javascript:categoriesSelection()">
                    	<option class="TEXTBOX" value="all" >All</option>
                            <%
                            String selected = "";
                            for(int i=0;i<categories.length;++i) {
                            	if(categories[i].equals(selectedCat)){
                              	selected = "selected";
                          	}else {
                              	selected = "";
                          	}
                            %>
                            <option class="TEXTBOX" value="<%=categories[i]%>" <%=selected%>><%=categories[i]%></option>
                           <%
                           }
                           %>                           
                        </select>

                    </td>
                    <td width="*">
                    <select size="1" name="SelectedTable" id="SelectedTable" onchange="javascript:tableSelection()" <%=selectedCat.equals("all") ? "" : "style=\"display:none\"" %>>
                            <%
                            selected = "";
                            for(int i=0;i<tNames.length;++i) {
                            	if(tNames[i].equals(selectedTable)){
                                	selected = "selected";
                            	}else {
                                	selected = "";
                            	}
                            %>
                            <option class="TEXTBOX" value="<%=tNames[i]%>" <%=selected%>><%=tNames[i]%></option>
                           <%
                           }
                           %>                           
                        </select>
                         <select size="1" name="SelectedCustomTable" id="SelectedCustomTable" onchange="javascript:tableCutomSelection()" <%=!selectedCat.equals("all") ? "" : "style=\"display:none\"" %>>                       
                             <%
                             if (!selectedCat.equals("all")){
                            selected = "";
                            for(int i=0;i<tNames.length;++i) {
                            	if (i > 0  && !tNames[i].startsWith(selectedCat)){
                            		continue;
                            	}
                            	if(tNames[i].equals(selectedTable)){
                                	selected = "selected";
                            	}else {
                                	selected = "";
                            	}
                            	String name = tNames[i];
                            	int ind = name.indexOf(".");
                            	if (ind > 0){
                            		name = name.substring(ind+1);
                            	}
                            %>
                            <option class="TEXTBOX" value="<%=tNames[i]%>" <%=selected%>><%=name%></option>
                           <%
                           }}
                           %>                            
                        </select>
                        
                        </td>
                        <td width="*">
                                           </td>
                        </tr>
                        </table>
                        </td>
                    </tr>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">Query Definition</span></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">Here you need to specify the query you 
                    want XpoLog to execute on one or more of the tables listed above</span></td>
                  </tr>
                  <tr height="50">
                    <td><textarea class="TEXTBOX" rows="3" id="sqlQuery" name="sqlQuery" cols="120" style="font-size: 8pt"><%=query%></textarea></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">example:
                            SELECT * FROM TABLE1, TABLE2</span></td>
                  </tr>
                  <tr height="10">
                    <td>
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="250"><a href="javascript:doVerify()" class="LINK">verify query</a></td>
                          <td width="1"></td>
                          <!--<td width="194"><a href="javascript:getPatternSuggestions()" class="LINK">get pattern suggestions</a></td>-->
                          <!--<td width="76"></td>-->
                        </tr>
                      </table>
                    </td>
                  </tr>
                 <%if (isOnline){
                	 String numbersStr = Configuration.getInstance().getPropertiesManager().getProperty("dbLogDataPattern.maxRowsList","-1,1000,5000,10000,50000,100000");
                	 String [] maxNumbers = numbersStr.split(",");
                	 %>
									 <tr style="padding-top:2;padding-bottom:10" height="18">
                    <td><span class="REGULARTEXT">Show maximum </span>
                    <select id="maximumRows" name= "maximumRows" class="TEXTBOX" onChange="javascript:maxRowsChanged(this)">
                    <%
                    for (int i = 0; i < maxNumbers.length;i++){
                    	String value = 	maxNumbers[i];
                    	String name = maxNumbers[i].equals("-1") ? "Unlimit" : maxNumbers[i];
                    
                    %>
                    <option value="<%=value%>" class="TEXTBOX" <%=String.valueOf(maxRows).equals(value) ? "selected" : "" %>><%=name%></option>
                    <%} %>
                    </select>
                    <span class="REGULARTEXT" id="forwardSpan" style="display:<%=maxRows == -1 ? "none" : "" %>">rows
                    <select id="direction" name= "direction" class="TEXTBOX">
                    <option value="true" class="TEXTBOX" <%=isForward ? "selected" : ""%>>forward</option>
                    <option value="false" class="TEXTBOX" <%=!isForward ? "selected" : ""%>>backword</option>
                    </select>
                    </span> 
                    <span class="SMALLTEXT" id="unlimitSpan" style="display:<%=maxRows == -1 ? "" : "none" %>">
                    <a href="javascript:showHideOrderBy()" class="LINK">order by</a>
                    &nbsp;&nbsp;(<%=sequenceMessage%>).
                    </span> 
                    </td>
                  </tr>
                 <%} %>
                  <tr height="10">
                    <td><a href="javascript:shownHideAdv()" class="LINK"><div id="defShowLink">Show advanced Pattern Definition</div><div id="defHideLink" style="display:none">Hide advanced Pattern Definition</div></a></td>
                  </tr>

                  <tr height="10">
                    <td><input type="hidden" name="isAdvOpen"/>
                    <div id="advanced" style="display:none">
                    
                      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="90%">
                        <tr>
                          <td width="33%"><span class="HEADER">Field Name </span></td>
                          <td width="2%">&nbsp;</td>
                          <td width="33%"><span class="HEADER">Field Pattern</span></td>
                          <td width="*">&nbsp;</td>
                        </tr>
                        <%
                       	
                        if(names != null && patternForFields != null && names.length > 0 && patternForFields.length > 0 && query != "" && query != null && !query.equalsIgnoreCase(DBMedia.BASE_QUERY)) {
                        	for(int i=0;i<names.length;++i){
                        		boolean isSeq = false;
                        	  
                        %>
                        <tr>                    
                          <td width="33%"><span class="REGULARTEXT"><%=names[i]%></span></td>                   
                          <td width="2%">&nbsp;</td>
                          <td width="33%">
                          <input type="text" name="FieldPattren_<%=String.valueOf(i)%>" size="50" value="<%=i < patternForFields.length && patternForFields[i] != null?  patternForFields[i] : "{string}"%>"> </td> 
                          <td width="*">&nbsp;</td>
                        </tr>
                        <%
                        	}//for
                        }//if
                        %>
                        
                        
												<%if (isOnline){ %>
					            <%}%>
                      </table>
                      <p align="left"><a href="javascript:doVerify()" class="LINK"> verify patterns and query</a><p>&nbsp;
                      
                      </div>
                      </td>
                  </tr>
                  <%if (queryOk){ %>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">Log records analysis result&nbsp;&nbsp;</span></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">Here you can see the log lines after they
                      were analyzed using the data pattern</span></td>
                  </tr>
                  <tr height="10">
                    <td>
                    <div id="DBrecordAnalysedId" style="width:<%=logAdminScreenWidth%>px;height:*;overflow-y:auto;overflow-x:auto;border:0px">
                    <%=html%>
                    </div>   
                    </td>                 
                  </tr>
                  <% }else { %>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">Query verification status</span></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">Analysis result of the log lines with the
                      query</span></td>
                  </tr>
                  <tr height="10">
                    <td>
                        <span class="REGULARTEXT">Query verification -
                        <%if(queryOk){%>
			 	<span class="OKMESSAGE">ok</span>
			<%}else{%>
                <span class="ERRORMESSAGE">error:
                        <%=errorQuery%></span>
			<%}%>
                        </span>
                    </td>
                  </tr>
                  <%} %>
                  <tr height="100%"><td>&nbsp;</td></tr>
                  </table>
                </td>
              </tr>
              <tr height="10">
								<td colspan="3" style="padding-top:10">
								
								<%
								
								String actionNames = "";
								String actions = "";
								
								actionNames += "Previous";
								if(backwardURL == null) {
                  actions += "javascript:history.go(-1)";
                 }else {
                 	actions += backwardURL;
                 }

								actionNames += "#Save";
								actions += "#javascript:doSave()";

								actionNames += "#Cancel";
								actions += "#" + "common/actions/cancelAction.jsp";
								
								%>
									<jsp:include page="../../../common/buttonsFooter.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />				
										<jsp:param name="align" value="right"/> 
										<jsp:param name="actionNames" value="<%=actionNames%>"/> 
								    <jsp:param name="actions" value="<%=actions%>"/> 
									</jsp:include>											
								</td>
							</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<div id="orderByDiv" style="position:absolute;display:none;">
	<table border="0" width="60%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Order By</span>
			</td>
		</tr>
		<tr>
			<td align="center" style="padding:5">
			<table border="0">
				<tr>
					<td>
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr>
						  <td>
						  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber19">
						  	<tr>
						  		<td><span class="HEADER">Available Columns</span></td>
						  		<td>&nbsp;</td>
						  		<td><span class="HEADER">Selected Columns</span></td>
						  		<td>&nbsp;</td>
						  	</tr>
						    <tr>
						      <td>
						      <select size="7" name="RealColSelect" id="RealColSelect" style="width: 250; height: 156" multiple>
						
						        <%
						         String name = null;
						         String value = null;
						       	for(int i=0;names != null && i<names.length;++i){
						           name = names[i];
						           value = String.valueOf(i);
						       %>
						       <option class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
						       <%
						         }
						       %>
						     </select>
						     </td>
						     
						     <td width="10%" style="padding-left:5;padding-right:5">
						     	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="77%" id="AutoNumber20">
						       <tr>
						         <td width="100%" align="center">
						         <a href="javascript:addToCust()" class="SMALLLINK">add</a> </td>
						       </tr>
						       <tr>
						         <td width="100%" align="center">
						         <a href="javascript:removeFromCust()" class="SMALLLINK">remove</a></td>
						       </tr>
						      </table>
						     </td>
						     
						     <td width="14%">
						      <select size="7" name="CustomizedColSelect" id="CustomizedColSelect" style="width: 250; height: 156" multiple>
						
						      <%
										name = null;
										value = null;
					        	for(int i=0;seqColumns != null && i<seqColumns.length;++i){
				              name = names[seqColumns[i]];
				              value = String.valueOf(seqColumns[i]);
						        %>
						        <option  class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
						        <%
					        		}
						        %>
						
						       </select>
						      </td>
						      
						      <td width="14%" style="padding-left:5;padding-right:5">
						      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber21">
					        	<tr>
				          		<td width="100%" align="center">
				           		<a href="javascript:moveUpinCust()" class="SMALLLINK"><nobr>Move up</nobr></a></td>
		            </tr>
		            <tr>
	              <td width="100%" align="center">
	               <a href="javascript:moveDowninCust()" class="SMALLLINK"><nobr>Move down</nobr></a></td>
               </tr>
             </table>
              </td>
              
              <td width="20%">&nbsp;</td>
              
             </tr>
           </table>
           </td>
          </tr>
          <tr><td>&nbsp;</td></tr>
					<tr><td><span class="HEADER">Unique Record Identifier</span></td></tr>
					<tr><td height="20"><span class="REGULARTEXT">Select a unique identifier for record in this view:</span></td></tr>
					<tr>
						<td>
						<table border="0">
							<tr>
								<td>
								<input type="radio" name="uniqueId" value="NONE" <%=noneChecked%>><span class="REGULARTEXT">none</span><br>
								<span class="SMALLTEXT" style="padding-left:20"> the selected view has no unique id identifier</span>
								</td>
							</tr>
							<tr>
								<td>
								<input type="radio" name="uniqueId" value="ORDER" <%=uniqueChecked%>><span class="REGULARTEXT">the columns defined in the above order by section</span><br>
								<span class="SMALLTEXT" style="padding-left:20">the combination of the columns defined in the above 'order by' section is a uniqe identifier of a record</span>
								</td>
							</tr>
							<%if (useOid){%>
							<tr>
								<td>
								<input type="radio" name="uniqueId" value="ROWID" <%=uniqueAndOidChecked%>><span class="REGULARTEXT">row id</span><br>
								<span class="SMALLTEXT" style="padding-left:20">the combination of the columns defined in the above 'order by' section </span><br>
								<span class="SMALLTEXT" style="padding-left:20">together with the table's row id is a uniqe identifier of a record</span>
								</td>
							</tr>
							<%} %>
							</table>
							</td>
						</tr>
				           
					</table>
					</td>
				</tr>
				<tr>
					<td align="center"><a href="javascript:showHideOrderBy()"><span class="LINK">close</span></a></td>
				</tr>
			</table>
			</td>
		</tr>
	</table>
</div>
</form>

</body>

</html>