<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>

<%@ page import="java.util.regex.Pattern"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String SQL_QUERY = "sqlQuery";
  String SELECTED_DATA_PATTERN = "SELECTED_DATA_PATTERN";
  String PATTERN_FIELDS = "advanced";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  //check if need to save or configure.
  String isNextStr = request.getParameter("isNext");
  boolean isNext = isNextStr != null && isNextStr.equals("true");
  
  String isForwardStr = request.getParameter("direction");
  boolean isForward = isForwardStr == null || isForwardStr.length() == 0 || isForwardStr.equals("true");
  
  String maxRowsStr = request.getParameter("maximumRows");
  int maxRows = -1;
  try {
  	maxRows = Integer.parseInt(maxRowsStr);
  }catch (Exception e){}
  
  String query = request.getParameter(SQL_QUERY);
  request.getSession().setAttribute(SELECTED_DATA_PATTERN,query);
  //verify data
  ErrorModel errmodel = new ErrorModel();

  if(query == null || query.trim().equals("")){
    errmodel.addError("No SQL Query was supplied.");
  }
  
  DBSimpleLogBuilder builder = (DBSimpleLogBuilder)request.getSession().getAttribute(BUILDER);
  boolean isOnline = builder instanceof OnlineDBSimpleLogBuilder;

  if (isOnline && maxRows == -1){
  	String q = query.trim().toLowerCase();
  	if (Pattern.matches("select .* from [^\\(]* order by [^\\)]*",q)){
  		errmodel.addError("'order by' clause is not allowed if 'unlimit' is selected");
  	}
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;

  }
  query = query.trim();
  builder.setUsePattern(false);
  builder.setSourceLocation(query);
  builder.setQueryForward(isForward);
  builder.setMaxRows(maxRows);
  builder.setUseIndexing(maxRows == -1);
  
  //check if the query and pattern is valid
  LogBrowsingManager lbm = builder.getLogBrowserManager();
  DBMedia media = null;
  if (isOnline){
  	media = DatabaseAdminHelper.getMedia(lbm);
  }else {
  	media = (DBMedia)xpolog.eye.admin.helpers.IntervalAdminHelper.getMedia(lbm);
  }
  String errorQuery = null;
  boolean queryOk = true;
  String 	logDataPattern =  isOnline ? DatabaseAdminHelper.getXpologPattern(lbm) :  LogAdminHelper.getXpologPattern(lbm);
  try{
	  //check the data pattern
	 
	  String[] pattern = builder.getColumnsPattern();
	  String check = "";
	  String fieldName = "";
	  String patternFromFields = "";
	  StringBuffer seqIndexesBuffer = new StringBuffer();
	  // check if there are null values and we are in edit
	  check = request.getParameter("FieldPattren_0");
	  //get the old pattern from the log
	  //check if need to assamble new pattern
	  if(pattern != null && pattern.length > 0 && check != null && !check.equals("")) {
		  for(int i=0; i<pattern.length; ++i) {
		  	fieldName = "FieldPattren_" + String.valueOf(i);
		  	check = "";
		  	check = request.getParameter(fieldName);
		  	if(check == null || check.equals("")) {
		  		pattern[i] = "{string}";
		  	}else {
		  		pattern[i] = check;
		  	}
		  	
		  }
		  
		  String[] selCols = request.getParameterValues("CustomizedColSelect");
		  for (int i=0; selCols != null && i < selCols.length; i++){
		  	if (seqIndexesBuffer.length() > 0){
		  		seqIndexesBuffer.append(",");
		  	}
		  	seqIndexesBuffer.append(selCols[i]);
		  }
		  
		  String uniqueId = request.getParameter("uniqueId");
		  boolean isUnique = (uniqueId != null && (uniqueId.equals("ORDER") || uniqueId.equals("ROWID")));
		  boolean addDataBaseOID = uniqueId != null && uniqueId.equals("ROWID");
		  
		  builder.setColumnsPattern(pattern);
		  patternFromFields = builder.BuildColumnsPattern();
		  builder.setXpologPattern(patternFromFields);
		  builder.setSeqColumns(seqIndexesBuffer.toString());
		  builder.setUnique(isUnique);
		  builder.setAddDataBaseOID(addDataBaseOID);
	  }
	  
	  RecordMask oldMask = null;
	  if (query.equals(builder.getSourceLocation()) && logDataPattern != null && logDataPattern.equals(builder.BuildColumnsPattern())){
	    oldMask = lbm.getRecordMask();
	  }
	  boolean useIndexing = true;
	  boolean indexNullValues = false;
	  boolean useInDashboard = true;
	  if (isOnline){
  	  if (maxRows > 0){
				useIndexing = false;
	    }else {
	    	LogBrowsingManager origlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	    	useIndexing = origlbm == null || origlbm.isUseIndexing();
	    	indexNullValues = origlbm != null && origlbm.isIndexNullValues();
	    	useInDashboard = origlbm == null || origlbm.isUseInDashboard();
	    }
	  }
  	builder.setUseIndexing(useIndexing);
  	builder.setIndexNullValues(indexNullValues);
  	builder.setUseInDashboard(useInDashboard);
	  if (isOnline && maxRows == -1  && (builder.getSeqColumns() == null || builder.getSeqColumns().length == 0)){
	  	errmodel.addError("No sequence column was supplied.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("../errorpage.jsp");
	    return;
	  }
	  
		if (!media.isReadOnlyPattern(query)){
			ErrorModel ermod = new ErrorModel();
	    ermod.addError("statement must be read only");
	    request.getSession().setAttribute(ERROR_OBJ,ermod);
	    response.sendRedirect("../errorpage.jsp");
	    return;
		}
  	  //if query not valid default pattern exists
      builder.updateBuilder();
      builder.buildPatternFields();
      lbm = builder.getLogBrowserManager();
      //check if the query is executable
 	  if(media == null || !media.verifyQuery()){
	  	  errorQuery = media == null ? "No database media " : media.getLastErrorMessage();
	  	  queryOk = false;
      }
      
      if (oldMask != null){
     	 lbm.setRecordMask(oldMask);
      } 
  }catch(Exception e){
    errorQuery = e.getMessage();
    queryOk = false;
  }
  if(!queryOk) {
  	errmodel.addError("Building log problem,please check query and pattern again.");
    errmodel.addError(errorQuery);
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  
  if(isNext) {
    String BASE_DIRECTORY = "../../../";
    AdminUIController controller = builder.getUiController();
    String forwardPage = "../logFieldAdmin.jsp";
    if (controller != null){    
      if (controller.getForwardPage() != null){
        forwardPage = BASE_DIRECTORY + controller.getForwardPage();
      }
    }
  
    response.sendRedirect(forwardPage);
  }else {
  	response.sendRedirect("../logFieldAdminAction.jsp?doSaveOnly=true");
  }
  
%>


