<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.DBMedia"%>
<%@ page import="xpolog.eye.site.ProgressRunner"%>
<%@ page import="xpolog.eye.site.SiteConstants"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%@ page import="java.util.regex.Pattern"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	//constants
	String LOG_ID = "LOG_ID";
	String BUILDER = "CURRENT_LOG_BUILDER";
	String CURRENT_LOG = "CURRENT_LOG";
	String ERROR_OBJ = "ERROR_OBJ";
	String SQL_TO_VERIFY = "sqlQuery";
	String SELECTED_TABLE = "SelectedTable";
	String USE_SCHEMA_IN_TABLE_NAMES = "useSchemaInTableNames";
	String AdvancedPatternDefinitionLink = null;
	String logDataPattern = null;
	String verifyQuery = request.getParameter(SQL_TO_VERIFY);
	int NUM_RECORDS_TO_FETCH = 25;

	//page data
	LogBrowsingManager lbm = null;

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	
	lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	final DBSimpleLogBuilder builder = (DBSimpleLogBuilder)request.getSession().getAttribute(BUILDER);
	
	if(builder == null){
	  ErrorModel ermod = new ErrorModel();
	  ermod.addError("No builder exsited in session");
	  request.getSession().setAttribute(ERROR_OBJ,ermod);
	  response.sendRedirect("../errorpage.jsp");
	  return;
	}

	boolean isOnline = builder instanceof OnlineDBSimpleLogBuilder;
	boolean isVerify = verifyQuery != null && verifyQuery.length() > 0;

	RecordMask oldMask = null;
	String sql = null;
	if(lbm == null){
	   lbm = builder.getLogBrowserManager();	
	}else{
		String origQuery  =  !lbm.getType().equals(DBSimpleLogBuilder.DB_LOG_TYPE) ? DatabaseAdminHelper.getQuery(lbm) : IntervalAdminHelper.getSourceDirLocation(lbm);		
		if (origQuery == null || origQuery.length() == 0 || isVerify){			
			lbm = builder.getLogBrowserManager();	
			origQuery  =  isOnline ? DatabaseAdminHelper.getQuery(lbm) : IntervalAdminHelper.getSourceDirLocation(lbm);
		}
		if(verifyQuery == null){
			verifyQuery = origQuery;
		}
	}

	//params to pass back to DBLogDataPattern
	String selectedTable = request.getParameter(SELECTED_TABLE);
  String orgSelectedTable = selectedTable;
	String useSchemaInTableNamesStr = request.getParameter(USE_SCHEMA_IN_TABLE_NAMES);
	boolean useSchemaInTableNames = useSchemaInTableNamesStr != null && useSchemaInTableNamesStr.equals("true");
	if (selectedTable != null && selectedTable.length() > 0 && !useSchemaInTableNames){
		int ind = selectedTable.indexOf(".");
		if (ind != -1 && ind < selectedTable.length()-1){
			selectedTable = selectedTable.substring(ind+1);
		}
	}
	
	boolean isQueryIdentical = false;
	String query = "";
	if(verifyQuery != null && !verifyQuery.equals("")) {
		query = verifyQuery;
	}else {
			query = "SELECT * FROM " + selectedTable;
	}
	query = query.trim();
	if(query.equals(builder.getSourceLocation())) { 
		isQueryIdentical = true; 
	}
	
  DBMedia media = (DBMedia)builder.getMedia();
	if (!media.isReadOnlyPattern(query)){
		ErrorModel ermod = new ErrorModel();
    ermod.addError("statement must be read only");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("../errorpage.jsp");
    return;
	}

	String isForwardStr = request.getParameter("direction");
	 if (isForwardStr != null && isForwardStr.length() > 0){
  	  boolean isForward =  isForwardStr.equals("true");
  	  builder.setQueryForward(isForward);
	 }
	 	 	  
	 String maxRowsStr = request.getParameter("maximumRows");
	 
	 if (maxRowsStr != null && maxRowsStr.length() > 0){
	    int maxRows = -1;
	    try {
	  	  maxRows = Integer.parseInt(maxRowsStr);
	  	  if (isOnline && maxRows == -1){
	  	  	String q = query.trim().toLowerCase();
	  	  	if (Pattern.matches("select .* from [^\\(]* order by [^\\)]*",q)){
	  	  		ErrorModel errmodel = new ErrorModel();
	  	  		errmodel.addError("'order by' clause is not allowed if 'unlimit' is selected");
	  	      request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  	      response.sendRedirect("../errorpage.jsp");
	  	      return;
	  	  	}
	  	  }
	  	  
	  	}catch (Exception e){}
	    builder.setMaxRows(maxRows);
	 }
	
	builder.setUsePattern(true);
	builder.setSourceLocation(query);
	builder.setNumRecordsToFetch(NUM_RECORDS_TO_FETCH);
	
	
	String errorQuery = "";
	boolean queryOk = true;
	
	logDataPattern =  request.getParameter("logdatapat");
	if (logDataPattern == null){
		logDataPattern = isOnline ? DatabaseAdminHelper.getXpologPattern(lbm) :  LogAdminHelper.getXpologPattern(lbm);
	}
	String logDataPatternUpdatedStr = request.getParameter("logDataPatternUpdated");
	boolean logDataPatternUpdated = logDataPatternUpdatedStr != null && logDataPatternUpdatedStr.equals("true");
	
	if(logDataPattern != null && !logDataPattern.equals("") && !logDataPatternUpdated && isQueryIdentical) {
		if(!logDataPattern.equals("{string}")){
			builder.setUsePattern(false);
			builder.setXpologPattern(logDataPattern);			
	  	builder.buildPatternFields();
		  //runLogBrowser = true;
		}
	}else {
		if (isVerify){
	  	builder.buildPatternFields();
		}
	}
	
	
	String[] pattern = builder.getColumnsPattern();
	String check = "";
	String fieldName = "";
	String patternFromFields = "";
	StringBuffer seqIndexesBuffer = new StringBuffer();
	
	// check if there are null values and we are in edit
	check = request.getParameter("FieldPattren_0");
	//get the old pattern from the log
	//check if need to assamble new pattern
	
  boolean orderBySet = false;
	if(pattern != null && pattern.length > 0 && check != null && !check.equals("")) {
	  for(int i=0; i< pattern.length; ++i) {
	  	fieldName = "FieldPattren_"+String.valueOf(i);
	  	check = "";
	  	check = request.getParameter(fieldName);
	  	if(check == null || check.equals("")) {
	  		pattern[i] = "{string}";
	  	}else {
	  		pattern[i] = check;
	  	}
	  }
	  
	  String[] selCols = request.getParameterValues("CustomizedColSelect");
	  for (int i=0; selCols != null && i < selCols.length; i++){
	  	if (seqIndexesBuffer.length() > 0){
	  		seqIndexesBuffer.append(",");
	  	}else{
	  		orderBySet = true;
	  	}
	  	seqIndexesBuffer.append(selCols[i]);
	  }
	  
	  String uniqueId = request.getParameter("uniqueId");
	  boolean isUnique = (uniqueId != null && (uniqueId.equals("ORDER") || uniqueId.equals("ROWID")));
	  boolean addDataBaseOID = uniqueId != null && uniqueId.equals("ROWID");
	  
	  builder.setColumnsPattern(pattern);
	  patternFromFields = builder.BuildColumnsPattern();
	  builder.setXpologPattern(patternFromFields);
	  builder.setSeqColumns(seqIndexesBuffer.toString());
	  builder.setUnique(isUnique);
	  builder.setAddDataBaseOID(addDataBaseOID);
	}
	if(isQueryIdentical){
		if(logDataPattern.equals(builder.BuildColumnsPattern())){
			builder.setUsePattern(false);
			oldMask = lbm.getRecordMask();
		}else{
			builder.setUsePattern(false);
			if(patternFromFields != null && !patternFromFields.equals("")) {
	  		builder.setXpologPattern(patternFromFields);
	  	    builder.buildPatternFields();
		    }
		} 
	}else{
		builder.setUsePattern(true);
	}
	
	String verifyQueryParam = (query != null && query.length() > 0 ? SQL_TO_VERIFY + "=" + query: null);
	String selectedTableParam = (orgSelectedTable != null && orgSelectedTable.length() > 0 ? SELECTED_TABLE + "=" + orgSelectedTable : null);
	String nextToken = "?";
	if (verifyQueryParam != null){
		verifyQueryParam = nextToken + verifyQueryParam;
		nextToken = "&";
	}else{
		verifyQueryParam = "";
	}
	if (selectedTableParam != null){
		selectedTableParam = nextToken + selectedTableParam;
		nextToken = "&";
	}else{
		selectedTableParam = "";
	}
	
	String selectedCat = request.getParameter("SelectedCategories");
  if (selectedCat == null || selectedCat.length() == 0){
  	selectedCat = "";
		nextToken = "&";
  }else {
  	selectedCat = nextToken + "SelectedCategories=" + selectedCat;
  }
  
  String orderBySetParam = orderBySet ? nextToken + "orderBySet=true" : "";
  
  String doSaveStr = request.getParameter("doSave");
   boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

   String modid = (String)request.getSession().getAttribute("MODULE_ID");
  if (doSave && modid != null && modid.length() > 0){
    builder.updateBuilder();
  	lbm = builder.getLogBrowserManager();
  	LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  	if(oldlbm != null && lbm.getType().equals(oldlbm.getType())){  	  	
	  	lbm.setFilterManager(oldlbm.getFilterManager());
  	  lbm.setRecordMask(oldlbm.getRecordMask());
  	  if (!builder.isOnline()){
    	  LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(LogAdminHelper.getMergeIndexing(oldlbm));
  	  }
    	lbm.setCustomizationManager(oldlbm.getCustomizationManager());
    	lbm.setSearchAndFilterDef(oldlbm.getSearchAndFilterDef());
  	}
    Module parentmod = mgmt.getModuleFromId(modid);
    if(parentmod == null){
      parentmod = mgmt.getModuleFromId(modid);
    }
		IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(lbm);
		if(ds != null) {
			ds.setLogBrowserId(lbm.getId());
		}
    		
	  LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),builder.getApplicationsIds());
	  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	  UserContext userContext = UserEnvironment.getUserContext(request);
	  
    admin.addLogBrowser(lbm,parentmod,userContext);
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    AuditManager auditMgr = AuditManager.getInstance();
    auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
	  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  	return;
  }

	
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	
	final JobStatus status = builder.getJobStatus();
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 
	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600";
	}
	String screenSizeParam = "&LogAdminScreenWidth=" + logAdminScreenWidth;

	verifyQueryParam = verifyQueryParam.replaceAll("\"","&quot;");
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "loggers/admin/database/DBLogDataPattern.jsp" + verifyQueryParam + selectedTableParam + selectedCat + orderBySetParam + screenSizeParam) {
	  public void run(HttpServletRequest request){
    	long startTime = System.currentTimeMillis();
	    try {
		    builder.updateBuilder();
		    builder.buildPatternFields();
	    	
	   }catch (Exception e){
	     ErrorModel.log.error("Failed to update db builder query",e);
	   }
	   long diff = System.currentTimeMillis() - startTime;
	   if (diff < 1000){
	  	 try {
	  		 Thread.sleep(1000 - diff);
	  	 }catch (Exception e){}
	   }
	  }
	};
	env.setProgressRunner(runner);
	String stopUrl = "loggers/admin/database/DBPresentStatusStopAction.jsp";
%>

<%@page import="xpolog.eye.data.log.external.IntervalDataSource"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="<%=stopUrl%>"/>
</jsp:include>

  
