<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";

  String toVerify = request.getParameter("logLines");
  String isSchemaEditStr = request.getParameter("isSchemaEdit");
  boolean isSchemaEdit = isSchemaEditStr != null && isSchemaEditStr.equals("true");

  //page data
  LogBrowsingManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  LogBrowsingManager lbmBuilder = builder.getLogBrowserManager();;
  if(lbm == null){
     lbm = lbmBuilder;
  }


  boolean doUpdate = builder.getElementsPatternInfoCount() == 0 || toVerify != null || isSchemaEdit;
  String recordString = toVerify;
  String emptyResult = "XpoLog : There is no element found for tag name";
  if (toVerify == null || toVerify.startsWith("XpoLog")){
     recordString = XMLLogAdminHelper.getFirstElementRecord(lbmBuilder);
     if (recordString == null || recordString.trim().length() == 0){
       doUpdate = false;
       if (XMLLogAdminHelper.isFilesExists(lbmBuilder)){
         recordString = emptyResult + " " + builder.getTagName();
       }else {
        recordString = "XpoLog : No files were found according to the details you supplied.\n";
        recordString += "XpoLog : Please check the path details.";
       }
     }

  }

  String errorPattern = "";
  boolean patternOk = true;
  if (doUpdate){

    try{
      if (isSchemaEdit){
        for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
           XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
           String pat = request.getParameter("elemPattern_" + i);
           String cond = request.getParameter("conditionCombo" + i);
           String condVal = request.getParameter("conditionValue_" + i);
           String ignore = request.getParameter("ignore_" + i);
           info.setSelected(ignore == null || !ignore.equals("on"));
           if (pat != null && pat.trim().length() > 0){
             info.setXpologPattern(pat);
           }

           if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
             info.setConditionProperty(cond,condVal);
           }else {
             info.setConditionParameters(null);
           }
        }

      }else {
        builder.buildElementsPatternInfo(recordString);
      }
      builder.updateBuilder();

    }catch(Exception e){
      errorPattern = e.getMessage();
      patternOk = false;
    }
  }
  lbm = builder.getLogBrowserManager();
   //log table example

  String html = "";
  if(builder.getElementsPatternInfoCount() > 0 && patternOk){
    //html creation
    RecordsMaskTableModel model = lbm.getFirstEntries(3);
    LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
    OHtmlTable tab = new OHtmlTable(lem);

    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
    tab.render();
    html = tab.getHtml();
  }
  
  String charset = lbm.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script language="javascript">
function doNext(){
   document.access.action = "XMLLogSchemaAction.jsp";
   document.access.submit();
}
function reanalyzeXMLCode(){
   document.access.action = "XMLLogSchema.jsp";
   document.access.submit();
}

function verifySchema(){
   document.access.action = "XMLLogSchema.jsp?isSchemaEdit=true";
   document.access.submit();
}

function ElementColumn(){
  this.attributes = new Array();
}

function ElementAttribute(key,value){
  this.key = key;
  this.value = value;
}

var elementsColumns = new Array();
<%
for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
  XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
%>
  elementsColumns[elementsColumns.length] = new ElementColumn();
  var atts = elementsColumns[elementsColumns.length - 1].attributes;
  <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
     for(int j=0;j<attributes.length;++j){
   %>
       atts[atts.length] = new ElementAttribute("<%=attributes[j].key%>","<%=attributes[j].value%>");
  <%}
}
%>


function changeAttribute(combo,index){
  var txtVal = document.getElementById("conditionValue_" + index);
  if (combo.selectedIndex > 0){
    txtVal.value = elementsColumns[index].attributes[combo.selectedIndex - 1].value;
  }else {
    txtVal.value = "";
  }
}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="500" class="TOPBORDER">
                <span class="PAGEHEADER">XML Log schema administration</span></td>
                <td width="377" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="423">&nbsp;</td>
                <td width="456">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Text from the XML file</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="SMALLTEXT">The first log
                      element from the XML log file you specified.</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18">
                    <textarea class="TEXTBOX" rows="20" name="logLines" id="logLines" wrap="off" cols="115" style="font-size: 8pt"><%=recordString%>
                    </textarea></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="700" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="30%"></td>
                          <td width="41%"><a href="javascript:reanalyzeXMLCode()" class="SMALLLINK">reanalyze
                            XML code</a></td>
                          <td width="34%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">XML schema definition</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you need to specify for each field
                      type and name according to the XML code above<br>
                      If there are missing elements or attributes please add
                      them to the structure above and click on </span><a href="javascript:reanalyzeXMLCode()" class="SMALLLINK">reanalyze
                            XML code</a></td>
                  </tr>
                  <tr>
                    <td>
                        <table border="1" width="700">
                          <tr>
                            <td width="10">&nbsp;</td>
                            <td width="150"><span class="REGULARTEXT">Tag Name</span></td>
                            <td width="150"><span class="REGULARTEXT">Attribute</span></td>
                            <td width="300"><span class="REGULARTEXT">Value - XpoLog
                              pattern</span></td>
                            <td width="270"><span class="REGULARTEXT">condition</span></td>
                            <td width="20"><span class="REGULARTEXT">Ignore</span></td>
                          </tr>
                          <% for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
                               XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
                          %>

                            <tr>
                            <td width="10"><span class="REGULARTEXT"><%=String.valueOf(i + 1)%>.</span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getTagName()%></span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getPropertyKey() == null ?"&nbsp;" : info.getPropertyKey()%></span></td>
                            <td width="300"><span class="REGULARTEXT"><input class="TEXTBOX"  type="text" name="elemPattern_<%=i%>" size="40" value="<%=info.getXpologPattern()%>"></span></td>
                            <td width="270" ><nobr><font size="2">
                             <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
                                if (attributes.length > 0){
                                  Properties condProp = info.getConditionParameters();
                                  %>

                                 <select size="1" name="conditionCombo<%=i%>" id="conditionCombo_<%=i%>" onChange="javascript:changeAttribute(this,<%=i%>)">
                          <%
                            String selected = "";
                            boolean hasCondition = condProp != null && condProp.size() > 0;
                            selected = !hasCondition? "selected=\"true\"" : "";
                            String value = "";
                            %>
                             <option class="TEXTBOX" value="noSelect" <%=selected%> >No Selected</option>
                            <%
                            for(int j=0;j<attributes.length;++j){
                              if(hasCondition && condProp.getProperty(attributes[j].key) != null){
                                selected = "selected=\"true\"";
                                value = attributes[j].value;
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=attributes[j].key%>" <%=selected%>><%=attributes[j].key%></option>
                          <%}%>

                             </select>
                            &nbsp;=&nbsp;<input class="TEXTBOX" type="text" name="conditionValue_<%=i%>" size="20" value="<%=value%>">
                            <% } else { %>
                                  &nbsp;
                             <% } %>
                            </nobr></td>
                            <td width="20"><input type="checkbox" name="ignore_<%=i%>"  <%=!info.isSelected()?"checked" : ""%>></td>
                          </tr>

                          <% } %>




                        </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="138"><a href="javascript:verifySchema()" class="LINK">verify
                            schema</a></td>
                          <td width="76"></td>
                          <td width="118"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Pattern verification status</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Analysis result of the log lines with the
                      data pattern</span></td>
                  </tr>
                  <tr>
                    <td>

                      <span class="REGULARTEXT">Log analysis verification -</span>
                        <%if(patternOk){%>
                            <span class="OKMESSAGE">ok</span>
                        <%}else{%>
                            <span class="ERRORMESSAGE">error:
                          <%=errorPattern%></span>
                        <%}%>

                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Log records analysis result&nbsp;&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you can see the log view after the xml log was
                      analyzed the schema</span></td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td><%=html%></td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <td width="90">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>

                        <td width="91"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="94">
                          <p align="left"><a href="javascript:doNext()" class="LINK">next</a></p>
                        </td>
                        <td width="443">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>