<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.eye.smart.patternrec.*"%>
<%@ page import="xpolog.eye.smart.patternmap.*"%>
<%@ page import="xpolog.eye.util.trees.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../";
	void updatePatternsList(ArrayList list) {
	}
%>

<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_DATA_PATTERN = "logDataPattern";
  String PATTERNS_LIST = "PATTERNS_LIST";

  String toVerify = request.getParameter(LOG_DATA_PATTERN);

  //page data
  LogBrowsingManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }


  RecordMask oldMask = null;
  if(lbm == null){
     lbm = builder.getLogBrowserManager();
  }else{
    LogBrowsingManager lbm1 = builder.getLogBrowserManager();
    String patternCheck = toVerify != null ? toVerify : LogAdminHelper.getXpologPattern(lbm1);
    if(LogAdminHelper.getXpologPattern(lbm).equals(patternCheck)){
      oldMask = lbm.getRecordMask();
    }else{

    }
  }

  String xpoPattern = LogAdminHelper.getXpologPattern(lbm);
  String oldPattern = xpoPattern;
  String errorPattern = "";
  boolean patternOk = true;

  try{
    if(toVerify != null){
       xpoPattern = toVerify;
    }
    builder.setRecordPattern(xpoPattern);
    builder.updateBuilder();
    lbm = builder.getLogBrowserManager();
    if (oldMask != null){
      lbm.setRecordMask(oldMask);
    }
  }catch(Exception e){
    errorPattern = e.getMessage();
    patternOk = false;
  }




  String[] lines = LogAdminHelper.readLines(lbm,200);
  boolean exsitLines = false;
  for (int i = 0; i < lines.length; i++) {
    if (lines[i] != null && lines[i].length() > 0){
       exsitLines = true;
    }
  }


  if(!exsitLines){
    if (!LogAdminHelper.isFilesExists(lbm)){
      lines = new String[2];
      lines[0] = "XpoLog : No files were found according to the details you supplied.";
      lines[1] = "XpoLog : Please check the path details.";
    }else {
      lines = new String[1];
      lines[0] = "XpoLog : It seems that the file is empty.";
    }
  }


  //log table example
  RecordsMaskTableModel model = lbm.getFirstEntries(10);
  String html = "";
  if(exsitLines && patternOk){
    //html creation
    LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
    OHtmlTable tab = new OHtmlTable(lem);

    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
    tab.render();
    html = tab.getHtml();
  }


  builder.setRecordPattern(oldPattern);
  builder.updateBuilder();

  boolean patternToLogOk = true;
  String errorPatternToLog = "";
  if(exsitLines){
    if(model==null || model.getColumnCount()==0 || !patternOk){
      patternToLogOk = false;
      errorPatternToLog = "Please check if pattern accuratly describes the log records.";
    }
  }

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>

<script language="javascript">
	function doNext(){
    	  var path ="logDataPatternAction.jsp?";
          path = path + "&<%=LOG_DATA_PATTERN%>=" + document.access.logDataPattern.value;
    	  document.location = path;
	}
	function doApply(){
    	  var path ="logDataPattern.jsp?";
   	  path = path + "&<%=LOG_DATA_PATTERN%>=" + document.access.logDataPattern.value;
   	  document.location = path;
	}

        function updatePattern() {
    	  var path ="logDataPattern.jsp?";
          if (document.access.pattern.length == null)
            document.access.<%=LOG_DATA_PATTERN%>.value = document.access.pattern.value;
          else
            for (var i=0; i<document.access.pattern.length; i++) {
              if (document.access.pattern[i].checked == true)
                document.access.<%=LOG_DATA_PATTERN%>.value = document.access.pattern[i].value;
            }
          document.access.submit();
        }


</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" name="access" id="access" action="logDataPattern.jsp" method="post">
<input type="hidden" name="<%=LOG_DATA_PATTERN%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="425" class="TOPBORDER">
                <span class="PAGEHEADER">Log pattern Assistant<%=logname%></span></td>
                <td width="457" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="423">&nbsp;</td>
                <td width="456">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Log pattern suggestions</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="SMALLTEXT">Possible log patterns
                    detected by the system.</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18">
                    <%String sep = System.getProperty("line.separator");
                      PatternInput input = new PatternInput(lines);
                      PatternDetector detector = new PatternDetector();
                      PatternOutput output = detector.process(input);
                      ArrayList list = output != null ? (ArrayList)output.getResult() : null;
                      if (list == null || list.size() == 0){
                      	list = new ArrayList();
                      	list.add("{string}");
                      }
                      Iterator it = list.iterator();
                      String first = LogPattern.toHtmlString((String)list.get(0));
                      request.getSession().setAttribute(PATTERNS_LIST,list);
                      for (int i=0; i<list.size(); i++) {
                        String s = LogPattern.toHtmlString((String)list.get(i));
                        String checked = (i==0)?"checked=\"true\"":"";%>
                        <input type="radio" value="<%=s%>" <%=checked%> id="R<%=i+1%>" name="pattern" >
                        <span class="REGULARTEXT"><%=s%></span><br>
                      <%
                      }
                      //pmman.save();
                    %>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <!--<td width="90">-->
                        <!--<p align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a></td>-->
                        <%
                          int o = -1;
                        %>
                        <td width="91"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="94">
                          <!--<p align="left"><a href="javascript:doNext()" class="LINK">apply</a></p>-->
                          <p align="left"><a href="javascript:updatePattern()" class="LINK">apply</a></p>
                        </td>
                        <td width="443">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>