<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.run.LogActionsConfiguration"%>
<%@ page import="xpolog.eye.site.startup.LogsDataGeneratorQuery"%>

<%@ page import="java.util.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String MODULE_ID = "ParentModule";
  String FILED_PARAM_PREF = "F_";

  ArrayList colsdata = new ArrayList();
  ArrayList colsname = new ArrayList();

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  //page data
  MergedLogBrowserManager lbm = null;
  MergedLogBrowserBuilder builder = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //verify data
  ErrorModel errmodel = new ErrorModel();

  lbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
  //No need to check lbm type while edit, get the lbm from builder anyway.
  builder = (MergedLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder != null){
    lbm = builder.getMergeLogBrowser();
  }


  String [] fieldsIds = request.getParameterValues("IDMASTER");
  int x=0;
  String data = null;
  for(int i = 0;fieldsIds != null && i < fieldsIds.length;i++){
    data = fieldsIds[i];
    ++x;
    if(data == null){
      break;
    }
    colsdata.add(data);
  }
  if(colsdata.size() == 0){
    errmodel.addError("You must select at least one column for the merged table.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  StringTokenizer tok=null;
  String delim = ";";
  String delimp = "-";
  String tstr,name,logid,indexAtLog;
  MergeDescriptor desc;
  MergeDescriptor[] intToDesc = new MergeDescriptor[colsdata.size()];
  String[] names = new String[colsdata.size()];

  for(int i=0;i<colsdata.size();++i){
    data = (String)colsdata.get(i);
    tok = new StringTokenizer(data,delim);
    name = tok.nextToken();
    desc = new MergeDescriptor();
    while(tok.hasMoreTokens()){
      tstr = tok.nextToken();
      int iti = tstr.lastIndexOf(delimp);
      logid = tstr.substring(0,iti);
      indexAtLog = tstr.substring(iti+1);
      if(desc.getIndexForLog(logid) < 0){
        desc.setLogMappingToRecord(logid,Integer.parseInt(indexAtLog));
      }else{
        errmodel.addError("You are not allowed merge two columns from the same log");
        request.getSession().setAttribute(ERROR_OBJ,errmodel);
        response.sendRedirect("errorpage.jsp");
        return;
      }
    }
    intToDesc[i]= desc;
    names[i] = name;
  }

  MaskColumn[] allcols = new MaskColumn[names.length];
  RecordMask mask = lbm.getRecordMask();

  LogBrowsingManager[] logsb = lbm.getLogBrowsers();
  HashMap idToMask = new HashMap();
  for(int t=0;t<logsb.length;++t){
    idToMask.put(logsb[t].getId(),logsb[t].getRecordMask());
  }
  Iterator iter;
  MaskColumn colToAdd = null;
  String id = null;
  int ind = -1;
  MaskColumn coltemp = null;
  for(int t=0;t<intToDesc.length;++t){
    iter = intToDesc[t].getLogIdsAssociatedWithRecord().iterator();
    while(iter.hasNext()){
      id = (String)iter.next();
      ind = intToDesc[t].getIndexForLog(id);
      if(colToAdd == null){
        colToAdd = ((RecordMask)idToMask.get(id)).getMaskColumn(ind).cloneMaskCol();
      }else{
        if(!(colToAdd.getType().equalsIgnoreCase(((RecordMask)idToMask.get(id)).getMaskColumn(ind).getType()))){
          errmodel.addError("You can not merge different column type into column -" + names[t]);
        }else{
	  colToAdd.mergeWithColumn(((RecordMask)idToMask.get(id)).getMaskColumn(ind));
        }
      }
    }
    coltemp = mask.getMaskColumn(t);
    allcols[t] = colToAdd;
    allcols[t].setName(names[t]);
    if (coltemp != null){
    	allcols[t].setUseInStatistics(coltemp.isUseInStatistics());
    }
    
    colToAdd = null;
  }

  if(errmodel.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  RecordMask masker = lbm.getRecordMask();
  masker.setColumns(allcols);

  MergeIndexing indexing = MergeAdminHelper.getMergeIndexing(lbm);
  indexing.setDescriptors(intToDesc);

  //we need to reset customization
  MergeCustomizationManager mcum = (MergeCustomizationManager)lbm.getCustomizationManager();
  int[] phy = new int[allcols.length];
  int[] vi = new int[allcols.length];
  for(int t=0;t<vi.length;++t){
    phy[t] = t;
    vi[t] = t;
  }
  mcum.setCustomizationColumns(phy,vi);

  String BASE_DIRECTORY = "../../../";
  AdminUIController controller = builder.getUiController();
  String forwardPage = "mergefieldadmin.jsp";
  if (controller != null){    
    if (controller.getForwardPage() != null){
      forwardPage = BASE_DIRECTORY + controller.getForwardPage();
    }
  }
  
  String modid = (String)request.getSession().getAttribute(MODULE_ID);
  admin.addLogBrowser(lbm,mgmt.getModuleFromId(modid));
  Boolean isNew = (Boolean)request.getSession().getAttribute("IS_NEW");
	if(isNew != null && isNew.booleanValue()) {
		boolean runReports = LogActionsConfiguration.getInstance().isRunReports();
  	boolean runDashboard = LogActionsConfiguration.getInstance().isRunDashboard();
  	LogsDataGeneratorQuery query = new LogsDataGeneratorQuery();
  	query.setRunReports(runReports);
  	query.setRunDashboard(runDashboard);
		query.setRunIndexing(false);
		String[] lbmIds = new String[1];
    lbmIds[0] = lbm.getId();
    admin.generateLogData(lbmIds, query, userContext);
  }
  
  
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  request.getSession().setAttribute("logid",lbm.getId());
  request.getSession().removeAttribute(BUILDER);
  request.getSession().removeAttribute("IS_NEW");
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
  
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/merge/logaddopok.jsp");
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  //response.sendRedirect(forwardPage);
%>


