<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<% 

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String LOG_CHARSET = "charset";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
 

  String modid      = request.getParameter("ParentModule");
  String logname    = request.getParameter(LOG_NAME);
  String logdesc    = request.getParameter(LOG_DESCRIPTION);
  String mergeId     = request.getParameter("mergeLog");
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String charset    = request.getParameter(LOG_CHARSET);
  
  String ignoreUnparsedRecordsStr = request.getParameter("ignoreUnparsedRecords");
  String updateLinesNumberStr = request.getParameter("updateLinesNumberStr");    
  boolean ignoreUnparsedRecords = ignoreUnparsedRecordsStr != null && ignoreUnparsedRecordsStr.equalsIgnoreCase("on");
  boolean updateLinesNumber = updateLinesNumberStr != null && updateLinesNumberStr.equalsIgnoreCase("on");
  
  if (charset != null && charset.equals("default")){
    charset = null;
  }
  
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  
  if(mergeId == null || mergeId.trim().equals("")){
    errmodel.addError("No merge log was supplied.");
  }

  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }


  MultiPatternCoverterBuilder builder = new MultiPatternCoverterBuilder();

  builder.setName(logname);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setCharset(charset);
  builder.setIgnoreUnparsedRecords(ignoreUnparsedRecords);
  builder.setUpdateLinesNumber(updateLinesNumber);
  builder.setMergeLogId(mergeId);
  

  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  LogBrowsingManager lbm = builder.getLogBrowserManager();
  admin.addLogBrowser(lbm,parentmod);
  request.getSession().removeAttribute("logid");
  request.getSession().removeAttribute("callsPage");
  request.getSession().removeAttribute("lastModel");
  request.getSession().setAttribute(CURRENT_LOG,lbm);
 
  response.sendRedirect("../logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
%>


