<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "ParentModule";
  String LOG_PATH = "LogPath";
  String LOG_DATA_PATTERN = "DataPattern";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String DB_ACCOUNT = "DatabaseAccount";
  String SELECTED_LBMS = "selectedLbms";
  

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  ErrorModel errmodel = new ErrorModel();
  
  String modid      = "";
  String logname    = "SQL analyzer";
  String logdesc    = "";
  String timeZoneId = "default";
  String dbId = AddressBook.getInstance().getDefaultAccount(DBAccount.TYPE_DB);
  if (XpologLicenseManager.getInstance().isDemo() && (dbId == null || dbId.length() == 0)){
  	dbId = "defaultSqlDb";
  }

  String mediaType = "DBMedia";
  String [] lbmIds = new String[0];
  String [] filterIds = new String[0]; 
  

  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
 
  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.SQL_TYPE);
  
  String query = "";
  String logdatapat = "{string}";
  int maxRecords = 100;
  if(lbm != null){    
    if (lbm.getType().equals(SQLLogSimpleBuilder.SQL_LOG_TYPE)){
      query = LogSQLAdminHelper.getQuery(lbm);
      lbmIds = LogSQLAdminHelper.getLbmIds(lbm);
      filterIds = LogSQLAdminHelper.getFilterIds(lbm);
      if (lbm.isTemporary()){
        maxRecords = LogSQLAdminHelper.getMaxRecordsInUse(lbm);
      }
    }else {
      query = "select * from Table1";
      lbmIds = new String[]{lbm.getId()};
      filterIds = new String[]{lbm.getFilterManager().getActiveFilterId() == null ? "" : lbm.getFilterManager().getActiveFilterId()}; 
    }
  }
  builder.setName(logname);
  builder.setLogsFileNamePattern("{string}");
  builder.setLogsDirectory(builder.createUniqueDirLocation());
  builder.setRecordPattern(logdatapat);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setQuery(query);
  builder.setLogsInfo(lbmIds,filterIds);
  builder.setMaxRecordsToUse(maxRecords);

  DBAccount acc = (DBAccount)AddressBook.getInstance().getAccountById(dbId);
  if (acc == null){
  	errmodel.addError("No default database account found");
  	errmodel.addError("Please enter the address book and set a default database account");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  builder.setAccount(acc);

  try{
    //for configuration reasons
    builder.updateBuilder();
    builder.buildPatternFields();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  boolean executeQuery = query != null && query.length() > 0;
  request.getSession().setAttribute(BUILDER, builder);
  response.sendRedirect("SQLAnalyzerPattern.jsp?isFirstTime=true&executeQuery=" + executeQuery);

%>


