<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.sql.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String SQL_QUERY = "sqlQuery";
  String SELECTED_DATA_PATTERN = "SELECTED_DATA_PATTERN";
  String SELECTED_LBMS = "selectedLbms";
  String LOG_NAME = "LogName";
  String PARENT_MODULE = "ParentModule";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  //get the builder
  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)request.getSession().getAttribute(BUILDER);
  
  //check if need to save or configure.
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.equals("true");
  
  LogBrowsingManager lbm = null;
  DBMedia media = null;
  String errorQuery = null;
  boolean queryOk = true;
  int maxRecordsToUse = -1;
  String modid = null;
  String logname = null;
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  //chekc if back from user permission or fist time here
  String userAgreed = request.getParameter("userAgreed");
  if(userAgreed == null) {
	  String query = request.getParameter(SQL_QUERY);
	  request.getSession().setAttribute(SELECTED_DATA_PATTERN,query);
	
	  if(query == null || query.trim().equals("")){
	    errmodel.addError("No SQL Query was supplied.");
	  }
	  
	  String [] lbmFilterIds = request.getParameterValues(SELECTED_LBMS);
	  
	  if(lbmFilterIds == null || lbmFilterIds.length == 0 || lbmFilterIds[0].length() == 0){
	    errmodel.addError("No selected logs were supplied.");
	  }
	  
	  modid      = request.getParameter(PARENT_MODULE);
	  logname    = request.getParameter(LOG_NAME);
	  if (doSave){
	    if(logname == null || logname.trim().equals("")){
	      errmodel.addError("No name was supplied.");
	    }
	    
	    if(modid == null || modid.trim().equals("")){
	      errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
	    }
	  }
	  
	  if(errmodel.getErrorCount() != 0){
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("../errorpage.jsp");
	    return;
	
	  }
	  query = query.trim();
	  builder.setColumnsPattern(null);
	  if (doSave) {
	    builder.setName(logname);
	    builder.setID(null);
	  }
	  builder.setQuery(query);
	  
	  //check if the query and pattern is valid
	  lbm = builder.getLogBrowserManager();
	  media = (DBMedia)builder.getMedia();
	  errorQuery = null;
	  queryOk = true;
	  maxRecordsToUse = -1;
		  //check the data pattern
		 RecordMask oldMask = lbm.getRecordMask();
		  String[] pattern = builder.getColumnsPattern();
		 
		  String [] lbmIds = new String[lbmFilterIds.length];
	  	  String [] filterIds = new String[lbmFilterIds.length];
	      for (int i = 0; i < lbmFilterIds.length; i++) {
	        int index = lbmFilterIds[i].indexOf(";");
	        lbmIds[i] = lbmFilterIds[i].substring(0,index);
	        filterIds[i] = lbmFilterIds[i].substring(index + 1,lbmFilterIds[i].length());       
	      }
		 
		  String maxRecordsToUseChoice = request.getParameter("maxRecordsToUseChoice");
	  	  String maxRecordsToUseStr = request.getParameter("maxRecordsToUse");
	  	  maxRecordsToUse = builder.getMaxRecordsToUse();
	  	  if (maxRecordsToUseChoice != null){  	
	    	if (maxRecordsToUseChoice.equalsIgnoreCase("custom") && maxRecordsToUseStr != null){
	   		  if (maxRecordsToUseStr.trim().length() > 0){
	        	try {
	        	  maxRecordsToUse = Integer.parseInt(maxRecordsToUseStr);
		          if (maxRecordsToUse < 0){
	    	       maxRecordsToUse = builder.getMaxRecordsToUse();
	        	  }
		        }catch (Exception e){}
	    	  }else {
		        maxRecordsToUse = -1;
	    	  }
	        }else {
	          maxRecordsToUse = -1;
	        }
		  }
	  	  builder.setMaxRecordsToUse(maxRecordsToUse);
  	  	
  	  	//check if memory problems will rise.
  	  	int checkQuery = LogSQLAdminHelper.checkMemoryQuery(query);
  	  	if((checkQuery > 0 && maxRecordsToUse > 10) || (checkQuery > 5 && maxRecordsToUse > 5) || (checkQuery > 0 && maxRecordsToUse == -1)) {
  	  	   response.sendRedirect("askUserPermission.jsp?url=SQLAnalyzerPatternAction.jsp&doSave="+doSave);
  	       return;
  	  	}
  	  }//userAgreed
  try{
  	  //if query not valid default pattern exists
      builder.updateBuilder();
      builder.buildPatternFields();
      LogBrowsingManager newLbm = builder.getLogBrowserManager();
      //check if the query is executable
 	  media = (DBMedia)builder.getMedia();
 	  if(!media.verifyQuery()  || !media.isUpdateVerification()){
	  	  errorQuery = media.getLastErrorMessage();
	  	  queryOk = false;
      } 
      lbm = newLbm;
  }catch(Exception e){
    errorQuery = e.getMessage();
    queryOk = false;
  }
  if(!queryOk) {
  	errmodel.addError("Building log problem,please check query and pattern again.");
    errmodel.addError(errorQuery);
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  if(doSave) {   
    request.getSession().removeAttribute(CURRENT_LOG);
    request.getSession().setAttribute("MODULE_ID",modid);
  	response.sendRedirect("../logFieldAdminAction.jsp");
  }else {
    lbm.setTemporary(true);
    lbm.setUsingProxy(true);
    request.getSession().removeAttribute("logid");
  	request.getSession().removeAttribute("callsPage");
  	request.getSession().removeAttribute("lastModel");
  	request.getSession().setAttribute(CURRENT_LOG,lbm);
  	response.sendRedirect("../../logview.jsp?firstTime=true");
  }
  
%>


