<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String LOG_DIRECTORY = "LOG_DIRECTORY";
  String LOG_NAME_PATTERN = "LOG_NAME_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String LOG_TIME_ZONE = "LOG_TIME_ZONE";
  int ALLOWED_LOG_NAME_LENGTH = 30;

  //page data
  LogBrowsingManager lbm = null;
  String modid      = "";
  String logname    = "";
  String logdesc    = "";
  String query     = "";
  String lognameexp = "";
  String accId = "defaultSqlDb";
  String [] selectedLbmIds = new String[0];
  String [] selectedFilterIds = new String[0];

  boolean isUsingDefaultTimeZone = true;
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = defaultZone.getID();

  boolean isAutoUpdate = false;
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = null;
  String backwardURL = null;
  //check state
  String op = request.getParameter(OP);
  if((op != null) && op.trim().equals(ADD)){
    //we are adding a new browser
    request.getSession().removeAttribute(CURRENT_LOG);
    backwardURL  = "../logAdminGate.jsp";
  }else{
    SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
    if (builder != null){
      lbm = builder.getLogBrowserManager();
    }
    
    if (lbm == null){
      String id = request.getParameter(LOG_ID);
      if((id != null) && !(id.trim().equals(""))){
        try{
          lbm = mgmt.getLogBrowserManager(id);
          if(lbm != null){
            request.getSession().setAttribute(CURRENT_LOG,lbm);
          }
        }catch(Exception e){}
      }else{
        lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
      }      
    }

	
    if(lbm != null){
        logname    = lbm.getName();
        logdesc    = lbm.getDescription();

        timeZoneId = lbm.getTimeZone().getID();
        isUsingDefaultTimeZone = lbm.isUsingDefaultTimeZone();
        List l = LogAdminHelper.getLogFilesPattern(lbm);
        if (l.size() > 0){
         lognameexp = (String)l.get(0);
        }
        curmod.setId(lbm.getId());
        curmod.setName(logname);
        curmod.setType("Log");
        curmod.setDescription(logdesc);
        accId = LogSQLAdminHelper.getAccount(lbm).getId();
        selectedLbmIds = LogSQLAdminHelper.getLbmIds(lbm);
        selectedFilterIds = LogSQLAdminHelper.getFilterIds(lbm);
        isAutoUpdate = IntervalAdminHelper.isAutoUpdate(lbm);
        try{
          pmod = mgmt.getParentModule(lbm.getId());
          if (pmod != null){
            boolean foundModule = false;
            for (int i = 0; i < mdarr.length; i++) {
              if (mdarr[i].getId().equals(pmod.getId())){
                foundModule = true;
                break;
              }
            }
            if (!foundModule){
              Module [] tmp = new Module[mdarr.length + 1];
              System.arraycopy(mdarr,0,tmp,0,mdarr.length);
              mdarr = tmp;
              mdarr[mdarr.length - 1] = pmod;
            }
          }
        }catch(Exception e){}
      }
  }

  if(pmod == null){
    pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if(pmod == null){
      pmod = new Module();
      pmod.setId("");
    }
  }

  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module [] {tmpMod};
  }
 
  String[] timeZonesArr = TimeZone.getAvailableIDs();
  Arrays.sort(timeZonesArr);
  
  List list = AddressBook.getInstance().getAccountsByFilter(new DBAccountFilter());
  Account defAccount = AddressBook.getInstance().getAccountById("defaultSqlDb");
  if (defAccount != null){
    list.add(0,defAccount);
  }
  if(list.size() == 0) {
  	//No accounts defined in system
  	ErrorModel errmodel = new ErrorModel();
  	errmodel.addError("There is no databases account defined. Please <a href=\"../../tools/addresses/db/listOfDB.jsp\">create DB account</a> first.");
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  
  HashSet selectedLbmsFilters = new HashSet();
  HashSet selectedLbms = new HashSet();
  for (int i = 0; i < selectedLbmIds.length; i++) {
    selectedLbmsFilters.add(selectedLbmIds[i] + ";" + selectedFilterIds[i]);
    selectedLbms.add(selectedLbmIds[i]);
  }
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>

<script>
	function doNext(){   	  
		var selectedCombo = document.getElementById("selectedLbms");
 		 if (selectedCombo.options.length == 1 && selectedCombo.options[0].value == ""){
    		selectedCombo.options[0] = null;
  		}
  		for (var i = 0; i < selectedCombo.options.length; i++){
    	  selectedCombo.options[i].selected =true;
    	}
    	
    	document.access.action = "addLogSQLAction.jsp";
    	document.access.submit();
	}
	
	
function Filter(id,name,isSelected){
	this.id = id;
	this.name = name;
	this.isSelected = isSelected;
}

function LBM(id,name){
	this.id = id;
	this.name = name;
	this.filters = new Array();
	this.filtersInit = false;
}

var lbms = new Array();

<%
  String name = null;	
  ModuleMember [] membersLbm = SiteManagment.getInstance().getAllLogBrowsersIdsByContext(userContext,false);
   for (int i = 0; i < membersLbm.length; i++) {
     try {
     String id = membersLbm[i].getId();
     boolean isSelectedLbm = selectedLbms.contains(id);
     String [][] filters =  !isSelectedLbm ? new String [0][0] : SiteManagment.getInstance().getFiltersForLogBrowserManager(id);
	name = membersLbm[i].getName();
	if(name != null && name.length() > ALLOWED_LOG_NAME_LENGTH) {
		name = name.substring(0,ALLOWED_LOG_NAME_LENGTH)+"...";
	}
%> 
   var lbm = new LBM("<%=id%>","<%=name%>");
   lbm.filters[lbm.filters.length] = new Filter("","None",<%=selectedLbmsFilters.contains(id + ";")%>);
   lbm.filtersInit = <%=String.valueOf(isSelectedLbm)%>;
<%
   	for (int j = 0; j < filters.length; j++) {
   	  String filterId = filters[j][0];
   	  String fName = filters[j][1];
   	  if(fName != null && fName.length() > ALLOWED_LOG_NAME_LENGTH) {
		 fName = fName.substring(0,ALLOWED_LOG_NAME_LENGTH)+"...";
	 }
%>
  lbm.filters[lbm.filters.length] = new Filter("<%=filterId%>","<%=fName%>",<%=selectedLbmsFilters.contains(id + ";" + filterId)%>);
  
<% 	} %>
   lbms[lbms.length] = lbm;
<% }catch (Exception e){}
} %>
	

function initLbms(){
  var selectedCombo = document.getElementById("selectedLbms");
  selectedCombo.options[selectedCombo.options.length] = new Option("           ","");
  var lbmCombo = document.getElementById("lbms");
  for (var i = 0; i < lbms.length; i++){
    lbmCombo.options[lbmCombo.options.length] = new Option(lbms[i].name,lbms[i].id);    
  }
  if (lbms.length > 0){
    lbmCombo.selectedIndex = 0;
  }
  initSelectedLbms();
  initFilters();
}

function initSelectedLbms(){
  <% for (int i = 0; i < selectedLbmIds.length; i++){%>
      initSelectedLbm("<%=selectedLbmIds[i]%>","<%=selectedFilterIds[i]%>");
  <%}%>
}

function initSelectedLbm(lbmId,filterId){
   for (var i = 0; i < lbms.length; i++){
     if (lbms[i].id == lbmId){
       for (var j = 0; j < lbms[i].filters.length; j++){
         if (lbms[i].filters[j].id == filterId){
           addSelectedLbm(i,j);
         }
       }
     }
   }
}

function initFilters(){
  var lbmCombo = document.getElementById("lbms");
  var filterCombo = document.getElementById("filters");
  filterCombo.options.length = 0;
  var index = lbmCombo.selectedIndex;
  if (index == -1 || lbmCombo.options[index].value == ""){
  	return;
  }
  
  if (lbms[index].filtersInit){
    for (var i = 0; i < lbms[index].filters.length; i++){
      //check the lengths of the filter name
      var fName = lbms[index].filters[i].name;
      if(fName.length > 30) {
      	fName = fName.substring(0,30)+"...";
      }
      //filterCombo.options[filterCombo.options.length] = new Option(lbms[index].filters[i].name,lbms[index].filters[i].id);
      filterCombo.options[filterCombo.options.length] = new Option(fName,lbms[index].filters[i].id);
    }
    filterCombo.selectedIndex = 0;
  }else {
    frames['filtersResultFrame'].location = "SQLAnalyzerGetFilters.jsp?lbmId=" + lbms[index].id + "&index=" + index;
  }
}

function filtersLoaded(){  
  if (frames['filtersResultFrame'].filtersIds && frames['filtersResultFrame'].lbmIndex >= 0){
    var lbm = lbms[frames['filtersResultFrame'].lbmIndex];
    for (var i = 0; i < frames['filtersResultFrame'].filtersIds.length;i++){
      lbm.filters[lbm.filters.length] = new Filter(frames['filtersResultFrame'].filtersIds[i],frames['filtersResultFrame'].filtersNames[i],false);
    }
    lbm.filtersInit = true;
    initFilters();
  }
}

function doAdd(){
  var lbmIndex = document.getElementById("lbms").selectedIndex;
  var filterIndex = document.getElementById("filters").selectedIndex;
  addSelectedLbm(lbmIndex,filterIndex);
}

function addSelectedLbm(lbmIndex,filterIndex){
   if (filterIndex == -1){
     return;
   }
   var selectedId = lbms[lbmIndex].id + ";" + lbms[lbmIndex].filters[filterIndex].id;
  
  var selectedCombo = document.getElementById("selectedLbms");
  if (selectedCombo.options.length == 1 && selectedCombo.options[0].value == ""){
    selectedCombo.options.length = 0;
  }
  for (var i = 0; i < selectedCombo.options.length; i++){
    if (selectedCombo.options[i].value == selectedId){
      return;
    }
  }
  //check the lengths of the filter name
  var fName = lbms[lbmIndex].filters[filterIndex].name;
  if(fName.length > 30) {
  	fName = fName.substring(0,30)+"...";
  }
  var selectedName = lbms[lbmIndex].name + " [" + fName + "]";
  //var selectedName = lbms[lbmIndex].name + " [" + lbms[lbmIndex].filters[filterIndex].name + "]";
  selectedCombo.options[selectedCombo.options.length] = new Option(selectedName,selectedId);
}
 
function doRemove(){
  var selectedCombo = document.getElementById("selectedLbms");
  if (selectedCombo.selectedIndex >= 0 && selectedCombo.options[selectedCombo.selectedIndex].value != ""){
    selectedCombo.options[selectedCombo.selectedIndex] = null;        
  }
} 
</script>
</head>

<body onLoad="initLbms()">
<iframe name="filtersResultFrame" style="visibility:hidden" onLoad="javascript:filtersLoaded()" width="0" height="0"></iframe>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="800" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="671" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Log</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="374" id="AutoNumber3">
                  <tr>
                    <td width="800" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" height="18"></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Parent folder</span></td>
                        <td width="89%">
                        <select size="1" class="TEXTBOX" name="ParentModule" id="ParentModule">
                          <%
                            String selected = "";
                            for(int i=0;i<mdarr.length;++i){
                              if(mdarr[i].getId().equals(pmod.getId())){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>          
                          <%} %>
                        </select></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800" height="21">
                    <span class="HEADER">Database Details</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="800"></td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="150"><span class="REGULARTEXT">Database Account</span></td>
                          <td width="574">
                        <select size="1" class="TEXTBOX" name="DatabaseAccount" id="DatabaseAccount">
                        <option value="">--- Select db account ---</option>
                            <%
                            	String accselected = "selected";
                            	String accunselected = "";
                            	String toGo = accunselected;
                            	Account account = null;
                            	
                            	for(int i=0;i<list.size();++i){
                            		account = (Account)list.get(i);
                            		if(account.getId().equals(accId)){
                            			toGo = accselected;
                            		}else{
                            			toGo = accunselected;
                            		}
                            %>
                            <option class="TEXTBOX" <%=toGo%> value=<%=account.getId()%>><%=account.getAccountName()%></option>
                            <%
                            	}
                            %>
                        </select>
                        <%
                        if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <a href="<%=BASE_DIRECTORY%>tools/addresses/db/listOfDB.jsp" class="LINK">new</a>
                        <a href="<%=BASE_DIRECTORY%>tools/addresses/addressview.jsp?addressType=db" class="LINK">edit</a>
                        <%}%>
                        </td>
                        
                          <td width="76"></td>
                        </tr>
                        <tr>
                          <td width="150"></td>
                          <td width="574">
                        <span class="SMALLTEXT">Choose the Database account to execute the
                        		query on.&nbsp;</span></td>
                          <td width="76"></td>
                        </tr>                       
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>

                    <td width="800">
                        <span class="HEADER">Time Zone</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="170"><span class="REGULARTEXT">Log time zone</span></td>
                          <td width="630">
                          <select size="1" class="TEXTBOX" name="TimeZone" id="TimeZone">
                          <%
                            selected = "";
                            selected = isUsingDefaultTimeZone? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default [<%=defaultZone.getID()%>]</option>
                            <%
                            for(int i=0;i<timeZonesArr.length;++i){
                              if(!isUsingDefaultTimeZone && timeZonesArr[i].equals(timeZoneId)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=timeZonesArr[i]%>" class="TEXTBOX" <%=selected%>><%=timeZonesArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">(if the table doesn't have a date column the time zone will be ignored).</span></td>
                          <td width="83"></td>
                        </tr>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Automatic data update&nbsp;</span></td>
                          <td width="574">
                          	<input type="checkBox" name="AutoUpdate" id="AutoUpdate" value="true" 
                          	<%=isAutoUpdate ? " checked":""%>></input>
                          	<span class="SMALLTEXT">Select this option to update the viewed data each time the log is being accessed</span>
                          </td>
                          <td width="76"></td>
                        </tr>         
                        <tr>
                          <td width="150"></td>
                          <td width="550"> </td>
                          <td width="83"></td>
                        </tr>
                        </table>
                     		 </td>
                     	 </tr>
                     		<tr>
                   			  <td width="100%">&nbsp;</td>
		                    </tr>
                         <tr>

                    		<td width="800">
                       			 <span class="HEADER">Logs</span>
                    		</td>
                  		 </tr>
                  		  <tr>
                    		<td width="800">
                     		 <table border="0" width="800" cellspacing="0" cellpadding="0">
                     		 <tr>
                    		   <td>
                      			<table border="0" width="100%" cellspacing="0" cellpadding="0">
                      				<tr>
                      					<td width="50"><span class="REGULARTEXT">Logs: </span></td>
                      					<td width="100"><select size="1" class="TEXTBOX" name="lbms" id="lbms" onChange="initFilters()">
                      						</select></td>
                      					<td width="50"><span class="REGULARTEXT">Filters: </span></td>
                      					<td width="100"><select size="1" class="TEXTBOX" name="filters" id="filters">
                      						</select></td>
                      					<td width="50" style="padding-left:10;padding-right:10">
                          					<table border="0" width="100%" cellspacing="0" cellpadding="0">
                           						 <tr>
                             						 <td width="100%"></td>
                            					 </tr>
                           						 <tr>
                              						<td width="100%">
                                						<table border="0" width="100%" cellspacing="0" cellpadding="0">
                                    			 		<tr>
					                                    <td width="100%" align="center"><a href="javascript:doAdd()" class="SMALLLINK">add</a></td>
                    				                	</tr>
                                  						<tr>
                                    					<td width="100%" align="center"><a href="javascript:doRemove()" class="SMALLLINK">remove</a></td>
                                  						</tr>
                                						</table>
                              						</td>
                            					</tr>
                            					<tr>
                              						<td width="100%"></td>
                            					</tr>
                      					    </table>
                     				      </td>
                     				      <td width="200"><select size="5" class="TEXTBOX" name="selectedLbms" id="selectedLbms" multiple>                     				      
                      						</select></td>
                      					  <td width="*">&nbsp;</td>
                      				</table>
                      				</td>
                      				</tr>     
                     		 </table>
                     		 </td>
                     	 
                  </tr>
                  <tr>
                    <td width="800">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <% if (backwardURL != null){ %>
                        <td width="10%"><a href="<%=backwardURL%>" class="LINK">previous</a></td>
			<%}%>
                        <td width="16%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="38%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>