<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.util.*"%>
<% 

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "ParentModule";
  String LOG_PATH = "LogPath";
  String LOG_DATA_PATTERN = "DataPattern";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String DB_ACCOUNT = "DatabaseAccount";
  String SELECTED_LBMS = "selectedLbms";
  String AUTO_UPDATE = "AutoUpdate";
  String autoUpdateString = request.getParameter(AUTO_UPDATE);
  

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String modid      = request.getParameter(MODULE_ID);
  String logname    = request.getParameter(LOG_NAME);
  String logdesc    = request.getParameter(LOG_DESCRIPTION);
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String dbId = request.getParameter(DB_ACCOUNT);
  String [] lbmFilterIds = request.getParameterValues(SELECTED_LBMS);
  String mediaType = "DBMedia";
   
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }

   if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  
  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }

  if(dbId == null || dbId.trim().equals("")){
    errmodel.addError("No Database account was supplied.");
  }
  
  if(lbmFilterIds == null || lbmFilterIds.length == 0 || lbmFilterIds[0].length() == 0){
    errmodel.addError("No selected logs were supplied.");
  }
  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
 
  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.SQL_TYPE);
  
  boolean autoUpdate = true;
  if (autoUpdateString == null || !autoUpdateString.equals("true")){
  	autoUpdate = false;
  }
  
  String [] lbmIds = new String[lbmFilterIds.length];
  String [] filterIds = new String[lbmFilterIds.length];
  for (int i = 0; i < lbmFilterIds.length; i++) {
    int index = lbmFilterIds[i].indexOf(";");
    lbmIds[i] = lbmFilterIds[i].substring(0,index);
    filterIds[i] = lbmFilterIds[i].substring(index + 1,lbmFilterIds[i].length());
  }

  int maxRecordsToUse = 100;
  String query = "";
  String logdatapat = "{string}";
  if(lbm != null){
    if (!lbm.isTemporary()){
      builder.setID(lbm.getId());
    }
    query = LogSQLAdminHelper.getQuery(lbm);
    logdatapat = LogAdminHelper.getXpologPattern(lbm);
  }else {
    query = "select * from ";
  	for (int i = 0; i < lbmIds.length; i++) {
  	  if (i > 0){
  	    query += ",";
  	  }
   	  query += "Table" + (i + 1);
  	}
  	if (lbmIds.length > 5){
  	  maxRecordsToUse = 5;
  	}else if (lbmIds.length > 1){
  	  maxRecordsToUse = 10;
  	}
  }
  builder.setName(logname);
  builder.setLogsFileNamePattern("{string}");
  builder.setLogsDirectory(builder.createUniqueDirLocation());
  builder.setRecordPattern(logdatapat);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setQuery(query);
  builder.setLogsInfo(lbmIds,filterIds);
  builder.setMaxRecordsToUse(maxRecordsToUse);
  builder.setAutoUpdate(autoUpdate);

  DBAccount acc = (DBAccount)AddressBook.getInstance().getAccountById(dbId);

  builder.setAccount(acc);

  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  
  if (lbm != null && LogSQLAdminHelper.isIdentical(builder.getLogBrowserManager(),lbm)){
    builder.getLogBrowserManager().setRecordMask(lbm.getRecordMask());
  }

  String BASE_DIRECTORY = "../../../";
  String [] pages = {"loggers/admin/sql/addLogSQL.jsp",
  		     "loggers/admin/sql/SQLLogDataPattern.jsp",
  		     "loggers/admin/logFieldAdmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  builder.setUiController(controller);

  request.getSession().setAttribute("MODULE_ID",modid);
  request.getSession().setAttribute(BUILDER, builder);
  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());

%>


