<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.media.auth.win.WinAuthenticationAccountFilter"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String OP = "OP";
  String ADD = "ADD"; 
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String LOG_TIME_ZONE = "LOG_TIME_ZONE";

  //page data
  LogBrowsingManager lbm = null;
  String modid      = "";
  String logname    = "";
  String logdesc    = "";
  String eventLogName = "";
  String machineName = "";
  String fileType = "";

  boolean isUsingDefaultTimeZone = true;
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = defaultZone.getID();
  String selectedCharset = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String authAccountId = request.getParameter("accountId");

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = null;
  boolean useIndexing = false;
  boolean useIndexingForDateSearch = false;
  //check state
  String op = request.getParameter(OP);
  if((op != null) && op.trim().equals(ADD)){
    //we are adding a new browser
    request.getSession().removeAttribute(CURRENT_LOG);
  }else{
    String id = request.getParameter(LOG_ID);
    if((id != null) && !(id.trim().equals(""))){
      try{
        lbm = mgmt.getLogBrowserManager(id);
      }catch(Exception e){}
    }else{
      lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
    }

    if(lbm != null){
        request.getSession().setAttribute(CURRENT_LOG,lbm);
        logname    = lbm.getName();
        logdesc    = lbm.getDescription();
        timeZoneId = lbm.getTimeZone().getID();
        selectedCharset = lbm.getCharset();
        isUsingDefaultTimeZone = lbm.isUsingDefaultTimeZone();
        machineName = WinEventAdminHelper.getMachineName(lbm);
        eventLogName = WinEventAdminHelper.getLogName(lbm);
        fileType = WinEventAdminHelper.getLogType(lbm); 
        useIndexing = lbm.isUseIndexing();
        useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
        
        if (authAccountId == null || authAccountId.length() == 0){
	        Account authAccount = WinEventAdminHelper.getAuthAccount(lbm);
	        if (authAccount != null){
	        	authAccountId = authAccount.getId();
	        }
        }
        curmod.setId(lbm.getId());
        curmod.setName(logname);
        curmod.setType("Log");        
        curmod.setDescription(logdesc);
        try{
          pmod = mgmt.getParentModule(lbm.getId());
          if (pmod != null){
            boolean foundModule = false;
            for (int i = 0; i < mdarr.length; i++) {
              if (mdarr[i].getId().equals(pmod.getId())){
                foundModule = true;
                break;
              }
            }
            if (!foundModule){
              Module  [] tmp = new Module[mdarr.length + 1];
              System.arraycopy(mdarr,0,tmp,0,mdarr.length);
              mdarr = tmp;
              mdarr[mdarr.length - 1] = pmod;
            }
          }
        }catch(Exception e){
        }
      }
  }

  int type = type = WinEventAdminHelper.calculateType(eventLogName,fileType);

  if(pmod == null){
    pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if(pmod == null){
      pmod = new Module();
      pmod.setId("");
    }
  }

  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module[] {tmpMod};
  }


  String[] timeZonesArr = TimeZone.getAvailableIDs();
  Arrays.sort(timeZonesArr);
  
  Map charsetMap = java.nio.charset.Charset.availableCharsets();
  String [] charsetArr = (String [])charsetMap.keySet().toArray(new String [charsetMap.size()]);
  
  
  boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(xpolog.eye.managment.XpologManagment.SEARCH_ENGINE_COMPONENT);
  String indexingSpecialCharacters = "";
  boolean useSearchEngineSetting = indexingSpecialCharacters == null;
  String defUseIndexForDateSearchStr = Configuration.getInstance().getPropertiesManager().getProperty("useIndexingForDateSearch", null);
  boolean defUseIndexForDateSearchForNew = lbm == null && defUseIndexForDateSearchStr != null && defUseIndexForDateSearchStr.equals("true");
  
  AddressBook adbook = AddressBook.getInstance();
	AddressFilter filter = new WinAuthenticationAccountFilter();
  List list = adbook.getAccountsByFilter(filter,userContext);
  
  String selected = "";
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>

<script>

 function updateUseIndex(){
		var isChecked = document.getElementById("useIndexingStr").checked;
		
		var dateIndexSearchDiv = document.getElementById("dateIndexSearchDiv");
	  if(dateIndexSearchDiv){
	    if (isChecked){
	      dateIndexSearchDiv.style.visibility = "";
	    }else {
	      dateIndexSearchDiv.style.visibility = "hidden";
	    } 
	  }
	}
	
	function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/auth/authAccWin.jsp";
		<%
		String forwardURL = "loggers/admin/winevent/winEventAdmin.jsp?"+request.getQueryString();
		forwardURL = xpolog.eye.util.XpologUtil.replaceAll(forwardURL,"?","%3f"); 
		forwardURL = xpolog.eye.util.XpologUtil.replaceAll(forwardURL,"&","%26"); 
		%>
		document.access.forwardURL.value = path;
		document.access.submit();
	}
	
	function addNewLocation(){
		document.getElementById("allNewPaths").style.display = "";
		var allNewPathsDiv = document.getElementById("allNewPaths");
		var divIdName = "newPath"+indx+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		newdiv.innerHTML = "<tr><td>" +
											 "<table border=\"0\" cellspacing=\"3\" cellpadding=\"0\" width=\"800\">" + 
											 "<tr><td width=\"75\"><span class=\"REGULARTEXT\">Log Path</span></td>" + 
	                     "<td width=\"425\"><input type=\"TEXTBOX\" class=\"TEXTBOX\" onKeyPress=\"javascript:doOpenBrowser('FullPath_" + indx+ "',"+ indx+",event);\"  name=\"FullPath_"+indx+"\" id=\"FullPath_"+indx+"\" size=\"75\" value=\"\"></td>" +
	                     "<td width=\"80\"><input type=button id=\"fileBrowseButton_"+indx+"\" value=\"Browse\" onClick=\"openBrowser('FullPath_" + indx+ "',"+ indx+")\"></td>" +                                                                            	                    	                    
	                    "<td width=\"70\">" +
													"<select class=\"TEXTBOX\" name=\"LogState_"+indx+"\"   onChange=\"javascript:changeStatus(this.value,'" +indx+"')\">" +
															"<option value=\"online\" \"selected\">online</option>"+
															"<option value=\"offline\" >offline</option>"+
													"</select>"+
                          "</td>"+  
                          
                          "<td width=\"30\" style=\"cursor:pointer;\" onClick=\"javascript:showLogSettings(event,'" +indx+"','0')\">"+                   
														"<img id=\"imgid_"+indx+"\" src=\"../../images/slides/menuArrow.gif\" alt=\"Log dynamic type settings\" style=\"display:\">" +
                         "</td>"+                                                                                               	                    
	                     "<td colspan=\"2\" width=\"100\"><a id=\"removePath_"+indx+ "\" href=\"javascript:remove('newPath"+indx+"Div');\" class=\"SMALLLINK\">Remove</a></td>" +                    
	                     "</tr></table></td></tr>"
		 allNewPathsDiv.appendChild(newdiv);
		 indx = (indx-1+2);	
		 counter = (counter-1+ 2);	
	}
	
	function doNext(){
		if (updateParentModule){
			updateParentModule(tree,"ParentModule");
		}
    document.access.submit();
	}
	

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="winEventAdminAction.jsp">
<input type="hidden" name="forwardURL">
<input type="hidden" name="ParentModule">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="800" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="671" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Log</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="374" id="AutoNumber3">
                  <tr>
                    <td width="800" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" height="18"></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td colspan="2">
													<jsp:include page="../../../common/selectParentModule.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="PARENT_MODULE_ID" value="<%=pmod.getId()%>" />
													</jsp:include>
                        </td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800" height="21">
                    <span class="HEADER">Location</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">                                                
                        <tr>
                          <td width="220"><span class="REGULARTEXT">Machine name</span></td>
                          <td width="480">
                        <input type="text" class="TEXTBOX" name="machineName" id="machineName" size="30" value="<%=machineName%>"></td>
                          <td width="100"></td>
                        </tr>  
                        <tr>
                          <td width="220"></td>
                          <td width="580" colspan="2"><span class="SMALLTEXT">Leave blank for localhost</span></td>
                        </tr>
                        <tr>                  
                    <td >
                    &nbsp;&nbsp;</td>
                  </tr>
									<%if (xpolog.tools.XpologSystemInfo.isWindows()){%>			                      	
			                        <tr>
			                          <td colspan="2"><span class="REGULARTEXT">Authentication Account &nbsp;</span>
						                     <select name="authAccId" id="authAccId">
						                     	<option value=""><span class="REGULARTEXT">-- select ---</span></option>
						                     <%
						                      for(int t=0;t<list.size();t++){
						                        Account acc = (Account)list.get(t);
						                        String accSelected = "";
						                        String accType = acc.getType();
						                        if (authAccountId != null && acc.getId().equals(authAccountId)){
						                        	accSelected = " selected";
						                        }
						                     %>
						                     	<option value="<%=acc.getId()%>" <%=accSelected%>><span class="REGULARTEXT"><%=acc.getAccountName() + " (" + accType + ")"%></span></option>
						                     <%} %>
						                     </select>
																	<%
																	if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
																	%>
																	<span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
																	<%}%>
			                          </td>
			                        </tr>
			                        <%}%>
                        <tr>
                          <td width="750" colspan="3">&nbsp;</td>
                        </tr>
                        <tr>
                          <td width="150"><span class="HEADER">Log Name:</span></td>
                          <td width="550"></td>
                          <td width="100"></td>
                        </tr>
                         <tr>
                          <td width="750" colspan="3">&nbsp;</td>
                        </tr>
                        <tr height="30">
                          <td width="700" colspan="2"><nobr>
                          <input type="radio"  name="eventType" id="Application" value="<%=String.valueOf(WinEventAdminHelper.APPLICATION_TYPE)%>" <%=type == WinEventAdminHelper.APPLICATION_TYPE? "checked" : "" %>><span class="REGULARTEXT">&nbsp;Application</span>
                          &nbsp;&nbsp;<input type="radio"  name="eventType" id="System" value="<%=String.valueOf(WinEventAdminHelper.SYSTEM_TYPE)%>" <%=type == WinEventAdminHelper.SYSTEM_TYPE? "checked" : "" %>><span class="REGULARTEXT">&nbsp;System</span>
                          &nbsp;&nbsp;<input type="radio"  name="eventType" id="Security" value="<%=String.valueOf(WinEventAdminHelper.SECURITY_TYPE)%>" <%=type == WinEventAdminHelper.SECURITY_TYPE? "checked" : "" %>><span class="REGULARTEXT">&nbsp;Security</span>
                          </nobr></td>                         
                          <td width="100"></td>
                        </tr>                                             
                        <tr height="30">
                          <td width="150"><input type="radio"  name="eventType" id="other" value="<%=String.valueOf(WinEventAdminHelper.OTHER_TYPE)%>" <%=type == WinEventAdminHelper.OTHER_TYPE? "checked" : "" %>><span class="REGULARTEXT">&nbsp;Custom:</span></td>                         
                          <td width="550">
                          <input type="text" class="TEXTBOX" name="eventLogName" size="50" onFocus="document.access.other.checked=true" value="<%=type == WinEventAdminHelper.OTHER_TYPE?eventLogName : ""%>"></td>
                          <td width="100"></td>
                        </tr>
                         <tr>
                          <td width="150"></td>
                          <td width="700" colspan="2"><span class="SMALLTEXT">Notice: If a custom registered log name cannot be found, the event logging service will open the Application log </span></td>
                        </tr>
                         <tr>
                          <td width="750" colspan="3">&nbsp;</td>
                        </tr>
                        <tr height="30">
                          <td width="150"><input type="radio" name="eventType" id="file" value="<%=String.valueOf(WinEventAdminHelper.FILE_TYPE)%>" <%=type == WinEventAdminHelper.FILE_TYPE? "checked" : "" %>><span class="REGULARTEXT">&nbsp;File:</span></td>                         
                          <td width="550">
                          <nobr>
                          <input type="<%=type == WinEventAdminHelper.FILE_TYPE?"text" : "file"%>" class="TEXTBOX" name="eventLogPath" size="50" onFocus="document.access.file.checked=true" value="<%=type == WinEventAdminHelper.FILE_TYPE?eventLogName : ""%>">&nbsp;
                          <span class="REGULARTEXT">from type</span>
                          &nbsp;
                          <select size="1" class="TEXTBOX" name="fileType" id="fileType">                           
                            <%
                            
                            String [] types = WinEventAdminHelper.getFilesTypes(lbm);
                            selected = "";
                            for(int i=0;i<types.length;++i){
                              if(types[i].equals(fileType)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=types[i]%>" class="TEXTBOX" <%=selected%>><%=types[i]%></option>
                          <%}%>

                        </select>
                          </nobr>
                          </td>
                          <td width="100"></td>
                        </tr>
                        
                      </table>
                    </td>
                  </tr>
                  
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>                  
                  <tr>

                    <td width="800">
                        <span class="HEADER">Time Zone</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="170"><span class="REGULARTEXT">Log time zone</span></td>                         
                          <td width="630">
                          <select size="1" class="TEXTBOX" name="TimeZone" id="TimeZone">
                          <%
                            selected = "";
                            selected = isUsingDefaultTimeZone? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default [<%=defaultZone.getID()%>]</option>
                            <%
                            for(int i=0;i<timeZonesArr.length;++i){
                              if(!isUsingDefaultTimeZone && timeZonesArr[i].equals(timeZoneId)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=timeZonesArr[i]%>" class="TEXTBOX" <%=selected%>><%=timeZonesArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">(if the log doesn't have a date field the time zone will be ignored).</span></td>
                          <td width="83"></td>
                        </tr>
                        
                                             
                      </table>
                    </td>
                  </tr>
                   
                  <tr>

                    <td width="800">
                        <span class="HEADER">Charecter Encoding</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="225"><span class="REGULARTEXT">Character set</span></td>
                          <td width="550">
                          <select size="1" class="TEXTBOX" name="charset" id="charset">
                          <%
                            selected = "";
                            selected = selectedCharset == null? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default</option>
                            <%
                            for(int i=0;i<charsetArr.length;++i){
                              if(selectedCharset != null && charsetArr[i].equals(selectedCharset)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=charsetArr[i]%>" class="TEXTBOX" <%=selected%>><%=charsetArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">Use charset according the file encoding and machine charset support.</span></td>
                          <td width="83"></td>
                        </tr>
                                                
                      </table>
                    </td>
                  </tr>
                  
                   <tr>
                    <td>&nbsp;</td>
                  </tr>
									<tr>
										<td <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
											<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			                  <tr>
			                    <td><span class="HEADER">Indexing settings</span></td>
			                  </tr>                  
			                  <tr>
			                    <td><input id="useIndexingStr" name="useIndexingStr" type="checkbox"  <%=useIndexing?"checked" : ""%>  onClick="javascript:updateUseIndex()"><span class="REGULARTEXT">Use indexing</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;using log indexing enables rapid search and filtering; indexed logged can be used in Xpolog Search Engine </span></td>
			                  </tr>                 
			                  <tr style="font-size:3">
			                    <td>&nbsp;</td>
			                  </tr>
			                  <tr>
			                    <td>
			                    	<div id="dateIndexSearchDiv" <%=useIndexing ? "" : "style=\"visibility:hidden\""%>>
			                    	<input id="useIndexingForDateSearchStr" name="useIndexingForDateSearchStr" type="checkbox"  <%=(useIndexingForDateSearch || defUseIndexForDateSearchForNew)?"checked" : ""%>><span class="REGULARTEXT">Use indexing for date search</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to allow for quick date search using the index</span>
			                    	</div>
			                    </td>
			                  </tr>                 
			                  <!--
												<tr>
													<td><span class="ERRORMESSAGE"><b>Note: changing the following setting will delete the log's index!</b></span></td>
												</tr>
												<tr>
													<td><input type="checkbox" name="useSearchEngineSettings" id="useSearchEngineSettings" value="true" onClick="javasciprt:showHideIndexingSpecialCharactersDiv()"><span class="REGULARTEXT">Use search engine's settings</span></td>
												</tr>
												<tr>
													<td>
														<div id="overrideIndexingSpecialCharactersDiv" <%=useSearchEngineSetting ? "style=\"visibility:hidden\"" : ""%>>
														<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
															<tr>
																<td><span class="REGULARTEXT">Special Characters: <input type="text" name="indexingSpecialCharacters" id="indexingSpecialCharacters" value="<%=indexingSpecialCharacters == null ? "" : indexingSpecialCharacters%>"></span></td>
															</tr>
															<tr>
																<td><span class="SMALLTEXT">
																	Please insert the special characters which should be used as a delimeter in the indexing process.<br>
																	Please enter the characters without spaces between them (e.g -  &[];:%,{})
																</span></td>
														  </tr>
														</table>
														</div>
													</td>
												</tr>
												-->
											</table>
										</td>
									</tr>
									
									
                  <tr>                  
                    <td width="800">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <td width="10%"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="16%"><a href="javascript:doNext();" class="LINK">save</a></td>
                        <td width="38%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>