<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.data.index.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  
  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG"; 

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String modid      = request.getParameter("ParentModule");
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname    = request.getParameter("LogName");
  String logdesc    = request.getParameter("LogDescription");
  String machine    = request.getParameter("machineName");  
  String timeZoneId = request.getParameter("TimeZone");
  String charset    = request.getParameter("charset");
  String eventType = request.getParameter("eventType");
  if (charset != null && charset.equals("default")){
    charset = null;
  }
  String authAccId = request.getParameter("accountId");
  //verify data
  ErrorModel errmodel = new ErrorModel();

  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  String fileType = null;
  String eventLogName = null;
  if(eventType == null || eventType.equals("")){
    errmodel.addError("No event log name supplied.");
  }else {
    int type = Integer.parseInt(eventType);
    switch (type){
      case WinEventAdminHelper.APPLICATION_TYPE:
        eventLogName = "Application";
        break;
      case WinEventAdminHelper.SYSTEM_TYPE:
        eventLogName = "System";
        break;
      case WinEventAdminHelper.SECURITY_TYPE:
        eventLogName = "Security";
        break;
      case WinEventAdminHelper.OTHER_TYPE:
        eventLogName    = request.getParameter("eventLogName");
        if(eventLogName == null || eventLogName.equals("")){
    	   errmodel.addError("No event log name supplied.");
  		}
        break;
      case WinEventAdminHelper.FILE_TYPE:
        eventLogName    = request.getParameter("fullPath_0WinEvent");
        if(eventLogName == null || eventLogName.equals("")){
    	   errmodel.addError("No event log name supplied.");
  		}
  		
  		fileType = request.getParameter("fileType");
  		if(fileType == null || fileType.equals("")){
    	   errmodel.addError("No file type supplied.");
  		}
        break;
      default :
        eventLogName = "Application";
        break; 
        
    }
  }
  
  
  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }
  
  if (authAccId != null && authAccId.length() > 0 && (machine == null || machine.length() == 0 || machine.equalsIgnoreCase("localhost"))){
  	authAccId = null;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !lbm.getType().equals(WinEventLogBuilder.EVENT_VIEWER_TYPE)){
  	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }

  WinEventLogBuilder builder = (WinEventLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.WIN_EVENT_TYPE);
  String dataPat = builder.createDefaultPattern();
  
  boolean shouldRemoveIndex = false;
  if(lbm != null){
    builder.setID(lbm.getId());
    dataPat = WinEventAdminHelper.getXpologPattern(lbm);
    String machineName = WinEventAdminHelper.getMachineName(lbm);
    String logName = WinEventAdminHelper.getLogName(lbm);
    if (lbm.isUseIndexing() && ((machineName != null && !machineName.equalsIgnoreCase(machine)) || (logName != null && !logName.equalsIgnoreCase(logname)))){
    	shouldRemoveIndex = true;
    }
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
    builder.setIndexNullValues(lbm.isIndexNullValues());
    builder.setUseWholeWords(lbm.isUseWholeWords());
    builder.setComputeStatistics(lbm.isComputeStatistics());
    builder.setUseInDashboard(lbm.isUseInDashboard());
    builder.setUseInDashboardTask(lbm.isUseInDashboardTask());
    builder.setHost(lbm.getHost());
    builder.setScannerRoot(lbm.getScannerRoot());
  }

  builder.setName(logname);
  builder.setApplicationsIds(applicationsIds);
  builder.setRecordPattern(dataPat);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setCharset(charset);
  builder.setMachineName(machine);
  builder.setLogName(eventLogName);
  builder.setLogType(fileType);
  if(lbm != null){
	  builder.setIgnoreUnparsedRecords(LogAdminHelper.isIgnoreUnparsedRecords(lbm));
  }
  if (authAccId != null){
  	AuthenticationAccount acc = (AuthenticationAccount)AddressBook.getInstance().getAccountById(authAccId);
  	builder.setAuthenticationAccount(acc);
  }else{
  	builder.setAuthenticationAccount(null);
  }

  boolean isNew = lbm == null || lbm.getId() == null;
  if(isNew) {
  	builder.setUseIndexing(true);
  }
  
  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  LogBrowsingManager newLbm = builder.getLogBrowserManager();
  if(lbm != null){
  	newLbm.setFilterManager(lbm.getFilterManager());
  	newLbm.setCustomizationManager(lbm.getCustomizationManager());
  	newLbm.setSearchAndFilterDef(lbm.getSearchAndFilterDef());
  	newLbm.setConsolidation(lbm.isConsolidation());
  }
  
	String forwardURL = request.getParameter("forwardURL");
	if (forwardURL != null && forwardURL.length() > 0){
	 	String nextToken = forwardURL.indexOf("?") == -1 ? "?" : "&";
	 	forwardURL = forwardURL + nextToken + "forwardURL=loggers/admin/winevent/winEventAdmin.jsp";
	 	response.sendRedirect(forwardURL);
	 	return;
	}
	  
	if (shouldRemoveIndex){
	  SearchEngineManager.getInstance().getDefaultIndexAdapter().removeIndex(new IndexedObject(newLbm));
	}
  

  if(modid == null || modid.trim().equals("")){
    modid = "rootModule";
  }
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + newLbm.getName());
  admin.addLogBrowser(newLbm,parentmod);
  
  if(isNew) {
  	String[] lbmIds = new String[1];
  	lbmIds[0] = newLbm.getId();
  	admin.generateLogData(lbmIds, userContext);
  }
  
  request.getSession().removeAttribute(BUILDER);
  request.getSession().removeAttribute("IS_NEW");
  request.getSession().setAttribute(CURRENT_LOG,newLbm);
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/winevent/logaddopok.jsp");
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
%>


