<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";

 
  //page data
  LogBrowsingManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  String doReanalyzedStr = request.getParameter("doReanalyzed");
 	boolean doReanalyzed = doReanalyzedStr != null && doReanalyzedStr.equals("true");
	//clear old schema results	
 	if(doReanalyzed && builder != null){
		builder.clearElementsInfo();
	}
  String doUpdateTagStr = request.getParameter("doUpdateTag");
 	boolean doUpdateTag = doUpdateTagStr != null && doUpdateTagStr.equals("true");
  
  String tagName = request.getParameter("tagName");
  if(tagName == null || tagName.length() == 0){
  	tagName = lbm == null ? "" : XMLLogAdminHelper.getTagName(lbm);
  }
  if(tagName != null && tagName.length() > 0){
  	builder.setTagName(tagName.trim());
  	builder.updateBuilder();
  }
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("XMLLogSchema.jsp");
  }
  String toVerify = request.getParameter("logLines");
  String isSchemaEditStr = request.getParameter("isSchemaEdit");
  boolean isSchemaEdit = isSchemaEditStr != null && isSchemaEditStr.equals("true");
  String backwardURL = request.getParameter("backwardURL");
  String backwardURLOrig = backwardURL;
  if (backwardURL != null && backwardURL.length() > 0){
    if (!backwardURL.startsWith("javascript")){
      //backwardURL = BASE_DIRECTORY + backwardURL;
    }
  }else {
    if (controller != null){
      backwardURL = controller.getBackwardPage();
      backwardURLOrig = controller.getBackwardPage();
    }
  }       

  LogBrowsingManager lbmBuilder = builder.getLogBrowserManager();;
  if(lbm == null){
     lbm = lbmBuilder;
  }


  boolean doUpdate = builder.getElementsPatternInfoCount() == 0 || toVerify != null || isSchemaEdit;
  String recordString = toVerify;
  String []lines  = null;
  String emptyResult = "XpoLog : There is no element found for tag name";
  if (doUpdateTag || toVerify == null || toVerify.startsWith("XpoLog")){
   recordString = XMLLogAdminHelper.getFirstElementRecord(lbmBuilder);
   if (recordString == null || recordString.trim().length() == 0){
     doUpdate = false;
     if (XMLLogAdminHelper.isFilesExists(lbmBuilder)){
   	  lines = XMLLogAdminHelper.readLines(lbmBuilder,20);    	   
  	  if(lines == null || lines.length == 0){
        recordString = emptyResult + " " + builder.getTagName();
  	  }else{
     		String sep = System.getProperty("line.separator");
 				for(int t=0;t<lines.length;++t){
 					String line = lines[t];			
 					line = line.replaceAll("<","&lt;");
 					line = line.replaceAll(">","&gt;");
 					line = line.replaceAll("\"","&quot;");
 					recordString += line + sep;
 				}  	  		
  	  }
     }else {
      recordString = "XpoLog : No files were found according to the supplied details\n";
      recordString += "XpoLog : Please check the path";
     }
   }
  }
  String errorPattern = "";
  boolean patternOk = true;
  if (doUpdate){

    try{
      if (isSchemaEdit){
        for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
           XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
           String pat = request.getParameter("elemPattern_" + i);
           String cond = request.getParameter("conditionCombo" + i);
           String condVal = request.getParameter("conditionValue_" + i);
           String ignore = request.getParameter("ignore_" + i);
           String includeElements = request.getParameter("includeElements_" + i);
           info.setSelected(ignore == null || !ignore.equals("on"));
           info.setIncludeInnerElements(includeElements != null && includeElements.equals("on"));
           if (pat != null && pat.trim().length() > 0){
             info.setXpologPattern(pat);
           }

           if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
             info.setConditionProperty(cond,condVal);
           }else {
             info.setConditionParameters(null);
           }
        }

      }else {
	        builder.buildElementsPatternInfo(recordString);
      }
      builder.setVirtualColumnsBuilder(null); 
      builder.updateBuilder();

    }catch(Exception e){
      errorPattern = e.getMessage();
      patternOk = false;
    }
  }
  lbm = builder.getLogBrowserManager();
   //log table example

  String html = "";
  if(builder.getElementsPatternInfoCount() > 0 && patternOk){
    //html creation
    RecordsMaskTableModel model = lbm.getFirstEntries(5);
    LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
 		// don't use priority coloring in admin
    lem.getCustomizationManager().setUsePriorityBgColor(false);
    OHtmlTable tab = new OHtmlTable(lem);

    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
    tab.render();
    html = tab.getHtml();
  }
  String htmlColor = "";
  if(html == null || html.length() == 0){
  	htmlColor = "red";
  	if(recordString == null || recordString.length() == 0){
	  	html = "XpoLog : Please check the path";
  	}else if(tagName == null || tagName.length() == 0){
  		html = "XpoLog : Please specify the record tag name";
  	}else if(tagName != null && tagName.length() > 0){
  		html = "XpoLog : No element was found for the tag " + tagName;
  	}else{
  		html = "XpoLog : No files were found according to the supplied details";
  	}
  }
  String charset = lbm.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }

  backwardURLOrig = backwardURLOrig.replaceAll("\\?","%3f");
  backwardURLOrig = backwardURLOrig.replaceAll("\\&","%26");
  
  String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}else {
		int w = -1;
		try {
			w = Integer.parseInt(logAdminScreenWidth);
			logAdminScreenWidth = "" + (w - 8);
		}catch (Exception e){			
		}
		
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script language="javascript">
function doNext(){
   document.access.action = "XMLLogSchemaAction.jsp";
   document.access.submit();
}
function reanalyzeXMLCode(isUpdateTag){
   var tagName = document.access.tagName.value;
   document.access.action = "XMLLogSchema.jsp?<%=backwardURLOrig == null ? "" : "backwardURL=" + backwardURLOrig%>" + "&tagName=" + tagName + "&LogAdminScreenWidth=<%=logAdminScreenWidth %>"  + "&doReanalyzed=true" + "&doUpdateTag=" + isUpdateTag;
   document.access.submit();
}

function verifySchema(){
   document.access.action = "XMLLogSchema.jsp?isSchemaEdit=true<%=backwardURLOrig == null ? "" : "&backwardURL=" + backwardURLOrig%>&LogAdminScreenWidth=<%=logAdminScreenWidth %>";
   document.access.submit();
}

function ElementColumn(){
  this.attributes = new Array();
}

function ElementAttribute(key,value){
  this.key = key;
  this.value = value;
}

var elementsColumns = new Array();
<%
for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
  XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
%>
  elementsColumns[elementsColumns.length] = new ElementColumn();
  var atts = elementsColumns[elementsColumns.length - 1].attributes;
  <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
     for(int j=0;j<attributes.length;++j){
   %>
       atts[atts.length] = new ElementAttribute("<%=attributes[j].key%>","<%=attributes[j].value%>");
  <%}
}
%>


function changeAttribute(combo,index){
  var txtVal = document.getElementById("conditionValue_" + index);
  if (combo.selectedIndex > 0){
    txtVal.value = elementsColumns[index].attributes[combo.selectedIndex - 1].value;
  }else {
    txtVal.value = "";
  }
}
</script>
</head>

<body style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1" height="100%">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
            	<tr height="10">
								<td>
									<jsp:include page="../../../common/pageHeader.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="headerTitle" value="XML Schema Administration" />
									</jsp:include>											
								</td>
							</tr>
              <tr height="10">
                <td style="padding-top:10;padding-left:10" valign="top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
               		<tr height="18">
               			<td>
               				<table border="0" cellpadding="0" cellspacing="0">
               					<tr>
               				       <td width="120"><span class="REGULARTEXT">Record Tag Name</span></td>
               				       <td width="11">&nbsp;</td>
							                <td width="200">
							                <input class="TEXTBOX" type="text" name="tagName" size="30" value="<%=tagName%>"></td>
							                <td width="11">&nbsp;</td>
							                <td width="100"><a href="javascript:reanalyzeXMLCode(true)" class="SMALLLINK">update</a></td>
							                <td width="*">&nbsp;</td>
					              </tr>             				
               				</table>
               			</td>
               		</tr>				                  
                  <tr height="18">
                    <td width="15%" style="padding-top:10"><span class="HEADER">Text from the XML file</span></td>
                  </tr>
                  <tr height="18">
                    <td width="15%"><span class="SMALLTEXT">The first log
                      element from the XML log file you specified.</span></td>
                  </tr>
                  <tr height="18">
                    <td>
                    <textarea class="TEXTBOX" rows="10" name="logLines" id="logLines" wrap="off"  style="font-size: 8pt;width:100%"><%=recordString%>
                    </textarea></td>
                  </tr>
                  <tr height="10">
                    <td>
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="30%"></td>
                          <td width="41%"><a href="javascript:reanalyzeXMLCode(false)" class="SMALLLINK">reanalyze
                            XML code</a></td>
                          <td width="34%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">XML schema definition</span></td>
                  </tr>
                  <tr height="20">
                    <td><span class="SMALLTEXT">Here you need to specify for each field
                      type and name according to the XML code above<br>
                      If there are missing elements or attributes please add
                      them to the structure above and click on </span><a href="javascript:reanalyzeXMLCode(false)" class="SMALLLINK">reanalyze
                            XML code</a></td>
                  </tr>
                  <tr>
                    <td>
                        <table border="1" width="100%">
                          <tr>
                            <td width="10">&nbsp;</td>
                            <td width="150"><span class="REGULARTEXT">Tag Name</span></td>
                            <td width="150"><span class="REGULARTEXT">Attribute</span></td>
                            <td width="250"><span class="REGULARTEXT">Value - XpoLog
                              pattern</span></td>
                            <td width="270"><span class="REGULARTEXT">condition</span></td>
                            <td width="20"><span class="REGULARTEXT">Ignore</span></td>
                            <td width="20"><span class="REGULARTEXT">Tags Included</span></td>
                          </tr>
                          <% for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
                               XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
                          %>

                            <tr>
                            <td width="10"><span class="REGULARTEXT"><%=String.valueOf(i + 1)%>.</span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getTagName()%></span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getPropertyKey() == null ?"&nbsp;" : info.getPropertyKey()%></span></td>
                            <td width="250"><span class="REGULARTEXT"><input class="TEXTBOX"  type="text" name="elemPattern_<%=i%>" size="30" value="<%=info.getXpologPattern()%>"></span></td>
                            <td width="270" ><nobr><font size="2">
                             <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
                                if (attributes.length > 0){
                                  Properties condProp = info.getConditionParameters();
                                  %>

                                 <select size="1" name="conditionCombo<%=i%>" id="conditionCombo_<%=i%>" onChange="javascript:changeAttribute(this,<%=i%>)">
                          <%
                            String selected = "";
                            boolean hasCondition = condProp != null && condProp.size() > 0;
                            selected = !hasCondition? "selected=\"true\"" : "";
                            String value = "";
                            %>
                             <option class="TEXTBOX" value="noSelect" <%=selected%> >No Selected</option>
                            <%
                            for(int j=0;j<attributes.length;++j){
                              if(hasCondition && condProp.getProperty(attributes[j].key) != null){
                                selected = "selected=\"true\"";
                                value = attributes[j].value;
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=attributes[j].key%>" <%=selected%>><%=attributes[j].key%></option>
                          <%}%>

                             </select>
                            &nbsp;=&nbsp;<input class="TEXTBOX" type="text" name="conditionValue_<%=i%>" size="20" value="<%=value%>">
                            <% } else { %>
                                  &nbsp;
                             <% } %>
                            </nobr></td>
                            <td width="20" align="center" style="padding-left:10"><input type="checkbox" name="ignore_<%=i%>"  <%=!info.isSelected()?"checked" : ""%>></td>
                            <td width="20" align="center" style="padding-left:10">
                              <%if (info.isElementType()){%>
                              <input type="checkbox" name="includeElements_<%=i%>"  <%=info.isIncludeInnerElements()?"checked" : ""%>></td>
                              <% }%>
                          </tr>

                          <% } %>




                        </table>
                    </td>
                  </tr>
                  <tr height="10">
                    <td>
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      	<tr>
                      	<td colspan="4">
	                      	<span class="SMALLTEXT"><nobr><b>pattern examples: </b>{date,dd-MM-yyyy}, {number}, {string}, {priority,DEBUG;INFO;WARN;ERROR} <a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Pattern.htm')" title="open patterns help page" class="SMALLLINK">pattern help</a></nobr></span>
	                     	</td>
                      	</tr>
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="138"><a href="javascript:verifySchema()" class="LINK">verify
                            schema</a></td>
                          <td width="76"></td>
                          <td width="118"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">Pattern verification status</span></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">Analysis result of the log lines with the
                      data pattern</span></td>
                  </tr>
                  <tr height="18">
                    <td>

                      <span class="REGULARTEXT">Log analysis verification -</span>
                        <%if(patternOk){%>
                            <span class="OKMESSAGE">ok</span>
                        <%}else{%>
                            <span class="ERRORMESSAGE">error:
                          <%=errorPattern%></span>
                        <%}%>

                    </td>
                  </tr>
                  <tr height="18">
                    <td style="padding-top:10"><span class="HEADER">Log records analysis result</span></td>
                  </tr>
                  <tr height="10">
                    <td><span class="SMALLTEXT">Here you can see the log view after the xml log was
                      analyzed the schema</span></td>
                  </tr>
                  <tr>
                    <td>
                    	<div id="recordAnalysedId" style="width:<%=logAdminScreenWidth%>px;height:110px;overflow-y:auto;overflow-x:auto;border:1px solid #DBDFE2;" class="REGULARTEXT" >
                    	<font color="<%=htmlColor%>"><%=html%></font>	
                    	</div>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
              <tr height="100%"><td>&nbsp;</td></tr>
              <tr height="10">
								<td style="padding-top:10">
								
								<%
								
								String actionNames = "";
								String actions = "";
								
			             actionNames += "Previous";
								if(backwardURL == null) {
			               actions += "javascript:history.go(-1)";
			              }else {
			              	actions += backwardURL;
			              }
			
								actionNames += "#Save";
								actions += "#javascript:doNext()";
			
								actionNames += "#Cancel";
								actions += "#" + "common/actions/cancelAction.jsp";
								
								%>
									<jsp:include page="../../../common/buttonsFooter.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />				
										<jsp:param name="actionNames" value="<%=actionNames%>"/> 
										<jsp:param name="align" value="right"/> 
									    <jsp:param name="actions" value="<%=actions%>"/> 
									</jsp:include>											
								</td>
							</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>