<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="java.util.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";


  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
    XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
    String pat = request.getParameter("elemPattern_" + i);
    String cond = request.getParameter("conditionCombo" + i);
    String condVal = request.getParameter("conditionValue_" + i);
    String ignore = request.getParameter("ignore_" + i);
    String includeElements = request.getParameter("includeElements_" + i);
    info.setIncludeInnerElements(includeElements != null && includeElements.equals("on"));
    info.setSelected(ignore == null || !ignore.equals("on"));
    if (pat != null && pat.trim().length() > 0){
       info.setXpologPattern(pat);
    }

    if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
       info.setConditionProperty(cond,condVal);
    }
  }

  if(builder.getSelectedPatternElementInfoCount() == 0){
    errmodel.addError("No elements pattern were supplied.");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && builder.getVirtualColumnsBuilder() == null && builder.isEqualsSelectedPatterns(XMLLogAdminHelper.getElementPatternsParser(lbm,false))){
     builder.setVirtualColumnsBuilder(XMLLogAdminHelper.getVirtualColumnsBuilder(lbm));
  }

  Boolean isNew = (Boolean)request.getSession().getAttribute("IS_NEW");
  if(isNew != null && isNew.booleanValue()) {
  	builder.setUseIndexing(true);
  }
  
  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  String BASE_DIRECTORY = "../../../";
  AdminUIController controller = builder.getUiController();
  String forwardPage = "xmlLogFieldAdmin.jsp";
  if (controller != null){    
    if (controller.getForwardPage() != null){
      forwardPage = BASE_DIRECTORY + controller.getForwardPage();
    }
  }
  
  //parent handling
  String modid =  (String)request.getSession().getAttribute(MODULE_ID);
   if(modid == null || modid.trim().equals("")){
    modid = "rootModule";
  }
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  
  //audit
  lbm = builder.getLogBrowserManager();
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
  
  LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
	reindexQuery.setLbm(lbm);
	reindexQuery.setHandleRecordMask(true);
	reindexQuery.setHandleSortByLastUpdate(true);
	boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
  
  boolean saved = builder.saveLogBrowser(lbm,parentmod);
	if(saved) {
		if(isNew != null && isNew.booleanValue()) {
			String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, userContext);
		}
	}
  request.getSession().removeAttribute("logid");
  request.getSession().removeAttribute("callsPage");
  request.getSession().removeAttribute("lastModel");
  request.getSession().removeAttribute(BUILDER);
  request.getSession().removeAttribute("IS_NEW");
  
  if(shouldReindex) {
  	LogAdminHelper.reindexLog(userContext, lbm.getId());
  }
  
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,("loggers/admin/xml/xmlLogAddOpOk.jsp?removeLog=" + !builder.isLogCanBeUsed()));
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  //response.sendRedirect(forwardPage);

%>


