<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.OnlineDBSimpleLogBuilder"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.merge.MultiLogBrowsingDataSource"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION,true)){
		return;
	}	

	//constants
	String LOG_ID = "LOG_ID";
	String CURRENT_LOG = "CURRENT_LOG";
	String ERROR_OBJ = "ERROR_OBJ";
	
	//page data
	LogBrowsingManager lbm = null;
	boolean toCheckUseIndexing = false;
  
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();

	String id = request.getParameter(LOG_ID);
	if((id != null) && !(id.trim().equals(""))){
		try{
			lbm = mgmt.getLogBrowserManager(id);
		}catch(Exception e){}
	}else{
		lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	}
   
	CustomizationManager cuman = null;
	RecordMask mask = null;
	String logName = lbm != null ? lbm.getName() : "";

	if(lbm != null && lbm.getId() != null){
		cuman = lbm.getCustomizationManager();
		mask = lbm.getRecordMask();
		request.getSession().setAttribute(CURRENT_LOG,lbm);
	}else{
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
    
    boolean isMergeDs = false;
	//lines number and indexing issue
	LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();    
	if(linearDS instanceof MultiFilesDataSource) {
		toCheckUseIndexing = true;
	}else if(linearDS instanceof XMLElementDataSource) {
		toCheckUseIndexing = true;
	}else if(linearDS instanceof WinEventDataSource) {     
		toCheckUseIndexing = true;
	}else if (lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)){
		toCheckUseIndexing = true;
	}else if (linearDS instanceof MultiLogBrowsingDataSource){
		toCheckUseIndexing = true;
		isMergeDs = true;
	}

	//search and filter issue
	String searchAndFilterDef = lbm.getSearchAndFilterDef();
	if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
		searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
	}

	String startOperation = cuman.getStartOperation();
	if (startOperation == null || startOperation.length() == 0){
		startOperation = "CURRENT";
	}
	boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && toCheckUseIndexing;
	showIndexing = lbm.isTemporary() && !isMergeDs ? false : showIndexing;

	boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
	boolean showStatistics = isDashboardValid && (lbm.isTemporary() ? false : true);
	
	//virtual columns
  int number = mask.getCulomnsNumber();
	
	String headerTitle = "Customize Log " + lbm.getName(); 
	String searchAndIndexTitle = isMergeDs ? "Search" : "Search and Index";
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script language="javascript">

	function init(){
		initTabs();
		//initTables();
	}

	function saveCustomization(){
		for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
			document.access.CustomizedColSelect.options[i].selected = true;
		}
		document.access.submit();
	}
	
	function checkHeaderDate(){
		var r = document.access.eventDate;
		for(var i = 0; i < r.length; i++) {
			r[i].checked = false;
			if(r[i].value == "headerDate") {
				r[i].checked = true;
			}
		}
	}
  
	function addToCust(){
		if(document.access.RealColSelect.selectedIndex == -1){
			return;
		}
		for(var j=0;j<document.access.RealColSelect.options.length;j++){
			if (document.access.RealColSelect.options[j].selected){
				var name = document.access.RealColSelect.options[j].text;
				var value = document.access.RealColSelect.options[j].value;
				var found = false;
				for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
					if(document.access.CustomizedColSelect.options[i].value == value){
						alert("One or more of the selected columns is already presented. Please modify the selection!");
						return;
					}
				}
				var option0 = new Option(name,value);
				document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
			}
		}
	}

	function removeFromCust(){
		if(document.access.CustomizedColSelect.selectedIndex == -1){
			return;
		}
	
		for(var i= document.access.CustomizedColSelect.options.length ; --i >= 0;){
			if(document.access.CustomizedColSelect.options[i].selected){
				document.access.CustomizedColSelect.options[i] = null;
			}
		}
	}
  
	function moveUpinCust(){
		if(document.access.CustomizedColSelect.selectedIndex == -1){
			return;
		}
		index = document.access.CustomizedColSelect.selectedIndex;
		if(index == 0){
			return;
		}
		document.access.CustomizedColSelect.selectedIndex = index - 1;
		moveDowninCust();
		document.access.CustomizedColSelect.selectedIndex = index;
	}

	function moveDowninCust(){
		if(document.access.CustomizedColSelect.selectedIndex == -1){
			return;
		}
		index = document.access.CustomizedColSelect.selectedIndex;
		if(index == (document.access.CustomizedColSelect.options.length-1) || document.access.CustomizedColSelect.options.length == 1){
			return;
		}
		var options = new Array();
		for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
			if(i == index){
				var option0 = new Option(document.access.CustomizedColSelect.options[i+1].text,document.access.CustomizedColSelect.options[i+1].value);
				options[i] = option0;
				option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
				options[i+1] = option0;
				i = i+1;
			}else{
				var option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
				options[i] = option0;
			}
		}
		for(var i=0;i<options.length;i++){
			document.access.CustomizedColSelect.options[i] = null;
		}
		for(var i=0;i<options.length;i++){
			document.access.CustomizedColSelect.options[i] = options[i];
		}
		document.access.CustomizedColSelect.selectedIndex = index + 1;
	}


	function openColorSelector(name){
		window.open('<%=BASE_DIRECTORY%>colorchooser/ColorChooser.jsp?TEXT_NAME=' + name,'color','width=300,height=300,status=no,resizable=no,top=200,left=400,dependent=yes,alwaysRaised=yes');
	}
  

	var contextreq;
	function addMenu(op,id){
		if (typeof XMLHttpRequest != "undefined") {
			contextreq = new XMLHttpRequest();
		} else if (window.ActiveXObject) {
			contextreq = new ActiveXObject("Microsoft.XMLHTTP");
		}
		var url = "logCustomizationMenues.jsp?op=" + op + "&id=" + id;
		var contextSearchCol = eval("document.access.contextSearchCol0");
		for (var i = 0; contextSearchCol;){
			url = url + "&contextSearchCol" + i + "=" + contextSearchCol[contextSearchCol.selectedIndex].value;
			url = url + "&contextSearchName" + i + "=" + escape(eval("document.access.contextSearchName" + i).value);
			url = url + "&contextSearchPath" + i + "=" + escape(eval("document.access.contextSearchPath" + i).value);
			i++;
			contextSearchCol = eval("document.access.contextSearchCol" + i);   
		}
		contextreq.open("POST",url, true);
		contextreq.onreadystatechange = addMenucallback;
		contextreq.send(null);
	}

	function addMenucallback() {
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var val = contextreq.responseText;
				if (!val){
					val = "";
				}     
				var td = document.getElementById("searchMenuesTD");
				if(td){
					td.innerHTML = val;
				}
				return;
			}
		}
	}
	
	function showAddVirtualCol(){
		comp = document.getElementById("addVirtualColTD");
		y = findPosY(comp) - 150;
		showHideLayerInMiddle2("addVirtualColDiv",200,y);
	}

	function addVirtualCol(){
		var cmbo = document.getElementById("virtualColSelected");
		var count = 0;
		if (cmbo){
			for (var i = 0; i < cmbo.options.length; i++){
				if (cmbo.options[i].selected){
					count++;
				}
			}
		}
		if (count == 0){
			alert("Please select one of the columns");
			return;
		}
		update("OP=ADD_VIRTUAL_COL");
	}

	function removeVirtualCol(virCol){
		update("OP=REMOVE_VIRTUAL_COL&&virtualColIndex=" + virCol);
	}
	
	//indexing start
	function updateUseIndex(){
		var isChecked = document.getElementById("useIndexingStr").checked;
		var div = document.getElementById("columnsIndexingDiv");
		if(div){
			if (isChecked){
				div.style.display = "";
			}else {
				div.style.display= "none";
			} 
		}
		var dateIndexSearchDiv = document.getElementById("dateIndexSearchDiv");
		if(dateIndexSearchDiv){
			if (isChecked){
				dateIndexSearchDiv.style.display = "";
			}else {
				dateIndexSearchDiv.style.display = "none";
			} 
		}
	}
	
	function setAllIndex(){
		var allChecked = document.getElementById("indexAll").checked;
		for (var i=0; i<<%=number%>; i++){
			var cb = document.getElementById("useColIndex" + i);
			cb.checked = allChecked;
		}
	}
	
	function updateAllIndex(){
		for (var i=0; i<<%=number%>; i++){
			var cb = document.getElementById("useColIndex" + i);
			if (!cb.checked){
				document.getElementById("indexAll").checked = false;
				return;
			}
		}
		document.getElementById("indexAll").checked = true;
	}
	//indexing end
	
	//statistics start
	function updateUseInDashboard(){
		/*var isChecked = document.getElementById("useInDashboardStr").checked;
		var div = document.getElementById("ComputeStatisticsDiv");
		if(div){
			if (isChecked){
				div.style.display = "";
			}else {
				div.style.display= "none";
			} 
		}*/
	}
	
	function updateComputeStatistics(){
		var isChecked = document.getElementById("computeStatisticsStr").checked;
		var div = document.getElementById("columnsStatisticsDiv");
		if(div){
			if (isChecked){
				div.style.display = "";
			}else {
				div.style.display= "none";
			} 
		}
	}

	//statistics end
	
</script>

<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>


<title></title>
</head>

<body onLoad="init()" style="margin:0;padding:0;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="logCustomizationAction.jsp" style="margin:0;padding:0;" method="POST">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr height="1">
		<td>
			<jsp:include page="../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0;">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding:5;padding-left:20">
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td>
											<span class="REGULARTEXT">Log Name: <b><%=logName%></b></span>
										</td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
						
					<tr style="background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;"></div>
							<div id="generalDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="logCustomizationGeneral.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="layoutDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="logCustomizationLayout.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%if (showIndexing){ %>
							<div id="searchAndIndexDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="logCustomizationSearchAndIndex.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<%} %>
							<div id="statisticsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="logCustomizationStatistics.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>							
							<div id="addVirtualColDiv" style="position:absolute;display:none;height:80">
								<table border="0" width="200" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
									<tr height="10">
										<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
											<span class="PROGRESSTEXT" >Add Virtual Column</span>
										</td>
									</tr>
									<tr>
										<td>
										<table border="0"  cellspacing="1" cellpadding="0">
											<tr>
												<td width="70" nowrap style="padding-left:10;padding-top:10"><span class="PROGSMALLTEXT">Operation</span></td>
												<td width="200" style="padding-left:10;padding-top:10;padding-right:10">
													<select size="1" class="PROGSMALLTEXT" name="virtualColOp" id="virtualColOp">
														<option class="PROGSMALLTEXT" value="append">Merge</option>      
													</select>
												</td>
												<td width="*">&nbsp;</td>
											</tr>                  
											<tr>
												<td width="70" nowrap style="padding-left:10;padding-top:10"><span class="PROGSMALLTEXT">Columns</span></td>
												<td width="200" style="padding-left:10;padding-top:10;padding-right:10">
													<select size="5" multiple class="PROGSMALLTEXT" name="virtualColSelected" id="virtualColSelected">      				          
													<%
													for(int i=0;i<number;++i){
													String name = mask.getMaskColumn(i).getName();				  
													%>
														<option class="PROGSMALLTEXT" value="<%=String.valueOf(i)%>"><%=name%></option>          
													<%}%>
													</select>
												</td>
												<td width="*"></td>
											</tr>            
										</table>
										</td>
									</tr>
									<tr height="20">
										<td align="center" style="padding:5">
											<a class="LINK" href="javascript:hideLayer('addVirtualColDiv');">cancel</a>&nbsp;
											<a class="LINK" href="javascript:addVirtualCol();">add</a>&nbsp;		  	
										</td>
									</tr>
								</table>
							</div>
							<%
							if (showIndexing && showStatistics){ %>
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="layoutDiv" />
								<jsp:param name="name.2" value="Layout" />
								<jsp:param name="id.3" value="searchAndIndexDiv" />
								<jsp:param name="name.3" value="<%=searchAndIndexTitle%>" />
								<jsp:param name="id.4" value="statisticsDiv" />
								<jsp:param name="name.4" value="<%=analyticsH %>" />
							</jsp:include>											
							<%}else if (showIndexing){ %>
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="layoutDiv" />
								<jsp:param name="name.2" value="Layout" />
								<jsp:param name="id.3" value="searchAndIndexDiv" />
								<jsp:param name="name.3" value="<%=searchAndIndexTitle%>" />
							</jsp:include>	
							<%}else if (showStatistics){ %>
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="layoutDiv" />
								<jsp:param name="name.2" value="Layout" />
								<jsp:param name="id.3" value="statisticsDiv" />
								<jsp:param name="name.3" value="<%=analyticsH %>" />
							</jsp:include>			
							<%}else if (!showIndexing && !showStatistics){ %>
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="layoutDiv" />
								<jsp:param name="name.2" value="Layout" />
							</jsp:include>											
							<%}%>								
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Cancel" />
				<jsp:param name="actions" value="javascript:saveCustomization()#loggers/logview.jsp?refreshMenu=false" />
			</jsp:include>											
		</td>
	</tr>
</table>

<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr height="20">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" id="messageTitle"></span>
		</td>
	</tr>
	<tr height="*" style="padding:5">
		<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
		</td>
	</tr>											
	<tr height="10">
		<td align="center" style="padding:5"><nobr>
			<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
			</nobr>		  							
		</td>
	</tr>
</table>
</div>
</form>
</body>
</html>