<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.admin.helpers.XMLLogAdminHelper"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION,true)){
		return;
	}
	
	//constants
	String LOG_ID = "LOG_ID";
	String CURRENT_LOG = "CURRENT_LOG";
	String LOG_NAME = "LOG_NAME";
	String LOG_DESCRIPTION = "LOG_DESCRIPTION";
	String MODULE_ID = "MODULE_ID";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
	String COLOR_PARAM = "COLOR_PARAM_";
	
	//page data
	LogBrowsingManager lbm = null;
	String logname    = "";
	boolean updateLinesNumber = false;
	boolean toCheckLineNumbers = false;
	boolean ignoreUnparsedRecords = false;
  
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();

	String id = request.getParameter(LOG_ID);
	if((id != null) && !(id.trim().equals(""))){
		try{
			lbm = mgmt.getLogBrowserManager(id);
		}catch(Exception e){}
	}else{
		lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	}
   
	CustomizationManager cuman = null;
	RecordMask mask = null;

	if(lbm != null && lbm.getId() != null){
		logname = lbm.getName();
		cuman = lbm.getCustomizationManager();
		mask = lbm.getRecordMask();
		request.getSession().setAttribute(CURRENT_LOG,lbm);
		ignoreUnparsedRecords = LogAdminHelper.isIgnoreUnparsedRecords(lbm);
	}else{
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}
    
	//lines number and indexing issue
	LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();    
	MultiFilesDataSource ds = null;
	if(linearDS instanceof MultiFilesDataSource) {
		ds = (MultiFilesDataSource)linearDS;       
	}else if(linearDS instanceof XMLElementDataSource) {
		ds = ((XMLElementDataSource)linearDS).getDataSource();       
	}
	if (ds != null){
		updateLinesNumber = ds.isUpdateLines();
		if(!(ds instanceof SshMediaMultiFilesDataSource)) {
			toCheckLineNumbers = true;
		}
	}
    
	//search and filter issue
	String searchAndFilterDef = lbm.getSearchAndFilterDef();
	if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
		searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
	}

	String startOperation = cuman.getStartOperation();
	if (startOperation == null || startOperation.length() == 0){
		startOperation = Configuration.getInstance().getPropertiesManager().getProperty("logview.startOperation", "LAST");
	}
	  
	String globalCustomName = "";
	if(cuman != null && cuman.isUseGlobal()){
		String name = cuman.getGlobalCustomName();
		if(name != null && name.length() > 0) {
			globalCustomName = "Currenlty using global customization: " + cuman.getGlobalCustomName()+"<br>&nbsp;";
		}else {
			globalCustomName = "<br>&nbsp;";
		}
	}
	
	//header settings
	FileDSHeaderBuilder dsHeaderBuilder = null;
	if (linearDS instanceof MultiFilesDataSource){
		dsHeaderBuilder = LogAdminHelper.getHeaderBuilder(lbm); 
	}else if (linearDS instanceof XMLElementDataSource){
		dsHeaderBuilder = XMLLogAdminHelper.getHeaderBuilder(lbm);
	}
	
	String headerPattern = null;
	boolean useFileDate = false;
	int headerCheckNumOfRecords = 1000;
	if (dsHeaderBuilder != null){
		if (!dsHeaderBuilder.isUseFileTime()){
			if(dsHeaderBuilder.getBuilder() != null) {
				headerPattern = LogAdminHelper.getLogRecordBuilderPattern(dsHeaderBuilder.getBuilder());
				headerCheckNumOfRecords = dsHeaderBuilder.getNumberOfRecordsToCheck();
			}
		}else{
			useFileDate = true;
		}
	}
	
	
%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td>
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td style="padding-top:10px"><span class="HEADER">Log Viewer Settings</span></td>
			</tr>  
			<tr>
				<td><input id="ignoreUnparsedRecords" name="ignoreUnparsedRecords" type="checkbox"  <%=ignoreUnparsedRecords ?"checked" : ""%>><span class="REGULARTEXT">Ignore unparsed records - check this option to display only records that are successfully parsed</span></td>
			</tr>   
			<%if(toCheckLineNumbers){%>                
			<tr>
				<td><input id="updateLinesNumberStr" name="updateLinesNumberStr" type="checkbox"  <%=updateLinesNumber?"checked" : ""%>><span class="REGULARTEXT">Show lines number - when this option is checked you will be able to see the lines number <br>&nbsp;&nbsp;&nbsp;(Note: unchecking this option will improve performance on browsing to the end of the log) </span></td>
			</tr>   
			<%}%>              
			<tr>
				<td><input id="consolidationStr" name="consolidationStr" type="checkbox"  <%=lbm != null && lbm.isConsolidation() ?"checked" : ""%>><span class="REGULARTEXT">Consolidation - merge similar records. </span></td>
			</tr>   
			<%
			if (cuman instanceof MergeCustomizationManager){
				MergeCustomizationManager mergeCuman = (MergeCustomizationManager)cuman;
				boolean singleZoomIn = mergeCuman.isZoomInToSingleLog();
			%>
			<tr>
				<td><input id="singleZoomInStr" name="singleZoomInStr" type="checkbox"  <%=singleZoomIn ? "checked" : ""%>><span class="REGULARTEXT">Single zoom in - zoom in to single log from merge filter view. </span></td>
			</tr>   
			<%}%>
			<tr>
				<td><b>&nbsp;</b></td>
			</tr>
			<tr>
				<td><span class="HEADER">Log Viewer Entry Point</span></td>
			</tr>
			<tr>
				<td><span class="REGULARTEXT">When viewing a log that comprises of several files, view the log:</span></td>
			</tr>
			<tr>
				<td><span style="font-size:3">&nbsp;</span></td>
			</tr>
			<tr>
				<td>
					<input type="radio" value="CURRENT" name="startOperation" <%=startOperation.equals("CURRENT")? "checked" : ""%>><span class="REGULARTEXT">from the beginning of the most updated file</span><br>
					<input class="REGULARTEXT" type="radio" value="START" name="startOperation" <%=startOperation.equals("START")? "checked" : ""%>><span class="REGULARTEXT">from the beginning of the oldest file</span><br>
					<input class="REGULARTEXT" type="radio" value="LAST" name="startOperation" <%=startOperation.equals("LAST")? "checked" : ""%>><span class="REGULARTEXT">from the end of the most updated file</span><br>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>

			<%if(ds instanceof MultiFilesDataSource) {%>
			<tr>
				<td><span class="HEADER">Event Date and Time Settings</span></td>
			</tr>
			<tr>
				<td>
				<table border="0" width="100%" cellspacing="0" cellpadding="0">                    			
					<tr>
						<td>
							<input type="radio" name="eventDate" value="recordDate" <%=!useFileDate && headerPattern == null  ? "checked" : ""%>>
							<span class="REGULARTEXT">Use event's date and time</span>
						</td>
					</tr>
					<tr>
						<td>
							<input type="radio" name="eventDate" value="fileDate" <%=useFileDate ? "checked" : ""%>>
							<span class="REGULARTEXT">Use file's date in combination with event's time</span>
						</td>
					</tr>
					<tr>
						<td>
							<input type="radio" name="eventDate" value="headerDate" <%=headerPattern != null && !headerPattern.equalsIgnoreCase(SimpleLogBrowserBuilder.FILE_TIME_HEADER) ? "checked" : ""%>>
							<span class="REGULARTEXT">Use date from file's header in combination with event's time</span>
						</td>
					</tr>
					<tr>
						<td>
							<span class="REGULARTEXT" style="padding-left:25">Extract the date from the file header using the following pattern:</span>
						</td>
					</tr>
					<tr>
						<td>
							<span  style="padding-left:25">
								<textarea class="TEXTBOX" rows="3" id="logHeaderPattern" name="logHeaderPattern" cols="100" style="font-size: 8pt" onClick="javascript:checkHeaderDate()"><%=headerPattern == null || headerPattern.equalsIgnoreCase(SimpleLogBrowserBuilder.FILE_TIME_HEADER)? "" : headerPattern%></textarea>
							</span>
						</td>
					</tr>
					<tr>
						<td>
							<span class="REGULARTEXT" style="padding-left:25">Search for above defined pattern in the first <input type="text" class="TEXTBOX" name="headerNumOfRecords" id="headerNumOfRecords" size="10" value="<%=headerCheckNumOfRecords < 0?"" : String.valueOf(headerCheckNumOfRecords)%>"> lines of the file</span>
							<a style="padding-left:10" href=javascript:openHelp('<%=BASE_DIRECTORY%>',"HeaderPattern.htm") title="open header settings help page" class="SMALLLINK">header settings help</a>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td><b>&nbsp;</b></td>
			</tr>
			<%}%>

			<tr>
				<td><span class="HEADER">Log Filter Settings</span></td>
			</tr>  
			<tr>
				<td>
					<input id="searchAndFilterDefStr" name="searchAndFilterDefStr" type="checkbox"  <%=searchAndFilterDef.equals("START")?"checked" : ""%>>
					<span class="REGULARTEXT">Perform searches and filtering from the beginning of the log</span><br>
					<span class="SMALLTEXT">leave this option unchecked to search and filter on the current view</span>
				</td>
			</tr>                 
			<tr>
				<td>&nbsp;</td>
			</tr>

		</table>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
