<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.util.ModuleMembersUtil"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION,true)){
		return;
	}
	
	//constants
	String LOG_ID = "LOG_ID";
	String CURRENT_LOG = "CURRENT_LOG";
	String LOG_NAME = "LOG_NAME";
	String LOG_DESCRIPTION = "LOG_DESCRIPTION";
	String MODULE_ID = "MODULE_ID";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
	String COLOR_LOG_NAME = "COLOR_LOG_NAME_";
	String VIRTUAL_LOG_NAME = "VIRTUAL_LOG_NAME_";
	String COLOR_PARAM = "COLOR_PARAM_";
	
	//page data
	LogBrowsingManager lbm = null;
	String logname    = "";
	
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();

	String id = request.getParameter(LOG_ID);
	if((id != null) && !(id.trim().equals(""))){
		try{
			lbm = mgmt.getLogBrowserManager(id);
		}catch(Exception e){}
	}else{
		lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	}
   
	CustomizationManager cuman = null;
	RecordMask mask = null;

	if(lbm != null && lbm.getId() != null){
		logname = lbm.getName();
		cuman = lbm.getCustomizationManager();
		mask = lbm.getRecordMask();
		request.getSession().setAttribute(CURRENT_LOG,lbm);
	}else{
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	String[] priorities = null;
	int cnum = mask.getCulomnsNumber();
	for(int i=0;i<cnum;++i){
		if((mask.getMaskColumn(i) instanceof PriorityMask)){
			priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
		}
	}
	HashMap p2c = cuman.getPriorityColorMap();

	String startOperation = cuman.getStartOperation();
	if (startOperation == null || startOperation.length() == 0){
		startOperation = "CURRENT";
	}
	  
	String globalCustomName = "";
	if(cuman != null && cuman.isUseGlobal()){
		String name = cuman.getGlobalCustomName();
		if(name != null && name.length() > 0) {
			globalCustomName = "Currenlty using global customization: " + cuman.getGlobalCustomName()+"<br>&nbsp;";
		}else {
			globalCustomName = "<br>&nbsp;";
		}
	}
	
	//SimpleLogBrowserBuilder builder = new SimpleLogBrowserBuilder();
	//builder.setLogBrowserManager(lbm);
	//builder.updateFromLogBrowserManager();
	//builder.updateBuilder();
	VirtualColumnsBuilder virtualColumnBuilder = null;//builder.getVirtualColumnsBuilder();
  VirtualColumn [] virtualColumns = virtualColumnBuilder == null ? new VirtualColumn[0] : virtualColumnBuilder.getVertualColumns();
	
%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:10px"><span class="HEADER">Column Selection and Ordering</span></td>
	</tr>
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			<tr>
				<td width="17%">
					<select size="7" name="RealColSelect" id="RealColSelect" style="width: 250; height: 156" multiple>
					<%
					String name = null;
					String value = null;
					for(int i=0;i<mask.getCulomnsNumber();++i){
						name = mask.getMaskColumn(i).getName();
						value = String.valueOf(i);
					%>
					<option class="TEXTBOX" value="<%=value%>" title="<%=name%>"><%=name%></option>
					<%}%>
					</select>
				</td>
				<td width="10%" style="padding-left:5;padding-right:5">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="77%" id="AutoNumber20">
					<tr>
						<td width="100%" align="center">
							<a href="javascript:addToCust()" class="SMALLLINK">add</a>
						</td>
					</tr>
					<tr>
						<td width="100%" align="center">
							<a href="javascript:removeFromCust()" class="SMALLLINK">remove</a>
						</td>
					</tr>
				</table>
				</td>
				<td width="14%">
					<select size="7" name="CustomizedColSelect" id="CustomizedColSelect" style="width: 250; height: 156" multiple>
					<%
					name = null;
					value = null;
					int ci = -1;
					for(int i=0;i<mask.getCulomnsNumber();++i){
						ci = cuman.getIndexFromCustomizedCol(i);
						if(ci == -1){
							continue;
						}
						name = mask.getMaskColumn(ci).getName();
						value = String.valueOf(ci);
					%>
						<option  class="TEXTBOX" value="<%=value%>" title="<%=name%>"><%=name%></option>
					<%}%>
					</select>
				</td>
				<td width="14%" style="padding-left:5;padding-right:5">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber21">
					<tr>
						<td width="100%" align="center">
							<a href="javascript:moveUpinCust()" class="SMALLLINK"><nobr>Move up</nobr></a>
						</td>
					</tr>
					<tr>
						<td width="100%" align="center">
							<a href="javascript:moveDowninCust()" class="SMALLLINK"><nobr>Move down</nobr></a>
						</td>
					</tr>
				</table>
				</td>
			<td width="20%">&nbsp;</td>
			</tr>
		</table>
		</td>
	</tr>

<!-- priorities -->
	<%
	if(priorities != null){
		boolean usePriorityColors = cuman.isUsePriorityBgColor();
		String priorName = "";
	%>
	<tr>
		<td><b>&nbsp;</b></td>
	</tr>
	<tr>
		<td>
			<span class="HEADER">Priority Coloring</span><br>
			<span class="REGULARTEXT">Set records colors according to the following settings:</span>
		</td>
	</tr>
	<tr>
		<td><input id="usePriorityColors" name="usePriorityColors" type="checkbox" <%=usePriorityColors?"checked" : ""%> value="true"><span class="REGULARTEXT">Use priority coloring</span></td>
	</tr>                 
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber18">
			<%
			String val = "";
			String[] defcol = null;
			if(p2c.size() == 0){
				DefaultColorConfig colm = Configuration.getInstance().getDefColorMgr();
				defcol = colm.getPriorColorsForNumber(priorities.length);
			}
			for (int i=0;i<priorities.length;++i){
				priorName = priorities[i];
				val = (String)p2c.get(priorities[i]);
				if(val == null){
					if(defcol != null){
						val = defcol[i];
					}else{
						val = "";
					}
				}
				%>
			<tr>
				<td width="20%"><span class="REGULARTEXT">&nbsp;<%=priorName%> &nbsp;paint in </span></td>
				<td width="80%">
					<input type="text" class="TEXTBOX" name="<%=COLOR_PRIOR_NAME + String.valueOf(i)%>" value="<%=val%>">
					<a href="javascript:openColorSelector('<%=COLOR_PRIOR_NAME + String.valueOf(i)%>')" class="SMALLLINK">pick color</a>
				</td>
			</tr>
		<%}%>
		</table>
		</td>
	</tr>
	<%}%>


<!-- Merge Logs Names -->
	<%
	if(lbm != null && lbm instanceof MergedLogBrowserManager) {
			if(cuman != null && cuman instanceof MergeCustomizationManager){
		MergeCustomizationManager mcuman = (MergeCustomizationManager)cuman;
	%>
		<tr>
			<td><b>&nbsp;</b></td>
		</tr>
		<tr>
			<td>
				<span class="HEADER">Source Logs Name Customization</span><br>
				<span class="REGULARTEXT">Customize the log's source name that will be presented in the merge</span>
			</td>
		</tr>
		
		<tr>
			<td colspan="2">
					<table border="0" cellpadding="0" cellspacing="0" width="100%">
						<tr class="TABLES_HEADERS">
						<td width="20%" style="padding-left:11px"><nobr><span class="REGULARTEXT">Original Log Name</span></nobr></td>
						<td width="25%" style="padding-left:11px"><nobr>
							<span class="REGULARTEXT">Customized Log Name</span></nobr>
						</td>
						<td width="*" style="padding-left:11px"><nobr>
							<span class="REGULARTEXT">Parent Folder</span></nobr>
						</td>
					</tr>
					<tr>
						<td colspan="3" style="font-size: 3px">&nbsp;</td>
					</tr>
				
					<%
					LogBrowsingManager logb = null;
				  String logName = "";
				  String logid = "";
					String virtualNameVal = "";
					String logPath = "";		
					MergedLogBrowserManager mlbm = (MergedLogBrowserManager)lbm;
				  LogBrowsingManager[] logs = mlbm.getLogBrowsers();
				  String[] logIds = mlbm.getLogBrowsersIds();
				  HashMap logsIdToVirtualNames = mcuman.getLogsIdToVirtualNames();
				  for(int i=0;i<logs.length;++i){
				    logb =  logs[i];
				    logName = logb.getName();
				    logid = logb.getId();
				    virtualNameVal = logsIdToVirtualNames != null && logsIdToVirtualNames.containsKey(logid) ? (String)logsIdToVirtualNames.get(logid) : "";
				    logPath = ModuleMembersUtil.getPathToRoot(logid);
					%>
					<tr>
						<td width="25%" style="padding-left:11px"><span class="REGULARTEXT"><%=logName%></span></td>
						<td width="25%" style="padding-left:11px"><input type="text" size="30px" class="TEXTBOX" name="<%=VIRTUAL_LOG_NAME + String.valueOf(i)%>" value="<%=virtualNameVal%>"></td>
						<td width="*" style="padding-left:11px"><span class="REGULARTEXT"><nobr><%=logPath%></nobr></span></td>
					</tr>
					<%
						}//for
					%>
		
					</table>
			</td>
		</tr>
	
	
	<%
			}
	%>
		<tr>
			<td><b>&nbsp;</b></td>
		</tr>
		<tr>
			<td>
				<span class="HEADER">Columns Name Customization</span><br>
				<span class="REGULARTEXT">Customize the column names that will be presented in the merge</span>
			</td>
		</tr>
		
		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr class="TABLES_HEADERS">
						<td width="25%" style="padding-left:11px"><nobr><span class="REGULARTEXT">Original Column Name</span></nobr></td>
						<td width="25%" style="padding-left:11px"><nobr><span class="REGULARTEXT">Column Name</span></nobr></td>
						<td width="20%" style="padding-left:11px"><nobr><span class="REGULARTEXT">Column Type</span></nobr></td>
						<td width="*">&nbsp;</td>
					</tr>
					<tr>
						<td colspan="4" style="font-size: 3px">&nbsp;</td>
					</tr>
					<%
          name = "";
          String type = "";
          String filedentry = "FieldNumber_";
          int dateIndex = mask.getDateColumnIndex();
          int number = mask.getCulomnsNumber();
          for(int i=0;i<number;++i){
          	MaskColumn col = mask.getMaskColumn(i);
            name = mask.getMaskColumn(i).getName();
            type = mask.getMaskColumn(i).getType();
       		%>
        	<tr>
	          <td style="padding-left:11px"><span class="REGULARTEXT"><%=name%></span></td>
	          <td style="padding-left:11px">
	            <input type="text" size="30px" class="TEXTBOX" name="<%=String.valueOf(filedentry+i)%>" id="<%=String.valueOf(filedentry+i)%>" size="26" value="<%=name%>">
	          </td>
	          <td style="padding-left:11px"><span class="REGULARTEXT"><%=type%></span></td>
	          <td >&nbsp;</td>
        	</tr>
        	<%
            }
          %>
				</table>
			</td>
		</tr>
					
	<%
	}%>

	<%if (!(cuman instanceof MergeCustomizationManager)){%>
	<tr>
		<td><b>&nbsp;</b></td>
	</tr>
	<tr>
		<td><span class="HEADER">Search Context Menu</span></td>
	</tr>  
	<tr>
		<td id="searchMenuesTD">
			<jsp:include page="logCustomizationMenues.jsp" flush="true"/>
		</td>
	</tr>
	<%}%>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>

</table>
