<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page import="xpolog.eye.merge.MultiLogBrowsingDataSource"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION,true)){
		return;
	}
	
	//constants
	String LOG_ID = "LOG_ID";
	String CURRENT_LOG = "CURRENT_LOG";
	String LOG_NAME = "LOG_NAME";
	String LOG_DESCRIPTION = "LOG_DESCRIPTION";
	String MODULE_ID = "MODULE_ID";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
	String COLOR_PARAM = "COLOR_PARAM_";
	
	//page data
	LogBrowsingManager lbm = null;
	String logname    = "";
	boolean toCheckUseIndexing = false;
	boolean useIndexing = false;
	boolean useIndexingForDateSearch = false;
	boolean indexNullValues = false;
	
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();

	String id = request.getParameter(LOG_ID);
	if((id != null) && !(id.trim().equals(""))){
		try{
			lbm = mgmt.getLogBrowserManager(id);
		}catch(Exception e){}
	}else{
		lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	}
   
	CustomizationManager cuman = null;
	RecordMask mask = null;

	if(lbm != null && lbm.getId() != null){
		logname = lbm.getName();
		cuman = lbm.getCustomizationManager();
		mask = lbm.getRecordMask();
		request.getSession().setAttribute(CURRENT_LOG,lbm);
	}else{
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}
	
  int number = mask.getCulomnsNumber();
	
    
	//lines number and indexing issue
	LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();
	boolean mergeDs = false;
	boolean indexable = false;
	if(linearDS instanceof MultiFilesDataSource) {
		indexable = true;
	}else if(linearDS instanceof XMLElementDataSource) {
		indexable = true;
	}else if(linearDS instanceof WinEventDataSource) {     
		indexable = true;
	}else if (lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)){
		indexable = true;
	}else if (linearDS instanceof MultiLogBrowsingDataSource){
		mergeDs = true;
	}
	
	
	if(indexable) {
		useIndexing = lbm.isUseIndexing();
		useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
		indexNullValues = lbm.isIndexNullValues();
		toCheckUseIndexing = true;
	}
	boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && toCheckUseIndexing;
    
	boolean useQuickFilter = lbm.isUseQuickFilter();
	boolean useWholeWords = lbm.isUseWholeWords();
  
%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:10px"><span class="HEADER">Log Search Settings </span></td>
	</tr>                  
	<tr>
		<td>
			<input id="useWholeWords" name="useWholeWords" type="checkbox"  <%=useWholeWords ? "checked" : ""%>>
			<span class="REGULARTEXT">Use by default whole words in Search Engine</span><br>
			<span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;Checking this option will cause the search engine to search by default for whole words only<br>
			&nbsp;&nbsp;&nbsp;this can boost up dramatically search and filter performances</span>
		</td>
	</tr>                 
	<tr>
		<td><b>&nbsp;</b></td>
	</tr>
	<tr>
		<td>
		<div <%=mergeDs? "style=display:none" : ""%>>
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr>
					<td><span class="HEADER">Log Indexing Settings</span></td>
				</tr>
				<tr>
					<td><input id="useIndexingStr" name="useIndexingStr" type="checkbox"  <%=useIndexing?"checked" : ""%>  value="true" onClick="javascript:updateUseIndex()"><span class="REGULARTEXT">Use indexing</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;using log indexing enables rapid search and filtering; indexed logged can be used in Xpolog Search Engine </span></td>
				</tr>
				<tr style="font-size:3">
					<td>&nbsp;</td>
				</tr>
				<tr>
					<td>
						<div id="dateIndexSearchDiv" <%=useIndexing ? "" : "style=\"display:none\""%>>
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
								<tr>
									<td><input id="useIndexingForDateSearchStr" name="useIndexingForDateSearchStr" type="checkbox"  <%=useIndexingForDateSearch?"checked" : ""%> value="true"><span class="REGULARTEXT">Use indexing for date search</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to allow for quick date search using the index</span></td>
								</tr>
								<tr>
									<td><input id=indexNullValuesStr" name="indexNullValuesStr" type="checkbox"  <%=indexNullValues?"checked" : ""%> value="true"><span class="REGULARTEXT">Index NULL values</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to allow to allow search of NULL values</span></td>
								</tr>
							</table>
						</div>
					</td>
				</tr>                 
				<tr>
					<td>&nbsp;</td>
				</tr>
			
				<tr>
					<td width="15%" height="22">
					<div id="columnsIndexingDiv" <%=useIndexing ? "" : "style=\"display:none\""%>>
					<table border="0" cellpadding="0" cellspacing="0"  width="500px" style="border-collapse: collapse">
						<tr>
							<td colspan="3"><span class="HEADER">Columns Indexing Settings</span></td>
						</tr>                  
						<tr>
							<td colspan="3">
								<span class="REGULARTEXT">Select the columns to index: </span><br>
							</td>
						</tr>                  
						<tr class="TABLES_HEADERS">
							<td width="220"><nobr><span class="REGULARTEXT">Field Name</span></nobr></td>
							<td width="100"><nobr><span class="REGULARTEXT" style="padding-left:5px">Field Type</span></nobr></td>
							<%
							boolean allChecked = true;
							for(int i=0;i<number;++i){
								if (!mask.getMaskColumn(i).isUseIndex()){
									allChecked = false;
									break;
								}
							} 
							%>
							<td style="padding-left:5px"><input type="checkbox" name="indexAll" id="indexAll" onClick="setAllIndex()" <%=allChecked ? "checked" : ""%>></td>
						</tr>
						<tr>
							<td colspan="3" style="font-size:3px">&nbsp;</td>
						</tr>
						
						<%
						String name = "";
						String type = "";
						String filedentry = "FIELD_NAME_";
						for(int i=0;i<number;++i){
							name = mask.getMaskColumn(i).getName();
							type = mask.getMaskColumn(i).getType();
							boolean useInStatistics = mask.getMaskColumn(i).isUseInStatistics();
							boolean computeAvg = useInStatistics && mask.getMaskColumn(i).isComputeAvgContextStatistics();
						%>
						<tr>
							<td><span class="REGULARTEXT"><%=name%></span></td>
							<td><span class="REGULARTEXT" style="padding-left:5px"><%=type%></span></td>
							<td style="padding-left:5px">
								<input type="checkbox" name="useColIndex<%=String.valueOf(i)%>" id="useColIndex<%=String.valueOf(i)%>" value="ON" <%=(mask.getMaskColumn(i).isUseIndex() ? "checked" : "")%> onClick="updateAllIndex()">
							</td>
						</tr>
						<%
						}//for
						%>
					</table>
					</div>
					</td>
				</tr>
			</table>
		</div>
		</td>
	</tr>

	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
