<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION, true)) {
		return;
	}

	//constants
	String LOG_ID = "LOG_ID";
	String CURRENT_LOG = "CURRENT_LOG";
	String LOG_NAME = "LOG_NAME";
	String LOG_DESCRIPTION = "LOG_DESCRIPTION";
	String MODULE_ID = "MODULE_ID";
	String ERROR_OBJ = "ERROR_OBJ";

	String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
	String COLOR_PARAM = "COLOR_PARAM_";

	//page data
	LogBrowsingManager lbm = null;
	String logname = "";
	boolean useInDashboard = false;
	boolean computeStatistics = false;

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();

	String id = request.getParameter(LOG_ID);
	if ((id != null) && !(id.trim().equals(""))) {
		try {
			lbm = mgmt.getLogBrowserManager(id);
		} catch (Exception e) {
		}
	} else {
		lbm = (LogBrowsingManager) request.getSession().getAttribute(CURRENT_LOG);
	}

	CustomizationManager cuman = null;
	RecordMask mask = null;

	if (lbm != null && lbm.getId() != null) {
		logname = lbm.getName();
		cuman = lbm.getCustomizationManager();
		mask = lbm.getRecordMask();
		request.getSession().setAttribute(CURRENT_LOG, lbm);
	} else {
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ, ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	int number = mask.getCulomnsNumber();

	//lines number and indexing issue
	LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();
	useInDashboard = lbm.isUseInDashboard();
	//computeStatistics = lbm.isComputeStatistics();
	//search and filter issue
	String searchAndFilterDef = lbm.getSearchAndFilterDef();
	if (searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
		searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef", "START");
	}
	
	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-left:10">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr height="10">
					<td style="padding-top:10px"><span class="HEADER"><%=analyticsH %> Settings</span></td>
				</tr>
				<tr height="10">
					<td style="padding-top:5"><input id="useInDashboardStr" name="useInDashboardStr" type="checkbox" <%=useInDashboard?"checked" : ""%> onClick="javascript:updateUseInDashboard()">
						<span class="REGULARTEXT">Generate <%=analytics %> data</span><br>
						<span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to enable <%=analytics %> data generation on this log</span>
					</td>
				</tr>
				<tr height="10">
					<td style="padding-top:10">
					<div id="computeStatisticsDiv" style="display:none">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr height="10">
								<td><span class="HEADER">Log Statistics Settings</span></td>
							</tr>
							<tr height="10">
								<td style="padding-top:5"><input id="computeStatisticsStr" name="computeStatisticsStr" type="checkbox" <%=computeStatistics?"checked" : ""%> onClick="javascript:updateComputeStatistics()">
									<span class="REGULARTEXT">Compute statistics</span><br>
									<span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to enable statistical evaluations on this log</span>
								</td>
							</tr>
							<tr>
								<td valign="top" style="padding-top:10">
								<div id="columnsStatisticsDiv" <%=computeStatistics ? "" : "style=\"display:none\""%>>
									<table border="0" cellpadding="0" cellspacing="0" width="500px" style="border-collapse: collapse">
										<tr>
											<td colspan="3"><span class="HEADER">Columns Statistics Settings</span></td>
										</tr>
										<tr>
											<td colspan="3"><span class="REGULARTEXT">Select for each column which statistics method to use: </span></td>
										</tr>
										<tr class="TABLES_HEADERS">
											<td width="220"><nobr><span class="REGULARTEXT">Field Name</span></nobr></td>
											<td width="100" style="padding-left: 5px"><nobr>
												<span class="REGULARTEXT">Field Type</span></nobr>
											</td>
											<td width="*">&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3" style="font-size: 3px">&nbsp;</td>
										</tr>
				
									<%
										String name = "";
										String type = "";
										String filedentry = "FIELD_NAME_";
										for (int i = 0; i < number; ++i) {
											name = mask.getMaskColumn(i).getName();
											type = mask.getMaskColumn(i).getType();
											boolean useInStatistics = mask.getMaskColumn(i).isUseInStatistics();
											boolean computeAvg = useInStatistics && mask.getMaskColumn(i).isComputeAvgContextStatistics();
									%>
										<tr>
											<td><span class="REGULARTEXT"><%=type%></span></td>
											<td><span class="REGULARTEXT" style="padding-left: 5px"><nobr><%=name%></nobr></span></td>
											<td style="padding-left:5px"><nobr>
												<select name="useColStatistics<%=String.valueOf(i)%>" class="TEXT_BOX">
													<option value="no">do not compute</option>
													<option value="yes" <%=useInStatistics && !computeAvg ? "selected" : ""%>>compute unique values</option>
													<option value="useAvg" <%=computeAvg ? "selected" : "" %>>compute average</option>
												</select> </nobr>
											</td>
										</tr>
									<%
										}//for
									%>
									</table>
								</div>
								</td>
							</tr>
						</table>
					</div>
					</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>