<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.log.LogRecord"%>
<%@ page import="xpolog.eye.data.source.DataReference"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.logview.LogViewContext"%>
<%@ page import="xpolog.eye.logview.LogViewQueryInfo"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%@ page import="java.util.Date"%>

<%!static final String BASE_DIRECTORY = "../";%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LogName";
  String IS_DATE = "isDateColumn";
  String OP = "START";
  String key = "";
  
  String logname    = request.getParameter(LOG_NAME);
 	String isDateColStr = request.getParameter(IS_DATE);
 	boolean isDateCol = isDateColStr != null && isDateColStr.equals("true");
	LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	String currentLogId = "";
	if(logcontext != null && logcontext.logId != null){
		currentLogId = logcontext.logId;
	}
  LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
  int leapsize =  queryInfo == null ? 25 : queryInfo.leapsize;

  UserContext userContext = UserEnvironment.getUserContext(request);
  
  //page data
  MergedLogBrowserManager mlbm = null;
  LogBrowsingManager lbm = null;
  
	boolean isCurrentLogInList = false;
	
  String logsList = request.getParameter("logs");
  String [] LogsToMerge = null;
  if (logsList != null && logsList.length() > 0){
  	LogsToMerge = logsList.split(",");
 	}
  
  //Check if current log in list
  if(currentLogId != null && currentLogId.length() > 0 && LogsToMerge != null){
	  for(int i = 0 ;i < LogsToMerge.length ; i ++){
	  	if(currentLogId.equals(LogsToMerge[i])){
	  		isCurrentLogInList = true;
	  		break;
	  	}
	  }
  }
 
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(LogsToMerge == null) {
  	errmodel.addError("You must select at least one log.");  	
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?");
    return;
  }


  String charset = null;
  String[] logIds = null;

  MergedLogBrowserBuilder builder = new MergedLogBrowserBuilder();
	if (logname == null || logname.length() == 0){
		logname = "Filter merge log";
	}
	builder.setName(logname);
	builder.setLogDescription("Merge search log");
	builder.setTimeZoneId(DataBrowsingInfo.DEFAULT);
	
	builder.setLogsToMergeIds(LogsToMerge);
	try {
		builder.updateBuilder();
	} catch (XpologBuilderException e) {
		e.printStackTrace();
	}
	mlbm = builder.getMergeLogBrowser();
	BuildersColumnsInfo info = builder.initAutomaticMergeRecordMask();
	mlbm.setRecordMask(info.getRecordMask());
	MergeIndexing indexing = MergeAdminHelper.getMergeIndexing(mlbm);
	int size = info.getMergeIndexing().getDescriptorCount();
	MergeDescriptor[] mds = new MergeDescriptor[size];
	for (int i = 0; i < mds.length; i++) {
		mds[i] = info.getMergeIndexing().getDescriptorAt(i);
	}
	
	 indexing.setDescriptors(mds);
	//create merge customization manager
	 MergeCustomizationManager mcm = builder.initCustomizationManager(info.getRecordMask());
	 mlbm.setCustomizationManager(mcm);
	    
	 DefaultColorConfig defc = Configuration.getInstance().getDefColorMgr();
	 String[] mc = defc.getDefMergeBgColors();
	 logIds = mlbm.getLogBrowsersIds();
	 int number = mc.length <= logIds.length ? mc.length : logIds.length; 
	 for (int i = 0; i < number ; i++) {
			mcm.setLogColor(logIds[i],mc[i]);
	 }
	 mlbm.updateLegend();
	 charset = mlbm.getLogBrowsersCharset();
	 mlbm.setCharset(charset);
	 String id = "SearchId" + System.currentTimeMillis();
	 mlbm.setID(id);
	 mlbm.setTemporary(true);
	 request.getSession().setAttribute("logid",id); 
	 request.getSession().setAttribute(CURRENT_LOG,mlbm);
	
	int selectedRowIndex = -1;
	//DATE FILTERING PART
	if(isDateCol){
		LogBrowsingManager currentLbm = logcontext.lbm;	
		int dateIndex = currentLbm.getRecordMask().getDateColumnIndex();
		RecordsMaskTableModel RMModel = currentLbm.getCurrentEntries(leapsize);
		String selectedRowIndexStr = request.getParameter("selectedRowIndex");
		try{
			selectedRowIndex = Integer.parseInt(selectedRowIndexStr);
		}catch(Exception e){
			selectedRowIndex = -1;
		}
		DataReference ref = null;	
		LogRecord rec = null;
		if(RMModel != null){
			rec = (LogRecord)RMModel.getRecordAt(selectedRowIndex);			
		}
		//CURRENT LOG IS SELECTED 
		if(isCurrentLogInList && logcontext != null && logcontext.lbm != null && rec != null){
			OP = "ZOOM_IN";
			ref = rec.getDataReference();				
			if(ref != null){
				MultiLogBrowingDataReference mRef = new MultiLogBrowingDataReference();
				String []ids = mlbm.getLogBrowsersIds();
				for(int i = 0 ; i < ids.length ; i++){	
					mRef.addDataReference(ids[i].equals(currentLogId) ? ref : null);
					mRef.addID(ids[i]);
				}
				key = mRef.getKey();
				mlbm.clearLastFilterView();
			}
		}else{	
			//FILTER DATE WITHOUT USING CURRENT LOG			
			// Create date filter
			Date date = null;
			if(RMModel != null){
				if(rec != null){
					Object obj = rec.getFieldAt(dateIndex);
					if (obj instanceof Date){
						date = (Date)obj;
					}
				}
			}
			DateFilter dateFilter = new DateFilter();
			dateFilter.setMinDate(date);
			FilterCollection fc = new FilterCollection();
			fc.setId("TempFilterInDate");
			dateFilter.setColIndex(mlbm.getRecordMask().getDateColumnIndex());
			dateFilter.setIndexing(mlbm.getRecordMask());
			fc.addFilter(dateFilter);							
			mlbm.getFilterManager().addFilterCollection(fc);
	  	//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fc.getSummary());	 	 	
			RMModel = mlbm.getFirstEntries(1);		
			if(RMModel != null && RMModel.getRecords() != null && RMModel.getRecords().size() > 0){
				rec = (LogRecord)RMModel.getRecordAt(0);			
				if(rec != null){
					OP = "ZOOM_IN";
					ref = rec.getDataReference();				
					if(ref != null){
						key = ref.getKey();
						mlbm.clearLastFilterView();
					}			
				}
			}			
		}		
	}else{
		 //FILTER USING SEARCH TERM PART (NOT DATE)		
	   String searchEngineSearchTerm = request.getParameter("searchEngineSearchTerm");
	   if(searchEngineSearchTerm == null){
	   		searchEngineSearchTerm = "";
	   }else {
	  	 if(charset != null) {
	  		 searchEngineSearchTerm = new String(searchEngineSearchTerm.getBytes("8859_1"), "UTF-8");
	  	 }
	   }
	   String searchEngineAllWords = request.getParameter("searchEngineAllWords");
	   if(searchEngineAllWords == null){
	   		searchEngineAllWords = "";
	   }
	   String matchWholeWordsOnly = request.getParameter("matchWholeWordsOnly");
	   if(matchWholeWordsOnly == null){
	   		matchWholeWordsOnly = "";
	   }
	   String searchRegExp = request.getParameter("searchRegExp");
	   if(searchRegExp == null){
	   		searchRegExp = "";
	   }
	   
	   
	   boolean allWords = (searchEngineAllWords != null && searchEngineAllWords.equals("allWords"));
	   boolean matchWholeWordsOnlyBol = (matchWholeWordsOnly != null && matchWholeWordsOnly.equals("true"));
	   FilterCollection fcol = null;
	   fcol = SearchEngineAdminHelper.createFilter(searchEngineSearchTerm,allWords,mlbm,matchWholeWordsOnlyBol,false,false,null); 
		 if (fcol != null){
		 	 fcol.setSearchEngineResultsOnly(true);	 	 
	  	 mlbm.getFilterManager().addFilterCollection(fcol);
		 }
	}
   response.sendRedirect(BASE_DIRECTORY + "/loggers/logview.jsp?disableZoomOut=true&opdirect=" + OP + "&gotoMain=true" + (key.length() > 0 ? "&zoomInKey=" + key : ""));
%>


