<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.SshSimpleBuilder"%>
<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.admin.LogBrowserBuilderFactory"%>
<%@ page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.data.util.NameExpression"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.knowledge.log.LogAdminResult"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.TimeZone"%>

<%
	String PREFIX = request.getParameter("PREFIX");
	if (PREFIX == null || PREFIX.length() == 0){
		PREFIX = "";
	}


	String ERROR_OBJ = PREFIX+"ERROR_OBJ";
	String LOG_NAME = PREFIX+"LogName";
	String LOG_LOCATION_PATH = PREFIX+"fullPath_";  
	String LOG_LOCATION_STATUS = PREFIX+"locationStatus_";
	String ACCOUNT_ID = PREFIX+"accountId";

  String logname = request.getParameter(LOG_NAME);
  String authAccId = request.getParameter(PREFIX+"authAccId");
  String aId = request.getParameter(ACCOUNT_ID);
  
	NameExpression nameExpr = new NameExpression();
	ArrayList nameExprList = new ArrayList();
	String pathParam = LOG_LOCATION_PATH + "0";
	String statusParam = LOG_LOCATION_STATUS + "0";
	String locationFullPath = request.getParameter(pathParam);
	String pattern = null;
	if(locationFullPath != null && locationFullPath.length() > 0){
		int indx = locationFullPath.lastIndexOf("/");
		if(indx < 0){
			indx = locationFullPath.lastIndexOf("\\");
		}
		String dir = locationFullPath.substring(0,indx + 1);	
		pattern = locationFullPath.substring(indx+1,locationFullPath.length());
		String locationStatus = request.getParameter(statusParam);
		int dynmicState;
		try{
			dynmicState = (locationStatus != null && locationStatus.length() > 0) ? Integer.parseInt(locationStatus) : 0;
		}catch(NumberFormatException e){
			dynmicState = 0;
	  }
		nameExpr = new NameExpression();
		nameExpr.setDirectory(dir);
		nameExpr.setXpologNamePatternsStr(pattern);
		nameExpr.setLogDynamicType(dynmicState);
		nameExprList.add(nameExpr);
	}

  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(logname == null || logname.trim().equals("")){
  	if (pattern != null){
  		logname = XpologUtil.removeSpecialCharsFromLogName(pattern);
  	}
  }
  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
    errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	if(nameExprList == null || nameExprList.size() == 0){
		errmodel.addError("please check log's path and pattern.");
	}
	if (aId == null || aId.trim().equals("")) {
		errmodel.addError("No Account was supplied.");
	}
	
	//defaults
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = defaultZone.getID();
  String logdatapat = "{string}";

  LogBrowsingManager lbm = null;
  SshSimpleBuilder builder = (SshSimpleBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.SSH_LOG_TYPE);
	builder.setName(logname);

	builder.setNameExprList(nameExprList);
	builder.setRecordPattern(logdatapat);
	builder.setTimeZoneId(timeZoneId);
	builder.setDynamicFiles(true);
	builder.setSortByLastUpdate(true);
	
	Account acc = AddressBook.getInstance().getAccountById(aId);
	Media med = MediaManager.newInstace().getMediaByAccount(acc);

	builder.setMedia(med);
	builder.setAccount(acc);
	builder.setDownloadFiles(false);
	builder.setRefreshInterval(-1);
	builder.setAutoUpdate(false);
  //builder.setSourceLocationList(sourceList);

	String result = "";


  try{
    //for configuration reasons
    builder.updateBuilder();
    lbm = builder.getLogBrowserManager();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
  }
  
  if (lbm != null){
  	String[] events = LogAdminHelper.readLines(lbm,100);
  	if (events != null){
  		List patternsList = PatternAdminHelper.getPatternSuggestions(events);
  		if (patternsList != null && patternsList.size() > 0){
  			LogAdminResult res = (LogAdminResult)patternsList.get(0);
  			if(res != null && res.getXpologPattern() != null){
  				logdatapat = res.getXpologPattern();
  				builder.setRecordPattern(logdatapat);
  			  try{
						//for configuration reasons
						builder.updateBuilder();
						lbm = builder.getLogBrowserManager();
						SiteManagment mgmt = SiteManagment.getInstance();
						SiteAdministrator admin = SiteManagment.getAdminInstance();

						Module rootModule = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
						Module parentmod = mgmt.getModuleFromId(Module.ROOT_MONITORS_MODULE_ID);
						boolean parentCreated = false;
						if(parentmod == null){
							parentmod = new Module();
							parentmod.setId(Module.ROOT_MONITORS_MODULE_ID);
							parentmod.setName(Module.ROOT_MONITORS_MODULE_NAME);
							admin.addModule(parentmod,rootModule);
							parentCreated = true;
						}
						//UserEnvironment env = UserEnvironment.getUserEnvironment(request);
						UserContext userContext = UserEnvironment.getUserContext(request);
						String lbmId = admin.addLogBrowser(lbm,parentmod,userContext);
						AuditManager auditMgr = AuditManager.getInstance();
						auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
						userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
						if(lbmId != null && lbmId.length() > 0) {
					  	String[] lbmIds = new String[1];
					  	lbmIds[0] = lbmId;
					  	admin.generateLogData(lbmIds, userContext);
					  }
						
						//result
						StringBuffer xml = new StringBuffer();
						xml.append("<root>");
						xml.append("<result ");
						xml.append("logId=\"" + lbm.getId()+ "\"");
						if (parentCreated){
							xml.append(" refreshItem=\"Module-" + rootModule.getId() + "\"");
						}else{
							xml.append(" refreshItem=\"Module-" + parentmod.getId() + "\"");
						}
						xml.append(" openItem=\"Module-" + parentmod.getId() + "\"");
						xml.append("/>");
						xml.append("</root>");
						result = xml.toString();
  			  
					}catch(Exception e){
						errmodel.addError("Building log problem,please check patterns and path again.");
						errmodel.addError(e.getMessage());
					}
  			}
  		}
  	}
  }






	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	out.write(result);
	out.flush();

%>