/*
	This is the JavaScript file for the AJAX Suggest Tutorial

	You may use this code in your own projects as long as this 
	copyright is left	in place.  All code is provided AS-IS.
	This code is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	For the rest of the code visit http://www.DynamicAJAX.com
	
	Copyright 2006 Ryan Smith / 345 Technical / 345 Group.	

*/
//Gets the browser specific XmlHttpRequest Object
function getXmlHttpRequestObject() {
	if (window.XMLHttpRequest) {
		return new XMLHttpRequest();
	} else if(window.ActiveXObject) {
		return new ActiveXObject("Microsoft.XMLHTTP");
	}
}

var searchReq = getXmlHttpRequestObject();
var clearReq = getXmlHttpRequestObject();
var posX = -1;
var posY = -1;
var start = -1;
var end = -1;
var sel;
var lastSel;
var suggestionFound = false;

function searchSuggest(e) {
	suggestionFound = false;
	if ((e.keyCode >= 48 && e.keyCode <= 90) || (e.keyCode >= 186 && e.keyCode <= 192) || (e.keyCode >= 219 && e.keyCode <= 222)){
		if (e.keyCode != 40 && e.keyCode != 38 && e.keyCode != 13 && e.keyCode != 37 && e.keyCode != 39 && e.keyCode != 27){
			start = new Date();
			if (posX == -1){
				var pos = findSearchTextPosition();
				posX = pos[0];
		 		posY = pos[1];
		 	}
			setTimeout("_searchSuggest('start',false)",300);
		}
	}
}

var lastSearchString = "";
function _searchSuggest(op) {
	end = new Date();
	if (end != null && start != null && end.getTime() - start.getTime() < 250){
		return;
	}
	if (searchReq.readyState == 4 || searchReq.readyState == 0) {
		var str = escape(document.getElementById('searchText').value);
		if (str == null){
			str = "";
		}
		opPar = "";
		if (op && op != null && op == 'start'){
			var ss = document.getElementById('search_suggest_div');
			ss.style.height = "20px";
			ss.innerHTML = '';
			ss.style.display = "none";
			ss.style.left = posX;
			ss.style.top = posY + 20;
			opPar = "&op=" + op;
			if ((!str || str == "" || str.length == 1)){
				if (lastSearchString != ""){
					hideSuggest();
				}
				return;
			}
		}
		var d = new Date();
		lastSearchString = str;
		searchReq.open("GET", 'searchSuggest.jsp?tstmp='+d.getTime()+'&searchText=' + str + opPar, true);
		searchReq.onreadystatechange = handleSearchSuggest; 
		searchReq.send(null);
	}		
}

var running = false;
var finished = false;
var start_fetching = false;
function handleSearchSuggest() {
	if (searchReq.readyState == 4) {
		var ss = document.getElementById('search_suggest_div');
		//ss.innerHTML = '';
		var str = searchReq.responseText.split("\n");
		var ssTable = document.getElementById('search_suggest_table');
		var started = false;
		for(var i=0; i < str.length; i++) {
			if (trim(str[i]) != ""){
				var suggest = '<div style="width:200;word-wrap:break-word" onmouseover="javascript:suggestOver(this);" ';
				suggest += 'onmouseout="javascript:suggestOut(this);" ';
				suggest += 'onclick="javascript:setSearch(this.innerHTML);" ';
				suggest += 'class="suggest_link">' + str[i] + '</div>';
				if (str[i] == "[STARTED]"){
					start_fetching = false;
					finished = false;
					running = true;
				}else if (str[i] == "[FINISHED]"){
					//if (start_fetching){
					//	ss.innerHTML = '';
					//}
					start_fetching = false;
					running = false;
					finished = true;
				}else if (str[i] == "fetching..."){
					//start_fetching = true;
					//ss.innerHTML = suggest;
				}else{
					//if (start_fetching){
					//	ss.innerHTML = '';
					//	start_fetching = false;
					//}
					if (ss.style.display == "none"){
						ss.style.display = "";
					}
					start_fetching = true;
					var hpx = ss.style.height;
					if (hpx){
						var ind = hpx.indexOf("px");
						if (ind != -1){
							var h = parseInt(hpx.substring(0,ind));
							if (h < 100){
								h += 10;
								ss.style.height = h+"px";
							}
						}
					}
					suggestionFound = true;
					ss.innerHTML += suggest;
				}
			}
		}
	}
	start = null;
	end = null;
	if (running){
		setTimeout("fetchSearchSuggestions()",300);
	}
}

function fetchSearchSuggestions(){
	if (finished == true){
		setTimeout("clearSuggestionsCache()",15000);
	}else{
		_searchSuggest('');
	}
}

function clearSuggestionsCache(){
	if (clearReq.readyState == 4 || clearReq.readyState == 0) {
		var d = new Date();
		searchReq.open("GET", 'searchSuggest.jsp?tstmp='+d.getTime()+'&op=clear');
		searchReq.send(null);
	}		
}

//Mouse over function
function suggestOver(div_value) {
	if (lastSel){
		suggestOut(lastSel);
	}
	div_value.className = 'suggest_link_over';
	sel = div_value;
	lastSet = div_value;
}
//Mouse out function
function suggestOut(div_value) {
	div_value.className = 'suggest_link';
	sel = null;
}
//Click function
function setSearch(value) {
	if (value && value != ""){
		document.getElementById('searchText').value = value;
	}
	document.getElementById('search_suggest_div').innerHTML = '';
	document.getElementById('search_suggest_div').style.display = "none";
	sel = null;
	lastSet = null;
}

var lastMarkedDiv;
var checkSuggestStart;
var checkSuggestEnd;
function hideSuggest(){
	checkSuggestStart = new Date();
	setTimeout("_hideSuggest()",100);
}


function _hideSuggest(){
	if (!sel || sel == null){
		checkSuggestEnd = new Date();
		if (document.all && checkSuggestEnd.getTime() - checkSuggestStart.getTime() < 100){
			return;
		}
		document.getElementById('search_suggest_div').style.display = "none";
	}
}

function keepSuggestDivOpen(){
	setTimeout("_keepSuggestDivOpen()",20);
}


function _keepSuggestDivOpen(){
	checkSuggestStart = new Date();
}

function findSearchTextPosition(){
	var st = document.getElementById('searchText');
	return findPos(st);
}

function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

function getCursor(){
	var ss = document.getElementById('search_suggest_div');
	if (ss.innerHTML.length == 0){
		return -1;
	}
	
	for (var i = 0; i < ss.childNodes.length; i++){
		if (ss.childNodes[i].className == "suggest_link_over"){
			return i;
		}
	}
	return ss.childNodes.length;
}
	


function handleArrows(event){
	var str = escape(document.getElementById('searchText').value);
	if (event.keyCode == 27){
		//make sure autocomplete has no values
		hideSuggest();
		return;
	}
	var ss = document.getElementById('search_suggest_div');
	var cursor = getCursor();
	if (event.keyCode == 13 || event.keyCode == 9){
		if (cursor != -1 && cursor < ss.childNodes.length){
			setSearch(ss.childNodes[cursor].innerText);
			hideSuggest();
		}
	}else if(event.keyCode == 40 || event.keyCode == 38){
		if (cursor != -1){
			if (event.keyCode == 40){
				if (cursor == ss.childNodes.length){
					ss.childNodes[0].className = "suggest_link_over";
				}else if (cursor < ss.childNodes.length - 1){
					ss.childNodes[cursor].className = "suggest_link";
					ss.childNodes[cursor + 1].className = "suggest_link_over";
					focusSelectedItem(ss.childNodes[cursor + 1])
				}
			}else{
				if (cursor > 0){
					ss.childNodes[cursor].className = "suggest_link";
					ss.childNodes[cursor - 1].className = "suggest_link_over";
					focusSelectedItem(ss.childNodes[cursor - 1])
				}
			}
		}
	}

	function getAbsoluteTop(htmlObject){
		var yPos = htmlObject.offsetTop;
		//alert("yPos = " + yPos);
		var temp = htmlObject.offsetParent;
		while(temp != null){
			yPos+= temp.offsetTop;
			temp = temp.offsetParent;
		}
		return yPos;
	}


	function focusSelectedItem(obj){
		var divNode = document.getElementById("search_suggest_div");
		if(divNode){
			if(!obj)return(0);
			if (lastSel){
				suggestOut(lastSel);
			}
			lastSel = obj;
			var scrollPos = getAbsoluteTop(divNode);
			//alert("scrollPos = " + scrollPos);
		  var z=getAbsoluteTop(obj);
		  //alert("z = " + z);
			divNode.scrollTop=(z-scrollPos-50);
		}
	}

		
	
}

