<%!
public String createCronExp(HttpServletRequest request, HttpServletResponse response) throws Exception{

	String ERROR_OBJ = "ERROR_OBJ";
	
	String name,description,id,actionId,iterNumber,intervalTimeUnit,startDate;
	String endDate,interTime;
	String hours,minutTens,minutUnit,secTen,secUnit,trigType,timeType;
	String typeDay;
	String[] montharr,daywarr,dayInMonarr;
	String hoursInterval,minutesInterval;
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	name = request.getParameter("SchedulerName");
	description = request.getParameter("SchedulerDescription");
	id = request.getParameter("SchedulerId");
	
	startDate = request.getParameter("startDate"+suffix);
	endDate = request.getParameter("endDate"+suffix);
	intervalTimeUnit = request.getParameter("intervalTimeUnit"+suffix);
	iterNumber = request.getParameter("iterationNumber"+suffix);
	interTime = request.getParameter("intervalTime"+suffix);
	daywarr = request.getParameterValues("dayw"+suffix);
    
 	montharr = request.getParameterValues("Month"+suffix);
 	dayInMonarr =request.getParameterValues("DayInMonth"+suffix);
 	hours = request.getParameter("Hours"+suffix);
	minutTens = request.getParameter("minutesTens"+suffix);
	minutUnit = request.getParameter("minutesUnit"+suffix);
	secTen = request.getParameter("secondTen"+suffix);
	secUnit = request.getParameter("secondUnit"+suffix);
	trigType = request.getParameter("trigType"+suffix);
	typeDay = request.getParameter("typeDay"+suffix);
	String state = request.getParameter("State");
	if (state == null){
		state = "2";
	}
	hoursInterval = request.getParameter("hoursInterval"+suffix);
	minutesInterval = request.getParameter("minutesInterval"+suffix);
	
	ErrorModel errmodel = new ErrorModel(); 
	if(name == null || name.equals("")){
    	errmodel.addError("No Name was supplied.");
 	}
 	if(trigType == null || trigType.equals("")){
 		errmodel.addError("Please specify scheduling method");
 	}
 	if(trigType != null && trigType.equals("simple")){
  	if(interTime == null || interTime.equals("")){
    	errmodel.addError("Please specify interval period");
  	}
  	try{
			int i = Integer.parseInt(interTime);
			if(i <=0){
				errmodel.addError("Please specify a positive interval period");
			}
	  }catch(Exception ie){
	  	errmodel.addError("Interval period must be a valid positive number");
	  }
	}
 	if(trigType != null && trigType.equals("cron")){
  	if(typeDay == null || typeDay.equals("")){
    	errmodel.addError("Please specify schedule details");
  	}else{
  		if(typeDay.equals("dayOWeek") && (daywarr == null || daywarr.length == 0)){
  			errmodel.addError("Please specify days in week");
  		}else if(typeDay.equals("dayOMon")){
  			if(dayInMonarr == null || 
	  				dayInMonarr.length == 0 || 
	  				montharr == null || 
	  				montharr.length == 0){
	 				errmodel.addError("Please specify months and days");
	  		}
  		}
  	}
	}
	
	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		//response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return "";
	}
  	
  	
	ActionJobBuilder builder = new ActionJobBuilder();
	builder.setId(id);
	builder.setName(name);
	builder.setDescription(description);
	builder.setActionId("");
	builder.setState(state); 
    
	builder.setStartDate(startDate);
	builder.setEndDate(endDate);
    
  //simple or cron
	if(trigType.equals("simple")){
		builder.setSimple(true);
		builder.setIntervalTime(interTime);
		builder.setIntervalTimeUnit(intervalTimeUnit);
		builder.setIterationNumber(iterNumber);
	}else if(trigType.equals("cron")){
		builder.setCron(true);
    	
		if(typeDay.equals("dayOWeek")){
			builder.setDayType(JobBuilder.DAY_OF_WEEK);	
    	Integer[] darr = new Integer[daywarr.length];
    	for(int i=0;i<darr.length;++i){
    		darr[i] = new Integer(daywarr[i]);
			}
    	builder.setDays(darr);
    }else if(typeDay.equals("dayOMon")){
    	builder.setDayType(JobBuilder.DAY_OF_MONTH);
    	Integer[] darr = new Integer[dayInMonarr.length];
    	for(int i=0;i<darr.length;++i){
				if(dayInMonarr[i].equals("all")){
					builder.setAllDayInMonth(true);
    	    darr = new Integer[0];
    	    break;
				}
    	  darr[i] = new Integer(dayInMonarr[i]);
			}
			builder.setDayInMonth(darr);
			Integer[] marr = new Integer[montharr.length];
			for(int i=0;i<marr.length;++i){
				if(montharr[i].equals("all")){
					builder.setAllMonth(true);
					marr = new Integer[0];
					break;
				}
				marr[i] = new Integer(montharr[i]);
			}
			builder.setMonth(marr);
   	}
    	
		builder.setHours(hours);
		builder.setMinutesTen(minutTens);
		builder.setMinuteUnit(minutUnit);
		builder.setSecondTen(secTen);
		builder.setSecondUnit(secUnit);
		builder.setMinutesInterval(minutesInterval);
		builder.setHoursInterval(hoursInterval);
		if(minutTens.equals("0") && minutUnit.equals("0") && minutesInterval.equals("1")){
			builder.setEveryMinute(true);
		}
		if(hours.equals("0") && hoursInterval.equals("1")){
			builder.setEveryHour(true);
		}
	}
  	
	XpoScheduledOperation ops = builder.buildXpoSchedOp();
	String cronExp = ((XpoCronTrigger)ops.getTriggers().get(0)).getCronExpression();
	return cronExp;
}
%>

