<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String DATA_SOURCE_BUILDER = "DATA_SOURCE_BUILDER";

  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  UIXMLDataSourceBuilder builder = (UIXMLDataSourceBuilder)request.getSession().getAttribute(DATA_SOURCE_BUILDER);
  if (builder == null){
	response.sendRedirect("addXMLDataSource.jsp");
	return;
  }
  
  String dsName = request.getParameter("dsName");
  String dsDesc = request.getParameter("dsDesc");
  
  if (dsName == null || dsName.trim().length() == 0){
  	errmodel.addError("Data source name not supplied.");
  }
  
  builder.setName(dsName);
  builder.setLogDescription(dsDesc);

  for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
    UIXMLDataSourceBuilder.LogicPatternElementInfo info = builder.getLogicElementPatternInfoAt(i);
    String pat = request.getParameter("elemPattern_" + i);
    String cond = request.getParameter("conditionCombo" + i);
    String condVal = request.getParameter("conditionValue_" + i);
    String ignore = request.getParameter("ignore_" + i);
    String unique = request.getParameter("uniqueUse_" + i);
    String uniqueVal = request.getParameter("uniqueValue_" + i);
    
    info.setSelected(ignore == null || !ignore.equals("on"));
    if (pat != null && pat.trim().length() > 0){
       info.setXpologPattern(pat);
    }

    if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
       info.setConditionProperty(cond,condVal);
    }
    
    boolean isUnique = unique != null && unique.equals("on");
    info.setUniqueSelected(isUnique);
    if (isUnique){
       info.setUniqueValue(uniqueVal);
    }else {
       info.setUniqueValue(null);
    }
  }  
  
  String [] metaDataKeys = UIDataSourceHelper.getMetaDataKeys(); 
  Properties metaDataProp = new Properties();
  for (int i = 0; i < metaDataKeys.length; i++){
     String chk = request.getParameter(metaDataKeys[i] + "Chk");
     if (chk != null && chk.equals("on")){
        String val = request.getParameter(metaDataKeys[i] + "Txt");
        metaDataProp.setProperty(metaDataKeys[i],val);
     }
  }
  builder.setMetaDataProperties(metaDataProp);

  if(builder.getSelectedPatternElementInfoCount() == 0){
    errmodel.addError("No elements pattern were supplied.");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
    return;

  }

  try{
    if (builder.getAtomicParadigm().getId() == null){
      builder.setID(null);
    }
    //for configuration reasons
    builder.updateBuilder();
    String id = UIDataSourceHelper.saveDataSource(builder);
  }catch(Exception e){
    errmodel.addError("Building data source problem,please check xml and xpolog patterns are valid.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
    return;
  }

  response.sendRedirect("dataSourceAdmin.jsp");
%>


