<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.util.LogicUserContext"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigmInfo"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%

  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String hoursToKeepStr = request.getParameter("hoursToKeep");
  long hoursToKeep = 0;

  ErrorModel errmodel = new ErrorModel();
  
  if (hoursToKeepStr != null && hoursToKeepStr.trim().length() > 0){
		try {
			hoursToKeep = Long.parseLong(hoursToKeepStr);
		}catch (Exception e){
			errmodel.addError("Failed to parse 'hours to keep' parameter. Please check your entry again");
		}
  }
  
  String [] transactions = request.getParameterValues("transactions");
  if(transactions == null){
	  transactions = new String[0];
  }
  
  for (int i = 0;i < transactions.length; i++){
  	TransactionParadigm t = BrainConfigurationRepository.getRepository().getTransactionParadigmById(transactions[i]);
    if(t != null) {
    	String intervalTimeStr = request.getParameter("intervalTime" + t.getId());
    	String intervalTimeUnit = request.getParameter("intervalTimeUnit" + t.getId());
   	 	if(intervalTimeStr != null && intervalTimeStr.length() > 0 && intervalTimeUnit != null && intervalTimeUnit.length() > 0) {
   			long intervalTime = -1;
   			try {
   				intervalTime = Long.parseLong(intervalTimeStr);
   				if(intervalTimeUnit.equals("seconds")) {
  				 	intervalTime *= DateUtil.SEC_UNIT;
  				}else if(intervalTimeUnit.equals("minutes")) {
  					intervalTime *= DateUtil.MIN_UNIT;
  				}else if(intervalTimeUnit.equals("hours")) {
  					intervalTime *= DateUtil.HOUR_UNIT;
  				}
  	   		t.getTransactionInfo().addProperty(TransactionParadigmInfo.ONLINE_SLEEP_INTERVAL, String.valueOf(intervalTime));
  	   		t.getTransactionInfo().addProperty(TransactionParadigmInfo.ONLINE_SLEEP_INTERVAL_UNIT, intervalTimeUnit);
   		 	}catch(Exception e) {
   			 	errmodel.addError("Failed to parse 'Sampling interval' parameter of transaction " + t.getName() + ". Please check your entry again");
   		 	}
    	}
    }
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/online/tranToMonitor.jsp");
    return;
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  DataSession dataSession = ctrlMgr.getDataSessionById(DataSession.ONLINE_DATA_SESSION_ID);
  dataSession.setHoursToKeep(hoursToKeep);
  
  boolean suc = ctrlMgr.saveDataSession(dataSession);
  if (!suc){
      errmodel.addError("Internal problem occured while saving information.");      
  }else {     
			String[] transOrg = ctrlMgr.getTransactionParadigmForSessionPradigm(dataSession.getId());
			List transToAdd = new LinkedList();
			for (int i = 0; i < transOrg.length; i++){
				TransactionParadigm t = BrainConfigurationRepository.getRepository().getTransactionParadigmById(transOrg[i]);
				if (!LogicUserContext.isTransactionVisible(userContext,t)){
					transToAdd.add(transOrg[i]);
				}
			}
      ctrlMgr.deleteAllTransactionFromSessionParadigm(dataSession.getId());
      for (int i = 0;i < transactions.length; i++){
       ctrlMgr.addTransactionToSessionParadigm(dataSession.getId(),transactions[i]);
       
       TransactionParadigm t = BrainConfigurationRepository.getRepository().getTransactionParadigmById(transactions[i]);
       if(t != null) {
      	 
      	 String intervalTimeStr = t.getTransactionInfo().getProperty(TransactionParadigmInfo.ONLINE_SLEEP_INTERVAL);
      	 if(intervalTimeStr != null && intervalTimeStr.length() > 0) {
		       UITransactionParadigmHelper.updateTransactionInfo(t);
      	 }
       }
     }
      //add transactions deleted which are unvisible in the user context
      for (int i = 0;i < transToAdd.size(); i++){
        ctrlMgr.addTransactionToSessionParadigm(dataSession.getId(),(String)transToAdd.get(i));
      }
  }
  //update engine with new conf
  OnlineEngineControl.getInstance().getDefaultEngine().configurationChanged();
  
  String names = "";
  for(int i=0;i<transactions.length;i++) {
	  names += transactions[i];
	  if(i+1<transactions.length) {
		  names+=", ";
	  }
  }
  //    audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "set transactions to monitor", AuditConstants.TRANSACTION, "set transactions to monitor " + names);

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/online/tranToMonitor.jsp");
    return;
  }
  response.sendRedirect(BASE_DIRECTORY + "logic/admin/common/opok.jsp?okUrl=logic/admin/online/tranToMonitor.jsp");
 
%>
