<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);



  ErrorModel errmodel = new ErrorModel();

  if (security == null){
    errmodel.addError("This operation can't be done.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  String dataSessionId = request.getParameter("id");
  if (dataSessionId == null || dataSessionId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }



  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "";
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  DataSession dataSession = ctrlMgr.getDataSessionById(dataSessionId); 
  
  if (dataSession == null){
    errmodel.addError("No project was found for id - " + dataSessionId);
  }
  ModuleMemberPermissions currPermission = ctrlMgr.getDataSessionPermissions(dataSession);	
  if (currPermission != null && !security.isEditable(currPermission)){
    response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp?okURL=logic/admin/session/sessionsDefinitionView.jsp");
    return;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }
  
  ModuleMemberPermissions permissions = UITransactionParadigmHelper.getTransactionDefaultPermissions();
  String forwardPage = BASE_DIRECTORY + "security/common/moduleMemberPermissionsIncluder.jsp";
 
  if (currPermission != null){
	  request.setAttribute("currPermission",currPermission);
  }
  if (permissions != null){
	  request.setAttribute("permissions",permissions);
  }

  String resetURL = "logic/admin/session/perm/sessionPermissions.jsp?id=" + dataSessionId;  
  String actionURL = "logic/admin/session/perm/sessionPermissionsAction.jsp";
  String name = dataSession == null ? "" : dataSession.getName();
%>

<jsp:forward page="../../../../security/common/moduleMemberPermissionsIncluder.jsp">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="id" value="<%=dataSessionId%>"/>
 <jsp:param name="type" value=""/>
 <jsp:param name="memberName" value="<%=name%>"/>
 <jsp:param name="actionURL" value="<%=actionURL%>"/>
 <jsp:param name="resetURL" value="<%=resetURL%>"/>
 <jsp:param name="forwardURL" value="<%=forwardURL%>"/>
 <jsp:param name="ignoreParent" value="true"/>
</jsp:forward>
