<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>
<%@ include file="../../../logic/admin/common/createScheduler.jsp"%>
<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%
UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
	

  String workspaceId = request.getParameter("workspaceId");
  
  String sessionId = request.getParameter("sessionId");
  String sessionName = request.getParameter("sessionName");
  String sessionDesc = request.getParameter("sessionDesc");
  String hoursToKeepStr = request.getParameter("hoursToKeep");
  long hoursToKeep = 0;

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  Workspace workspace = ctrlMgr.getWorkspaceById(workspaceId);


  ErrorModel errmodel = new ErrorModel();

  if(workspace == null){
    errmodel.addError("No workspace was supplied.");
  }
	
  if(sessionName == null || sessionName.trim().equals("")){
    errmodel.addError("No session name was supplied.");
  }
  
  if (hoursToKeepStr != null && hoursToKeepStr.trim().length() > 0){
		try {
			hoursToKeep = Long.parseLong(hoursToKeepStr);
		}catch (Exception e){
			errmodel.addError("Failed to parse 'hours to keep' parameter. Please check your entry again");
		}
  }
  
  String [] transactions = request.getParameterValues("transactions");
  if (transactions == null){
    //transactions = new String[0];
    errmodel.addError("No transaction was selected");
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionsDefinitionView.jsp?workspaceId=" + workspaceId);
    return;
  }

  DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);
  boolean isNew = dataSession == null;
  if (isNew){
    dataSession = new DataSession();
    dataSession.setParentWorkspaceId(workspaceId);
  }
  dataSession.setName(sessionName);
  dataSession.setDescription(sessionDesc);
  dataSession.setHoursToKeep(hoursToKeep);

  //filter section
  RecordMask mask = new RecordMask();
  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
  MaskColumn[] cols = {dateMask};
  mask.setColumns(cols);

	DateFilter dfilter = createDateFilter(request,response,mask);
	
	if(dfilter != null){
		LogicExecutionPolicy logicExePolicy = new LogicExecutionPolicy();
		FilterCollection fc = new FilterCollection();
		fc.setName(dataSession.getName()+"_fc");
		fc.setId(System.currentTimeMillis()+"_fc");
	  fc.addFilter(dfilter);
	  logicExePolicy.setCombineStartEndRule(fc);
	  dataSession.setLogicExePolicy(logicExePolicy);
	}else{
		dataSession.setLogicExePolicy(new LogicExecutionPolicy());
	}
	
	
  
  boolean suc = isNew ? ctrlMgr.addDataSession(dataSession,workspaceId,userContext) != null : ctrlMgr.saveDataSession(dataSession);
  if (!suc){
      errmodel.addError("A problem occured while saving session.");      
  }else {     
     if (!isNew){
       ctrlMgr.deleteAllTransactionFromSessionParadigm(dataSession.getId());
     }     
     for (int i = 0;i < transactions.length; i++){
       ctrlMgr.addTransactionToSessionParadigm(dataSession.getId(),transactions[i]);
     }
  }
	//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "add/edit project", AuditConstants.PROJECT, "add/edit project " + dataSession.getName());

  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionsDefinitionView.jsp?workspaceId=" + workspaceId);
    return;
  }
  response.sendRedirect(BASE_DIRECTORY + "logic/admin/common/opok.jsp?doRefresh=true&okUrl=logic/admin/session/sessionsDefinitionView.jsp?workspaceId=" + workspaceId);
 
%>
