<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>
<%@ include file="../../../logic/admin/common/createScheduler.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";

  String sessionId = request.getParameter("sessionId");

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);

  ErrorModel errmodel = new ErrorModel();

  if(dataSession == null){
    errmodel.addError("Session does not exist.");
  }

	final LogicExecutionPolicy logExePolicy = new LogicExecutionPolicy();	
	logExePolicy.setDataSessionParadigmId(sessionId);

	//filter section
	//filter section
  RecordMask mask = new RecordMask();
  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
  MaskColumn[] cols = {dateMask};
  mask.setColumns(cols);

	DateFilter dfilter = null;
	try{
		dfilter = createDateFilter(request,response,mask);
	}catch(Exception e){
		errmodel.addError("Failed to create date filter. Please check your entry again");
	}
	if(dfilter != null){
		FilterCollection fc = new FilterCollection();
		fc.setName(dataSession.getName()+"_fc");
		fc.setId(System.currentTimeMillis()+"_fc");
	    fc.addFilter(dfilter);
		logExePolicy.setCombineStartEndRule(fc);        
	}

	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionRuntimeAdmin.jsp");
		return;
	}
				
	  //	  audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "run result set on project", AuditConstants.PROJECT, "run result set on project " + dataSession.getName());

	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/admin/session/sessionRuntimeStatus.jsp?sessionId=" + sessionId) {
		public void run(HttpServletRequest request){
			boolean isFinished = false;
			boolean isFailed = false;
			try {
				Thread.sleep(1000);
				ExecutionManager execman = ExecutionManager.getInstance();				
				final ExecutionHandler execHandler = execman.registerExecutionRequest(logExePolicy);
				if (execHandler != null){
					final org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger("events");
					if (log.isDebugEnabled()){
						final long start = System.currentTimeMillis();
					
						execHandler.getEngine().addJobStatusListener(new xpolog.eye.common.JobStatusListener(){
							public void statusChanged(xpolog.eye.common.JobStatusEvent evt){
								long diff = System.currentTimeMillis() - start;
								diff = diff / 1000;														
  			  			log.info("execute result set on " + execHandler.getSessionParadigm().getName() + " finished in " + diff + " seconds");							
							}
						});
					}  				
				}
			}catch (Exception e){
				e.printStackTrace();
				isFailed = true;
			}
		}
	};
	env.setProgressRunner(runner);
 
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>
