<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.*"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

	String OP = "OP";
	String ADD = "ADD";
	String DUPLICATE = "DUPLICATE";

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	if (!ctrlMgr.persistencyMediumOk()){
		ErrorModel errmod = new ErrorModel();
		errmod.addError("Could not connect to database");
		errmod.addError("Please ensure that the TxExpo database is well configured and running");
		request.getSession().setAttribute(ERROR_OBJ,errmod);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	UserSecurity user = manager.getUserSecurity(request);
	String ds_id = request.getParameter("ds_id");
	String op = request.getParameter(OP);

	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");

	UITransactionParadigmBuilder builder = null;
	if (op == null || !op.equals(ADD)) {
		if (ds_id != null && ds_id.trim().length() > 0) {
			builder = new UITransactionParadigmBuilder();
			if (op != null && op.equals(DUPLICATE)) {
				builder.duplicateTransactionGraph(ds_id);
			}else {
				builder.loadTransactionGraph(ds_id);
				builder.setEditTransaction(true);
				isView = true;
				/*HashSet set = new HashSet();
				XpoLogAtomicParadigm[] unusable = UITransactionParadigmHelper.checkTransationParadigmValidity(builder);
				if (unusable != null && unusable.length > 0) {
					ErrorModel ermo = new ErrorModel();
					ermo.addError("Error in transaction definition");
					ermo.addError("The are problems with the following data sources:");
					for (int i = 0; i < unusable.length; i++) {
						String lbmId = (unusable[i] == null || unusable[i].getDateSource() == null) ? "N/A" : unusable[i].getDateSource().getLbmId();
						String nodeId = (unusable[i] == null || unusable[i].getDateSource() == null) ? null : unusable[i].getDateSource().getNodeId();
						StringBuffer message = new StringBuffer();
						message.append("Log Id: " + lbmId);
						if (nodeId != null && nodeId.length() > 0) {
							xpolog.eye.cloud.XplgNode node = SiteManagment.getInstance().getCloudMgr().getNodeById(nodeId);
							String nodeName = node != null ? node.getName() : nodeId;
							message.append(" (XpoLog Node Id: " + nodeName + ". Check that remote node is up and that the remote log is accessible)");
						}
						set.add(message.toString());
					}
					Iterator it = set.iterator();
					while (it.hasNext()) {
						String m = (String)it.next();
						ermo.addError(m);
					}
					request.getSession().setAttribute(ERROR_OBJ, ermo);
					response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
					return;
				}*/
			}
		}else {
			builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
		}
	}

	if (builder == null) {
		builder = new UITransactionParadigmBuilder();
		builder.setEditTransaction(true);
		builder.createNewTransaction();
	}
	request.getSession().setAttribute(TRAN_PARADIGM_BUILDER, builder);

	response.sendRedirect("transactionView.jsp?ds_id=" + ds_id + "&isView=" + isViewStr);
	
%>
