<%@ page language="java" %>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>


<%
  String id = request.getParameter("id");
	String filterId = request.getParameter("filterId");
	if (id == null || id.length() == 0){
	  return;
	}
	String logid = id;
	int index = id.indexOf("$");
	String nodeid = null;
	if (index >= 0){
	  nodeid = id.substring(0,index);
	  if (nodeid.length() == 0 || nodeid.equals("localhost")){
	    nodeid = null; 
	  }
	  logid = id.substring(index + 1);
	}
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){		
	  return;
	}
	String routineId = request.getParameter("routineId");
	if (routineId == null || routineId.length() == 0){
	  return;
	}
	
	XpoLogAtomicParadigm atomicParadigm = builder.getAtomicByRoutineId(routineId);
	if (atomicParadigm == null){
	  return;
	}
	XplgDataSource xds = builder.getDataSourceByRoutineId(routineId);

	xds.setNodeId(nodeid);
	
	xds.setLbmId(logid);
	if(filterId != null && filterId.length() > 0) {
		xds.setFilterId(filterId);
	}
		
 	LogBrowsingManager lbm = null;
  try {
    lbm = xds.createLogBrowsingManager();
  }catch (Exception e){
    e.printStackTrace();
  }
  if (lbm == null){
    return;
  }
  atomicParadigm.setDataSourceId(logid);
	atomicParadigm.setLbm(lbm);
	atomicParadigm.setName(lbm.getName());
	xds.setName(lbm.getName());
	String [] names = UITransactionParadigmHelper.getColumnNames(lbm.getRecordMask());
	
	List filtersList = lbm.getFilterManager().getFilterCollections();
	
	FilterCollection[] managerFilters = null;//UITransactionParadigmHelper.getDataFiltersForAtomic(ds_id,true,true);
	if (managerFilters == null) {
		managerFilters = new FilterCollection[0];
	}
	HashMap fMap = null;//builder.getDataSourceFilters(ds_id);
	Collection fc = (fMap != null) ? fMap.values() : null;
	FilterCollection[] builderFilters = new FilterCollection[0];
	if (fc != null){
		builderFilters = (FilterCollection[])fc.toArray(new FilterCollection[fc.size()]);
	}
	FilterCollection[] filters = new FilterCollection[managerFilters.length+builderFilters.length];
  System.arraycopy(managerFilters,0,filters,0,managerFilters.length);
  System.arraycopy(builderFilters,0,filters,managerFilters.length,builderFilters.length);
%>
<html>
<head>
  <meta http-equiv="Content-Language" content="en-us">
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="EXPIRES" CONTENT="0">
</head>
<body>
<script>
var dsid = "<%=logid%>";
var dsname = "<%=lbm.getName()%>";
var names = new Array();
var filtersIds = new Array();
var filtersNames = new Array();
var dataFilters = new Array();
<% for (int i = 0; i < names.length; i++) {%>
	names[names.length] = "<%=names[i]%>"; 
<%}%>

filtersNames[0] = "None";
filtersIds[0] = "";
<%if (filtersList != null){ 
		for (int i = 0; i < filtersList.size(); i++) {
		  FilterCollection col = (FilterCollection)filtersList.get(i);		
		%>
			filtersNames[filtersNames.length] = "<%=col.getName()%>"; 
			filtersIds[filtersIds.length] = "<%=col.getId()%>";
<%
		}
	}
%>

dataFilters[0] = "No Filter"; 
<%if (filters != null){ 
		for (int i = 0; i < filters.length; i++) {%>
			dataFilters[dataFilters.length] = "<%=filters[i].getName()%>"; 
<%
		}
	}
%>
</script>
</body>
</html>