<%@ page import="java.util.List"%>

<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.edge.NodesEdgeParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!

public String getGroupableNodes(UITransactionParadigmBuilder builder, NodeModelParadigm node) {
	String groupableNodes = "";
	
	groupableNodes += getOutgoingGroupableNodes(builder, node, null);
	groupableNodes += getIncomingGroupableNodes(builder, node);
	if(groupableNodes.length() > 0) {
		groupableNodes = groupableNodes.substring(0, groupableNodes.length() - 1);
	}
	
	return groupableNodes;
}

public String getOutgoingGroupableNodes(UITransactionParadigmBuilder builder, NodeModelParadigm node, NodeModelParadigm exclude) {
	String groupableNodes = "";
	NodesEdgeParadigm currentEdge;
	NodeModelParadigm currentNode;
	String nodeType;
	
	List outgoingEdges = builder.getTransactionGraph().outgoingEdgesOf(node);
	if(outgoingEdges.size() > 0) {
		for(int i = 0; i < outgoingEdges.size(); i++) {
			currentEdge = (NodesEdgeParadigm)outgoingEdges.get(i);
			currentNode = currentEdge.getTargetParadigm();
			if(!currentNode.equals(exclude)) {
				if(currentNode.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM) ||
					 currentNode.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
					nodeType = currentNode.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM) ? "subTransaction" : "routine";
					groupableNodes += (nodeType + currentNode.getId() + ",");
				}
			}
		}
	}
	
	return groupableNodes;
}

public String getIncomingGroupableNodes(UITransactionParadigmBuilder builder, NodeModelParadigm node) {
	String groupableNodes = "";
	NodesEdgeParadigm currentEdge;
	NodeModelParadigm currentNode;
	String nodeType;
	
	List incomingEdges = builder.getTransactionGraph().incomingEdgesOf(node);
	if(incomingEdges.size() > 0) {
		for(int i = 0; i < incomingEdges.size(); i++) {
			currentEdge = (NodesEdgeParadigm)incomingEdges.get(i);
			currentNode = currentEdge.getSourceParadigm();
			if(currentNode.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM) ||
				 currentNode.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
				if(currentEdge instanceof InnerEdgeParadigm) {
					nodeType = currentNode.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM) ? "subTransaction" : "routine";
					groupableNodes += (nodeType + currentNode.getId() + ",");
				}
				groupableNodes += getOutgoingGroupableNodes(builder, currentNode, node);
			}
		}
	}
	
	return groupableNodes;
}

%>