<%@ page language="java"%>

<%@ page import="java.awt.Rectangle"%>

<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImage"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImageDescriptor"%>

<%!

static final String BASE_DIRECTORY = "../../../";

public String getNodeData(UITransactionParadigmBuilder builder, NodeModelParadigm node) {
	String result = "";
	if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
		result = getSubTransactionData(builder, (TransactionParadigm)node);
	}else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
		result = getRoutineData(builder, (RoutineParadigm)node);
	}
	return result;
}

public String getSubTransactionData(UITransactionParadigmBuilder builder, TransactionParadigm subTransaction) {
	StringBuffer result = new StringBuffer();
	
	TransactionParadigm previousRoot = builder.getRoot();
	builder.setRoot(subTransaction, false);
	
	JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(10, 10, "#FFFFFF");
	
	builder.setRoot(previousRoot);
	
	int width = imageDescriptor.getImageGraphWidth();
	if(width < 120) {
		width = 120;
	}
	result.append("<table id=\"nodeDataTable\" border=\"0\" width=\"" + width + "\" cellspacing=\"0\" style=\"border-collapse: collapse\">");
	result.append("<tr valign=\"top\" bgcolor=\"#E1E1E1\">");
	result.append("<td align=\"center\" style=\"padding-left:4;padding-right:4\" class=\"SUB_TRANSACTION_CONTENT_HEADER\">");
	result.append(subTransaction.getName());
	result.append(" Content");
	result.append("</td>");
	result.append("</tr>");
	result.append("<tr bgcolor=\"#E1E1E1\">");
	result.append("<td>");
	result.append("<table border=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" width=\"100%\" bgcolor=\"#FFFFFF\">");
	result.append("<tr>");
	result.append("<td style=\"padding-left:2;padding-right:2; padding-bottom:20\"><img src=\"" + BASE_DIRECTORY + imageDescriptor.getImageGraphURL() + "\" USEMAP=\"#subTransactionMap\" border=\"0\">");
	result.append("</td>");
	result.append("</tr>");
	result.append("</table>");
	result.append("</td>");
	result.append("</tr>");
	result.append("</table>");
	
	return result.toString();
}

public String getRoutineData(UITransactionParadigmBuilder builder, RoutineParadigm routine) {
	StringBuffer result = new StringBuffer();
	String atomicName = "None";
	String filterName = "None";
	String rulesName = "";
  
	XpoLogAtomicParadigm atomic = builder.getAtomicByRoutineId(routine.getId());
	XplgDataSource dataSource = null;
	
	if(atomic != null && atomic.getLbm() != null) {
		atomicName = atomic.getName();
		dataSource = builder.getDataSourceByRoutineId(routine.getId());
	}else {
		atomic = null;
	}
	if(atomic == null ||  dataSource.getFilterId() == null || dataSource.getFilterId().length() == 0 || dataSource.getFilterId().equals("none")) {
		filterName = "None";
  }else {
  	if(atomic != null) {
			java.util.List filtersList = atomic.getLbm().getFilterManager().getFilterCollections();
			if(filtersList != null) { 					
 			String selectedFilterId = dataSource == null ? null : dataSource.getFilterId();
	    	for (int f = 0; f < filtersList.size(); f++) {
		      FilterCollection col = (FilterCollection)filtersList.get(f);
		      boolean selected = selectedFilterId != null && selectedFilterId.equals(col.getId());
		      if(selected) {
		      	filterName = col.getName();
		      	break;
   			}			    
 			}
			}
		}
  }
	rulesName += routine.isLogicFromType(RoutineParadigm.START_LOGIC_TYPE) ? "Open, " : "";
	rulesName += routine.isLogicFromType(RoutineParadigm.SINGLE_LOGIC_TYPE) ? "Single, " : "";
	rulesName += routine.isLogicFromType(RoutineParadigm.OPTIONAL_LOGIC_TYPE) ? "Optional, " : "";
	rulesName += routine.isLogicFromType(RoutineParadigm.END_LOGIC_TYPE) ? "End, " : "";
  if(rulesName.length() > 0) {
  	rulesName = rulesName.substring(0, rulesName.length() - 2);
  }
	
	result.append("<table id=\"nodeDataTable\" border=\"0\" width=\"250\" cellspacing=\"0\" height=\"100%\" cellpadding=\"0\" style=\"background:#E1E1E1; border:1px solid #000000\">");
	
	result.append("<tr>");
	result.append("<td class=\"TOOLTIP_LEFT_TEXT\" style=\"padding-left:5;width:50\">Name: </td>");
	result.append("<td id=\"tooltipName\" align=\"left\" class=\"TOOLTIP_RIGHT_TEXT\" style=\"padding-right:5;width:*\">");
	result.append(routine.getName());
	result.append("</td>");
	result.append("<td width=\"1%\">&nbsp;</td>");
	result.append("</tr>");
	
	result.append("<tr>");
	result.append("<td class=\"TOOLTIP_LEFT_TEXT\" style=\"padding-left:5;width:50\">Source: </td>");
	result.append("<td id=\"tooltipSource\" align=\"left\" class=\"TOOLTIP_RIGHT_TEXT\" style=\"padding-right:5;width:*\">");
	result.append(atomicName);
	result.append("</td>");
	result.append("<td width=\"1%\">&nbsp;</td>");
	result.append("</tr>");
	
	result.append("<tr>");
	result.append("<td class=\"TOOLTIP_LEFT_TEXT\" style=\"padding-left:5;width:50\">Filter: </td>");
	result.append("<td id=\"tooltipFilter\" align=\"left\" class=\"TOOLTIP_RIGHT_TEXT\" style=\"padding-right:5;width:*\">");
	result.append(filterName);
	result.append("</td>");
	result.append("<td width=\"1%\">&nbsp;</td>");
	result.append("</tr>");
	
	result.append("<tr>");
	result.append("<td class=\"TOOLTIP_LEFT_TEXT\" style=\"padding-left:5;width:50\">Rules: </td>");
	result.append("<td id=\"tooltipRules\" align=\"left\" class=\"TOOLTIP_RIGHT_TEXT\" style=\"padding-right:5;width:*\">");
	result.append(rulesName);
	result.append("</td>");
	result.append("<td width=\"1%\">&nbsp;</td>");
	result.append("</tr>");
	
	result.append("</table>");
	
	return result.toString();
}

public String getSubTransactionMappingStr(UITransactionParadigmBuilder builder, TransactionParadigm subTransaction) {
	TransactionParadigm previousRoot = builder.getRoot();
	builder.setRoot(subTransaction, false);
	
	JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(10, 10, "#FFFFFF");
	String mappingStr = builder.createMappingString(imageDescriptor.getJgraphImage(), false);
	
	builder.setRoot(previousRoot);
	
	return mappingStr;
}

%>

<%
	String NODE_TYPE = "nodeType";
	String NODE_ID = "nodeId";
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";
	
	String nodeType = request.getParameter(NODE_TYPE);
	String nodeId = request.getParameter(NODE_ID);
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	NodeModelParadigm node = null;
  if(nodeType.equals("subTransaction")) {
  	node = builder.getTransactionById(nodeId);
  }else if(nodeType.equals("routine")) {
  	node = builder.getRoutineById(nodeId);
  }else if(nodeType.equals("dummy")) {
  	node = builder.getDummyById(nodeId);
  }
	
	String result = "", mappingStr = "";
	Rectangle rec = null;
  if(node != null) {
  	JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(700, 220, "#FFFFFF");
  	JGraphImage graphImg = imageDescriptor.getJgraphImage();
		rec = graphImg.getRectangleForVertex(node);
		result = getNodeData(builder, node);
  	if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
			mappingStr = getSubTransactionMappingStr(builder, (TransactionParadigm)node);
		}
  }
	
	String nodeName = node == null ? "" : node.getName();
	String x = rec == null ? "-1" : Integer.toString((int)rec.getMinX());
	String y = rec == null ? "-1" : Integer.toString((int)rec.getMinY());	
	
	response.setContentType("text/xml");
%>


<%@page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@page import="xpolog.logic.sources.xplg.XplgDataSource"%>
<%@page import="xpolog.eye.data.filters.FilterCollection"%>
<NodeData>
<Node type="<%=nodeType %>" id="<%=nodeId %>" name="<%=nodeName %>" x="<%=x %>" y="<%=y %>">
<![CDATA[
<%=result %>
]]>
</Node>
<Mapping>
<![CDATA[<%=mappingStr %>]]>
</Mapping>
</NodeData>
