<%@ page language="java"%>

<%@ page import="java.awt.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ page import="xpolog.logic.alert.engine.*"%>
<%@ page import="xpolog.logic.alert.engine.actions.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.common.DummyParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.graph.*"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	String ds_id = request.getParameter("ds_id");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);

	JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(700, 220, "#FFFFFF");
	JGraphImage graphImg = imageDescriptor.getJgraphImage();
	String mappingStr = builder.createMappingString(imageDescriptor.getJgraphImage(), true);
	
  UIProperties defProperties = UIPreferences.getInstance().getDefaultProperies();
  UIProperties globalProperties = UIPreferences.getInstance().getGlobalProperties();
  UIProperty [] imagesProperties = globalProperties != null ?
  		globalProperties.getSortedProperties(globalProperties.getAllProperties(UIConstants.IMAGES_TYPE)) :
  		new UIProperty[0];	

  NodeModelParadigm[] nodes = builder.getTransactionNodes();
	NodeModelParadigm node = null;
	double x = -1, y = -1;
  if(nodes.length == 1) {
  	node = nodes[0];
  	if(node.getNodeType().equals(DummyParadigm.DUMMY_PARADIGM)) {
  		Rectangle rec = graphImg.getRectangleForVertex(nodes[0]);
  		if(rec != null) {
  	  	x = rec.getMinX();
  	  	y = rec.getMinY();
  	  }
  	}else {
  		node = null;
  	}
  }
	
	TransactionParadigm[] transactionAlerts = new TransactionParadigm[1];
	transactionAlerts[0] = builder.getTransactionParadigm();
	boolean isOnline = false;
	boolean isNew = builder.getTransactionParadigm().getId() == null || builder.getTransactionParadigm().getId().trim().length() == 0;
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="CACHE-CONTROL" content="NO-CACHE">
<meta http-equiv="PRAGMA" content="NO-CACHE">
<meta http-equiv="EXPIRES" content=0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicAdminUI.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/transactionAdmin.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />

<script>
	var baseDirectory = '<%=BASE_DIRECTORY %>';
	var routineUploadPath = '<%="conf/ui/" + LogicVertexView.ROUTINE_RUNTIME_IMG_DIR%>';
	var routineHttpPath = '<%=LogicVertexView.ROUTINE_RUNTIME_IMG_DIR%>';
</script>

<script src="transaction.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>logic/scripts/logicAdminUI.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/help/help.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js" type="text/javascript"></script>

<%!
  static String buildLogicImage(UIProperty property){
    if (property == null){
      return "null";
    }
    
    return "new LogicImage('" + property.getId() + "','" + property.getName() + "','" + BASE_DIRECTORY + property.getValue() + "');";
  }
%>

<script>
var globalImages = new Array();
var defRoutineRuntimeImg = <%=buildLogicImage(defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_KEY) : null)%>
var defRoutineRuntimeErrorImg = <%=buildLogicImage(defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_ERROR_KEY) : null)%>
var defDummyRoutineImg = <%=buildLogicImage(defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.DUMMY_ROUTINE_KEY) : null)%>

<%
  for (int i = 0; i < imagesProperties.length; i++){
  	builder.addImageProperty(imagesProperties[i]);
  %>
    globalImages[globalImages.length] = <%=buildLogicImage(imagesProperties[i])%>
  <%}
%>

function init(){    
  updateTableHeight();
  updateImageWidth();
  <%
  if(node != null && x != -1 && y != -1) {
  %>
  	handleCurrentNode('dummy', '<%=node.getId() %>');
  	doShowNodeMenuImage(<%=x %>, <%=y %>);
  <%
	}
  %>
  
}

</script>
</head>

<body id="body" style="margin: 0; padding: 0; border-width: 0;overflow-y:auto" onLoad="init()" onScroll="javascript:hideNodeMenuImageDiv();hideNodeData();">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
	<input type="hidden" id="TranId" name="TranId" value="<%=builder.getTransactionParadigm().getId() %>"> 
	<input type="hidden" id="OP" name="OP" value="Update">
	<input type="hidden" id="edgeIndex" name="edgeIndex" value="">
	<input type="hidden" id="isEdit" name="isEdit" value="<%=!isView %>">
	<input type="hidden" id="doUpdate" name="doUpdate" value="false">
	<input type="hidden" id="checkTopology" name="checkTopology" value="true">
	
<div id="nodeDataDiv" class="TREE_NODE_CLASS" style="position:absolute; display:none;" onMouseOver="javascript:onMouseOverNodeData()" onMouseOut="javascript:onMouseOutNodeData()">
</div>

<div id="nodeMenuImageDiv" style="position:absolute; display:none">
<table border="0" width="20" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td class="TOOLTIP_LEFT_TEXT"><img id="nodeMenuImage" src="<%=BASE_DIRECTORY %>logic/images/tranview/openRoutineArrow.gif" onClick="javascript:showNodeMenu()"></td>
	</tr>
</table>
</div>

<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<div id="popupDiv">
</div>
<div id="loadingDiv" style="display:none">
</div>
<div id="dataSourceListWrapperDiv" style="position:absolute; display:none; height:250; width:450; border:1 solid #BBBBBB">
<table border="0" width="450" height="310" cellspacing="0" height="100%" cellpadding="0" bgcolor="#FFFFFF">
	<tr height="30">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Data Source Selection</span>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<div id="treeboxbox_tree" style="position:absolute; display:none; height:250; width:450; overflow-y: scroll; overflow-x: auto"></div>
		</td>
	</tr>
	<tr height="30">
		<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" valign="middle">
			<table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td>
						<a href="javascript:selectDataSource('<%=XpoLogObjectTypes.LOG_TYPE %>', '<%=XpoLogObjectTypes.FILTER_TYPE %>', <%=isView %>);closeDataSourceSelction()" class="BODY_ACTION_LINK">OK</a>
					</td>
					<td width="10" style="font-size:2pt">&nbsp;</td>
					<td>
						<a href="javascript:closeDataSourceSelction()" class="BODY_ACTION_LINK">Close Window</a>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</div>
<div id="transactionNameDiv" style="position:absolute; visibility:hidden; height:100; width:300">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
		<tr height="20">
			<td align="center"  style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
		  	<span class="PROCESSING_HEADER">Transaction Name Missing</span>
	    </td>
    </tr>
    <tr height="30">
    	<td class="PROCESSING_TEXT" align="center">Please specify the name of the transaction:</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center">
    		<input type="text" id="tranNameFromDiv" name="tranNameFromDiv" size="23" class="" class="TRANSACTION_TEXTBOX">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="30">
			<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" valign="middle">
				<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td>
							<a href="javascript:continueSave()" class="BODY_ACTION_LINK">Continue</a>
						</td>
						<td width="10" style="font-size:2pt">&nbsp;</td>
						<td>
							<a href="javascript:cancelSave('transactionNameDiv')" class="BODY_ACTION_LINK">Cancel</a>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	 </table>
</div>
<div id="validateNodesDiv" style="position:absolute; visibility:hidden; height:100; width:500; z-index:100">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
		<tr height="20">
			<td align="center"  style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
		  	<span class="PROCESSING_HEADER">Transaction Validation Failed</span>
	    </td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" style="padding-left:10">The following problems are preventing the transaction from being saved:</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="30">
    	<td id="validateNodesErrorTd" style="padding-left:10">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="30">
			<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" valign="middle">
				<div id="validationNoContinueButtonsDiv" style="display:none">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td>
								<a href="javascript:cancelSave('validateNodesDiv');" class="BODY_ACTION_LINK">OK</a>
							</td>
						</tr>
					</table>
				</div>
				<div id="validationContinueButtonsDiv" style="display:none">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td>
								<a href="javascript:continueSave('false')" class="BODY_ACTION_LINK">Continue</a>
							</td>
							<td width="10" style="font-size:2pt">&nbsp;</td>
							<td>
								<a href="javascript:cancelSave('validateNodesDiv')" class="BODY_ACTION_LINK">Cancel</a>
							</td>
						</tr>
					</table>
				</div>
			</td>
		</tr>
	 </table>
</div>
<div id="messagesDiv" style="position:absolute; visibility:hidden; height:100; width:500; z-index:100">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
		<tr height="20">
			<td align="center"  style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
		  	<span class="PROCESSING_HEADER">Transaction Error Occured</span>
	    </td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" style="padding-left:10">The following errors occured:</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="30">
    	<td id="messagesErrorTd" style="padding-left:10" class="PROCESSING_TEXT">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center"></td>
    </tr>
    <tr height="30">
			<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" valign="middle">
				<div id="messagesNoContinueButtonsDiv">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td>
								<a href="javascript:cancelSave('messagesDiv');" class="BODY_ACTION_LINK">OK</a>
							</td>
						</tr>
					</table>
				</div>
			</td>
		</tr>
	 </table>
</div>
<map id="graphMap" name="graphMap">
	<%=mappingStr%>
</map>
<map id="subTransactionMap" name="subTransactionMap" onMouseOver="javascript:isMouseOverNodeData=true;" onMouseOut="javascript:isMouseOverNodeData=false;">
</map>

<table border="0" width="100%" cellspacing="0"  cellpadding="0" height="100%" cellpadding="0">
	<tr valign="top">
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr valign="top" height="20">
				<td width="100%">
				<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
					<tr bgcolor="#6E6D6C">
						<td width="3%"></td>
						<td><span class="HEADER">Transaction Admin</span></td>
					</tr>
				</table>
				</td>
			</tr>
			<tr valign="top" height="15">
				<td width="100%">
					<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
						<tr bgcolor="#000000">
							<td width="3%" style="font-size:2pt">&nbsp;</td>
							<td width="*" style="font-size:2pt">&nbsp;</td>
							<td id="transactionVisualViewTabImage" style="width:109px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/transactionTabSelected.gif); background-repeat:no-repeat;" valign="bottom" align="center" onClick="javascript:showTransactionTab(0)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span class="TRANSACTION_TAB_TEXT">Visual View</span></td>
							<td id="transactionPreferencesTabImage" style="width:109px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/transactionTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showTransactionTab(1)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span class="TRANSACTION_TAB_TEXT">Preferences</span></td>
							<td width="10">&nbsp;</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr valign="top" height="15">
				<td id="transactionHeader" width="100%">
					<jsp:include page="transactionHeader.jsp" flush="true">
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="isView" value="<%=isViewStr%>" />
					</jsp:include>
				</td>
			</tr>
			<tr valign="top" height="220">
				<td width="100%">
				<div id="processingDiv" style="position:absolute; visibility:hidden; height:80; width:200">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
						<tr height="10">
							<td align="center"  style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
						  	<span class="PROCESSING_HEADER">Status</span>
					    </td>
				    </tr>
				    <tr height="*">
				    	<td class="PROCESSING_TEXT" align="center">Processing...</td>
				    </tr>											
					 </table>
				</div> 
				<div id="transactionVisualViewDiv">
					<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%" height="100">
						<tr valign="top" bgcolor="#E1E1E1">
							<td width="100%">
								<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
									<tr>
										<td>
										<div id="transactionVisualViewInnerDiv" style="overflow-x: scroll; overflow-y:none" onScroll="javascript:hideNodeMenuImageDiv();hideNodeData();">
											<table id="transactionVisualViewInnerTable" border="0" cellspacing="0" cellpadding="0" width="100%">
												<tr>
													<td colspan="5" valign="middle" style="padding-left:2" bgcolor="#FFFFFF">
														<div id="graphImageDiv">
															<img id="graphImage" src="<%=BASE_DIRECTORY + (imageDescriptor.getImageGraphURL().startsWith("/") ? imageDescriptor.getImageGraphURL().substring(1) : imageDescriptor.getImageGraphURL())  %>" USEMAP="#graphMap" border="0">
														</div>
													</td>
												</tr>
											</table>
										</div>
										</td>
									</tr>	
								  <tr>
										<td>
											<table  border="0" cellspacing="0" cellpadding="0"  width="100%">
											  <tr bgcolor="#E4E4E4" style="" height="5" valign="top">
													<td height="6" style="padding-left:5;padding-top:2;padding-bottom:2;border-bottom:1 solid #000000;font-size:1pt" valign="center" width="10" >
														<img border="0" src="<%=BASE_DIRECTORY%>logic/images/tranview/makeGroup.gif">
													</td>
													<td style="padding-left:5;padding-bottom:4;border-bottom:1 solid #000000;padding-top:0" height="10" width="100" valign="top">
														<a href="javascript:createGroupFromSelected('false')" class="BODY_ACTION_LINK" style="padding:0" ><nobr>Create group from selected nodes</nobr></a>
													</td>
													<td width="*" style="font-size:5pt;border-bottom:1 solid #000000">&nbsp;</td>
													<td  height="10" style="padding-top:4;padding-right:0;font-size:1pt;width:20" align="center" valign="bottom" width="20" >
														<img border="0" src="<%=BASE_DIRECTORY%>logic/images/tranview/fullList.gif">
													</td>
													<td width="100" style="font-size:5pt;border-bottom:1 solid #000000">&nbsp;</td>
												</tr>
											</table>
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</div>
				<div id="transactionPreferencesDiv" style="display:none">
					<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr height="15">
							<td width="3%">&nbsp;</td>
							<td colspan="6">&nbsp;</td>
						</tr>
						<tr>
							<td width="3%">&nbsp;</td>
							<td width="30"><nobr><a id="preferencesGeneralLink" class="PREFERENCES_LINK_SELECTED" href="javascript:showPreferencesTab(0)">General</a></nobr></td>
							<td width="15">&nbsp;</td>
							<td width="30"><nobr><a id="preferencesApplicationNameLink" class="PREFERENCES_LINK" href="javascript:showPreferencesTab(1)">Application Name</a></nobr></td>
							<td width="15">&nbsp;</td>
							<td width="30"><nobr><a id="preferencesAdvancedLink" class="PREFERENCES_LINK" href="javascript:showPreferencesTab(2)">Advanced</a></nobr></td>
							<td>&nbsp;</td>
						</tr>
						<tr height="10">
							<td width="3%">&nbsp;</td>
							<td colspan="6">&nbsp;</td>
						</tr>
					</table>
					<div id="transactionPreferencesGeneralDiv">
						<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr valign="top" height="250">
								<td width="3%">&nbsp;</td>
								<td>
									<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
										<tr>
											<td width="15%" nowrap><span class="TRANSACTION_REGULAR_TEXT">Name</span></td>
											<td width="33%"><input type="text" id="tranName" name="tranName" size="23" value="<%=builder.getTransactionParadigm().getName() == null ? "" : builder.getTransactionParadigm().getName() %>" class="TRANSACTION_TEXTBOX"></td>
											<td width="34%"></td>
										</tr>
										<tr>
											<td width="15%" nowrap><span class="TRANSACTION_REGULAR_TEXT">Description</span></td>
											<td width="33%"><input type="text" id="tranDesc" name="tranDesc" size="50" value="<%=builder.getTransactionParadigm().getDescription()%>" class="TRANSACTION_TEXTBOX"></td>
											<td width="34%"></td>
										</tr>
										<tr>
											<td width="15%" nowrap><span class="TRANSACTION_REGULAR_TEXT">Normal life cycle period</span></td>
											<%
												long lifeCycle = UITransactionParadigmHelper.getWarnLifeCycle(builder.getTransactionParadigm());
												long timeUnit = UITransactionParadigmHelper.calculateTimeUnit(lifeCycle);
												String lifeCycleStr = timeUnit == -1 ? "" : String.valueOf(lifeCycle / timeUnit);
											%>
											<td width="33%">
												<input type="text" id="tranLifeCycle" name="tranLifeCycle" size="5" value="<%=lifeCycleStr%>" class="TRANSACTION_TEXTBOX">
												<span CLASS="TRANSACTION_REGULAR_TEXT">
												<select size="1" CLASS="TRANSACTION_TEXTBOX" id="lifeCycleTimeUnit" name="lifeCycleTimeUnit">
													<option value="<%=UITransactionParadigmHelper.MILLISECOND%>" <%=timeUnit == UITransactionParadigmHelper.MILLISECOND? "selected" : "" %>>milliseconds</option>
													<option value="<%=UITransactionParadigmHelper.SECOND%>" <%=timeUnit == UITransactionParadigmHelper.SECOND? "selected" : "" %>>seconds</option>
													<option value="<%=UITransactionParadigmHelper.MINUTE%>" <%=timeUnit == UITransactionParadigmHelper.MINUTE? "selected" : "" %>>minutes</option>
													<option value="<%=UITransactionParadigmHelper.HOUR%>" <%=timeUnit == UITransactionParadigmHelper.HOUR? "selected" : "" %>>hours</option>
													<option value="<%=UITransactionParadigmHelper.DAY%>" <%=timeUnit == UITransactionParadigmHelper.DAY? "selected" : "" %>>days</option>
												</select>
												</span>
											</td>
											<td width="34%"></td>
										</tr>
										<tr>
											<td width="15%" nowrap><span class="TRANSACTION_REGULAR_TEXT">Online period</span></td>
											<%
												long onLineLifeCycle = UITransactionParadigmHelper.getLifeCycle(builder.getTransactionParadigm());
												if (onLineLifeCycle == -1) {
													onLineLifeCycle = 1 * UITransactionParadigmHelper.DAY;
												}
												long onlineTimeUnit = UITransactionParadigmHelper.calculateTimeUnit(onLineLifeCycle);
												String onlineLifeCycleStr = onlineTimeUnit == -1 ? "" : String.valueOf(onLineLifeCycle / onlineTimeUnit);
											%>
											<td width="33%"><input type="text" id="tranOnlineLifeCycle" name="tranOnlineLifeCycle" size="5" value="<%=onlineLifeCycleStr%>" class="TRANSACTION_TEXTBOX">
											<span CLASS="TRANSACTION_REGULAR_TEXT"> 
											<select size="1" CLASS="TRANSACTION_TEXTBOX" id="onlineLifeCycleTimeUnit" name="onlineLifeCycleTimeUnit">
												<option value="<%=UITransactionParadigmHelper.MILLISECOND%>" <%=timeUnit == UITransactionParadigmHelper.MILLISECOND? "selected" : "" %>>milliseconds</option>
												<option value="<%=UITransactionParadigmHelper.SECOND%>" <%=onlineTimeUnit == UITransactionParadigmHelper.SECOND? "selected" : "" %>>seconds</option>
												<option value="<%=UITransactionParadigmHelper.MINUTE%>" <%=onlineTimeUnit == UITransactionParadigmHelper.MINUTE? "selected" : "" %>>minutes</option>
												<option value="<%=UITransactionParadigmHelper.HOUR%>" <%=onlineTimeUnit == UITransactionParadigmHelper.HOUR? "selected" : "" %>>hours</option>
												<option value="<%=UITransactionParadigmHelper.DAY%>" <%=onlineTimeUnit == UITransactionParadigmHelper.DAY? "selected" : "" %>>days</option>
											</select>
											</span>
											</td>
											<td width="34%"></td>
										</tr>
									</table>
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td>
									<hr size="1" color="#ABC1C7">
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
						</table>
					</div>
					<div id="transactionPreferencesApplicationNameDiv" style="display:none">
						<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr valign="top" height="250">
								<td width="3%">&nbsp;</td>
								<td>
									<jsp:include page="appName.jsp" flush="true" />
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td>
									<hr size="1" color="#ABC1C7">
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
						</table>
					</div>
					<div id="transactionPreferencesAdvancedNameDiv" style="display:none">
						<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr valign="top" height="250">
								<td width="3%">&nbsp;</td>
								<td>
									<jsp:include page="tranAdvanced.jsp" flush="true" />
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td>
									<hr size="1" color="#ABC1C7">
								</td>
								<td width="3%">&nbsp;</td>
							</tr>
						</table>
					</div>
				</td>
			</tr>
			<tr valign="top">
				<td width="100%">
					<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
						<tr>
							<td>
							<div id="nodesDiv" style="height:300">
								<jsp:include page="transactionGlobalView.jsp" flush="true">
									<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>" />
									<jsp:param name="isView" value="<%=isView %>" />
								</jsp:include>
							</div>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr valign="top" height="15" bgcolor="#7A7A7A">
				<td width="100%" style="font-size:2pt">
				
				&nbsp;</td>
			</tr>
		</table>
		</td>
	</tr>
</table>

</form>

<%@ include file="images.jsp"%>

<form AUTOCOMPLETE="OFF" name="addFilter" action="<%=BASE_DIRECTORY%>logic/online/filters/TransactionFilter.jsp" target="filtersWindow">
	<input type="hidden" id="trans_paradigm_id" name="trans_paradigm_id" value=<%=ds_id%>>
	<input type="hidden" id="routine_id" name="routine_id">
	<input type="hidden" id="ds_id" name="ds_id">
	<input type="hidden" id="elem_id" name="elem_id">
	<input type="hidden" id="filter_collection_id" name="filter_collection_id">
	<input type="hidden" id="new_window" name="new_window" value="y">
</form>
</body>