<%@ page language="java" %>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>

<%@ include file="getNodesData.jsp"%>

<%
  String id = request.getParameter("id");
	String filterId = request.getParameter("filterId");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	if (id == null || id.length() == 0){
	  return;
	}
	String logid = id;
	int index = id.indexOf("$");
	String nodeid = null;
	if (index >= 0){
	  nodeid = id.substring(0,index);
	  if (nodeid.length() == 0 || nodeid.equals("localhost")){
	    nodeid = null; 
	  }
	  logid = id.substring(index + 1);
	}
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){		
	  return;
	}
	String routineId = request.getParameter("routineId");
	if (routineId == null || routineId.length() == 0){
	  return;
	}
	
	XpoLogAtomicParadigm atomicParadigm = builder.getAtomicByRoutineId(routineId);
	if (atomicParadigm == null){
	  return;
	}
	XplgDataSource xds = builder.getDataSourceByRoutineId(routineId);
	
	xds.setNodeId(nodeid);
	
	String previousLbmId = xds.getLbmId();
	if(previousLbmId != null) {
		boolean selectionHasChanged = !previousLbmId.equals(logid);
		if(selectionHasChanged) {
			builder.removeFunctionEdgesByRoutine(routineId);
			builder.removeRoutineFilters(routineId);
		}
	}
	
	xds.setLbmId(logid);
	if(filterId != null && filterId.length() > 0) {
		xds.setFilterId(filterId);
	}
		
 	LogBrowsingManager lbm = null;
  try {
    lbm = xds.createLogBrowsingManager();
  }catch (Exception e){
    e.printStackTrace();
  }
  if (lbm == null){
  	response.setContentType("text/xml");
%>
<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeNodeAttributesElement" value="false"/>
	<jsp:param name="nodeId" value="<%=routineId %>"/>
	<jsp:param name="nodeType" value="routine"/>
	<jsp:param name="showNodeMenuImage" value="false"/>
	<jsp:param name="includeDataSourceElement" value="true"/>
	<jsp:param name="isError" value="true"/>
</jsp:include>
<%
  }else {
	  atomicParadigm.setDataSourceId(logid);
		atomicParadigm.setLbm(lbm);
		atomicParadigm.setName(lbm.getName());
		xds.setName(lbm.getName());
		String [] names = UITransactionParadigmHelper.getColumnNames(lbm.getRecordMask());
		
		List filtersList = lbm.getFilterManager().getFilterCollections();
		
		FilterCollection[] managerFilters = null;//UITransactionParadigmHelper.getDataFiltersForAtomic(ds_id,true,true);
		if (managerFilters == null) {
			managerFilters = new FilterCollection[0];
		}
		HashMap fMap = null;//builder.getDataSourceFilters(ds_id);
		Collection fc = (fMap != null) ? fMap.values() : null;
		FilterCollection[] builderFilters = new FilterCollection[0];
		if (fc != null){
			builderFilters = (FilterCollection[])fc.toArray(new FilterCollection[fc.size()]);
		}
		FilterCollection[] filters = new FilterCollection[managerFilters.length+builderFilters.length];
	  System.arraycopy(managerFilters,0,filters,0,managerFilters.length);
	  System.arraycopy(builderFilters,0,filters,managerFilters.length,builderFilters.length);
	  
	  String namesArr = "";
	   for (int i = 0; i < names.length; i++) {
	  	namesArr += (names[i] + ",");
	  }
	  namesArr = namesArr.substring(0, namesArr.length() - 1);
	  
	  String filtersNamesArr = "", filtersIdsArr = "";
	  filtersNamesArr += "None,";
	  filtersIdsArr += ",";
	  if (filtersList != null){ 
	  	for (int i = 0; i < filtersList.size(); i++) {
			  FilterCollection col = (FilterCollection)filtersList.get(i);
			  filtersNamesArr += (col.getName() + ",");
			  filtersIdsArr += (col.getId() + ",");
	  	}
	  }
	  filtersNamesArr = filtersNamesArr.substring(0, filtersNamesArr.length() - 1);
	  filtersIdsArr = filtersIdsArr.substring(0, filtersIdsArr.length() - 1);
	  
	  String dataFiltersArr = "";
	  dataFiltersArr += "No Filter,";
	  if (filters != null){ 
	  	for (int i = 0; i < filters.length; i++) {
	  		dataFiltersArr += (filters[i].getName() + ",");
	    }
	  }
	  dataFiltersArr = dataFiltersArr.substring(0, dataFiltersArr.length() - 1);
	  
		getTransactionData(request, builder, null);
		
		NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
	  getNodesData(request, builder, transactionNodes, null);
	  
	  response.setContentType("text/xml");
%>
<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeNodeAttributesElement" value="true"/>
	<jsp:param name="nodeId" value="<%=routineId %>"/>
	<jsp:param name="nodeType" value="routine"/>
	<jsp:param name="showNodeMenuImage" value="false"/>
	<jsp:param name="includeDataSourceElement" value="true"/>
	<jsp:param name="dsid" value="<%=logid %>"/>
	<jsp:param name="dsname" value="<%=lbm.getName() %>"/>
	<jsp:param name="names" value="<%=namesArr %>"/>
	<jsp:param name="filtersNames" value="<%=filtersNamesArr %>"/>
	<jsp:param name="filtersIds" value="<%=filtersIdsArr %>"/>
	<jsp:param name="dataFilters" value="<%=dataFiltersArr %>"/>
</jsp:include>
<%
  }
%>