<%@ page import="java.io.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";
	
	ErrorModel errmodel = new ErrorModel();
	
	String propertyType = UIConstants.IMAGES_TYPE;
	String propertyId = request.getParameter("propertyId");
	String propertyName = request.getParameter("propertyName");
	String propertyValue = request.getParameter("propertyValue");
	String archFile = request.getParameter("archivePath");
	String targetPath = request.getParameter("targetPath");
	if (targetPath == null || targetPath.length() == 0){
		targetPath = UILogicAdminHelper.IMAGES_CUSTOM_PATH;
	}else{
		targetPath = Configuration.XPOLOG_ROOT_PATH + targetPath;
	}
	String httpPath = request.getParameter("httpPath");
	if (httpPath == null || httpPath.length() == 0){
		httpPath = UILogicAdminHelper.IMAGES_CUSTOM_HTTP_PATH;
	}
	String routineId = request.getParameter("routineId");
	String imageType = request.getParameter("imageType");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");

	
	if(propertyName == null || propertyName.trim().equals("")){
      errmodel.addError("No Qproperty name was supplied.");
    }
    
    if(propertyValue == null || propertyValue.trim().equals("")){
      errmodel.addError("No image was supplied.");
    }
    
	
	if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect(BASE_DIRECTORY  + "common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
      return;
    }
    
    boolean isNew = false;
    UIProperty property = UIPreferences.getInstance().getGlobalProperties().getProperty(propertyType,propertyId);
    if (property == null){     
      isNew = true;
    }
    property = new UIProperty();
    property.setKey(imageType);
    property.setType(UIConstants.IMAGES_TYPE);
    property.setGroupType(UIConstants.GLOBAL_GROUP_TYPE);
    property.setName(propertyName);
    property.setValue(httpPath + propertyValue);
    if (!isNew){
      property.setId(propertyId);
    }
    
    File arch = null;
    if (archFile != null && archFile.trim().length() > 0){
      arch = new File(archFile);
    }
    UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
    RoutineParadigm routine = builder.getRoutineById(routineId);
    try {
      if (arch != null){
        File targetDir = new File(targetPath + propertyValue);        
 	      arch = UploadHelper.putUploadFileOnServer(request,arch,targetDir.getParentFile().getAbsolutePath(),targetDir.getName());
      }
      if (isNew){
        UIPreferences.getInstance().insertGlobalProperties(property);
      }else {
        UIPreferences.getInstance().updateGlobalProperties(property);
      }
      propertyId = property.getId();
      propertyName = property.getName();
      propertyValue = property.getValue();
      UIProperties properties = (UIProperties)routine.getUIObject();
      if (properties == null){
      	properties = new UIProperties();
      	routine.setUIObject(properties);
      }
      UIProperty prop = UITransactionParadigmHelper.addGlobalProperty(properties,UIConstants.IMAGES_TYPE,propertyId,imageType,UIConstants.ROUTINE_GROUP_TYPE);
      if (prop != null){
      	builder.addImageProperty(prop);
      }
      
     
    }catch (Exception e){
      String error = "Saving image property failed from the following reason: ";
      error += e.getMessage();	  
	    errmodel.addError(error);
    }
    if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
      return;
    }
    
	//      audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
         			userContext, AuditConstants.CHANGE, "add/edit image property", AuditConstants.CONFIGURATION, "add/edit image property");
%>