<%@ page language="java" %>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="xpolog.logic.alert.engine.*"%>
<%@ page import="xpolog.logic.alert.engine.actions.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.common.DummyParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.functions.transform.TableModelTransformFunction"%>
<%@ page import="xpolog.logic.functions.transform.TransactionTableModelTransformFunction"%>
<%@ page import="xpolog.logic.functions.NodeFunctionEdge"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
 
<%!	  
	void validateNodesData(UITransactionParadigmBuilder builder, NodeModelParadigm[] nodes, ErrorModel errmodel) {
		NodeModelParadigm node = null;
	  TransactionParadigm subTransaction = null;
	  RoutineParadigm routine = null;
	  
	  for (int i = 0; i < nodes.length; i++) {
	    node = nodes[i];
	    if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
	    	subTransaction = (TransactionParadigm)node;
	    	validateSubTransactionData(builder, subTransaction, errmodel);
	    }else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
	    	routine = (RoutineParadigm)node;
	    	validateRoutineData(builder, routine, errmodel);
	    }else if(node.getNodeType().equals(DummyParadigm.DUMMY_PARADIGM)) {
	    	String groupName = "";
	    	TransactionParadigm parent = builder.getTransactionById(node.getTransactionParadigmId());
	    	if(parent != null && parent.getTransactionType() == TransactionParadigm.SUB_TRANSACTION_TYPE) {
	    		groupName = " (inside " + parent.getName() + ") ";
	    	}
	    	errmodel.addError("Node " + node.getName() + groupName + " was not set as a group or a routine");
	    }
		}
	  
	  validateFunctionsData(builder, nodes, errmodel);
	}
	
	void validateSubTransactionData(UITransactionParadigmBuilder builder, TransactionParadigm subTransaction, ErrorModel errmodel) {
		if(errmodel != null && subTransaction.getName() == null || subTransaction.getName().length() == 0) {
			errmodel.addError("Group name was not specified");
		}
		
		List edges = builder.getTransactionGraph().outgoingEdgesOf(subTransaction);
		validateEdgesData(builder, edges, errmodel);
	}
	
	void validateRoutineData(UITransactionParadigmBuilder builder, RoutineParadigm routine, ErrorModel errmodel) {
		if(errmodel != null && routine.getName() == null || routine.getName().length() == 0) {
			errmodel.addError("Routine name was not specified");
		}
		XplgDataSource dataSource = builder.getDataSourceByRoutineId(routine.getId());
		if(errmodel != null && dataSource != null && dataSource.getLbmId() == null) {
			errmodel.addError("No data source was selected for routine " + routine.getName());
		}else {
			XpoLogAtomicParadigm atomic = builder.getAtomicByRoutineId(routine.getId());
			if(errmodel != null && atomic != null && atomic.getLbm() == null) {
				errmodel.addError("No data source was selected for routine " + routine.getName());
			}
		}
		
		List edges = builder.getTransactionGraph().outgoingEdgesOf(routine);
		validateEdgesData(builder, edges, errmodel);
	}
	
	void validateEdgesData(UITransactionParadigmBuilder builder, List edges, ErrorModel errmodel) {
		NodesEdgeParadigm edge = null;
		for(int i = 0; i < edges.size(); i++) {
			edge = (NodesEdgeParadigm)edges.get(i);
			if(edge instanceof InnerEdgeParadigm) {
				if(errmodel != null && edge.getName() == null || edge.getName().length() == 0) {
					errmodel.addError("Connector name (inside " + edge.getSourceParadigm().getName() + ") was not specified");
				}
			}
		}
	}
	
	void validateFunctionsData(UITransactionParadigmBuilder builder, NodeModelParadigm[] nodes, ErrorModel errmodel) {
		HashSet functionNodes = new HashSet();
		NodeModelParadigm node = null;
		NodeFunctionEdge[] functionEdges = null;
		NodeFunctionEdge functionEdge = null;
		
	  for (int i = 0; i < nodes.length; i++) {
	  	node = nodes[i];
	  	functionEdges = node.getIncomingRoutineFunctionEdge();
	  	for(int j = 0; j < functionEdges.length; j++) {
	  		functionEdge = functionEdges[j];
	  		if(functionEdge.getFunction().getType().equals(TransactionTableModelTransformFunction.TRANSACTION_TABLE_TRANSFORM_TYPE)) {
	  			RoutineParadigm routine = builder.getRoutineById(((TransactionTableModelTransformFunction)functionEdge.getFunction()).getTargetRoutineParadigmId());
	  			if(routine != null) {
						functionNodes.add(routine);
	  			}
	  		}else if(functionEdge.getFunction().getType().equals(TableModelTransformFunction.TABLE_TRANSFORM_TYPE)) {
	  			functionNodes.add(functionEdge.getTargetParadigm());
	  		}
	  	}
	  }
	  List firstTransactionNodes = builder.getTransactionFirstNodes();
	  List firstSubTransactionsNodes = getFirstSubTransactionsNodes(builder);
	  for (int i = 0; i < nodes.length; i++) {
	  	if(nodes[i].getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM) && !functionNodes.contains(nodes[i]) && !firstTransactionNodes.contains(nodes[i]) && !firstSubTransactionsNodes.contains(nodes[i])) {
	  		errmodel.addError(nodes[i].getName() + " does not have functions defined");
	  	}
	  }
	}
	
	List getFirstSubTransactionsNodes(UITransactionParadigmBuilder builder) {
		List firstSubTransactionsNodes = new ArrayList();
		NodeModelParadigm[] nodes = builder.getTransactionNodes(true);
		
		for(int i = 0; i < nodes.length; i++) {
			if(nodes[i].getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM) && ((TransactionParadigm)nodes[i]).getTransactionType() == TransactionParadigm.SUB_TRANSACTION_TYPE) {
				firstSubTransactionsNodes.addAll(builder.getTransactionFirstNodes((TransactionParadigm)nodes[i]));
			}
		}

		return firstSubTransactionsNodes;
	}
%>

<%@ include file="getNodesData.jsp"%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String checkTopologyStr = request.getParameter("checkTopology");
	boolean checkTopology = checkTopologyStr != null && checkTopologyStr.equals("true");
	String isEditStr = request.getParameter("isEdit");
	boolean isEdit = isEditStr != null && isEditStr.equals("true");
	
	ErrorModel errmodel = new ErrorModel();
	
	getTransactionData(request, builder, errmodel);
	
	NodeModelParadigm[] nodes = null;
	if(errmodel.getErrorCount() == 0) {
	 	nodes = builder.getTransactionNodes(builder.getRoot());
	  getNodesData(request, builder, nodes, errmodel);
	}

	boolean canContinue = false;
	if(errmodel.getErrorCount() == 0) {
	  nodes = builder.getTransactionNodes(builder.getTransactionParadigm(), true);
	  validateNodesData(builder, nodes, errmodel);
	  if(errmodel.getErrorCount() > 0) {
	  	canContinue = false;
	  }
	}
	
	boolean isNew = builder.getTransactionParadigm().getId() == null || builder.getTransactionParadigm().getId().trim().length() == 0;
	if(errmodel.getErrorCount() == 0 && !isNew && checkTopology) {
		boolean topolgyHasChanged = UITransactionParadigmHelper.topolgyHasChanged(builder, userContext);
		if(topolgyHasChanged) {
			canContinue = topolgyHasChanged;
			errmodel.addError("The topology of the transaction has been changed.<br>&nbsp;&nbsp;&nbsp;&nbsp;If you continue the saving process, old result sets of this transaction<br>&nbsp;&nbsp;&nbsp;&nbsp;will not be available anymore.<br>&nbsp;&nbsp;&nbsp;&nbsp;If you wish to continue accessing old result sets of this transaction you<br>&nbsp;&nbsp;&nbsp;&nbsp;can duplicate the transaction and save the new topology as a new transaction.");
		}
	}
	
	StringBuffer result = new StringBuffer();
	
	result.append("<NodesValidation>");
	if(errmodel.getErrorCount() == 0) {
		result.append("<Status status=\"ok\" canContinue=\"" + canContinue + "\" />");
	}else {
		result.append("<Status status=\"fail\" canContinue=\"" + canContinue + "\" />");
		result.append("<Errors>");
		result.append("<![CDATA[");
		result.append("<table border=0 cellspacing=0 cellpadding=0>");
		String[] errors = errmodel.getErrors();
		for(int i = 0; i < errors.length; i++) {
			result.append("<tr><td class=PROCESSING_TEXT align=left>* " + errors[i] + "</td></tr>");
		}
		result.append("</table>");
		result.append("]]>");
		result.append("</Errors>");
	}
	result.append("</NodesValidation>");
	
	response.setContentType("text/xml");
	out.write(result.toString());
	out.flush();
%>