<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="xpolog.logic.detect.TransactionDetectionHelper"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionManager"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionProcess"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionQuery"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResult"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQuery"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQueryResult"%>
<%@ page import="xpolog.logic.security.LogicPermissionConstants"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImageDescriptor"%>

<%!

	static final String BASE_DIRECTORY = "../../";

%>

<jsp:include flush="true" page="detectionProcessResultsIncluder.jsp"></jsp:include>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
  }
	
	boolean isPermittedWorkspaces = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.WORKSPACES_PERMISSION);
  boolean isPermittedProjects = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.PROJECTS_PERMISSION);
  boolean isPermittedTransactions = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.TRANSACTIONS_PERMISSION);
	boolean hasSavePermissions = isPermittedTransactions;
	boolean hasSaveAndExecutePermissions = isPermittedWorkspaces && isPermittedProjects && isPermittedTransactions;
  
	String refreshSlideStr = request.getParameter("refreshSlide");
	boolean refreshSlide = refreshSlideStr != null && refreshSlideStr.equals("true");
  
  TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
	String processId = (String)session.getAttribute(TransactionDetectionProcess.TRANSACTION_DETECTION_PROCESS_ID);
  TransactionDetectionProcess process = detectionManager.getTransactionDetectionProcessById(processId);

	if (process == null || process.getQuery() == null) {
		response.sendRedirect("newDetectionProcess.jsp");
		return;
	}
	TransactionDetectionQuery query = process.getQuery();

	TransactionDetectionResultQuery resultQuery = (TransactionDetectionResultQuery)session.getAttribute(TransactionDetectionResultQuery.RESULT_QUERY);
	TransactionDetectionResultQueryResult queryResult = (TransactionDetectionResultQueryResult)session.getAttribute(TransactionDetectionResultQueryResult.QUERY_RESULT);
	if(resultQuery == null || queryResult == null) {
		
	}
	
	String actionType = request.getParameter("actionType");
	
	String pagingControls = TransactionDetectionHelper.getPagingControls(queryResult, BASE_DIRECTORY);
	
	long minInstanceTime = TransactionDetectionHelper.getMinInstanceTime(queryResult);
	long maxInstanceTime = TransactionDetectionHelper.getMaxInstanceTime(queryResult);
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="CACHE-CONTROL" content="NO-CACHE">
<meta http-equiv="PRAGMA" content="NO-CACHE">
<meta http-equiv="EXPIRES" content="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/transactionDetection.css" />

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<!-- Date only with year scrolling -->
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/slider.js" type="text/javascript" ></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>logic/detection/detection.js"></script>

<%
if(refreshSlide) {
%>
<script>
	var frm = getFrameByName("treeframe");
	if(frm.frames[0].updateDetectionThresholdsSlidesPage) {
		frm.frames[0].updateDetectionThresholdsSlidesPage();
	}
</script>
<%
}
%>

<script>
	frm = getFrameByName("treeframe");
	if(frm.frames[0].slider[2]) {
		frm.frames[0].slider[2].min = <%=minInstanceTime %>;
		frm.frames[0].slider[2].minVal = <%=minInstanceTime %>;
		frm.frames[0].slider[2].max = <%=maxInstanceTime %>;
		frm.frames[0].slider[2].maxVal = <%=maxInstanceTime %>;
	}
</script>

<script>
  
  function showResults(id, index) {
  	document.getElementById("actionType").value = "show";
  	if(!id) {
  		id = "";
  	}
  	document.getElementById("resultId").value = id;
  	if(!index) {
  		index = "";
  	}
  	document.getElementById("resultIndex").value = index;
  	document.getElementById("access").submit();
  }
  
  function showResultView(index, type, src) {
 		var logsDiv = document.getElementById("result" + index + "LogsDiv");
 		var hostsDiv = document.getElementById("result" + index + "HostsDiv");
 		var resultImage = document.getElementById("result" + index + "Image");
 		
  	if(type == 0) {
  		logsDiv.style.display = "";
  		hostsDiv.style.display = "none";
  	}else if(type == 1) {
  		logsDiv.style.display = "none";
  		hostsDiv.style.display = "";
  	}
 		resultImage.src = src;
  }
	
	function init() {
		<%
		if(actionType == null || !actionType.equals("show")) {
		%>
			showSlide('transactionDetectionThresholds',true);
		<%
		}
		%>
	}

</script>
</head>
<body onLoad="javascript:init()">

<form AUTOCOMPLETE="OFF" id="access" name="access" action="detectionProcessResultsAction.jsp">
	<input type="hidden" name="resultId" id="resultId">
	<input type="hidden" name="resultIndex" id="resultIndex">
	<input type="hidden" name="actionType" id="actionType">
	<input type="hidden" name="minTimeDistanceThreshold" id="minTimeDistanceThreshold" value="<%=resultQuery.getMinTimeDistanceThreshold() %>">
	<input type="hidden" name="maxTimeDistanceThreshold" id="maxTimeDistanceThreshold" value="<%=resultQuery.getMaxTimeDistanceThreshold() %>">
	<input type="hidden" name="minTimeThreshold" id="minTimeThreshold" value="<%=resultQuery.getMinTimeThreshold() %>">
	<input type="hidden" name="maxTimeThreshold" id="maxTimeThreshold" value="<%=resultQuery.getMaxTimeThreshold() %>">
	<input type="hidden" name="minPercentageThreshold" id="minPercentageThreshold" value="<%=resultQuery.getMinPercentageThreshold() %>">
	<input type="hidden" name="maxPercentageThreshold" id="maxPercentageThreshold" value="<%=resultQuery.getMaxPercentageThreshold() %>">
	<input type="hidden" name="idFilter" id="idFilter" value="<%=resultQuery.getIdfilter() == null ? "" : resultQuery.getIdfilter() %>">
	<input type="hidden" name="pagingActionType" id="pagingActionType">
	<input type="hidden" name="pageNumber" id="pageNumber">
	
	<input type="hidden" name="processId" id="processId" value="<%=process.getProcessId() %>">
	<input type="hidden" name="processName" id="processName" value="<%=process.getProcessName() %>">

	<input type="hidden" name="execute" id="execute">
	<input type="hidden" name="workspaceId" id="workspaceId">
	<input type="hidden" name="workspaceName" id="workspaceName">
	<input type="hidden" name="projectId" id="projectId">
	<input type="hidden" name="projectName" id="projectName">
	<input type="hidden" name="transactionName" id="transactionName">
</form>

<table border="0" width="100%" cellspacing="0"  cellpadding="0" height="100%" cellpadding="0">
	<tr valign="top">
		<td width="100%">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr valign="top" height="20">
					<td width="100%">
					<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr bgcolor="#6E6D6C">
							<td width="3%"></td>
							<td><span class="HEADER">Transaction Detection Results</span></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr valign="top" height="15">
					<td width="100%">
						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
							<tr bgcolor="#000000">
								<td>&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr valign="top" height="15">
					<td id="transactionHeader" width="100%">
						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
							<tr bgcolor="#B1B6CC">
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="*">&nbsp;</td>
								<td width="200" align="center"><a href="detectionGate.jsp" class="HEADER_ACTION_LINK">Transaction Detection Gate</a></td>
								<td width="150" align="center"><a href="newDetectionProcess.jsp" class="HEADER_ACTION_LINK">New Process</a></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr valign="middle" height="20" bgcolor="#DEDEDE">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr>
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="15" style="font-size:2">&nbsp;</td>
								<td width="300" class="DETECTION_HEADER_TEXT" align="left" style="padding-left:5"><!-- Number of transactions detected: <%=queryResult.getNumberOfInstances() %>--></td>
								<td style="font-size:2">&nbsp;</td>
								<td width="150" align="center">
									<div id="processFiltersDivShow">
										<a href="javascript:shownHidediv('processFiltersDiv')" class="REPORT_HEADER_LINK">show process details</a>
									</div>
									<div id="processFiltersDivHide" style="display:none">
										<a href="javascript:shownHidediv('processFiltersDiv')" class="REPORT_HEADER_LINK">hide process details</a>
									</div>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="1">
					<td>
					<div id="processFiltersDiv" style="display:none">
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr height="5"><td style="font-size:2">&nbsp;</td></tr>
							<tr>
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="100" class="INNER_RESULT_TEXT" style="padding-left:5">Process Name:</td>
								<td width="300" class="INNER_RESULT_TEXT" id="processNameTd"><%=process.getProcessName() %>&nbsp;&nbsp;&nbsp;<a href="javascript:editProcessName()" class="REPORT_HEADER_LINK">edit</a></td>
								<td style="font-size:2">&nbsp;</td>
							</tr>
							<tr height="5"><td style="font-size:2">&nbsp;</td></tr>
							<tr>
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="100" class="INNER_RESULT_TEXT" style="padding-left:5">Time Filter:</td>
								<td width="300" class="INNER_RESULT_TEXT"><%=query.getTimeString() %></td>
								<td style="font-size:2">&nbsp;</td>
							</tr>
							<tr height="5"><td style="font-size:2">&nbsp;</td></tr>
							<tr>
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="100" class="INNER_RESULT_TEXT" style="padding-left:5">Search Terms:</td>
								<td width="300" class="INNER_RESULT_TEXT"><%=query.getSearchString() %></td>
								<td style="font-size:2">&nbsp;</td>
							</tr>
						</table>
					</div>
					</td>
				</tr>
				<%
				ArrayList results = queryResult.getPageResults();
				if(results.size() == 0) {
					String message = "";
					if(resultQuery.getIdfilter() == null || resultQuery.getIdfilter().length() == 0) {
						message = "No transactions were detected";
					}else {
						message = "No matching results exist";
					}
				%>
				<tr height="20">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr>
								<td width="3" style="font-size:2">&nbsp;</td>
								<td class="INNER_RESULT_TEXT" style="padding-left:5"><%=message %></td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				}else {
					if(pagingControls != null && pagingControls.length() > 0) {
					%>
					<tr height="20" bgcolor="#EAEBED">
						<td>
							<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
								<tr>
									<td width="3" style="font-size:2">&nbsp;</td>
									<td width="15" style="font-size:2">&nbsp;</td>
									<td width="300">
										<%=pagingControls %>
									</td>
									<td>&nbsp;</td>
							</table>
						</td>
					</tr>
					<%
					}
					TransactionDetectionResult result = null;
					JGraphImageDescriptor logsImageDescriptor = null, hostsImageDescriptor = null;
					String logsImageSrc = null, hostsImageSrc = null;
					int resultIndex = -1;
					
					for(int i = 0; i < results.size(); i++) {
						result = (TransactionDetectionResult)results.get(i);
						logsImageDescriptor = TransactionDetectionHelper.getJGraphImageDescriptor(result, null, true, null, 500, 50, "#FFFFFF");
						if(logsImageDescriptor.getImageGraphURL().startsWith("/")) {
							logsImageSrc = BASE_DIRECTORY + logsImageDescriptor.getImageGraphURL().substring(1);
						}else {
							logsImageSrc = BASE_DIRECTORY + logsImageDescriptor.getImageGraphURL();
						}
						hostsImageDescriptor = TransactionDetectionHelper.getJGraphImageDescriptor(result, query.getLogToHost(), true, null, 500, 50, "#FFFFFF");
						if(hostsImageDescriptor.getImageGraphURL().startsWith("/")) {
							hostsImageSrc = BASE_DIRECTORY + hostsImageDescriptor.getImageGraphURL().substring(1);
						}else {
							hostsImageSrc = BASE_DIRECTORY + hostsImageDescriptor.getImageGraphURL();
						}
						
						resultIndex = (((queryResult.getCurrentPageNumber() - 1) * TransactionDetectionResultQueryResult.RESULTS_PER_PAGE)) + i;
					%>
					<tr valign="top" height="10">
						<td style="padding-top:10">
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
								<tr bgcolor="#797B87" height="25">
									<td width="25" align="center" class="RESULT_HEADER_TEXT"><%=resultIndex + 1 %></td>
									<td width="3" bgcolor="#FFFFFF" style="font-size:0">&nbsp;</td>
									<td width="*">
										<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
											<tr>
												<td width="180" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">Transactions: <%=result.getNumberOfInstances() %> (<%=TransactionDetectionHelper.getPercentageString(result.getTransactionPercentage()) %>)</td>
												<td width="2" bgcolor="#C3C4C9"></td>
												<td width="150" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">Events: <%=result.getNumberOfEvents() %> (<%=TransactionDetectionHelper.getPercentageString(result.getNumberOfEvents(), queryResult.getNumberOfEvents()) %>)</td>
												<td width="2" bgcolor="#C3C4C9"></td>
												<td width="150" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">
													<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
														<tr>
															<td class="RESULT_HEADER_TEXT">Avg. Duration: <%=TransactionDetectionHelper.getTimeString(result.getAverageTime()) %></td>
														</tr>
													</table>
												</td>
												<td width="2" bgcolor="#C3C4C9"></td>
												<td width="120" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">Permutations: <%=result.getChildResults().size() %></td>
												<td width="2" bgcolor="#C3C4C9"></td>
												<td width="65" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">Hosts: <%=result.getNumberOfHosts() %></td>
												<td width="2" bgcolor="#C3C4C9"></td>
												<td width="65" align="left" style="padding-left: 5" class="RESULT_HEADER_TEXT">Logs: <%=result.getNumberOfLogs() %></td>
												<td>&nbsp;</td>
												<td width="168" valign="bottom">
												<div id="result<%=resultIndex %>LogsDiv">
													<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
														<tr height="10"><td style="font-size:2">&nbsp;</td></tr>
														<tr>
															<td style="width:40px;" align="center"><span class="RESULT_HEADER_TEXT">View:</span></td>
															<td style="width:64px; background-image:url(<%=BASE_DIRECTORY %>logic/images/detection/resultTabSelected.gif); background-repeat:no-repeat" align="center"><span class="RESULT_SELECTED_TAB_TEXT">Logs</span></td>
															<td style="width:64px;" align="center" onClick="javascript:showResultView(<%=resultIndex %>, 1, '<%=hostsImageSrc %>')" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span class="RESULT_TAB_TEXT">Hosts</span></td>
														</tr>
													</table>
												</div>
												<div id="result<%=resultIndex %>HostsDiv" style="display:none">
													<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
														<tr height="10"><td style="font-size:2">&nbsp;</td></tr>
														<tr>
															<td style="width:40px;" align="center"><span class="RESULT_HEADER_TEXT">View:</span></td>
															<td style="width:64px;" align="center" onClick="javascript:showResultView(<%=resultIndex %>, 0, '<%=logsImageSrc %>')" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span class="RESULT_TAB_TEXT">Logs</span></td>
															<td style="width:64px; background-image:url(<%=BASE_DIRECTORY %>logic/images/detection/resultTabSelected.gif); background-repeat:no-repeat" align="center"><span class="RESULT_SELECTED_TAB_TEXT">Hosts</span></td>
														</tr>
													</table>
												</div>
												</td>
												<td width="30">&nbsp;</td>
											</tr>
										</table>
									</td>
								</tr>
								<tr height="8">
									<td style="font-size:2">&nbsp;</td>
									<td style="font-size:2">&nbsp;</td>
									<td style="font-size:2" bgcolor="#DEDEDE">&nbsp;</td>
								</tr>
								<tr valign="top" height="10">
									<td style="font-size:2">&nbsp;</td>
									<td style="font-size:2">&nbsp;</td>
									<td style="padding-left:10;">
										<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
											<tr>
												<td width="200">
													<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
														<tr height="5" style="padding-top:3">
															<td class="INNER_RESULT_TEXT">Above Avg.: <%=result.getAboveTimeInstances() %> (<%=TransactionDetectionHelper.getPercentageString(result.getAboveTimeInstances(), result.getNumberOfInstances()) %>)</td>
														</tr>
														<tr height="5" style="padding-top:3">
															<td class="INNER_RESULT_TEXT" style="padding-left:5"><%=TransactionDetectionHelper.getTimeString(result.getMinAboveTime()) %> - <%=TransactionDetectionHelper.getTimeString(result.getMaxAboveTime()) %></td>
														</tr>
														<tr height="5" style="padding-top:3">
															<td style="font-size:2">&nbsp;</td>
														</tr>
														<tr height="5" style="padding-top:3">
															<td class="INNER_RESULT_TEXT">Below Avg.: <%=result.getBelowTimeInstances() %> (<%=TransactionDetectionHelper.getPercentageString(result.getBelowTimeInstances(), result.getNumberOfInstances()) %>)</td>
														</tr>
														<tr height="5" style="padding-top:3">
															<td class="INNER_RESULT_TEXT" style="padding-left:5"><%=TransactionDetectionHelper.getTimeString(result.getMinBelowTime()) %> - <%=TransactionDetectionHelper.getTimeString(result.getMaxBelowTime()) %></td>
														</tr>
														<tr>
															<td>&nbsp;</td>
														</tr>
													</table>
												</td>
												<td><img id="result<%=resultIndex %>Image" src="<%=logsImageSrc  %>" border="0"></td>										
											</tr>
										</table>
									</td>
								</tr>
								<tr>
									<td>&nbsp;</td>
								</tr>
								<tr height="10">
									<td style="font-size:2">&nbsp;</td>
									<td style="font-size:2">&nbsp;</td>
									<td style="font-size:2" bgcolor="#DEDEDE">
										<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
											<tr height="2"><td style="font-size:2" colspan="5">&nbsp;</td></tr>
											<tr>
												<td width="5">&nbsp;</td>
												<%
												if(result.getChildResults().size() > 0) {
												%>
												<td>
													<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
														<tr><td height="5" style="font-size:2" colspan="2">&nbsp;</td></tr>
														<tr>
															<td style="width:112px; background-image:url(<%=BASE_DIRECTORY %>logic/images/detection/permutationsTabClosed.gif); background-repeat:no-repeat" align="center" onClick="javascript:showResults('<%=result.getParadigmString() %>', '<%=resultIndex %>')" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span class="RESULT_SELECTED_TAB_TEXT">Permutations</span></td>
															<td style="font-size:2">&nbsp;</td>
														</tr>
													</table>
												</td>
												<td>&nbsp;</td>
												<%
												}else {
												%>
												<td colspan="2">&nbsp;</td>
												<%
												}
												%>
												<td width="150" align="center">
													<%if(hasSavePermissions) { %>
													<a href="javascript:saveResult('<%=result.getParadigmString() %>')" class="REPORT_HEADER_LINK">Save as transaction</a>
													<%} %>
												</td>
												<td width="250" align="center">
													<%if(hasSaveAndExecutePermissions) { %>
													<a href="javascript:saveAndExecuteResult('<%=result.getParadigmString() %>')" class="REPORT_HEADER_LINK">Save as transaction and execute</a>
													<%} %>
												</td>
											</tr>
											<tr bgcolor="B5B8C1" height="2"><td style="font-size:2" colspan="5">&nbsp;</td></tr>
										</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<%
					}
					if(pagingControls != null && pagingControls.length() > 0) {
					%>
					<tr height="20" bgcolor="#EAEBED">
						<td>
							<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
								<tr>
									<td width="3" style="font-size:2">&nbsp;</td>
									<td width="15" style="font-size:2">&nbsp;</td>
									<td width="300">
										<%=pagingControls %>
									</td>
									<td>&nbsp;</td>
							</table>
						</td>
					</tr>
					<%
					}
				}
				%>
				<tr>
					<td>&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

</body>
</html>