<%@ page import="java.util.Arrays"%>
<%@ page import="java.util.Comparator"%>

<%@ page import="xpolog.logic.ConfigMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.CtrlMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.DataSession"%>
<%@ page import="xpolog.logic.ui.ctrl.Workspace"%>

<%!

static final String BASE_DIRECTORY = "../../";

%>

<%

CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
Workspace[] workspaces = ctrlMgr == null ? null : ctrlMgr.getWorkspaces();
if (workspaces == null){
  workspaces = new Workspace[0];
}
Arrays.sort(workspaces, new Comparator() {
	public int compare(Object o1, Object o2) {
		String w1Name = ((Workspace)o1).getName();
		String w2Name = ((Workspace)o2).getName();
		return w1Name.toLowerCase().compareTo(w2Name.toLowerCase());
	}
});

%>

<script>

var workspaceSessions = new Array();
<%
for(int i = 0; i < workspaces.length; i++) {
	DataSession[] sessions = ctrlMgr == null ? null : ctrlMgr.getDataSessionsByWorkspace(workspaces[i].getId());
	if (sessions == null){
	  sessions = new DataSession[0];
	}
%>
	workspaceSessions[<%=workspaces[i].getId() %>] = new Array();
<%
	for(int j = 0; j < sessions.length; j++) {
%>
	workspaceSessions[<%=workspaces[i].getId() %>][<%=j %>] = "<%=sessions[j].getId() %>#<%=sessions[j].getName() %>";
<%
	}
%>
<%
}
%>

function selectWorkspace() {
	var workspaceId = document.getElementById("wsId").value;
	if(workspaceId == "") {
		clearProjectsList();
		handleProjectElements("true", "false");
	}else if(workspaceId == "-1") {
		clearProjectsList();
		document.getElementById("wsName").disabled = false;
		handleProjectElements("true", "false");
	}else {
		document.getElementById("wsName").value = "";
		document.getElementById("wsName").disabled = true;
		buildProjectsList(workspaceId);
		handleProjectElements("false", "true");
	}
}

function handleProjectElements(disableProjectId, disableProjectName) {
	if(disableProjectId == "true") {
		document.getElementById("pjId").selectedIndex = 0;
		document.getElementById("pjId").disabled = true;
	}else {
		document.getElementById("pjId").disabled = false;
	}
	if(disableProjectName == "true") {
		document.getElementById("pjName").value = "";
		document.getElementById("pjName").disabled = true;
	}else {
		document.getElementById("pjName").disabled = false;
	}
}

function buildProjectsList(workspaceId) {
	var projectId = document.getElementById("pjId");
	
	clearProjectsList();
	
	var newOption;
	var value;
	var index;
	var id, name;
	for(i = 0; i < workspaceSessions[workspaceId].length; i++) {
		value = workspaceSessions[workspaceId][i];
		index = value.indexOf("#");
		id = value.substring(0, index);
		name = value.substring(index + 1);
		newOption = new Option(name, id);
		
		projectId.options[projectId.options.length] = newOption;
	}
	projectId.options[projectId.options.length] = new Option("New Project", "-1");
}

function clearProjectsList() {
	var projectId = document.getElementById("pjId");
	
	for(i = projectId.options.length - 1; i >= 0; i--) {
		projectId.options[i] = null;
	}
}

function selectProject() {
	var projectId = document.getElementById("pjId").value;
	if(projectId == "-1") {
		document.getElementById("pjName").disabled = false;
	}else {
		document.getElementById("pjName").value = "";
		document.getElementById("pjName").disabled = true;
	}
}

</script>

<div id="saveTransactionDiv" style="position:absolute; visibility:hidden; height:100; width:300">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
		<tr>
			<td colspan="2">
			<div id="saveHeaderDiv" style="display:none">
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr height="20">
						<td align="center" colspan="2" style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
					  	<span class="PROCESSING_HEADER">Save as Transaction</span>
				    </td>
			    </tr>
			    <tr height="10">
			    	<td class="PROCESSING_TEXT" align="center" colspan="2"></td>
			    </tr>
				</table>
			</div>
			<div id="saveAndExecuteHeaderDiv" style="display:none;">
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr height="20">
						<td align="center" colspan="2" style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
					  	<span class="PROCESSING_HEADER">Save as Transaction and Execute</span>
				    </td>
			    </tr>
			    <tr height="10">
			    	<td class="PROCESSING_TEXT" align="center" colspan="2"></td>
			    </tr>
			    <tr height="10">
			    	<td class="PROCESSING_TEXT" align="left" style="padding-left:5">Workspace Name:</td>
			    	<td class="PROCESSING_TEXT" align="left">
			    		<select id="wsId" name="wsId" size="1" class="PROCESSING_TEXT" onChange="javascript:selectWorkspace()">
			    			<option value="">Select Workspace</option>
					    	<%
					    	for(int i = 0; i < workspaces.length; i++){
					    	%>
					    	<option value="<%=workspaces[i].getId() %>"><%=workspaces[i].getName() %></option>
					    	<%
					    	}
					    	%>
					    	<option value="-1">New Workwspace</option>
			    	</td>
			    </tr>
			    <tr height="10">
			    	<td>&nbsp;</td>
			    	<td class="PROCESSING_TEXT" align="left">
				    	<input type="text" id="wsName" name="wsName" size="30" class="TRANSACTION_TEXTBOX">
				    </td>
			    </tr>
			    <tr height="10">
			    	<td class="PROCESSING_TEXT" align="left" style="padding-left:5">Project Name:</td>
			    	<td class="PROCESSING_TEXT" align="left">
			    		<select id="pjId" name="pjId" size="1" class="PROCESSING_TEXT" onChange="javascript:selectProject()" disabled>
			    	</td>
			    </tr>
			    <tr height="10">
			    	<td>&nbsp;</td>
			    	<td class="PROCESSING_TEXT" align="left">
			    		<input type="text" id="pjName" name="pjName" size="30" class="TRANSACTION_TEXTBOX">
			    	</td>
			    </tr>
				</table>
			</div>
			</td>
		</tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="left" style="padding-left:5">Transaction Name:</td>
    	<td class="PROCESSING_TEXT" align="left">
    		<input type="text" id="tranName" name="tranName" size="30" class="TRANSACTION_TEXTBOX">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center" colspan="2"></td>
    </tr>
    <tr height="30">
			<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" colspan="2" valign="middle">
				<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td>
							<a href="javascript:continueSave()" class="BODY_ACTION_LINK">Continue</a>
						</td>
						<td width="10" style="font-size:2pt">&nbsp;</td>
						<td>
							<a href="javascript:cancelSave('saveTransactionDiv')" class="BODY_ACTION_LINK">Cancel</a>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	 </table>
</div>

<div id="editProcessNameDiv" style="position:absolute; visibility:hidden; height:100; width:400">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
		<tr>
			<td colspan="2">
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr height="20">
						<td align="center" colspan="2" style="border-bottom:solid 1px #000000" bgcolor="#B1B6CC">
					  	<span class="PROCESSING_HEADER">Edit Process Name</span>
				    </td>
			    </tr>
			    <tr height="10">
			    	<td class="PROCESSING_TEXT" align="center" colspan="2"></td>
			    </tr>
				</table>
			</td>
		</tr>
		<tr>
			<td colspan="2" id="editProcessNameErrorTd" style="padding-left:5">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" width="100" align="left" style="padding-left:5">Process Name:</td>
    	<td class="PROCESSING_TEXT" align="left">
    		<input type="text" id="newProcessName" name="newProcessName" size="30" class="TRANSACTION_TEXTBOX">
    	</td>
    </tr>
    <tr height="10">
    	<td class="PROCESSING_TEXT" align="center" colspan="2"></td>
    </tr>
    <tr height="30">
			<td style="border-top:solid 2px #DBDFE2; padding-bottom:2" align="center" colspan="2" valign="middle">
				<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td>
							<a href="javascript:continueEditProcessName()" class="BODY_ACTION_LINK">Save</a>
						</td>
						<td width="10" style="font-size:2pt">&nbsp;</td>
						<td>
							<a href="javascript:cancelSave('editProcessNameDiv')" class="BODY_ACTION_LINK">Cancel</a>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	 </table>
</div>