<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.util.hosts.Host"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="xpolog.logic.detect.TransactionDetectionManager"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionProcess"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQuery"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionQuery"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!

	static final String BASE_DIRECTORY = "../../";
	
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);

%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	
	String RENDERER = "RENDERER";

	String processName = request.getParameter("processName");
	
	if(processName == null || processName.trim().equals("")){
    errmodel.addError("Process name was not specified.");
  }
	if(WebUtil.isContainSpecialCharecter(processName)){
    errmodel.addError("The following charecters are prohibited in the process name field: "+WebUtil.getSpecialCharectersList());
 	}
	
	TransactionDetectionQuery query = new TransactionDetectionQuery();

	RecordMask mask = new RecordMask();
	DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	MaskColumn[] cols = {dateMask};
	mask.setColumns(cols);
	//create the date and number filter
	try {
		DateFilter dfilter = createDateFilter(request, response, mask);
		if (dfilter != null) {
			query.setTimeFilter(dfilter);
			query.setDateFormat(dateFormat);
		}
	}catch (Exception e) {
		errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
		session.setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/detection/detectionGate.jsp&okURL=logic/detection/newDetectionProcess.jsp");
		return;
	}
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	//search terms issues
	List searchList = null;
	String searchVals = request.getParameter("searchTerms");
	if (searchVals != null && searchVals.trim().length() > 0) {
		searchList = new ArrayList();
		String[] arr = searchVals.split(",");
		for (int i = 0; i < arr.length; i++) {
			searchList.add(arr[i]);
		}
		query.setSearchList(searchList);
	}else {
		query.setSearchList(new ArrayList());
	}
	
	String[] selectedValues = null;
	String selectedList = request.getParameter("checkedItems");
	if (selectedList != null && selectedList.length() > 0) {
		selectedValues = selectedList.split(",");
	}
	
	HashSet members = new HashSet();
	
	HashSet hosts = new HashSet();
	HashSet apps = new HashSet();
	HashSet modules = new HashSet();
	HashSet logs = new HashSet();
	
	HashMap logToHost = new HashMap();
	HashMap logToApplication = new HashMap();
	HashMap moduleToHost = new HashMap();
	HashMap applicationToHost = new HashMap();
	
	if(selectedValues == null) {
		errmodel.addError("No logs were selected.");
	}else {
		String currentString = null;
		int hostIndex = -1, appIndex = -1, index = -1;
		String host = null, app = null, type = null, id = null;
		for(int i=0 ; i < selectedValues.length; i++) {
			currentString = selectedValues[i];
			hostIndex = currentString.indexOf("^");
			if(hostIndex == -1) {
				hostIndex = currentString.indexOf("-");
				if(hostIndex == -1) {
					continue;
				}else {
					host = currentString.substring(hostIndex + 1, currentString.length());
					if(host.endsWith("*")) {
						host = host.substring(0, host.length() - 1);
						hosts.add(host);
					}
				}
			}else {
				host = currentString.substring(0, hostIndex);
				if(host.indexOf("-") != -1) {
					host = host.substring(host.indexOf("-") + 1, host.length());
				}
				
				currentString = currentString.substring(hostIndex + 1, currentString.length());
				appIndex = currentString.indexOf("@");
				if(appIndex == -1) {
					appIndex = currentString.indexOf("-");
					if(appIndex == -1) {
						continue;
					}else {
						app = currentString.substring(appIndex + 1, currentString.length());
						if(app.endsWith("*")) {
							app = app.substring(0, app.length() - 1);
							apps.add(app);
						}
						
						applicationToHost.put(app, host);
					}
				}else {
					app = currentString.substring(0, appIndex);
					if(app.indexOf("-") != -1) {
						app = app.substring(app.indexOf("-") + 1, app.length());
					}
					applicationToHost.put(app, host);
					
					currentString = currentString.substring(appIndex + 1, currentString.length());
					index = currentString.indexOf("-");
					if(index != -1) {
						type = currentString.substring(0, index);
						id = currentString.substring(index + 1, currentString.length());
						id = XpologUtil.removeAppFromId(id);
						if (type.equals(XpoLogObjectTypes.MODULE_TYPE)){
							if(id.endsWith("*")) {
								id = id.substring(0, id.length() - 1);
								modules.add(id);
								moduleToHost.put(id, host);
							}
						}else if (type.equals(XpoLogObjectTypes.LOG_TYPE)){
							id = ModuleMemberRenderer.getIdFromUniqueId(id);
							logToHost.put(id, host);
							logToApplication.put(id, app);
							
							logs.add(XpoLogObjectTypes.LOG_TYPE + "-" + id);
						}
					}
				}
			}
		}
		members.addAll(logs);
		
		ModuleMemberRenderer renderer = (ModuleMemberRenderer)session.getAttribute(RENDERER);
		HashMap hostObjs = renderer.getHosts();
		session.setAttribute(RENDERER, null);
		
		if(hosts.size() > 0) {
			// get all applications and logs under each host
			Iterator it = hosts.iterator();
			Host hostObj = null;
			ArrayList logIds = null;
			String logId = null;
			
			while(it.hasNext()) {
				host = (String)it.next();
				hostObj = (Host)hostObjs.get(host);
				logIds = hostObj.getCleanLogIds();
				for(int i = 0; i < logIds.size(); i++) {
					logId = (String)logIds.get(i);
					members.add(XpoLogObjectTypes.LOG_TYPE + "-" + logId);
					logToHost.put(logId, host);
				}
			}
		}
		
		if(modules.size() > 0) {
			// get logs under each module
			String module = null;
			Iterator it = modules.iterator();
			Host hostObj = null;
			
			while(it.hasNext()) {
				HashMap currentModules = new HashMap();
				HashMap currentLogs = new HashMap();
	
				module = (String)it.next();
				host = (String)moduleToHost.get(module);
				
				module = ModuleMemberRenderer.getIdFromUniqueId(module);
				
				ModuleMemberRenderer.addAllModuleChildren(module, currentModules, currentLogs);
				
				hostObj = (Host)hostObjs.get(host);
				if(hostObj != null) {
					Iterator it1 = currentLogs.keySet().iterator();
					while (it1.hasNext()) {
						String logid = (String)it1.next();
						if(hostObj.getCleanLogIds().contains(logid)) {
							members.add(XpoLogObjectTypes.LOG_TYPE + "-" + logid);
							logToHost.put(logid, host);
						}
					}
					it1 = currentModules.keySet().iterator();
					while (it1.hasNext()) {
						String modid = (String)it1.next();
						if(hostObj.getCleanModuleIds().contains(modid)) {
							members.add(XpoLogObjectTypes.MODULE_TYPE + "-" + modid);
						}
					}
				}
			}
		}
	
		if (members.size() == 0) {
			errmodel.addError("No logs were selected.");
		}
	}

	if (errmodel.getErrorCount() > 0) {
		session.setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/detection/detectionGate.jsp&okURL=logic/detection/newDetectionProcess.jsp");
		return;
	}
	
	query.setModuleMembers(members);
	query.setLogToHost(logToHost);
	query.setLogToApplication(logToApplication);
	query.setApplicationToHost(applicationToHost);

	final TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
	final TransactionDetectionProcess process = new TransactionDetectionProcess(query, processName);

	session.setAttribute(TransactionDetectionManager.CURRENT_PROCESS, process.getProcessId());
	
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	final UserContext context = env.getUserContext();
	context.setDateFilter(null);
	session.setAttribute(TransactionDetectionProcess.TRANSACTION_DETECTION_PROCESS_ID, process.getProcessId());

	session.setAttribute(TransactionDetectionResultQuery.RESULT_QUERY, null);

	String stopUrl = "logic/detection/stopDetectionProcess.jsp?processId=" + process.getProcessId();

	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/detection/showDetectionProcess.jsp?processId=" + process.getProcessId() + "&loadProcess=false") {
		public void run(HttpServletRequest request) {
			try {
				Thread.sleep(500);
				detectionManager.startTransactionDetectionProcess(process, context);
			}catch (Exception e) {
				ErrorModel.log.error("Failed to run detection process", e);
			}
		}
	};
	env.setProgressRunner(runner);
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, process.getJobStatus());
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
  <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
  <jsp:param name="message" value="Processing"/>
  <jsp:param name="stopUrl" value="<%=stopUrl%>"/>
  <jsp:param name="redirectStopUrl" value="true"/>
  <jsp:param name="useStatus" value="true"/>
</jsp:include>
