<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.ctrl.DataSession"%>
<%@ page import="xpolog.logic.ui.ctrl.DataSessionRuntime"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@page import="xpolog.eye.site.portal.PortalItem"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  SiteManagment mgmt = SiteManagment.getInstance();
  AddressBook adbook = AddressBook.getInstance();
  Account acc = adbook.getAccountById("xpologicDB");
  if (acc == null){
    response.sendRedirect(BASE_DIRECTORY + "logic/admin/settings/dbSettings.jsp");
    return;
  }
  
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  Module root = mgmt.getModuleFromId("rootModule");
  WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request, response, null, true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
	DataSessionRuntime dsr = new DataSessionRuntime();
	dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	if (!ctrlMgr.persistencyMediumOk()){
		ErrorModel errmod = new ErrorModel();
		errmod.addError("Could not connect to database");
		errmod.addError("Please ensure that the TxExpo database is well configured and running");
		request.getSession().setAttribute(ERROR_OBJ,errmod);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}

	boolean isDemo = XpologLicenseManager.getInstance().isDemo();
  
	boolean isPermittedTransactions = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.TRANSACTIONS_PERMISSION);
  boolean isPermittedWorkspaces = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.WORKSPACES_PERMISSION);
  boolean isPermittedProjects = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.PROJECTS_PERMISSION);
  boolean haveAdministrations = isPermittedTransactions || isPermittedWorkspaces || isPermittedProjects;

  boolean isPermittedViewReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean isPermittedAddReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
  boolean isPermittedReports = isPermittedViewReports || isPermittedAddReports;

  boolean isPermittedDetection = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.TRANSACTION_DETECTION_PERMISSION);
  boolean isPermittedDbSettings = !isDemo &&  securityManager.isHavePermission(userContext,LogicPermissionConstants.SettingsPermissions.DB_SETTINGS_PERMISSION);  
 

  boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
  int daynum = XpologLicenseManager.getInstance().getDaysLeft();
  boolean allowed = false;
  boolean perm = XpologLicenseManager.getInstance().isPermanentLicense();

  boolean secureActive = false;
  String userMessage = "";
  String activeState = "inactive";
  if(userContext != null && userContext.getUser() != null){
    secureActive = true;
    userMessage = "Hello "+userContext.getUser().getUser().getDisplayName();
    activeState = "active";
  }

   boolean isOnline = false;
  boolean enableResetDb = XpoLogicInitiator.getInstance().isEnableResetDb();

  String refreshMenu = request.getParameter("refreshMenu");
  
  ArrayList list = new ArrayList();
  if (isDemo){
  list.add(new PortalItem("Transaction <br>Analysis","logic/online/sessionViewAction.jsp?sessionRuntimeId=4","Transaction Analysis","images/portal/btns/transactions.gif","images/portal/btns/transactions-on.gif"));
  list.add(PortalItem.SEP_ITEM);
  }
  if (!isDemo){
    list.add(new PortalItem("Transaction <br>Monitor","logic/online/sessionViewAction.jsp?sessionRuntimeId=0","Transaction Monitor","images/portal/btns/transactions-monitor.gif","images/portal/btns/transactions-monitor-on.gif"));
    list.add(PortalItem.SEP_ITEM);
  }
  if (isPermittedReports){    
    list.add(new PortalItem("Reports","reports/reportsDefinitionView.jsp","Reports","images/portal/btns/reports.gif","images/portal/btns/reports-on.gif"));
    list.add(PortalItem.SEP_ITEM);
  }
  list.add(new PortalItem("Transaction Detection","logic/detection/detectionGate.jsp","Transaction Detection","images/portal/btns/transactions-detection.gif","images/portal/btns/transactions-detection-on.gif"));
    
  request.setAttribute("mainItems",list);
  
  list = new ArrayList();
  if (valid){
  	if (isPermittedTransactions){
      list.add(new PortalItem("Add Transaction","logic/admin/transaction/addNewTransaction.jsp?OP=ADD&ds_id=","Add Transaction","images/portal/btns/small/add-log.gif","images/portal/btns/small/add-log-on.gif"));
  	}
	if (isPermittedAddReports){  	
 		// list.add(new PortalItem("Generate Report","reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation","Generate Report","images/portal/btns/small/generate-report.gif","images/portal/btns/small/generate-report-on.gif"));
	}
	if (isPermittedDbSettings){
      list.add(new PortalItem("DB Settings","logic/admin/settings/dbSettings.jsp","DB Settings","images/portal/btns/small/add-transaction.gif","images/portal/btns/small/add-transaction-on.gif"));
	}
  
    request.setAttribute("adminItems",list);
  
    list = new ArrayList();
    if (isPermittedWorkspaces){
      list.add(new PortalItem("Add Workspace","logic/admin/workspace/workspaceDefinition.jsp","Add Workspace"));
    }
    request.setAttribute("linksItems",list);
  }
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
</HEAD>
<BODY style="margin: 0; padding: 0; border-width: 0">
<jsp:include page="../portal//portal.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="title" value="TxExpo" />
</jsp:include>
</BODY>
</HTML>