<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.transaction.data.Transaction"%>

<%@ page import="java.text.DecimalFormat"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  
  UserSecurity user = manager.getUserSecurity(request);
	String heightStr = request.getParameter("height");
	int height = heightStr != null && heightStr.length() > 0 ? Integer.parseInt(heightStr) : 330;
	String widthStr = request.getParameter("width");
	int width = widthStr != null && widthStr.length() > 0 ? Integer.parseInt(widthStr) : 750;
	
  TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");  
  TransactionTypeViewModel model = tranResultBuilder.getTranTypeViewModel();
  Transaction root = null;
  if (model != null){
	  root = model.getRoot();
  }
  TransactionDetailsResult detailsResult = tranResultBuilder == null ? null : tranResultBuilder.getDetailsResult();
  if (detailsResult != null && detailsResult.isDoReset()){
  	detailsResult = null;
  }
  String time = "";
  boolean messagesExist = false;
  if (detailsResult != null){
  	List list = detailsResult.getMessages();
  	if (list != null && list.size() > 0){
  		messagesExist = true;
  	  if (list != null && list.size() > 1){
        Routine rout1 = (Routine)list.get(0);
        Routine rout2 = (Routine)list.get(list.size()-1);
        long transactionTime = rout2.getCreatedTimeStamp() - rout1.getCreatedTimeStamp();
        time = xpolog.eye.util.DateUtil.formatTime(transactionTime,new DecimalFormat("##.##"));
      }
  	}
  }
  
  JGraphImageDescriptor imageDescriptor = detailsResult == null ? null : detailsResult.getImageDescriptor();

  String imgSrc = imageDescriptor == null ? null : BASE_DIRECTORY + imageDescriptor.getImageGraphURL();
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
	var baseDirectory = '<%=BASE_DIRECTORY %>';
</script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="online.js" type="text/javascript"></script>

<script>
  function openUrl(url){
    if (parent){
      parent.location = url;
    }
  }
  var show = true;
  var currentTransactionId;
	var xmlHttpRequestObjectShowTransaction;
	function showTransaction(subTransactionId) {
		hideNodeData();
		currentTransactionId = subTransactionId;
		nodeClicked = false;
		xmlHttpRequestObjectShowTransaction = GetXmlHttpObject();
	  
		var processingDiv = document.getElementById("processingDiv");
	  processingDiv.style.display = "";
	  
	  var url = "showTransaction.jsp?";
		var parameters = "";
		parameters += "&subTransactionId=" + subTransactionId;
		parameters += "&height=<%=height%>&width=<%=width%>";
		
		xmlHttpRequestObjectShowTransaction.open("POST", url, true);
		xmlHttpRequestObjectShowTransaction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  xmlHttpRequestObjectShowTransaction.setRequestHeader("Content-length", parameters.length);
	  xmlHttpRequestObjectShowTransaction.setRequestHeader("Connection", "close");
	 	xmlHttpRequestObjectShowTransaction.onreadystatechange = showTransactionCallback;
	  xmlHttpRequestObjectShowTransaction.send(parameters);
		document.body.style.cursor = "default";
	}
	
	function showTransactionCallback() {
		if (xmlHttpRequestObjectShowTransaction.readyState == 4) {
			if (xmlHttpRequestObjectShowTransaction.status == 200) {
				var processingDiv = document.getElementById("processingDiv");
	  		processingDiv.style.display = "none";
	  		
			  var xmlDoc = xmlHttpRequestObjectShowTransaction.responseXML.documentElement;
				updateTransactionView(xmlDoc);
			}
		}
	}
	
	function updateTransactionView(xmlDoc) {
		if(xmlDoc.getElementsByTagName("TransactionHeader").length > 0) {
			// update the transaction header
			var transactionHeaderElement = xmlDoc.getElementsByTagName("TransactionHeader")[0];
			var transactionHeaderStr = getElementValue(transactionHeaderElement);
			var transactionHeader = document.getElementById('transactionHeader');
			transactionHeader.innerHTML = transactionHeaderStr;
		}
		if (show){
			var imageElement = xmlDoc.getElementsByTagName("Image")[0];
			// update the graph image
			var src = imageElement.getAttribute("src");
			var graphImageDiv = document.getElementById("graphImageDiv");
			graphImageDiv.innerHTML = "<img id=\"graphImage\" src=\"" + baseDirectory + src + "\" USEMAP=\"#graphMap\" border=\"0\">";
			document.getElementById("graphImage").style.display = "";
			
			// update the graph mapping
			var mappingElement = xmlDoc.getElementsByTagName("Mapping")[0];
			var mappingStr = getElementValue(mappingElement);
			var graphMap = document.getElementById('graphMap');
			graphMap.innerHTML = mappingStr;
		}
		
		// update messages
		parent.loadDetailsFrame(currentTransactionId);
	}
	
	function getElementValue(element) {
		var elementValue = "";
		if(document.all) {
			elementValue = element.childNodes[0].nodeValue;
		}else {
			elementValue = element.childNodes[1].nodeValue;
		}
		return elementValue;
	}
</script>
</head>

<body style="margin: 0; padding: 0; border-width: 0" class="MAIN_SCROLL" <%if (root != null){%>onload="javascript:showTransaction('<%=root.getId()%>')"<%}%>>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<div id="nodeDataDiv" class="TREE_NODE_CLASS" style="position:absolute; display:none;" onMouseOver="javascript:onMouseOverNodeData()" onMouseOut="javascript:onMouseOutNodeData()">
</div>
<map id="graphMap" name="graphMap">
</map>
<map id="subTransactionMap" name="subTransactionMap" onMouseOver="javascript:isMouseOverNodeData=true;" onMouseOut="javascript:isMouseOverNodeData=false;">
</map>
<table border="0" width="100%" cellspacing="0" cellpadding="0" >
  <tr valign="top">
    <td width="100%">
    <table border="0" id="scrollElement" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
      <tr >
        <td align="left" width="100"><span class="SMALLTEXT" style="font-weight:bold"><nobr>Transaction Visual</nobr></span>
        </td>
        <td align="right" style="padding-right:5" width="*">
        <span class="SMALLTEXT">Total Transaction Time:</span>
        </td>
        <td width="100">
        <span class="SMALLTEXT"><nobr><%=time%></nobr></span>
        </td>
      </tr>
        
			<tr>
				<td id="transactionHeader" width="100%" colspan="3">
				</td>
			</tr>
        
        <tr>
        <td colspan="3">
        <div id="processingDiv" style="position:absolute; display:none">
					<table border="0" width="150" cellspacing="0" height="100%" cellpadding="0">
						<tr>
							<td class="PROCESSING_TEXT" style="padding-left:5">Processing...</td>
						</tr>
					</table>
				</div>
				</td>
				</tr>
				
	      <tr>          
					<td width="100%" colspan="3">
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr>
							<td width="100%" class="SMALLTEXT">
								<div id="graphImageDiv">
									<img id="graphImage" src="<%=BASE_DIRECTORY%>images/tree/blank.gif" style="display:none" USEMAP="#graphMap" border="0">
								</div>
							</td>
							<td class="SMALLTEXT">&nbsp;</td>
						</tr>
					</table>
					</td>
				</tr>
				
        <%if (false && imageDescriptor != null){ 
        		if (messagesExist){
        %>
		          <tr>          
    		        <td width="100%" colspan="3">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr>
                        <td width="100%" class="SMALLTEXT"><img id="graphImage" src="<%=imgSrc%>" ></td>
                        <td class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                </td>
        		  </tr>
        		<%}else{%>
		          <tr>          
    		        <td width="100%" colspan="3">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                    	<tr height="80"><td>&nbsp;</td></tr>
                      <tr>
                      	<td align="center"><span class="REGULARTEXT">Unfinished transaction</span></td>
                      </tr>
                    </table>
                </td>
        		  </tr>
        		<%}%>
          <%} else if (false){%>
          <tr>          
            <td width="100%" colspan="3">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                    	<tr height="80"><td>&nbsp;</td></tr>
                      <tr>
                      	<td align="center"><span class="REGULARTEXT">No transaction selected</span></td>
                      </tr>
                    </table>
                </td>
          </tr>
          <%}%>
        </table>
     </td>
  </tr>
</table>
</form>
</body>
</html>