<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="java.util.regex.*"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%> 
<%@ page import="xpolog.eye.data.*"%> 
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.common.JobStatus"%>

<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.brain.model.*"%>
<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String LEAP_TOP = "leap_top";
  String DIRECTION = "direction";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
  String sessionRuntimeId = logicEnv.getSessionRuntimeId();
	DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
	}
	if (dsr == null){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
	}
	final String tranId = request.getParameter("runtime_tran_id");
  
  String paradigmId = request.getParameter("tran_id");
	if (paradigmId == null){
		paradigmId = "";
	}

	String leapTopParam = request.getParameter(LEAP_TOP);
	String leapTopAttr = (String) request.getSession().getAttribute(LEAP_TOP);
	int _leapTop = 25;
	if (leapTopParam == null && leapTopAttr != null)
		_leapTop = Integer.parseInt(leapTopAttr);
	if (leapTopParam != null)
		_leapTop = Integer.parseInt(leapTopParam);
	request.getSession().setAttribute(LEAP_TOP, String.valueOf(_leapTop));
	
	final int leapTop = _leapTop;
	final String direction = request.getParameter(DIRECTION);
	
	
	final TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
  final TransactionQuery tranQuery = transResultBuilder.getTranQuery();

	
	JobStatus status = transResultBuilder.getJobStatus();
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status);
	boolean needToUpdateCache = transResultBuilder.needToUpdateResultCache(direction,leapTop);
	
	if (needToUpdateCache){
		ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/online/TransListView.jsp?"+request.getQueryString()) {
			public void run(HttpServletRequest request){
				boolean isFailed = false;
				long start = System.currentTimeMillis();
				try {
					
					//tlvh.getTransArrByDataFilter(result,model,trarrbuffer,fc,routineParadigmId,appName);
					//transResultBuilder.updateTransactionsResult(tranQuery,true,false);
	
					Transaction[] trarr = null;
					if (direction == null || direction.length() == 0) {
						trarr = transResultBuilder.getCurrentTransactions(tranQuery,leapTop);
					} else if (direction.equals("first")) {
						trarr = transResultBuilder.getNextTransactions(tranQuery,leapTop, true);
					} else if (direction.equals("prev")) {
						trarr = transResultBuilder.getPrevTransactions(tranQuery,leapTop, false);
					} else if (direction.equals("last")) {
						trarr = transResultBuilder.getPrevTransactions(tranQuery,leapTop, true);
					} else if (direction.equals("next")) {
						trarr = transResultBuilder.getNextTransactions(tranQuery,leapTop, false);
					} else if (direction.equals("gotoById") && tranId != null && tranId.length() > 0) {
						trarr = transResultBuilder.getTransactionsFromId(tranQuery,leapTop, tranId);
					}
					request.getSession().setAttribute("transactionsList",trarr);
	
				}catch (Exception e){
					e.printStackTrace();
					isFailed = true;
				}
				long end = System.currentTimeMillis();
				if ((end - start) < 1000){
					try {
						Thread.sleep(1000 - (end - start));
					}catch (Exception e){}
				}
			}
		};
		env.setProgressRunner(runner);
	}else{
		Transaction[] trarr = null;
		if (direction == null || direction.length() == 0) {
			trarr = transResultBuilder.getCurrentTransactions(tranQuery,leapTop);
		} else if (direction.equals("first")) {
			trarr = transResultBuilder.getNextTransactions(tranQuery,leapTop, true);
		} else if (direction.equals("prev")) {
			trarr = transResultBuilder.getPrevTransactions(tranQuery,leapTop, false);
		} else if (direction.equals("last")) {
			trarr = transResultBuilder.getPrevTransactions(tranQuery,leapTop, true);
		} else if (direction.equals("next")) {
			trarr = transResultBuilder.getNextTransactions(tranQuery,leapTop, false);
		} else if (direction.equals("gotoById") && tranId != null && tranId.length() > 0) {
			trarr = transResultBuilder.getTransactionsFromId(tranQuery,leapTop, tranId);
		}
		request.getSession().setAttribute("transactionsList",trarr);
		response.sendRedirect(BASE_DIRECTORY + "logic/online/TransListView.jsp?"+request.getQueryString());
	}
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="divWidth" value="250"/>
 <jsp:param name="height" value="50"/>
 <jsp:param name="divStyle" value=""/>
 <jsp:param name="hideDivHeader" value="true"/>
 <jsp:param name="hideDots" value="false"/>
 <jsp:param name="messageLeftPadding" value="40"/>
 <jsp:param name="forceRedirect" value="true"/>
 <jsp:param name="stopUrl" value="logic/online/TransListStopAction.jsp"/>
</jsp:include>
