<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%> 
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%> 
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log"; 

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){ 
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);

  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
  String sessionRuntimeId = logicEnv.getSessionRuntimeId();
  String titleName = "online";
  String extraTitle = "";
  boolean isOnline = false;
	DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);               
	}
	String dataSessionId = null;
	if (dsr == null){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
		dataSessionId = DataSession.ONLINE_DATA_SESSION_ID;
		isOnline = true;
	}else {
	  DataSession dataSession = CtrlMgr.getInstance().getDataSessionById(dsr.getDataSesParadigmId());
    if (dataSession != null){
			titleName = dataSession.getName();
	    dataSessionId = dataSession.getId();
	  }else {
	    titleName = "N/A";
	  }
	}
	
  if (dsr.getId().equals(DataSession.ONLINE_DATA_SESSION_ID)){
    extraTitle += " (Online)";
    isOnline = true;
    
    
  }else {
  	long time = dsr.getStartTime() != 0 ? dsr.getStartTime() : dsr.getCreatedTime();
    if (time > 0){
      extraTitle += " (" + xpolog.eye.site.SiteUtil.formatDefaultDate(new Date(time),true);
      if (dsr.getStartTime() == 0){
      	extraTitle += "*";
      }
    }  
    if (dsr.getEndTime() > 0){
      extraTitle += " - " + xpolog.eye.site.SiteUtil.formatDefaultDate(new Date(dsr.getEndTime()),true);
    }
    if (extraTitle.length() > 0){
      extraTitle += ")";
    }
  }
	
	
	
  TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
  TransactionParadigm[] trarr =  model.getTransactionParadigmListFromSessionRuntime(userContext,sessionRuntimeId,dataSessionId);
  Map map = model.getOnlineCountMapForTransactions(trarr);
  String transParadigmList = "";
  List list = new LinkedList();
  UITransactionParadigmBuilder builder = new UITransactionParadigmBuilder();
  if (trarr != null){
	  for (int i = 0; i < trarr.length; i++) {
			builder.loadTransactionGraph(trarr[i].getId());
  		XpoLogAtomicParadigm[] unusable = UITransactionParadigmHelper.checkTransationParadigmValidity(builder);
  		if (unusable != null && unusable.length > 0){
  			//continue;
  		}
			transParadigmList += (transParadigmList.length() == 0 ? "" : ",") + trarr[i].getId();
 			list.add(trarr[i]);
	  }
  }
  trarr = (TransactionParadigm[])list.toArray(new TransactionParadigm[list.size()]);
  
  String[] pids = new String[trarr.length];
  for (int i = 0; i < trarr.length; i++) {
	pids[i] = trarr[i].getId();
  }
  
	Map time = model.getTimeStautForTransactionParadigm(pids,0.0,0.1,1.0,trarr);
 	Map flow = model.getFlowStautForTransactionParadigm(pids,0.0,0.1,1.0,trarr);
 	//filter section
	String filterActive = request.getParameter("filter");
 	HashSet timeFilter = new HashSet();
    HashSet flowFilter = new HashSet();
    if(filterActive != null){
   	 	String ferr = request.getParameter("f_err");
 		String fwrn = request.getParameter("f_warn");
 		String fnorm = request.getParameter("f_norm");
	    if(fnorm != null){
	    	flowFilter.add(TransactionTypeViewModel.GREEN_STATE);
	    }
	   if(fwrn != null){
	    	flowFilter.add(TransactionTypeViewModel.YELLOW_STATE);
	    }
	    if(ferr != null){
	    	flowFilter.add(TransactionTypeViewModel.RED_STATE);
	    }
	    
	    String terr = request.getParameter("t_err");
 		String twrn = request.getParameter("t_warn");
 		String tnorm = request.getParameter("t_norm");
	    if(tnorm != null){
	    	timeFilter.add(TransactionTypeViewModel.GREEN_STATE);
	    }
	    if(twrn != null){
	    	timeFilter.add(TransactionTypeViewModel.YELLOW_STATE);
	    }
	    if(terr != null){
	    	timeFilter.add(TransactionTypeViewModel.RED_STATE);
	    }
	 }else{
	 	flowFilter.add(TransactionTypeViewModel.GREEN_STATE);
	    flowFilter.add(TransactionTypeViewModel.YELLOW_STATE);
	    flowFilter.add(TransactionTypeViewModel.RED_STATE);
	 	timeFilter.add(TransactionTypeViewModel.GREEN_STATE);
	    timeFilter.add(TransactionTypeViewModel.YELLOW_STATE);
	    timeFilter.add(TransactionTypeViewModel.RED_STATE);
	 }
    
    String refreshMenuStr = request.getParameter("refreshMenu");
    boolean refreshMenu = refreshMenuStr != null && refreshMenuStr.equals("true");
    
	//      audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
         			userContext, AuditConstants.VIEW, "view project summary", AuditConstants.PROJECT, "view project summary " + titleName);

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	function generate(){
		path = "TransTypeView.jsp?filter=active";
		//flow
		if(document.access.f_err.checked){
			path = path + "&f_err=1";
		}
		if(document.access.f_warn.checked){
			path = path + "&f_warn=1";
		}
		if(document.access.f_norm.checked){
			path = path + "&f_norm=1";		
		}
		//time
		if(document.access.t_err.checked){
			path = path + "&t_err=1";
		}
		if(document.access.t_warn.checked){
			path = path + "&t_warn=1";
		}
		if(document.access.t_norm.checked){
			path = path + "&t_norm=1";
		}
		
		window.location = path;
	}
	
	function checkForNumber(number){
		return true;
	}
</script>
</head>
<%if(refreshMenu){ %>
<body onload="javascript:refreshMenus()">
<%}else { %>
<body>
<%} %>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0"  width="100%" class="LOGIC_MAIN_TABLE">
          <tr>
            <td width="100%" style="padding-left:10">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
              <tr>
                <td nowrap><span class="PAGEHEADER">Transactions Summary - <%=titleName%></span><span class="SMALLTEXT" style="font-weight:bold;"><nobr>&nbsp;<%=extraTitle%></nobr></span></td>
              </tr>
              <tr>
                <td  valign="top"><span class='SMALLTEXT'>&nbsp;</span></td>
              </tr>
	
             	 <tr>
                    <td>
                      <hr>
                    </td>
                  </tr>
		  <tr>
                    <td align="right" style="padding-right:20">
                    <%if (false && isOnline && trarr.length > 0){%>
                       <a href="translogviewAction.jsp<%=trarr.length > 1 ? "" : "?transParadigmId="+trarr[0].getId()%>&zoomOutUrl=logic/online/TransTypeView.jsp" class="LINK">Transactions Log View</a>
                     <%}%>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr class="TABLES_HEADERS">
                        <td width="15%"><span class="REGULARTEXT">Name</span></td>
                        <td width="15%" align="left"><span class="REGULARTEXT">Flow Stauts</span></td>
                        <td width="15%" class="REGULARTEXT" nowrap align="left">Time Status</td>
                        <td width="10%" class="REGULARTEXT" nowrap align="left">Total&nbsp;</td>
                        <td width="45%" class="REGULARTEXT" nowrap align="center"></td>
                        
                      </tr>
                      <%if (trarr.length > 0){
	                      	for (int i = 0; i < trarr.length; i++) {
	                      		if(trarr[i].getTransactionType() == TransactionParadigm.SUB_TRANSACTION_TYPE) {
															continue;
														}
	                      		int num = ((Integer)map.get(trarr[i].getId())).intValue();
	                      		TransactionTypeViewModel.StatusResult tstat = (TransactionTypeViewModel.StatusResult)time.get(trarr[i].getId());
	                      		TransactionTypeViewModel.StatusResult fstat = (TransactionTypeViewModel.StatusResult)flow.get(trarr[i].getId());
	                      		//check filters
	                      		if(!(timeFilter.contains(tstat.status) || flowFilter.contains(fstat.status))){
	                      			continue;
	                      		}
	                      		
	                      		
	                      		
	                      		String timeStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_green_small.gif";
	                      		String flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_green_small.gif";
	                      		
	                      		if(tstat != null && tstat.status != null){
	                      			if(tstat.status.equals(TransactionTypeViewModel.YELLOW_STATE)){
	                      				//timeStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_yellow.png";
	                      				timeStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
	                      			}else if(tstat.status.equals(TransactionTypeViewModel.RED_STATE)){
	                      				timeStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
	                      			}
	                      		}
	                      		
	                      		if(fstat != null && fstat.status != null){
	                      			if(fstat.status.equals(TransactionTypeViewModel.YELLOW_STATE)){
	                      				//flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_yellow.png";
	                      				flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
	                      			}else if(fstat.status.equals(TransactionTypeViewModel.RED_STATE)){
	                      				flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
	                      			}
	                      		}
	                      %>
	                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM" style="padding-top:3;padding-bottom:3">
	                        <td width="15%" class="SMALLTEXT" nowrap>
						              <%if (isOnline && XpologLicenseManager.getInstance().isDemo()) {%>
	                        <span class="REGULARTEXT"><b><%=trarr[i].getName()%></b></span>
	                        <%}else{%>
	                        <a href="TransView.jsp?isFirst=true&tran_id=<%=trarr[i].getId()%>&resetQuery=true&timestamp=<%=String.valueOf(System.currentTimeMillis())%>" class="LINK"><%=trarr[i].getName()%></a>
	                        <%} %>
	                        </td>
	                        <td width="15%" class="REGULARTEXT" align="center">
	                        <table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
	                        <td class="REGULARTEXT" width="20"><img src="<%=flowStatImg%>"></td>
	             						<td class="REGULARTEXT" width="*"><%=fstat == null ? "" : "(" + fstat.count + ")"%></td></tr>
	             						</table>
	                        </td>
	                        <td width="15%" class="REGULARTEXT" nowrap align="center">
	                        <table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
	                        <td class="REGULARTEXT" width="20"><img src="<%=timeStatImg%>"></td>
	             						<td class="REGULARTEXT" width="*"><%=tstat == null ? "" : "(" + tstat.count + ")"%></td></tr>
	             						</table>
	             						</td>                        
	                        <td width="10%" class="REGULARTEXT" nowrap align="left" valign="center"><%=String.valueOf(num) + (isOnline ? " (Online)" : "")%></td>
	                        <td width="45%" class="REGULARTEXT" nowrap align="right" style="padding-right:20">
  						             <%if (isOnline && XpologLicenseManager.getInstance().isDemo()) {%>
												   <span class="REGULARTEXT"><b>Analysis</b></span>&nbsp;&nbsp;
  						             <%}else{ %>
												   <a href="TransView.jsp?isFirst=true&tran_id=<%=trarr[i].getId()%>&timestamp=<%=String.valueOf(System.currentTimeMillis())%>" class="LINK">Analysis</a>&nbsp;&nbsp;
  						             <%}%>
												</td>                        
	                      </tr>
	                      <%
	                      	} //end for
                      } //end if
                      else{%>
                      <tr><td>&nbsp;</td></tr>
                      <tr>
                        <td colspan="5"><span class="REGULARTEXT" style="font-weight:bold;">No transactions were found for the selected result set</span></td>
                      </tr>
                      <%}%>
                      <tr>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                        <td width="10%" class="SMALLTEXT">&nbsp;</td>
                        <td width="45%" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
              <%if (isOnline && XpologLicenseManager.getInstance().isDemo()) {%>
              <tr><td>&nbsp;</td></tr>
              <tr>
              	<td align="center"><span class="LICENSEMESSAGE">
              		Monitoring is not avaiable in trial version.<br>
              		Use TxExpo's commercial version to see online transactions analysis of your system.
              	</span></td>
              </tr>
              <tr><td>&nbsp;</td></tr>
              <%}%>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
          <td class="REGULARTEXT">&nbsp;</td>
      </tr>
	
    </table>
    </td>
  </tr>
</table>

</body>

</html>