<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.filters.*"%>

<%
  String BASE_DIRECTORY = "../../../";
  String TYPE_LOG = "Log";
  String RECORD_MASK = "RECORD_MASK";
  String FILTER_MAN = "FILTER_MAN";
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String ROUTINE_ID = "routine_id"; //used from addNewTransaction.jsp
  String DATA_SOURCE_ID = "ds_id";
  String ROUTINE_PARADIGM_ID = "routine_paradigm_id";
  String TRANS_PARADIGM_ID = "trans_paradigm_id";
  String ERROR_OBJ = "ERROR_OBJ";

  String OP = "OP";
  String ADD = "ADD";
  String EDIT = "EDIT";

  boolean isStatusFilter = false;
  boolean isDisplayFilter = true;

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }

 String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";


  UserSecurity user = manager.getUserSecurity(request);
  ErrorModel errmod = new ErrorModel();

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
  AtomicConfigurationManager atomicConfig = XpoLogicInitiator.getInstance().getAtomicConfigManager();
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();

  LogBrowsingManager lbm = null;
  FilterManager fman = null;
  RecordMask mask = null;
  String operation = "";

	String dsId = request.getParameter(DATA_SOURCE_ID);
	String routine_id = request.getParameter(ROUTINE_ID);
	String comboId = request.getParameter("elem_id");
	String newWindow = request.getParameter("new_window");
	String returnUrl = request.getParameter("url");
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
	String routineParadigmId = request.getParameter(ROUTINE_PARADIGM_ID);
	String atomicParadigmId = null;
	String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);
	String selectedFilterId = request.getParameter("selected_filter_id");
	String statFilterString = request.getParameter("status_filter");
	String dispFilterString = request.getParameter("display_filter");
	if (dsId != null){
		isStatusFilter = true;
		isDisplayFilter = false;
	} else {
		isStatusFilter = false;
		isDisplayFilter = true;
	}
	if (statFilterString != null){
		isStatusFilter = statFilterString.equals("1");
	}
	if (dispFilterString != null){
		isDisplayFilter = dispFilterString.equals("1");
	}

	SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
	if (sdfmgr == null){
		sdfmgr = new SessionFilterManager(transParadigmId);
		request.getSession().setAttribute("sessionDataFilterManager",sdfmgr);
	}

	FilterCollection filterCollection = null;
	if (builder == null || routine_id == null){
		filterCollection = sdfmgr.getFilterCollectionById(filterCollectionId);
	}else{
		filterCollection = builder.getRoutineFilter(routine_id,filterCollectionId);
	}
	AtomicDataFilter transFilter = null;
	if (filterCollection != null && filterCollection.getFilters().size() > 0){
		transFilter = (AtomicDataFilter)filterCollection.getFilters().get(0);
		routineParadigmId = transFilter.getRoutineParadigmId();
		//System.out.println("routineParadigmId="+routineParadigmId);
	}
	
  if (transFilter != null){
  	atomicParadigmId = ""; //transFilter.getAtomicParadigmId();
  	fman = (FilterManager)transFilter.getRecordFilter();
  	isStatusFilter = transFilter.isStatusFilter();
  	isDisplayFilter = transFilter.isDisplayFilter();
  	String op = request.getParameter(OP);
  	if (op != null && op.equals("duplicate")){
			transFilter = null;
  		filterCollectionId = null;
  		filterCollection = (FilterCollection)filterCollection.clone();
  		filterCollection.setId(filterCollectionId);
	 		filterCollection.setName("copy of "+filterCollection.getName());
			operation = ADD;
	  } else {
	  	operation = EDIT;
	  }
	} else {
		operation = ADD;
	}
	
	if (builder == null || routine_id == null){
	 	if (transParadigmId != null && transParadigmId.trim().length() > 0){
	 		builder = new UITransactionParadigmBuilder();
		  builder.loadTransactionGraph(transParadigmId);
		  builder.setEditTransaction(true);
	 	}else {
	    errmod.addError("No paradigm id supplied");
	    request.getSession().setAttribute(ERROR_OBJ,errmod);
	    response.sendRedirect(BASE_DIRECTORY +"common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
	    return;
	 	}
	}

  RoutineParadigm[] routineParadigms = builder.getRoutineParadimgs();
	FilterCollection[] filters = null;
	XpoLogAtomicParadigm atomicParadigm = null;

	if (routine_id != null){
		routineParadigmId = routine_id;
		atomicParadigm = builder.getAtomicByRoutineId(routineParadigmId);
	  if (atomicParadigm != null){
			LinearBrowsingManager linbm = atomicParadigm.getLbm();
			if (linbm instanceof LogBrowsingManager){
				lbm = (LogBrowsingManager)linbm;
				mask = lbm.getRecordMask();
				request.getSession().setAttribute(RECORD_MASK,mask);
			}
		}
	}
	else {
		if (routineParadigmId == null){
		  routineParadigmId = routineParadigms[0].getId();
		}
		if (routineParadigmId.length() > 0){
			AtomicRoutineParadigm routineParadigm = (AtomicRoutineParadigm)rep.getRoutineParadigmById(routineParadigmId);
			atomicParadigmId = routineParadigm.getAtomicParadigmID();
			LinearBrowsingManager linbm = UITransactionParadigmHelper.getDSLinearBrowsingManager(atomicParadigmId);
			if (linbm instanceof LogBrowsingManager){
				lbm = (LogBrowsingManager)linbm;
				mask = lbm.getRecordMask();
				request.getSession().setAttribute(RECORD_MASK,mask);
			}
			filters = UITransactionParadigmHelper.getDataFiltersForAtomic(atomicParadigmId,isStatusFilter,isDisplayFilter);
			if (filters == null) filters = new FilterCollection[0];
		}
	}

	request.getSession().setAttribute(FILTER_MAN,fman);
	String charset = TransactionTypeViewModel.getCharSetForRoutineParadigm(routineParadigmId);	
	if (charset != null){
		response.setContentType("text/html; charset=" + charset);
	}
%>

<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
 
<script>
 function markStringCheck(filed,tocheck){
  	if(filed.value == ""){
  		tocheck.checked = false;
  		return;
  	}
  	tocheck.checked = true;
  }

  function trim(a){
		while(''+a.charAt(a.length-1)==' '){
		 a=a.substring(0,a.length-1);
		}
  	return a;
  }
  function init(){
  	alert(opener.document.getElementById("<%=comboId%>").length);
  }
</script>

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="OP" value="<%=operation%>">
<input type="hidden" name="trans_paradigm_id" value="<%=transParadigmId%>">
<input type="hidden" name="statusFilter" value="<%=isStatusFilter%>">
<input type="hidden" name="displayFilter" value="<%=isDisplayFilter%>">
<%if (transFilter != null){%>
<input type="hidden" name="<%=FILTER_COLLECTION_ID%>" value="<%=filterCollectionId%>">
<%}%>
<%if (dsId != null){%>
<input type="hidden" name="ds_id" value="<%=dsId%>">
<%}%>
<%if (routine_id != null){%>
<input type="hidden" name="routine_id" value="<%=routine_id%>">
<%}%>
<%if (atomicParadigmId != null){%>
<input type="hidden" name="atomicParadigmId" value="<%=atomicParadigmId%>">
<%}%>
<%if (comboId != null){%>
<input type="hidden" name="combo_id" value="<%=comboId%>">
<%}%>
<%if (returnUrl != null){%>
<input type="hidden" name="url" value="<%=returnUrl%>">
<%}%>
<%if (newWindow != null){%>
<input type="hidden" name="new_window" value="<%=newWindow%>">
<%}%>
<input type="hidden" name="enc" value="<%=charset == null? "" : charset%>">
<input type="hidden" name="tempFilter">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%" class="LOGIC_MAIN_TABLE">
          <tr>
            <td width="100%">
            <table border="0" cellspacing="1" style="border-collapse: collapse" width="100%">
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Transaction Filter </span></td>
                <td width="50%" >&nbsp;</td>
              </tr>
							<tr><td colspan="3" valign="top"><span class='SMALLTEXT'>&nbsp;</span></td></tr>
              <tr>
                <td width="3%" valign="top"></td>
                <td width="100%" colspan="2" valign="top">
                <table border="0" cellspacing="1" cellpadding="0">
	                <tr>
	                	<%if (dsId == null){%>
	                  <td nowrap><span class='HEADER'>Routine: </span>
	                    <select class="TEXTBOX" name="routineParadigmId" onChange="javascript:refreshView()">
	                    	<%for (int i=0; i<routineParadigms.length; i++){
	                    		if (transFilter != null && !routineParadigms[i].getId().equals(routineParadigmId)){
	                    			continue;
	                    		}
	                    		String selected = routineParadigms[i].getId().equals(routineParadigmId) ? "selected" : "";
	                    	%>
	                      <option value="<%=routineParadigms[i].getId()%>" <%=selected%>><%=routineParadigms[i].getName()%></option>
	                      <%}%>
	   					 				</select>
	                  </td>
	                  <td colspan="2">&nbsp;</td>
	                  <%} else {
	                  	AtomicModelParadigm atomic = atomicConfig.getParadigmById(dsId);
	                  %>
		                  <td nowrap><span class='HEADER'>Data Source: <%=atomicParadigm.getName()%></span>
	                  <%}%>
	                </tr>
	                <tr>
	                	<td colspan="3">&nbsp;</td>
	                </tr>
				          <tr>
				          	<td colspan="3">
											<%if (lbm != null) {%>
											<%@ include file="AtomicRoutineFilter.jsp" %>
											<%}%>
				          	</td>
				          </tr>
                </table>
              </tr>
            </table>
            </td>
          </tr>
        </table>
      	</td>
      </tr>
    </table>
    </td>
	</tr>
</table>
</form>
</body>
</html>
