<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="xpolog.logic.brain.admin.db.filters.*"%>
<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	//constants
	String ERROR_OBJ = "ERROR_OBJ";

	String FILTER_NAME = "filterName";
	String FILTER_KEYS = "filtersKeys";

	String TRANS_PARADIGM_ID = "trans_paradigm_id";
	String FILTER_COLLECTION_ID = "filter_collection_id";
	String OP = "OP";
	String ADD = "ADD";
	String EDIT = "EDIT";
  String STATUS_FILTER = "statusFilter";
  String DISPLAY_FILTER = "displayFilter";

	//page data
	String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
	SessionFilterManager sdfmgr = (SessionFilterManager) request
			.getSession().getAttribute("sessionDataFilterManager");
	BrainConfigurationRepository rep = BrainConfigurationRepository
			.getRepository();
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder) request
			.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	String enc = request.getParameter("enc");
	if (enc != null && enc.trim().length() == 0) {
		enc = null;
	}
	ErrorModel ermo = new ErrorModel();

	String filtersKeysStr = request.getParameter(FILTER_KEYS);
	String[] keys = null;
	if (filtersKeysStr != null && filtersKeysStr.length() > 0) {
		keys = filtersKeysStr.split("\\|");
	}
	if (keys == null || keys.length==0) {
		ermo.addError("You must select at least one event for this filter");
	}

	//check validity for name
	String filterName = request.getParameter(FILTER_NAME);
	if (filterName != null && enc != null) {
		filterName = new String(filterName.getBytes("8859_1"), enc);
	}

	if (filterName == null || filterName.trim().equals("")) {
		ermo.addError("You must name the filter.");
	}
	
//	filter section
	RecordMask mask = new RecordMask();
	DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	MaskColumn[] cols = { dateMask };
	mask.setColumns(cols);
	DateFilter dfilter = null;
	try {
	  createDateFilter(request, response, mask);
	}catch(Exception e){
		ermo.addError(e.getMessage());
	}

	if (ermo.getErrorCount() > 0) {
		request.getSession().setAttribute(ERROR_OBJ, ermo);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}

	boolean doAdd = request.getParameter(OP).equals(ADD);
	boolean doEdit = request.getParameter(OP).equals(EDIT);

	String isTempFilterStr = request.getParameter("tempFilter");
	boolean isTempFilter = (isTempFilterStr != null && isTempFilterStr.equals("true"));
	boolean wasTempFilter = false;
  String statusFilterStr = request.getParameter(STATUS_FILTER);
  boolean statusFilter = statusFilterStr != null && statusFilterStr.equals("true");
  String displayFilterStr = request.getParameter(DISPLAY_FILTER);
  boolean displayFilter = displayFilterStr != null && displayFilterStr.equals("true");

	FilterCollection fcman = null;
	String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);
	//System.out.println("filterCollectionId="+filterCollectionId+"; doAdd="+doAdd+"; doEdit="+doEdit);
	if (filterCollectionId == null) {
		fcman = new FilterCollection();
	} else {
		fcman = sdfmgr.getFilterCollectionById(filterCollectionId);
		if (fcman == null) {
			fcman = new FilterCollection();
		} else {
			fcman = (FilterCollection) fcman.clone();
			wasTempFilter = fcman.isTransientFilter();
		}
	}
	String tempFilterId = filterCollectionId;

	if (isTempFilter != wasTempFilter) {
		doAdd = true;
		doEdit = false;
		fcman = new FilterCollection();
		if (isTempFilter && !wasTempFilter) {
			filterCollectionId = String.valueOf(System.currentTimeMillis());
			fcman.setId(filterCollectionId);
			//filterName = filterName+"-temp";
		}
	}

	fcman.setName(filterName);
	fcman.setTransientFilter(isTempFilter);
	fcman.clearAllFromName(EventFilter.EVENT_FILTER_TYPE);
	EventFilter eventFilter = new EventFilter();

	//adding the filter operations
	String rpId;
	int op;
	String value = null;
	for (int i = 0; i < keys.length; ++i) {
		value = null;
		String key = keys[i];
		String[] arr = key.split("\\*");
		int len = arr.length;
		if (len < 2) {
			
		} else {
			rpId = arr[0];
			op = Integer.parseInt(arr[1]);
			if (len == 3) {
		value = arr[2];
			}
			eventFilter.addEvent(rpId, op, value);
		}
	}

	
	
	if (dfilter != null) {
		eventFilter.setDateFilter(dfilter);
	}
	eventFilter.setStatusFilter(statusFilter);
	eventFilter.setDisplayFilter(displayFilter);

	fcman.addFilter(eventFilter);
	if (doAdd) {
		if (!isTempFilter) {
			filterCollectionId = sdfmgr.saveDataFilter(fcman);
		} else {
			sdfmgr.addFilterCollection(fcman);
		}
	}
	if (doEdit) {
		sdfmgr.updateDataFilter(fcman);
	}
	TransactionParadigm t = rep
			.getTransactionParadigmById(transParadigmId);
	if (t != null) {
		if (!isTempFilter) {
			HashMap map = (HashMap) t.getFiltersForRoutinesMap();
			HashSet set = (HashSet) map.get("-1");
			if (set == null) {
		set = new HashSet();
		map.put("-1", set);
			}
			set.add(fcman.getId());
			rep.getTranConfigBuilder().updateTransactionFilters(t);
		}
	}

	//remove temp filter if saved
	if (!isTempFilter && wasTempFilter) {
		sdfmgr.removeFilterCollection(tempFilterId);
	}

	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "addedit event filter",
			AuditConstants.TRANSACTION,
			"add/edit event filter " + filterName);

	response.sendRedirect(BASE_DIRECTORY
			+ "logic/online/TransView.jsp?filter_collection_id="
			+ fcman.getId() + "&advancedOpen=y");
%>
