<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="xpolog.logic.brain.admin.db.filters.*"%>
<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  //constants
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";

  String FILTER_NAME = "filterName";
  String FILTER_LOGOP_OP = "LogicalOp";
  String FILTER_COL_IDS = "FilterCollectionIds";

  String TRANS_PARADIGM_ID = "trans_paradigm_id";
  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String EDIT = "EDIT";
  String NEGATE = "Negate";

  //page data
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
  SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }

  String[] colids = request.getParameterValues(FILTER_COL_IDS);
  //check validity for name
  
  String filterName = request.getParameter(FILTER_NAME);
	if (filterName != null && enc != null){
		filterName = new String(filterName.getBytes("8859_1") ,enc);
	}
  String logicOp = request.getParameter(FILTER_LOGOP_OP);
  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));

  ErrorModel ermo = new ErrorModel();
  if(filterName == null || filterName.trim().equals("")){
    ermo.addError("You must name the filter.");
  }
  if(colids == null || (negate && colids.length < 1) || (!negate && colids.length < 2)){
    ermo.addError("You must select at least two filters.");
  }
  if(ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  boolean doAdd = request.getParameter(OP).equals(ADD);
  boolean doEdit = request.getParameter(OP).equals(EDIT);

  String isTempFilterStr = request.getParameter("tempFilter");
  boolean isTempFilter = (isTempFilterStr != null && isTempFilterStr.equals("true"));
  boolean wasTempFilter = false;

  FilterCollection fcman = null;
  String filterCollectionId = request.getParameter(EDIT_FILTER_ID);
  if(filterCollectionId == null){
    fcman = new FilterCollection();
  }else{
    fcman = sdfmgr.getFilterCollectionById(filterCollectionId);
    if(fcman == null){
      fcman = new FilterCollection();
    }else{
      fcman = (FilterCollection)fcman.clone();
		  wasTempFilter = fcman.isTransientFilter();
    }
  }
	String tempFilterId = filterCollectionId;

  if (isTempFilter != wasTempFilter){
  	doAdd = true;
  	doEdit = false;
  	fcman = new FilterCollection();
  	if (isTempFilter && !wasTempFilter){
	  	filterCollectionId = String.valueOf(System.currentTimeMillis());
	  	fcman.setId(filterCollectionId);
	  	//filterName = filterName+"-temp";
	  }
  }

  fcman.setName(filterName);
	fcman.setTransientFilter(isTempFilter);
  fcman.clearAllFromName(MultiFilter.MULTI_FILTER_NAME);
  MultiFilter multiFilter = new MultiFilter(sdfmgr);
  //setting the ids
  for(int i=0;i<colids.length;++i){
    multiFilter.addFilteCollection(colids[i]);
  }
  //setting boolean op
  if(logicOp.equalsIgnoreCase("OR")){
    multiFilter.setBooleanOpAsOR();
  }else{
    multiFilter.setBooleanOpAsAND();
  }
  multiFilter.setNegateFilter(negate);

  fcman.addFilter(multiFilter);
	if (doAdd){
		if (!isTempFilter){
			filterCollectionId = sdfmgr.saveDataFilter(fcman);
		}else{
			sdfmgr.addFilterCollection(fcman);
		}
	}
	if (doEdit){
		sdfmgr.updateDataFilter(fcman);
	}
  TransactionParadigm t = rep.getTransactionParadigmById(transParadigmId);
  if (t != null){
  	if (!isTempFilter){
			HashMap map = (HashMap)t.getFiltersForRoutinesMap();
			HashSet set = (HashSet)map.get("-1");
			if (set == null){
				set = new HashSet();
				map.put("-1",set);
			}
			set.add(fcman.getId());
			rep.getTranConfigBuilder().updateTransactionFilters(t);
		}
	}

	//remove temp filter if saved
	if (!isTempFilter && wasTempFilter){
		sdfmgr.removeFilterCollection(tempFilterId);
	}

	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "add/edit multi filter", AuditConstants.TRANSACTION, "add/edit multi filter " + filterName);


  response.sendRedirect(BASE_DIRECTORY +"logic/online/TransView.jsp?filter_collection_id="+fcman.getId()+"&advancedOpen=y");
%>
