<%@ page language="java"%>

<%@ page import="java.awt.Rectangle"%>

<%@ page import="xpolog.logic.common.NodeRuntimeInstance"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImage"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImageDescriptor"%>
<%@ page import="xpolog.logic.transaction.data.Transaction"%>
<%@ page import="xpolog.logic.ui.TransResultBuilder"%>
<%@ page import="xpolog.logic.ui.TransactionTypeViewModel"%>

<%!

static final String BASE_DIRECTORY = "../../";

public String getNodeData(TransactionTypeViewModel model, NodeRuntimeInstance node) {
	String result = "";
	if(node.getNodeType().equals(Transaction.TRANSACTION_ENTITY_TYPE)) {
		result = getSubTransactionData(model, (Transaction)node);
	}
	return result;
}

public String getSubTransactionData(TransactionTypeViewModel model, Transaction subTransaction) {
	StringBuffer result = new StringBuffer();
	
	Transaction previousRoot = model.getRoot();
	model.setRoot(subTransaction, false);
	
	JGraphImageDescriptor imageDescriptor = model.getGraphForRoot(10, 10);
	
	model.setRoot(previousRoot);
	
	int width = imageDescriptor.getImageGraphWidth();
	if(width < 120) {
		width = 120;
	}
	result.append("<table id=\"nodeDataTable\" border=\"0\" width=\"" + width + "\" cellspacing=\"0\" style=\"border-collapse: collapse\">");
	result.append("<tr valign=\"top\" bgcolor=\"#E1E1E1\">");
	result.append("<td align=\"center\" style=\"padding-left:4;padding-right:4\" class=\"SUB_TRANSACTION_CONTENT_HEADER\">");
	result.append(subTransaction.getTransactionParadigm().getName());
	result.append(" Content");
	result.append("</td>");
	result.append("</tr>");
	result.append("<tr bgcolor=\"#E1E1E1\">");
	result.append("<td>");
	result.append("<table border=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" width=\"100%\" bgcolor=\"#FFFFFF\">");
	result.append("<tr>");
	result.append("<td style=\"padding-left:2;padding-right:2; padding-bottom:20\"><img src=\"" + BASE_DIRECTORY + imageDescriptor.getImageGraphURL() + "\" USEMAP=\"#subTransactionMap\" border=\"0\">");
	result.append("</td>");
	result.append("</tr>");
	result.append("</table>");
	result.append("</td>");
	result.append("</tr>");
	result.append("</table>");
	
	return result.toString();
}

public String getSubTransactionMappingStr(TransactionTypeViewModel model, HttpServletRequest request, Transaction subTransaction) {
	Transaction previousRoot = model.getRoot();
	model.setRoot(subTransaction, false);
	
	JGraphImageDescriptor imageDescriptor = model.getGraphForRoot(10, 10);
	String mappingStr = model.createMappingString(imageDescriptor.getJgraphImage(), request, false);
	model.setRoot(previousRoot);
	
	return mappingStr;
}
%>

<%
	String NODE_TYPE = "nodeType";
	String NODE_ID = "nodeId";
	
	String nodeType = request.getParameter(NODE_TYPE);
	String nodeId = request.getParameter(NODE_ID);
	
	TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");  
	TransactionTypeViewModel model = tranResultBuilder.getTranTypeViewModel();
	
	NodeRuntimeInstance node = null;
  if(nodeType.equals("subTransaction")) {
  	node = model.getTransactionById(nodeId);
  }
	
	String result = "", mappingStr = "";
	Rectangle rec = null;
  if(node != null) {
  	JGraphImageDescriptor imageDescriptor = model.getGraphForRoot(700, 220);
  	JGraphImage graphImg = imageDescriptor.getJgraphImage();
    rec = graphImg.getRectangleForVertex(node);
    result = getNodeData(model, node);
  	if(node.getNodeType().equals(Transaction.TRANSACTION_ENTITY_TYPE)) {
			mappingStr = getSubTransactionMappingStr(model, request, (Transaction)node);
		}
  }
	
	String x = rec == null ? "-1" : Integer.toString((int)rec.getMinX());
	String y = rec == null ? "-1" : Integer.toString((int)rec.getMinY());	
	
	response.setContentType("text/xml");
%>

<NodeData>
<Node type="<%=nodeType %>" x="<%=x %>" y="<%=y %>">
<![CDATA[
<%=result %>
]]>
</Node>
<Mapping>
<![CDATA[<%=mappingStr %>]]>
</Mapping>
</NodeData>
