<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.smart.magicdir.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!

  public void go(String str){
    System.out.println(str);
  }

%>
<%

  String MAGICDIR_ID = "MAGICDIR_ID";
  String MAGICDIR_NAME = "MAGICDIR_NAME";
  String MAGICDIR_OWNER = "MAGICDIR_OWNER";
  String MAGICDIR_DESCRIPTION = "MAGICDIR_DESCRIPTION";
  String MAGICDIR_PARENT_MODULE = "PARENT_MODULE";
  //String MAGICDIR_MODULE_ID = "MAGICDIR_MODULE_ID";
  String MAGICDIR_DIRECTORY = "MAGICDIR_DIRECTORY";
  //String MAGICDIR_FILTER = "MAGICDIR_FILTER";
  String MAGICDIR_FE_FILTER = "MAGICDIR_FE_FILTER";
  String MAGICDIR_FE_FILTER_TYPE = "MAGICDIR_FE_FILTER_TYPE";
  String MAGICDIR_NE_FILTER = "MAGICDIR_NE_FILTER";
  String MAGICDIR_NE_FILTER_TYPE = "MAGICDIR_NE_FILTER_TYPE";
  String MAGICDIR_RECURSEDIR = "MAGICDIR_RECURSEDIR";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  MagicDirManager mdManager = SiteManagment.getMagicDirManagerInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  ErrorModel errmod = new ErrorModel();

  String magicDirId = request.getParameter(MAGICDIR_ID);
  String magicDirName = request.getParameter(MAGICDIR_NAME);
  String magicDirOwner = request.getParameter(MAGICDIR_OWNER);
  String magicDirParentModule = request.getParameter(MAGICDIR_PARENT_MODULE);
  //String magicDirModuleId = request.getParameter(MAGICDIR_MODULE_ID);
  String magicDirDesc = request.getParameter(MAGICDIR_DESCRIPTION);
  String magicDirDirectory = request.getParameter(MAGICDIR_DIRECTORY);
  String magicDirFileExtFilter = request.getParameter(MAGICDIR_FE_FILTER);
  String magicDirFileExtFilterType = request.getParameter(MAGICDIR_FE_FILTER_TYPE);
  String magicDirNameExpFilter = request.getParameter(MAGICDIR_NE_FILTER);
  String magicDirNameExpFilterType = request.getParameter(MAGICDIR_NE_FILTER_TYPE);
  String magicDirRecurseStr = request.getParameter(MAGICDIR_RECURSEDIR);
  boolean magicDirRecurseDirs = false;
  
  if (magicDirRecurseStr != null && magicDirRecurseStr.equals("true"))
  	magicDirRecurseDirs = true;
  
  if(magicDirParentModule == null || magicDirParentModule.length() == 0) {
  	errmod.addError("No folder was supplied");
  }

  if(magicDirName == null || magicDirName.trim().equals("")){
    errmod.addError("No name was supplied");
  }

  HashSet set = new HashSet();
  set.add("?");
  set.add("\"");
  set.add("'");
  set.add(">");
  set.add("<");
  set.add("}");
  set.add("{");
  set.add("\\");
  set.add("/");
  set.add("!");
  set.add(":");
  set.add(";");
  set.add("=");
  set.add("(");
  set.add(")");
  set.add("|");
  set.add("[");
  set.add("]");
  String chars = "?,\",\\,',/,{,},[,],(,),=,:,;,<,>,!,|";
  Iterator it = set.iterator();
  while(it.hasNext()){
    if(magicDirName.indexOf((String)it.next()) >= 0){
      errmod.addError("The following charecters are prohibited in the name field: " +chars);
    }
  }
  
  try {
  	File dir = new File(magicDirDirectory);
  	if (!dir.isDirectory()) {
  		errmod.addError("No valid directory was supplied " + magicDirDirectory);
  	}
  }
  catch (Exception e) {
  	errmod.addError(e.toString());
  }
  
  it = mdManager.getMagicDirList().iterator();
  while (it.hasNext()) {
	  MagicDir md = (MagicDir)it.next();
  	if (!md.getId().equals(magicDirId)) {
	  	if (md.getDirectory().equals(magicDirDirectory)) {
	  		errmod.addError("A magic directory with the specified directory already exists");
	  		break;
	  	}
	  	if (md.getName().equals(magicDirName)) {
	  		errmod.addError("A magic directory with the specified name already exists");
	  		break;
	  	}
  	}
  }
  
  if (errmod.getErrorCount() > 0) {
  	request.getSession().setAttribute(ERROR_OBJ,errmod);
		response.sendRedirect("errorpage.jsp");
		return;
  }
  
  MagicDir magicDir = new MagicDir();
 	magicDir.setId(magicDirId);
	magicDir.setDirectory(magicDirDirectory);
  magicDir.setName(magicDirName);
  magicDir.setOwner(magicDirOwner);
  magicDir.setDescription(magicDirDesc);
  magicDir.setParentModuleId(magicDirParentModule);
  magicDir.setRecurseDirs(magicDirRecurseDirs);
  MagicDirFilter filter = new MagicDirFilter();
  filter.setFileExtensions(magicDirFileExtFilter);
  filter.setFileExtType(magicDirFileExtFilterType);
  filter.setNameExpressions(magicDirNameExpFilter);
  filter.setNameExpType(magicDirNameExpFilterType);
  magicDir.setFilter(filter);

  String str =  mdManager.addMagicDir(magicDir,true);
    
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "edit/add magic directory", AuditConstants.LOGS, "change magic directory " + magicDirName);

  response.sendRedirect("addopok.jsp");

%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
</head>
<body>
	<%=magicDirId%>
	<%=magicDirName%>
	<%=magicDirOwner%>
	<%=magicDirParentModule%>
	<%=magicDirDesc%>
	<%=magicDirDirectory%>
	<%=magicDirRecurseDirs%>
</body>
</html>