<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>

<%@ page import="java.util.HashSet"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = manager.getUserSecurity(request);
	MetaDataManager mdMgr = mgmt.getMetaDataMgr();
	 
	String appId = request.getParameter("appId");
	if (appId == null) {
		appId = "";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}

	String name = "", desc = "";
	String headerTitle = "";
  MetaData metaData = null;
  String parentName = "";
  if (appId != null && appId.length() > 0){
    metaData = mdMgr.getMetaData(appId,true);
    if (metaData != null){
  		name = metaData.getName();
  		desc = metaData.getDescription();
    }
    HashSet parents = mdMgr.getMetaDatasByXplgObject(XpoLogObjectTypes.META_DATA_TYPE,appId);
    MetaData parent = parents == null || parents.size() < 1 ? null : (MetaData)parents.iterator().next();
    parentName = parent == null ? "" : parent.getName();
    headerTitle = "Edit Application";
  }else{
  	appId = "";
    headerTitle = "Add Application";
  }
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
  
	if (XpologSecurityManager.getInstance().isEnabled()){
		ModuleMemberPermissions currPermission = metaData != null ? metaData.getPermissions() : null;	
		if (currPermission != null){  	
			request.setAttribute("currPermission",currPermission);
		}
	}
  
	
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>

<style type="text/css">
.APPLICATION_MEMBERS_TAB {
  padding-left : 5px;
  padding-right : 5px;
  padding-top : 2px;
  padding-bottom : 2px;
  background-color : #A4A4A4;
  margin : 0px;
}

.APPLICATION_SELECTED_MEMBERS_TAB {
  padding-left : 5px;
  padding-right : 5px;
  padding-top : 2px;
  padding-bottom : 2px;
  background-color :#FFFFFF;
  margin : 0px
}
</style>


<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script language="javascript">

	function init(){
		initTabs();
		//initTables();
	}

	function updatePermissions(){
		for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
			document.access.selectedEditMembersList.options[j].selected = true;
		}
		for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
			document.access.selectedViewMembersList.options[j].selected = true;
		}
	}

	
	function hideMessageDiv(){
		document.getElementById("messageDiv").style.display = "none";
	}
	
	//general start
	baseDirectory = "<%=BASE_DIRECTORY%>";
  
	function doSave(){
  	updateSelected();
  	updateVerifiersSelected();
  	 <%if(txExpoViewer){%>
		  updateWorkspaces();
		<%}%>
		<%if (XpologSecurityManager.getInstance().isEnabled()){%>
			updatePermissions();
		<%}%>	  
  	document.access.submit();
	}
  
	function updatePermissions(){
		for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
			document.access.selectedEditMembersList.options[j].selected = true;
		}
		for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
			document.access.selectedViewMembersList.options[j].selected = true;
		}
	}

	function showTextField(combo){
		if (combo.options.multiple == false){
			if (combo.options[combo.options.selectedIndex].value == "other"){
				document.getElementById("New"+combo.name+"Div").style.display = "";
			}else{
				document.getElementById("New"+combo.name+"Div").style.display = "none";
			}
		}else{
			otherSelected = false;
			for (var i=0; i<combo.length; i++){
				if (combo.options[i].value == "other"){
					if (combo.options[i].selected == true){
						document.getElementById("New"+combo.name+"Div").style.display = "";
					}else{
						document.getElementById("New"+combo.name+"Div").style.display = "none";
					}
				}
			}
		}
	}
  
	function addNewProp(){
		document.getElementById("NewPropTableHeader").style.display = "";
		var ni = document.getElementById("newProps");
		var numi = document.getElementById("numberOfProps");
		var num = (document.getElementById("numberOfProps").value -1)+ 2;
		numi.value = num;
		var divIdName = "newProp"+num+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		//newdiv.innerHTML = "Element Number "+num+" has been added! <a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">Remove the div &quot;"+divIdName+"&quot;</a>";
		newdiv.innerHTML = "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">"+
	                      "<tr><td width=\"20%\" valign=\"top\" nowrap><span class=\"REGULARTEXT\">"+
	                      "<input type=\"text\" name=\"key_"+num+"\" id=\"key_"+num+"\" size=\"20\">"+
	                      "</span></td>"+
	                      "<td width=\"80%\">"+
	                     "<input type=\"text\" name=\"value_"+num+"\" id=\"value_"+num+"\" size=\"20\">"+
	                     "&nbsp;<span class=\"LINK\"><a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">&nbsp;remove</a></link>"+
	                      "</td></tr></table>";
		ni.appendChild(newdiv);
	}

	function removeEvent(divNum){
		var d = document.getElementById('newProps');
		var olddiv = document.getElementById(divNum);
		d.removeChild(olddiv);
		num = document.access.numberOfProps.value;
		if (!document.getElementById("newProp"+num+"Div")){
			document.getElementById("NewPropTableHeader").style.display = "none";
		}
	}


	var contextreq;
	function addMenu(op,id){
		if (typeof XMLHttpRequest != "undefined") {
	       contextreq = new XMLHttpRequest();
	   } else if (window.ActiveXObject) {
	       contextreq = new ActiveXObject("Microsoft.XMLHTTP");
	   }
	  var url = "metaDataContextMenues.jsp?op=" + op + "&id=" + id;
	   var contextSearchCol = eval("document.access.contextSearchCol0");
	   for (var i = 0; contextSearchCol;){
	     url = url + "&contextSearchCol" + i + "=" + contextSearchCol.value;
	     url = url + "&contextSearchName" + i + "=" + escape(eval("document.access.contextSearchName" + i).value);
	     url = url + "&contextSearchPath" + i + "=" + escape(eval("document.access.contextSearchPath" + i).value);
	     i++;
	     contextSearchCol = eval("document.access.contextSearchCol" + i);   
	   }
	   
	   contextreq.open("POST",url, true);
	   contextreq.onreadystatechange = addMenucallback;
	   contextreq.send(null);
	}

	function addMenucallback() {
	  if (contextreq.readyState == 4) {
	    if (contextreq.status == 200) {
	     
	      var val = contextreq.responseText;
	      if (!val){
	        val = "";
	      }     
	      var td = document.getElementById("searchMenuesTD");
	     
	      if(td){
	        td.innerHTML = val;
	      }
	      return;
	    }
	  }
	}
	//general end
	
	function updateSelected(){
		list = tree1.getAllChecked(true);
		arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}
	
	function updateVerifiersSelected(){
		list = metaVerTree.getAllChecked();
		arr = list.split(",");
	  var verStr = "";
	  var multiVerStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=MultiVerifier.MULTI_TYPE%>"){
					if (multiVerStr != ""){
						multiVerStr += ",";
					}
					multiVerStr += id;
					if (metaVerTree.hasChildren(s) && metaVerTree.hasChildren(s)==true){
	 				multiVerStr += "*";
					}
				}else{
					if (verStr != ""){
						verStr += ",";
					}
					verStr += id;
				}
			}
		}
		document.access.multiVerifiers.value = multiVerStr;
		document.access.verifiers.value = verStr;
	}
	  function updateWorkspaces(){
		list = wsTree.getAllChecked(true);
		arr = list.split(",");
	  var wsStr = "";
	  var projStr = "";
	  var transStr = "";	  
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.WORKSAPCE_TYPE%>"){
					if (wsStr != ""){
						wsStr += ",";
					}
					wsStr += id;
					
				}else{
					if (type == "<%=XpoLogObjectTypes.PROJECT_TYPE%>"){
						if (projStr != ""){
							projStr += ",";
						}
						projStr += id;
					
					}else{
							if (transStr != ""){
								transStr += ",";
							}
							transStr += id;
						}
					}
			}
		}
		document.access.workspaces.value = wsStr;
		document.access.projects.value = projStr;
		document.access.projectTransactions.value = transStr;		
	}
	//members end

</script>

<jsp:include page="../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<title></title>
</head>

<body onLoad="init()" onUnload="destroyTables()" style="margin:0;padding:0;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="applicationDefinitionAction.jsp" style="margin:0;padding:0" method="POST">
<input type="hidden" name="IsAdmin" value="true"/>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr height="1">
		<td>
			<jsp:include page="../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<%if(MetaDataManager.SHOW_ID_FIELD) { %>
										<tr>
											<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Id</span></td>
											<td width="80%">
											<%
											if (appId == null || appId.length() == 0){%>
												<input type="text" name="appId" class="TEXTBOX" size="30" value="<%=appId%>">
											<%}else{%>
												<span class="REGULARTEXT" style="height:20px"><b><%=appId%></b></span>
												<input type="hidden" name="appId" value="<%=appId%>">
											<%}%>
											</td>
										</tr>
										<%}else if(appId != null && appId.length() > 0){ %>
										<input type="hidden" name="appId" value="<%=appId%>">
										<%} %>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="name" size="30" value="<%=name%>" onClick="resetBgColor(this)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:5">&nbsp;</span></td>
										</tr>
										<tr>
											<td><span class="REGULARTEXT">Description:</span></td>
											<td>
												<input type="text" class="TEXTBOX" name="desc" size="30" value="<%=desc%>"> 
											</td>
											<td>&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;" ></div>
							<div id="generalDiv"  style="padding:10;display:none;height:100%;width:90%" >
								<jsp:include page="applicationDefinitionGeneral.jsp" flush="true">
									<jsp:param name="appId" value="<%=appId%>" />
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
							</div>
							<div id="membersDiv"  style="padding:10;display:none;height:100" >
								<jsp:include page="applicationMembersAdmin.jsp" flush="true">
									<jsp:param name="appId" value="<%=appId%>" />
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
							</div>
							<%if (XpologSecurityManager.getInstance().isEnabled()){%>
							<div id="permissionsDiv" style="padding-left:10;display:none;height:100" >
								<jsp:include page="../security/common/moduleMemberPermissionsIncluder.jsp" flush="true">
									<jsp:param name="embedded" value="true" />
									<jsp:param name="ignoreName" value="true"/>
									<jsp:param name="parentName" value="<%=parentName%>"/>
									<jsp:param name="showDefault" value="true"/>
								</jsp:include>
							</div>
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="membersDiv" />
								<jsp:param name="name.2" value="Members" />
								<jsp:param name="id.3" value="permissionsDiv" />
								<jsp:param name="name.3" value="Security" />
							</jsp:include>
							<%}else{ %>
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="membersDiv" />
								<jsp:param name="name.2" value="Members" />
							</jsp:include>
							<%} %>								
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Applications" />
				<jsp:param name="actions" value="javascript:doSave()#metadata/applicationsView.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>

<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr height="20">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" id="messageTitle"></span>
		</td>
	</tr>
	<tr height="*" style="padding:5">
		<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
		</td>
	</tr>											
	<tr height="10">
		<td align="center" style="padding:5"><nobr>
			<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
			</nobr>		  							
		</td>
	</tr>
</table>
</div>
</form>
</body>
</html>