<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.HashSet"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  ErrorModel errmodel = new ErrorModel();

  if (security == null){
    errmodel.addError("This operation can't be done.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  String metaDataId = request.getParameter("id");
  if (metaDataId == null || metaDataId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }



  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "";
  }

  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaData metaData = metaDataMgr.getMetaData(metaDataId);
  HashSet parents = metaDataMgr.getMetaDatasByXplgObject(XpoLogObjectTypes.META_DATA_TYPE,metaDataId);
  boolean ignoreParents = parents == null || parents.isEmpty();
  MetaData parent = parents == null || parents.size() < 1 ? null : (MetaData)parents.iterator().next();
  String parentName = parent == null ? "" : parent.getName();
  
  if (metaData == null){
    errmodel.addError("No application was found for id - " + metaDataId);
  }
  ModuleMemberPermissions currPermission = metaData.getPermissions();	
  if (currPermission != null && !security.isEditable(currPermission)){
    response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp?okURL=metadata/metaDataView.jsp");
    return;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }
  
  ModuleMemberPermissions permissions = new ModuleMemberPermissions();
  String forwardPage = BASE_DIRECTORY + "security/common/moduleMemberPermissionsIncluder.jsp";
 
  if (currPermission != null){
	  request.setAttribute("currPermission",currPermission);
  }
  if (permissions != null){
	  request.setAttribute("permissions",permissions);
  }

  String resetURL = "metadata/perm/metaDataPermissions.jsp?id=" + metaDataId;  
  String actionURL = "metadata/perm/metaDataPermissionsAction.jsp";
  String name = metaData == null ? "" : metaData.getName();
%>

<jsp:include page="<%=forwardPage%>">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="id" value="<%=metaDataId%>"/>
 <jsp:param name="type" value=""/>
 <jsp:param name="memberName" value="<%=name%>"/>
 <jsp:param name="parentName" value="<%=parentName%>"/>
 <jsp:param name="actionURL" value="<%=actionURL%>"/>
 <jsp:param name="resetURL" value="<%=resetURL%>"/>
 <jsp:param name="forwardURL" value="<%=forwardURL%>"/>
 <jsp:param name="ignoreParent" value="<%=ignoreParents%>"/>
</jsp:include>
