<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  ErrorModel errmodel = new ErrorModel();
  String metaDataId = request.getParameter("id");
  if (metaDataId == null || metaDataId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }

  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaData metaData = metaDataMgr.getMetaData(metaDataId);
  
  if (metaData == null){
    errmodel.addError("No application was found for id - " + metaDataId);
  }

  ModuleMemberPermissions permissions = null;
  String permissionsPolicy = request.getParameter("memberPolicy");
  if (permissionsPolicy != null && permissionsPolicy.equals("current")){
    ModuleMemberPermissions orgPermissions = metaData.getPermissions();
    Collection orgEditMembers = orgPermissions != null ? orgPermissions.getEditMembers() : null;
    Collection orgViewMembers = orgPermissions != null ? orgPermissions.getViewMembers() : null;
    Collection nonAdministeredEditMembers = null;
    Collection nonAdministeredViewMembers = null;
    if (orgEditMembers != null){
    	nonAdministeredEditMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgEditMembers,false));
    }
    permissions = new ModuleMemberPermissions();
    String [] editNames = request.getParameterValues("selectedEditMembersList");
    HashSet editNamesCol = new HashSet();
		if (editNames != null && editNames.length > 0){
			for (int i=0; i<editNames.length; i++){
				editNamesCol.add(editNames[i]);
			}
		}
		if (nonAdministeredEditMembers != null){
	  	Iterator it = nonAdministeredEditMembers.iterator();
	  	while (it.hasNext()){
	  		XpologPrincipal p = (XpologPrincipal)it.next();
	  		editNamesCol.add(p.getName());
	  	}
		}
		if (!editNamesCol.isEmpty()){
			permissions.setEditMembers(editNamesCol);
		}
	
    if (orgViewMembers != null){
    	nonAdministeredViewMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgViewMembers,false));
    }
		String [] viewNames = request.getParameterValues("selectedViewMembersList");
    HashSet viewNamesCol = new HashSet();
		if (viewNames != null && viewNames.length > 0){
			for (int i=0; i<viewNames.length; i++){
				viewNamesCol.add(viewNames[i]);
			}
		}
		if (nonAdministeredViewMembers != null){
	  	Iterator it = nonAdministeredViewMembers.iterator();
	  	while (it.hasNext()){
	  		XpologPrincipal p = (XpologPrincipal)it.next();
	  		viewNamesCol.add(p.getName());
	  	}
		}
		if (!viewNamesCol.isEmpty()){
			permissions.setViewMembers(viewNamesCol);
		}
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

  metaData.setPermissions(permissions);
  try {
    metaDataMgr.saveMetaData(metaData);
  }catch (Exception e){
  }
  String name = metaData.getName();
//audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit/save application", AuditConstants.CONFIGURATION, "change permission to application " + name);
  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "security/common/moduleMemberSetOK.jsp?okURL=metadata/metaDataView.jsp";
  }
  forwardURL = BASE_DIRECTORY + forwardURL;
  response.sendRedirect(forwardURL);

%>

