<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.jms.JMSTask"%>
<%@ page import="xpolog.eye.automation.tasks.exe.ExeTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.SNMPTask"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccount"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.*"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>
<%@ page import="xpolog.eye.verifiers.VerifierTasksListener"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	String op = request.getParameter("op");
	boolean doGenerate = op != null && op.equalsIgnoreCase("generate");
	
	String type = request.getParameter("type");
	
	if (doGenerate){
		request.getRequestDispatcher("aggReportExecutionDefinition.jsp").forward(request, response);
		return;
	}
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = manager.getUserSecurity(request);
	boolean canAddMonitor = WebSecurityManager.getInstance().isHavePermission(user,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
			
	String monitorId = request.getParameter("monitorId");
	if (monitorId == null) {
		monitorId = "";
	}
	
	String logId = request.getParameter("LOG_ID");
	String filterId = request.getParameter("FILTER_ID");

	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String useSessionLogStr = request.getParameter("useSessionLog");
	boolean useSessionLog = useSessionLogStr == null || useSessionLogStr.equals("true");
	
	String useSessionBuilderStr = request.getParameter("useSessionBuilder");
	boolean useSessionBuilder = useSessionBuilderStr != null && useSessionBuilderStr.equals("true");
	
	String headerTitle = "";
	VerifierManager verifierMgr = mgmt.getVerifierManager();
	Verifier monitor = monitorId.length() == 0 ? null : verifierMgr.getVerfierFromId(monitorId);
	
	if (monitor != null && (type == null || type.length() == 0)){
		type = monitor.getType();
	}
	boolean isMulti = type != null && type.equals(MultiVerifier.MULTI_TYPE);

	VerifierBuilder builder = null;
	if (useSessionBuilder){
		builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
		monitor = builder.getVerifier();
	}
	if (builder == null){
		if (isMulti){
			builder = new MultiVerifierBuilder();
		}else{
			builder = new LogVerifierBuilder();
		}
	}
	
	if (monitor == null){
		request.getSession().removeAttribute("lastSelectedMonitor");
		if (isMulti){
			headerTitle = "Add Group";
			monitor = new MultiVerifier();
		}else{
			headerTitle = "Add Monitor";
			monitor = new LogVerifier();
			LinearBrowsingManager lbm = null;
			String logName = null;
			String filterName = null;
			String monitorName = null;
			if (logId != null && logId.length() > 0){
				((LogVerifier)monitor).setLogId(logId);
				((LogVerifier)monitor).setLogFilterId(filterId);
				try{
					lbm = mgmt.getLogBrowserManager(logId,true);
					logName = lbm.getName();
				}catch(Exception e){
				}
			}else if (useSessionLog){
				lbm = (LinearBrowsingManager)request.getSession().getAttribute("CURRENT_LOG");
				if (lbm != null){
					logId = lbm.getId();
					filterId = lbm.getFilterManager().getActiveFilterId();
					logName = lbm.getName();
					FilterCollection fc = lbm.getFilterManager().getFilterCollectionById(filterId);
					filterName = fc != null ? fc.getName() : null;
				}
			}
			monitorName = logName != null ? (logName + (filterName != null ? " - " + filterName : "") + " Monitor") : "";
			((LogVerifier)monitor).setLogId(logId);
			((LogVerifier)monitor).setLogFilterId(filterId);
			monitor.setName(monitorName);
			
			if (lbm != null){
				lbm.dispose();
			}
		}
	}else{
		if (isMulti){
			if(monitor.getId() == null) {
				headerTitle = "Add Group";
			}else {
				headerTitle = "Edit Group";
			}
		}else {
			if(monitor.getId() == null) {
				headerTitle = "Add Monitor";
			}else {
				headerTitle = "Edit Monitor";
			}
		}
		if(monitor.getId() == null) {
			request.getSession().removeAttribute("lastSelectedMonitor");
		}else {
		  request.getSession().setAttribute("lastSelectedMonitor",monitor.getId());
		}
	}
	request.setAttribute("XpologNode",monitor);
	
	builder.setVerifier(monitor);
	builder.updateFromVerifier();
	request.getSession().setAttribute(VERIFIER_BUILDER,builder);
	String monitorGeneralPage = 
		isMulti ? "multiMonitorDefinitionGeneral.jsp" : "monitorDefinitionGeneral.jsp";
	String monitorActionPage = "monitorDefinitionAction.jsp";
		//isMulti ? "multiMonitorDefinitionAction.jsp" : "monitorDefinitionAction.jsp";
	
	String monitorName = monitor.getName();
	String monitorDesc = monitor.getDescription();
	
	String selectedLogId = null;
	String selectedFilterId = null;
	if (!isMulti){
		selectedLogId = ((LogVerifier)monitor).getLogId();
		if (selectedLogId == null) selectedLogId = "";
		selectedFilterId = ((LogVerifier)monitor).getLogFilterId();
		if (selectedFilterId == null) selectedFilterId = "";
	}
	String treeName = "tree";
	
	String generalTabName = isMulti ? "Members" : "Rules";
	
	String selectFilterString = "Select or ";
	boolean allowNewFilter = true;
	UserContext userContext = UserEnvironment.getUserContext(request);
	if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION)){
		allowNewFilter = false;
		selectFilterString = "Select rule ";
  }
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script language="JavaScript1" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>tasks/snmp/snmp.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>tasks/jms/jms.js"></script>

<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script language="javascript">

	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";

	function init(){
		initTabs();
		//initTables();
		//mygridAlerts.enableAutoHeigth(false,"330");      
		<%if (!isMulti){%>
		//loadLogsTree();
		//mygridPositiveAlerts.enableAutoHeigth(false,"330");
		//if (createLogMenu){
		//	createLogMenu();
		//}
		<%}%>
	}

	function showSaveSettings(){
		showHideLayerInMiddle("saveSettingsDiv",-1,-1);
	}
 
	function saveMonitor(){
		<%if (isMulti){%>
		if(document.access.SelectedVerifiersList) {
		for(var j=0;j<document.access.SelectedVerifiersList.options.length;j++){
			document.access.SelectedVerifiersList.options[j].selected = true;
		}
		}
		<%}else{%>
		updateSelected();
		<%}%>
	  //doTasks();
	  //prepareApplicationToSubmit();
	  <%if (XpologSecurityManager.getInstance().isEnabled()){%>
	  updatePermissions();
	  <%}%>
	  var q = getFormElementsQueryString(document.access);
	  var url = "monitorDefinitionAction.jsp?";
	  //alert(url);
	  sendAjaxRequest(url,function(req){
	    var xmldoc = req.responseXML.documentElement;
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      //var message = xmldoc.getElementsByTagName('message')[0].text;
      //var params = xmldoc.getElementsByTagName('params')[0].text;
      if (result == "false"){
			  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
    		var msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"

		    var msgWriter = new messageWriter("monitorDefinitionMessage","Save Monitor Error","<%=BASE_DIRECTORY%>");
    		msgWriter.addAction("OK","javascript:hideLayer('monitorDefinitionMessage')");
    		msgWriter.setStyle("left");
		    msgWriter.showMessage(msg);

	    	if (xmldoc.getElementsByTagName('params')[0] && xmldoc.getElementsByTagName('params')[0].firstChild){
		    	var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
		    	var pArr = params.split("*;*");
		    	for (var i=0; i<pArr.length; i++){
		    		if (eval("document.access."+ pArr[i])){
		    			setErrorColor(eval("document.access."+ pArr[i]));
		    		}
		    	}
	    	}
      }else{
      	document.location = "addopok.jsp?refreshMenu=true";
      }


	  }, 'POST', q);
		//document.access.submit();
	}
	
	function updatePermissions(){
		for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
			document.access.selectedEditMembersList.options[j].selected = true;
		}
		for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
			document.access.selectedViewMembersList.options[j].selected = true;
		}
	}

	function updateSelected(){
		if (tree){
			list = tree.getAllCheckedAndPartiallyChecked();
			arr = list.split(",");
		  var logsStr = "";
		  var filtersStr = "";
			for (var i=0; i<arr.length; i++){
				s = arr[i];
				ind = s.indexOf("-");
				if (ind == -1){
					continue;
				}else{
					type = s.substring(0,ind);
					id = s.substring(ind+1,s.length);
					if (type == "<%=XpoLogObjectTypes.LOG_TYPE%>"){
						if (logsStr != ""){
							logsStr += ",";
						}
						logsStr += id;
					}else if (type == "<%=XpoLogObjectTypes.FILTER_TYPE%>"){
						if (filtersStr != ""){
							filtersStr += ",";
						}
						filtersStr += id;
					}
				}
			}
			document.access.logs.value = logsStr;
		}else{
		}
	}
	
	function setErrorColor(elem){
		if (elem){
			elem.className = 'ERROR_MSG_BACKGROUNDCOLOR';
		}
	}
	
	//multi start
	function doVerifierAdd(){
	  if(document.access.availableVerifiersList.selectedIndex == -1){
	    return;
	  }
	  for(var j=0;j<document.access.availableVerifiersList.options.length;j++){
	    if (document.access.availableVerifiersList.options[j].selected){
	      var name = document.access.availableVerifiersList.options[j].text;
	      var value = document.access.availableVerifiersList.options[j].value;
	      var found = false;
	      for(var i=0;i<document.access.SelectedVerifiersList.options.length;i++){
	        if(document.access.SelectedVerifiersList.options[i].value == value){
	          found = true;
	        }
	      }
	      if (!found){
	        var option0 = new Option(name,value);
	        document.access.SelectedVerifiersList.options[document.access.SelectedVerifiersList.options.length] = option0;
	      }
	    }
	  }
	}
	
	function doVerifierRemove(){
	  if(document.access.SelectedVerifiersList.selectedIndex == -1){
	    return;
	  }
	
	  for(var i= document.access.SelectedVerifiersList.options.length ; --i >= 0;){
	    if(document.access.SelectedVerifiersList.options[i].selected){
	       document.access.SelectedVerifiersList.options[i] = null;
	    }
	  }
	}
	//multi end

	//alerts start
	function _addNewAlert(){
		var alertType = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
		var timeUnitElem = document.getElementById("timeUnit");
		if (alertType == "positive" && timeUnitElem){
			timeUnitElem.style.display = "none";
		}
	  document.getElementById("alertDivTitle").innerHTML = "Add task";
	  hideMonitorsAlerts();
	}
	
	function _hideMonitorsAlerts(){
	  document.getElementById("alertsTD").style.display = "none";
	  showLayerInMiddle("monitorsAlertsDiv",100,40);
	}
	
	function hideMonitorsAlerts(){
	  document.getElementById("monitorsAlertsDiv").style.display = "none";
	  document.getElementById("alertsTD").style.display = "";
	}
	
	var alertTypes = new Array();
	alertTypes[0] = "MailAlert";
	alertTypes[1] = "SNMPAlert";
	alertTypes[2] = "JMSAlert";
	alertTypes[3] = "ExeAlert";

  function editTask(){
		var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
    var alertType;
    var id;
    var gridName;
    if (alertGroup == "fail"){
    	id = getFirstSelectedRow(mygridAlerts);
    	alertType = mygridAlerts.getUserData(id,"alertType");
    	gridName = "mygridAlerts";
    }else{
    	id = getFirstSelectedRow(mygridPositiveAlerts);
    	alertType = mygridPositiveAlerts.getUserData(id,"alertType");
    	gridName = "mygridPositiveAlerts";
    }
    if (id == "") {
			var msgWriter = new messageWriter("mygridMessage","No Alert Selected","<%=BASE_DIRECTORY%>");
	    msgWriter.setYParent(document.getElementById(gridName),50);
	    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	    msgWriter.showMessage("<nobr>Please select an alert to edit</nobr>");
			return;
    }
    if (alertType){
			if (alertType == "<%=MailTask.TYPE_MAIL%>"){
				editMailAlert(id);
			}else if (alertType == "<%=SNMPTask.SNMP_TASK_TYPE%>"){
				editSNMPAlert(id);
			}else if (alertType == "<%=JMSTask.TYPE_JMS_TASK%>"){
				editJMSAlert(id);
			}else if (alertType == "<%=ExeTask.TYPE_EXE%>"){
				editExeAlert(id);
			}
    } 
  }
  

	function addMailAlert(){
		editMailAlert();
	}

	var mailTasksList;
	var mailTaskLabels = "&emailTaskLabel=Email Alert&existingTasksLabel=Existing Monitor Alerts&existingTasksNote=copy details from existing email alert";
	function editMailAlert(taskId){
		var getMonitorsAlertsUrl = "alerts/getMonitorsAlerts.jsp?alertType=<%=MailTask.TYPE_MAIL%>";
		sendAjaxRequest(getMonitorsAlertsUrl,function(req){
			var mailTasks = req.responseText;	
			mailTasks = mailTasks.replace(/^\s+|\s+$/g, '') ;
			var url = "../tasks/mail/mailTaskDefinition.jsp?";
			url = url + "base_directory=<%=BASE_DIRECTORY%>&noScripts=true&embedded=true&isMulti=<%=isMulti %>";
			url = url + "&showName=false&showFrom=false&showAdvanced=true&suffix=MailAlert"+mailTaskLabels;
			if (mailTasks && mailTasks != ""){
				mailTasksList = mailTasks;
				url = url + "&tasks=" + encode(mailTasks);
			}
			if (taskId){
				var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
				sendAjaxRequest("alerts/setTaskInSession.jsp?alertGroup="+alertGroup+"&taskId="+taskId,function(req1){
					showAlert("MailAlert",url,"Edit Email Alert");
				});
			}else{
				sendAjaxRequest("alerts/checkAlertPrecondition.jsp?alertType=<%=MailTask.TYPE_MAIL%>",function(req1){
					var preconditionResult = req1.responseText;
					if(trim(preconditionResult) == "ok") {
						showAlert("MailAlert",url,"Add Email Alert");
					}else {
						var preconditionUrl = "../tasks/mail/mailSettings.jsp";
						showPrecondition("MailAlert",url,preconditionUrl);
					}
				});
			}
		});
	}
	
	function addSNMPAlert(){
		editSNMPAlert()
	}

	var snmpTasksList;
	var snmpTaskLabels = "&snmpTaskLabel=SNMP Trap&existingTasksLabel=Existing Monitor Alerts&existingTasksNote=copy details from existing SNMP trap";
	function editSNMPAlert(taskId){
		var getMonitorsAlertsUrl = "alerts/getMonitorsAlerts.jsp?alertType=<%=SNMPTask.SNMP_TASK_TYPE%>";
		sendAjaxRequest(getMonitorsAlertsUrl,function(req){
			var snmpTasks = req.responseText;	
			snmpTasks = snmpTasks.replace(/^\s+|\s+$/g, '') ;
			var url = "../tasks/snmp/snmpTaskDefinition.jsp?embedded=true&noScripts=true&suffix=SNMPAlert"+snmpTaskLabels;
			if (snmpTasks && snmpTasks != ""){
				snmpTasksList = snmpTasks;
				url = url + "&tasks=" + encode(snmpTasks);
			}
			if (taskId){
				var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
				sendAjaxRequest("alerts/setTaskInSession.jsp?alertGroup="+alertGroup+"&taskId="+taskId,function(req){
					showAlert("SNMPAlert",url,"Edit SNMP Trap");
				});
			}else{
				showAlert("SNMPAlert",url,"Add SNMP Trap");
			}
		});
	}
	
	function addJMSAlert(){
		editJMSAlert()
	}

	var jmsTasksList;
	var jmsTaskLabels = "&jmsTaskLabel=JMS Message&existingTasksLabel=Existing Monitor Alerts&existingTasksNote=copy details from existing JMS message";
	function editJMSAlert(taskId){
		var getMonitorsAlertsUrl = "alerts/getMonitorsAlerts.jsp?alertType=<%=JMSTask.TYPE_JMS_TASK%>";
		sendAjaxRequest(getMonitorsAlertsUrl,function(req){
			var jmsTasks = req.responseText;	
			jmsTasks = jmsTasks.replace(/^\s+|\s+$/g, '') ;
			var url = "../tasks/jms/jmsTaskDefinition.jsp?embedded=true&noScripts=true&suffix=JMSAlert"+jmsTaskLabels;
			if (jmsTasks && jmsTasks != ""){
				jmsTasksList = jmsTasks;
				url = url + "&tasks=" + encode(jmsTasks);
			}
			if (taskId){
				var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
				sendAjaxRequest("alerts/setTaskInSession.jsp?alertGroup="+alertGroup+"&taskId="+taskId,function(req){
					showAlert("JMSAlert",url,"Edit JMS Message");
				});
			}else{
				showAlert("JMSAlert",url,"Add JMS Message");
			}
		});
	}
	
	function addExeAlert(){
		editExeAlert()
	}

	var exeTasksList;
	var exeTaskLabels = "&exeTaskLabel=Batch Execution&existingTasksLabel=Existing Monitor Alerts&existingTasksNote=copy details from existing batch execution";
	function editExeAlert(taskId){
		var getMonitorsAlertsUrl = "alerts/getMonitorsAlerts.jsp?alertType=<%=ExeTask.TYPE_EXE%>";
		sendAjaxRequest(getMonitorsAlertsUrl,function(req){
			var exeTasks = req.responseText;	
			exeTasks = exeTasks.replace(/^\s+|\s+$/g, '') ;
			var url = "../tasks/execute/exeTaskDefinition.jsp?embedded=true&noScripts=true&suffix=ExeAlert"+exeTaskLabels;
			if (exeTasks && exeTasks != ""){
				exeTasksList = exeTasks;
				url = url + "&tasks=" + encode(exeTasks);
			}
			if (taskId){
				var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
				sendAjaxRequest("alerts/setTaskInSession.jsp?alertGroup="+alertGroup+"&taskId="+taskId,function(req){
					showAlert("ExeAlert",url,"Edit Batch Execution Alert");
				});
			}else{
				showAlert("ExeAlert",url,"Add Batch Execution Alert");
			}
		});
	}
	
	function showAlert(alertType,url,title){
		var index = url.indexOf("?");
		var params = "";
		if(index > -1) {
			params = url.substring(index + 1);
			url = url.substring(0, index);
		}
		sendAjaxRequest(url,function(req){
			hideAllGeneralAdminDiv();
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get logs list!.");
				return;			
			}
			hideAllAlertDivs(alertType);
			showGeneralAdminDiv(alertType);
			if (title){
				var t = document.getElementById("generalDivTitle"+alertType);
				if (t){
					t.innerHTML = title;
				}
			}
			updateGeneralAdminDiv(alertType,result);
		}, 'POST', params);
	}
	
	function showPrecondition(alertType,url,preconditionUrl){
		var params = "postconditionUrl=" + escape(url);
		sendAjaxRequest(preconditionUrl,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get logs list!.");
				return;			
			}
			hideAllAlertDivs(alertType + "Precondition");
			showGeneralAdminDiv(alertType + "Precondition");
			updateGeneralAdminDiv(alertType + "Precondition",result);
		}, 'POST', params);
	}
	
	function saveMailSettings() {
		var postconditionUrl = document.getElementById("postconditionUrl");
		saveMailSettings0("MailAlert", postconditionUrl.value);
	}
	
	function saveMailSettings0(alertType,url) {
		var smtpHost = document.getElementById("SMTPHost").value;
		if(smtpHost == '') {
			alert("SMTP host cannot be empty");
			return;
		}else if(smtpHost == 'my.domain.com') {
			alert("SMTP host cannot be my.domain.com");
			return;
		}
	
		var params = "";
		params += "SMTPHost=" + document.getElementById("SMTPHost").value;
		params += "&SMTPProt=" + document.getElementById("SMTPProt").value;
		params += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
		sendAjaxRequest("../tasks/mail/mailSettingsAction.jsp?"+params,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get logs list!.");
				return;			
			}
			if(result.indexOf("ok") != -1) {
				hideGeneralAdminDiv(alertType + "Precondition");
				showAlert(alertType,url);
			}
		});
	}
	
	function hideAllAlertDivs(type){
		for (var i=0; i<alertTypes.length; i++){
			if (alertTypes[i] != type){
				hideGeneralAdminDiv(alertTypes[i]);
			}
		}
	}
	
	function closeAlertDiv(type){
		showHideGeneralAdminDiv(type);
	}
	
	

	/*
	function addNewMailTask(){	  
	  showLayerInMiddle("mailTaskDiv_",200,60);	  
	}
	*/
	
	function selectTabHandler(idn,ido){	  
	  if (ido && ido == "tab_2"){
	    //closeMailTaskDiv("");
			//hideMonitorsAlerts();
	  }
    return true;
	}
	
	function saveAlert(alertType){
		if(alertType == 'SNMPAlert' && eval("document.access." + SNMP_PREFIX + "AccountsList")) {
			eval("document.access.snmpAccountId" + alertType).value = eval("document.access." + SNMP_PREFIX + "AccountsList").value;
		}else if(alertType == 'JMSAlert' && eval("document.access." + JMS_PREFIX + "AccountsList")) {
			eval("document.access.jmsAccountId" + alertType).value = eval("document.access." + JMS_PREFIX + "AccountsList").value;
		} 
		var params = getFormElementsQueryString(document.access,alertType);
		
		if(params == "falseInput"){
			return;
		}else{
			if (alertType){
				params += "&suffix=" + alertType + "&alertType=" + alertType;
			}
		}
		
		var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
		var timeUnitElem = document.getElementById("timeUnit");
		if (timeUnitElem){
			timeUnitElem.style.display = "";
		}

		var url = "alerts/saveAlert.jsp?";
		var params = "alertGroup=" + alertGroup + "&" + params;
		if (alertGroup == "fail"){
			sendAjaxRequest(url,function(req){
				var result = req.responseText;
				if (result){	
					result = result.replace(/^\s+|\s+$/g, '');
				}
				var resultStrs = result.split("#");
				if (resultStrs.length > 1 && resultStrs[0] == "SAVE_ALERT_ERROR"){
					var msg = "<ul>";
	    		for (var i=1; i<resultStrs.length; i++){
	    			msg = msg + "<li>" + resultStrs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
	
		    	var msgWriter = new messageWriter("saveAlertMessage","Save Alert Error","<%=BASE_DIRECTORY%>");
			    msgWriter.addAction("OK","javascript:hideLayer('saveAlertMessage')");
			    msgWriter.setStyle("left");  
			    msgWriter.showMessage(msg);
				}else{
					var url = "<%=BASE_DIRECTORY%>monitor/monitorAlertsXML.jsp?dataOnly=true";
			  	mygridAlerts.clearAll();
			  	mygridAlerts.loadXML(url);
			  	hideAllAlertDivs();
				}				
			}, 'POST', params);
		}else{
			sendAjaxRequest(url,function(req){
				var result = req.responseText;
				if (result){	
					result = result.replace(/^\s+|\s+$/g, '');
				}
				var resultStrs = result.split("#");
				if (resultStrs.length > 1 && resultStrs[0] == "SAVE_ALERT_ERROR"){
			    var msg = "<ul>";
	    		for (var i=1; i<resultStrs.length; i++){
	    			msg = msg + "<li>" + resultStrs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
	
		    	var msgWriter = new messageWriter("saveAlertMessage","Save Alert Error","<%=BASE_DIRECTORY%>");
			    msgWriter.addAction("OK","javascript:hideLayer('saveAlertMessage')");
			    msgWriter.setStyle("left");  
			    msgWriter.showMessage(msg);
				}else{
					var url = "<%=BASE_DIRECTORY%>monitor/monitorPositiveAlertsXML.jsp?dataOnly=true";
			  	mygridPositiveAlerts.clearAll();
			  	mygridPositiveAlerts.loadXML(url);
			  	hideAllAlertDivs();
		  	}  
			}, 'POST', params);
		}
	}

	var selectAlertXmlHttp;
	function doSelect(id){
		var alertGroup = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
		var timeUnitElem = document.getElementById("timeUnit");
		if (timeUnitElem){
			timeUnitElem.style.display = "";
		}
		var url = "alerts/addTask.jsp?alertGroup="+alertGroup+"&taskId=" + id + "&tstmp=" + new Date().getTime();
		selectAlertXmlHttp = GetXmlHttpObject();
		selectAlertXmlHttp.open('POST', url, true);
		//alert("id = " + id + ", type = " + alertGroup);
		if (alertGroup == "fail"){
			selectAlertXmlHttp.onreadystatechange = doSelectCallback;
		}else{
			selectAlertXmlHttp.onreadystatechange = doSelectPosAlertCallback;
		}
		selectAlertXmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  selectAlertXmlHttp.setRequestHeader("Connection", "close");
	  selectAlertXmlHttp.send(null);  	

	}
	
	function doSelectCallback(){
		if (selectAlertXmlHttp.readyState == 4) {
			if (selectAlertXmlHttp.status == 200) {
				var url = "<%=BASE_DIRECTORY%>monitor/monitorAlertsXML.jsp?dataOnly=true";
		  	mygridAlerts.clearAll();
		  	mygridAlerts.loadXML(url);  
				hideMonitorsAlerts();
			}
		}
	}
	
	function doSelectPosAlertCallback(){
		if (selectAlertXmlHttp.readyState == 4) {
			if (selectAlertXmlHttp.status == 200) {
				updateTablePositiveAlerts();
				hideMonitorsAlerts();
			}
		}
	}
	
	function closeTasksDiv(){
		var timeUnitElem = document.getElementById("timeUnit");
		if (timeUnitElem){
			timeUnitElem.style.display = "";
		}
		hideMonitorsAlerts();
	}
	
	function checkMaxAlert(maxAlerts){
		var maxAlertsValue = maxAlerts == "" ? -1 : parseInt(maxAlerts);
		if (maxAlertsValue == -1 || maxAlertsValue > <%=VerifierTasksListener.MAX_FAIL_TASKS_EXECUTIONS%>){
			var message = "";
	    if (maxAlertsValue == -1){
    		message = "Missing maximun number of alerts to send";
   		}else{
    		message = "Maximun number of alerts to send is greater than <%=VerifierTasksListener.MAX_FAIL_TASKS_EXECUTIONS%>. This might result in many executions";
   		}
			var msgWriter = new messageWriter("mygridMessage","Invalid Max Alerts","<%=BASE_DIRECTORY%>");
	    msgWriter.setYParent(document.getElementById("mygridPositiveAlerts"),50);
	    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	    msgWriter.showMessage(message);
		}
	}
	
	function showMonitorAlertsByType(alertType){
		var maDiv = document.getElementById("monitorsAlertsDiv");
		if (maDiv){
			maDiv.style.display = "";
			var url = "<%=BASE_DIRECTORY%>monitor/allMonitorsAlertsViewXML.jsp?selectOnly=true&dataOnly=true&alertType=" + alertType + "&tstmp=" + new Date().getTime();
		  mygridTasks.clearAll();
		  mygridTasks.loadXML(url);
		  if (alertType == "<%=MailTask.TYPE_MAIL%>"){
		  	showNewMailDiv();
		  }else{
		  	clearNewAlertDiv();
		  }
		}
	}
	
	var showNewMailXmlHttp;
	function showNewMailDiv(){
		var url = "<%=BASE_DIRECTORY%>tasks/mail/newMailTaskDiv.jsp?";
		var param = "base_directory=<%=BASE_DIRECTORY%>&noScripts=true&divStyle=width:400px;height:300px";
		param = param + "&saveLinkName=add&showCloseLink=false&saveMailTaskFunction=saveNewMailAlert()";
		param = param + "&showFrom=false&showAdvanced=true&showTableHeader=false&tstmp=" + new Date().getTime();
		url = url + param;
		showNewMailXmlHttp = GetXmlHttpObject();
		showNewMailXmlHttp.open('POST', url, true);
		showNewMailXmlHttp.onreadystatechange = showNewMailDivCallBack;
		showNewMailXmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  showNewMailXmlHttp.setRequestHeader("Connection", "close");
	  showNewMailXmlHttp.send(null);  	
	}	
	
	function showNewMailDivCallBack(){
		if (showNewMailXmlHttp.readyState == 4) {
			if (showNewMailXmlHttp.status == 200) {
				var d = document.getElementById("newAlertHeader1TD");
				d.style.display = "";
				d = document.getElementById("newAlertHeader2TD");
				d.style.display = "";
				d = document.getElementById("newAlertTD");
				d.style.display = "";
				d.innerHTML = showNewMailXmlHttp.responseText;
			}
		}	
	}
	
	function clearNewAlertDiv(){
		var d = document.getElementById("newAlertHeader1TD");
		d.style.display = "none";
		d = document.getElementById("newAlertHeader2TD");
		d.style.display = "none";
		d = document.getElementById("newAlertTD");
		d.style.display = "none";
		d.innerHTML = "&nbsp;";
	}
	
  function deleteTask(){
  	var alertType = tabbar.getActiveTab() == "tab_2" ? "fail" : "positive";
    var id;
    var gridName;
  	if (alertType == "fail"){
  		id = getFirstSelectedRow(mygridAlerts);
    	gridName = "mygridAlerts";
  	}else{
  		id = getFirstSelectedRow(mygridPositiveAlerts);
    	gridName = "mygridPositiveAlerts";
  	}
    if (id == "") {
			var msgWriter = new messageWriter("mygridMessage","No Alert Selected","<%=BASE_DIRECTORY%>");
	    msgWriter.setYParent(document.getElementById(gridName),50);
	    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	    msgWriter.showMessage("<nobr>Please select an alert to remove</nobr>");
			return;
    }
    if (alertType == "fail"){
  		deleteGridRow(mygridAlerts,id,baseDirectory + "monitor/removeMonitorAlertAction.jsp?taskId=" + id + "&alertType=" + alertType + "&timestamp=" + new Date().getTime());
	  }else{
  		deleteGridRow(mygridPositiveAlerts,id,baseDirectory + "monitor/removeMonitorAlertAction.jsp?taskId=" + id + "&alertType=" + alertType + "&timestamp=" + new Date().getTime());
	  }
  }
  
	//alerts end
	
	function hideMessageDiv(){
		document.getElementById("messageDiv").style.display = "none";
	}
	
	function toggleSendAgentAddressDiv() {
   	var sendAgentAddressDiv = document.getElementById("sendAgentAddressDiv");
   	var version = document.getElementById("version");
   	if(sendAgentAddressDiv && version) {
    	if(version.value == <%=SNMPAccount.SNMP_VERSION_1 %>) {
    		sendAgentAddressDiv.style.visibility = "visible";
    	}else {
    		sendAgentAddressDiv.style.visibility = "hidden";
    	}
    }
  }

	function toggleFrom(isSystem, suffix) {
		if(!suffix) {
			suffix = "";
		}
		var mailFrom = document.getElementById("mailFrom" + suffix);
		var fromCustom = document.getElementById("fromCustom" + suffix);
		if(mailFrom && fromCustom) {
			if(isSystem) {
				fromCustom.disabled = true;
				fromCustom.value = "";
			}else {
				fromCustom.disabled = false;
			}
		}
	}
	
</script>

<jsp:include page="../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../common/selectLogHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="../" />
	<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
	<jsp:param name="FILTER_ID" value="<%=selectedFilterId%>" />
	<jsp:param name="mode" value="logs" />
	<jsp:param name="treeOnly" value="true" />
	<jsp:param name="ignoreHeader" value="true" />
	<jsp:param name="allowNewLog" value="true" />
	<jsp:param name="logPopupMenu" value="true" />
	<jsp:param name="parameterName" value="Monitor log:" />
	<jsp:param name="openLinkName" value="select log" />
	<jsp:param name="showMonitorsModule" value="true" />
	<jsp:param name="showNewFilter" value="false" />
	<jsp:param name="paramNameWidth" value="150" />
	<jsp:param name="dummy" value="dummy" />
	<jsp:param name="newFilterLabel" value="Match Text"/>
</jsp:include>
<jsp:include page="../common/accountsListCombo.jsp" flush="true">
	<jsp:param name="base_directory" value="../"/> 
	<jsp:param name="scriptsOnly" value="true"/>
</jsp:include>
<%
String allowNewLogStr = request.getParameter("allowNewLog");
boolean allowNewLog = allowNewLogStr == null || allowNewLogStr.equals("true");
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION,false)){
	allowNewLog = false;
}
String actionsNames = allowNewLog ? "Create new Log#Close" : "Close";
String actions = allowNewLog ? "javascript:openNewLogDiv()#javascript:closeLogSelectionDiv()" : "javascript:closeLogSelectionDiv()";

%>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Log to Monitor"/> 
	<jsp:param name="suffix" value="SelectLog"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>


<script>
	var lastSelectedMonitorLog= "<%=selectedLogId%>";
	function updateSourceForLogChange(id,name){
		if (id){
			var lbmId = "";
			if (id.indexOf("Log-") == 0){
				lbmId = id.substring(4);
			}else{
				lbmId = id;
			}
			var url = "filtersList.jsp?isAjax=true&lbmId="+lbmId;
			if (lbmId == "<%=selectedLogId%>"){
				url += "&filterId=<%=selectedFilterId%>";
			}
			document.access.logs.value = lbmId;
			var selectedLog = tree.getAllCheckedAndPartiallyChecked();
			if(selectedLog == '') {
				selectedLog = lbmId;
			}
			var noLogDiv = document.getElementById("noLogDiv");
			var hasLogDiv = document.getElementById("hasLogDiv");
			if(selectedLog == '') {
				noLogDiv.style.display = "";
				hasLogDiv.style.display = "none";
			}else {
				noLogDiv.style.display = "none";
				hasLogDiv.style.display = "";
			}
			sendAjaxRequest(url,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not get logs list!");
					return;			
				}
				if (result != "NO_FILTERS"){
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = result; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT"><%=selectFilterString%></span>';
					}
				}else{
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = ""; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT" style="color:#9E5B04">* No rules are assigned to this log. </span>';
					}
					<%if(allowNewFilter) {%>
						openNewFilterDiv(50,250);
					<%}%>
				}
			});
			lastSelectedMonitorLog = selectedLog;
		}
	}

	function updateSourceForFilterChange(lbmId,filterId){
		if (lbmId){
			var url = "filtersList.jsp?";
			var params = "isAjax=true&lbmId="+lbmId;
			var filterIds = "&filterId="+ getSelectedFilters();
			if (filterIds){
				filterIds += "," + filterId;
			}
			params += filterIds;
			document.access.logs.value = lbmId;
			sendAjaxRequest(url,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not get logs list!.");
					return;			
				}
				if (result != "NO_FILTERS"){
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = result; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT">Select or </span>';
					}
				}else{
					var e = document.getElementById("filtersListDiv");
					if (e){
						e.innerHTML = ""; 
					}
					e = document.getElementById("filtersSelectionLabelTD");
					if (e){
						e.innerHTML = '<span class="REGULARTEXT" style="color:#9E5B04">* No rules are assigned to this log. </span>';
					}
				}
			}, 'POST', params);
		}
	}
	
	function getSelectedFilters(){
		if (document.access.filters){
			var selectedFilters = "";
			var len = document.access.filters.length;
			if (!len){
				return document.access.filters.value;
			}
			for (var i=0; i<len; i++){
				if (document.access.filters[i].checked){
					selectedFilters = selectedFilters + "," + document.access.filters[i].value;
				}
			}
			return selectedFilters;
		}else{
			return "";
		}
	}
	
	function updateFromMailTask(){
		if (document.access.mailTasks){
			var taskId = document.access.mailTasks.options[document.access.mailTasks.selectedIndex].value;
			sendAjaxRequest("alerts/setMonitorAlertInSession.jsp?taskId="+taskId,function(req){
				var result = req.responseText;	
				if(!result){
					alert("Error updating email alert");
					return;			
				}else{
					result = result.replace(/^\s+|\s+$/g, '') ;
					if (result.indexOf("ERROR") != -1){
					}else{
						var url = "../tasks/mail/mailTaskDefinition.jsp?";
						var params = "base_directory=<%=BASE_DIRECTORY%>&noScripts=true&embedded=true&isMulti=<%=isMulti %>";
						params += "&showName=false&showFrom=false&showAdvanced=true&suffix=MailAlert&onlyUpdate=true"+mailTaskLabels;
						params += "&tasks=" + encode(mailTasksList);
						sendAjaxRequest(url,function(req){
							var result2 = req.responseText;	
							result2 = result2.replace(/^\s+|\s+$/g, '') ;
							var e = document.getElementById("taskDescriptionTDMailAlert");
							if (e){
								e.innerHTML = result2;
							}
						}, 'POST', params);

					}
				}
			});
		}
	}
	
	function updateFromSNMPTask(){
		if (document.access.snmpTasks){
			var taskId = document.access.snmpTasks.options[document.access.snmpTasks.selectedIndex].value;
			sendAjaxRequest("alerts/setMonitorAlertInSession.jsp?taskId="+taskId,function(req){
				var result = req.responseText;	
				if(!result){
					alert("Error updating SNMP trap");
					return;			
				}else{
					result = result.replace(/^\s+|\s+$/g, '') ;
					if (result.indexOf("ERROR") != -1){
					}else{
						var url = "../tasks/snmp/snmpTaskDefinition.jsp?";
						var params = "embedded=true&noScripts=true&suffix=SNMPAlert&onlyUpdate=true"+snmpTaskLabels;
						params += "&tasks=" + encode(snmpTasksList);
						sendAjaxRequest(url,function(req){
							var result2 = req.responseText;	
							result2 = result2.replace(/^\s+|\s+$/g, '') ;
							var e = document.getElementById("taskDescriptionTDSNMPAlert");
							if (e){
								e.innerHTML = result2;
							}
						}, 'POST', params);

					}
				}
			});
		}
	}
	
	function updateFromJMSTask(){
		if (document.access.jmsTasks){
			var taskId = document.access.jmsTasks.options[document.access.jmsTasks.selectedIndex].value;
			sendAjaxRequest("alerts/setMonitorAlertInSession.jsp?taskId="+taskId,function(req){
				var result = req.responseText;	
				if(!result){
					alert("Error updating JMS message");
					return;			
				}else{
					result = result.replace(/^\s+|\s+$/g, '') ;
					if (result.indexOf("ERROR") != -1){
					}else{
						var url = "../tasks/jms/jmsTaskDefinition.jsp?";
						var params = "embedded=true&noScripts=true&suffix=JMSAlert&onlyUpdate=true"+jmsTaskLabels;
						params += "&tasks=" + encode(jmsTasksList);
						sendAjaxRequest(url,function(req){
							var result2 = req.responseText;	
							result2 = result2.replace(/^\s+|\s+$/g, '') ;
							var e = document.getElementById("taskDescriptionTDJMSAlert");
							if (e){
								e.innerHTML = result2;
							}
						}, 'POST', params);

					}
				}
			});
		}
	}
	
	function updateFromExeTask(){
		if (document.access.exeTasks){
			var taskId = document.access.exeTasks.options[document.access.exeTasks.selectedIndex].value;
			sendAjaxRequest("alerts/setMonitorAlertInSession.jsp?taskId="+taskId,function(req){
				var result = req.responseText;	
				if(!result){
					alert("Error updating batch execution alert");
					return;			
				}else{
					result = result.replace(/^\s+|\s+$/g, '') ;
					if (result.indexOf("ERROR") != -1){
					}else{
						var url = "../tasks/execute/exeTaskDefinition.jsp?";
						var params = "embedded=true&noScripts=true&suffix=ExeAlert&onlyUpdate=true"+exeTaskLabels;
						params += "&tasks=" + encode(exeTasksList);
						sendAjaxRequest(url,function(req){
							var result2 = req.responseText;	
							result2 = result2.replace(/^\s+|\s+$/g, '') ;
							var e = document.getElementById("taskDescriptionTDExeAlert");
							if (e){
								e.innerHTML = result2;
							}
						}, 'POST', params);

					}
				}
			});
		}
	}
	
	function selectTabHandler(idn,ido){
		if (!idn){
			return false;
		}
		hideAllGeneralAdminDiv();
		return true;
	}
</script>

<title></title>
</head>

<div id="addAccDiv" style="display:none">
</div>

<%
String onLoadFunctions = "initMenusAlerts();initMenusPositiveAlerts();initTables();init()";
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=monitorActionPage%>" style="margin:0;padding:0" method="POST">
<input type="hidden" name="suffix" value="session">
<input type="hidden" name="doSave" value="true">
<input type="hidden" name="LOG_ID">
<input type="hidden" name="mods">
<input type="hidden" name="logs" value="<%=selectedLogId%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="1">
		<td>
			<jsp:include page="../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="name" size="30" value="<%=monitorName%>" onClick="resetBgColor(this)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:5">&nbsp;</span></td>
										</tr>
										<tr>
											<td><span class="REGULARTEXT">Description:</span></td>
											<td>
												<input type="text" class="TEXTBOX" name="desc" size="30" value="<%=monitorDesc%>"> 
											</td>
											<td>&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
										<%if (!isMulti){%>
										<tr height="10">
											<td valign="top" colspan="3">
												<jsp:include page="../common/selectLog.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../" />
													<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
													<jsp:param name="FILTER_ID" value="<%=selectedFilterId%>" />
													<jsp:param name="ignoreHeader" value="true"/>
													<jsp:param name="noTree" value="true"/>
													<jsp:param name="mode" value="logs" />
													<jsp:param name="allowNewLog" value="true" />
													<jsp:param name="logPopupMenu" value="true" />
													<jsp:param name="parameterName" value="Monitored Log:" />
													<jsp:param name="openLinkName" value="select log" />
													<jsp:param name="showMonitorsModule" value="true" />
													<jsp:param name="showNewFilter" value="false" />
													<jsp:param name="labelWidth" value="150" />
													<jsp:param name="textBoxSize" value="30" />
													<jsp:param name="newFilterTitle" value="Create New Monitor Rule" />
													<jsp:param name="newFilterLabel" value="Match Text" />
												</jsp:include>
											</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
										<%} %>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
							<div id="generalDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding:10px">							
								<jsp:include page="<%=monitorGeneralPage%>" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="alertsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding:10px">							
								<jsp:include page="monitorAlerts.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="schedulerDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="monitorDefinitionSched.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="advancedDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px;padding-right:10px">							
								<jsp:include page="monitorDefinitionAdvanced.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td>
								</tr>
								</table>
							</div>
							<%if (XpologSecurityManager.getInstance().isEnabled()){%>
							<div id="permissionsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding:10px">							
								<jsp:include page="../security/common/moduleMemberPermissionsIncluder.jsp" flush="true">
									<jsp:param name="embedded" value="true" />
 									<jsp:param name="ignoreName" value="true"/>
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="<%=generalTabName%>" />
								<jsp:param name="id.2" value="alertsDiv" />
								<jsp:param name="name.2" value="Alerts" />
								<jsp:param name="id.3" value="schedulerDiv" />
								<jsp:param name="name.3" value="Schedule" />
								<jsp:param name="id.4" value="advancedDiv" />
								<jsp:param name="name.4" value="Advanced" />
								<jsp:param name="id.5" value="permissionsDiv" />
								<jsp:param name="name.5" value="Security" />
							</jsp:include>
							<%}else{ %>
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="<%=generalTabName%>" />
								<jsp:param name="id.2" value="alertsDiv" />
								<jsp:param name="name.2" value="Alerts" />
								<jsp:param name="id.3" value="schedulerDiv" />
								<jsp:param name="name.3" value="Schedule" />
								<jsp:param name="id.4" value="advancedDiv" />
								<jsp:param name="name.4" value="Advanced" />
							</jsp:include>
							<%} %>								
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Monitors" />
				<jsp:param name="actions" value="javascript:saveMonitor()#monitor/monitorsView.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>
<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=310">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="20">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
					<span class="PROGRESSTEXT" id="messageTitle"></span>
			</td>
		</tr>
		<tr height="*" style="padding:5">
			<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
			</td>
		</tr>											
		<tr height="10">
			<td align="center" style="padding:5"><nobr>
				<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
				</nobr>		  							
			</td>
		</tr>
	</table>
</div>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlert"/> 
	<jsp:param name="width" value="600px"/> 
	<jsp:param name="height" value="420px"/>
	<jsp:param name="title" value="Email Alert"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('MailAlert')#javascript:closeAlertDiv('MailAlert')"/> 
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlertPrecondition"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="300px"/>
	<jsp:param name="title" value="XpoLog Center Mail Settings"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()#javascript:closeAlertDiv('MailAlertPrecondition')"/> 
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="SNMPAlert"/> 
	<jsp:param name="width" value="830px"/> 
	<jsp:param name="height" value="450px"/> 
	<jsp:param name="title" value="SNMP Trap"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('SNMPAlert')#javascript:closeAlertDiv('SNMPAlert')"/> 
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="JMSAlert"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="440px"/> 
	<jsp:param name="title" value="JMS Message"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('JMSAlert')#javascript:closeAlertDiv('JMSAlert')"/> 
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="ExeAlert"/> 
	<jsp:param name="width" value="705px"/> 
	<jsp:param name="height" value="420px"/> 
	<jsp:param name="title" value="Batch Execution"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('ExeAlert')#javascript:closeAlertDiv('ExeAlert')"/> 
</jsp:include>
</form>
<script>
function handleMenuItemsAlerts(){
	aMenuAlerts.menu.showButtons("editTask,deleteTask");
}
function handleMenuItemsPositiveAlerts(){
	aMenuPositiveAlerts.menu.showButtons("editPositiveTask,deletePositiveTask");
}
</script>
</body>
</html>