<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
	static final String [] logRulesNames = {"more than", " less than"};
	static final String [] multiRulesNames = {"at least one monitor failed", "all monitors failed"};
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	Verifier monitor = builder.getVerifier();
	if (monitor == null){
		monitor = new LogVerifier();
	}
	
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}

	boolean showFailTaskExecPolicy = monitor != null && monitor.getType().equals(LogVerifier.LOG_TYPE);
	long failCountForAggTasks = builder.getFailCountForAggregationTasks();
	int posAlertInterval = builder.getPositiveAlertInterval();
	int intervalTimeUnit = builder.getIntervalTimeUnit();
	int maxFailAlerts = builder.getMaxFailTasksExecutions();
	String maxFailAlertsStr = maxFailAlerts == -1 ? "" : String.valueOf(maxFailAlerts);

  String[] rulesNames = null;
	if (monitor.getType().equals(LogVerifier.LOG_TYPE)){
		rulesNames = logRulesNames;
	}else{
		rulesNames = multiRulesNames;
	}

%>
<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<%
	if (monitor.getType().equals(LogVerifier.LOG_TYPE)){
		boolean runFromLastLocation = ((LogVerifier)monitor).isRunFromLastLocation();
	%>
	<tr>
		<td style="padding-top:20"><span class="HEADER">Monitor Execution Policy</span><b>&nbsp;</b></td>
	</tr>
	<tr>
		<td>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>                                                                      
				<td><input type="checkbox" name="runFromLastLocation" value="true" <%=runFromLastLocation ? "checked" : ""%> ></td>
				<td nowrap><span class="REGULARTEXT">Scan log from last scan point</span></td>
				<td width="90%"></td>
			</tr>
		</table>
		</td>
	</tr>
	<%}%>
	
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td><span class="HEADER">Failure</span><b>&nbsp;</b></td>
	</tr>
	<%if (monitor.getType().equals(LogVerifier.LOG_TYPE)){ %>
	<tr>
		<td>
			<span class="REGULARTEXT"><nobr>&nbsp;Failure means that there are &nbsp;<nobr>
			   <select size="1" name="rulesType" id="rulesType">
				  <% for (int i = 0; i < rulesNames.length; i++){%>
							<option class="REGULARTEXT" value="<%=String.valueOf(i)%>"  <%=((LogVerifierBuilder)builder).getRuleType() == i? "selected" : ""%>><%=rulesNames[i]%></option>
							<%}%>
						</select> </span>
			<input type="text" class="TEXTBOX" name="recordsAmount" size="5" value="<%=((LogVerifierBuilder)builder).getRecordsAmount()%>" onClick="resetBgColor(this)"> 
			<span class="REGULARTEXT"><nobr>&nbsp;records in the result.</nobr></span> 
		</td>
	</tr>
	<%}else{ %>
	<tr>
		<td>
			<span class="REGULARTEXT"><nobr>&nbsp;Failure means that &nbsp;</nobr></span> 
			<select size="1" name="rulesType" id="rulesType">
				<% for (int i = 0; i < rulesNames.length; i++){%>
				<option class="REGULARTEXT" value="<%=String.valueOf(i)%>"  <%=((MultiVerifierBuilder)builder).getRuleType() == i? "selected" : ""%>><%=rulesNames[i]%></option>
				<%}%>                     
			</select>																			
		</td>
	</tr>
	<%} %>
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>
			<span class="REGULARTEXT">
				<nobr>&nbsp;Once failed, execute failure actions only after &nbsp;</nobr>
				<input type="text" class="TEXTBOX" name="failCountForAggTasks" size="5" value="<%=(failCountForAggTasks != -1 ? String.valueOf(failCountForAggTasks) : "")%>">
				<nobr>&nbsp;monitor failures</nobr> 
			</span>
		</td>
	</tr>
	<%
	if (monitor.getType().equals(LogVerifier.LOG_TYPE)){
		int policy = ((LogVerifier)monitor).getFailTaskExecPolicy();
	%>
	<tr>
		<td>
		<table border="0" width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td width="30%"><span class="REGULARTEXT"><nobr>&nbsp;Once failed, execute failure actions for: &nbsp;</nobr></span></td>
				<td width="70%"><input type="radio" name="eventExecution" value="<%=LogVerifier.NO_EVENT%>" <%=policy==LogVerifier.NO_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; none of the events</span></td>						
			</tr>
			<tr>
				<td></td>
				<td><input type="radio" name="eventExecution" value="<%=LogVerifier.FIRST_EVENT_ONLY%>" <%=policy==LogVerifier.FIRST_EVENT_ONLY ? "checked":""%>><span class="REGULARTEXT">&nbsp; the first event only</span></td>						
			</tr>
			<tr>
				<td></td>
				<td><input type="radio" name="eventExecution" value="<%=LogVerifier.EACH_EVENT%>" <%=policy==LogVerifier.EACH_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; each event</span></td>						
			</tr>
			<tr>
				<td></td>
				<td><input type="radio" name="eventExecution" value="<%=LogVerifier.LAST_EVENT_ONLY%>" <%=policy==LogVerifier.LAST_EVENT_ONLY ? "checked":""%>><span class="REGULARTEXT">&nbsp; the last event only</span></td>						
			</tr>
		</table>
		</td>
	</tr>
	<%}%>
	<tr><td>&nbsp;</td></tr>						
	<tr>
		<td>
			<span class="REGULARTEXT">&nbsp;Maximum number of alerts to send: &nbsp;</span>
			<input type="text" name="maxFailAlerts" class="TEXTBOX" value="<%=maxFailAlertsStr%>" size="5" onClick="resetBgColor(this)" onChange="javascript:checkMaxAlert(this.value)">
		</td>						
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td><span class="HEADER">Positive</span><b>&nbsp;</b></td>
	</tr>
	<tr>
		<td><span class="REGULARTEXT">&nbsp;Execute positive alert(s) after 
			<input type="text" class="TEXTBOX" name="posAlertInterval" size="5" value="<%=(posAlertInterval != -1 ? String.valueOf(posAlertInterval) : "")%>" onClick="resetBgColor(this)">
			<select name="timeUnit" id="timeUnit">
			<%
			String[] timeUnits = VerifierTasksListener.getTimeUnits();
			for (int i = 0; i < timeUnits.length; i++) {
				String tu = timeUnits[i];
				int tv = -1;
				try{
					tv = Integer.parseInt(VerifierTasksListener.getTimeUnitValue(tu));
				}catch(Exception e){}
					if (tu.length() == 0){
					tu = "- select -";
				}
			%>
				<option class="REGULARTEXT" value="<%=tv%>"<%=intervalTimeUnit == tv ? " selected" : ""%>><%=tu%></option>
			<%}%>
			</select> &nbsp;from last failure </span>
		</td>
	</tr>
	<tr>
		<td width="100%">
			<span class="SMALLTEXT">&nbsp;Note: if no positive alert settings are defined positive alert<br>
			&nbsp;will be sent upon first monitor success following a monitor failure
			</span>
		</td>
	</tr>
	<%
	if (monitor.getType().equals(LogVerifier.LOG_TYPE)){
		int posAlertPolicy = ((LogVerifier)monitor).getPositiveAlertPolicy();
	%>
	<tr>
		<td>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td width="30%"><span class="REGULARTEXT">&nbsp;Send positive alert </span></td>
				<td width="70%"><input type="radio" name="posAlertPolicy" value="<%=LogVerifier.ONCE%>" <%=posAlertPolicy==LogVerifier.ONCE || posAlertPolicy==LogVerifier.UNDEFINED? "checked":""%>><span class="REGULARTEXT">&nbsp; once only</span></td>						
			</tr>
			<tr>
				<td width="30%"></td>
				<td width="70%"><input type="radio" name="posAlertPolicy" value="<%=LogVerifier.FOR_EACH_EVENT%>" <%=posAlertPolicy==LogVerifier.FOR_EACH_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; for each executed failure action</span></td>						
			</tr>
		</table>
		</td>
	</tr>
	<%}%>
	<tr>
		<td class="SMALLTEXT">&nbsp;</td>
	</tr>
	<tr>
		<td>
			<span class="SMALLTEXT">execute following actions upon <b>positive alert</b> signal:</span>
		</td>
	</tr>
	
	<tr>
		<td>
			<%
			String suffix = "PositiveAlerts";
			
			boolean showMenu = true;
			if(showMenu) {
				String menuIds = "editPositiveTask,deletePositiveTask";
				String menuTexts = "Edit,Delete";
				String menuHrefs = "javascript:editTask();,javascript:deleteTask();";
			%>
				<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
					<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				  <jsp:param name="suffix" value="<%=suffix %>" />
				</jsp:include>
				<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
				  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				  <jsp:param name="showMenu" value="<%=showMenu%>" />
				  <jsp:param name="menuIds" value="<%=menuIds%>" />
				  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
				  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
				  <jsp:param name="suffix" value="<%=suffix %>" />
				</jsp:include>
			<%
			}
			%>
			
			<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="suffix" value="<%=suffix%>" />
			</jsp:include>
			
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr>
					<td id="positiveAlertsTD" valign="top">
					<%
					String menu = showMenu ? "aMenu" + suffix : "";
					
					String addName = "New Email#New SNMP#New JMS#New Batch Execution";
			    String addLink = "javascript:addMailAlert()#javascript:addSNMPAlert()#javascript:addJMSAlert()#javascript:addExeAlert()";
			    
					String tableNames = "Edit#Delete";
			    String tableActions = "javascript:editTask()#javascript:deleteTask()";
			    String ids = "EditPositive#DeletePositive";
			    String selectTypes = "2#2";
					%>
					<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="initXML" value="monitor/monitorPositiveAlertsXML.jsp" />
						<jsp:param name="updateXML" value="monitor/monitorPositiveAlertsXML.jsp?dataOnly=true" />
						<jsp:param name="menu" value="<%=menu%>"/>
						<jsp:param name="newActionNames" value="<%=addName%>" />
						<jsp:param name="newActions" value="<%=addLink%>" />
						<jsp:param name="tableActionNames" value="<%=tableNames%>" />
						<jsp:param name="tableActions" value="<%=tableActions%>" />
						<jsp:param name="tableActionIds" value="<%=ids%>" />
						<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
						<jsp:param name="suffix" value="<%=suffix %>" />
						<jsp:param name="recordsText" value="Positive Alerts" />
						<jsp:param name="style" value="main" />
						<jsp:param name="doubleClickAction" value="editTask" />
					</jsp:include>
					</td>
				</tr>
			</table>
			<script>
				function updateButtonActivatePositiveAlerts(rowid,id,columnType,gridType){
					if (!id || id == "") return;
					enableActionButton(id);
				}
			</script>
		</td>
	</tr>
</table>