<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.MultiVerifierBuilder"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";
	String ERROR_OBJ = "ERROR_OBJ";
	
	MultiVerifierBuilder builder = (MultiVerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	
	UserContext userContext = UserEnvironment.getUserContext(request);

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
  }
	UserSecurity security = manager.getUserSecurity(request);
	ErrorModel errmodel = new ErrorModel();
		
	String name = request.getParameter("name");
	if (name == null || name.trim().equals("")){
		errmodel.addError("No Name was supplied.");
	}
	if(WebUtil.isContainSpecialCharecter(name)){
		errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
	}
	String desc = request.getParameter("desc");

	String [] verifiersIds = request.getParameterValues("SelectedVerifiersList");
	if (verifiersIds == null || verifiersIds.length == 0){
		errmodel.addError("At least one monitor must be selected.");
	}
	
 
	int ruleType = Integer.parseInt(request.getParameter("rulesType"));
	
	if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
	
	boolean edit = (builder.getId() != null);
	
	ErrorModel errmod = new ErrorModel();
	builder.setName(name);
	builder.setDescription(desc);
	builder.setRuleType(ruleType);
	builder.setVerifiersIds(verifiersIds);

	
	String failCountForAggTasksStr = request.getParameter("failCountForAggTasks");
	String posAlertIntervalStr = request.getParameter("posAlertInterval");
	String timeUnitStr = request.getParameter("timeUnit");
	int failCountForAggTasks = -1;
	try{
		failCountForAggTasks = (failCountForAggTasksStr != null && failCountForAggTasksStr.length() > 0) ? Integer.parseInt(failCountForAggTasksStr) : -1;
	}catch(Exception e){
		errmod.addError("Failed to parse number of failures");
	}
	int posAlertInterval = -1;
	try{
		posAlertInterval = (posAlertIntervalStr != null && posAlertIntervalStr.length() > 0) ? Integer.parseInt(posAlertIntervalStr) : -1;
	}catch(Exception e){
		errmod.addError("Failed to parse number of executions for positive alert");
	}
	int timeUnit = (timeUnitStr != null && timeUnitStr.length() > 0 && !timeUnitStr.equals("0")) ? Integer.parseInt(timeUnitStr) : -1;
	builder.setFailCountForAggregationTasks(failCountForAggTasks);
	builder.setPositiveAlertInterval(posAlertInterval);
	builder.setIntervalTimeUnit(timeUnit);
	if ((builder.getPositiveAlertInterval() != -1 && builder.getIntervalTimeUnit() == -1 ) ||
			(builder.getPositiveAlertInterval() == -1 && builder.getIntervalTimeUnit() != -1 )
	){
		errmod.addError("Wrong positive alerts settings");
	}
	
	//scheduler
	XpoScheduledOperation opSched = null;
  try {
  	String trigType = request.getParameter("trigTypeMonitorSched");  	
  	opSched = trigType == null || trigType.length() == 0 ? null : SchedulerHelper.getVerifierScheduledOperation(request,"MonitorSched",errmodel);  	
  	builder.setSchedOp(opSched);
  }catch (Exception e){
  	e.printStackTrace();
  	errmodel.addError("Invalid scheduler rule. Please make sure the scheduler rule is valid and try again");
  }

	
	errmod = VerifiersHelper.saveVerifier(request, builder);

	if (errmod != null){
  	request.getSession().setAttribute(ERROR_OBJ,errmod);
  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
  	return;
	}else{
		request.getSession().removeAttribute("CURRENT_VERIFIER_RESULT");
		request.getSession().setAttribute("CURRENT_VERIFIER",builder.getVerifier());
	}
	
	response.sendRedirect("addopok.jsp?refreshMenu=true");
	
%>