<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@ page import="xpolog.eye.computation.TopComputationResult"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlert"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidget"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.widgets.view.XpoLogWidgetView"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../";

static final int WIDE_GRAPH_WIDTH = 1000;
static final int NARROW_GRAPH_WIDTH = 850;
static final int STEP_GRAPH_WIDTH = 1024;
static final int TALL_GRAPH_HEIGHT = 270;
//static final int SHORT_GRAPH_HEIGHT = 180;
static final int SHORT_GRAPH_HEIGHT = 270; // leave height same as in high resolution for now
static final int STEP_GRAPH_HEIGHT = 768;
%>

<%
String HOME_PAGE_HEALTH_VIEW_MODEL = "HomePageHealthViewModel";
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

UserContext userContext = UserEnvironment.getUserContext(request);
boolean isResize = request.getParameter("useCache") != null && request.getParameter("useCache").equals("true"); 

HealthViewModel model = (HealthViewModel)session.getAttribute(HOME_PAGE_HEALTH_VIEW_MODEL);;
if (!isResize || model == null){
	model = new HealthViewModel();
	ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
	DateFilter defaultDisplayDateFilter = ComputationConfigurationHelper.getDefaultDisplayDateFilter(model, computationConfiguration);

	model.setTimeFilter(defaultDisplayDateFilter);
	model.setViewBy(computationConfiguration.getViewBy());
	model.setViewType(computationConfiguration.getViewType());
	model.setViewGroupType(computationConfiguration.getViewGroupType());
	model.setShowMetrics(computationConfiguration.isShowMetrics());
	model.setViewHierarchyType(computationConfiguration.getViewHierarchyType());

	model.setCheckMissingExecutions(false);

	model.updateModel(HealthViewModel.ACTION_LOAD_DATA, userContext, null, true, false);	
}

session.setAttribute(HOME_PAGE_HEALTH_VIEW_MODEL, model);

HealthViewResult currentResult = model.getCurrentResult();

String windowWidthStr = request.getParameter("windowWidth");
int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;
//int graphWidth = windowWidth != -1 && windowWidth <= STEP_GRAPH_WIDTH ? NARROW_GRAPH_WIDTH : WIDE_GRAPH_WIDTH;
int graphWidth = windowWidth != -1 ? windowWidth : NARROW_GRAPH_WIDTH;
String windowHeightStr = request.getParameter("windowHeight");
int windowHeight = windowHeightStr != null && windowHeightStr.length() > 0 ? Integer.parseInt(windowHeightStr) : -1;
int graphHeight = windowHeight != -1 && windowHeight <= STEP_GRAPH_HEIGHT ? SHORT_GRAPH_HEIGHT : TALL_GRAPH_HEIGHT;


HealthViewGraphQuery graphQuery = new HealthViewGraphQuery(graphWidth, graphHeight, null);
graphQuery.setShowTooltip(false);
graphQuery.setShowZoom(false);
graphQuery.setShowMeasurments(model.isShowMetrics());
HealthViewGraphResult graphResult = HealthViewHelper.generateTotalXYChart(currentResult, graphQuery);

String graphImagePath = baseDirectory + graphResult.getImagePath();

DateFilter dateFilter = model.getTimeFilter();
Date minDate = dateFilter.getMinDate();
Date maxDate = dateFilter.getMaxDate();

String minDateString = DateUtil.transformDateToString(minDate);
int minIndex = minDateString.indexOf(" ");
String minDateShortString = minDateString.substring(0, minIndex);
String minTimeString = minDateString.substring(minIndex + 1);
if(minTimeString.indexOf(":") != minTimeString.lastIndexOf(":")) {
	minTimeString = minTimeString.substring(0, minTimeString.lastIndexOf(":"));
}

String maxDateString = DateUtil.transformDateToString(maxDate);
int maxIndex = maxDateString.indexOf(" ");
String maxDateShortString = maxDateString.substring(0, maxIndex);
String maxTimeString = maxDateString.substring(maxIndex + 1);
if(maxTimeString.indexOf(":") != maxTimeString.lastIndexOf(":")) {
	maxTimeString = maxTimeString.substring(0, maxTimeString.lastIndexOf(":"));
}


request.setAttribute("homeCurrModel",model);

boolean showMetrics = ComputationConfiguration.getInstance().isShowMetrics();
showMetrics = showMetrics && model.getCurrentResult().getRootHostResultElement() != null;

XpoLogWidget [] widgets = XpoLogWidgetsManager.getIntsance().getUserWidgets(request,"dashboard");
int widgetsLen = widgets == null ? 0 : widgets.length;
response.setContentType("text/xml");

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>

<HomePageDashboardResponse>
	<Response showMetrics="<%=showMetrics %>">
	<![CDATA[
		<input type="hidden" id="dashboardMinDateFullStr" name="dashboardMinDateFullStr" value="<%=minDateString %>">
		<input type="hidden" id="dashboardMaxDateFullStr" name="dashboardMaxDateFullStr" value="<%=maxDateString %>">
		
		<div id="dashboardMetricsGraphLegendDiv" class="HOME_PAGE_DASHBOARD_METRICS_GRAPH_LEGEND_DIV">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td><span class="HOME_PAGE_DASHBOARD_METRICS_GRAPH_LEGEND_CPU_TEXT">CPU</span>&nbsp;<span class="HOME_PAGE_DASHBOARD_METRICS_GRAPH_LEGEND_TEXT_SEPERATOR">|</span>&nbsp;<span class="HOME_PAGE_DASHBOARD_METRICS_GRAPH_LEGEND_MEMORY_TEXT">Memory</span></td>
				</tr>
			</table>
		</div>
		
		<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">	
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_GRAPH_LEFT_PAD">&nbsp;</td>
				<td>
					<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
						<tr height="10px">
							<td class="HOME_PAGE_DASHBOARD_GRAPH_TITLE_CELL">
								<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
									<tr valign="middle">
										<td class="HOME_PAGE_DASHBOARD_SUB_TITLE_TEXT HOME_PAGE_DASHBOARD_GRAPH_TITLE_TEXT_CELL"><%=analyticsH%> Summary</td>
										<td class=""><a href="<%=baseDirectory %>componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>" class="HOME_PAGE_DASHBOARD_SUB_TITLE_LINK">Go to <%=analyticsH %></a></td>
										<td>&nbsp;</td>
										<td class="HOME_PAGE_DASHBOARD_TITLE_DATES_TEXT"><%=(minDateShortString + " " + minTimeString) %> - <%=(maxDateShortString + " " + maxTimeString) %></td>
										<td width="10px">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
						<tr height="10px">
							<td id="dashboardGraphTd" class="HOME_PAGE_DASHBOARD_GRAPH_CELL" style="height:300px">
								<a href="<%=baseDirectory %>componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>" onMouseOver="javascript:showTooltip(homePageTooltips['goToDashboard'])" onMouseOut="javascript:hideTooltip()"><img border="0" id="graphImage" src="<%=graphImagePath%>"></a>
							</td>
						</tr>
						<tr height="20px"><td>&nbsp;</td></tr>
						<tr height="10px">
							<td>
								<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
                  <% 
                    for (int i = 0; i < widgetsLen;i++){
                      XpoLogWidget widget = widgets[i];  
                      XpoLogWidgetView view  = widget.getView();
                      String widgetId = widget.getId();
                  %>
									<tr valign="middle">
                      <%
                        String loadPage = view == null ? null : widget.getView().getLoadPage();
                        if (loadPage != null && loadPage.length() > 0){
                          if (loadPage.startsWith("file:")){
                        	  String html = view.getHTMLFile(loadPage);
                              %>
                              <%=html%>
                            <%
                        	  }else {
                        	  loadPage = BASE_DIRECTORY + loadPage;
                         %>
                           <jsp:include page="<%=loadPage%>" flush="true">
											<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                      <jsp:param name="widgetId" value="<%=widgetId%>" />
										</jsp:include>
                    <%     	
                          }
                        }
                      %>
                  
										<td width="20px">&nbsp;</td>			
                    <%
                    i++;
                    if (i < widgetsLen){
                      widget = widgets[i];
                      widgetId = widget.getId();
                      loadPage = widget.getView() == null ? null : widget.getView().getLoadPage();
                      if (loadPage != null && loadPage.length() > 0){
                    	  if (loadPage.startsWith("file:")){
                          String html = view.getHTMLFile(loadPage);
                          %>
                          <%=html%>
                        <%
                    	  }else {                        
                        	  loadPage = BASE_DIRECTORY + loadPage;
                       %>
                       <jsp:include page="<%=loadPage%>" flush="true">
                          <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                          <jsp:param name="widgetId" value="<%=widgetId%>" />
                       </jsp:include>
                      <%     	
                    	  }
                        }
                    }else {                    
                      %>
                    <td class="HOME_PAGE_DASHBOARD_ALERTS_TOP_CELL">&nbsp;
                    </td>
                    <%}%>							
									</tr>
									
									<%}%>
								</table>
							</td>
						</tr>
					</table>
				</td>
				<td class="HOME_PAGE_DASHBOARD_GRAPH_RIGHT_PAD">&nbsp;</td>
			</tr>
		</table>
	]]>
	</Response>
</HomePageDashboardResponse>