<%@ page language="java"%>

<%@ page import="java.util.List"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.ApplicationComponent"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.XpologLicenseManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

WebSecurityManager securityManager = WebSecurityManager.getInstance();
if (!securityManager.checkForPermission(request,response,null,true)){
  return;
}

UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);

List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
boolean showComps = comps.size() > 1;

boolean xpologEnabled = false;
boolean searchEnabled = false;
boolean dashboardEnabled = false;
boolean txexpoEnabled = false;
String xpologLink = "";
String xpologSearchLink = "";
String dashboardLink = "";
String txexpoLink = "";
for(int i=0;i<comps.size();i++) {
	ApplicationComponent comp = (ApplicationComponent)comps.get(i);		
	if(comp != null && comp.getName().equals("XpoLog") && comp.isVisible()) {
		xpologEnabled = true;
		xpologLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals("Search Engine") && comp.isVisible()) {
		searchEnabled = true;
		xpologSearchLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
		dashboardEnabled = true;
		dashboardLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals("TxExpo") && comp.isVisible()) {
		txexpoEnabled = true;
		txexpoLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
}

boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;

boolean isPermittedAddVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
boolean isPermittedEditVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);

boolean isPermittedAddReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
boolean isPermittedViewReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;

boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
boolean isPermittedViewDashboard = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_VIEW_PERMISSION);

boolean isPermittedEnvironmentAnalysis = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);

boolean isPermittedAddLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.EDIT_LOG_COLLECTOR_PERMISSION);
boolean isPermittedViewLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.VIEW_LOG_COLLECTION_PERMISSION);
boolean isPermittedLogCollection = isPermittedViewLogCollection || isPermittedAddLogCollection;

boolean presentQuickStart = isPermittedAddLog || isPermittedAddReport || isPermittedAddVerify;
boolean showMoreActions = isPermittedAddLog || isPermittedAddVerify || isPermittedAddReport || presentQuickStart || isPermittedSettings; 

boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();

boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();

boolean isDemo = XpologLicenseManager.getInstance().isDemo();

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

%>

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr valign="top" height="10px">
		<td>
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						Quick Actions
					</td>
				</tr>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<%if(valid) { %>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_QUICK_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<%if(isTestingBuid) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=testingPortal.jsp" %>"><img src="<%=baseDirectory %>images/home/environmentAnalysis.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'environmentAnalysisOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'environmentAnalysis.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=testingPortal.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Testing Environments</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isSiteDemo) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=Log4J_Log_1227520538204%2526gotoMain=true%2526timetamp=" + System.currentTimeMillis() %>"><img src="<%=baseDirectory %>images/home/logViewer.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logViewerOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logViewer.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=Log4J_Log_1227520538204%2526gotoMain=true%2526timetamp=" + System.currentTimeMillis() %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Viewer</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%}else { %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=view/mainView.jsp" %>"><img src="<%=baseDirectory %>images/home/logViewer.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logViewerOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logViewer.gif')" ></a>
											</td>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=view/mainView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Viewer</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isPermittedVerify) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorsView.jsp" %>"><img src="<%=baseDirectory %>images/home/logMonitor.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logMonitorOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logMonitor.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorsView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Monitor</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isPermittedViewReport) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp" %>"><img src="<%=baseDirectory %>images/home/reports.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'reportsOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'reports.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Reports</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isDashboardValid && isPermittedViewDashboard) { %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=dashboardLink %>"><img src="<%=baseDirectory %>images/home/dashboard.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'dashboardOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'dashboard.gif')" ></a>
											</td>
											<td>
												<a href="<%=dashboardLink %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK"><%=analyticsH %></a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(searchEnabled) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologSearchLink %>"><img src="<%=baseDirectory %>images/home/searchEngine.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'searchEngineOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'searchEngine.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologSearchLink %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Search Engine</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%}%>
							<%if(!isTestingBuid && isPermittedEnvironmentAnalysis) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true" %>"><img src="<%=baseDirectory %>images/home/environmentAnalysis.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'environmentAnalysisOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'environmentAnalysis.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Environment Analysis</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isPermittedLogCollection) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=logcollection/logCollectionsView.jsp" %>"><img src="<%=baseDirectory %>images/home/logCollection.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logCollectionOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logCollection.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=logcollection/logCollectionsView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Collection</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<tr height="100%"><td>&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<%if (showMoreActions){%>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						More Actions
					</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_MORE_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<%if (isPermittedAddLog){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp" %>"><img src="<%=baseDirectory %>images/home/addLog.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'addLogOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'addLog.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Add and view log</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedAddLog && isPermittedAddModule){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner" %>"><img src="<%=baseDirectory %>images/home/addLogsDirectory.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'addLogsDirectoryOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'addLogsDirectory.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Add logs directory</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<% if (isPermittedAddVerify){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp" %>"><img src="<%=baseDirectory %>images/home/createMonitor.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'createMonitorOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'createMonitor.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Create log monitor</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedAddReport){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation" %>"><img src="<%=baseDirectory %>images/home/generateReport.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'generateReportOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'generateReport.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Generate report</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (presentQuickStart){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="javascript:showStartWizard()"><img src="<%=baseDirectory %>images/home/openQuickStartWizard.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'openQuickStartWizardOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'openQuickStartWizard.gif')" ></a>
											</td>
											<td>
												<a href="javascript:showStartWizard()" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Quick start wizard</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedSettings){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=settings/mailset.jsp" %>"><img src="<%=baseDirectory %>images/home/settings.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'settingsOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'settings.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=settings/mailset.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Settings</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<tr><td style="font-size: 1px; height: 1px;">&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%} %>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						Get Help
					</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_GET_HELP_CELL" valign="top">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="mailto:support@xplg.com?subject=Questions regarding XpoLog Center" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK">Contact XpoLog</a>
								</td>
							</tr>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="http://www.xplg.net/support/" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK" target="_new">Online knowledge base</a>
								</td>
							</tr>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="http://www.xpolog.com/home/common/redirects.jsp?redirectRequest=user_manual" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK" target="_new">XpoLog Center user manual</a>
								</td>
							</tr>
							<tr><td style="font-size: 1px; height: 1px;">&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%
						if (isDemo){
				%>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_LIVE_SUPPORT_CELL">
					<!-- Begin SupportSuite Javascript Code -->
					
					<!-- BEGIN TAG CODE -->
						<div>
							<div id="proactivechatcontainernc2v4biell">
							</div>
							<table border="0" cellspacing="0" cellpadding="0">
								<tr>
									<td align="center" id="swifttagcontainernc2v4biell">
										<div style="display: inline;" id="swifttagdatacontainer"></div>
									</td>
								</tr>
								<tr>
									<td align="center"></td>
								</tr>
							</table>
						</div>
						<script type="text/javascript">
							var swiftscriptelemnc2v4biell=document.createElement("script");
							swiftscriptelemnc2v4biell.type="text/javascript";
							var swiftrandom = Math.floor(Math.random()*1001);
							var swiftuniqueid = "nc2v4biell";
							var swifttagurlnc2v4biell="http://xpolog.net/support/visitor/index.php?/LiveChat/HTML/HTMLButtonBase";
							setTimeout("swiftscriptelemnc2v4biell.src=swifttagurlnc2v4biell;document.getElementById('swifttagcontainernc2v4biell').appendChild(swiftscriptelemnc2v4biell);",1);
						</script>
					<!-- END TAG CODE -->
					
					<!-- End SupportSuite Javascript Code -->
					</td>
				</tr>
				<%
						}
				%>
				<tr><td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND">&nbsp;</td></tr>
				<%}else { %>
				<tr>
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_QUICK_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="settings/settings.jsp"><img src="<%=baseDirectory %>images/home/logCollection.gif" border="0" onMouseOver="javascript:setImageSource(this, 'logCollectionOver.gif')" onMouseOut="javascript:setImageSource(this, 'logCollection.gif')" ></a>
											</td>
											<td>
												<a href="settings/settings.jsp" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Save License</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<%} %>
			</table>
		</td>
	</tr>
</table>