<%@ page language="java"%>

<%@ page import="org.w3c.dom.Element"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsViewContainer"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalGadget"%>
<%@ page import="xpolog.eye.util.XMLUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../../";

%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();

WidgetsView view = null;
String viewId = request.getParameter("viewId");
if (viewId != null && viewId.length() > 0){
  view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);  
}

String widgetUrl = request.getParameter("widgetUrl");

String message = "";
viewId = "";

PortalGadget gadget = null;
String layoutId = "";
boolean canBeDisplayed = true;
try {
	
   if (widgetUrl == null || widgetUrl.length() == 0){
      message = "No widget was given";  
   }else if (view == null){
	    message = "No View was selected";
   }else {
	   Element elem = XpoLogWidgetsManager.getIntsance().getGadgetSpec(request,widgetUrl);
     if (elem != null){
       gadget = new PortalGadget();
       gadget.setId(view.getId() + "_" + String.valueOf(System.currentTimeMillis()));
       gadget.setSpecUrl(widgetUrl);
       gadget.setTitle(XMLUtil.getAttribute(elem,"title",""));
       gadget.setWidth("100%");
       
       List list = XMLUtil.getChildsElementsByTagName(elem,"UserPref");
     	 for (int i = 0;i < list.size();i++){
     	 	 Element e = (Element)list.get(i);
     	 	 String required = e.getAttribute("required");
     	 	 if(required != null && required.equals("true")) {
     	 	 	// if a required pref was found, the gadget cannot be displayed until it is saved
     	 		canBeDisplayed = false;
     	 		 break;
     	 	 }
     	 }
     	gadget.setCanBeDisplayed(canBeDisplayed);
     	gadget.setUserContext(view.getUserContext());
       
     	 //audit
       AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
     	  	userContext, AuditConstants.CHANGE, "add dashboard gadget", AuditConstants.WIDGETS, "add dashboard gadget " + gadget.getId() + " (" + widgetUrl +")");
       
	     PortalWidgetsViewContainer portalContainer = (PortalWidgetsViewContainer)view.getContainer();
	     layoutId = portalContainer.addPortalGadget(gadget, true);
       XpoLogWidgetsManager.getIntsance().updateWidgetsView(request,view);
       viewId = view.getId();
     }else {
       message = "No spec for widget " + widgetUrl; 
     }
   }
}catch (Exception e){
  ErrorModel.log.error("Failed to add widget to view " + viewId + " with widget url " + widgetUrl,e); 
  message = "Failed to add widget to view " + viewId + " with widget url " + widgetUrl;
}
response.setContentType("text/xml; charset=UTF-8");
%>

<Result>
	<Message><%=message%></Message>
	<ViewID><%=viewId%></ViewID>
<%
if(gadget != null && layoutId != null && !layoutId.equals("")) {
%>
	<Gadget xplgGadgetId="<%=gadget.getId() %>" layoutId="<%=layoutId %>" canBeDisplayed="<%=canBeDisplayed %>">
		<![CDATA[<%=gadget.getGadgetParameters(request)%>]]>
	</Gadget>
<%
}
%>
</Result>
