<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.ui.charts.XpoLogChartModel"%>
<%@ page import="xpolog.eye.site.ui.grid.types.GridValueWrapper"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTableModel"%>
<%@ page import="xpolog.eye.site.widgets.data.handler.WidgetDataHandler"%>
<%@ page import="xpolog.eye.site.widgets.data.ui.WidgetDataResponse"%>
<%@ page import="xpolog.eye.site.widgets.data.ui.WidgetRecordsDataResult"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetDataRequest"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetsDataHelper"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetsDataManager"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.WidgetGridTable"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
String key = request.getParameter("key");
if (!SiteManagment.getInstance().checkKey(key)){
	if (!manager.checkForPermission(request, response, null, true)) {
	  return;
  }
}

WidgetDataRequest widgetDataRequest = WidgetsDataHelper.createWidgetDataRequest(request, userContext);
WidgetsDataManager widgetsDataManager = XpoLogWidgetsManager.getIntsance().getWidgetsDataManager();
WidgetDataResponse widgetDataResponse = widgetsDataManager.getWidgetData(widgetDataRequest);
if(widgetDataResponse != null && widgetDataResponse.getStatus() == WidgetDataResponse.STATUS_OK && widgetDataResponse.getDataObject() != null) {
	String gadgetTitle = widgetDataRequest.getParam("xplg_title");
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		userContext, AuditConstants.VIEW, "view dashboard gadget", AuditConstants.WIDGETS, "view dashboard gadget " + gadgetTitle + " (" + widgetDataRequest.getGadgetId() + "): " + widgetDataRequest);
	
	Object widgetDataObj = widgetDataResponse.getDataObject();
	long resultTimestamp = widgetDataResponse.getTimestamp();
	String resultTime = "N/A";
	if(resultTimestamp > 0) {
		resultTime = DateUtil.sdf.format(new Date(resultTimestamp));
	}
	// change result timestamp to be the current time  instead of the data generation time
	//String resultTime = DateUtil.sdf.format(new Date(System.currentTimeMillis()));
	
	String responseType = "";
	if(widgetDataObj instanceof GridTableModel) {
		responseType = "table";
	}else if(widgetDataObj instanceof XpoLogChartModel) {
		responseType = "chart";
	}else if(widgetDataObj instanceof WidgetRecordsDataResult) {
		responseType = "events";
	}else {
		responseType = "empty";
	}
	
	String baseDirectory = widgetDataRequest.getParam("baseDirectory");
	if(baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}
	
	response.setContentType("text/xml; charset=UTF-8");
%>

<GadgetResponse>
		<GadgetResponseHeader responseType="<%=responseType %>" resultTime="<%=resultTime %>" gadgetId="<%=widgetDataResponse.getGadgetId() %>" />
<%
	if(widgetDataResponse.getGeneralLinkWrapper() != null) {
		String generalLink = GridValueWrapper.getGridCellText(widgetDataResponse.getGeneralLinkWrapper());
		if(generalLink != null) {
			generalLink = XpologUtil.replaceAll(generalLink, WidgetDataHandler.BASE_DIRECTORY_PLACEHOLDER, baseDirectory);
		}
%>
		<GadgetResponseGeneralLink>
		<![CDATA[
			<%=generalLink %>
		]]>
		</GadgetResponseGeneralLink>
<%
	}
	if(widgetDataObj instanceof GridTableModel) {
		GridTableModel tableModel = (GridTableModel)widgetDataObj;
		tableModel.setBaseDirectory(baseDirectory);
		WidgetGridTable gridTable = new WidgetGridTable(tableModel);
		request.setAttribute("widgetTable",gridTable);
%>
		<GadgetResponseData>
			<![CDATA[
				<jsp:include page="initWidgetTable.jsp" flush="true" />
			]]>
		</GadgetResponseData>
<%
	}else if(widgetDataObj instanceof XpoLogChartModel) {
		XpoLogChartModel chartModel = (XpoLogChartModel)widgetDataObj;
		chartModel.setBaseDirectory(baseDirectory);
		request.setAttribute("chartModel",chartModel);
		String url = BASE_DIRECTORY + "widgets/charts/jsp/initChartView.jsp";
%>
		<GadgetResponseData>
			<jsp:include page="<%=url %>" flush="true" />
		</GadgetResponseData>
<%
	}else if(widgetDataObj instanceof WidgetRecordsDataResult) {
		WidgetRecordsDataResult widgetRecordsDataResult = (WidgetRecordsDataResult)widgetDataObj;
		widgetRecordsDataResult.setBaseDirectory(baseDirectory);
		request.setAttribute("recordsDataResult",widgetRecordsDataResult);
%>
		<GadgetResponseData>
			<![CDATA[
				<jsp:include page="initWidgetEvents.jsp" flush="true" />
			]]>
		</GadgetResponseData>
<%
	}
%>
	</GadgetResponse>
<%
}else {
	String gadgetTitle = widgetDataRequest.getParam("xplg_title");
	String gadgetId = widgetDataRequest != null ? widgetDataRequest.getGadgetId() : "N/A";
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		userContext, AuditConstants.VIEW, "view dashboard gadget", AuditConstants.WIDGETS, "view dashboard gadget " + gadgetTitle + " (" + gadgetId + ") returned no response: " + widgetDataRequest);
   
	response.setContentType("text/xml; charset=UTF-8");
	String errorMessage = "Failed to load gadget data, please refresh";
	if(widgetDataResponse != null) {
		List errorMessages = widgetDataResponse.getErrorMessages();
		if(errorMessages != null && errorMessages.size() > 0) {
			errorMessage = (String)errorMessages.get(0);
		}
	}
%>
			<GadgetResponse>
				<GadgetResponseHeader responseType="empty" message="" />
				<GadgetResponseData>
					<![CDATA[
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
						    <td class="WIDGETS_PORTAL_TABLE_GADGET_NO_DATA_CELL"><%=errorMessage %></td>
						  </tr>
						</table>
					]]>
				</GadgetResponseData>
			</GadgetResponse>
<%
}
%>