var WIDGETS_PORTAL_HEADER_ROW_HEIGHT = 75; // 75 because of the WIDGETS_PORTAL_HEADER_ROW height

function replaceDivContent(id, responseText) {
	handleInnerHTMLJQuery(id, responseText);
}

function onWidgetsViewLoad(selectedView, selectedGadget, addNewDashboard){
	loadWidgetsPortalContainer(selectedView, selectedGadget, addNewDashboard);
}

function loadWidgetsPortalContainer(selectedView, selectedGadget, addNewDashboard) {
	var viewId = selectedView;
	if(!viewId || selectedView == '') {
		viewId = CURRENT_VIEW_ID;
		if(!viewId || viewId == '') {
			if(addNewDashboard && addNewDashboard == "true") {
				updateAddDashboardDiv("", "");
				addPortalView();
			}
			return;
		}
	}
	if(!selectedGadget) {
		selectedGadget = '';
	}
	
	updateDummyLayout();
	
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&viewId=" + viewId;
	params += "&gadgetId=" + selectedGadget;
	var padding = 20;
	var maximizedGadgetLayoutWidth = ($(document).width() - (padding * 2)) + "px";
	params += "&maximizedGadgetLayoutWidth=" + maximizedGadgetLayoutWidth;
	sendAjaxRequest("widgetsPortalContainer.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var layoutIdsForJquery = "";
	    	var layoutElement = xmldoc.getElementsByTagName("Layout")[0];
	    	var viewIdFromResponse;
	    	var viewNameFromResponse;
	    	if(layoutElement) {
	    		viewIdFromResponse = layoutElement.getAttribute("viewId");
	    		viewNameFromResponse = layoutElement.getAttribute("viewName");
	    		
	    		var text = getXMLElementValue(layoutElement);
	    		document.getElementById(BODY_DIV_ID).innerHTML = text;
	    		
	    		var gadgetNames = layoutElement.getAttribute("gadgetNames");
	    		eval ("var gadgetNamesArr = [" + gadgetNames + "]");
	    		gadgets.container.layoutManager.setGadgetChromeIds(gadgetNamesArr);
	    		
	    		if(gadgetNamesArr.length == 0 && IS_EDITABLE) {
	    			showHideLayoutDummyDiv(true);
				}
	    		
	    		layoutIdsForJquery = layoutElement.getAttribute("layoutIdsForJquery");
	    	}
	    	
	    	updateAddDashboardDiv(viewIdFromResponse, viewNameFromResponse);
			updateAddGadgetDiv();
			updateChangeLayoutDiv(viewId);
	    	
	    	var gadgetsElement = xmldoc.getElementsByTagName("Gadgets")[0];
			if(gadgetsElement) {
				var list = gadgetsElement.getElementsByTagName("Gadget");
				for (var i = 0; i < list.length;i++){
				  var xplgGadgetId = list[i].getAttribute("xplgGadgetId");
				  var canBeDisplayed = list[i].getAttribute("canBeDisplayed");
				  var text = getXMLElementValue(list[i]);		
				  if(text) {
					  eval("var a = {" + text + "}");
					  var gadgetAttributes = getDefaultGadgetAttributes();
					  for (attrname in a) { gadgetAttributes[attrname] = a[attrname]; }
					  
					  var gad = gadgets.container.createGadget(gadgetAttributes);
					  gad.setServerBase(GADGETS_BASE_DIRECTORY);
					  gad.xplgGadgetId = xplgGadgetId;
					  gad.canBeDisplayed = canBeDisplayed;
					  gadgets.container.addGadget(gad);
					  
					  if(gad.userPrefs.xplg_refreshInterval) {
						  handleGadgetRefreshInterval(gad);
					  }
				  }
				}
				gadgets.container.renderGadgets();
				
				if(layoutIdsForJquery.length > 0) {
					$(layoutIdsForJquery).sortable({
						connectWith: '.connectedSortable',
						placeholder: 'WIDGETS_PORTAL_DRAGGED_GADGET_DIV',
						forcePlaceholderSize: true,
						stop: handleDropGadget,
						cursor: 'move',
						opacity: 0.6,
						revert: true,
						handle: '.DRAG_HANDLE'
					});
				}
			}
			CURRENT_VIEW_ID = viewId;
		}
	}, "POST", params);
}

function updateDummyLayout() {
	var layoutDummy = document.getElementById("layoutDummy");
	if(layoutDummy) {
		var padding = 20;
		layoutDummy.style.width = ($(document).width() - (padding * 2)) + "px";
		layoutDummy.style.top = "95px";
		layoutDummy.style.left = (padding + "px");
	}
}

function handleGadgetRefreshInterval(gadget) {
	clearGadgetRefreshInterval(gadget);
	if(!gadget.userPrefs.xplg_refreshInterval) {
		return;
	}
	var refreshIntervalStr = gadget.userPrefs.xplg_refreshInterval.value;
	var index = refreshIntervalStr.indexOf("_");
	if(index > 0) {
		var refreshInterval = getRefreshInterval(refreshIntervalStr, index);
		if(refreshInterval > 0) {
			gadget.refreshIntervalObject = setInterval("refreshGadgetByInterval('" + gadget.id + "')", refreshInterval);
		}
	}
}

function clearGadgetRefreshInterval(gadget) {
	if(gadget.refreshIntervalObject) {
		clearInterval(gadget.refreshIntervalObject);
		gadget.refreshIntervalObject = null;
	}
}

function getRefreshInterval(refreshIntervalStr, index) {
	var refreshInterval = -1;
	
	var amount = refreshIntervalStr.substr(0, index);
	var type = refreshIntervalStr.substr(index + 1);
	if(type == "minute") {
		var MINUTE_INTERVAL = 1000 * 60;
		refreshInterval = parseInt(amount) * MINUTE_INTERVAL;
	}else if(type == "minute") {
		var HOUR_INTERVAL = 1000 * 60 * 60;
		refreshInterval = parseInt(amount) * HOUR_INTERVAL;
	}
	return refreshInterval;
}

function refreshGadgetByInterval(gadgetId) {
	refreshGadget(gadgetId, false);
}

function handleDropGadget(event, ui) {
	var gadgetDiv = ui.item[0];
	var id = gadgetDiv.id;
	var index = id.indexOf("gadget_");
	if(index != -1) {
		var xplgGadgetId = id.substr(index + "gadget_".length);
		var gadget = gadgets.container.getGadgetByXplgGadgetId(xplgGadgetId);
		handleMouseOverGadgetTitleRow(gadget.getIframeId(), false, xplgGadgetId);
		
		var targetLayoutId = "";
		var nextGadgetId = "";
		var parentElement = gadgetDiv.parentNode;
		while(parentElement) {
			var parentId = parentElement.id;
			if(parentId && parentId != '') {
				index = parentId.indexOf("layout");
				if(index == 0) {
					var suffix = parentId.substr("layout".length);
					if(suffix != '') {
						targetLayoutId = suffix;
						if(gadgetDiv.nextSibling) {
							var nextSibling = document.all ? gadgetDiv.nextSibling : gadgetDiv.nextElementSibling;
							if(nextSibling && nextSibling.id) {
								nextGadgetId = nextSibling.id;
								index = nextGadgetId.indexOf("gadget_");
								if(index != -1) {
									nextGadgetId = nextGadgetId.substr(index + "gadget_".length);
								}
							}
						}
						break;
					}
				}
			}
			parentElement = parentElement.parentNode;
		}
		if(targetLayoutId != '') {
			sendAjaxRequest("../admin/dragPortalWidgetAction.jsp?viewId=" + CURRENT_VIEW_ID + "&gadgetId=" + xplgGadgetId + "&targetLayoutId=" + targetLayoutId + "&nextGadgetId=" + nextGadgetId, function(req){
				var xmldoc = req.responseXML.documentElement;
			    if(xmldoc) {
			    	var shouldRefreshGadgetElement = xmldoc.getElementsByTagName("ShouldRefreshGadget")[0];
			    	if(shouldRefreshGadgetElement) {
			    		var shouldRefreshGadget = shouldRefreshGadgetElement.getAttribute("value");
			    		if(shouldRefreshGadget && shouldRefreshGadget == "true") {
			    			refreshGadget(gadget.id, false);
			    		}
			    	}
			    }
			});
		}
	}
}

function getDefaultGadgetAttributes(){
	var result = {};				
	return result;
}

function setImageSource(imageElement, imageSource) {
	imageElement.src = BASE_DIRECTORY + "images/widgets/dashboard/" + imageSource;
}

function showHeaderCoverDiv(colored) {
	var widgetsPortalHeaderCoverDiv = document.getElementById("widgetsPortalHeaderCoverDiv");
	if(widgetsPortalHeaderCoverDiv) {
		if(colored) {
			widgetsPortalHeaderCoverDiv.className = "WIDGETS_PORTAL_HEADER_COVER_DIV_COLORED";
		}else {
			widgetsPortalHeaderCoverDiv.className = "WIDGETS_PORTAL_HEADER_COVER_DIV";
		}
		widgetsPortalHeaderCoverDiv.style.height = (WIDGETS_PORTAL_HEADER_ROW_HEIGHT + "px");
		widgetsPortalHeaderCoverDiv.style.display = "block";
	}
}

function hideHeaderCoverDiv() {
	var widgetsPortalHeaderCoverDiv = document.getElementById("widgetsPortalHeaderCoverDiv");
	if(widgetsPortalHeaderCoverDiv) {
		widgetsPortalHeaderCoverDiv.style.display = "none";
	}
}

function showBodyCoverDiv(colored) {
	var widgetsPortalBodyCoverDiv = document.getElementById("widgetsPortalBodyCoverDiv");
	if(widgetsPortalBodyCoverDiv) {
		if(colored) {
			widgetsPortalBodyCoverDiv.className = "WIDGETS_PORTAL_BODY_COVER_DIV_COLORED";
		}else {
			widgetsPortalBodyCoverDiv.className = "WIDGETS_PORTAL_BODY_COVER_DIV";
		}
		widgetsPortalBodyCoverDiv.style.height = (($(document).height() - WIDGETS_PORTAL_HEADER_ROW_HEIGHT) + "px");
		widgetsPortalBodyCoverDiv.style.display = "block";
	}
}

function hideBodyCoverDiv() {
	var widgetsPortalBodyCoverDiv = document.getElementById("widgetsPortalBodyCoverDiv");
	if(widgetsPortalBodyCoverDiv) {
		widgetsPortalBodyCoverDiv.style.display = "none";
	}
}

function updateAddDashboardDiv(viewId, viewName) {
	var widgetsPortalAddDashboardDiv = document.getElementById("widgetsPortalAddDashboardDiv");
	if(widgetsPortalAddDashboardDiv) {
		$(document)
		var padding = 275;
		if($(document).width() <= 1024) {
			padding = 100;
		}
		widgetsPortalAddDashboardDiv.style.width = ($(document).width() - (padding * 2)) + "px";
		widgetsPortalAddDashboardDiv.style.top = "95px";
		widgetsPortalAddDashboardDiv.style.left = (padding + "px");
	}
}

function updateAddGadgetDiv() {
	sendAjaxRequest("addGadgetDivContent.jsp", function(req){
		var text = req.responseText;
		 if(text) {
			 var addGadgetDiv = document.getElementById("widgetsPortalAddGadgetDiv");
			 if(addGadgetDiv) {
				 replaceDivContent("widgetsPortalAddGadgetDiv", text);
				 
				 var widgetsPortalAddGadgetDivContent = document.getElementById("widgetsPortalAddGadgetDivContent");
				 if(widgetsPortalAddGadgetDivContent) {
					 var maxHeight = $(document).height() - WIDGETS_PORTAL_HEADER_ROW_HEIGHT - 50;
					 widgetsPortalAddGadgetDivContent.style.height = (maxHeight + "px");
				 }
			 }
		}
	}, "GET");
}

function openAddGadgetDiv() {
	var widgetsPortalAddGadgetDiv = document.getElementById("widgetsPortalAddGadgetDiv");
	if(widgetsPortalAddGadgetDiv) {
		if(widgetsPortalAddGadgetDiv.style.display == "block") {
			widgetsPortalAddGadgetDiv.style.display = "none";
			hideBodyCoverDiv();
		}else {
			widgetsPortalAddGadgetDiv.style.display = "block";
			showBodyCoverDiv(false);
		}
	}
}

function doAddPortalWidget(widgetId){
	var widgetsPortalAddGadgetDiv = document.getElementById("widgetsPortalAddGadgetDiv");
	if(widgetsPortalAddGadgetDiv) {
		if(widgetsPortalAddGadgetDiv.style.display == "block") {
			widgetsPortalAddGadgetDiv.style.display = "none";
			hideBodyCoverDiv();
		}
	}
	
	var viewId = CURRENT_VIEW_ID;
	
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&viewId=" + viewId;
	params += "&widgetUrl=" + widgetId;
	sendAjaxRequest("../admin/addPortalWidgetAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var viewElement = xmldoc.getElementsByTagName("ViewID")[0];
			if(viewElement) {	
				var viewId = getXMLElementValue(viewElement);
				if (viewId && viewId != ""){
					var gadgetElement = xmldoc.getElementsByTagName("Gadget")[0];
					if(gadgetElement) {
						var xplgGadgetId = gadgetElement.getAttribute("xplgGadgetId");
						var layoutId = gadgetElement.getAttribute("layoutId");
						var canBeDisplayed = gadgetElement.getAttribute("canBeDisplayed");
						var text = getXMLElementValue(gadgetElement);
						
						if(xplgGadgetId && layoutId && text) {
							var layoutDiv = document.getElementById(layoutId);
							if(layoutDiv) {
								var gadgetDiv = document.createElement('DIV');
								if(gadgetDiv) {
									showHideLayoutDummyDiv(false);
									
									gadgetDiv.id = "gadget_" + xplgGadgetId;
									gadgetDiv.className = "WIDGETS_PORTAL_GADGET_DIV";
									
									if(layoutDiv.firstChild) {
										layoutDiv.insertBefore(gadgetDiv, layoutDiv.firstChild);
									}else {
										layoutDiv.appendChild(gadgetDiv);
									}
									
									gadgets.container.layoutManager.addGadgetChromeId('gadget_' + xplgGadgetId);
									
									eval("var a = {" + text + "}");
									var gadgetAttributes = getDefaultGadgetAttributes();
									for (attrname in a) { gadgetAttributes[attrname] = a[attrname]; }
									var gad = gadgets.container.createGadget(gadgetAttributes);
									gad.setServerBase(GADGETS_BASE_DIRECTORY);
									gad.xplgGadgetId = xplgGadgetId;
									gad.canBeDisplayed = canBeDisplayed;
									gadgets.container.addGadget(gad);
									
									gadgets.container.renderGadget(gad);
								}
							}
						}
					}
				}else {
					var messageElement = xmldoc.getElementsByTagName("Message")[0];
					if (messageElement){
						var msg = getXMLElementValue(messageElement);
						alert("Error: " + msg);
					}
				}				
			}
	    }
  }, "POST", params);
}

function updateChangeLayoutDiv(viewId) {
	sendAjaxRequest("changeLayoutDivContentFetcher.jsp?viewId=" + viewId, function(req){
		var xmldoc = req.responseXML.documentElement;
		 if(xmldoc) {
			var changeLayoutElement = xmldoc.getElementsByTagName("ChangeLayout")[0];
	    	if(changeLayoutElement) {
	    		var text = getXMLElementValue(changeLayoutElement);
	    		replaceDivContent("widgetsPortalChangeLayoutDiv", text);
				
	    		var templateId = changeLayoutElement.getAttribute("templateId");
	    		if(templateId && templateId != '') {
	    			CURRENT_TEMPLATE_ID = templateId;
	    			updateGadgetLayouts();
	    		}
	    	}
		}
	}, "GET");
}

function updateGadgetLayouts() {
	if(CURRENT_TEMPLATE_ID && CURRENT_TEMPLATE_ID != '') {
		var documentWidthStr = $(document).width();
		var documentWidth = parseInt(documentWidthStr);
		var padding = 10;
		var wideLayoutWidth = Math.round(documentWidth - (padding * 2));
		padding += 1;
		var narrowLayoutWidth = Math.round((documentWidth / 2) - padding - (padding / 2));
		if(CURRENT_TEMPLATE_ID == "template1") {
			var layout0 = document.getElementById("layout0");
			if(layout0) {
				updateLayoutDiv(layout0, wideLayoutWidth);
			}
		}else if(CURRENT_TEMPLATE_ID == "template2") {
			var layout0 = document.getElementById("layout0");
			var layout1 = document.getElementById("layout1");
			if(layout0 && layout1) {
				updateLayoutDiv(layout0, narrowLayoutWidth);
				updateLayoutDiv(layout1, narrowLayoutWidth);
			}
		}else if(CURRENT_TEMPLATE_ID == "template3") {
			var layout0 = document.getElementById("layout0");
			var layout1 = document.getElementById("layout1");
			var layout2 = document.getElementById("layout2");
			if(layout0 && layout1 && layout2) {
				updateLayoutDiv(layout0, wideLayoutWidth);
				updateLayoutDiv(layout1, narrowLayoutWidth);
				updateLayoutDiv(layout2, narrowLayoutWidth);
			}
		}else if(CURRENT_TEMPLATE_ID == "template4") {
			var layout0 = document.getElementById("layout0");
			var layout1 = document.getElementById("layout1");
			var layout2 = document.getElementById("layout2");
			if(layout0 && layout1 && layout2) {
				updateLayoutDiv(layout0, narrowLayoutWidth);
				updateLayoutDiv(layout1, narrowLayoutWidth);
				updateLayoutDiv(layout2, wideLayoutWidth);
			}
		}
	}
}

function updateLayoutDiv(layoutDiv, width, paddingTop, paddingRight, paddingLeft, float) {
	layoutDiv.style.width = width + "px";
	/*layoutDiv.style.marginTop = paddingTop + "px";
	layoutDiv.style.marginRight = paddingRight + "px";
	layoutDiv.style.marginLeft = paddingLeft + "px";
	layoutDiv.style.float = float;*/
}

function openChangeLayoutDiv() {
	var widgetsPortalChangeLayoutDiv = document.getElementById("widgetsPortalChangeLayoutDiv");
	if(widgetsPortalChangeLayoutDiv) {
		if(widgetsPortalChangeLayoutDiv.style.display == "block") {
			widgetsPortalChangeLayoutDiv.style.display = "none";
			hideBodyCoverDiv();
		}else {
			widgetsPortalChangeLayoutDiv.style.display = "block";
			showBodyCoverDiv(false);
		}
	}
}

function doChangeLayout(viewId, templateId) {
	var widgetsPortalChangeLayoutDiv = document.getElementById("widgetsPortalChangeLayoutDiv");
	if(widgetsPortalChangeLayoutDiv) {
		if(widgetsPortalChangeLayoutDiv.style.display == "block") {
			widgetsPortalChangeLayoutDiv.style.display = "none";
			hideBodyCoverDiv();
		}
	}
	if(templateId != CURRENT_TEMPLATE_ID) {
		var params = "baseDirectory=" + BASE_DIRECTORY;
		params += "&viewId=" + viewId;
		params += "&templateId=" + templateId;
		sendAjaxRequest("changeLayoutAction.jsp", function(req){
			var xmldoc = req.responseXML.documentElement;
		    if(xmldoc) {
		    	var resultElement = xmldoc.getElementsByTagName("Result")[0];
				if(resultElement) {
					var status = resultElement.getAttribute("status");
					if(status && status == "ok") {
						iframeCounter++;
						gadgets.container = new gadgets.IfrContainer();
						loadWidgetsPortalContainer(CURRENT_VIEW_ID);
					}else {
						var message = resultElement.getAttribute("message");
						if(message) {
							alert(message);
						}
					}
				}
		    }
		}, "POST", params);
	}
}

function openPortalSettingsMenu() {
	var portalSettingsMenuDiv = document.getElementById("portalSettingsMenuDiv");
	if(portalSettingsMenuDiv) {
		if(portalSettingsMenuDiv.style.display == "block") {
			portalSettingsMenuDiv.style.display = "none";
			hideBodyCoverDiv();
		}else {
			portalSettingsMenuDiv.style.display = "block";
			showBodyCoverDiv(false);
		}
	}
}

function closePortalSettingsMenu() {
	var portalSettingsMenuDiv = document.getElementById("portalSettingsMenuDiv");
	if(portalSettingsMenuDiv) {
		portalSettingsMenuDiv.style.display = "none";
		hideBodyCoverDiv();
	}
}

function setSettingsMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}

var currentEditPortalAction;
function showEditPortalView(action){
	var widgetsPortalAddDashboardErrorTd = document.getElementById("widgetsPortalAddDashboardErrorTd");
	if(widgetsPortalAddDashboardErrorTd) {
		replaceDivContent("widgetsPortalAddDashboardErrorTd", "");
	}
	currentEditPortalAction = action;
	var widgetsPortalAddDashboardDiv = document.getElementById("widgetsPortalAddDashboardDiv");
	if(widgetsPortalAddDashboardDiv) {
		var savePortalName = document.getElementById("savePortalName");
		if(savePortalName) {
			if(action == "add") {
				savePortalName.value = "";
			}else if(action == "edit") {
				savePortalName.value = CURRENT_VIEW_NAME;
			}
		}
		var widgetsPortalAddDashboardTitleCell = document.getElementById("widgetsPortalAddDashboardTitleCell");
		if(widgetsPortalAddDashboardTitleCell) {
			if(action == "add") {
				replaceDivContent("widgetsPortalAddDashboardTitleCell", "Add New Dashboard");
			}else if(action == "edit") {
				replaceDivContent("widgetsPortalAddDashboardTitleCell", "Edit Dashboard");
			}
		}
		var widgetsPortalAddDashboardSelectLayoutRow = document.getElementById("widgetsPortalAddDashboardSelectLayoutRow");
		if(widgetsPortalAddDashboardSelectLayoutRow) {
			if(action == "add") {
				widgetsPortalAddDashboardSelectLayoutRow.style.display = "";
			}else if(action == "edit") {
				widgetsPortalAddDashboardSelectLayoutRow.style.display = "none";
			}
		}
		
		widgetsPortalAddDashboardDiv.style.display = "block";
		showHeaderCoverDiv(true);
		showBodyCoverDiv(true);
		
		var savePortalName = document.getElementById("savePortalName");
		if(savePortalName) {
			savePortalName.focus();
		}
	}
}

function hideEditPortalDiv(){
	var widgetsPortalAddDashboardDiv = document.getElementById("widgetsPortalAddDashboardDiv");
	if(widgetsPortalAddDashboardDiv) {
		widgetsPortalAddDashboardDiv.style.display = "none";
		hideHeaderCoverDiv();
		hideBodyCoverDiv();
	}
}

function addPortalView(){
	showEditPortalView('add');
}

function editPortalView() {
	showEditPortalView('edit');
}

var addDashboardSelectedTemplateId;
function doSelectLayout(templateId) {
	var widgetsPortalChangeLayoutDiv = document.getElementById("widgetsPortalChangeLayoutDiv");
	if(widgetsPortalChangeLayoutDiv) {
		if(widgetsPortalChangeLayoutDiv.style.display == "block") {
			widgetsPortalChangeLayoutDiv.style.display = "none";
			hideBodyCoverDiv();
		}
	}
	if(templateId != addDashboardSelectedTemplateId) {
		addDashboardSelectedTemplateId = templateId;
		for(var i = 1; i < 5; i++) {
			var widgetsPortalAddDashboardSelectLayout = document.getElementById("widgetsPortalAddDashboardSelectLayout_template" + i);
			var widgetsPortalAddDashboardSelectLayoutSelected = document.getElementById("widgetsPortalAddDashboardSelectLayoutSelected_template" + i);
			if(widgetsPortalAddDashboardSelectLayout && widgetsPortalAddDashboardSelectLayoutSelected) {
				if(templateId == ("template" + i)) {
					widgetsPortalAddDashboardSelectLayoutSelected.style.display = "";
					widgetsPortalAddDashboardSelectLayout.style.display = "none";
				}else {
					widgetsPortalAddDashboardSelectLayoutSelected.style.display = "none";
					widgetsPortalAddDashboardSelectLayout.style.display = "";
				}
			}
		}
	}
}

function doSavePortalView(){
	var viewId = '';
	var viewName = document.getElementById("savePortalName").value;
	var templateId = '';
	if(currentEditPortalAction == "add") {
		templateId = addDashboardSelectedTemplateId;
	}else if(currentEditPortalAction == "edit") {
		viewId = CURRENT_VIEW_ID;
		templateId = CURRENT_TEMPLATE_ID;
	}
	
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&viewId=" + viewId;
	params += "&viewName=" + encodeURIComponent(viewName);
	params += "&templateId=" + templateId;
	sendAjaxRequest("../admin/savePortalViewAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var messageElement = xmldoc.getElementsByTagName("Message")[0];
			if (messageElement){
				var msg = getXMLElementValue(messageElement);
				if(msg && msg != '') {
					var widgetsPortalAddDashboardErrorTd = document.getElementById("widgetsPortalAddDashboardErrorTd");
					if(widgetsPortalAddDashboardErrorTd) {
						replaceDivContent("widgetsPortalAddDashboardErrorTd", msg);
					}
				}else {
					var viewElement = xmldoc.getElementsByTagName("ViewID")[0];
					if(viewElement) {	
						var viewId = getXMLElementValue(viewElement);
						if (viewId && viewId != ""){
							parent.updateDashboardsMenu();
							this.location.href = "widgetsPortalView.jsp?selectedView=" + viewId;
						}			
					}
				}
			}
	    	
	    }
  }, "POST", params);
}

function removePortalView() {
	if(CURRENT_VIEW_ID && CURRENT_VIEW_ID != '' && 
	   CURRENT_VIEW_NAME && CURRENT_VIEW_NAME != '') {
		var msgWriter = new messageWriter("removeDashboardMessage","Remove Dashboard Action",BASE_DIRECTORY);
	    msgWriter.addAction("Yes","javascript:hideLayer('removeDashboardMessage');javascript:removePortalView0()");
	    msgWriter.addAction("No","javascript:hideLayer('removeDashboardMessage')");  
	    msgWriter.showMessage("<nobr>Are you sure you want to remove the dashboard</nobr><br>" + CURRENT_VIEW_NAME_SHORT + "?");
	}
}

function removePortalView0(){
	var viewId = CURRENT_VIEW_ID;
	
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&viewId=" + viewId;
	sendAjaxRequest("../admin/removePortalViewAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
	    	var viewElement = xmldoc.getElementsByTagName("Status")[0];
			if(viewElement) {	
				var stat = getXMLElementValue(viewElement);
				
				if (stat && stat == "true"){
					parent.updateDashboardsMenu();
					this.location.href = "widgetsPortalView.jsp?selectedView=";
				}else {
					var messageElement = xmldoc.getElementsByTagName("Message")[0];
					if (messageElement){
						var msg = getXMLElementValue(messageElement);
						alert("Error: " + msg);
					}
				}				
			}
	    }
  }, "POST", params);
}

function handleMouseOverGadgetTitleRow(id, isOver, xplgGadgetId) {
	var leftCell = document.getElementById("gadgetLeftCell-" + id);
	var mainCell = document.getElementById("gadgetMainCell-" + id);
	var rightCell = document.getElementById("gadgetRightCell-" + id);
	var titleTextSpanCell = document.getElementById(id + "_title");
	var titleLastRefreshedTextSpanCell = document.getElementById(xplgGadgetId + "-title-last-refreshed");
	if(leftCell && mainCell && rightCell && titleTextSpanCell) {
		if(isOver) {
			leftCell.className = "WIDGETS_PORTAL_GADGET_TITLE_LEFT_CELL_OVER";
			mainCell.className = "WIDGETS_PORTAL_GADGET_TITLE_MAIN_CELL_OVER";
			rightCell.className = "WIDGETS_PORTAL_GADGET_TITLE_RIGHT_CELL_OVER";
			
			titleTextSpanCell.className = "gadgets-gadget-title_OVER";
			if(titleLastRefreshedTextSpanCell) {
				titleLastRefreshedTextSpanCell.className = "gadgets-gadget-title-last-refreshed_OVER";
			}
		}else {
			leftCell.className = "WIDGETS_PORTAL_GADGET_TITLE_LEFT_CELL";
			mainCell.className = "WIDGETS_PORTAL_GADGET_TITLE_MAIN_CELL";
			rightCell.className = "WIDGETS_PORTAL_GADGET_TITLE_RIGHT_CELL";
			
			titleTextSpanCell.className = "gadgets-gadget-title";
			if(titleLastRefreshedTextSpanCell) {
				titleLastRefreshedTextSpanCell.className = "gadgets-gadget-title-last-refreshed";
			}
		}
	}
	
	var gadgetMove = document.getElementById("gadgetMove" + id);
	if(gadgetMove) {
		if(isOver) {
			gadgetMove.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMoveOverTitle.gif";
		}else {
			gadgetMove.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMove.gif";
		}
	}
	var gadgetMaximize = document.getElementById("gadgetMaximize" + id);
	var gadgetMaximizeDisabled = document.getElementById("gadgetMaximizeDisabled" + id);
	if(gadgetMaximize && gadgetMaximizeDisabled) {
		if(isOver) {
			if(CURRENT_GADGET_ID == '') {
				gadgetMaximize.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMaximizeOverTitle.gif";
				gadgetMaximizeDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMaximizeOverTitle.gif";
			}else {
				gadgetMaximize.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetRestoreOverTitle.gif";
				gadgetMaximizeDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetRestoreOverTitle.gif";
			}
		}else {
			if(CURRENT_GADGET_ID == '') {
				gadgetMaximize.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMaximize.gif";
				gadgetMaximizeDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMaximize.gif";
			}else {
				gadgetMaximize.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetRestore.gif";
				gadgetMaximizeDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetRestore.gif";
			}
		}
	}
	var gadgetMenuArrow = document.getElementById("gadgetMenuArrow" + id);
	var gadgetMenuArrowDisabled = document.getElementById("gadgetMenuArrowDisabled" + id);
	if(gadgetMenuArrow && gadgetMenuArrowDisabled) {
		if(isOver) {
			gadgetMenuArrow.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMenuArrowOverTitle.gif";
			gadgetMenuArrowDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMenuArrowOverTitle.gif";
		}else {
			gadgetMenuArrow.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMenuArrow.gif";
			gadgetMenuArrowDisabled.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadgetMenuArrow.gif";
		}
	}
}

/*function handleMouseOverGadgetTitleButton(type, id, isOver) {
	var gadgetImage = document.getElementById("gadget" + type + id);
	if(gadgetImage) {
		if(isOver) {
			gadgetImage.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadget" + type + "OverTitleMouseOver.gif";
		}else {
			gadgetImage.src = BASE_DIRECTORY + "images/widgets/dashboard/gadget/gadget" + type + "OverTitle.gif";
		}
	}
}*/

function removeGadget(gadgetId) {
	var gadget = gadgets.container.getGadget(gadgetId);
	if(gadget) {
		var title = "";
		if(gadget.userPrefs && gadget.userPrefs.xplg_title) {
			title = gadget.userPrefs.xplg_title.value;
		}
		var msgWriter = new messageWriter("removeGadgetMessage","Remove Gadget Action",BASE_DIRECTORY);
	    msgWriter.addAction("Yes","javascript:hideLayer('removeGadgetMessage');javascript:removeGadget0('" + gadgetId + "')");
	    msgWriter.addAction("No","javascript:hideLayer('removeGadgetMessage')");
	    if(title == "") {
	    	msgWriter.showMessage("<nobr>Are you sure you want to remove the gadget?</nobr>");
	    }else {
	    	msgWriter.showMessage("<nobr>Are you sure you want to remove the gadget</nobr><br>" + title + "?");
	    }
	}
}

function removeGadget0(gadgetId) {
	var gadget = gadgets.container.getGadget(gadgetId);
	var viewId = CURRENT_VIEW_ID;
  
	var params = "baseDirectory=" + BASE_DIRECTORY;
	params += "&gadgetId=" + gadget.id;
	params += "&xplgGadgetId=" + gadget.xplgGadgetId;
	params += "&viewId=" + viewId;
	sendAjaxRequest(BASE_DIRECTORY + 'portal/widgets/admin/removePortalWidgetAction.jsp', function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var resultElement = xmldoc.getElementsByTagName("Result")[0];
			if(resultElement) {
				var status = resultElement.getAttribute("status");
				if(status && status == "ok") {
					removeGadgetDiv(gadget.xplgGadgetId);
					clearGadgetRefreshInterval(gadget);
					gadgets.container.removeGadget(gadget);
					
					var numberOfGadgets = resultElement.getAttribute("numberOfGadgets");
					if(numberOfGadgets && numberOfGadgets == "0") {
						showHideLayoutDummyDiv(true);
					}
				}else {
					var message = resultElement.getAttribute("message");
					if(message && message != "") {
						alert(message);
					}
				}
			}
	    }
	}, "POST", params);
}

function removeGadgetDiv(xplgGadgetId) {
	var gadgetDiv = document.getElementById('gadget_' + xplgGadgetId);
	if(gadgetDiv) {
		var parentDiv = gadgetDiv.parentNode;
		if(parentDiv) {
			parentDiv.removeChild(gadgetDiv);
		}
	}
}

function maximizeGadget(xplgGadgetId) {
	this.location.href = "widgetsPortalView.jsp?selectedView=" + CURRENT_VIEW_ID + "&selectedGadget=" + xplgGadgetId;
}

function restoreGadget() {
	this.location.href = "widgetsPortalView.jsp?selectedView=" + CURRENT_VIEW_ID;
}

function showHideLayoutDummyDiv(show) {
	var layoutDummy = document.getElementById("layoutDummy");
	if(layoutDummy) {
		if(show) {
			openAddGadgetDiv();
			layoutDummy.style.display = "block";
		}else {
			layoutDummy.style.display = "none";
		}
	}
}

var currentOpenGadgetMenuId = null;
var currentIFrameId = null;
function openGadgetMenu(titleBarId, menuId, iFrameId) {
	var portalGadgetMenuDiv = document.getElementById(menuId);
	if(portalGadgetMenuDiv) {
		if(currentOpenGadgetMenuId && currentOpenGadgetMenuId != menuId) {
			var currentOpenGadgetMenu = document.getElementById(currentOpenGadgetMenuId);
			if(currentOpenGadgetMenu) {
				currentOpenGadgetMenu.style.display = "none";
			}
		}
		if(portalGadgetMenuDiv.style.display == "block") {
			portalGadgetMenuDiv.style.display = "none";
			currentOpenGadgetMenuId = null;
			currentIFrameId = null;
		}else {
			currentOpenGadgetMenuId = menuId;
			currentIFrameId = iFrameId;
			var position = $("#" + titleBarId).position();
			if(position) {
				portalGadgetMenuDiv.style.left = (position.left + $("#" + titleBarId).width() - 95) + "px";
				portalGadgetMenuDiv.style.top = (position.top + 30) + "px";
				
				portalGadgetMenuDiv.style.display = "block";
			}
		}
	}
}

function closeGadgetMenu(menuId) {
	var portalGadgetMenuDiv = document.getElementById(menuId);
	if(portalGadgetMenuDiv) {
		portalGadgetMenuDiv.style.display = "none";
		currentOpenGadgetMenuId = null;
		currentIFrameId = null;
	}
}

function setGadgetMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}

function setElementClass(elementId, className) {
	var element = document.getElementById(elementId);
	if(element) {
		element.className = className;
	}
}

function changeGadgetMenuMinimizeText(gadgetMenuMinimizeCellId, iFrameId) {
	var gadgetIframe = document.getElementById(iFrameId);
	var gadgetMenuMinimizeCell = document.getElementById(gadgetMenuMinimizeCellId);
	if (gadgetIframe && gadgetMenuMinimizeCell) {
		var gadgetContent = gadgetIframe.parentNode;
	    var display = gadgetContent.style.display;
	    if(display) {
	    	replaceDivContent(gadgetMenuMinimizeCellId, "Expand");
	    	handleGadgetMenuItemsAfterMinimize(true, iFrameId);
	    }else {
	    	replaceDivContent(gadgetMenuMinimizeCellId, "Minimize");
	    	handleGadgetMenuItemsAfterMinimize(false, iFrameId);
	    }
	  }
}

function handleGadgetMenuItemsAfterMinimize(isMinimized, iFrameId) {
	var state = 0;
	if(isMinimized) {
		state = 1;
	}
	handleGadgetMenuItems(state, iFrameId);
}

function handleGadgetMenuItems(state, iFrameId) {
	var portalGadgetMenuItemMinimize = document.getElementById("portalGadgetMenuItemMinimize" + iFrameId);
	var portalGadgetMenuItemMaximize = document.getElementById("portalGadgetMenuItemMaximize" + iFrameId);
	var portalGadgetMenuItemRefresh = document.getElementById("portalGadgetMenuItemRefresh" + iFrameId);
	var portalGadgetMenuItemSeparator = document.getElementById("portalGadgetMenuItemSeparator" + iFrameId);
	var portalGadgetMenuItemEdit = document.getElementById("portalGadgetMenuItemEdit" + iFrameId);
	var portalGadgetMenuItemRemove = document.getElementById("portalGadgetMenuItemRemove" + iFrameId);
	
	var displayMinimize = "";
	var displayMaximize = "";
	var displayRefresh = "";
	var displaySeparator = "";
	var displayEdit = "";
	var displayRemove = "";
	
	var display = "";
	if(state == 0) {
		displayMinimize = "block";
		displayMaximize = "block";
		displayRefresh = "block";
		displaySeparator = "";
		displayEdit = "block";
		displayRemove = "block";
	}else if(state == 1) {
		displayMinimize = "block";
		displayMaximize = "none";
		displayRefresh = "none";
		displaySeparator = "none";
		displayEdit = "none";
		displayRemove = "none";
	}else if(state == 2) {
		displayMinimize = "none";
		displayMaximize = "none";
		displayRefresh = "none";
		displaySeparator = "none";
		displayEdit = "none";
		displayRemove = "block";
	}else {
		displayMinimize = "block";
		displayMaximize = "block";
		displayRefresh = "block";
		displaySeparator = "";
		displayEdit = "block";
		displayRemove = "block";
	}
	if(portalGadgetMenuItemMinimize) {
		portalGadgetMenuItemMinimize.style.display = displayMinimize;
	}
	if(portalGadgetMenuItemMaximize) {
		portalGadgetMenuItemMaximize.style.display = displayMaximize;
	}
	if(portalGadgetMenuItemRefresh) {
		portalGadgetMenuItemRefresh.style.display = displayRefresh;
	}
	if(portalGadgetMenuItemSeparator) {
		portalGadgetMenuItemSeparator.style.display = displaySeparator;
	}
	if(portalGadgetMenuItemEdit) {
		portalGadgetMenuItemEdit.style.display = displayEdit;
	}
	if(portalGadgetMenuItemRemove) {
		portalGadgetMenuItemRemove.style.display = displayRemove;
	}
}

function handleGadgetTitleButtons(show, iFrameId) {
	handleGadgetTitleButtonMaximize(show, iFrameId);
	
	handleGadgetTitleButtonOpenMenu(show, iFrameId);
}

function handleGadgetTitleButtonMaximize(show, iFrameId) {
	var gadgetMaximizeLink = document.getElementById("gadgetMaximizeLink" + iFrameId);
	var gadgetMaximizeDisabled = document.getElementById("gadgetMaximizeDisabled" + iFrameId);
	if(gadgetMaximizeLink && gadgetMaximizeDisabled) {
		if(show) {
			gadgetMaximizeLink.style.display = "";
			gadgetMaximizeDisabled.style.display = "none";
		}else {
			gadgetMaximizeLink.style.display = "none";
			gadgetMaximizeDisabled.style.display = "";
		}
	}
}

function handleGadgetTitleButtonOpenMenu(show, iFrameId) {
	var gadgetButtonOpenMenu = document.getElementById("gadgetButtonOpenMenu" + iFrameId);
	var gadgetMenuArrowDisabled = document.getElementById("gadgetMenuArrowDisabled" + iFrameId);
	if(gadgetButtonOpenMenu + gadgetMenuArrowDisabled) {
		if(show) {
			gadgetButtonOpenMenu.style.display = "";
			gadgetMenuArrowDisabled.style.display = "none";
		}else {
			gadgetButtonOpenMenu.style.display = "none";
			gadgetMenuArrowDisabled.style.display = "";
		}
	}
}

function handleNewGadgetButtonsAndMenu(iFrameId) {
	handleGadgetTitleButtonMaximize(false, iFrameId);
	handleGadgetTitleButtonOpenMenu(true, iFrameId);
	
	handleGadgetMenuItems(2, iFrameId);
}

function handleSavedGadgetButtonsAndMenu(iFrameId) {
	handleGadgetTitleButtonMaximize(true, iFrameId);
	handleGadgetTitleButtonOpenMenu(true, iFrameId);
	
	handleGadgetMenuItems(0, iFrameId);
}

function refreshGadget(gadgetId, forceDataGeneration) {
	var gadget = gadgets.container.getGadget(gadgetId);
	if(gadget) {
		var iframeId = gadget.getIframeId();
		if(iframeId) {
			var iframe = document.getElementById(iframeId);
			if(iframe) {
				iframe.contentWindow.doRefreshGadget(forceDataGeneration);
			}
		}
	}
}

function showGadgetTooltip(id, side) {
	var gadgetTooltipDiv = document.getElementById('addGadget_gadget' + id + 'Tooltip');
	var gadgetImage = document.getElementById('addGadgetImage' + id);
	if(gadgetTooltipDiv && gadgetImage) {
		var tooltipObj = $(gadgetTooltipDiv);
		var tooltipWidth = tooltipObj.width();
		var imageObj = $(gadgetImage);
		var imageOffset = imageObj.position();
		var imageWidth = imageObj.width();
		gadgetTooltipDiv.style.top = imageOffset.top + "px";
		if(side == "left") {
			var left = parseInt(imageOffset.left) - parseInt(tooltipWidth) + 4;
			gadgetTooltipDiv.style.left = left + "px";
		}else {
			var right = parseInt(imageOffset.left) + parseInt(imageWidth) - 4;
			gadgetTooltipDiv.style.left = right + "px";
		}
		gadgetTooltipDiv.style.display = "block";
	}
}

function hideGadgetTooltip(id) {
	var gadgetTooltipDiv = document.getElementById('addGadget_gadget' + id + 'Tooltip');
	if(gadgetTooltipDiv) {
		gadgetTooltipDiv.style.display = "none";
	}
}

function changeTimeType(timeTypeSelect, timeAmountId, timeUnitId) {
	var timeAmountElement = document.getElementById(timeAmountId);
	var timeUnitElement = document.getElementById(timeUnitId);
	if(timeAmountElement && timeUnitElement) {
		var timeType = timeTypeSelect.options[timeTypeSelect.selectedIndex].value;
		var visibility = "visible";
		if(timeType == "allTime") {
			visibility = "hidden";
			timeAmountElement.value = "";
		}
		timeAmountElement.style.visibility = visibility;
		timeUnitElement.style.visibility = visibility;
	}
}

function openSavedSearchesList(searchQueryElementId) {
	setTimeout("openSavedSearchesList0(" + searchQueryElementId + ")", 500);
}

function openSavedSearchesList0(searchQueryElement) {
	if(searchQueryElement) {
		openSavedSearchesList1(searchQueryElement, "");
		openSavedSearchesList1(searchQueryElement, "search.");
	}
}

function openSavedSearchesList1(searchQueryElement, text) {
	searchQueryElement.focus();
	searchQueryElement.value = text;
	setCaretPosition(searchQueryElement, text.length);
	
	if(document.all) {
		searchQueryElement.fireEvent("onKeyUp");
    }else {
        var keyUpEvent = window.document.createEvent("KeyEvents");
        keyUpEvent.initKeyEvent('keyup', true, true, window, false, false, false, false, 46, 0);
        searchQueryElement.dispatchEvent(keyUpEvent); 
    } 
}