<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.smart.LogInserter"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	//constants
  String ERROR_OBJ = "ERROR_OBJ";
	String LOG_FULL_PATH = "LOG_FULL_PATH";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String MODULE_ID = "MODULE_ID";
  String LOG_DIRECTORY = "LOG_DIRECTORY";
  String LOG_NAME_PATTERN = "LOG_NAME_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String LOG_TIME_ZONE = "LOG_TIME_ZONE";
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  String fullPath = request.getParameter(LOG_FULL_PATH);
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if (fullPath == null || fullPath.equals("")) {
  	errmodel.addError("No file name was supplied");
  }
  
  Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  if (pmod == null && mdarr.length > 0){
    pmod = mdarr[0];
  }
  
	if (errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
		return;
	}

  boolean isUsingDefaultTimeZone = true;
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = isUsingDefaultTimeZone ? defaultZone.getID() : "";

	LogInserter li = new LogInserter(fullPath);
	li.setLogTimeZone(timeZoneId);
	LogBrowsingManager lbm = li.createLogBrowsing();
  String[] lines = LogAdminHelper.readLines(lbm,20);
  boolean existLines = false;
  for (int i = 0; i < lines.length; i++) {
    if (lines[i] != null && lines[i].length() > 0){
       existLines = true;
    }
  }
  
  if (fullPath != null && !fullPath.equals("") && !existLines) {
  	errmodel.addError("File path supplied is wrong of file is empty");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  String CURRENT_LOG = "CURRENT_LOG";
  request.getSession().removeAttribute("logid");
  request.getSession().removeAttribute("callsPage");
  request.getSession().removeAttribute("lastModel");
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  admin.addLogBrowser(lbm,pmod);
  String logid = lbm.getId();
  if(logid != null && logid.length() > 0) {
  	String[] lbmIds = new String[1];
  	lbmIds[0] = logid;
  	admin.generateLogData(lbmIds, userContext);
  }
  String url = BASE_DIRECTORY + "loggers/logview.jsp?logid="+logid;
  response.sendRedirect(url);
 %>
 
 <html>
 	<body>
 	</body>
 </html>
