<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!static final String BASE_DIRECTORY = "../../";%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	ErrorModel ermod = new ErrorModel();

	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	boolean success = true;
	String message = "";

	if (builder == null) {
		message = "Session is not valid any more. Please try again";
		success = false;
	}

	MultiLogAggCaseBuilder multiBuilder = null;
	DefaultLogAggCaseBuilder currentBuilder = null;
	if (builder.getCurrentCaseBuilder() instanceof MultiLogAggCaseBuilder) {
		multiBuilder = (MultiLogAggCaseBuilder) builder.getCurrentCaseBuilder();
	} else if (builder.getCurrentCaseBuilder() instanceof DefaultLogAggCaseBuilder) {
		currentBuilder = (DefaultLogAggCaseBuilder) builder.getCurrentCaseBuilder();
		multiBuilder = new MultiLogAggCaseBuilder();

		AggCaseDefinition def = new AggCaseDefinition();
		def.setName(currentBuilder.getCaseDef().getName());
		def.setDesc("");
		def.setType(AggReportBuilder.LOG_MULTI_TYPE);
		def.setGroup(currentBuilder.getCaseDef().getGroup());
		multiBuilder.setLogId(currentBuilder.getLogId());
		multiBuilder.setCaseDef(def);
		multiBuilder.setCurrentBuilder(currentBuilder);		
	}

	boolean isEdit = false;
	if (multiBuilder == null) {
		multiBuilder = new MultiLogAggCaseBuilder();
	} else {
		currentBuilder = multiBuilder.getCurrentBuilder();
		isEdit = true;
	}

	String name = request.getParameter("name");
	if (name == null || name.length() == 0) {
		message = "No name was defined";
		success = false;
	}

	String logId = request.getParameter("logId");
	if (logId == null || logId.length() == 0) {
		if (message.length() > 0) {
			message += "\n";
		}
		message += "No log was defined";
		success = false;
	}

	String desc = request.getParameter("desc");

	LogBrowsingManager lbm = null;
	String type = "";
	if (success) {
		try {
			lbm = SiteManagment.getInstance().getLogBrowserManager(logId);
		} catch (Exception e) {
			success = false;
			message += "No log was found";
		}
	}

	String resultsToDisplayStr = request.getParameter("advancedMaxResults");
	AggCaseDisplayRule displayRule = null;
	if (success && resultsToDisplayStr != null && resultsToDisplayStr.length() > 0) {
		int resultsToDisplay = -1;
		try {
			resultsToDisplay = Integer.parseInt(resultsToDisplayStr);
			displayRule = new AggCaseDisplayRule();
			displayRule.setResultsToDisplay(resultsToDisplay);
		} catch (Exception e) {
			success = false;
			message += "Invalid max results value";
		}
	}

	if (success) {
		if (currentBuilder == null) {
			AggCaseDefinition def = new AggCaseDefinition();
			def.setName(name);
			def.setDesc(desc == null ? "" : desc);
			def.setType(AggReportBuilder.LOG_MULTI_TYPE);
			multiBuilder.setLogId(logId);
			builder.addModuleMemberLogId(logId);
			multiBuilder.setCaseDef(def);
		} else {
			currentBuilder.getCaseDef().setName(name);
			currentBuilder.getCaseDef().setDesc(desc == null ? "" : desc);
			currentBuilder.setLogId(logId);
		}

	}

	if (success) {
		try {

			AggBuilderHelper.updateAggMultiCaseBuilderNames(multiBuilder.getCaseDef(), lbm);

			String group = logId;			
			multiBuilder.getCaseDef().setGroup(group);

			String[] datafilterIds = request.getParameterValues("To_Select_filtersAdvancedDataFilters");
			boolean isTimeFilter = false;
			if (datafilterIds != null && datafilterIds.length > 0) {
				for (int i = 0; i < datafilterIds.length; i++) {
					if (datafilterIds[i].startsWith("*TimeFilter*")) {
						datafilterIds[i] = datafilterIds[i].substring(12);
						isTimeFilter = true;
					}
				}
			}
			multiBuilder.setDataFilters(datafilterIds);
			multiBuilder.setDisplayRule(displayRule);

			// Filter report type  
			String suffix = AggReportBuilder.LOG_CASE_TYPE;
			String checkboxStr = request.getParameter("checkbox" + suffix);
			boolean isCheck = checkboxStr != null && checkboxStr.equals("true");

			if ((isCheck && currentBuilder == null) || (currentBuilder != null && currentBuilder instanceof LogAggCaseBuilder)) {
				LogAggCaseBuilder caseBuilder = currentBuilder != null ? (LogAggCaseBuilder) currentBuilder : (LogAggCaseBuilder) multiBuilder
						.getFirstSubBuildersByType(AggReportBuilder.LOG_CASE_TYPE);

				String[] filetrsIds = request.getParameterValues("To_Select_filters" + AggReportBuilder.LOG_CASE_TYPE);
				boolean isSubTimeFilter = false;
				if (filetrsIds != null && filetrsIds.length > 0) {					
					for (int i = 0; i < filetrsIds.length; i++) {
						if (filetrsIds[i].startsWith("*TimeFilter*")) {
							filetrsIds[i] = filetrsIds[i].substring(12);
							isSubTimeFilter = true;
						}
					}
				}

				if (filetrsIds == null || filetrsIds.length == 0) {
					if (message.length() > 0) {
						message += "\n";
					}
					message += "No filter was selected.";
					success = false;
				}

				if (success) {
					LogAggCaseBuilder[] filterBuilders = null;
					ArrayList list = new ArrayList();
					if (caseBuilder != null || filetrsIds.length == 1) {
						filterBuilders = new LogAggCaseBuilder[] { caseBuilder };
						list.add(filetrsIds);
					} else if (filetrsIds.length > 1) {
						filterBuilders = new LogAggCaseBuilder[filetrsIds.length];
						for (int i = 0; i < filterBuilders.length; i++) {
							list.add(new String[] { filetrsIds[i] });
						}
					}

					for (int i = 0; i < filterBuilders.length; i++) {
						caseBuilder = filterBuilders[i];
						if (caseBuilder == null) {
							caseBuilder = new LogAggCaseBuilder();

							AggCaseDefinition def = new AggCaseDefinition();
							def.setName(multiBuilder.getCaseDef().getName() + " - FILTERS_NAME");
							def.setDesc("");
							def.setType(AggReportBuilder.LOG_CASE_TYPE);
							def.setGroup(group);
							def.setId(AggBuilderHelper.createCaseBuilderId(def));
							caseBuilder.setCaseDef(def);
						}
						filterBuilders[i] = caseBuilder;

						caseBuilder.getCaseDef().setGroup(group);
						caseBuilder.setLogId(multiBuilder.getLogId());

						LogAggregationConf conf = new LogAggregationConf();
						conf.setLogId(multiBuilder.getLogId());
						conf.setTotal(true);
						conf.setDayDis(false);
						conf.setHourDis(false);
						conf.setMinDis(false);

						filetrsIds = (String[]) list.get(i);
						if (filetrsIds != null && filetrsIds.length > 0 && !(filetrsIds.length == 1 && filetrsIds[0].length() == 0)) {
							conf.setDataFilters(filetrsIds);
						}
						conf.setFilters(new String[] { "" });
						conf.setFilters(true);
						caseBuilder.setAggConf(conf);
						caseBuilder.setDataFilters(filetrsIds);
						caseBuilder.setUseInMerge(!isSubTimeFilter);

						AggBuilderHelper.updateAggCaseBuilderNames(caseBuilder, lbm);

						if (currentBuilder == null) {
							multiBuilder.addSubBuilder(caseBuilder);
						}
					}
				}
			}

			//Group by report type
			suffix = AggReportBuilder.LOG_DIMS_CASE_TYPE;
			checkboxStr = request.getParameter("checkbox" + suffix);
			isCheck = checkboxStr != null && checkboxStr.equals("true");

			if ((isCheck && currentBuilder == null) || (currentBuilder != null && currentBuilder instanceof LogDimsAggCaseBuilder)) {
				LogDimsAggCaseBuilder caseBuilder = currentBuilder != null ? (LogDimsAggCaseBuilder) currentBuilder
						: (LogDimsAggCaseBuilder) multiBuilder.getFirstSubBuildersByType(AggReportBuilder.LOG_DIMS_CASE_TYPE);
				;
				
				String allDimsStr = request.getParameter("allColumns" + suffix);
				boolean allDims = allDimsStr != null && allDimsStr.equals("true");				
				
				String[] contextsIds = request.getParameterValues("To_Select_column" + suffix);
				if (contextsIds == null || contextsIds.length == 0) {
					if (message.length() > 0) {
						message += "\n";
					}
					message += "No context column was selected.";
					success = false;
				}
	
				if (success){			
				  LogDimsAggCaseBuilder[] dimsBuilders = null;
				  ArrayList list = new ArrayList();
				
				  if (caseBuilder != null || allDims || contextsIds.length == 1) {
						dimsBuilders = new LogDimsAggCaseBuilder[] { caseBuilder };
						list.add(contextsIds);
					} else if (contextsIds.length > 1) {
						dimsBuilders = new LogDimsAggCaseBuilder[contextsIds.length];
						for (int i = 0; i < dimsBuilders.length; i++) {
							list.add(new String[] { contextsIds[i] });
						}
					}

					for (int i = 0; i < dimsBuilders.length; i++) {
						caseBuilder = dimsBuilders[i];
				
				if (caseBuilder == null) {
					caseBuilder = new LogDimsAggCaseBuilder();

					AggCaseDefinition def = new AggCaseDefinition();
					def.setName(multiBuilder.getCaseDef().getName() + " group by [COLUMNS_NAME]");
					def.setDesc("");
					def.setType(AggReportBuilder.LOG_DIMS_CASE_TYPE);
					def.setGroup(group);
					def.setId(AggBuilderHelper.createCaseBuilderId(def));
					caseBuilder.setCaseDef(def);
				}
				dimsBuilders[i] = caseBuilder;
				caseBuilder.getCaseDef().setGroup(group);
				caseBuilder.setLogId(multiBuilder.getLogId());

				
				if (success) {
					LogAggregationConf conf = new LogAggregationConf();
					conf.setLogId(multiBuilder.getLogId());
					conf.setTotal(true);
					conf.setDayDis(false);
					conf.setHourDis(false);
					conf.setMinDis(false);

					contextsIds = (String[]) list.get(i);
					int[] contextsIndexes = null;
					if (contextsIds != null && contextsIds.length > 0) {
						contextsIndexes = new int[contextsIds.length];
						for (int j = 0; j < contextsIds.length; j++) {
							try {
								contextsIndexes[j] = Integer.parseInt(contextsIds[j]);
							} catch (Exception e) {
								ErrorModel.log.error("Failed to convert context id to int " + contextsIds[i], e);
								contextsIndexes[j] = -1;
							}
						}
						conf.setContentIndexToAgg(contextsIndexes);
						conf.setByAllContentColumns(true);

					}

					if (datafilterIds != null && datafilterIds.length > 0) {
						conf.setDataFilters(datafilterIds);
					}
					conf.setFilters(new String[] { "" });
					conf.setFilters(true);
					caseBuilder.setAggConf(conf);
					caseBuilder.setDataFilters(datafilterIds);
					caseBuilder.setContentCols(contextsIndexes);
					caseBuilder.setDisplayRule(multiBuilder.getDisplayRule());

					AggBuilderHelper.updateAggCaseBuilderNames(caseBuilder, lbm);

					if (currentBuilder == null) {
						multiBuilder.addSubBuilder(caseBuilder);
					}
				}
				}

			   }
			}

			//knowledge report type
			suffix = AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE;
			checkboxStr = request.getParameter("checkbox" + suffix);
			isCheck = checkboxStr != null && checkboxStr.equals("true");

			if ((isCheck && currentBuilder == null) || (currentBuilder != null && currentBuilder instanceof LogKnowledgeAggCaseBuilder)) {
				LogKnowledgeAggCaseBuilder caseBuilder = currentBuilder != null ? (LogKnowledgeAggCaseBuilder) currentBuilder
						: (LogKnowledgeAggCaseBuilder) multiBuilder.getFirstSubBuildersByType(AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE);
				;
				if (caseBuilder == null) {
					caseBuilder = new LogKnowledgeAggCaseBuilder();

					AggCaseDefinition def = new AggCaseDefinition();
					def.setName(multiBuilder.getCaseDef().getName() + " content");
					def.setDesc("");
					def.setType(AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE);
					def.setGroup(group);
					def.setId(AggBuilderHelper.createCaseBuilderId(def));
					caseBuilder.setCaseDef(def);
				}

				caseBuilder.getCaseDef().setGroup(group);
				caseBuilder.setLogId(multiBuilder.getLogId());

				if (success) {
					LogAggregationConf conf = new LogAggregationConf();
					conf.setLogId(multiBuilder.getLogId());
					conf.setTotal(true);
					conf.setDayDis(false);
					conf.setHourDis(false);
					conf.setMinDis(false);

					if (datafilterIds != null && datafilterIds.length > 0) {
						conf.setDataFilters(datafilterIds);
					}
					conf.setFilters(new String[] { "" });
					conf.setFilters(true);
					KnowledgeAggConf knowAggConf = new KnowledgeAggConf();
					knowAggConf.setAddUnknownResults(false);
					conf.setKnowledgeConf(knowAggConf);
					conf.setKnowledge(true);

					caseBuilder.setAggConf(conf);
					caseBuilder.setDataFilters(datafilterIds);
					caseBuilder.setDisplayRule(multiBuilder.getDisplayRule());

					if (currentBuilder == null) {
						multiBuilder.addSubBuilder(caseBuilder);
					}
				}

			}

			//similarity report type
			suffix = AggReportBuilder.LOG_SIMILARITY_CASE_TYPE;
			checkboxStr = request.getParameter("checkbox" + suffix);
			isCheck = checkboxStr != null && checkboxStr.equals("true");

			if ((isCheck && currentBuilder == null) || (currentBuilder != null && currentBuilder instanceof LogSimilarityAggCaseBuilder)) {
				LogSimilarityAggCaseBuilder caseBuilder = currentBuilder != null ? (LogSimilarityAggCaseBuilder) currentBuilder
						: (LogSimilarityAggCaseBuilder) multiBuilder.getFirstSubBuildersByType(AggReportBuilder.LOG_SIMILARITY_CASE_TYPE);
				;
				if (caseBuilder == null) {
					caseBuilder = new LogSimilarityAggCaseBuilder();

					AggCaseDefinition def = new AggCaseDefinition();
					def.setName(multiBuilder.getCaseDef().getName() + " unique messages");
					def.setDesc("");
					def.setType(AggReportBuilder.LOG_SIMILARITY_CASE_TYPE);
					def.setGroup(group);
					def.setId(AggBuilderHelper.createCaseBuilderId(def));
					caseBuilder.setCaseDef(def);
				}

				caseBuilder.getCaseDef().setGroup(group);
				caseBuilder.setLogId(multiBuilder.getLogId());

				if (success) {
					LogAggregationConf conf = new LogAggregationConf();
					conf.setLogId(multiBuilder.getLogId());
					conf.setTotal(true);
					conf.setDayDis(false);
					conf.setHourDis(false);
					conf.setMinDis(false);

					if (datafilterIds != null && datafilterIds.length > 0) {
						conf.setDataFilters(datafilterIds);
					}
					conf.setFilters(new String[] { "" });
					conf.setFilters(true);

					SimilarityAggConf similarityAggConf = new SimilarityAggConf();
					String[] includeColumnsIds = request.getParameterValues("To_Select_column" + suffix);  
					HashSet includeColumns = null;
					if (includeColumnsIds != null && includeColumnsIds.length > 0) {
						includeColumns = new HashSet();						
						for (int i = 0; i < includeColumnsIds.length; i++) {
							try {
								includeColumns.add(new Integer(includeColumnsIds[i]));
							} catch (Exception e) {
								ErrorModel.log.error("Failed to convert context id to int " + includeColumnsIds[i], e);
							}
						}
					}
					similarityAggConf.setIncludeColumns(includeColumns);
					similarityAggConf.setThreshold(0.8);

					conf.setSimilarityConf(similarityAggConf);
					conf.setSimilarity(true);					

					caseBuilder.setAggConf(conf);
					caseBuilder.setDataFilters(datafilterIds);
					caseBuilder.setDisplayRule(multiBuilder.getDisplayRule());

					AggBuilderHelper.updateAggCaseBuilderNames(caseBuilder, lbm);
					if (currentBuilder == null) {
						multiBuilder.addSubBuilder(caseBuilder);
					}
				}

			}

			//function report type
			suffix = AggReportBuilder.LOG_FUNCTION_CASE_TYPE;
			checkboxStr = request.getParameter("checkbox" + suffix);
			isCheck = checkboxStr != null && checkboxStr.equals("true");

			if ((isCheck && currentBuilder == null) || (currentBuilder != null && currentBuilder instanceof LogFunctionAggCaseBuilder)) {
				LogFunctionAggCaseBuilder caseBuilder = currentBuilder != null ? (LogFunctionAggCaseBuilder) currentBuilder
						: (LogFunctionAggCaseBuilder) multiBuilder.getFirstSubBuildersByType(AggReportBuilder.LOG_FUNCTION_CASE_TYPE);
				if (caseBuilder == null) {
					caseBuilder = new LogFunctionAggCaseBuilder();

					AggCaseDefinition def = new AggCaseDefinition();
					def.setName(multiBuilder.getCaseDef().getName() + " computation");
					def.setDesc("");
					def.setType(AggReportBuilder.LOG_FUNCTION_CASE_TYPE);
					def.setGroup(group);
					def.setId(AggBuilderHelper.createCaseBuilderId(def));
					caseBuilder.setCaseDef(def);
				}

				caseBuilder.getCaseDef().setGroup(group);
				caseBuilder.setLogId(multiBuilder.getLogId());

				if (success) {
					LogAggregationConf conf = new LogAggregationConf();
					conf.setLogId(multiBuilder.getLogId());
					conf.setTotal(true);
					conf.setDayDis(false);
					conf.setHourDis(false);
					conf.setMinDis(false);

					if (datafilterIds != null && datafilterIds.length > 0) {
						conf.setDataFilters(datafilterIds);
					}
					conf.setFilters(new String[] { "" });
					conf.setFilters(true);
					caseBuilder.setAggConf(conf);
					caseBuilder.setDataFilters(datafilterIds);
					caseBuilder.setDisplayRule(multiBuilder.getDisplayRule());

					LogFunctionAggCaseBuilder tmpBuilder = builder.getTempFunctionCaseBuilder();
					if (tmpBuilder != null) {
						caseBuilder.setColIndexes(tmpBuilder.getColIndexes());
						caseBuilder.setExpressions(tmpBuilder.getExpressions());
						caseBuilder.setFunctionsInfo(tmpBuilder.getFunctionsInfo());
						caseBuilder.setTemplates(tmpBuilder.getTemplates());
					}

					if (caseBuilder.getExpressionsAggConf().length == 0) {
						if (message.length() > 0) {
							message += "\n";
						}
						message += "No function was added.";
						success = false;
					}

					if (success) {
						DataExpressionAggConf [] confs = caseBuilder == null ? null : caseBuilder.getExpressionsAggConf();
						ExpressionAggConf eaConf = new ExpressionAggConf();
						ArrayList list = new ArrayList(Arrays.asList(confs));
						eaConf.setExpressionsConf(list);
						conf.setExpressionConf(eaConf);
						conf.setExpression(true);
						  
						if (currentBuilder == null) {
							multiBuilder.addSubBuilder(caseBuilder);
						}
					}
				}

			}

			if (success) {
				if (!isEdit) {
					DefaultLogAggCaseBuilder[] subBuilders = multiBuilder.getSubBuildersArr();
					for (int i = 0; i < subBuilders.length; i++) {
						builder.addReportTypeBuilder(subBuilders[i]);
					}
				}
			}

		} catch (Throwable e) {
			e.printStackTrace();
			ErrorModel.log.error("Failed to add report types " + type, e);
			success = false;
			if (message.length() > 0) {
				message += "\n";
			}
			message += e.getMessage();
		}
	}

	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");

	out.write(xml);
	out.flush();
%>


