<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.reports.agg.result.view.AggReportViewer"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%!static final String BASE_DIRECTORY = "../../";
	static final int MAX_NAME_CHAR = 100;
	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	final UserContext userContext = UserEnvironment.getUserContext(request);
	String reportId = request.getParameter("reportId");
	String reportRuntimeId = request.getParameter("reportRuntimeId");
	String print = request.getParameter("print");
	boolean isPrint = print != null && print.equalsIgnoreCase("true");
	String mail = request.getParameter("mail");
	boolean isMail = mail != null && mail.equalsIgnoreCase("true");
	String forceForwardStr = request.getParameter("forceForward");
	boolean forceForward = forceForwardStr != null && forceForwardStr.equals("true");
	String refreshMenusStr = request.getParameter("refreshMenus");
	boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");
	String executableStr = request.getParameter("executable");
	boolean executable = executableStr != null && executableStr.equals("true");
	
	ReportsManager reportMgr = ReportsManager.getInstance();
	final Report report = reportMgr.getReportById(reportId, true);
	
	if (reportId != null && !reportId.equals("AggregationCompare")){
	  request.getSession().setAttribute("lastSelectedReport",reportId);
	}

	if (reportId == null || reportId.trim().equals("")) {
		errmodel.addError("No Report id was supplied.");
	}
	if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
		errmodel.addError("No Report runtime id was supplied.");
	}

	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=applications/delek/reports/reportsDefinitionView.jsp");
		return;
	}
			
	String reportName = report.getReportName();
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.VIEW, "view report", AuditConstants.REPORTS, "view report " + reportName);

	final ReportRuntime repRuntime  = report.getReportRuntimeById(reportRuntimeId);			
	if (isMail || forceForward){
		request.getRequestDispatcher("aggReportInner.jsp").forward(request, response);
		return;
	}
	
	String forward = "reports/agg/aggReportInner.jsp";
	String params = "?";
	params += request.getQueryString();
	params += "&isProgress=true";
	params += "&refreshMenus=" + refreshMenus;
	params += "&executable=" + executable;
	forward = forward + params;
	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	env.removeProgressRunner();
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + forward) {
	  public void run(HttpServletRequest request){
	  	try {
	  	long start = System.currentTimeMillis();
	  	
	  	AggReportRuntime runtime = null;
	  	AggReportGroupRuntime groupRuntime = null;
	  	if (repRuntime instanceof AggReportGroupRuntime){
				groupRuntime = (AggReportGroupRuntime)repRuntime;
				runtime = groupRuntime.getAggRuntime();				
			}else {
				runtime = (AggReportRuntime)repRuntime;
			}
	  	
	  	AggReportViewer viewer = new AggReportViewer();
		  viewer.setReport(report);
		  viewer.setReportRuntime(runtime);
		  viewer.setBaseDirectory(BASE_DIRECTORY);
		  viewer.setUserContext(userContext);
		  viewer.init();
		  
		  env.setTempAttribute("TEMP_REPORT_RUNTIME", runtime);
	  	env.setTempAttribute("TEMP_AGG_REPORT_VIEWER", viewer);
	  	if(groupRuntime != null) {
	  		env.setTempAttribute("TEMP_REPORT_GROUP_RUNTIME", groupRuntime);
	  	}
	  	
	  	long end = System.currentTimeMillis();
	  	if(end - start < 3000) {
	  		try {
	  			Thread.sleep(3000 - (end - start));
	  		}catch(Exception e) {
	  		}
	  	}
	  	}catch(Exception e) {
	  		e.printStackTrace();
	  	}
	  }
	};
	env.setProgressRunner(runner);
	
	String isEnvironmentAnalysisStr = request.getParameter("isEnvironmentAnalysis");
  boolean isEnvironmentAnalysis = isEnvironmentAnalysisStr != null && isEnvironmentAnalysisStr.equals("true");
  isEnvironmentAnalysis = isEnvironmentAnalysis || (report != null && report instanceof EnvironmentAnalysisReport);
  boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
  
  String text = "Loading report data";
	if(isEnvironmentAnalysis) {
		if(isTestingBuid) {
			text = "Loading testing analysis data";
		}else {
			text = "Loading environment analysis data";
		}
	}
%>
	
<jsp:include page="../../common/actionProgress.jsp" flush="true">
	 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
	 <jsp:param name="message" value="<%=text %>"/>
	</jsp:include>