<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.TranReportBuilder"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>

<%!static final String BASE_DIRECTORY = "../../";

	%>
<%
			String DUPLICATE = "DUPLICATE";
			
			String op = request.getParameter("op");
			boolean doGenerate = op != null && op.equalsIgnoreCase("generate");
			
			if (doGenerate){
				request.getRequestDispatcher("aggReportExecutionDefinition.jsp").forward(request, response);
				return;
			}

			WebSecurityManager manager = WebSecurityManager.getInstance();
			if (!manager.checkForPermission(request, response, null, true)) {
				return;
			}
			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();
			UserSecurity user = manager.getUserSecurity(request);
			
			
			String duplicateStr = request.getParameter(DUPLICATE);
			boolean duplicate = duplicateStr != null && duplicateStr.equals("true");

			String reportTemplateId = request.getParameter("reportTemplateId");
			if (reportTemplateId == null) {
				reportTemplateId = "";
			}

			String reportId = request.getParameter("reportId");
			if (reportId == null) {
				reportId = "";
			}

			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportId.length() == 0 ? null : (Report) reportMgr.getReportById(reportId);
			boolean isNew = false;
			if (report == null) {
				report = reportTemplateId.length() == 0 ? null : (Report) reportMgr.getReportTemplateById(reportTemplateId);
				isNew = true;
				request.getSession().removeAttribute("lastSelectedReport");
			}else {
				request.getSession().setAttribute("lastSelectedReport",reportId);
			}
			
			
			
			AbstractReportBuilder builder = null;
			if (report == null) {
				builder = (AbstractReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
				if (builder != null){
					report = builder.getReport();
				}
			} else {
				if (report.getReportType().equals(Report.LOG_GROUP_TYPE)){
				  builder = new AggReportGroupBuilder((LogAggReportGroup)report);
				}else if (report.getReportType().equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){
				  builder = new EnvironmentAnalysisReportBuilder((EnvironmentAnalysisReport)report);
				}else {
					builder = report.getReportType().equals(Report.TRANSACTION_TYPE) ? new TranReportBuilder((AggReport)report) :  new AggReportBuilder((AggReport)report);
				}
				builder.setNew(isNew);
				builder.updateInfo();
			}		
			
			String type = builder.getReportType();
			boolean isEnvironmentAnalysis = type != null && type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE);
			boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
			boolean isTxExpo = builder != null && builder instanceof TranReportBuilder;
			
			request.setAttribute("report",report);
			
			String executableStr = request.getParameter("executable");
			boolean executable = executableStr != null && executableStr.equals("true");
			if(isNew) {
				executable = true;
			}
			
			if (op == null){
				op = builder == null ? "" : builder.getOp();
			}
			builder.setOp(op);
			request.getSession().setAttribute("REPORT_BUILDER", builder);
			
			if (XpologSecurityManager.getInstance().isEnabled()){
			  ModuleMemberPermissions currPermission = report.getPermissions();	
			  if (currPermission != null){
			    request.setAttribute("currPermission",currPermission);
		    }
		  }
			
			String selectedSourceId = null;
			if (builder instanceof TranReportBuilder){
				TranReportBuilder tranBuilder = (TranReportBuilder)builder;
				String tranId = tranBuilder.getDefaultTransactionParaigmId();
				String projectId = tranBuilder.getDefaultProjectId();
				if (tranId == null){
					selectedSourceId = "";
				}else {
					selectedSourceId = projectId + "@" + tranId;
					boolean findTran = false;
					try {
						TransactionParadigm paradigm = BrainConfigurationRepository.getRepository().getTransactionParadigmById(tranId);
						findTran = paradigm != null;
					}catch (Exception e){}
					if (!findTran){		  			 
		  			 selectedSourceId = "";
		  			 tranBuilder.clearReportTypes();
		  			 tranBuilder.setDefaultProjectId("");
		  			 tranBuilder.setDefaultTransactionParaigmId("");
		  		 }
				}			
			}else if (builder instanceof AggReportBuilder){
				AggReportBuilder aggReportBuilder = (AggReportBuilder)builder;
				selectedSourceId = aggReportBuilder.getDefaultLogId();
				if (selectedSourceId == null){
					selectedSourceId = "";
				}else if (selectedSourceId.length() > 0){
		  		 boolean findLog = true;
		  		 try {
		  			 LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager(selectedSourceId, true,false);
		  			 findLog = lbm != null;
		  		 }catch (Exception e){  			 
		  			 findLog = false;
		  		 }
		  		 if (!findLog){		  			 
		  			 selectedSourceId = "";
		  			 aggReportBuilder.clearReportTypes();
		  			 aggReportBuilder.setDefaultLogId(selectedSourceId);
		  			 
		  		 }		  
				}
			}
			
			String headerTitle = "";
			if (type.equals(Report.LOG_TYPE)){
				if (isNew){
					headerTitle = "Add Log Report";
				}else {
					headerTitle = "Edit Log Report";
				}
			}else if (type.equals(Report.LOG_GROUP_TYPE)){
				if (isNew){
					headerTitle = "Add Log Group Report";
				}else {
					headerTitle = "Edit Log Group Report";
				}
			}else if (type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){
				String titleType = " ";
				if(report.getDisplayType() != null &&  report.getDisplayType().length() > 0) {
					titleType += report.getDisplayType();
				}
				if (isNew){
					headerTitle = "Add" + titleType + " Environment Analysis";
				}else {
					headerTitle = "Edit" + titleType + " Environment Analysis";
				}
			}else if (type.equals(Report.TRANSACTION_TYPE)){				
				if (isNew){
					headerTitle = "Add Transaction Report";
				}else {
					headerTitle = "Edit Transaction Report";
				}
			}
			
			String reportName = "";
			String reportDesc = "";
			if (report != null) {
				reportName = report.getReportName();
				reportDesc = report.getDescription();
			}
			
			if (duplicate || isNew){
				reportName = "";
				reportDesc = "";
				reportId = "";				
				builder.setNew(true);
			}
			
			String[] appIds = builder.getApplicationsIds();
			String appIdsStr = "";
			if(appIds != null && appIds.length != 0){
				for(int i = 0; i < appIds.length; i++) {
			  	appIdsStr += appIds[i] + "#";		  
			  }
			}
			
			UserContext userContext = UserEnvironment.getUserContext(request);
			boolean allowNewApplication = true;
		  if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION)){
		  	allowNewApplication = false;
		  }
			
		  String typeText = "Report";
		  String typeTextLower = "report";
		  if(isEnvironmentAnalysis) {
		  	if(isTestingBuid) {
		  		typeText = "Testing Analysis";
		  		typeTextLower = "testing analysis";
		  	}else {
		  		typeText = "Environment Analysis";
		  		typeTextLower = "environment analysis";
		  	}
		  }

			%>

<%@page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us" charset="windows-1255">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />

<script language="JavaScript1" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<script language="javascript">	
	
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
	var base_directory = "<%=BASE_DIRECTORY%>";
	  
  function showSaveSettings(){
  	showHideLayerInMiddle("saveSettingsDiv",-1,-1);
  }
    
  function saveReport(fromSaveReportAndGenerate){    
  	// document.getElementById("caseDivMessage").innerHTML = "";
    prepareGeneral();      
    updateTimeParams();    
    prepareSaveCustom();
    <%if (XpologSecurityManager.getInstance().isEnabled()){%>
	  updatePermissions();
	  <%}%>
	  
	  if(!fromSaveReportAndGenerate || fromSaveReportAndGenerate == 'false') {
	  	document.access.saveAndGenerate.value="false";
	  }
	  
	  if (validateSubmit()){
	  	var params = getFormElementsQueryString(document.access);
	  	params += "&executable=<%=executable %>";
	  	var url = getSavePage();
	  	sendAjaxRequest(url,function(req){
		    var xmldoc = req.responseXML.documentElement;
	      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	      if (result == "false"){
				  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	    		var msg = "<ul>";
	    		var errs = message.split("*;*");
	    		for (var i=0; i<errs.length; i++){
	    			msg = msg + "<li>" + errs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
	
		    	var msgWriter = new messageWriter("reportDefinitionMessage","Save <%=typeText %> Error","<%=BASE_DIRECTORY%>");
			    msgWriter.addAction("OK","javascript:hideLayer('reportDefinitionMessage')");
			    msgWriter.setStyle("left");
			    msgWriter.showMessage(msg);
	
		    	if (typeof setErrorColor == 'function' && xmldoc.getElementsByTagName('params')[0] && xmldoc.getElementsByTagName('params')[0].firstChild){
			    	var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
			    	var pArr = params.split("*;*");
			    	for (var i=0; i<pArr.length; i++){
			    		if (eval("document.access."+ pArr[i])){
			    			setErrorColor(eval("document.access."+ pArr[i]));
			    		}
			    	}
		    	}
	      }else{
	      	if (xmldoc.getElementsByTagName('params')[0] && xmldoc.getElementsByTagName('params')[0].firstChild){
			    	var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
			    	var pArr = params.split("*;*");
			    	var reportId;
			    	var isEnvironmentAnalysis;
			    	var doGenerate;
			    	if(pArr.length > 0) {
			    		reportId = pArr[0];
			    	}
			    	if(pArr.length > 1) {
			    		isEnvironmentAnalysis = pArr[1];
			    	}
			    	if(pArr.length > 2) {
			    		doGenerate = pArr[2];
			    	}
			    	if(reportId && reportId != '' && doGenerate && doGenerate == 'true') {
			    		if(document.access.saveAndGenerate.value == "true") {
			    			if(typeof needsUserInput == 'function' && needsUserInput()) {
					  			var page = "../reportGenerationDiv.jsp?base_directory=../../&reportId=" + reportId + "&noScripts=true&needsUserInput=true&executable=<%=executable %>";
						  		sendAjaxRequest(page,function(req){
										var result = req.responseText;	
										result = result.replace(/^\s+|\s+$/g, '') ;
										if (!result){
											alert("Could not open generation window!");
											return;
										}
										var reportGenerationDivElem = document.getElementById("reportGenerationDiv");
										if(reportGenerationDivElem){
										  reportGenerationDivElem.style.display = "";
											reportGenerationDivElem.innerHTML = result;
										}
										showGeneralAdminDiv("reportGeneration");
									});
					  		}else {
					  			document.location = "<%=BASE_DIRECTORY %>reports/reportRuntimeGenerate.jsp?reportId=" + reportId + "&isEnvironmentAnalysis=" + isEnvironmentAnalysis + "&executable=<%=executable %>";
					  		}
			    		}else {
			    			document.location = "<%=BASE_DIRECTORY %>reports/reportRuntimeGenerate.jsp?reportId=" + reportId + "&isEnvironmentAnalysis=" + isEnvironmentAnalysis + "&executable=<%=executable %>";
			    		}
			    	}else {
		    			document.location = "<%=BASE_DIRECTORY %>reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=" + isEnvironmentAnalysis + "&executable=<%=executable %>";
		    		}
		    	}
	      }
		  },'POST',params);
  	}
	}
	
	function saveReportAndGenerate(){
  	document.access.saveAndGenerate.value="true";
    saveReport('true');
	}
	
  function continueReportGeneration(reportId, isEnvironmentAnalysis) {
  	var prefix = 'reportGenerationInputRequest';
  	if(typeof updateGenerationTimeParams == 'function' && eval('document.reportGenerationForm.' + prefix + 'TimeUnit')) {
  		updateGenerationTimeParams();
  	}
  	var params = "reportId=" + reportId + "&prefix=reportGenerationInputRequest&";
  	params += getFormElementsQueryString(document.reportGenerationForm, prefix);
  	var page = "../reportGenerationValidation.jsp?";
  	sendAjaxRequest(page,function(req){
			var xmldoc = req.responseXML.documentElement;
	    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	    if (result == "false"){
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
    		var msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"

		    var msgWriter = new messageWriter("reportDefinitionMessage","Generate Error","<%=BASE_DIRECTORY%>");
		    msgWriter.addAction("OK","javascript:hideLayer('reportDefinitionMessage')");
		    msgWriter.setStyle("left");
		    msgWriter.showMessage(msg);
			}else {
				document.location = "<%=BASE_DIRECTORY %>reports/reportRuntimeGenerate.jsp";
			}
		},'POST',params);
  }
  
  function cancelReportGeneration() {
  	var reportGenerationDivElem = document.getElementById("reportGenerationDiv");
		if(reportGenerationDivElem){
		  reportGenerationDivElem.style.display = "none";
			reportGenerationDivElem.innerHTML = "";
		}
  	hideGeneralAdminDiv("reportGeneration");
  }
	
	function updatePermissions(){
		for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
			document.access.selectedEditMembersList.options[j].selected = true;
		}
		for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
			document.access.selectedViewMembersList.options[j].selected = true;
		}
	}
	
	function init(){
	  initTabs();
		initTables();
		initCustom();
	}
	
	function validateSubmit(){
	  var result = true;
	  if (!document.getElementById("reportName") || document.getElementById("reportName").value == ""){
	    highlightBgColor("reportName");
    	document.getElementById("ReportNameErrorMsg").innerHTML = "Please name your <%=typeTextLower %>";
	    result = false;
	  }else {
	    clearBgColor("reportName");
	    document.getElementById("ReportNameErrorMsg").innerHTML = "";
	  }
	  
	  if (validateCustomSubmit()){
	    return result;
	  }else {
	    return false;
	  }	  	  
	}
    
</script>

<%if (type.equals(Report.LOG_TYPE)){%>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/reports/logAggReport.js"></script>
<%}else if (type.equals(Report.LOG_GROUP_TYPE)){%>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/reports/logAggGroupReport.js"></script>
<%} else if (type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){%>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/reports/environmentAnalysisReport.js"></script>
<%} else if (type.equals(Report.TRANSACTION_TYPE)){%>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/reports/transactionAggReport.js"></script>
<%} %>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../common/sysFilesBrowser.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/>
	<jsp:param name="scriptsOnly" value="true"/> 
</jsp:include>

	<%if (type.equals(Report.LOG_TYPE)){%>
<jsp:include page="../../common/selectLogHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="../../" />
	<jsp:param name="LBM_ID" value="<%=selectedSourceId%>" />
	<jsp:param name="mode" value="logs" />
	<jsp:param name="treeOnly" value="true" />
	<jsp:param name="ignoreHeader" value="true" />
	<jsp:param name="allowNewLog" value="true" />
	<jsp:param name="logPopupMenu" value="true" />
	<jsp:param name="parameterName" value="Report log:" />
	<jsp:param name="openLinkName" value="select log" />
	<jsp:param name="showReportsModule" value="true" />
	<jsp:param name="showNewFilter" value="false" />
	<jsp:param name="paramNameWidth" value="150" />
	<jsp:param name="dummy" value="dummy" />
</jsp:include>

<%
String allowNewLogStr = request.getParameter("allowNewLog");
boolean allowNewLog = allowNewLogStr == null || allowNewLogStr.equals("true");
if (userContext != null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION)){
	allowNewLog = false;
}
String actionsNames = allowNewLog ? "Create new Log#Close" : "Close";
String actions = allowNewLog ? "javascript:openNewLogDiv()#javascript:closeLogSelectionDiv()" : "javascript:closeLogSelectionDiv()";

%>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Log to report"/> 
	<jsp:param name="suffix" value="SelectLog"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>

<%} else if (type.equals(Report.TRANSACTION_TYPE)){ %>
<jsp:include page="../../logic/common/selectTransactionHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="../../" />
	<jsp:param name="TRAN_ID" value="<%=selectedSourceId%>" />
	<jsp:param name="mode" value="trans" />
	<jsp:param name="treeOnly" value="true" />
	<jsp:param name="ignoreHeader" value="true" />
	<jsp:param name="showNewFilter" value="false" />
	<jsp:param name="paramNameWidth" value="150" />	
	<jsp:param name="dummy" value="dummy" />	
</jsp:include>

<%
String actionsNames = "Close";
String actions = "javascript:closeTransactionSelectionDiv()";

%>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select transaction to report"/> 
	<jsp:param name="suffix" value="SelectTransaction"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>

<%} %>
<%
String actionsNames = "Apply#Close";
String actions = "javascript:applyFunctionsOp();makeChecked('logFunctionAgg')#javascript:closeFunction()";


%>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Computation"/> 
	<jsp:param name="suffix" value="function"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>

<jsp:include page="../reportGenerationDiv.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="scriptsOnly" value="true"/> 
</jsp:include>
<title></title>
</head>

<div id="addAccDiv" style="display:none">
</div>


<body onLoad="init()" onUnload="destroyTables()" style="margin:0px;padding:0px;overflow:auto;" >
<div id="reportGenerationDiv" style="display:none">
</div>
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0px;padding:0px;" method="POST">
<input type="hidden" name="reportTemplateId" value="<%=reportTemplateId%>"> 
<input type="hidden" name="suffix" value="session">
<input type="hidden" name="doSave" value="true">
<input type="hidden" name="saveAndGenerate" value="false">
<%if (type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){%>
<input type="hidden" name="parentApplication" id="parentApplication">

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="Location"/> 
	<jsp:param name="width" value="680px"/> 
	<jsp:param name="height" value="420px"/>
	<jsp:param name="title" value="Add Environment Logs Directory"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveEnvironmentAnalysisLocation()#javascript:showHideGeneralAdminDiv('Location')"/> 
</jsp:include>
<jsp:include page="../../common/sysFilesBrowser.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="file_filter" value="dirOnly"/>
</jsp:include>
<jsp:include page="../../common/accountsListCombo.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="scriptsOnly" value="true"/>
</jsp:include>
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

<tr height="1">
		<td>
			<jsp:include page="../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name:</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" id="reportName" name="reportName" size="50" value="<%=reportName%>"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr  id="ReportNameErrorMsgTR">
											<td style="padding-left:40px" style="font-size:5px">&nbsp;</td>
											<td>
												 <div id="ReportNameErrorMsg" class="ERROR_MSG">
												 </div>
											</td>
										</tr>
										<%if (!type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){%>
										<tr>
											<td><span class="REGULARTEXT">Description:</span></td>
											<td>
												<input type="text" class="TEXTBOX" name="reportDesc" size="50" value="<%=reportDesc%>"> 
											</td>
											<td>&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
										<%} %>
										<%if (type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){%>
										<tr height="10">
	                  	<td valign="top" colspan="3">
	                  		<jsp:include page="../../common/selectParentApplication.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="OBJECT_TYPE" value="<%=XpoLogObjectTypes.REPORT_TYPE%>" />
													<jsp:param name="OBJECT_ID" value="<%=reportId%>" />
													<jsp:param name="APPLICATIONS_IDS" value="<%=appIdsStr%>" />																																																						
													<jsp:param name="titleColWidth" value="150" />
													<jsp:param name="useTextBox" value="true" />
													<jsp:param name="textBoxSize" value="50" />		
													<jsp:param name="allowNewApplication" value="<%=allowNewApplication %>" />																																																																																																		
												</jsp:include>
											</td>																															 			                   						 			                   						 			                   
			             	</tr>
 										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<%} %>
										<%if (type.equals(Report.LOG_TYPE)){%>
										<tr height="10">
											<td valign="top" colspan="3">
												<jsp:include page="../../common/selectLog.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../../" />
													<jsp:param name="LBM_ID" value="<%=selectedSourceId%>" />													
													<jsp:param name="ignoreHeader" value="true"/>
													<jsp:param name="noTree" value="true"/>
													<jsp:param name="mode" value="logs" />
													<jsp:param name="allowNewLog" value="true" />
													<jsp:param name="logPopupMenu" value="true" />
													<jsp:param name="parameterName" value="Report Log:" />
													<jsp:param name="openLinkName" value="select log" />
													<jsp:param name="showReportsModule" value="true" />
													<jsp:param name="showNewFilter" value="false" />
													<jsp:param name="labelWidth" value="150" />
													<jsp:param name="textBoxSize" value="50" />
												</jsp:include>											
											</td>
										</tr>
										<%
										}
										if (type.equals(Report.TRANSACTION_TYPE)){%>
										<tr height="10">
											<td valign="top" colspan="3">
												<jsp:include page="../../logic/common/selectTransaction.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../../" />
													<jsp:param name="TRAN_ID" value="<%=selectedSourceId%>" />													
													<jsp:param name="ignoreHeader" value="true"/>
													<jsp:param name="noTree" value="true"/>
													<jsp:param name="mode" value="trans" />
													<jsp:param name="parameterName" value="Report Transaction:" />
													<jsp:param name="openLinkName" value="select transaction" />
													<jsp:param name="labelWidth" value="150" />
													<jsp:param name="textBoxSize" value="50" />
												</jsp:include>											
											</td>
										</tr>
										<%} %>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
								<div id="generalDiv" style="display:none;width:100%;height:100%;overflow:auto" >
								<jsp:include page="aggReportDefinitionGeneral.jsp" flush="true">
								  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</div>
								
								<%if (type.equals(Report.LOG_TYPE) || type.equals(Report.TRANSACTION_TYPE)){ %>
								<div id="casesDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<% if (!isTxExpo){ %>
									<jsp:include page="aggReportDefinitionCases.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									  <jsp:param name="type" value="<%=type%>" />
									</jsp:include>
									<%} else {
									%>
									<jsp:include page="../../logic/reports/agg/tranAggReportDefinitionCases.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									  <jsp:param name="type" value="<%=type%>" />
									</jsp:include>
									<%} %>
								</div>
								<%} else if (type.equals(Report.LOG_GROUP_TYPE)){ %>
						  	<div id="groupSelectionDiv" style="display:none;height:100%;width:100%;overflow:auto" >												
								<jsp:include page="aggReportGroupSelection.jsp" flush="true">
								  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								  <jsp:param name="type" value="<%=type%>" />
								</jsp:include>
								</div>
								<%} else if (type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)){ %>
						  	<div id="locationsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
						  	<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
									<tr><td style="padding:10px">
						  		<jsp:include page="aggReportEnvironmentAnalysisLocations.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									</jsp:include>			
									</td></tr>
								</table>						
								</div>
								<div id="environmentAnalysisInfoDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
						  		<jsp:include page="aggReportEnvironmentAnalysisInfo.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									</jsp:include>									
								</div>
								<%} %>		
								<div id="schedularDiv" style="display:none;width:100%;height:100%;overflow:auto" >
									<jsp:include page="aggReportDefinitionSched.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									</jsp:include>
								</div>
								<div id="emailDiv" style="display:none;width:100%;height:100%;overflow:auto" >
									<jsp:include page="aggReportDefinitionEmail.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									</jsp:include>
								</div>
								<%
								boolean showMaintenanceSection = true;
								if (type.equals(Report.LOG_GROUP_TYPE)){
									showMaintenanceSection = false;
								}
								%>
								<div id="advancedDiv" style="display:none;width:100%;height:100%;overflow:auto" >
									<jsp:include page="aggReportDefinitionAdvanced.jsp" flush="true">
									  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									  <jsp:param name="showMaintenanceSection" value="<%=showMaintenanceSection %>"/>
									</jsp:include>
								</div>

						    <%if (XpologSecurityManager.getInstance().isEnabled()){%>
						    <div id="permissionsDiv" style="display:none;width:100%;height:100%;overflow:auto" >
									<jsp:include page="../../security/common/moduleMemberPermissionsIncluder.jsp" flush="true">
										<jsp:param name="embedded" value="true" />
	 									<jsp:param name="ignoreName" value="true"/>
	 									<jsp:param name="showDefault" value="true"/>
									</jsp:include>
								</div>
						    <%} %>

						    <%
						    String generalDivId = "";
						    String generalDivTitle = "";
						    if (type.equals(Report.LOG_TYPE) || type.equals(Report.TRANSACTION_TYPE)){
						    	generalDivId = "casesDiv";
						    	generalDivTitle = "Report Types";
						    }else if(type.equals(Report.LOG_GROUP_TYPE)) {
						    	generalDivId = "groupSelectionDiv";
						    	generalDivTitle = "Reports";
						    }else if(type.equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)) {
						    	generalDivId = "environmentAnalysisInfoDiv";
						    	generalDivTitle = "Environment Info";
						    }
						    
						    String[] tabIds = null;
						    String[] tabNames = null;
				    		if (XpologSecurityManager.getInstance().isEnabled()){
				    			if(isEnvironmentAnalysis) {
						    		tabIds = new String[]{"locationsDiv", generalDivId, "generalDiv", "schedularDiv", "emailDiv", "advancedDiv", "permissionsDiv"};
				    				tabNames = new String[]{"Logs Directories", generalDivTitle, "Time Filter", "Schedule", "Emailing", "Advanced", "Security"};
				    			}else {
				    				tabIds = new String[]{generalDivId, "generalDiv", "schedularDiv", "emailDiv", "advancedDiv", "permissionsDiv"};
				    				tabNames = new String[]{generalDivTitle, "Time Filter", "Schedule", "Emailing", "Advanced", "Security"};
				    			}
				    		}else {
				    			if(isEnvironmentAnalysis) {
				    				tabIds = new String[]{"locationsDiv", generalDivId, "generalDiv", "schedularDiv", "emailDiv", "advancedDiv"};
					    			tabNames = new String[]{"Logs Directories", generalDivTitle, "Time Filter", "Schedule", "Emailing", "Advanced"};
				    			}else {
				    				tabIds = new String[]{generalDivId, "generalDiv", "schedularDiv", "emailDiv", "advancedDiv"};
					    			tabNames = new String[]{generalDivTitle, "Time Filter", "Schedule", "Emailing", "Advanced"};
				    			}
				    		}				    			
				    		request.setAttribute("tabIds", tabIds);
				    		request.setAttribute("tabNames", tabNames);
						    %>
						    <jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>			
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<%
		String backActionName = "Back to Reports";
		if(isEnvironmentAnalysis) {
			if(isTestingBuid) {
				backActionName = "Back to Testing Analyses";
			}else {
				backActionName = "Back to Environment Analyses";
			}
		}
		actionsNames = "Save#Save and Generate#" + backActionName;
		actions = "javascript:saveReport()#javascript:saveReportAndGenerate()#reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=" + isEnvironmentAnalysis;
		%>
		<td style="padding-top:10">
			<jsp:include page="../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="<%=actionsNames %>" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>											
		</td>
	</tr>
</table>
</form>
</body>
</html>
