<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%
	String BUILDER = "CURRENT_LOG_BUILDER";
	String ERROR_OBJ = "ERROR_OBJ";

	AbstractReportBuilder builder = (AbstractReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}

	String suffix = "ReportSched";
	String name = "reportScheduler";
	String id = "reportId_" + System.currentTimeMillis();

	
	MailTask mailTask = null;
	List tasks = builder.getTasks();
	if (tasks != null && tasks.size() > 0) {
		XpoTask task = (XpoTask) tasks.get(0);
		if (task instanceof MailTask) {
			mailTask = (MailTask) task;
		}
	}
	String systemFrom = MailTask.SYSTEM_ADDRESS_ID;
	String customFrom = "CUSTOM";
	String mailFrom = systemFrom;
	String mailTo = "";
	String mailSubject = "";
	
	String reportNameSubject = "[REPORT_NAME]";
	String reportNameWithGenSubject = "[REPORT_NAME] ([GENERATED_TIME])";
	String customSubject = "CUSTOM";
	
	String subject = reportNameSubject;
	if (mailTask != null) {
		mailFrom = mailTask.getFromId();
		mailTo = mailTask.getToId();
		mailSubject = mailTask.getSubject();
		subject = mailTask.getSubject();
		if(subject != null && subject.equals(reportNameWithGenSubject)) {
			mailSubject = reportNameSubject;
			subject = reportNameSubject;
		}
	}
	
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	boolean showMailSettings = host.length() == 0 || host.equals(MailConfig.DEF_SMTP_ADDRESS); 
	
	
	
%>


<% if (showMailSettings){ %>

<script>
function saveMailSettings() {
		var smtpHost = document.getElementById("SMTPHost").value;
		if(smtpHost == '') {
			alert("SMTP host cannot be empty");
			return;
		}else if(smtpHost == 'my.domain.com') {
			alert("SMTP host cannot be my.domain.com");
			return;
		}
	
		var params = "";
		params += "SMTPHost=" + document.getElementById("SMTPHost").value;
		params += "&SMTPProt=" + document.getElementById("SMTPProt").value;
		params += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
		sendAjaxRequest("../../tasks/mail/mailSettingsAction.jsp?"+params,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Saving mail setting failed");
				return;			
			}
			if(result.indexOf("ok") != -1) {
				document.getElementById("adminGeneralDivMailSettings").style.display = "none";
				document.getElementById("MailDetails").style.display = "";
			}
		});
	}
</script>

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailSettings"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="245px"/>
	<jsp:param name="left" value="50px"/>
	<jsp:param name="top" value="5px"/>
	<jsp:param name="includePath" value="tasks/mail/mailSettings.jsp?isShort=true"/>	
	<jsp:param name="title" value="Mail Settings"/> 
	<jsp:param name="message" value="Please specify the following mail settings before adding a report email:"/> 
	<jsp:param name="position" value="relative"/>
	<jsp:param name="display" value=""/>
	<jsp:param name="actionsNames" value="Save"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()"/> 
</jsp:include>
<%} %>
<script>
function toggleFrom(isSystem) {
	var mailFrom = document.getElementById("mailFrom");
	var fromCustom = document.getElementById("fromCustom");
	if(mailFrom && fromCustom) {
		if(isSystem) {
			fromCustom.disabled = true;
			fromCustom.value = "";
		}else {
			fromCustom.disabled = false;
		}
	}
}
function toggleSubject(isCustom) {
	var mailSubject = document.getElementById("mailSubject");
	var subjectCustom = document.getElementById("subjectCustom");
	if(mailSubject && subjectCustom) {
		if(isCustom) {
			subjectCustom.disabled = false;
		}else {
			subjectCustom.disabled = true;
			subjectCustom.value = "";
		}
	}
}
</script>
<div style="display:<%=showMailSettings ? "none" : ""%>" id="MailDetails">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

	<tr height="10" style="padding-top: 10">
		<td style="padding-top:10;padding-left:10" valign="top">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr height="10">
					<td style="padding-top:10">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
						<tr>
							<td style="width:100px;"><span class="REGULARTEXT"><nobr>Send from:</nobr></span></td>
							<td style="width:600px;">
								<input type="radio" id="mailFrom" name="mailFrom" value="<%=systemFrom %>" <%=mailFrom.equals(systemFrom) ? "checked" : ""%> onClick="javascript:toggleFrom(true)">
								<span class="REGULARTEXT"><nobr>System Email Address</nobr></span>
							</td>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td></td>
							<% 
							boolean isSystem =  mailFrom.equals(systemFrom);
							%>
							<td>
								<input type="radio" id="mailFrom" name="mailFrom" value="<%=customFrom%>" <%=isSystem ? "" : "checked"%> onClick="javascript:toggleFrom(false)">
								<span class="REGULARTEXT"><nobr>Custom</nobr></span>&nbsp;&nbsp;
								<input type="text" size="40" id="fromCustom" name="fromCustom" value="<%=isSystem ? "" : mailFrom %>" <%=isSystem ? "disabled" : "" %>>
							</td>
							<td>&nbsp;</td>
						</tr>
					</table>
					</td>
				</tr>
				<tr height="10">
					<td style="padding-top:10">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
						<tr >
							<td style="width:100px;"><span class="REGULARTEXT"><nobr>Send to:</nobr></span></td>
							<td style="padding-left: 10">
								<input type="text" name="mailTo" size="40" value="<%=mailTo%>">
								<span class="SMALLTEXT">semicolon separated list</span>
							</td>
						</tr>
					</table>
					</td>
				</tr>
				<tr height="10">
					<td style="padding-top:10">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
						<tr>
							<td style="width:100px;"><span class="REGULARTEXT"><nobr>Email subject:</nobr></span></td>
							<td style="width:600px;">
								<input type="radio" id="mailSubject" name="mailSubject" value="<%=reportNameSubject%>" <%=subject.equals(reportNameSubject) ? "checked" : ""%> onClick="javascript:toggleSubject(false)">
								<span class="REGULARTEXT"><nobr>Report Name </nobr></span>
							</td>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td></td>
							<% 
							boolean isCustom =  !subject.equals(reportNameSubject)/* && !subject.equals(reportNameWithGenSubject)*/;
							%>
							<td>
								<input type="radio" id="mailSubject" name="mailSubject" value="<%=customSubject%>" <%=isCustom ? "checked" : ""%> onClick="javascript:toggleSubject(true)">
								<span class="REGULARTEXT"><nobr>Custom </nobr></span>&nbsp;&nbsp;
								<input type="text" size="40" id="subjectCustom" name="subjectCustom" value="<%=isCustom ? subject : "" %>" <%=isCustom ? "" : "disabled" %>>
							</td>
							<td>&nbsp;</td>
						</tr>
					</table>
					</td>
				</tr>
				<tr><td>&nbsp;</td></tr>
			</table>
		</td>
	</tr>
</table>
</div>
