<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisHelper"%>
<%@page import="xpolog.eye.meta.MetaData"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String REPORT_BUILDER = "REPORT_BUILDER";
  
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String doSaveStr = request.getParameter("doSave");  
  boolean doSave = doSaveStr != null && doSaveStr.equalsIgnoreCase("true");
  boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
  
  ErrorModel errmodel = new ErrorModel();
  
  AbstractReportBuilder abstractBuilder = (AbstractReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  if(!(abstractBuilder instanceof EnvironmentAnalysisReportBuilder)) {
  	if(isTestingBuid) {
  		errmodel.addError("Testing analysis is no longer valid, please click the 'Back to Testing Analyses' button and try again");
  	}else {
  		errmodel.addError("Environment analysis is no longer valid, please click the 'Back to Environment Analyses' button and try again");
  	}
  }
  
  EnvironmentAnalysisReportBuilder builder = null;
  boolean doGenerate = false;
  if(errmodel.getErrorCount() == 0) {
	  builder = (EnvironmentAnalysisReportBuilder)abstractBuilder;
	  if (builder == null){
	  	if(isTestingBuid) {
	  		errmodel.addError("No testing analysis in session. Please try to create testing analysis again.");
	  	}else {
	  		errmodel.addError("No environment analysis in session. Please try to create environment analysis again.");
	  	}
	  }
	  
	  String op = builder == null ? "" : builder.getOp();
	  doGenerate = op.equalsIgnoreCase("generate");
	  
	  String parentApplication =  request.getParameter("parentApplication");
	  if (parentApplication == null){
	  	parentApplication = "";
	  }
	  
	  AggBuilderHelper.updateBasicBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
	  RecordMask mask = new RecordMask();
	  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	  MaskColumn[] cols = {dateMask};
	  mask.setColumns(cols);
	  FilterCollection fc = null;
	  //create the date and number filter
	  builder.setTimeRule(null);
	  try {
	  	DateFilter dfilter = createDateFilter(request,response,mask);
	  
	  	if(dfilter != null) {
	  		fc = new FilterCollection();
	  		fc.setName(builder.getName()+"_fc");
		  	fc.setId(System.currentTimeMillis()+"_fc");
		  	fc.addFilter(dfilter);
		  	builder.setTimeRule(fc);
	  	}
	  }catch(Exception e) {	  
		  errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
	  }
	  
		AggBuilderHelper.updateSchedBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
		// applications
		String parentApps = request.getParameter("parentApplication");
		String [] appIds = null;
		if(parentApps != null && parentApps.length() >0){
			appIds = parentApps.split("#");
		}
		if(appIds == null || appIds.length == 0) {
			String newAppId = EnvironmentAnalysisHelper.getApplicationId(builder.getName());
			
			MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
			if(metaDataMgr.getMetaData(newAppId) == null) {
				MetaData newMetaData = new MetaData();
				newMetaData.setId(newAppId);
				newMetaData.setName(builder.getName());
				newMetaData.setSystemMetaData(true);
				newMetaData.setInternalId(String.valueOf(newAppId));
				
				metaDataMgr.saveMetaData(newMetaData, userContext);
			}
			
			appIds = new String[]{newAppId};
		}
		builder.setApplicationsIds(appIds);
		
		if(builder.getEnvironmentAnalysisLocationInfos() == null || builder.getEnvironmentAnalysisLocationInfos().size() == 0) {
			errmodel.addError("No logs directories were specified, please add at least one logs directory");
		}
		
	  //Environment analysis info
	  try {
	  	List environmentAnalysisProperties = builder.getEnvironmentAnalysisProperties();
	    if(environmentAnalysisProperties != null) {
	    	EnvironmentAnalysisProperty environmentAnalysisProperty = null;
	    	String propertyValue = null;
	    	for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
	    		environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
	    		propertyValue = request.getParameter(environmentAnalysisProperty.getKey());
	    		if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_SELECT) && propertyValue.equals("other")) {
	    			propertyValue = request.getParameter(environmentAnalysisProperty.getKey() + "Other");
	    		}
	    		if(propertyValue != null) {
	    			environmentAnalysisProperty.setValue(propertyValue);
	    		}
	    	}
	    }
	  }catch (Exception e){
	  	ErrorModel.log.error("Failed to set environment analysis properties",e);
	  }
	  
	  AggBuilderHelper.updateSecurityBuilderFromRequest(builder,request,errmodel,doGenerate);
  }
  
  //save reports issues
  if(errmodel.getErrorCount() != 0){
  	//errors
		String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmodel.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		String xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
		
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }else {
	  if (!doGenerate){
	  	request.getSession().setAttribute(REPORT_BUILDER,builder);
	    if (doSave){
	    	String saveAndGenerateStr = request.getParameter("saveAndGenerate");
	     	boolean saveAndGenerate = saveAndGenerateStr != null && saveAndGenerateStr.equals("true");
	     	if (saveAndGenerate){
	     		response.sendRedirect("aggReportSaveAction.jsp?isEnvironmentAnalysis=true&doGenerate=true");
	     	}else {
	  	    response.sendRedirect("aggReportSaveAction.jsp?isEnvironmentAnalysis=true");
	     	}
	    }
	  }else {
	  	Report rep = builder.buildReport();
	  	request.getSession().setAttribute("report", rep);
	  	response.sendRedirect(BASE_DIRECTORY + "reports/reportRuntimeGenerate.jsp");
	  }
  }
%>
