<%@ page language="java"%>

<%@ page import="java.io.File"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.meta.MetaDataHelper"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  AbstractReportBuilder builder = (AbstractReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  UserContext userContext = UserEnvironment.getUserContext(request);

  String isEnvironmentAnalysisStr = request.getParameter("isEnvironmentAnalysis");
  boolean isEnvironmentAnalysis = isEnvironmentAnalysisStr != null && isEnvironmentAnalysisStr.equals("true");
  
  if(builder == null){
  	String message = "Session is not valid any more. Please try again";
		//params
		String xml = GridModelActionsHelper.getResultXML(false, message);
		
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }else {
	  Report rep = null;
	  try {
	  ReportsManager reportMgr = ReportsManager.getInstance();
	  rep = builder.buildReport();
	  if (rep != null){
	  	if (builder.isNew()){
	    	reportMgr.addNewReport(rep.getTemplateId(),rep,userContext);
	    	if(isEnvironmentAnalysis) {
	    		// delete the environmentAnalysis properties file that was copied from the template
	    		File environmentAnalysisPropertiesFile = ((EnvironmentAnalysisReport)rep).getEnvironmentAnalysisPropertiesFile();
	    		if(environmentAnalysisPropertiesFile.exists()) {
	    			environmentAnalysisPropertiesFile.delete();
	    		}
	    	}
	  	}else {
	  		reportMgr.saveReport(rep);  		
	  	}
	  	
	  	if (builder.getApplicationsIds() != null){
	  		MetaDataHelper.addMetaData(builder.getApplicationsIds(),XpoLogObjectTypes.REPORT_TYPE,rep.getId(),userContext);
	  	}
	  }
	 
	  String name = "";
	  if(rep != null) {
		name = rep.getReportName();
	  }
		//audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "edit/save report", AuditConstants.REPORTS, "change report " + name);
	
	  }catch (Exception e){
	  	e.printStackTrace();
	  }
	  
	  String doGenerateStr = request.getParameter("doGenerate");
		boolean doGenerate = doGenerateStr != null && doGenerateStr.equals("true");
		if (rep != null){
			request.getSession().setAttribute("lastSelectedReport",rep.getId());
		}
		String paramsList = rep.getId() + "*;*" + isEnvironmentAnalysis + "*;*" + doGenerate;
		String xml = GridModelActionsHelper.getResultXML(true, "Report Saved", paramsList);
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }
%>