<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  ErrorModel errmodel = new ErrorModel();
  
  ReportsManager reportsMgr = ReportsManager.getInstance();
	String reportId = request.getParameter("reportId");
	if (reportId == null || reportId.trim().equals("")){
		errmodel.addError("No report id was supplied.");
	}
	
	Report report = null;
	if (reportId != null && reportId.length() > 0){
		report = reportsMgr.getReportById(reportId,true);
	}
	if (report == null){
		errmodel.addError("Error loading report");
	}
	
	 if (security == null){
	    errmodel.addError("This operation can't be done.");
	 }
	 
	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}


  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "";
  }

 
  
  ModuleMemberPermissions currPermission = report.getPermissions();	
  if (currPermission != null && !security.isEditable(currPermission)){
    response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp?okURL=reports/reportsDefinitionView.jsp");
    return;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }
    
  ModuleMemberPermissions permissions = reportsMgr.getTransactionDefaultPermissions();
  String forwardPage = BASE_DIRECTORY + "security/common/moduleMemberPermissionsIncluder.jsp";
 
  if (currPermission != null){  	
	  request.setAttribute("currPermission",currPermission);
  }
  if (permissions != null){
	  request.setAttribute("permissions",permissions);
  }
  
  String resetURL = "reports/perm/reportPermissions.jsp?reportId=" + reportId;  
  String actionURL = "reports/perm/reportPermissionsAction.jsp";
  String name = report == null ? "" : report.getReportName();
%>

<jsp:include page="<%=forwardPage%>">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="id" value="<%=reportId%>"/>
 <jsp:param name="type" value=""/>
 <jsp:param name="memberName" value="<%=name%>"/>
 <jsp:param name="actionURL" value="<%=actionURL%>"/>
 <jsp:param name="resetURL" value="<%=resetURL%>"/>
 <jsp:param name="forwardURL" value="<%=forwardURL%>"/>
 <jsp:param name="ignoreParent" value="true"/>
</jsp:include>
