<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  ErrorModel errmodel = new ErrorModel();
  
  ReportsManager reportsMgr = ReportsManager.getInstance();
  String reportId = request.getParameter("id");
  if (reportId == null || reportId.trim().equals("")){
		errmodel.addError("No report id was supplied.");
	}
	
	Report report = null;
	if (reportId != null && reportId.length() > 0){
		report = reportsMgr.getReportById(reportId,false);
	}
	if (report == null){
		errmodel.addError("Error loading report");
	}
	
  
 

  ModuleMemberPermissions permissions = null;
  permissions = new ModuleMemberPermissions();
  String [] editNames = request.getParameterValues("selectedEditMembersList");
  if (editNames != null && editNames.length > 0){
    permissions.setEditMembers(Arrays.asList(editNames));
  }

  String [] viewNames = request.getParameterValues("selectedViewMembersList");
  if (viewNames != null && viewNames.length > 0){
     permissions.setViewMembers(Arrays.asList(viewNames));
  }
  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

  report.setPermissions(permissions);
  try {
  	reportsMgr.saveReport(report);
  }catch (Exception e){
    e.printStackTrace();
  }
  String name = report.getReportName();
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit/save report", AuditConstants.REPORTS, "change permission to report " + name);

  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "reports/reportsDefinitionView.jsp";
  }
  response.sendRedirect(BASE_DIRECTORY+forwardURL);
%>

