<%@ page language="java"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%@ include file="../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();

  String reportId = request.getParameter("reportId");
  ReportsManager reportMgr = ReportsManager.getInstance();
  
  Report report = reportId == null || reportId.length() == 0 ? null : reportMgr.getReportById(reportId);
 
  if(report == null){
    errmodel.addError("No report was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
  	String message = "Session is not valid any more. Please try again";
		//params
		String xml = GridModelActionsHelper.getResultXML(false, message);
		
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }else {
  	boolean isEnvironmentAnalysis = false;
    if(report instanceof EnvironmentAnalysisReport) {
    	isEnvironmentAnalysis = true;
	  	//Environment analysis info
	    try {
	    	String prefix = request.getParameter("prefix");
	    	List environmentAnalysisProperties = ((EnvironmentAnalysisReport)report).getEnvironmentAnalysisProperties();
	      if(environmentAnalysisProperties != null) {
	      	EnvironmentAnalysisProperty environmentAnalysisProperty = null;
	      	String propertyValue = null;
	      	boolean needTimeFilter = false;
	      	for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
	      		environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
	      		if(environmentAnalysisProperty.isRequired()) {
	      			if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TIME)) {
	      				needTimeFilter = true;
	      			}else {
		      			propertyValue = request.getParameter(prefix + environmentAnalysisProperty.getKey());
			      		if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_SELECT) && propertyValue.equals("other")) {
			      			propertyValue = request.getParameter(prefix + environmentAnalysisProperty.getKey() + "Other");
			      		}
			      		if(propertyValue != null) {
			      			environmentAnalysisProperty.setValue(propertyValue);
			      		}
	      			}
	      		}
	      	}
	      	if(needTimeFilter) {
	      		try {
	      			RecordMask mask = new RecordMask();
	      			DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	      		  MaskColumn[] cols = {dateMask};
	      		  mask.setColumns(cols);
	      	  	DateFilter dfilter = createDateFilter(request,response,mask);
	      	  	if(dfilter != null) {
	      	  		FilterCollection fc = new FilterCollection();
	      	  		fc.setName(report.getReportName()+"_fc_generation");
	      		  	fc.setId(System.currentTimeMillis()+"_fc");
	      		  	fc.addFilter(dfilter);
	      		  	report.setTimeRule(fc);
	      	  	}else {
	      	  		report.setTimeRule(null);
	      	  	}
	      	  }catch(Exception e) {	  
	      		  errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
	      	  }
	      	}
	      	String needsUserInputStr = request.getParameter(prefix + "needsUserInput");
	      	boolean needsUserInput = needsUserInputStr != null && needsUserInputStr.equals("true");
	      	if(needsUserInput != report.isNeedsUserInput()) {
	      		Report tmp = reportMgr.getReportById(report.getId());
	      		tmp.setNeedsUserInput(needsUserInput);
	      		reportMgr.saveReport(tmp);
	      	}
	      	session.setAttribute("report", report);
	      }
	    }catch (Exception e){
	    	ErrorModel.log.error("Failed to set environment analysis properties",e);
	    }
	  }
    
    if(errmodel.getErrorCount() > 0) {
    	//errors
  		String[] errors = errmodel.getErrors();
  		StringBuffer sb = new StringBuffer();
  		for (int i=0; i<errors.length; i++){
  			if (sb.length() > 0){
  				sb.append("*;*");
  			}
  			sb.append(errors[i]);
  		}
  		String message = sb.toString();
  		//params
  		String[] params = errmodel.getErrorParams();
  		sb = new StringBuffer();
  		for (int i=0; i<params.length; i++){
  			if (sb.length() > 0){
  				sb.append("*;*");
  			}
  			sb.append(params[i]);
  		}
  		String paramsList = sb.toString();
  		String xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
  		
  		response.setContentType("text/xml");
  		response.setHeader("Pragma-Control", "no-cache");
  		response.setHeader("Cache-Control", "no-cache");
  		response.setHeader("Expires", "0");
  		out.write(xml);
  		out.flush();
    }else {
    	String paramsList = report.getId() + "*;*" + isEnvironmentAnalysis;
  		String xml = GridModelActionsHelper.getResultXML(true, "Report Saved", paramsList);
  		response.setContentType("text/xml");
  		response.setHeader("Pragma-Control", "no-cache");
  		response.setHeader("Cache-Control", "no-cache");
  		response.setHeader("Expires", "0");
  		out.write(xml);
  		out.flush();
    }
  }
%>


