<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@page import="xpolog.eye.automation.tasks.TaskData"%>
<%@page import="xpolog.eye.automation.TasksExecutionManager"%>
<%@page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
  
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  String reportId = request.getParameter("reportId");
  String executableStr = request.getParameter("executable");
	final boolean executable = executableStr != null && executableStr.equals("true");
	ReportsManager reportMgr = ReportsManager.getInstance();
  
  final UserContext userContext = UserEnvironment.getUserContext(request);
  
  final Report report = reportId == null || reportId.length() == 0? (Report) request.getSession().getAttribute("report") : reportMgr.getReportById(reportId);
  if(report == null){
    errmodel.addError("No report was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../common/errorpage.jsp");
    return;
  }
  reportId = report.getId();
  //put the report on session
  request.getSession().setAttribute("report",report);
  
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  
  final ReportGenerator reportGenerator = report.getGenerator();
  final xpolog.eye.common.JobStatus jobStatus = reportGenerator.createJobStatus();
  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, jobStatus);
  
  String name = report.getReportName();
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "execute report", AuditConstants.REPORTS, "execute report " + name);
  
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "reports/reportView.jsp?reportId=" + reportId + "&executable=" + executable) {
      public void run(HttpServletRequest request){
        try{
        	Thread.sleep(500);
        	ReportRuntime reportRuntime = null;
    			try {
    				reportGenerator.addProcessInfo(userContext, jobStatus, "User report generation");
    				reportRuntime = reportGenerator.generateReport(null,jobStatus);
    			}finally{
    				reportGenerator.removeProcessInfo();
    			}		
         
         if (reportRuntime != null){
           reportRuntime.saveData();
					 ReportVerifier rv = report.getReportVerifier(reportRuntime);
					 if (rv != null){
				     VerifierResult vr = rv.execute(null,true);
				   }else if (report.getTasks().size() > 0){
							List tasks = report.getTasks();
							for (int i = 0; i < tasks.size(); i++) {
								XpoTask task = (XpoTask) tasks.get(i);
								TaskData data = ReportsManager.getInstance().createTaskData(report,reportRuntime);
								if (data != null){
									task.setTaskData(data);
								}
								TasksExecutionManager.getInstance().addTaskToExecution(task);
							}
						}
					 String resultUrl = report.getResultUrl();
					 if (resultUrl != null){
						 resultUrl = resultUrl.replaceAll("\\[REPORT_ID\\]",report.getId());
						 resultUrl = resultUrl.replaceAll("\\[REPORT_RUNTIME_ID\\]",reportRuntime.getId());
						 resultUrl += "&refreshMenus=true";
						 resultUrl += "&executable=" + executable;
						 setRedirectUrl(BASE_DIRECTORY + resultUrl);
					 }
         }else {
         	ReportsManager reportMgr = ReportsManager.getInstance();
         	reportMgr.removeReportRuntime(report.getId(),reportGenerator.getId());
         	if (report instanceof EnvironmentAnalysisReport){
         		setRedirectUrl(BASE_DIRECTORY + "reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true");
         	}
         }
        }catch(Throwable e){
          e.printStackTrace();
          errmodel.addError("Building log problem,please check patterns and path again.");
    			errmodel.addError(e.getMessage());
          createErrorRedirect(request,BASE_DIRECTORY);
        }
      }
   };
   env.setProgressRunner(runner);
%>


<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Generating Report"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="reports/presentStatusStopAction.jsp"/>
</jsp:include>