<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%!
	static final String BASE_DIRECTORY = "../";
	String format = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
        SimpleDateFormat dateFormat = new SimpleDateFormat(format);
%>
<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
    return;
  }
  UserSecurity user = manager.getUserSecurity(request);
	String reportId = request.getParameter("reportId");
	String viewerId = request.getParameter("viewerId");
	if(viewerId == null) {
		viewerId = "";
	}
	ReportsManager reportMgr = ReportsManager.getInstance();
	Report report = reportMgr.getReportById(reportId,true);
	request.getSession().setAttribute("lastSelectedReport",reportId);
	
	String goLastStr = request.getParameter("goLast");
	boolean goLast = goLastStr != null && goLastStr.equals("true"); 
	
	boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
	if (goLast || isSiteDemo){
		ReportRuntime runtime = report.getLastReportRuntime(true);
		if (runtime != null){
			String viewUrl = report.getResultUrl();
			if (viewUrl != null){
		  		viewUrl = viewUrl.replaceAll("\\[REPORT_ID\\]",report.getId());
		  		viewUrl = viewUrl.replaceAll("\\[REPORT_RUNTIME_ID\\]",runtime.getId());
		  		viewUrl += "&viewerId=" + viewerId;
			}
			response.sendRedirect(BASE_DIRECTORY + viewUrl);
			return;
		}
	}
	
	String executableStr = request.getParameter("executable");
	boolean executable = executableStr != null && executableStr.equals("true");
	
	boolean isEnvironmentAnalysis = report.getReportType().equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE);
	boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
	
	boolean isEdit = manager.isHavePermission(user,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
  boolean isExecute = executable && manager.isHavePermission(user,ActionsPermissionConstants.ToolsPermissions.EXECUTE_REPORTS_PERMISSION);
  String initXML = "reports/reportsRuntimeViewXML.jsp?reportId=" + (report == null ? "" : report.getId()) + "&isEnvironmentAnalysis=" + isEnvironmentAnalysis;
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isEdit;
if(showMenu) {
	String menuIds = "viewResult,deleteResult";
	String menuTexts = "View,Delete";
	String menuHrefs = "javascript:viewResult0();,javascript:removeResult0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
  function init(){
	  initTables();
  }

  function doGenerate(){
  	path = "reportRuntimeAction.jsp?reportId=<%=report.getId()%>&executable=true";
  	document.location = path;
  }
  
  function doDelete(){  
    var runtimeId = getFirstSelectedRow(mygrid);
    if (runtimeId == "") {
      return;
    }
    doDelete1(runtimeId);
  }
  
  function doDelete1(runtimeId){  
    var reportId = "<%=report.getId()%>";
    var name = mygrid.cells(runtimeId,0).getValue();
    var row = runtimeId; 
    var msgWriter = new messageWriter("mygridMessage","Reoprt Runtime Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
   	msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" + reportId + "','" + runtimeId +  "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')"); 
    <%if(isEnvironmentAnalysis) {%>
    	<%if(isTestingBuid) { %>
    	msgWriter.showMessage("<nobr>Are you sure you want to remove testing analysis runtime from </nobr>" + name + "?");
    	<%}else {%>
	    msgWriter.showMessage("<nobr>Are you sure you want to remove environment analysis runtime from </nobr>" + name + "?");
	    <%} %>
    <%}else {%>
  	  msgWriter.showMessage("<nobr>Are you sure you want to remove report runtime from </nobr>" + name + "?");
    <%} %> 
  }
  
  function doDelete0(row,reportId,runtimeId){  	
  	deleteGridRow(mygrid,row,baseDirectory + "reports/removeReportRuntimeAction.jsp?reportId=" + reportId + "&reportRuntimeId=" + runtimeId + "&timestamp=" + new Date().getTime());
  }
  
  function viewResult(){
    var runtimeId = getFirstSelectedRow(mygrid);
    if (runtimeId == "") {
     return;
    }
    viewResult1(runtimeId);
  }
  
  function viewResult1(runtimeId){
    var viewUrl = mygrid.getUserData(runtimeId,"viewurl"); 
		if (!viewUrl || viewUrl == ""){
		  return;
		}
		if(viewUrl.indexOf("?") == -1) {
			viewUrl += "?";
		}
		viewUrl += "&executable=<%=executable %>";
  	path = "<%=BASE_DIRECTORY%>" + viewUrl;
  	document.location = path;
  }
	
	function handleMenuItems(){
		<% if (isEdit){%>
 		    	aMenu.menu.showButtons("viewResult,deleteResult"); 
 			<%
 		}else {%>
 			  aMenu.menu.hideBar();
 		<%}%> 			    			  
  }
  
  function viewResult0(){
    if (contextRowId && contextRowId != ""){
      viewResult1(contextRowId);
    }
  }
  
  function removeResult0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
</script>
</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onload="<%=onLoadFunctions%>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
        <tr height="10">
        	<td>
		        <% 
		        String title = "Results of Report " + report.getReportName();
		        if(isEnvironmentAnalysis) {
		        	if(isTestingBuid) {
		        		title = "Results of Testing Analysis " + report.getReportName();
		        	}else {
		        		title = "Results of Environment Analysis " + report.getReportName();
		        	}
		        }
		        %>
	       		<jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="<%=title%>" />
						</jsp:include>
					</td>
        </tr>
        <tr>                
          <td valign="top">
          	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                                 
            	<tr>
             	 	<td>
                  <%
                                    
                  String addName = isExecute ? "Generate" : "";
                  String addLink = isExecute ? "javascript:doGenerate()" : "";
                  
                  String tableNames = isEdit ? "View#Delete" : "View";
                  String tableActions = isEdit ? "javascript:viewResult()#javascript:doDelete()" : "javascript:doEdit()";
                  String ids = isEdit ? "View#Delete" : "View";
                  String selectTypes = isEdit ? "2#2" : "2";
                  
                  String menu = showMenu ? "aMenu" : "";
              
              		%>
                    
                  <jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="initXML" value="<%=initXML%>" />
										<jsp:param name="recordsText" value="Results" />
										<jsp:param name="menu" value="<%=menu%>"/>
										<jsp:param name="newActionNames" value="<%=addName%>" />
										<jsp:param name="newActions" value="<%=addLink%>" />
										<jsp:param name="tableActionNames" value="<%=tableNames%>" />
										<jsp:param name="tableActions" value="<%=tableActions%>" />
										<jsp:param name="tableActionIds" value="<%=ids%>" />
										<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
										<jsp:param name="style" value="main" />
										<jsp:param name="doubleClickAction" value="viewResult" />
									</jsp:include>
                </td>
	            </tr>
            </table>
          </td>
        </tr>
    	</table>
    </td>
  </tr>
  <tr height="20px">
		<td style="padding-top:20">
		<%
		String actionsNames = "Back to Reports";
		String actions = "reports/reportsDefinitionView.jsp";
		if(isEnvironmentAnalysis) {
			if(isTestingBuid) {
				actionsNames = "Back to Testing Analyses";
			}else {
				actionsNames = "Back to Environment Analyses";
			}
			actions += "?isEnvironmentAnalysis=" + isEnvironmentAnalysis;
		}
		%>
		<jsp:include page="../common/buttonsFooter.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="align" value="right" />
			<jsp:param name="actionNames" value="<%=actionsNames %>" />
			<jsp:param name="actions" value="<%=actions %>" />
		</jsp:include>
		</td>
	</tr>
</table>
</body>

</html>