function messageWriter(divId,msgTitle,base_directory){
  this.messageDivId = divId;
  this.title = msgTitle;
  this.actionsNamesArr = new Array();
  this.actionsLinksArr = new Array();
  this.chboxNamesArr = new Array();
  this.chboxDefaultsArr = new Array();
  this.chboxIdsArr = new Array();
  this.functions = new Array();
  this.x = -1;
  this.y = -1;
  this.yParent = null;
  this.width = 350;
  this.height = 120;
  this.align="center";
  this.msgClass = "POPUP_MESSAGE"
  this.base_directory = base_directory;
  this.fadeStep = 0;
  this.fadeSteps = 20;
  this.fadeDelay = 100;
  this.fadeOutDelay = 1000;
  return this;
};

messageWriter.prototype.addAction=function(actionName,actionLink){
  this.actionsNamesArr[this.actionsNamesArr.length] = actionName;
  this.actionsLinksArr[this.actionsLinksArr.length] = actionLink;
};

messageWriter.prototype.addFunction=function(func){
  this.functions[this.functions.length] = func;
};

messageWriter.prototype.addChbox=function(chboxName,chboxId,checked){
  this.chboxNamesArr[this.chboxNamesArr.length] = chboxName;
  this.chboxIdsArr[this.chboxIdsArr.length] = chboxId;
  this.chboxDefaultsArr[this.chboxDefaultsArr.length] = checked;
};

messageWriter.prototype.setTitle=function(msgTitle){
  this.title = msgTitle;
};

messageWriter.prototype.setYParent=function(parent,offset){
  this.yParent = parent;
  this.yOffset = offset
};

messageWriter.prototype.setPosition=function(x,y){
  this.x = x;
  this.y = y;
};

messageWriter.prototype.setSize=function(w,h){
  this.width = w;
  this.height = h;
};

messageWriter.prototype.setStyle=function(align){
  this.align = align;
};

messageWriter.prototype.setMsgClass=function(msgClass){
  this.msgClass = msgClass;
};

messageWriter.prototype.showMessage=function(message){
  var div = document.getElementById(this.messageDivId);
  if (!div){
  	div = document.createElement("DIV");
  	div.id = this.messageDivId;
  	div.style.position = "absolute";
  	div.style.visibility = "hidden";
  	div.style.height=this.height;
  	div.style.width=this.width;
  	div.style.zIndex = 1000;
  	document.body.appendChild(div);
  }else {
    if (div.style.visibility == ""){
      hideLayer(this.messageDivId);
    }
  	div.style.height=this.height;
  	div.style.width=this.width;
  }
 
  var innerDiv = this.createInnerMessage(message);
	div.innerHTML = innerDiv;	
	var x  = this.x;
	var y = this.y;
	if (y == -1 && this.yParent && this.yParent != null){
		y = findPosY(this.yParent) + this.yOffset;
	}
	showLayerInMiddle(this.messageDivId,x,y);
	
};

messageWriter.prototype.createInnerMessage=function(message){
   var innerDiv = '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white">'
											+ '<tr height="10" ><td align="center"  style="padding:2px;border:solid 2px #737373" >'
											+ '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #AEAEAF">'
											+ '<tr height="25" ><td align="center"  style="border-bottom:solid 2px #AEAEAF">'
											+ '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" background="' + this.base_directory + 'images/common/messageHeaderBg.gif">'
											+ '<tr><td align="center">'																					
											+ '<span class="PROGRESSTEXT" style="font-family:Verdana;font-weight:normal;font-size:12px;color:black" >' + this.title + '</span>'
									    + '</td></tr></table>'
									    + '</td></tr>'
		 						    	+ '<tr height="*" ><td class="' + this.msgClass + '" align="' + this.align +  '" style="padding-left:10;padding-right:10;padding-top:5;padding-bottom:5;">' + message + '</td></tr>';
if (this.chboxNamesArr && this.chboxNamesArr.length > 0){
 for (var i = 0;  i < this.chboxNamesArr.length;i++){
		innerDiv = innerDiv + this.getChkbox(this.chboxNamesArr[i],this.chboxIdsArr[i],this.chboxDefaultsArr[i]);
 }
}
											innerDiv = innerDiv + '<tr>'
											+ '<tr height="5">'
											+	'<td align="center" style="padding:5">'
											+ '<table border="0" width="50" cellspacing="0" height="100%" cellpadding="0">'
 											+ '<tr>'
 for (var i = 0;  i < this.actionsNamesArr.length;i++){
		//innerDiv = innerDiv +	'<a class="PROGRESSLINK" href="' + this.actionsLinksArr[i] + '">' + this.actionsNamesArr[i] + '</a>&nbsp;'
		innerDiv = innerDiv + this.getButton(this.actionsNamesArr[i],this.actionsNamesArr[i],this.actionsLinksArr[i],"100");
 }
 innerDiv = innerDiv + '</tr></table>';			  							
										 +	'</td></tr>'
		 							 	 + '</table>';	
		 							 	 +	'</td></tr>'
		 							 	 + '</table>';	
		 							 	 
	return innerDiv;		 							 	 
		 							
}

messageWriter.prototype.getButton=function(id,name,link,width){
	var innerDiv = '<td style="padding-left:5;padding-right:5" width="' + width + '">'
					+ '<table border="0" width="100%" cellspacing="0" height="23" cellpadding="0">'
					+ '<tr>'					
					+ '<td width="3">'
					+ '<table border="0" width="3" cellspacing="0" height="23" cellpadding="0" background="' + this.base_directory + 'images/common/ctrlLeftBtn.gif">'
					+ '<tr>'
					+ '<td>'
					+ '</td>'
					+ '</tr>'
					+ '</table>'
					+ '</td>'
					+ '<td width="*">'
					+ '<table border="0" width="100%" cellspacing="0" height="23" cellpadding="0" background="' + this.base_directory + 'images/common/ctrlMiddleBtn.gif">'
					+ '<tr>'
					+ '<td style="padding-left:5;padding-right:5" >'
					+ '<a ' + (id != "" ? 'id=' + id : "") + ' href="' + link + '" class="BUTTON"><nobr>' + name + '</nobr></a>'
					+ '</td>'
					+ '</tr>'
					+ '</table>'
					+ '</td>'
					+ '<td width="3">'
					+ '<table border="0" width="3" cellspacing="0" height="23" cellpadding="0" background="' + this.base_directory + 'images/common/ctrlRightBtn.gif">'
					+ '<tr>'
					+ '<td>'
					+ '</td>'
					+ '</tr>'
					+ '</table>'
					+ '</td>'
					+ '</tr>'
					+ '</table>'
					+ '</td>'
		return innerDiv;			
};

messageWriter.prototype.getChkbox=function(name,id,chckd){
	var innerDiv = '<tr>'
					+ '<td style="padding-left:5;padding-right:5" >'
					+ '<span class="'+this.msgClass+'"><input type="checkbox" ' + (id != "" ? 'id="' + id + '"' : '') + (chckd != "" && chckd == "true" ? ' checked' : '') + ' value="true"><nobr>' + name + '</nobr></span>'
					+ '</td>'
					+ '</tr>'
		return innerDiv;			
};

messageWriter.prototype.showRSS=function(rssXML){
  var channelXMLArr = rssXML.getElementsByTagName('channel');
  var channelXML;
  if (channelXMLArr && channelXMLArr.length > 0){
    channelXML = channelXMLArr[0];
  }  
   var div = document.getElementById(this.messageDivId);
  if (!div){
  	div = document.createElement("DIV");
  	div.id = this.messageDivId;
  	div.style.position = "absolute";
  	div.style.visibility = "hidden";
  	div.style.height=this.height;
  	div.style.width=this.width;
  	div.style.zIndex = 1000;
  	document.body.appendChild(div);
  }else {
    if (div.style.visibility == ""){
      hideLayer(this.messageDivId);
    }
  	div.style.height=this.height;
  	div.style.width=this.width;
  }
 
  var innerDiv = this.buildRSSItems(channelXML);
	div.innerHTML = innerDiv;	
	var x  = this.x;
	var y = this.y;
	if (y == -1 && this.yParent && this.yParent != null){
		y = findPosY(this.yParent) + this.yOffset;
	}
	mWriter = this;
	this.fadeElem = document.getElementById(this.messageDivId);
	this.fadeStep = 0;
	fadeIn(this.fadeStep,this.fadeSteps,this.messageDivId,this.fadeDelay,this.fadeOutDelay);
	showLayerInMiddle(this.messageDivId,x,y);

}

messageWriter.prototype.buildRSSItems=function(rssChannel){
  var items;
  if (rssChannel){
    items = rssChannel.getElementsByTagName('item');
  }  
  var message = "No items were found";
  if (items && items.length > 0){
    message = '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">';
    for (var i = 0; i < items.length;i++){
      var desc = "";
      var item = items[i];
      var link = "";
      if (item.getElementsByTagName('link')[0] && item.getElementsByTagName('link')[0].firstChild){
			         link = item.getElementsByTagName('link')[0].firstChild.nodeValue;
			       }
       if (item.getElementsByTagName('description')[0] && item.getElementsByTagName('description')[0].firstChild){
			         desc = item.getElementsByTagName('description')[0].firstChild.nodeValue;
			       }
      message += '<tr height="10"><td>';
      message += '<a href="' + link + '" class="BUTTON_SMALLLINK" target="main">' + desc + '</a>';
      message += '</td></tr>';
    }
    message += '</table>';
  }
  
  var innerDiv = '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white">'
											+ '<tr height="10" ><td align="center"  style="padding:2px;border:solid 2px #737373" >'
											+ '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #AEAEAF">';
											if (this.title && this.title != ""){
											  innerDiv += '<tr height="25" ><td align="center"  style="border-bottom:solid 2px #AEAEAF">'
											  + '<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" background="' + this.base_directory + 'images/common/messageHeaderBg.gif">'
											  + '<tr><td align="center">'																					
											  + '<span class="PROGRESSTEXT" style="font-family:Verdana;font-weight:normal;font-size:12px;color:black" >' + this.title + '</span>'
									      + '</td></tr></table>'
									      + '</td></tr>';
									     }
		 						    	innerDiv += '<tr height="*" ><td class="' + this.msgClass + '" align="' + this.align +  '" style="padding-left:10;padding-right:10;padding-top:5;padding-bottom:5;">' + message + '</td></tr>';
										
 innerDiv = innerDiv + '</table>';	
		 							 	 +	'</td></tr>'
		 							 	 + '</table>';	
		 							 	 
	return innerDiv;		 	

}

fadeIn=function(fadeStep,fadeSteps,elemId,fadeDelay,fadeOutDelay) { 
    if(fadeStep > fadeSteps){ 
        if (fadeOutDelay > 0){
          window.setTimeout("fadeOut(0," + fadeSteps + ",'" + elemId + "'," + fadeDelay + ")", fadeOutDelay);
        }             
        return; 
    } 
    setOpacity(document.getElementById(elemId),(fadeStep/fadeSteps)); 
    this.writerName = "msgWriter";
    window.setTimeout("fadeIn(" + (fadeStep + 1)+ "," + fadeSteps + ",'" + elemId + "'," + fadeDelay + "," + fadeOutDelay + ")", fadeDelay); 
} 

fadeOut=function(fadeStep,fadeSteps,elemId,fadeDelay) {    
    if(fadeStep >fadeSteps){ 
        hideLayer(elemId);
        return; 
    } 
    setOpacity(document.getElementById(elemId), ((fadeSteps - fadeStep)/fadeSteps)); 
    window.setTimeout("fadeOut(" + (fadeStep + 1)+ "," + fadeSteps + ",'" + elemId + "'," + fadeDelay + ")", fadeDelay); 
} 



function setOpacity( el, opacity){ 
    if(el.style.opacity != undefined){ 
        el.style.opacity = opacity; 
    }else if( el.style.MozOpacity != undefined){ 
        el.style.MozOpacity = opacity; 
    }else if ( el.style.filter != undefined){ 
        el.style.filter="alpha(opacity=" + Math.round(opacity * 100) + ")"; 
    } 
} 


buildRSSMessage=function(rssXML){
var channelXMLArr = rssXML.getElementsByTagName('channel');
  var channelXML;
  if (channelXMLArr && channelXMLArr.length > 0){
    channelXML = channelXMLArr[0];
  } 
  var message =  buildRSSItemsMessage(channelXML);
  return message;
}

buildRSSItemsMessage=function(rssChannel){
  var items;
  if (rssChannel){
    items = rssChannel.getElementsByTagName('item');
  }  
  var message = "";
  if (items && items.length > 0){
    message = '<table border="0" width="250" cellspacing="0" height="100%" cellpadding="0" >';
    for (var i = 0; i < items.length;i++){
      var desc = "";
      var item = items[i];
      var link = "";
      if (item.getElementsByTagName('link')[0] && item.getElementsByTagName('link')[0].firstChild){
			         link = item.getElementsByTagName('link')[0].firstChild.nodeValue;
			         link = link.replace(/^\s+|\s+$/g, '') ;
			       }
       if (item.getElementsByTagName('description')[0] && item.getElementsByTagName('description')[0].firstChild){
			         desc = item.getElementsByTagName('description')[0].firstChild.nodeValue;
			         desc = desc.replace(/^\s+|\s+$/g, '') ;
			       }
			       
      message += '<tr height="10">';
       if (item.getElementsByTagName('image')[0]){
         var imageElem = item.getElementsByTagName('image')[0];
         var imageSrc = imageElem.getElementsByTagName('url')[0].firstChild.nodeValue;
         if (imageSrc){
           imageSrc = imageSrc.replace(/^\s+|\s+$/g, '') ;
         }
         var imageLink = "";
         if (imageElem.getElementsByTagName('link')[0]){
           imageLink = imageElem.getElementsByTagName('link')[0].firstChild.nodeValue;
           imageLink = imageLink.replace(/^\s+|\s+$/g, '') ;
         }
         message += '<td width="30">';         
         message += '<img src="' + imageSrc + '">';         
          message += '</td>';
         
       }
       
      message += '<td><a href="' + link + '" class="BALLOON_LINK">' + desc + '</a>';
      message += '</td></tr>';
    }
    message += '</table>';
  }
  return message;
}


