

function Tree(name){
  this.name = name;
  this.nodes = new Array();
  this.root = null;
  this.nodeStyle = "TREE_NODE_CLASS";
  this.nodeLeafStyle = "TREE_NODE_LEAF_CLASS";
  this.nodeImageStyle = "TREE_NODE_IMAGE_CLASS";
  this.linkStyle = "LINK";
  this.onSelectMarkChilds = true;
  this.onSelectMarkParents = false;
  this.onSelectClearChilds = false;
  this.onSelectClearParents = false;
}

function Node(tree,index,chkKey,parent,id,name,desc,text,selected,expand,disable,link){
  this.tree = tree;
  this.index = index;
  this.parent = parent;
  this.id = id;
  this.name = name;
  this.childs = new Array();
  this.desc = desc;
  this.text = text;
  this.selected = selected;
  this.expand = expand;
  this.chkKey = chkKey;
  this.indexInParent = -1;
  this.disable = disable;
  this.link = link;
  if (parent){
    this.indexInParent = parent.childs.length;
    parent.childs[parent.childs.length] = this;
  }
}

function isLeaf(){
  return this.childs.length == 0;
}

function createTree(name){
  var tree = new Tree(name);
  
  tree.root = tree.createNode(null,"","","","","",false,true);
  return tree;
}

function addNode(parent,chkKey,id,name,desc,text,selected,expand,disable,link){
  var node = this.createNode(parent,chkKey,id,name,desc,text,selected,expand,disable,link);
  this.nodes[this.nodes.length] = node;
  return node;
}

function createNode(parent,chkKey,id,name,desc,text,selected,expand,disable,link){
  var node = new Node(this,this.nodes.length,chkKey,parent,id,name,desc,text,selected,expand,disable,link);
  return node;
}


function writeTree(){
  for(var i = 0; i < this.root.childs.length;i++){
    this.writeNode(this.root.childs[i]);
  }
}

function writeNode(node){
  var divStyle = node.parent.expand ? "" : " style=\"display:none\"";
  document.writeln("<DIV class=" + (node.isLeaf() ? node.tree.nodeLeafStyle : node.tree.nodeStyle) +  " id=\"DivNode_" + this.name + "_" + node.index + "\"" + divStyle +  ">");
  this.writeNodeData(node);
  for(var i = 0; i < node.childs.length;i++){
    this.writeNode(node.childs[i]);
  }
  document.writeln("</DIV>");
}

function writeNodeData(node){ 
  if (!node.isLeaf()){
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + "," + node.tree.name + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
  }
  if (!node.ignoreSelection && (node.isLeaf() || showParentsSelection)){
    document.writeln("<input type=\""  + nodeSelectedType + "\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + this.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + "," + node.tree.name + ")\"" + (node.disable ? " disabled" : "") + ">");
  }
  if (node.link && node.link != ""){
  	document.writeln("<a href=\"" + node.link + "\" class=\"LINK\">");
  }
  document.writeln("&nbsp;" + node.name);
  if (node.link && node.link != ""){
  	document.writeln("</a>");
  }
  if (node.desc && node.desc != ""){
     document.writeln("&nbsp;(" + node.desc + ")");
  }
  if (node.text && node.text != ""){
     document.writeln("&nbsp;" + node.text);
  }  
}

function markTreeNode(node){
  
	nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	if (node.selected == nodeCbx.checked) return;
	
	var selected = nodeCbx.checked;	
  if (this.onSelectMarkChilds){
    markNodeChilds(node,selected);  
  }else {
    node.selected = selected;
  }
  
  if (this.onSelectMarkParents){
    markNodeParentsToRoot(node.parent,selected);  
  }
  if (this.onSelectClearChilds){
    clearNodeChilds(node); 
  }
  if (this.onSelectClearParents){
    clearNodeParentsToRoot(node.parent); 
  }
}


function markNodeChilds(node,selected){	
  nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	if (node.selected == selected) return;
	
	nodeCbx.checked = selected;
	node.selected = selected;
	for (var i = 0; i < node.childs.length; i++){
	  markNodeChilds(node.childs[i],selected);
	}
}
    
function clearNodeChilds(node){	
  nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	for (var i = 0; i < node.childs.length; i++){
	  clearNodeChilds0(node.childs[i]);
	}
}
    
function clearNodeChilds0(node){	
  nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	
	nodeCbx.checked = false;
	node.selected = false;
	for (var i = 0; i < node.childs.length; i++){
	  clearNodeChilds0(node.childs[i]);
	}
}
    
function markNodeParentsToRoot(node,selected){
  if (!node || node == null){
    return;
  }
	nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	if (node.selected == selected) return;
	
	nodeCbx.checked = selected;
	node.selected = selected;
	markNodeParentsToRoot(node.parent,selected);
	
}

function clearNodeParentsToRoot(node){
  if (!node || node == null){
    return;
  }
	nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	
	nodeCbx.checked = false;
	node.selected = false;
	clearNodeParentsToRoot(node.parent);
	
}
 
function markNode(index,t){
  if (t){
    t.markTreeNode(t.nodes[index]);
  }else if (tree){
    tree.markTreeNode(tree.nodes[index]);
  }
}

function selectTreeNode(node){	
	var expand = !node.expand;	
	node.expand = expand;
	var expImage = document.getElementById("ExpandImage_" + node.tree.name + "_" + node.index);
	if (expImage){
	  expImage.src = baseDirectory + (expand ? collapseImage : expandImage);
	}
	for (var i = 0; i < node.childs.length; i++){
	  var childDiv = document.getElementById("DivNode_" + node.childs[i].tree.name + "_" + node.childs[i].index);
	  if (childDiv){
	    if (expand){
	      childDiv.style.display = "";
	    }else {
	      childDiv.style.display = "none";
	    }
	  }
	}
	
}

function selectNode(index,t){
  if (t){
    t.selectTreeNode(t.nodes[index]);
  }else if (tree){
  	tree.selectTreeNode(tree.nodes[index]);
  }
}



Node.prototype.isLeaf = isLeaf;
Tree.prototype.addNode = addNode;
Tree.prototype.createNode = createNode;
Tree.prototype.writeTree = writeTree;
Tree.prototype.writeNode = writeNode;
Tree.prototype.writeNodeData = writeNodeData;
Tree.prototype.markTreeNode = markTreeNode;
Tree.prototype.selectTreeNode = selectTreeNode;

var tree = createTree("tree");
var baseDirectory = "";
var expandImage = "images/tree/plusnode.gif";
var collapseImage = "images/tree/minusnode.gif";
var showParentsSelection = true;
var nodeSelectedType = "checkbox";