(function($) {
	$.extend({
		tablesorterPager: new function() {
			
			function updatePageDisplay(config, selector, table, pageNumber) {
				$(".simplePagerNav").html(getPageDisplay(config));
				registerEvents(selector, table, pageNumber);
			}
			
			function updateSelectedPage(selector, pageNumber) {
				//remove current current (!) page
				selector.parent("li").parent("ul").find("li.currentPage").removeClass("currentPage");
				//Add current page highlighting
				selector.parent("li").parent("ul").find("a[rel='"+pageNumber+"']").parent("li").addClass("currentPage");
			}
			
			function registerEvents(selector, table, pageNumber) {
				selector.parent().find(".simplePagerNav a").click(function() {
					//grab the REL attribute 
					var clickedLink = $(this).attr("rel");
					var pageNumber = parseInt(clickedLink);
					
					moveToSpecificPage(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssFirst).click(function() {
					moveToFirstPage(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssNext).click(function() {
					moveToNextPage(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssNextGroup).click(function() {
					moveToNextPageGroup(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssPrev).click(function() {
					moveToPrevPage(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssPrevGroup).click(function() {
					moveToPrevPageGroup(table, $(this), pageNumber);
					return false;
				});
				selector.parent().find(config.cssLast).click(function() {
					moveToLastPage(table, $(this), pageNumber);
					return false;
				});
				/*selector.parent().find(config.cssPageSize).change(function() {
					setPageSize(table,parseInt($(this).val()));
					
					//remove current current (!) page
					$(this).parent("li").parent("ul").find("li.currentPage").removeClass("currentPage");
					//Add current page highlighting
					$(this).parent("li").parent("ul").find("a[rel='"+table.config.page+"']").parent("li").addClass("currentPage");
					
					return false;
				});*/
			}
			
			function getPageDisplay(config) {
				var pageNav = "";
				if(config.totalPages > 10) {
					//pageNav += "<li><img src=\"../css/jquery/tablesorter/pager/images/first.gif\" class=\"first\" height=\"21px\"/></li>";
					if(config.pageGroup > 0) {
						pageNav += "<li class=\"nextGroup\"><img src=\"../css/jquery/tablesorter/pager/images/prev.gif\" class=\"prevGroup\" height=\"21px\"/></li>";
					}else {
						pageNav += "<li><img src=\"../css/jquery/tablesorter/pager/images/prevDisabled.gif\" height=\"21px\"/></li>";
					}
				}
				if(config.totalPages > 1) {
					var minPage = config.page - (config.page % config.maxPagingLinks);
					var maxPage = Math.min(minPage + config.maxPagingLinks, config.totalPages);
					if(config.totalRows < (maxPage - minPage) * config.size) {
						maxPage = minPage + (config.totalRows / config.size);
					}
					
					for (i=minPage;i<maxPage;i++){
						if (i==config.page) {
							pageNav += "<li class='currentPage simplePageNav"+i+"'><a rel='"+i+"' href='#'>"+(i+1)+"</a></li>";	
						}
						else {
							pageNav += "<li class='simplePageNav"+i+"'><a rel='"+i+"' href='#'>"+(i+1)+"</a></li>";
						}
					}
				}
				if(config.totalPages > 10) {
					if(config.pageGroup < config.totalPagesGroup - 1) {
						pageNav += "<li class=\"nextGroup\"><img src=\"../css/jquery/tablesorter/pager/images/next.gif\" class=\"nextGroup\" height=\"21px\"/></li>";
					}else {
						pageNav += "<li><img src=\"../css/jquery/tablesorter/pager/images/nextDisabled.gif\" height=\"21px\"/></li>";
					}
					//pageNav += "<li><img src=\"../css/jquery/tablesorter/pager/images/last.gif\" class=\"last\" height=\"21px\"/></li>";
				}
				
				return pageNav;
			}
			
			function setPageSize(table,size) {
				var c = table.config;
				c.size = size;
				c.totalPages = Math.ceil(c.totalRows / c.size);
				c.pagerPositionSet = false;
				moveToPage(table);
				fixPosition(table);
			}
			
			function fixPosition(table) {
				var c = table.config;
				if(!c.pagerPositionSet && c.positionFixed) {
					var c = table.config, o = $(table);
					if(o.offset) {
						c.container.css({
							top: o.offset().top + o.height() + 'px',
							position: 'absolute'
						});
					}
					c.pagerPositionSet = true;
				}
			}
			
			function moveToSpecificPage(table, selector, pageNumber) {
				var c = table.config;
				c.page = pageNumber;
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToFirstPage(table, selector, pageNumber) {
				var c = table.config;
				c.page = 0;
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToLastPage(table, selector, pageNumber) {
				var c = table.config;
				c.page = (c.totalPages-1);
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToNextPage(table, selector, pageNumber) {
				var c = table.config;
				c.page++;
				if(c.page >= (c.totalPages-1)) {
					c.page = (c.totalPages-1);
				}
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToNextPageGroup(table, selector, pageNumber) {
				var c = table.config;
				c.pageGroup++;
				if(c.pageGroup >= (c.totalPagesGroup-1)) {
					c.pageGroup = (c.totalPagesGroup-1);
				}
				c.page = c.pageGroup * c.maxPagingLinks;
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToPrevPage(table, selector, pageNumber) {
				var c = table.config;
				c.page--;
				if(c.page <= 0) {
					c.page = 0;
				}
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToPrevPageGroup(table, selector, pageNumber) {
				var c = table.config;
				c.pageGroup--;
				if(c.pageGroup <= 0) {
					c.pageGroup = 0;
				}
				c.page = (c.pageGroup * c.maxPagingLinks) + (c.maxPagingLinks - 1);
				moveToPage(table);
				
				updateSelectedPage(selector, pageNumber);
			}
			
			function moveToPage(table) {
				var c = table.config;
				if(c.page < 0 || c.page > (c.totalPages-1)) {
					c.page = 0;
				}
				
				renderTable(table,c.rowsCopy);
			}
			
			function renderTable(table,rows) {
				
				var c = table.config;
				var l = rows.length;
				var s = (c.page * c.size);
				var e = (s + c.size);
				if(e > rows.length ) {
					e = rows.length;
				}
				
				
				var tableBody = $(table.tBodies[0]);
				
				// clear the table body
				
				$.tablesorter.clearTableBody(table);
				
				for(var i = s; i < e; i++) {
					
					//tableBody.append(rows[i]);
					
					var o = rows[i];
					var l = o.length;
					for(var j=0; j < l; j++) {
						
						tableBody[0].appendChild(o[j]);

					}
				}
				
				fixPosition(table,tableBody);
				
				$(table).trigger("applyWidgets");
				
				if( c.page >= c.totalPages ) {
        			moveToLastPage(table);
				}
				
				updatePageDisplay(c, $(table), table, c.page);
				
				if(typeof config.postRenderTableFunction == "function") {
					config.postRenderTableFunction();
				}
			}
			
			this.appender = function(table,rows) {
				
				var c = table.config;
				
				c.rowsCopy = rows;
				c.totalRows = rows.length;
				c.totalPages = Math.ceil(c.totalRows / c.size);
				c.totalPagesGroup = Math.ceil(c.totalPages / c.maxPagingLinks);
				
				renderTable(table,rows);
			};
			
			this.defaults = {
				size: 10,
				offset: 0,
				page: 0,
				pageGroup: 0,
				totalRows: 0,
				totalPages: 0,
				totalPagesGroup: 0,
				maxPagingLinks: 10,
				container: null,
				cssNext: '.next',
				cssNextGroup: '.nextGroup',
				cssPrev: '.prev',
				cssPrevGroup: '.prevGroup',
				cssFirst: '.first',
				cssLast: '.last',
				cssPageDisplay: '.pagedisplay',
				cssPageSize: '.pagesize',
				seperator: "/",
				positionFixed: true,
				appender: this.appender,
				pagerLocation: "before",
				borderBottom: "false",
				postRenderTableFunction: null
			};
			
			this.construct = function(settings) {
				
				return this.each(function() {
					
					config = $.extend(this.config, $.tablesorterPager.defaults, settings);
					
					var table = this, pager = config.container;
				
					$(this).trigger("appendCache");
					
					var pageNav = "";
					
					var borderBottomStyle = "";
					if(config.borderBottom == "true") {
						borderBottomStyle = "border-bottom: 1px solid #C8C8C8";
					}
					
					pageNav += "<div id=\"widgetTablePager\" style=\"" + borderBottomStyle + "\">";
					
					var resultsStr = " Results";
					if(config.totalRows == 1) {
						resultsStr = " Result";
					}
					pageNav += ("<span class=\"widgetTableTitle\">" + config.totalRows + resultsStr +"</span>");
					
					pageNav += "<ul id='simplePagerNav' class='simplePagerNav'>";
					pageNav += getPageDisplay(config);
					pageNav += "</ul>";
					
					//pageNav += "<input type=\"hidden\" class\"pagesize\" value=\"2\">";
					
					pageNav += "</div>";
					
					var selector = $(this);
					
					switch(config.pagerLocation) {
					case "before":
						selector.before(pageNav);
					break;
					case "both":
						selector.before(pageNav);
						selector.after(pageNav);
					break;
					default:
						selector.after(pageNav);
					}
					
					//config.size = parseInt($(".pagesize",pager).val());
					
					registerEvents(selector, this, config.page);
				});
			};
			
		}
	});
	// extend plugin scope
	$.fn.extend({
        tablesorterPager: $.tablesorterPager.construct
	});
	
})(jQuery);				