<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.search.AutoCompleteCacheRequest"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.search.SavedSearch"%>
<%@ page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@ page import="xpolog.eye.search.SearchUtil"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%
String SEARCH_MODEL = "SearchModel";
String STATUS_OK = "0";
String STATUS_ERROR = "1";

String status = STATUS_OK;
String errorMessage = "";

UserContext userContext = UserEnvironment.getUserContext(request);
SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);

String action = request.getParameter("action");

String savedSearchId = request.getParameter("savedSearchId");
if(savedSearchId == null) {
	savedSearchId = "";
}
String savedSearchName = request.getParameter("savedSearchName");
if(savedSearchName == null || savedSearchName.length() == 0) {
	status = STATUS_ERROR;
	errorMessage = "Name was not specified";
}
String savedSearchTerm = request.getParameter("savedSearchTerm");
if(savedSearchTerm == null || savedSearchTerm.length() == 0) {
	status = STATUS_ERROR;
	if(errorMessage.length() > 0) {
		errorMessage += ", ";
	}
	errorMessage += "Search term was not specified";
}
String savedSearchDescription = request.getParameter("savedSearchDescription");
if(savedSearchDescription == null) {
	savedSearchDescription = "";
}
String savedSearchFixedInterval = request.getParameter("savedSearchFixedInterval");
if(savedSearchFixedInterval == null) {
	savedSearchFixedInterval = "";
}
DateFilter timeFilter = null;
String savedSearchMinDateStr = request.getParameter("savedSearchMinDateStr");
String savedSearchMaxDateStr = request.getParameter("savedSearchMaxDateStr");
String savedSearchMinTimeStr = request.getParameter("savedSearchMinTimeStr");
String savedSearchMaxTimeStr = request.getParameter("savedSearchMaxTimeStr");
if(savedSearchMinDateStr != null && savedSearchMinDateStr.length() > 0 &&
		savedSearchMaxDateStr != null && savedSearchMaxDateStr.length() > 0 && 
		savedSearchMinTimeStr != null && savedSearchMinTimeStr.length() > 0 &&
		savedSearchMaxTimeStr != null && savedSearchMaxTimeStr.length() > 0) {
	savedSearchMinDateStr += (" " + savedSearchMinTimeStr);
	savedSearchMaxDateStr += (" " + savedSearchMaxTimeStr);
	SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm");
	Date newMinDate = sdf.parse(savedSearchMinDateStr);
	Date newMaxDate = sdf.parse(savedSearchMaxDateStr);
	
	timeFilter = new DateFilter();
	timeFilter.setMinDate(newMinDate);
	timeFilter.setMaxDate(newMaxDate);
	timeFilter.setRoundMilliseconds(model.getMsToRound());
	timeFilter.updateMinTime();
}

ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
HashMap defUnitsMap = new HashMap();
if (healthConfigs != null && healthConfigs.length > 0){
	String type = healthConfigs[0].getType();
	String healthWeight = request.getParameter("savedSearchSeverity" + type);
	
 	double weight = -1;
 	if (healthWeight != null && healthWeight.length() > 0){
 		try {
 			weight = Double.parseDouble(healthWeight);
 		}catch (Exception e){}  	
 	}
 
	FilterComputationDefUnit defUnit = null;
 	if (weight >= 0){
 		defUnit = new FilterComputationDefUnit();
 	    defUnitsMap.put(type,defUnit);
		defUnit.setType(type);
		defUnit.setWeight(weight);
		String healthAmountType = request.getParameter("savedSearchSeverityAmountType" + type);
 		int amountType = -1;
 		if (healthAmountType != null && healthAmountType.length() > 0){
  		try {
 				amountType = Integer.parseInt(healthAmountType);
 				defUnit.setAmountType(amountType);
   		}catch (Exception e){}  	
    }
 		String healthAmount = request.getParameter("savedSearchSeverityAmount" + type);
		int amount = -1;
		if (healthAmount != null && healthAmount.length() > 0){
 			try {
 				amount = Integer.parseInt(healthAmount);
 				defUnit.setAmount(amount);
   		}catch (Exception e){}  	
   	}
	}
}

String savedSearchVisibilityStr = request.getParameter("savedSearchVisibility");
boolean savedSearchVisibility = savedSearchVisibilityStr != null && savedSearchVisibilityStr.equals("true");
String visibility = null;
if(savedSearchVisibility) {
	if(userContext != null && userContext.getUser() != null && userContext.getUser().getUser() != null &&
		 userContext.getUser().getUser().getName() != null && userContext.getUser().getUser().getName().length() > 0 &&
		 userContext.getUser().getUser().getDisplayName() != null && userContext.getUser().getUser().getDisplayName().length() > 0) {
		visibility = "User-" + userContext.getUser().getUser().getName() + SavedSearch.VISIBILITY_SEPARATOR + userContext.getUser().getUser().getDisplayName();
		
		if(userContext.isAdmin()) {
			if(savedSearchId != null && savedSearchId.length() > 0) {
				SavedSearch orig = SearchHistoryManager.getInstance().getSavedSearchById(userContext, savedSearchId);
				if(orig != null) {
					String origVisibility = orig.getVisibility();
					if(origVisibility != null && origVisibility.length() > 0) {
						// if an administrator saves a private search of another user, use the original visibility
						visibility = origVisibility;
					}
				}
			}
		}
	}
}
if(visibility != null && visibility.length() > 0) {
	if(defUnitsMap.size() > 0) {
		status = STATUS_ERROR;
		errorMessage = "A private search cannot have a severity different than 'None'";
	}
}

if(status.equals(STATUS_OK)) {
	savedSearchName = savedSearchName.trim();
	savedSearchTerm = savedSearchTerm.trim();
	savedSearchDescription = savedSearchDescription.trim();
	
	SearchHistoryManager searchHistoryManager = SearchHistoryManager.getInstance();
	
	boolean isSavedSearchExists = false;
	List savedSearches = searchHistoryManager.getSavedSearchesByName(userContext, savedSearchName);
	SavedSearch savedSearch = null;
	String existingSavedSearchId = null;
	String existingSavedSearchVisibility = null;
	if(savedSearches != null && savedSearches.size() > 0) {
		for(int i = 0; i < savedSearches.size(); i++) {
			savedSearch = (SavedSearch)savedSearches.get(i);
			existingSavedSearchId = savedSearch.getId();
			existingSavedSearchVisibility = savedSearch.getVisibility();
			
			if(savedSearchId != null && savedSearchId.length() > 0) { // saving an existing search
				boolean sameId = savedSearchId.equals(existingSavedSearchId);
				if(sameId) { // this is the search that is being edited
					/*if(visibility == null || visibility.length() == 0) { // saving as public search
						if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // the search was already public
							// no problem
						}else { // the search was private
							if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // there is an existing public search with the same name
								isSavedSearchExists = true;
								break;
							}
						}
					}else { // saving as private search
						// no problem
					}*/
				}else { // this is not the search that is being edited
					if(visibility == null || visibility.length() == 0) { // saving as public search
						if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // there is an existing public search with the same name
							isSavedSearchExists = true;
							break;
						}else { // the other search is private
							// no problem
						}
					}else { // saving as private search
						if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // there is an existing public search with the same name
							// no problem
						}else { // the other search is private
							if(userContext.isAdmin()) {
								if(visibility.equals(existingSavedSearchVisibility)) {
									isSavedSearchExists = true;
									break;
								}
							}else {
								isSavedSearchExists = true;
								break;
							}
						}
					}
				}
			}else { // saving a new search 
				if(visibility == null || visibility.length() == 0) { // saving a new public search
					if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // there is an existing public search with the same name
						isSavedSearchExists = true;
						break;
					}else { // there is an existing private search with the same name
						// no problem
					}
				}else { // saving a new private search
					if(existingSavedSearchVisibility == null || existingSavedSearchVisibility.length() == 0) { // there is an existing public search with the same name
						// no problem
					}else { // there is an existing private search with the same name
						if(userContext.isAdmin()) {
							if(visibility.equals(existingSavedSearchVisibility)) {
								isSavedSearchExists = true;
								break;
							}
						}else {
							isSavedSearchExists = true;
							break;
						}
					}
				}
			}
		}
	}
	if(isSavedSearchExists) {
		status = STATUS_ERROR;
		errorMessage = "A saved search with the same name already exists";
	}else {
		if(action.equals(SearchHistoryManager.ACTION_ADD_SAVED_SEARCH) || action.equals(SearchHistoryManager.ACTION_EDIT_SAVED_SEARCH)) {
			SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(userContext, savedSearchTerm);
			if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
				status = STATUS_ERROR;
				errorMessage = parseResponse.getErrorMessage();
				errorMessage += "<br>";
				if(parseResponse.getErrorQuery() != null && parseResponse.getErrorQuery().length() > 0) {
					errorMessage += parseResponse.getErrorQuery();
				}
				errorMessage = WebUtil.doHTMLEncoding(errorMessage);
			}else if(parseResponse.isComplexQuery() && defUnitsMap.size() > 0) {
				status = STATUS_ERROR;
				errorMessage = "A complex search cannot have a severity different than 'None'";
			}else {
				savedSearch = new SavedSearch();
				if(savedSearchId.equals("")) {
					savedSearchId = SearchHistoryManager.generateSavedSearchId();
				}
				savedSearch.setId(savedSearchId);
				savedSearch.setName(savedSearchName);
				savedSearch.setSearchTerm(savedSearchTerm);
				savedSearch.setDescription(savedSearchDescription);
				savedSearch.setFixedInterval(savedSearchFixedInterval);
				savedSearch.setTimeFilter(timeFilter);
				
				savedSearch.setDefUnits(defUnitsMap);
				
				if(savedSearchVisibility) {
					savedSearch.setVisibility(visibility);
				}else {
					savedSearch.setVisibility(null);
				}
				
				if(action.equals(SearchHistoryManager.ACTION_ADD_SAVED_SEARCH)) {
					searchHistoryManager.addSavedSearch(userContext, savedSearch);
				}else if(action.equals(SearchHistoryManager.ACTION_EDIT_SAVED_SEARCH)) {
					searchHistoryManager.editSavedSearch(userContext, savedSearch);
				}
			}
		}else if(action.equals(SearchHistoryManager.ACTION_DELETE_SAVED_SEARCH)) {
			searchHistoryManager.deleteSavedSearch(userContext, savedSearchId);
		}
	}
}

if(status.equals(STATUS_OK)) {
	// update saved searches autocomplete cache
	AutoCompleteCacheRequest autoCompleteCacheRequest = new AutoCompleteCacheRequest();
	autoCompleteCacheRequest.setUserContext(userContext);
	autoCompleteCacheRequest.setIncludeSavedSearches(true);
	
	SearchViewHelper.createAutoCompleteCache(session, autoCompleteCacheRequest);
}

response.setContentType("text/xml; charset=UTF-8");
%>

<SaveSearchResponse>
	<Response status="<%=status %>" errorMessage="<%=errorMessage %>">
	</Response>
</SaveSearchResponse>