

function showSaveSearchDiv() {
	showGeneralAdminDiv("saveSearch", -1, 100);
}

function initSaveSearchDiv(savedSearchId, savedSearchName, savedSearchTerm, savedSearchDescription, savedSearchFixedInterval, savedSearchFixedIntervalStr, savedSearchSeverity, savedSearchSeverityType, savedSearchVisibility) {
	document.saveSearchForm.savedSearchId.value = savedSearchId;
	document.saveSearchForm.savedSearchName.value = savedSearchName;
	document.saveSearchForm.savedSearchTerm.value = savedSearchTerm;
	document.saveSearchForm.savedSearchDescription.value = savedSearchDescription;
	
	var defaultTimeIntervalCustomTd = document.getElementById("defaultTimeIntervalCustomTd");
	if(defaultTimeIntervalCustomTd) {
		var defaultTimeIntervalCustomTextLink = document.getElementById("defaultTimeIntervalCustomTextLink");
		if(defaultTimeIntervalCustomTextLink) {
			if(savedSearchFixedInterval == "custom" && savedSearchFixedIntervalStr && savedSearchFixedIntervalStr != "") {
				replaceDivContent("defaultTimeIntervalCustomTextLink", savedSearchFixedIntervalStr);
			}else {
				replaceDivContent("defaultTimeIntervalCustomTextLink", "");
			}
		}
	}
	
	var initDefaultTimeIntervalCustomTd = false;
	if(savedSearchFixedInterval != "") {
		var fixedIntervalSelect = document.saveSearchForm.savedSearchFixedInterval;
		var i;
		for(i = 0; i < fixedIntervalSelect.length; i++) {
			if(fixedIntervalSelect.options[i].value == savedSearchFixedInterval) {
				fixedIntervalSelect.options[i].selected = true;
				break;
			}
		}
		
		if(savedSearchFixedInterval == "custom") {
			if(savedSearchFixedIntervalStr && savedSearchFixedIntervalStr != "") {
				var dashIndex = savedSearchFixedIntervalStr.indexOf("-");
				if(dashIndex != -1) {
					var minDateString = savedSearchFixedIntervalStr.substr(0, dashIndex);
					minDateString = trim(minDateString);
					var minIndex = minDateString.indexOf(" ");
					var minDateShortString = minDateString.substr(0, minIndex);
					var minTimeString = minDateString.substr(minIndex + 1);
					
					var maxDateString = savedSearchFixedIntervalStr.substr(dashIndex + 1);
					maxDateString = trim(maxDateString);
					var maxIndex = maxDateString.indexOf(" ");
					var maxDateShortString = maxDateString.substr(0, maxIndex);
					var maxTimeString = maxDateString.substr(maxIndex + 1);
					
					var searchMinDateStr = document.getElementById("savedSearchMinDateStr");
					var searchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
					var searchMinTimeStr = document.getElementById("savedSearchMinTimeStr");
					var searchMaxTimeStr = document.getElementById("savedSearchMaxTimeStr");
					
					if(searchMinDateStr && searchMaxDateStr &&
					   searchMinTimeStr && searchMaxTimeStr) {
						searchMinDateStr.value = minDateShortString;
						searchMaxDateStr.value = maxDateShortString;
						searchMinTimeStr.value = minTimeString;
						searchMaxTimeStr.value = maxTimeString;
						
						searchCalendar.setDate(searchMinDateStr.value, searchMaxDateStr.value);
						
						var calendarStartTime = document.getElementById("calendarStartTime");
						if(calendarStartTime) {
							calendarStartTime.value = searchMinTimeStr.value;
						}
						var calendarEndTime = document.getElementById("calendarEndTime");
						if(calendarEndTime) {
							calendarEndTime.value = searchMaxTimeStr.value;
						}
					}
				}
			}
			
			if(defaultTimeIntervalCustomTd) {
				defaultTimeIntervalCustomTd.style.display = "";
			}
		}else {
			initDefaultTimeIntervalCustomTd = true;
		}
	}else {
		document.saveSearchForm.savedSearchFixedInterval.options[0].selected = true;
		initDefaultTimeIntervalCustomTd = true;
	}
	if(initDefaultTimeIntervalCustomTd) {
		if(defaultTimeIntervalCustomTd) {
			defaultTimeIntervalCustomTd.style.display = "none";
			var searchMinDateStr = document.getElementById("savedSearchMinDateStr");
			var searchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
			var searchMinTimeStr = document.getElementById("savedSearchMinTimeStr");
			var searchMaxTimeStr = document.getElementById("savedSearchMaxTimeStr");
			
			if(searchMinDateStr && searchMaxDateStr &&
			   searchMinTimeStr && searchMaxTimeStr) {
				searchMinDateStr.value = "";
				searchMaxDateStr.value = "";
				searchMinTimeStr.value = "";
				searchMaxTimeStr.value = "";
			}
		}
	}
	
	if(savedSearchSeverity != "" && savedSearchSeverityType != "") {
		var savedSearchSeveritySelect = document.getElementById("savedSearchSeverity" + savedSearchSeverityType);
		if(savedSearchSeveritySelect) {
			var savedSearchSeverityParsed = parseInt(savedSearchSeverity);
			for(i = 0; i < savedSearchSeveritySelect.length; i++) {
				if(savedSearchSeveritySelect.options[i].value == savedSearchSeverityParsed) {
					savedSearchSeveritySelect.options[i].selected = true;
					break;
				}
			}
		}
	}else {
		var savedSearchSeveritySelect = document.getElementById("savedSearchSeverityrisk");
		if(savedSearchSeveritySelect) {
			savedSearchSeveritySelect.options[0].selected = true;
		}
	}
	
	var savedSearchVisibilityEveryone = document.getElementById("savedSearchVisibilityEveryone");
	var savedSearchVisibilityCurrentUser = document.getElementById("savedSearchVisibilityCurrentUser");
	var savedSearchVisibilityText = document.getElementById("savedSearchVisibilityText");
	if(savedSearchVisibilityEveryone && savedSearchVisibilityCurrentUser && savedSearchVisibilityText) {
		var savedSearchVisibilityTextString = "";
		if(savedSearchVisibility && savedSearchVisibility != '') {
			savedSearchVisibilityEveryone.checked = false;
			savedSearchVisibilityCurrentUser.checked = true;
			savedSearchVisibilityTextString = savedSearchVisibility;
		}else {
			savedSearchVisibilityEveryone.checked = true;
			savedSearchVisibilityCurrentUser.checked = false;
			if(CURRENT_USER_DISPLAY_NAME && CURRENT_USER_DISPLAY_NAME != "") {
				savedSearchVisibilityTextString = CURRENT_USER_DISPLAY_NAME;
			}else {
				savedSearchVisibilityTextString = "Current user";
			}
		}
		replaceDivContent("savedSearchVisibilityText", savedSearchVisibilityTextString);
	}
}

function hideSaveSearchDiv() {
	showHideGeneralAdminDiv("saveSearch");
}

function doSaveSearch(mode) {
	hideSavedSearchErrorMessageDiv();
	
	var action = "add";
	var savedSearchId = document.getElementById("savedSearchId").value;
	if(savedSearchId && savedSearchId != "") {
		action = 'edit';
	}
	
	var saveSearchErrorMsgElement = document.getElementById("saveSearchErrorMsg");
	
	var savedSearchName = document.getElementById("savedSearchName").value;
	if(savedSearchName == "") {
		if(saveSearchErrorMsgElement) {
			saveSearchErrorMsgElement.style.display ="";
			saveSearchErrorMsgElement.innerHTML = "Name was not specified";
			return;
		}
	}
	var savedSearchTerm = document.getElementById("savedSearchTerm").value;
	if(savedSearchTerm == "") {
		if(saveSearchErrorMsgElement) {
			saveSearchErrorMsgElement.style.display ="";
			saveSearchErrorMsgElement.innerHTML = "Search term was not specified";
			return;
		}
	}
	var savedSearchDescription = document.getElementById("savedSearchDescription").value;
	
	var savedSearchFixedInterval = document.getElementById("savedSearchFixedInterval").value;
	var savedSearchMinDateStr = document.getElementById("savedSearchMinDateStr").value;
	var savedSearchMinTimeStr = document.getElementById("savedSearchMinTimeStr").value;
	var savedSearchMaxDateStr = document.getElementById("savedSearchMaxDateStr").value;
	var savedSearchMaxTimeStr = document.getElementById("savedSearchMaxTimeStr").value;
	if(savedSearchFixedInterval == "custom" && (savedSearchMinDateStr == "" || savedSearchMaxDateStr == "")) {
		if(saveSearchErrorMsgElement) {
			saveSearchErrorMsgElement.style.display ="";
			saveSearchErrorMsgElement.innerHTML = "Custom time range was not specified";
			return;
		}
	}
	
	var savedSearchSeverityType = document.getElementById("savedSearchSeverityType");
	var savedSearchSeverity = "";
	var savedSearchSeverityAmountType = "";
	var savedSearchSeverityAmount = "";
	if(savedSearchSeverityType) {
		savedSearchSeverity = document.getElementById("savedSearchSeverity" + savedSearchSeverityType.value).value;
		savedSearchSeverityAmountType = document.getElementById("savedSearchSeverityAmountType" + savedSearchSeverityType.value).value;
		savedSearchSeverityAmount = document.getElementById("savedSearchSeverityAmount" + savedSearchSeverityType.value).value;
	}
	
	var savedSearchVisibility = "false";
	var savedSearchVisibilityCurrentUser = document.getElementById("savedSearchVisibilityCurrentUser");
	if(savedSearchVisibilityCurrentUser) {
		if(savedSearchVisibilityCurrentUser.checked) {
			savedSearchVisibility = "true";
		}
	}
	
	var params = "";
	params += ("action=" + action);
	params += ("&savedSearchId=" + savedSearchId);
	params += ("&savedSearchName=" + encodeURIComponent(savedSearchName));
	params += ("&savedSearchTerm=" + encodeURIComponent(savedSearchTerm));
	params += ("&savedSearchDescription=" + savedSearchDescription);
	params += ("&savedSearchFixedInterval=" + savedSearchFixedInterval);
	params += ("&savedSearchMinDateStr=" + savedSearchMinDateStr);
	params += ("&savedSearchMinTimeStr=" + savedSearchMinTimeStr);
	params += ("&savedSearchMaxDateStr=" + savedSearchMaxDateStr);
	params += ("&savedSearchMaxTimeStr=" + savedSearchMaxTimeStr);
	if(savedSearchSeverityType) {
		params += ("&savedSearchSeverity" + savedSearchSeverityType.value + "=" + savedSearchSeverity);
		params += ("&savedSearchSeverityAmountType" + savedSearchSeverityType.value + "=" + savedSearchSeverityAmountType);
		params += ("&savedSearchSeverityAmount" + savedSearchSeverityType.value + "=" + savedSearchSeverityAmount);
	}
	params += ("&savedSearchVisibility=" + savedSearchVisibility);
	params += ("&ajaxTimestamp=" + new Date().getTime());
	params += ("&mode=" + mode);
	sendAjaxRequest("../common/savedSearchAction.jsp", function(req){
	    var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
	    	if(responseElement) {
				var status = responseElement.getAttribute("status");
				if(status == STATUS_OK) {
					hideSaveSearchDiv();
					
					if(mode == '0') {
						// update saved searches div
						sendAjaxRequest("../view/savedSearchesDivContent.jsp", function(req){
							var result = req.responseText;	
							result = result.replace(/^\s+|\s+$/g, '');
							if(result) {
								var savedSearchesDiv = document.getElementById("savedSearchesDiv");
								if(savedSearchesDiv) {
									replaceDivContent("savedSearchesDiv", result);
								}
							}
						}, 'GET', null);
					}else if(mode == '1') {
						// refresh grid table
						updateTablesavedSearches();
					}
				}else {
					var errorMessage = responseElement.getAttribute("errorMessage");
					if(!errorMessage || errorMessage == "") {
						errorMessage = "An error occured while saving the search, please try again"
					}
					var saveSearchErrorMsgElement = document.getElementById("saveSearchErrorMsg");
					if(saveSearchErrorMsgElement) {
						saveSearchErrorMsgElement.style.display ="";
						saveSearchErrorMsgElement.innerHTML = errorMessage;
					}
				}
			}else {
		    	var message = "savedSearchesFunctions.js, doSaveSearch, responseElement, mode=" + mode + ", params=" + params;
		    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
		    		message += ", " + req.responseText;
		    	}
				doLogJsError(BASE_DIRECTORY, message);
		    }
	    }else {
	    	var message = "savedSearchesFunctions.js, doSaveSearch, xmldoc, mode=" + mode + ", params=" + params;
	    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    		message += ", " + req.responseText;
	    	}
			doLogJsError(BASE_DIRECTORY, message);
	    }
	}, 'POST', params);
}

function hideSavedSearchErrorMessageDiv() {
	var saveSearchErrorMsgElement = document.getElementById("saveSearchErrorMsg");
	if(saveSearchErrorMsgElement) {
		saveSearchErrorMsgElement.style.display ="none";
	}
}

function changeDefaultTimeInterval(defaultTimeInterval) {
	var isCustom = (defaultTimeInterval == FIXED_INTERVAL_CUSTOM);
	toggleDefaultTimeIntervalCustomDiv(isCustom);
}

function toggleDefaultTimeIntervalCustomDiv(isCustom) {
	var defaultTimeIntervalCustomTd = document.getElementById("defaultTimeIntervalCustomTd");
	if(defaultTimeIntervalCustomTd) {
		if(isCustom) {
			defaultTimeIntervalCustomTd.style.display = "";
		}else {
			defaultTimeIntervalCustomTd.style.display = "none";
		}
	}
}