var searchCalendar;
function loadCalendar() {
	searchCalendar = new dhtmlxDblCalendarObject("searchCalendarTd", false, {isMonthEditable: true, isYearEditable: true});
	searchCalendar.setYearsRange(2000, 2040);
	searchCalendar.setDateFormat("%m/%d/%Y");
	searchCalendar.setOnClickHandler(onSearchCalendarClick);
}

function openSearchCalendar(xDelta, yDelta, locationReference, mode) {
	var searchCalendarDiv = document.getElementById("searchCalendarDiv");
	if(searchCalendarDiv) {
		if(searchCalendarDiv.style.display == "block") {
			searchCalendarDiv.style.display = "none";
		}else {
			searchCalendarMode = mode;
			
			var calendarTextLink = document.getElementById(locationReference);
			if(calendarTextLink) {
				var x = findPosX(calendarTextLink);
				var y = findPosY(calendarTextLink);
				if(xDelta) {
					x += xDelta;
				}
				if(yDelta) {
					y += yDelta;
				}
				
				searchCalendarDiv.style.left = (x + "px") ;
				searchCalendarDiv.style.top = (y + "px");
			}
			searchCalendar.draw();
			searchCalendar.show();
			
			updateSearchDisplayDates();
			
			var goSearchCalendarLink = document.getElementById("goSearchCalendarLink");
			if(goSearchCalendarLink) {
				goSearchCalendarLink.href = "javascript:goSearchCalendar('" + mode + "')";
			}
			
			searchCalendarDiv.style.display = "block";
		}
	}
}

var searchCalendarMode = '0';
function onSearchCalendarClick(date, calendar, type) {
	if (typeof date == "string") {
		date = new Date(date);
	}
	var month = date.getMonth() + 1;
	if((month + "").length == 1) {
		month = "0" + month;
	}
	var day = date.getDate();
	if((day + "").length == 1) {
		day = "0" + day;
	}
	var year = date.getFullYear();
	var dateString = month + "/" + day + "/" + year;
	if(type == "left") {
		var searchMinDateStr = document.getElementById("searchMinDateStr");
		if(searchMinDateStr) {
			searchMinDateStr.value = dateString;
		}
		if(searchCalendarMode == '1') {
			var savedSearchMinDateStr = document.getElementById("savedSearchMinDateStr");
			if(savedSearchMinDateStr) {
				savedSearchMinDateStr.value = dateString;
			}
		}
	}else if(type == "right") {
		var searchMaxDateStr = document.getElementById("searchMaxDateStr");
		if(searchMaxDateStr) {
			searchMaxDateStr.value = dateString;
		}
		if(searchCalendarMode == '1') {
			var savedSearchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
			if(savedSearchMaxDateStr) {
				savedSearchMaxDateStr.value = dateString;
			}
		}
	}
	
	updateSearchDisplayDates(date, type);
}

var leftDate, rightDate;
function updateSearchDisplayDates(date, type) {
	var searchMinDateStr = document.getElementById("searchMinDateStr");
	var searchMaxDateStr = document.getElementById("searchMaxDateStr");
	if(searchCalendarMode == '1') {
		searchMinDateStr = document.getElementById("savedSearchMinDateStr");
		searchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
	}
	var searchCalendarStartDateTd = document.getElementById("searchCalendarStartDateTd");
	var searchCalendarEndDateTd = document.getElementById("searchCalendarEndDateTd");
	if(searchMinDateStr && searchMinDateStr.value != "" &&
	   searchMaxDateStr && searchMaxDateStr.value != "" && 
	   searchCalendarStartDateTd && searchCalendarEndDateTd) {
		replaceDivContent("searchCalendarStartDateTd", searchMinDateStr.value);
		replaceDivContent("searchCalendarEndDateTd", searchMaxDateStr.value);
	}
	if(date && type) {
		if (typeof date == "string") {
			date = new Date(date);
		}
		if(type == "left") {
			leftDate = date;
		}else if(type == "right") {
			rightDate = date;
		}
	}
}

function goSearchCalendar(mode) {
	var validateTimeFormatResult = validateTimeFormat('calendarStartTime', 'Start Time');
	if(validateTimeFormatResult) {
		validateTimeFormatResult = validateTimeFormat('calendarEndTime', 'End Time');
		if(validateTimeFormatResult) {
			var validateTimeOrderResult = validateTimeOrder();
			if(validateTimeOrderResult) {
				var calendarStartTime = document.getElementById("calendarStartTime");
				var calendarEndTime = document.getElementById("calendarEndTime");
				if(mode == '0') {
					var searchMinTimeStr = document.getElementById("searchMinTimeStr");
					var searchMaxTimeStr = document.getElementById("searchMaxTimeStr");
					if(searchMinTimeStr && calendarStartTime && searchMaxTimeStr && calendarEndTime) {
						searchMinTimeStr.value = calendarStartTime.value;
						searchMaxTimeStr.value = calendarEndTime.value;
						
						closeSearchCalendar();
						onSearchCalendarUpdate("action=changeCalendar");
					}
				}else if(mode == '1') {
					var savedSearchMinDateStr = document.getElementById("savedSearchMinDateStr");
					var savedSearchMinTimeStr = document.getElementById("savedSearchMinTimeStr");
					var savedSearchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
					var savedSearchMaxTimeStr = document.getElementById("savedSearchMaxTimeStr");
					if(savedSearchMinTimeStr && calendarStartTime && savedSearchMaxTimeStr && calendarEndTime) {
						savedSearchMinTimeStr.value = calendarStartTime.value;
						savedSearchMaxTimeStr.value = calendarEndTime.value;
						
						var defaultTimeIntervalCustomTextLink = document.getElementById("defaultTimeIntervalCustomTextLink");
						if(defaultTimeIntervalCustomTextLink) {
							var text = (savedSearchMinDateStr.value + " " + savedSearchMinTimeStr.value + " - " + savedSearchMaxDateStr.value + " " + savedSearchMaxTimeStr.value);
							replaceDivContent("defaultTimeIntervalCustomTextLink", text);
						}
						
						closeSearchCalendar();
					}
				}
			}
		}
	}
}

function validateTimeFormat(id, text) {
	var searchCalendarErrorTd = document.getElementById("searchCalendarErrorTd");
	if(searchCalendarErrorTd) {
		searchCalendarErrorTd.innerHTML = "&nbsp;";
	}
	var isTimeFormatValidResult = isTimeFormatValid(id);
	if(!isTimeFormatValidResult) {
		if(searchCalendarErrorTd) {
			searchCalendarErrorTd.innerHTML = "Invalid " + text + ", use HH:mm format";
		}
		return false;
	}
	return isTimeFormatValidResult;
}

function isTimeFormatValid(id) {
	var timePat = /^(\d{1,2}):(\d{2})(:(\d{2}))?$/;
	
	var input = document.getElementById(id);
	if(input) {
		var timeStr = input.value;
		var matchArray = timeStr.match(timePat);
		if (matchArray == null) {
			return false;
		}
		hour = matchArray[1];
		minute = matchArray[2];
		second = matchArray[4];
		
		if(second == "") {
			second = 0;
		}
			
		if(hour < 0  || hour > 23) {
			return false;
		}
		if(minute < 0 || minute > 59) {
			return false;
		}
		if (second < 0 || second > 59) {
			return false;
		}
		var result = hour + ":" + minute + ":" + second;
		return result;
	}else {
		return false;
	}
}

function validateTimeOrder() {
	var searchMinDateStr = document.getElementById("searchMinDateStr");
	var searchMaxDateStr = document.getElementById("searchMaxDateStr");
	if(searchCalendarMode == '1') {
		searchMinDateStr = document.getElementById("savedSearchMinDateStr");
		searchMaxDateStr = document.getElementById("savedSearchMaxDateStr");
	}
	var calendarStartTime = document.getElementById("calendarStartTime");
	var calendarEndTime = document.getElementById("calendarEndTime");
	if(searchMinDateStr && searchMaxDateStr && calendarStartTime && calendarEndTime) {
		var searchCalendarErrorTd = document.getElementById("searchCalendarErrorTd");
		var searchMinDateStrValue = searchMinDateStr.value;
		if(searchMinDateStrValue == "") {
			if(searchCalendarErrorTd) {
				searchCalendarErrorTd.innerHTML = "Please click the start date";
			}
			return false;
		}
		var searchMaxDateStrValue = searchMaxDateStr.value;
		if(searchMaxDateStrValue == "") {
			if(searchCalendarErrorTd) {
				searchCalendarErrorTd.innerHTML = "Please click the end date";
			}
			return false;
		}
		searchMinDateStrValue = searchMinDateStrValue.replace(/\//g, "");
		searchMaxDateStrValue = searchMaxDateStrValue.replace(/\//g, "");
		if(searchMinDateStrValue == searchMaxDateStrValue) {
			var calendarStartTimeValue = calendarStartTime.value;
			var calendarEndTimeValue = calendarEndTime.value;
			if(calendarStartTimeValue >= calendarEndTimeValue) {
				if(searchCalendarErrorTd) {
					searchCalendarErrorTd.innerHTML = "End time must be later than start time";
				}
				return false;
			}
			return true;
		}
		return true;
	}
}

function closeSearchCalendar() {
	if(searchCalendar && searchCalendar.parent) {
		searchCalendar.hide();
		var searchCalendarDiv = document.getElementById("searchCalendarDiv");
		if(searchCalendarDiv) {
			searchCalendarDiv.style.display = "none";
		}
	}
}