<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.remote.*"%>
<%@ page import="xpolog.eye.data.index.*"%>

<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../";
%>

<%
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  SearchEngineConfiguration searchEngineConfig = SearchEngineManager.getInstance().getConfiguration();

  
	int resultsPerPage = searchEngineConfig.getResultsPerPage();
	int minDelta = searchEngineConfig.getMinDeltaToIndex();
  double cpuLimit = searchEngineConfig.getCpuLimit();
  boolean indexNumbers = searchEngineConfig.isIndexNumbers();
  String specialCharacters = searchEngineConfig.getIndexSpecialChars();
  if (specialCharacters != null){
     specialCharacters = specialCharacters.replaceAll("\"","\\&quot;");
  }
  String indexPath = searchEngineConfig.getIndexPath();
  boolean isDefaultIndexPath = indexPath == null || indexPath.length() == 0;
  if (indexPath == null) indexPath = "";
  long mainLocationThreshold = searchEngineConfig.getDiskSpaceThreshold();
  String mainLocationThresholdStr = mainLocationThreshold > 0 ? String.valueOf(mainLocationThreshold) : "";
  int mainLocationThresholdUnit = searchEngineConfig.getDiskSpaceThresholdUnit();
  String mainLocationThresholdUnitStr = null;
  if (mainLocationThresholdUnit != -1){
  	mainLocationThresholdUnitStr = Constants.InformationUnits.getUnitDescription(mainLocationThresholdUnit);
  }
  if (mainLocationThresholdUnitStr == null){
  	mainLocationThresholdUnitStr  = "";
  }
  List alternatePaths = searchEngineConfig.getAlternateIndexPaths();
  
%>




<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;padding-left:5;padding-top:5;" width="100%" id="AutoNumber3" height="53">                    
	<tr>
    <td><span class="HEADER">General</span></td>
  </tr>   
  <tr>
    <td><span class="REGULARTEXT">Number of results per page: <input type="text" name="resultsPerPage" id="resultsPerPage" value="<%=resultsPerPage%>" size="5"></span></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Minimal file change: <input type="text" name="minDelta" id="minDelta" value="<%=minDelta%>" size="7"></span></td>
  </tr>
  <tr>
    <td>
       <span class="SMALLTEXT">the minimal size in bytes of the unindexed portion a log
       so that the log will be indexed during incremental indexing</span>
    </td>
  </tr>
   <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Average CPU Limitation: </span>
      <select size="1" name="cpuLimit">
	<option value="-1" <%=cpuLimit <= 0 ? "selected" : "" %> >Unlimit </option>
	<% for (int i = 90; i >= 20; i = i - 5){%>
           <option value="<%=String.valueOf(i)%>" <%=cpuLimit == i ? "selected" : "" %> ><%=String.valueOf(i)%></option>
	<% } %>
      </select>
    </td>
  </tr>
  <tr>
    <td>
       <span class="SMALLTEXT">the average cpu for running an indexing (Indexing performance will be influence by changing this parameter).</span>
    </td>
  </tr>

  <tr>
    <td>&nbsp;</td>
  </tr>

   <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>
       <span class="ERRORMESSAGE"><b>Note: changing the directory will move all indexes to that directory<br>
       Indexes which are currently running will be deleted!</b></span>
    </td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Indexing directory: </span>
    	<table border="0" cellpadding="0" cellspacing="0">
    		<tr>
    			<td colspan="2" style="font-size:4px">&nbsp;</td>
    		</tr>
    		<tr>
    			<td><input type="radio" name="dir" id="default" value="default" <%=isDefaultIndexPath ? "checked" : ""%>></td>
    			<td><span class="REGULARTEXT"> Default Indexing Directory (<span style="font-style:italic">XpologHome</span>/index)</span></td>
    		</tr>
    		<tr>
    			<td><input type="radio" name="dir" id="other" value="other" <%=!isDefaultIndexPath ? "checked" : ""%>></td>
    			<td><span class="REGULARTEXT"> Directory:</span>
    				<input type="text" name="dirPath" value="<%=indexPath%>" size="50" onFocus="javascript:document.getElementById('other').checked=true">
    			</td>
    		</tr>
    	</table>
    	
    </td>
  </tr>
  <tr>
    <td>
       <span class="SMALLTEXT">select either the system's default indexing location or enter a valid directory name</span>
    </td>
  </tr>
	<tr>
		<td style="padding-top:15px">
			<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td align="left">
					<a href="javascript:showHideIdexingPathAdvanced()" class="BUTTON_SMALLLINK" id="advancedLink">show further indexing locations</a>
					<a href="javascript:showHideIdexingPathAdvanced()" class="BUTTON_SMALLLINK" id="hideAdvancedLink" style="display:none">hide</a>
					</td>
				</tr>
			</table>
		</td>
	</tr>
  <tr>
    <td>
    	<div id="advanced" style="display:none;padding-bottom:10">
    		<table border="0" cellpadding="0" cellspacing="0">
    		<tr>
					<td style="padding-top:5px;padding-bottom:10px" colspan="4">
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
			    		<tr>
			     			<td style="padding-top:10px"><span class="REGULARTEXT">Capacity: </span>
			     				<input type="text" name="threshold" value="<%=mainLocationThresholdStr%>" size="5">
			     			</td>
			     			<td style="padding-left:5px;padding-top:10px">
			     				<nobr>
			    				<select name="thresholdUnit">
			    					<option value="MB" <%=mainLocationThresholdUnitStr.equals("MB") ? "selected" : ""%>>MB</option>
			    					<option value="GB" <%=!mainLocationThresholdUnitStr.equals("MB") ? "selected" : ""%>>GB</option>
			    				</select>
			    				<span class="SMALLTEXT"> If alternate indexing locations are defined, they will be used when indexing
			    				directory size reaches this value</span>
			    				</nobr>
			    			</td>
							</tr>
						</table>
					</td>
    		</tr>
	<%
	int numPaths = 3;
	if (alternatePaths != null && alternatePaths.size() > 0){
		numPaths = alternatePaths.size() + 3;
	}
	IndexingPath indexingPath;
	String path;
  String threshold = "";
  int thresholdUnit = -1;
  String thresholdUnitStr = null;
  HashMap pronouns = new HashMap();
  pronouns.put("1","st");
  pronouns.put("2","nd");
  pronouns.put("3","rd");
  String pronoun = null;
	for (int i=0; i<numPaths; i++){
		if (alternatePaths != null && i < alternatePaths.size()){
			indexingPath = (IndexingPath)alternatePaths.get(i);
		}else{
			indexingPath = null;
		}
		pronoun = (String)pronouns.get(String.valueOf(i+1));
		if (pronoun == null){
			pronoun = "th";
		}
		if (indexingPath == null){
			path = "";
		  threshold = "";
		  thresholdUnit = -1;
		  thresholdUnitStr = "";
		}else{
			path = indexingPath.getIndexPath();
			threshold = String.valueOf(indexingPath.getDiskSpaceThreshold());
			thresholdUnit = indexingPath.getDiskSpaceThresholdUnit();
		  if (thresholdUnit != -1){
		  	thresholdUnitStr = Constants.InformationUnits.getUnitDescription(thresholdUnit);
		  }
		  if (thresholdUnitStr == null){
		  	thresholdUnitStr = "";
		  }
		}%>
					<tr>
	    			<td>
	    				<input type="hidden" name="numPaths" value="<%=numPaths%>"/>
	    				<span class="REGULARTEXT"><nobr><%=i+1%><sup><%=pronoun%></sup> Alternate Directory:</nobr></span>
	    			</td>
	    			<td style="padding-left:5px">
	    				<input type="text" name="alternateDir<%=i%>" value="<%=path%>" size="60">
	    			</td>
	    			<td style="padding-left:5px"><nobr><span class="REGULARTEXT"> Capacity:</span>
	    				<input type="text" name="alternateThreshold<%=i%>" value="<%=threshold%>" size="5"></nobr>
	    			</td>
	    			<td style="padding-left:5px">
	    				<select name="alternateThresholdUnit<%=i%>">
	    					<option value="MB" <%=thresholdUnitStr.equals("MB") ? "selected" : ""%>>MB</option>
	    					<option value="GB" <%=!thresholdUnitStr.equals("MB") ? "selected" : ""%>>GB</option>
	    				</select>
	    			</td>
	    		</tr>
	<%}%>
    		</table>
    	</div>
    </td>
	</tr>

  <tr>
    <td>&nbsp;</td>
  </tr>


<tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>
       <span class="ERRORMESSAGE"><b>Note: changing the following settings will delete all indexes!</b></span>
    </td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Index numbers: <input type="checkbox" name="indexNumbers" id="indexNumbers" value="true" <%=(indexNumbers?"checked":"")%>></span></td>
  </tr>
  <tr>
    <td>
       <span class="SMALLTEXT">Check this option to enable indexing of numerical values within logs</span>
    </td>
  </tr>
<tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Special Characters: <input type="text" name="specialCharacters" id="specialCharacters" value="<%=specialCharacters == null ? "" : specialCharacters%>"></span></td>
  </tr>
  <tr>
    <td>
       <span class="SMALLTEXT">Please insert the special characters which should be used as a delimeter in the indexing process.<br>
             Please enter the characters without spaces between them (e.g -  &[];:%,{})
	</span>
    </td>
  </tr>
  

  <tr>
    <td height="100%">&nbsp;</td>
  </tr>                 
</table>
                