<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>

<%!static final String BASE_DIRECTORY = "../";%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String FILED_PARAM_PREF = "F_";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "ParentModule";
  String DO_SAVE = "doSave";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String modid  = request.getParameter(MODULE_ID);
  String logname    = request.getParameter(LOG_NAME);
  String doSave = request.getParameter(DO_SAVE);
 
  String logsList = request.getParameter("logs");
  String [] LogsToMerge = null;
  if (logsList != null && logsList.length() > 0){
  	LogsToMerge = logsList.split(",");
 	}
  
  //page data
  MergedLogBrowserManager lbm = null;

  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(LogsToMerge == null || LogsToMerge.length < 2) {
  	errmodel.addError("You must select at least two logs for a merge.");
  	
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=search/searchMergeAdmin.jsp");
    return;

  }

	MergedLogBrowserBuilder builder = new MergedLogBrowserBuilder();
	if (logname == null || logname.length() == 0){
		logname = "Merge search log";
	}
	builder.setName(logname);
	builder.setLogDescription("Merge search log");
	builder.setTimeZoneId(DataBrowsingInfo.DEFAULT);
	
	builder.setLogsToMergeIds(LogsToMerge);
	try {
		builder.updateBuilder();
	} catch (XpologBuilderException e) {
		e.printStackTrace();
	}
	lbm = builder.getMergeLogBrowser();
	BuildersColumnsInfo info = builder.initAutomaticMergeRecordMask();
	lbm.setRecordMask(info.getRecordMask());
	MergeIndexing indexing = MergeAdminHelper.getMergeIndexing(lbm);
	int size = info.getMergeIndexing().getDescriptorCount();
	MergeDescriptor[] mds = new MergeDescriptor[size];
	for (int i = 0; i < mds.length; i++) {
		mds[i] = info.getMergeIndexing().getDescriptorAt(i);
	}
	
    indexing.setDescriptors(mds);
	//create merge customization manager
    MergeCustomizationManager mcm = builder.initCustomizationManager(info.getRecordMask());
    lbm.setCustomizationManager(mcm);
    
    DefaultColorConfig defc = Configuration.getInstance().getDefColorMgr();
	String[] mc = defc.getDefMergeBgColors();
	String[] logIds = lbm.getLogBrowsersIds();
	int number = mc.length <= logIds.length ? mc.length : logIds.length; 
	for (int i = 0; i < number ; i++) {
		mcm.setLogColor(logIds[i],mc[i]);
	}
	lbm.updateLegend();
	String charset = lbm.getLogBrowsersCharset();
	lbm.setCharset(charset);
    
    
    if(doSave != null  && doSave.equalsIgnoreCase("true")){
     admin.addLogBrowser(lbm,SiteManagment.getInstance().getModuleFromId(modid));
     request.getSession().setAttribute("logid",lbm.getId()); 
    }else{
     lbm.setID("SearchId");
     lbm.setTemporary(true);
     request.getSession().setAttribute("logid","SearchId"); 
    }
	request.getSession().setAttribute(CURRENT_LOG,lbm);
	
	
   String searchEngineSearchTerm = request.getParameter("searchEngineSearchTerm");
   if(searchEngineSearchTerm == null){
   		searchEngineSearchTerm = "";
   }else {
  	 if(charset != null) {
  		 searchEngineSearchTerm = new String(searchEngineSearchTerm.getBytes("8859_1"), "UTF-8");
  	 }
   }
   String searchEngineAllWords = request.getParameter("searchEngineAllWords");
   if(searchEngineAllWords == null){
   		searchEngineAllWords = "";
   }
   String matchWholeWordsOnly = request.getParameter("matchWholeWordsOnly");
   if(matchWholeWordsOnly == null){
   		matchWholeWordsOnly = "";
   }
   String searchRegExp = request.getParameter("searchRegExp");
   if(searchRegExp == null){
   		searchRegExp = "";
   }
   
   
   String params = "searchEngineSearchTerm=" + searchEngineSearchTerm + "&searchEngineAllWords=" + searchEngineAllWords + "&matchWholeWordsOnly="+matchWholeWordsOnly;
   
   boolean allWords = (searchEngineAllWords != null && searchEngineAllWords.equals("allWords"));
   boolean matchWholeWordsOnlyBol = (matchWholeWordsOnly != null && matchWholeWordsOnly.equals("true"));
   xpolog.eye.data.filters.FilterCollection fcol = SearchEngineAdminHelper.createFilter(searchEngineSearchTerm,allWords,lbm,matchWholeWordsOnlyBol);
	 if (fcol != null){
	 	 fcol.setSearchEngineResultsOnly(true);
	 	 lbm.getFilterManager().addFilterCollection(fcol);
	 	 //lbm.getFilterManager().setActiveFilterId(null);
	 }
   response.sendRedirect(BASE_DIRECTORY + "/loggers/logview.jsp?opdirect=START&gotoMain=true");
%>


