<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.search.SearchModelHelper"%>
<%@ page import="xpolog.eye.search.SearchResult"%>
<%@ page import="xpolog.eye.search.ui.SearchGraphTooltip"%>
<%@ page import="xpolog.eye.search.ui.SearchGraphTooltipQuery"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";
String STATUS_OK = "0";
String STATUS_ERROR = "1";

SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);
if(model == null) {
	return;
}

String startTimestampStr = request.getParameter("startTimestamp");
long startTimestamp = -1;
if(startTimestampStr != null && startTimestampStr.length() > 0) {
	try {
		startTimestamp = Long.parseLong(startTimestampStr);
	}catch(Exception e) {
	}
}
String endTimestampStr = request.getParameter("endTimestamp");
long endTimestamp = -1;
if(endTimestampStr != null && endTimestampStr.length() > 0) {
	try {
		endTimestamp = Long.parseLong(endTimestampStr);
	}catch(Exception e) {
	}
}
String elementIds = request.getParameter("elementIds");
HashSet elementIdsSet = new HashSet();
if(elementIds != null && elementIds.length() > 0) {
	String[] elementIdsArr = elementIds.split("\\|");
	for(int i = 0; i < elementIdsArr.length; i++) {
		elementIdsSet.add(elementIdsArr[i]);
	}
}
String modelUpdateTimeStr = request.getParameter("modelUpdateTime");
long modelUpdateTime = -1;
if(modelUpdateTimeStr != null && modelUpdateTimeStr.length() > 0) {
	try {
		modelUpdateTime = Long.parseLong(modelUpdateTimeStr);
	}catch(Exception e) {
	}
}
String graphTypeStr = request.getParameter("graphType");
int graphType = SearchGraphTooltipQuery.GRAPH_TYPE_RECORDS;
if(graphTypeStr != null && graphTypeStr.length() > 0) {
	try {
		graphType = Integer.parseInt(graphTypeStr);
	}catch(Exception e) {
	}
}
String url = "recordsGraphTooltip.jsp";

SearchResult currentResult = model.getCurrentResult();
SearchGraphTooltipQuery tooltipQuery = new SearchGraphTooltipQuery();
tooltipQuery.setSearchResult(currentResult);
tooltipQuery.setStartTimestamp(startTimestamp);
tooltipQuery.setEndTimestamp(endTimestamp);
tooltipQuery.setElementIds(elementIdsSet);
tooltipQuery.setGraphType(graphType);

SearchGraphTooltip graphTooltip = SearchModelHelper.getGraphTooltip(tooltipQuery);
SearchResultElement rootNodeResultElement = graphTooltip.getRootNodeResultElement();
long rootTotalEvents = graphTooltip.getRootTotalEvents();

StringBuffer tooltipHeaderDateString = new StringBuffer();
String startDateString = DateUtil.transformDateToString(new Date(startTimestamp));
if(startDateString.indexOf(":") != startDateString.lastIndexOf(":")) {
	startDateString = startDateString.substring(0, startDateString.lastIndexOf(":"));
}
tooltipHeaderDateString.append(startDateString);
tooltipHeaderDateString.append("&nbsp;-&nbsp;");
String endDateString = DateUtil.transformDateToString(new Date(endTimestamp));
if(endDateString.indexOf(":") != endDateString.lastIndexOf(":")) {
	endDateString = endDateString.substring(0, endDateString.lastIndexOf(":"));
}
tooltipHeaderDateString.append(endDateString);

String bgSuffix = "0";

request.setAttribute("currentResult", currentResult);
request.setAttribute("rootNodeResultElement", rootNodeResultElement);
request.setAttribute("rootTotalEvents", new Long(rootTotalEvents));
request.setAttribute("tooltipHeaderDateString", tooltipHeaderDateString.toString());
request.setAttribute("startDateString", startDateString);
request.setAttribute("endDateString", endDateString);
request.setAttribute("bgSuffix", bgSuffix);

response.setContentType("text/xml; charset=UTF-8");
if(startTimestamp == -1 || endTimestamp == -1) {
%>


<%@page import="xpolog.eye.search.ui.SearchResultElement"%><SearchGrpahTooltipResponse>
		<Response status="<%=STATUS_ERROR %>">
		
		</Response>
	</SearchGrpahTooltipResponse>
<%
}else {
	
%>
	<SearchGrpahTooltipResponse>
		<Response status="<%=STATUS_OK %>" bgSuffix="<%=bgSuffix %>">
			<jsp:include page="<%=url %>" flush="true" >
				<jsp:param name="startTimestamp" value="<%=startTimestamp %>" />
				<jsp:param name="endTimestamp" value="<%=endTimestamp %>" />
				<jsp:param name="elementIds" value="<%=elementIds %>" />
				<jsp:param name="graphType" value="<%=graphType %>" />
				<jsp:param name="isEmbeded" value="true" />
			</jsp:include>
		</Response>
	</SearchGrpahTooltipResponse>
<%
}
%>