<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>

<%@ page import="xpolog.eye.search.AutoCompleteCacheRequest"%>
<%@ page import="xpolog.eye.search.SearchModelHelper"%>
<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.search.ui.SearchModelRequest"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";

String query = request.getQueryString();
if (query == null){
	 query = "";
}
String loginUrl = "search/view/loadSearchModel.jsp" + (query.length() == 0 ? "" : "?") + query;
request.setAttribute("loginForwardURL",loginUrl);
WebSecurityManager securityManager = WebSecurityManager.getInstance();
if (!securityManager.checkForPermission(request,response,null,true)){
  return;
}

UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);

String searchQuery = request.getParameter("searchQuery");
String fixedInterval = request.getParameter("fixedInterval");
long startTime = -1;
long endTime = -1;
if(fixedInterval == null || fixedInterval.length() == 0) {
	String startTimeStr = request.getParameter("startTime");
	String endTimeStr = request.getParameter("endTime");
	try {
		startTime = Long.parseLong(startTimeStr);
		endTime = Long.parseLong(endTimeStr);
	}catch(Exception e) {
	}
	if(startTime == -1 && endTime == -1) {
		startTimeStr = request.getParameter("startTimeFullStr");
		endTimeStr = request.getParameter("endTimeFullStr");
		if(startTimeStr != null && startTimeStr.length() > 0 &&
			 endTimeStr != null && endTimeStr.length() > 0) {
			String dateFormat = request.getParameter("dateFormat");
			if(dateFormat == null || dateFormat.length() == 0) {
				dateFormat = DateUtil.dateFormat;
			}
			try {
				SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
				Date minDate = sdf.parse(startTimeStr);
				Date maxDate = sdf.parse(endTimeStr);
				
				startTime = minDate.getTime();
				endTime = maxDate.getTime();
			}catch(Exception e) {
			}
		}
	}
}
String isSavedSearchActivationStr = request.getParameter("isSavedSearchActivation");
boolean isSavedSearchActivation = isSavedSearchActivationStr != null && isSavedSearchActivationStr.equals("true");

SearchModelRequest searchModelRequest = new SearchModelRequest();
searchModelRequest.setSearchQuery(searchQuery);
searchModelRequest.setFixedInterval(fixedInterval);
searchModelRequest.setStartTime(startTime);
searchModelRequest.setEndTime(endTime);
searchModelRequest.setSavedSearchActivation(isSavedSearchActivation);

searchModelRequest.setUserContext(userContext);

SearchModel model = SearchModelHelper.getSearchModel(searchModelRequest);
if(model != null) {
	session.setAttribute(SEARCH_MODEL, model);
	
	//update search history autocomplete cache
	AutoCompleteCacheRequest autoCompleteCacheRequest = new AutoCompleteCacheRequest();
	autoCompleteCacheRequest.setUserContext(userContext);
	autoCompleteCacheRequest.setIncludeSearchHistory(true);
	
	SearchViewHelper.createAutoCompleteCache(session, autoCompleteCacheRequest);
}
response.sendRedirect(BASE_DIRECTORY + "componentAction.jsp?selectedCompId=SearchEngine&forward=root.jsp%3FmainPage=search/view/search.jsp");

%>