<%@ page language="java"%>

<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";

static final String HEADER_DIV_ID = "searchHeaderDiv";
static final String GRAPH_DIV_ID = "searchGraphDiv";
static final String MAIN_TABLE_DIV_ID = "searchMainTableDiv";
static final String STATUS_OK = "0";
static final String STATUS_NO_ACTION = "1";
%>

<%
String SEARCH_MODEL = "SearchModel";

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
String key = request.getParameter("key");
if (!SiteManagment.getInstance().checkKey(key)){
	if (!manager.checkForPermission(request, response, null, true)) {
	  return;
  }
}

String resetModelStr = request.getParameter("resetModel");
boolean resetModel = resetModelStr != null && resetModelStr.equals("true");

String searchTerm = request.getParameter("searchTerm");
if(searchTerm == null) {
	searchTerm = "";
}else if(searchTerm.length() > 0) {
	resetModel = false;
}

//audit
AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	userContext, AuditConstants.VIEW, "view xpo search", AuditConstants.SEARCH_ENGINE, "view xpo search");

boolean enableAutoComplete = SearchHistoryManager.ENABLE_AUTO_COMPLETE;

boolean printExtraDataOnError = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("ui.js.printExtraDataOnError", false);

boolean useAutoCompelteCache = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("xpolog.eye.search.ui.useAutoCompelteCache", true);
if(useAutoCompelteCache) {
	SearchViewHelper.createAutoCompleteCache(session, userContext);
}

response.setContentType("text/html; charset=UTF-8");
%>

<html>

<head>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=UTF-8">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/search.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dhtmlxCalendar.css" />
	
	<%if(enableAutoComplete) { %>
	<!-- JQuery autocmplete css  -->
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jquery/autocomplete/styles.css" />
	<%} %>
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jquery/tabs/styles.css" />
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery.js"></script>
	<%if(enableAutoComplete) { %>
	<!-- JQuery autocmplete code  -->
	<script type="text/javascript" src='<%=BASE_DIRECTORY%>scripts/jquery/autocomplete/jquery.autocomplete.js'></script>
	<%} %>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchFunctions.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchCalendarFunctions.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/savedSearchesFunctions.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchTooltips.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/search.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/searchExt.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/searchHeader.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/searchCalendar.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/searchGraph.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/view/searchMainTable.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>widgets/popup/js/popup.js"></script>
	
	<jsp:include page="../../common/constants.jsp" flush="true"/>
</head>

<script>

var BASE_DIRECTORY = "../../";

var HEADER_DIV_ID = "<%=HEADER_DIV_ID %>";
var GRAPH_DIV_ID = "<%=GRAPH_DIV_ID %>";
var MAIN_TABLE_DIV_ID = "<%=MAIN_TABLE_DIV_ID %>";

var STATUS_OK = "<%=STATUS_OK %>";
var STATUS_NO_ACTION = "<%=STATUS_NO_ACTION %>";
var FIXED_INTERVAL_CUSTOM = "<%=DateUtil.FIXED_INTERVAL_CUSTOM %>"

var RESULTS_PER_PAGE = 10;

var VIEW_BY;
var VIEW_TYPE;

var printExtraDataOnError = <%=printExtraDataOnError %>;

var enableAutoComplete = <%=enableAutoComplete %>;
var APOS_MASK = "<%=SearchViewHelper.AUTO_COMPLETE_APOS_MASK %>";

<%
if(userContext != null && userContext.getUser() != null && userContext.getUser().getUser() != null &&
	 userContext.getUser().getUser().getDisplayName() != null && userContext.getUser().getUser().getDisplayName().length() > 0) {
%>
var CURRENT_USER_DISPLAY_NAME = "<%=userContext.getUser().getUser().getDisplayName() %>";
<%
}
%>

document.onclick = hideSearchDivsIfClickedOutside;

function hideSearchDivsIfClickedOutside(e) {
	var ignoreIds = new Array();
	ignoreIds[0] = "fixedIntervalMenuTextLink";
	ignoreIds[1] = "fixedIntervalMenuLink";
	hideElementIfClickedOutside(e, "searchFixedIntervalDiv", ignoreIds);
	/*ignoreIds = new Array();
	ignoreIds[0] = "savedSearchesMenuTextLink";
	ignoreIds[1] = "searchDivsLink";
	hideElementIfClickedOutside(e, "searchSavedSearchesDiv", ignoreIds);*/
	ignoreIds = new Array();
	ignoreIds[0] = "recordsPerPageMenuTextLink";
	ignoreIds[1] = "recordsPerPageMenuLink";
	hideElementIfClickedOutside(e, "searchRecordsPerPageDiv", ignoreIds);
	ignoreIds = new Array();
	ignoreIds[0] = "sc&Cal";
	ignoreIds[1] = "month_btn_left";
	ignoreIds[2] = "month_btn_right";
	ignoreIds[3] = "planeMonth";
	ignoreIds[4] = "planeYear";
	ignoreIds[5] = "dhtmlxRichSelector";
	ignoreIds[6] = "calendarTextLink";
	ignoreIds[7] = "calendarLink";
	ignoreIds[8] = "custom";
	hideElementIfClickedOutside(e, "searchCalendarDiv", ignoreIds);
	hideElementIfClickedOutside(e, "searchFilterByTypeDiv");
	hideElementIfClickedOutside(e, "searchZoomInDiv");
	hideElementIfClickedOutside(e, "searchZoomInSmallImageDiv");
	ignoreIds = new Array();
	ignoreIds[0] = "searchResultActionsMenuLinkMainTable";
	ignoreIds[1] = "searchResultActionsMenuLinkTopMessages";
	hideElementIfClickedOutside(e, "searchResultActionsDiv", ignoreIds);
}
/*

*/
</script>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<body onLoad="javascript:doOnLoad(<%=resetModel %>, '<%=searchTerm %>')" onUnload="javascript:doOnUnload();" style="overflow-y:scroll">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>

<div id="searchErrorQueryDiv" class="SEARCH_HEADER_ERROR_QUERY_DIV" style="display:none">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td id="searchErrorQueryTd" class="SEARCH_HEADER_ERROR_QUERY_TEXT"></td>
		</tr>
	</table>
</div>
<div id="searchCalendarDiv" class="XPOLOG_DHTMLX_CALENDAR_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td id="searchCalendarTd"></td>
		</tr>
		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_DATE_CELL">Start Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="searchCalendarStartDateTd"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_DATE_CELL">End Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="searchCalendarEndDateTd"></td>
					</tr>
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_TIME_CELL">Start Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarStartTime" name="calendarStartTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarStartTime', 'Start Time')"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_TIME_CELL">End Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarEndTime" name="calendarEndTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarEndTime', 'End Time')"></td>
					</tr>
					<tr height="10px">
						<td id="searchCalendarErrorTd" class="XPOLOG_DHTMLX_CALENDAR_ERROR_CELL" colspan="4">&nbsp;</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="XPOLOG_DHTMLX_CALENDAR_BUTTONS_CELL">
				<a id="goSearchCalendarLink" href="javascript:goSearchCalendar('0')"><img src="<%=BASE_DIRECTORY %>images/search/header/calendarGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarGo.gif')"></a>
				<a href="javascript:closeSearchCalendar()"><img src="<%=BASE_DIRECTORY %>images/search/header/calendarClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarClose.gif')"></a>
			</td>
		</tr>
	</table>
</div>
<jsp:include page="searchFilterBy.jsp" flush="true" />
<div id="searchGraphTooltipDiv" class="SEARCH_GRAPH_TOOLTIP_DIV" style="display:none" onMouseOver="javascript:onMouseOverSearchGraphTooltip();" onMouseOut="javascript:onMouseOutSearchGraphTooltip();">
</div>
<div id="searchGraphTooltipStumDiv" class="SEARCH_GRAPH_TOOLTIP_STUM_DIV" style="display:none" onMouseOver="javascript:onMouseOverSearchGraphTooltip();" onMouseOut="javascript:onMouseOutSearchGraphTooltip();">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td align="center"><img id="searchGraphTooltipStumImage" src="" border="0"></td>
		</tr>
	</table>
</div>
<div id="searchZoomInTopDiv" class="SEARCH_GRAPH_ZOOM_IN_TOP_DIV" style="display:none">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td class="empty"></td>
		</tr>
	</table>
</div>
<div id="searchZoomInDiv" class="SEARCH_GRAPH_ZOOM_IN_DIV" style="display:none">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td align="center"><img id="searchGraphZoomInDivImage" src="<%=BASE_DIRECTORY %>images/search/graph/zoomInDiv.gif" border="0"></td>
		</tr>
	</table>
</div>
<form AUTOCOMPLETE="OFF" id="showLogForm" name="showLogForm" method="POST" action="<%=BASE_DIRECTORY %>common/showLog.jsp" class="SEARCH_FORM">
	<input type="hidden" name="lbmId">
	<input type="hidden" name="filterId">
	<input type="hidden" name="isKnowledge">
	<input type="hidden" name="DateMinimum">
	<input type="hidden" name="DateMaximum">
	<input type="hidden" name="Dates" value="TimeLimRadio">
	<input type="hidden" name="quickDateFilter" value="true">
	<input type="hidden" name="expandLogViewer" value="true">
	<input type="hidden" name="hideDashboardButton" value="false">
	<input type="hidden" name="modelSessionAttributeName" value="HealthViewModel">
</form>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Save Search"/> 
	<jsp:param name="suffix" value="saveSearch"/>
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="330px"/> 
	<jsp:param name="includePath" value="search/common/saveSearchDiv.jsp"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:doSaveSearch('0')#javascript:hideSaveSearchDiv()"/> 
</jsp:include>

<div id="<%=HEADER_DIV_ID %>" style="height:107px;">
</div>

<div id="<%=GRAPH_DIV_ID %>" style="height:250px;">
</div>

<div id="<%=MAIN_TABLE_DIV_ID %>">
</div>

</body>
</html>