function zoomInCalendar() {
	closeSearchCalendar();
	
	onSearchCalendarUpdate("action=zoomInCalendar");
}

function zoomOutCalendar() {
	closeSearchCalendar();
	
	onSearchCalendarUpdate("action=zoomOutCalendar");
}

function changeFixedInterval(params) {
	if(!params) {
		params = "action=changeFixedInterval";
	}
	onSearchCalendarUpdate(params);
}

function onSearchCalendarUpdate(params) {
	var form = document.getElementById("searchHeaderForm");
	if(form) {
		var postParams = getFormElementsQueryString(form);
		if(postParams != "") {
			postParams += "&";
		}
		postParams += params;
		updateSearchModel(postParams);
	}
}

function onAfterCalendarDivResponseLoaded() {
	var searchMinDateStr = document.getElementById("searchMinDateStr");
	var searchMaxDateStr = document.getElementById("searchMaxDateStr");
	var searchMinTimeStr = document.getElementById("searchMinTimeStr");
	var searchMaxTimeStr = document.getElementById("searchMaxTimeStr");
	if(searchMinDateStr && searchMinDateStr.value != "" && 
	   searchMaxDateStr && searchMaxDateStr.value != "" && 
	   searchMinTimeStr && searchMinTimeStr.value != "" && 
	   searchMaxTimeStr && searchMaxTimeStr.value != "") {
		searchCalendar.setDate(searchMinDateStr.value, searchMaxDateStr.value);
		
		var calendarStartTime = document.getElementById("calendarStartTime");
		if(calendarStartTime) {
			calendarStartTime.value = searchMinTimeStr.value;
		}
		var calendarEndTime = document.getElementById("calendarEndTime");
		if(calendarEndTime) {
			calendarEndTime.value = searchMaxTimeStr.value;
		}
	}
}

function openFixedIntervalMenu() {
	closeSearchCalendar();
	
	var searchFixedIntervalDiv = document.getElementById("searchFixedIntervalDiv");
	if(searchFixedIntervalDiv) {
		if(searchFixedIntervalDiv.style.display == "") {
			searchFixedIntervalDiv.style.display = "none";
		}else {
			searchFixedIntervalDiv.style.display = "";
		}
	}
}

function closeFixedIntervalMenu() {
	var searchFixedIntervalDiv = document.getElementById("searchFixedIntervalDiv");
	if(searchFixedIntervalDiv) {
		searchFixedIntervalDiv.style.display = "none";
	}
}

function setFixedInterval(fixedInterval, evenIfTheSame, ignoreMissingExecutions) {
	var fixedIntervalElement = document.getElementById("fixedInterval");
	if(fixedIntervalElement && (fixedIntervalElement.value != fixedInterval || (evenIfTheSame && evenIfTheSame == "true")) && fixedInterval != "custom") {
		fixedIntervalElement.value = fixedInterval;
		
		var roundMinTimeToZero = false;
		var searchMinTimeStr = document.getElementById("searchMinTimeStr");
		if(searchMinTimeStr) {
			roundMinTimeToZero = (searchMinTimeStr.value == "00:00");
		}
		var params = "action=changeFixedInterval&roundMinTimeToZero=" + roundMinTimeToZero;
		if(ignoreMissingExecutions) {
			params += "&ignoreMissingExecutions=" + ignoreMissingExecutions;
		}
		changeFixedInterval(params);
	}
	closeFixedIntervalMenu();
	
	if(fixedInterval == "custom") {
		openSearchCalendar(-270, 22, 'fixedIntervalMenuTextLink', '0');
	}
}

function setFixedIntervalMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}