var isMouseOverSearchGraphNode;
var isMouseOverSearchGraphTooltip;
var isMouseOverSearchGraphTooltipStum;
var hideSearchGraphTooltipIfNeededTimeoutId;
var hideSearchGrapTooltipIfNeededInterval = 500;

var searchViewTypeSlidingDivInterval;
var searchGroupTypeSlidingDivInterval;

function onAfterGraphDivResponseLoaded() {
	setTimeout("hideSearchViewTypeSlidingDiv()", 100);
	setTimeout("hideSearchGroupTypeSlidingDiv()", 100);
}

function initViewTypeDivsPositions() {
	var searchViewTypeUpperDiv = document.getElementById("searchViewTypeUpperDiv");
	if(searchViewTypeUpperDiv) {
		var left = findPosX(searchViewTypeUpperDiv);
		var top = findPosY(searchViewTypeUpperDiv);
		left += 48;
		top += 1;
		left = left + "px";
		top = top + "px";
		
		var searchViewTypeSlidingDiv = document.getElementById("searchViewTypeSlidingDiv");
		if(searchViewTypeSlidingDiv) {
			searchViewTypeSlidingDiv.style.left = left;
			searchViewTypeSlidingDiv.style.top = top;
			searchViewTypeSlidingDiv.style.width = "0px";
			searchViewTypeSlidingDiv.style.paddingTop = "";
			searchViewTypeSlidingDiv.style.paddingRight = "";
			searchViewTypeSlidingDiv.style.paddingBottom = "";
		}
	}
}

function showSearchViewTypeSlidingDiv(text) {
	if(searchViewTypeSlidingDivInterval) {
		clearInterval(searchViewTypeSlidingDivInterval);
		searchViewTypeSlidingDivInterval = null;
	}
	var searchViewTypeSlidingDiv = document.getElementById("searchViewTypeSlidingDiv");
	if(searchViewTypeSlidingDiv) {
		searchViewTypeSlidingDiv.style.paddingTop = "3px";
		searchViewTypeSlidingDiv.style.paddingRight = "10px";
		searchViewTypeSlidingDiv.style.paddingBottom = "3px";
		searchViewTypeSlidingDivInterval = showSlidingDiv("slideExpand", "searchViewTypeSlidingDiv", "searchViewTypeUpperDiv", text, "right", 170, 2, 10);
	}
}

function hideSearchViewTypeSlidingDiv() {
	if(searchViewTypeSlidingDivInterval) {
		clearInterval(searchViewTypeSlidingDivInterval);
		searchViewTypeSlidingDivInterval = null;
	}
	initViewTypeDivsPositions();
}

function changeViewType(viewType) {
	hideSearchViewTypeSlidingDiv();
	
	var params = "action=changeViewType&viewType=" + viewType
	updateSearchModel(params);
}

function initGroupTypeDivsPositions() {
	var searchViewGroupTypeUpperDiv = document.getElementById("searchViewGroupTypeUpperDiv");
	if(searchViewGroupTypeUpperDiv) {
		var left = findPosX(searchViewGroupTypeUpperDiv);
		var top = findPosY(searchViewGroupTypeUpperDiv);
		if(document.all) {
			left -= 2;
			top += 1;
		}else {
			left -= 12;
			top += 1;
		}
		left = left + "px";
		top = top + "px";
		
		var searchGroupTypeSlidingDiv = document.getElementById("searchGroupTypeSlidingDiv");
		if(searchGroupTypeSlidingDiv) {
			searchGroupTypeSlidingDiv.style.left = left;
			searchGroupTypeSlidingDiv.style.top = top;
			searchGroupTypeSlidingDiv.style.width = "0px";
			searchGroupTypeSlidingDiv.style.paddingTop = "";
			searchGroupTypeSlidingDiv.style.paddingLeft = "";
			searchGroupTypeSlidingDiv.style.paddingBottom = "";
		}
	}
}

function showSearchGroupTypeSlidingDiv(text) {
	if(searchGroupTypeSlidingDivInterval) {
		clearInterval(searchGroupTypeSlidingDivInterval);
		searchGroupTypeSlidingDivInterval = null;
	}
	var searchGroupTypeSlidingDiv = document.getElementById("searchGroupTypeSlidingDiv");
	if(searchGroupTypeSlidingDiv) {
		searchGroupTypeSlidingDiv.style.paddingTop = "3px";
		searchGroupTypeSlidingDiv.style.paddingLeft = "10px";
		searchGroupTypeSlidingDiv.style.paddingBottom = "3px";
		searchGroupTypeSlidingDivInterval = showSlidingDiv("slideExpand", "searchGroupTypeSlidingDiv", "searchViewGroupTypeUpperDiv", text, "left", 130, 2, 10);
	}
}

function hideSearchGroupTypeSlidingDiv() {
	if(searchGroupTypeSlidingDivInterval) {
		clearInterval(searchGroupTypeSlidingDivInterval);
		searchGroupTypeSlidingDivInterval = null;
	}
	initGroupTypeDivsPositions();
}

function changeViewGroupType(viewGroupType) {
	hideSearchGroupTypeSlidingDiv();
	
	var params = "action=changeViewGroupType&viewGroupType=" + viewGroupType
	updateSearchModel(params);
}

function onMouseOverSearchGraphNode(obj, event, startTimestamp, endTimestamp, elementIds, modelUpdateTime,graphType) {
	isMouseOverSearchGraphTooltip = false;
	isMouseOverSearchGraphTooltipStum = false;
	window.clearTimeout(hideSearchGraphTooltipIfNeededTimeoutId);
	isMouseOverSearchGraphNode = true;
	var postParams = "";
	postParams += ("startTimestamp=" + startTimestamp);
	postParams += ("&endTimestamp=" + endTimestamp);
	postParams += ("&elementIds=" + elementIds);
	postParams += ("&modelUpdateTime=" + modelUpdateTime);
	postParams += ("&graphType=" + graphType);
	postParams += ("&ajaxTimestamp=" + new Date().getTime());
	sendAjaxRequest("getGraphTooltip.jsp", function(req){
		if(isMouseOverSearchGraphNode) {
		    showSearchGraphTooltip(obj, event, req);
		}
	}, 'POST', postParams);
}

function showSearchGraphTooltip(obj, event, req) {
	var xmldoc = req.responseXML.documentElement;
	if(xmldoc) {
		var responseElement = xmldoc.getElementsByTagName("Response")[0];
		if(responseElement) {
			var status = responseElement.getAttribute("status");
			if(status == STATUS_OK) {
				var bgSuffix = responseElement.getAttribute("bgSuffix");
				var searchGraphTooltipDiv = document.getElementById("searchGraphTooltipDiv");
				var searchGraphTooltipStumDiv = document.getElementById("searchGraphTooltipStumDiv");
				if(searchGraphTooltipDiv && searchGraphTooltipStumDiv) {
					var responseText = getXMLElementValue(responseElement);
					replaceDivContent("searchGraphTooltipDiv", responseText);
					
					var graphImage = document.getElementById('graphImage');
					if(graphImage) {
						var graphImagePosition = findPos(graphImage);
						var objPosition = findPos(obj);
						var stumWidth = 33; // taken from the width of the stum image
						var stumHeight = 28; // taken from the height of the stum image
						var tableWidth = 270; // taken from width of SEARCH_GRAPH_TOOLTIP_DIV class in CSS
					  
					  // get the height of the tooltip div using a trick
					  searchGraphTooltipDiv.style.filter = "alpha(opacity=1)"; // IE
						searchGraphTooltipDiv.style.opacity = 0.01; // Firefox, etc..
						searchGraphTooltipDiv.style.display = ""; 
						var tableHeight = searchGraphTooltipDiv.offsetHeight;
						searchGraphTooltipDiv.style.display = "none"; 
						searchGraphTooltipDiv.style.filter = "alpha(opacity=100)"; // IE
						searchGraphTooltipDiv.style.opacity = 1; // Firefox, etc..
						
					  var winWidth = 1280;
					  var winHeight = 1024;
					  var sizeArr = getWindowSize();
					  if (sizeArr && sizeArr.length == 2){
					  	winWidth = sizeArr[0];
					  	winHeight = sizeArr[1];
					  }
						var x = (document.all ? objPosition[0] + graphImagePosition[0] : event.pageX);
						var y = (document.all ? objPosition[1] + graphImagePosition[1] : event.pageY);
						
						// check if the tooltip can be shown to the right of the mouse. if not, show on the left of the mouse
						var showOnRightSide;
						if(x < (winWidth - (tableWidth + stumWidth) - 50)) {
							showOnRightSide = true;
						}else {
							showOnRightSide = false;
						}
						if(showOnRightSide) {
							if(document.all) {
					  		x += 16;
							}else {
								x += 4;
							}
						}else {
							if(document.all) {
					  		x = x - (tableWidth + stumWidth);
							}else {
								x = x - (tableWidth + stumWidth + 7);
							}
							
						}
				  	if (x < 0){
				  		x = 0;
				  		showOnRightSide = true;
				  	}
				  	
				  	var showAbove;
				  	if(y - document.body.scrollTop > tableHeight / 2) {
							showAbove = true;
						}else {
							showAbove = false;
						}
				  	if (y < 0){
				  		y = 0;
				  	}
				  	
				  	var stumX, stumY;
				  	var bodyX, bodyY;
				  	
				  	var searchGraphTooltipStumImage = document.getElementById("searchGraphTooltipStumImage");
				  	if(showOnRightSide) {
				  		stumX = x;
				  		bodyX = (stumX + stumWidth) - 1;
				  		if(showAbove) {
				  			searchGraphTooltipStumImage.src = BASE_DIRECTORY + "images/search/graph/tooltipBackgrounds/stumLeftBottom" + bgSuffix + ".gif";
				  		}else {
				  			searchGraphTooltipStumImage.src = BASE_DIRECTORY + "images/search/graph/tooltipBackgrounds/stumLeftTop" + bgSuffix + ".gif";
				  		}
				  	}else {
				  		bodyX = x;
				  		stumX = (bodyX + tableWidth) - 1;
				  		if(showAbove) {
				  			searchGraphTooltipStumImage.src = BASE_DIRECTORY + "images/search/graph/tooltipBackgrounds/stumRightBottom" + bgSuffix + ".gif";
				  		}else {
				  			searchGraphTooltipStumImage.src = BASE_DIRECTORY + "images/search/graph/tooltipBackgrounds/stumRightTop" + bgSuffix + ".gif";
				  		}
				  	}
				  	if(showAbove) {
			  			stumY = y - 20;
			  			bodyY = stumY - (tableHeight / 2);
			  		}else {
			  			stumY = y;
			  			bodyY = stumY;
			  		}
				  	
				  	searchGraphTooltipDiv.style.left = (bodyX + "px");
						searchGraphTooltipDiv.style.top = (bodyY + "px");
						searchGraphTooltipDiv.style.display = "";
						
						searchGraphTooltipStumDiv.style.left = (stumX + "px");
						searchGraphTooltipStumDiv.style.top = (stumY + "px");
						searchGraphTooltipStumDiv.style.display = "";
					}
				}
			}else {
				var message = "searchGraph.js, showSearchGraphTooltip, status != STATUS_OK";
				if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
		    		message += ", " + req.responseText;
		    	}
				doLogJsError(BASE_DIRECTORY, message);
			}
		}else {
	    	var message = "searchGraph.js, showSearchGraphTooltip, responseElement";
	    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
	    		message += ", " + req.responseText;
	    	}
			doLogJsError(BASE_DIRECTORY, message);
	    }
	}else {
    	var message = "searchGraph.js, showSearchGraphTooltip, xmlDoc";
    	if(typeof printExtraDataOnError == "boolean" && printExtraDataOnError) {
    		message += ", " + req.responseText;
    	}
		doLogJsError(BASE_DIRECTORY, message);
    }
}

function onMouseOutSearchGraphNode(obj, event) {
	hideSearchGraphTooltipIfNeededTimeoutId = setTimeout("hideSearchGrapTooltipIfNeeded()", hideSearchGrapTooltipIfNeededInterval);
	isMouseOverSearchGraphNode = false;
}

function hideSearchGrapTooltipIfNeeded() {
	if(isMouseOverSearchGraphTooltip || isMouseOverSearchGraphTooltipStum) {
		hideSearchGraphTooltipIfNeededTimeoutId = window.setTimeout("hideSearchGrapTooltipIfNeeded()", hideSearchGrapTooltipIfNeededInterval);
	}else {
		hideSearchGraphTooltip();
	}
}

function hideSearchGraphTooltip() {
	var searchGraphTooltipDiv = document.getElementById("searchGraphTooltipDiv");
	if(searchGraphTooltipDiv) {
		searchGraphTooltipDiv.style.display = "none";
	}
	var searchGraphTooltipStumDiv = document.getElementById("searchGraphTooltipStumDiv");
	if(searchGraphTooltipStumDiv) {
		searchGraphTooltipStumDiv.style.display = "none";
	}
}

function onMouseOverSearchGraphTooltip() {
	isMouseOverSearchGraphTooltip = true;
	isMouseOverSearchGraphTooltipStum = true;
}

function onMouseOutSearchGraphTooltip() {
	isMouseOverSearchGraphTooltip = false;
	isMouseOverSearchGraphTooltipStum = false;
}

function onMouseOverZoomInGraphImage(minX, minY, maxX, maxY, startTimestamp, endTimestamp, modelUpdateTime) {
	var zoomInSmallImageWidth = 13; // 13 is the width of the image zoomIn.gif under images/search/graph
	var zoomInSmallImageHeight = 12; // 12 is the height of the image zoomIn.gif under images/search/graph

	var searchZoomInDiv = document.getElementById("searchZoomInDiv");
	var searchZoomInTopDiv = document.getElementById("searchZoomInTopDiv");
	if(searchZoomInDiv && searchZoomInTopDiv) {
		var graphImage = document.getElementById('graphImage');
		if(graphImage) {
			var graphImagePosition = findPos(graphImage);
			var left = minX + graphImagePosition[0];
			var top = minY + graphImagePosition[1];
			var width = maxX - minX;
			var height = maxY - minY;
			
			var zoomInDivLeft = left;
			var zoomInDivTop = top + zoomInSmallImageHeight;
			var zoomInDivWidth = width;
			var zoomInDivHeight = height - zoomInSmallImageHeight;
			
			var searchGraphZoomInDivImage = document.getElementById("searchGraphZoomInDivImage");
			if(zoomInDivWidth < 43) { // 43 is the width of the image zoomInDiv.gif under images/search/graph
				searchGraphZoomInDivImage.width = zoomInDivWidth;
			}else {
				searchGraphZoomInDivImage.width = 43;
			}
			
			zoomInDivLeft += "px";
			zoomInDivTop += "px";
			zoomInDivWidth += "px";
			zoomInDivHeight += "px";
			
			searchZoomInDiv.style.left = zoomInDivLeft;
			searchZoomInDiv.style.top = zoomInDivTop;
			searchZoomInDiv.style.width = zoomInDivWidth;
			searchZoomInDiv.style.height = zoomInDivHeight;
			searchZoomInDiv.style.display = "";
			
			var zoomInTopDivLeft = left + zoomInSmallImageWidth;
			var zoomInTopDivTop = top;
			var zoomInTopDivWidth = width - zoomInSmallImageWidth;
			if(zoomInTopDivWidth < 0) {
				zoomInTopDivWidth = 0;
			}
			var zoomInTopDivHeight = zoomInSmallImageHeight;
			
			zoomInTopDivLeft += "px";
			zoomInTopDivTop += "px";
			zoomInTopDivWidth += "px";
			zoomInTopDivHeight += "px";
			
			searchZoomInTopDiv.style.left = zoomInTopDivLeft;
			searchZoomInTopDiv.style.top = zoomInTopDivTop;
			searchZoomInTopDiv.style.width = zoomInTopDivWidth;
			searchZoomInTopDiv.style.height = zoomInTopDivHeight;
			searchZoomInTopDiv.style.display = "";
		}
	}
}

function onMouseOutZoomInGraphImage() {
	hideZoomInGraphImage();
}

function hideZoomInGraphImage() {
	var searchZoomInDiv = document.getElementById("searchZoomInDiv");
	var searchZoomInTopDiv = document.getElementById("searchZoomInTopDiv");
	if(searchZoomInDiv && searchZoomInTopDiv) {
		searchZoomInDiv.style.display = "none";
		searchZoomInTopDiv.style.display = "none";
	}
}

function zoomInGraph(obj, startTimestamp, endTimestamp, modelUpdateTime) {
	hideZoomInGraphImage();
	var params = "action=zoomInGraph";
	params += ("&startTimestamp=" + startTimestamp);
	params += ("&endTimestamp=" + endTimestamp);
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateSearchModel(params);
}

function zoomOutGraph() {
	var params = "action=zoomOutGraph";
	
	updateSearchModel(params);
}

function previousGraphTime(modelUpdateTime) {
	var params = "action=previousGraphTime";
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateSearchModel(params);
}

function nextGraphTime(modelUpdateTime) {
	var params = "action=nextGraphTime";
	params += ("&modelUpdateTime=" + modelUpdateTime);
	
	updateSearchModel(params);
}