<%@ page language="java"%>

<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.search.ui.*"%>

<%!
static final String BASE_DIRECTORY = "../../";
static final int WIDE_GRAPH_WIDTH = 1000;
static final int NARROW_GRAPH_WIDTH = 850;
static final int STEP_GRAPH_WIDTH = 1024;
static final int TALL_GRAPH_HEIGHT = 220;
//static final int SHORT_GRAPH_HEIGHT = 180;
static final int SHORT_GRAPH_HEIGHT = 220; // leave height same as in high resolution for now
static final int STEP_GRAPH_HEIGHT = 768;
%>

<%
String SEARCH_MODEL = "SearchModel";

SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);
SearchResult currentResult = model.getCurrentResult();

String windowWidthStr = request.getParameter("windowWidth");
int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;
//int graphWidth = windowWidth != -1 && windowWidth <= STEP_GRAPH_WIDTH ? NARROW_GRAPH_WIDTH : WIDE_GRAPH_WIDTH;
int graphWidth = windowWidth != -1 ? windowWidth : NARROW_GRAPH_WIDTH;
String windowHeightStr = request.getParameter("windowHeight");
int windowHeight = windowHeightStr != null && windowHeightStr.length() > 0 ? Integer.parseInt(windowHeightStr) : -1;
int graphHeight = windowHeight != -1 && windowHeight <= STEP_GRAPH_HEIGHT ? SHORT_GRAPH_HEIGHT : TALL_GRAPH_HEIGHT;

String graphMapName = "graphMap";
SearchGraphQuery graphQuery = new SearchGraphQuery(graphWidth, graphHeight, graphMapName);
SearchGraphResult graphResult = null;

String viewType = model.getViewType();
String viewGroupType = model.getViewGroupType();
if(viewType.equals(SearchContext.VIEW_TYPE_LINE)) {
	if(viewGroupType.equals(SearchContext.VIEW_GROUP_TYPE_SUMMARY)) {
		graphResult = SearchViewHelper.generateTotalXYChart(currentResult, graphQuery);
	}else {
		graphResult = SearchViewHelper.generateSplitXYChart(currentResult, graphQuery);
	}
}else if(viewType.equals(SearchContext.VIEW_TYPE_BAR)) {
	if(viewGroupType.equals(SearchContext.VIEW_GROUP_TYPE_SUMMARY)) {
		graphResult = SearchViewHelper.generateTotalBarChart(currentResult, graphQuery);
	}else {
		graphResult = SearchViewHelper.generateSplitBarChart(currentResult, graphQuery);
	}
}

String graphImagePath = BASE_DIRECTORY + graphResult.getImagePath();
String graphMap = graphResult.getMapStr();

boolean showZoomOut = model.getZoomInDateFilters().size() > 0;
%>

<form AUTOCOMPLETE="OFF" id="searchGraphForm" name="searchGraphForm" method="POST" class="SEARCH_FORM">
<div id="searchMapDiv" class="SEARCH_GRAPH_MAP_DIV">
<%=graphMap%>
</div>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr height="10px">
		<td class="SEARCH_GRAPH_OUTER_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="SEARCH_GRAPH_VIEW_TYPE_CELL">
									<div id="searchViewTypeUpperDiv" class="SEARCH_GRAPH_VIEW_TYPE_UPPER">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											if(viewType.equals(SearchContext.VIEW_TYPE_LINE)) {
											%>
											<td align="left"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewTypeLineOver.jpg" border="0" onMouseOver="javascript:showSearchViewTypeSlidingDiv('<nobr>Line Graph</nobr>')" onMouseOut="javascript:hideSearchViewTypeSlidingDiv()"></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="left"><a href="javascript:changeViewType('<%=SearchContext.VIEW_TYPE_BAR %>');"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewTypeBar.jpg" border="0" onMouseOver="javascript:setImageSource(this, 'graph/viewTypeBarOver.jpg');javascript:showSearchViewTypeSlidingDiv('<nobr>Bar Graph</nobr>')" onMouseOut="javascript:setImageSource(this, 'graph/viewTypeBar.jpg');javascript:hideSearchViewTypeSlidingDiv()"></a></td>
											<%
											}else if(viewType.equals(SearchContext.VIEW_TYPE_BAR)) {
											%>
											<td align="left"><a href="javascript:changeViewType('<%=SearchContext.VIEW_TYPE_LINE %>');"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewTypeLine.jpg" border="0" onMouseOver="javascript:setImageSource(this, 'graph/viewTypeLineOver.jpg');javascript:showSearchViewTypeSlidingDiv('<nobr>Line Graph</nobr>')" onMouseOut="javascript:setImageSource(this, 'graph/viewTypeLine.jpg');javascript:hideSearchViewTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="left"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewTypeBarOver.jpg" border="0" onMouseOver="javascript:showSearchViewTypeSlidingDiv('<nobr>Bar Graph</nobr>')" onMouseOut="javascript:hideSearchViewTypeSlidingDiv()"></td>
											<%
											}
											%>
										</tr>
									</table>
									</div>
									<div id="searchViewTypeSlidingDiv" class="SEARCH_GRAPH_VIEW_TYPE_POPUP"></div>
								</td>
								<%
								if(showZoomOut) {
								%>
									<td class="SEARCH_GRAPH_ZOOM_OUT_OUTER_CELL">
										<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
											<tr>
												<td class="empty">&nbsp;</td>
												<td class="SEARCH_GRAPH_ZOOM_OUT_CELL"><a href="javascript:zoomOutGraph()" class="SEARCH_GRAPH_ZOOM_OUT_TEXT" onMouseOver="javascript:showTooltip(searchTooltips['zoomOutGraph'])" onMouseOut="javascript:hideTooltip()">Zoom out</a></td>
												<td class="empty">&nbsp;</td>
											</tr>
										</table>
									</td>
								<%
								}else {
								%>
									<td class="empty">&nbsp;</td>
								<%
								}
								%>
								<td class="SEARCH_GRAPH_GROUP_TYPE_CELL">
									<div id="searchViewGroupTypeUpperDiv" class="SEARCH_GRAPH_VIEW_GROUP_TYPE_UPPER">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											if(viewGroupType.equals(SearchContext.VIEW_GROUP_TYPE_SPLIT)) {
											%>
											<td align="right"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewGroupTypeSplitOver.gif" border="0" onMouseOver="javascript:showSearchGroupTypeSlidingDiv('<nobr>Split View</nobr>')" onMouseOut="javascript:hideSearchGroupTypeSlidingDiv()"></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="right"><a href="javascript:changeViewGroupType('<%=SearchContext.VIEW_GROUP_TYPE_SUMMARY %>');"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewGroupTypeSummary.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/viewGroupTypeSummaryOver.gif');javascript:showSearchGroupTypeSlidingDiv('<nobr>Summary View</nobr>')" onMouseOut="javascript:setImageSource(this, 'graph/viewGroupTypeSummary.gif');javascript:hideSearchGroupTypeSlidingDiv()"></a></td>
											<%
											}else if(viewGroupType.equals(SearchContext.VIEW_GROUP_TYPE_SUMMARY)) {
											%>
											<td align="right"><a href="javascript:changeViewGroupType('<%=SearchContext.VIEW_GROUP_TYPE_SPLIT %>');"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewGroupTypeSplit.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/viewGroupTypeSplitOver.gif');javascript:showSearchGroupTypeSlidingDiv('<nobr>Split View</nobr>')" onMouseOut="javascript:setImageSource(this, 'graph/viewGroupTypeSplit.gif');javascript:hideSearchGroupTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="right"><img src="<%=BASE_DIRECTORY %>images/search/graph/viewGroupTypeSummaryOver.gif" border="0" onMouseOver="javascript:showSearchGroupTypeSlidingDiv('<nobr>Summary View</nobr>')" onMouseOut="javascript:hideSearchGroupTypeSlidingDiv()"></td>
											<%
											}
											%>
										</tr>
									</table>
									</div>
									<div id="searchGroupTypeSlidingDiv" class="SEARCH_GRAPH_GROUP_TYPE_POPUP" style="width:0px;"></div>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td>
						<img border="0" id="graphImage" src="<%=graphImagePath%>" usemap="#<%=graphMapName%>">
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</form>