var searchViewBySlidingDivInterval;
var searchGroupTypeSlidingDivInterval;

function onAfterHeaderDivResponseLoaded(isEmptySearch) {
	initSearchBoxSize();
	/*initSearchSyntaxDivSize();*/
	//hideSearchViewBySlidingDiv();
	//hideSearchGroupTypeSlidingDiv();
	
	initSaveSearchDiv("", "", document.getElementById("searchTerm").value, "", "", "", "", "", "");
	
	if(enableAutoComplete) {
		createSearchTermAutoCompleteObject(true);
	}
	
	var searchTerm = document.getElementById("searchTerm");
	if(searchTerm) {
		searchTerm.focus();
	}
	
	initSearchDivsTabs();
	if(isEmptySearch && isEmptySearch == "true") {
		openSearchDivs(isEmptySearch);
	}
}

function initSearchDivsTabs() {
	//When page loads...
	$(".SEARCH_DIVS_TAB_CONTENT").hide(); //Hide all content
	$("#searchSyntaxDivLink").addClass("active").show(); //Activate first tab
	$("#searchSyntaxDiv").show(); //Show first tab content

	//On Click Event
	$("ul.SEARCH_DIVS_TABS li").click(function() {
		
		$("ul.SEARCH_DIVS_TABS li").removeClass("active"); //Remove any "active" class
		$(this).addClass("active"); //Add "active" class to selected tab
		$(".SEARCH_DIVS_TAB_CONTENT").hide(); //Hide all tab content

		var activeTab = $(this).find("a").attr("href"); //Find the href attribute value to identify the active tab + content
		var index = activeTab.indexOf("#");
		if(index > 0) {
			// substr because of IE behavior
			activeTab = activeTab.substr(index);
		}
		
		$(activeTab).fadeIn(); //Fade in the active ID content
		return false;
	});

}

var autoCompleteObject;
function createSearchTermAutoCompleteObject(doCreate) {
	$(document).ready(function() {
		autoCompleteObject = $("#searchTerm").autocomplete({
			serviceUrl: BASE_DIRECTORY + "common/autocompleteHandler.jsp?type=complexSearch&source=xpoSearch",
			noCache: true,
			onSelect: handleAutoCompleteSelect,
			reference: $("#searchHeaderTextBoxCell"),
			aposMask: APOS_MASK
		});
 	});
}

function initSearchBoxSize() {
	var searchTerm = document.getElementById("searchTerm");
	if(searchTerm) {
		if(windowWidth) {
			var widthOfElementsOutsideWhiteArea = 251;
			var widthOfElementsInsideWhiteArea = 116;
			var textBoxWidth = windowWidth - widthOfElementsOutsideWhiteArea - widthOfElementsInsideWhiteArea - 10;
			searchTerm.style.width = textBoxWidth + "px";
		}else {
			searchTerm.style.width = "450px";
		}
	}
}

function initSearchSyntaxDivSize() {
	if(windowHeight < 700) {
		var searchSyntaxDiv = document.getElementById("searchSyntaxDiv");
		if(searchSyntaxDiv) {
			searchSyntaxDiv.style.height = "400px";
		}
	}
}

function initViewByDivsPositions() {
	var searchViewByUpperDiv = document.getElementById("searchViewByUpperDiv");
	if(searchViewByUpperDiv) {
		var left = findPosX(searchViewByUpperDiv);
		var top = findPosY(searchViewByUpperDiv);
		top += 1;
		left = left + "px";
		top = top + "px";
		
		var searchViewByCoverDiv = document.getElementById("searchViewByCoverDiv");
		if(searchViewByCoverDiv) {
			searchViewByCoverDiv.style.left = left;
			searchViewByCoverDiv.style.top = top;
			searchViewByCoverDiv.style.display = "";
			var searchViewBySlidingDiv = document.getElementById("searchViewBySlidingDiv");
			searchViewBySlidingDiv.style.left = left;
			searchViewBySlidingDiv.style.top = top;
			searchViewBySlidingDiv.style.display = "";
		}
	}
}

function showSearchViewBySlidingDiv(text) {
	searchViewBySlidingDivInterval = showSlidingDiv("slide", "searchViewBySlidingDiv", "searchViewByUpperDiv", text, "right", 145, 2, 10);
}

function hideSearchViewBySlidingDiv() {
	if(searchViewBySlidingDivInterval) {
		clearInterval(searchViewBySlidingDivInterval);
		searchViewBySlidingDivInterval = null;
	}
	initViewByDivsPositions();
}

function changeViewBy(viewBy) {
	hideSearchViewBySlidingDiv();
	
	var form = document.getElementById("searchHeaderForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=changeViewBy&viewBy=" + viewBy;
		updateSearchModel(params);
	}
}

function setCurrentNode(nodeId) {
	var params = "action=setCurrentNode&id=" + nodeId;
	updateSearchModel(params);
}

function openSearchFilterByDiv() {
	var searchFilterByDiv = document.getElementById("searchFilterByDiv");
	if(searchFilterByDiv) {
		var filterByDivLink = document.getElementById("filterByDivLink");
		if(filterByDivLink) {
			var left = findPosX(filterByDivLink);
			var top = findPosY(filterByDivLink);
			
			left += 70;
			
			left += "px";
			top += "px";
			
			searchFilterByDiv.style.left = left;
			searchFilterByDiv.style.top = top;
			searchFilterByDiv.style.display = "";
			
			if(!lastFilterByType) {
				lastFilterByType = VIEW_BY;
			}
			setFilterByType(lastFilterByType, true);
		}
	}
}

function goSearchFilterBy() {
	updateSelectedNodes();
	var form = document.getElementById("searchFilterByForm");
	if(form) {
		var params = getFormElementsQueryString(form);
		if(params != "") {
			params += "&";
		}
		params += "action=activateFilterBy";
		params += "&filterBy=" + document.getElementById("filterByType").value;
		//alert(params);
		updateSearchModel(params);
	}
	
	closeSearchFilterByDiv();
}

function updateSelectedNodes() {
	document.getElementById("filterLogs").value = "";
	document.getElementById("filterModules").value = "";
	document.getElementById("filterApplications").value = "";
	document.getElementById("filterServers").value = "";
	
	//var list = filterByContentTree.getAllCheckedAndPartiallyChecked();
	var list = filterByContentTree.getAllChecked();
	var arr = list.split(",");
	var logsStr = "";
 	var modsStr = "";
 	var applicationsStr = "";
 	var serversStr = "";
	for (var i = 0; i < arr.length; i++){
		var s = arr[i];
		var ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == "Module"){
				if (modsStr != ""){
					modsStr += ",";
				}
				modsStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					modsStr += "*";
				}
			}else if (type == "Application"){
				if (applicationsStr != ""){
					applicationsStr += ",";
				}
				applicationsStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					applicationsStr += "*";
				}
			}else if (type == "Host"){
				if (serversStr != ""){
					serversStr += ",";
				}
				serversStr += id;
				if (filterByContentTree.hasChildren(s) && filterByContentTree.hasChildren(s) == true){
					serversStr += "*";
				}
			}else{
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}
		}
	}
	document.getElementById("filterLogs").value = logsStr;
	document.getElementById("filterModules").value = modsStr;
	document.getElementById("filterApplications").value = applicationsStr;
	document.getElementById("filterServers").value = serversStr;
}

function clearSearchFilterBy() {
	var params = "action=clearFilterBy";
	updateSearchModel(params);
}

function closeSearchFilterByDiv() {
	var searchFilterByDiv = document.getElementById("searchFilterByDiv");
	if(searchFilterByDiv) {
		searchFilterByDiv.style.display = "none";
	}
}

function openFilterByTypeMenu() {
	var searchFilterByTypeDiv = document.getElementById("searchFilterByTypeDiv");
	if(searchFilterByTypeDiv) {
		var filterByTypeMenuLink = document.getElementById("filterByTypeMenuLink");
		if(filterByTypeMenuLink) {
			var left = findPosX(filterByTypeMenuLink);
			var top = findPosY(filterByTypeMenuLink);
			
			if(document.all) {
				left -= 110;
				top += 5;
			}else {
				left -= 100;
				top += 15;
			}
			
			left += "px";
			top += "px";
			
			searchFilterByTypeDiv.style.left = left;
			searchFilterByTypeDiv.style.top = top;
			searchFilterByTypeDiv.style.display = "";
		}
	}
}

function closeFilterByTypeMenu() {
	var searchFilterByTypeDiv = document.getElementById("searchFilterByTypeDiv");
	if(searchFilterByTypeDiv) {
		searchFilterByTypeDiv.style.display = "none";
	}
}

var lastFilterByType = null;
function setFilterByType(filterByType, reload) {
	var foldersContentDiv = document.getElementById("filterByFoldersContentDiv");
	var applicationsContentDiv = document.getElementById("filterByApplicationsContentDiv");
	var serversContentDiv = document.getElementById("filterByServersContentDiv");
	
	var filterByTypeElement = document.getElementById("filterByType");
	var filterByTypeTextElement = document.getElementById("filterByTypeText");
	if(filterByTypeElement && filterByTypeTextElement && (filterByTypeElement.value != filterByType || reload)) {
		loadFilterByContentDivTree(filterByType);
		lastFilterByType = filterByType;
		filterByTypeElement.value = filterByType;
		
		var text = "";
		if(filterByType == filterByFoldersAndLogsType) {
			text = filterByFoldersAndLogs;
			setImageTd(filterByFoldersAndLogsType, true);
			setImageTd(filterByApplicationsType, false);
			setImageTd(filterByServersType, false);
		}else if(filterByType == filterByApplicationsType) {
			text = filterByApplications;
			setImageTd(filterByFoldersAndLogsType, false);
			setImageTd(filterByApplicationsType, true);
			setImageTd(filterByServersType, false);
		}else if(filterByType == filterByServersType) {
			text = filterByServers;
			setImageTd(filterByFoldersAndLogsType, false);
			setImageTd(filterByApplicationsType, false);
			setImageTd(filterByServersType, true);
		}
		replaceDivContent("filterByTypeText", text);
	}
	
	closeFilterByTypeMenu();
}

function setFilterByTypeMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}

var filterByContentTree = null;
function loadFilterByContentDivTree(filterByType) {
	clearTreeNodes(filterByContentTree);
	
	filterByContentTree = new dhtmlXTreeObject("filterByContentbox_tree","100%","100%","0","hidden");
	filterByContentTree.setImagePath(BASE_DIRECTORY);
	filterByContentTree.setIconSize(13,13);
	filterByContentTree.enableTreeLines(false);
	filterByContentTree.setOnLoadingStart(startLoading);
	filterByContentTree.setOnLoadingEnd(endLoading);
	filterByContentTree.enableCheckBoxes(1);
	filterByContentTree.enableThreeStateCheckboxes(true);
	filterByContentTree.loadingDivName = "filterByContentDivLoading";
	filterByContentTree.setXMLAutoLoading(BASE_DIRECTORY + "search/view/filterByContentTreeXML.jsp?filterByType=" + filterByType);
	filterByContentTree.loadXML(BASE_DIRECTORY + "search/view/filterByContentTreeXML.jsp?filterByType=" + filterByType);
}

function setImageTd(id, selected) {
	var imageTd = document.getElementById(id + "ImageTd");
	if(imageTd) {
		if(selected) {
			imageTd.className = "SEARCH_FILTER_BY_TYPE_MENU_ITEM_CELL SEARCH_SELECTED_FILTER_BY_TYPE_MENU_ITEM";
			replaceDivContent(id + "ImageTd", "<img src='" + BASE_DIRECTORY + "images/search/header/filterByTypeSelected.gif' border='0'>");
		}else {
			imageTd.className = "SEARCH_FILTER_BY_TYPE_MENU_ITEM_CELL";
			replaceDivContent(id + "ImageTd", "&nbsp;");
		}
	}
}

function openSearchDivs(isEmptySearch) {
	var searchDivsContainer = document.getElementById("searchDivsContainer");
	if(searchDivsContainer) {
		if(searchDivsContainer.style.display == "") {
			searchDivsContainer.style.display = "none";
		}else {
			if(isEmptySearch && isEmptySearch == "true") {
				if(document.all) {
					searchDivsContainer.style.width = $("#searchHeaderCell").width() - 4;
				}else {
					searchDivsContainer.style.width = $("#searchHeaderCell").width() - 2;
				}
				searchDivsContainer.style.left = "0px";
				searchDivsContainer.style.top = "104px";
				
				searchDivsContainer.style.display = "";
			}else {
				var width = $("#searchHeaderTextBoxCell").width();
				if(width) {
					searchDivsContainer.style.width = width + "px";
				}
				var position = $("#searchHeaderTextBoxCell").position();
				if(position) {
					searchDivsContainer.style.left = position.left + "px";
				}
				searchDivsContainer.style.display = "";
			}
		}
	}
}

function goSavedSearch(searchTerm) {
	doSearchHistory(searchTerm);
}