var searchMainTableActionsSlidingDivInterval;

function onAfterMainTableDivResponseLoaded() {
	setTimeout("hideSearchMainTableActionsSlidingDiv()", 100);
}

function showPrevResultsGroup() {
	var params = "action=showPrevResultsGroup";
	params += "&divIds=" + MAIN_TABLE_DIV_ID;
	updateSearchModel(params);
}

function showPrevResults() {
	var params = "action=showPrevResults";
	params += "&divIds=" + MAIN_TABLE_DIV_ID;
	updateSearchModel(params);
}

function showNextResults() {
	var params = "action=showNextResults";
	params += "&divIds=" + MAIN_TABLE_DIV_ID;
	updateSearchModel(params);
}

function showNextResultsGroup() {
	var params = "action=showNextResultsGroup";
	params += "&divIds=" + MAIN_TABLE_DIV_ID;
	updateSearchModel(params);
}

function showPageResults(pageNumber) {
	var params = "action=showPageResults";
	params += "&divIds=" + MAIN_TABLE_DIV_ID + "&pageNumber=" + pageNumber;
	updateSearchModel(params);
}

function setMainTableRowClass(rowId, className) {
	setElementClass(rowId, className);
}

function isPagingAction(action) {
	return action && (action == "showPrevResultsGroup" || 
			  		  action == "showPrevResults" ||
			  		  action == "showNextResults" ||
			  		  action == "showNextResultsGroup" ||
			  		  action == "showPageResults")
}

function onPagingAction() {
	showDivLoadingImage(MAIN_TABLE_DIV_ID);
	scrollToTop();
}

function onAfterPagingAction(responseElement) {
	loadDivDataLight(MAIN_TABLE_DIV_ID);
	
	var runningMode = responseElement.getAttribute("runningMode");
	if(runningMode != "0") {
		activateSearchViewUpdater();
	}
}

function initMainTableActionsDivsPositions() {
	var searchMainTableActionsUpperDiv = document.getElementById("searchMainTableActionsUpperDiv");
	if(searchMainTableActionsUpperDiv) {
		var left = findPosX(searchMainTableActionsUpperDiv);
		var top = findPosY(searchMainTableActionsUpperDiv);
		if(document.all) {
			left -= 2;
			top += 2;
		}else {
			left -= 12;
			top += 1;
		}
		left = left + "px";
		top = top + "px";
		
		var searchMainTableActionsSlidingDiv = document.getElementById("searchMainTableActionsSlidingDiv");
		if(searchMainTableActionsSlidingDiv) {
			searchMainTableActionsSlidingDiv.style.left = left;
			searchMainTableActionsSlidingDiv.style.top = top;
			searchMainTableActionsSlidingDiv.style.width = "0px";
			searchMainTableActionsSlidingDiv.style.paddingTop = "";
			searchMainTableActionsSlidingDiv.style.paddingLeft = "";
			searchMainTableActionsSlidingDiv.style.paddingBottom = "";
		}
	}
}

function showSearchMainTableActionsSlidingDiv(text) {
	if(searchMainTableActionsSlidingDivInterval) {
		clearInterval(searchMainTableActionsSlidingDivInterval);
		searchMainTableActionsSlidingDivInterval = null;
	}
	var searchMainTableActionsSlidingDiv = document.getElementById("searchMainTableActionsSlidingDiv");
	if(searchMainTableActionsSlidingDiv) {
		searchMainTableActionsSlidingDiv.style.paddingTop = "3px";
		searchMainTableActionsSlidingDiv.style.paddingLeft = "10px";
		searchMainTableActionsSlidingDiv.style.paddingBottom = "3px";
		searchMainTableActionsSlidingDivInterval = showSlidingDiv("slideExpand", "searchMainTableActionsSlidingDiv", "searchMainTableActionsUpperDiv", text, "left", 200, 2, 10);
	}
}

function hideSearchMainTableActionsSlidingDiv() {
	if(searchMainTableActionsSlidingDivInterval) {
		clearInterval(searchMainTableActionsSlidingDivInterval);
		searchMainTableActionsSlidingDivInterval = null;
	}
	initMainTableActionsDivsPositions();
}

function toggleDashboardAnalysis(dashboardAnalysisActive) {
	hideSearchMainTableActionsSlidingDiv();
	
	var params = "action=toggleDashboardAnalysis&dashboardAnalysisActive=" + dashboardAnalysisActive
	updateSearchModel(params);
}

function toggleEventsCollapsed(eventsCollapsed) {
	hideSearchMainTableActionsSlidingDiv();
	
	var params = "action=toggleEventsCollapsed&eventsCollapsed=" + eventsCollapsed
	updateSearchModel(params);
}

function toggleEventCollapsed(rowId, eventCollapsed) {
	var recordCell = document.getElementById(rowId + "RecordCell");
	var shortRecordCell = document.getElementById(rowId + "ShortRecordCell");
	if(recordCell && shortRecordCell) {
		if(eventCollapsed == "true") {
			recordCell.style.display = "none";
			shortRecordCell.style.display = "";
		}else {
			recordCell.style.display = "";
			shortRecordCell.style.display = "none";
		}
	}
}

function showMainTableRowActionsCell(rowId, doShow) {
	var mainTableRowActionsListCell = document.getElementById("mainTableRowActionsListCell" + rowId);
	if(mainTableRowActionsListCell) {
		if(doShow == 'true') {
			mainTableRowActionsListCell.style.visibility = "visible";
		}else {
			mainTableRowActionsListCell.style.visibility = "hidden";
		}
	}
}

function openRecordsPerPageMenu(isHeader) {
	var searchRecordsPerPageDiv = document.getElementById("searchRecordsPerPageDiv");
	if(searchRecordsPerPageDiv) {
		if(isHeader == "true") {
			searchRecordsPerPageDiv.className = "SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_CONTAINER_HEADER";
			searchRecordsPerPageDiv.style.top = "400px";
			searchRecordsPerPageDiv.style.bottom = "";
		}else {
			searchRecordsPerPageDiv.className = "SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_CONTAINER_FOOTER";
			searchRecordsPerPageDiv.style.top = "";
			searchRecordsPerPageDiv.style.bottom = (40 - document.body.scrollTop) + "px";
		}
		
		if(searchRecordsPerPageDiv.style.display == "") {
			searchRecordsPerPageDiv.style.display = "none";
		}else {
			searchRecordsPerPageDiv.style.display = "";
		}
	}
}

function closeRecordsPerPageMenu() {
	var searchRecordsPerPageDiv = document.getElementById("searchRecordsPerPageDiv");
	if(searchRecordsPerPageDiv) {
		searchRecordsPerPageDiv.style.display = "none";
	}
}

function setRecordsPerPage(recordsPerPage) {
	var recordsPerPageElement = document.getElementById("recordsPerPage");
	if(recordsPerPageElement && (recordsPerPageElement.value != recordsPerPage)) {
		recordsPerPageElement.value = recordsPerPage;
		
		var params = "action=changeRecordsPerPage&recordsPerPage=" + recordsPerPage;
		updateSearchModel(params);
	}
	closeRecordsPerPageMenu();
}

function setRecordsPerPageMenuItemClass(itemId, className) {
	setElementClass(itemId, className);
}