<%@ page language="java"%>

<%@ page import="java.util.Date"%>

<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.search.data.SearchDataModelMeta"%>
<%@ page import="xpolog.eye.search.data.impl.records.SearchDataModelRecordsMeta"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";

try {
SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);
SearchResult currentResult = model.getCurrentResult();
SearchDataModelMeta meta = null;
if(currentResult != null && currentResult.getTableDataModel() != null && currentResult.getTableDataModel().getDataModel() != null) {
	meta = currentResult.getTableDataModel().getDataModel().getMetaData();
}

int runningMode = model.getRunningMode();
boolean logsResultsRunning = runningMode == SearchRunner.ALL_RUNNING || runningMode == SearchRunner.LOGS_RESULTS_RUNNING;


String minDateString = "";
String maxDateString = "";
String timeStr = "";
DateFilter dateFilter = model.getTimeFilter();
if(dateFilter != null) {
	Date minDate = dateFilter.getMinDate();
	Date maxDate = dateFilter.getMaxDate();
	
	minDateString = DateUtil.transformDateToString(minDate);
	int minIndex = minDateString.indexOf(" ");
	String minDateShortString = minDateString.substring(0, minIndex);
	String minTimeString = minDateString.substring(minIndex + 1);
	if(minTimeString.indexOf(":") != minTimeString.lastIndexOf(":")) {
		minTimeString = minTimeString.substring(0, minTimeString.lastIndexOf(":"));
	}
	
	maxDateString = DateUtil.transformDateToString(maxDate);
	int maxIndex = maxDateString.indexOf(" ");
	String maxDateShortString = maxDateString.substring(0, maxIndex);
	String maxTimeString = maxDateString.substring(maxIndex + 1);
	if(maxTimeString.indexOf(":") != maxTimeString.lastIndexOf(":")) {
		maxTimeString = maxTimeString.substring(0, maxTimeString.lastIndexOf(":"));
	}
	
	timeStr = "from ";
	timeStr += (minDateShortString + " " + minTimeString);
	timeStr += " to ";
	timeStr += (maxDateShortString + " " + maxTimeString);
}else {
	timeStr = "from all time";
}

String matchingEventsStr = "";
long totalRecords = currentResult.getRootNodeResultElement().getSearchTermFrequency();
if(totalRecords >= 0) {
	int numberOfLogs = currentResult.getNumberOfLogsMatched();
	String logsStr = "logs";
	if(numberOfLogs == 1) {
		logsStr = "log";
	}
	matchingEventsStr = "Found " + totalRecords + " matching log events in " + numberOfLogs + " " + logsStr;
}else {
	matchingEventsStr = "No matching events were found";
}

response.setContentType("text/html; charset=UTF-8");
%>

<table border="0" cellpadding="0" cellspacing="0" style="height:20px; width: 100%">
	<tr height="10px">
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr class="SEARCH_MAIN_TABLE_TITLE_ROW">
					<td class="SEARCH_MAIN_TABLE_TITLE_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td>
									<span class="SEARCH_MAIN_TABLE_TITLE_BIG_TEXT"><%=matchingEventsStr %></span>
									<span class="SEARCH_MAIN_TABLE_TITLE_SMALL_TEXT"><%=timeStr %></span>
								</td>
								<td id="searchMainTablePagingSectionCellHeader" class="SEARCH_MAIN_TABLE_PAGING_CELL">
									<jsp:include page="searchMainTablePagingSection.jsp" flush="true">
										<jsp:param name="isHeader" value="true"/>
									</jsp:include>
								</td>
								<td class="empty">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
<%
if(meta != null) {
	if(meta instanceof SearchDataModelRecordsMeta) {
		request.setAttribute(SEARCH_MODEL, model);
		request.setAttribute("minDateString", minDateString);
		request.setAttribute("maxDateString", maxDateString);
%>
	<jsp:include page="searchMainTableEvents.jsp" flush="true" />
<%
	}else {
		request.setAttribute(SEARCH_MODEL, model);
		request.setAttribute("meta", meta);
%>
	<jsp:include page="searchMainTableRows.jsp" flush="true" />
<%
	}
}else {
	String message = "No data was found";
	if(logsResultsRunning) {
		message = "Fetching data...";
	}
	String currentStatus = model.getCurrentStatus();
	if(currentStatus != null && currentStatus.length() > 0) {
		message = currentStatus;
	}
%>
				<tr>
					<td class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_HEADER_CELL"><%=message %></td>
				</tr>
<%
}
%>
				<tr class="SEARCH_MAIN_TABLE_FOOTER_ROW">
					<td class="SEARCH_MAIN_TABLE_FOOTER_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td>
									<span class="SEARCH_MAIN_TABLE_FOOTER_BIG_TEXT"><%=matchingEventsStr %></span>
									<span class="SEARCH_MAIN_TABLE_FOOTER_SMALL_TEXT"><%=timeStr %></span>
								</td>
								<td id="searchMainTablePagingSectionCellFooter" class="SEARCH_MAIN_TABLE_PAGING_CELL">
									<jsp:include page="searchMainTablePagingSection.jsp" flush="true">
										<jsp:param name="isHeader" value="false"/>
									</jsp:include>
								</td>
								<td class="empty">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="empty">&nbsp;</td>
	</tr>
</table>
<%
}catch(Exception e) {
	ErrorModel.log.error("An error occured in searchMainTable.jsp", e);
}
%>