<%@ page language="java"%>

<%!
static final String BASE_DIRECTORY = "../../";
public static final DecimalFormat DEFAULT_NUMBER_FORMAT = new DecimalFormat("#.##");
%>

<%@ page import="java.text.DecimalFormat"%>
<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.source.DataReference"%>
<%@ page import="xpolog.eye.data.Record"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataProcessing"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataRequest"%>
<%@ page import="xpolog.eye.knowledge.helpers.KnowledgeLogHelper"%>
<%@ page import="xpolog.eye.knowledge.KnowledgeResponse"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.search.data.SearchDataMetaColumnInfo"%>
<%@ page import="xpolog.eye.search.data.SearchDataModelEvent"%>
<%@ page import="xpolog.eye.search.data.SearchDataModelMeta"%>
<%@ page import="xpolog.eye.search.data.impl.overtime.SearchDataModelOverTimeMeta"%>
<%@ page import="xpolog.eye.search.data.impl.overtime.SearchDataModelSlotEvent"%>
<%@ page import="xpolog.eye.search.data.impl.records.SearchDataModelRecordEvent"%>
<%@ page import="xpolog.eye.search.data.impl.table.SearchResultTableDataRow"%>
<%@ page import="xpolog.eye.search.ui.*"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.SearchManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>

<%
String SEARCH_MODEL = "SearchModel";
try {
SearchModel model = (SearchModel)request.getAttribute(SEARCH_MODEL);
SearchResult currentResult = model.getCurrentResult();
SearchDataModelMeta meta = (SearchDataModelMeta)request.getAttribute("meta");

int runningMode = model.getRunningMode();
boolean logsResultsRunning = runningMode == SearchRunner.ALL_RUNNING || runningMode == SearchRunner.LOGS_RESULTS_RUNNING;

response.setContentType("text/html; charset=UTF-8");

List currentPageEvents = currentResult == null || currentResult.getTableDataModel() == null ? null : currentResult.getTableDataModel().getCurrentPageEvents();
if(currentPageEvents != null && currentPageEvents.size() > 0) {
	SearchDataMetaColumnInfo[] columns = meta.getColumns();
	SearchDataMetaColumnInfo column = null;
%>

<tr>
	<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
<%
	if(meta instanceof SearchDataModelOverTimeMeta) {
%>
				<td class="SEARCH_MAIN_TABLE_DATA_GENERAL_CELL SEARCH_MAIN_TABLE_DATA_HEADER_CELL">Time</td>
<%		
	}

	for(int i = 0; i < columns.length; i++) {
		column = columns[i];
%>

				<td class="SEARCH_MAIN_TABLE_DATA_GENERAL_CELL SEARCH_MAIN_TABLE_DATA_HEADER_CELL <%=i == columns.length - 1 ? "SEARCH_MAIN_TABLE_DATA_RIGHT_CELL" : ""%>"><%=column.getColumnName() %></td>
<%
	}
%>
			</tr>
<%	
	SearchDataModelEvent dataEvent = null;
	SearchResultTableDataRow dataRow = null;
	SearchDataModelSlotEvent dataSlot = null;
	
	String rowClassName = null;
	String rowId = null;
	long startTime = currentResult.getStartTime();
	long endTime = currentResult.getEndTime();
	
	for(int i = 0; i < currentPageEvents.size(); i++) {
		dataEvent = (SearchDataModelEvent)currentPageEvents.get(i);
		if(dataEvent instanceof SearchResultTableDataRow) {
			dataRow = (SearchResultTableDataRow)dataEvent;
		}else if(dataEvent instanceof SearchDataModelSlotEvent) {
			dataSlot = (SearchDataModelSlotEvent)dataEvent;
		}
		
		rowId = "mainTableRow_" + i;
		
		if(i % 2 == 0) {
			rowClassName = "SEARCH_MAIN_TABLE_DATA_COLORED_ROW";
		}else {
			rowClassName = "SEARCH_MAIN_TABLE_DATA_REGULAR_ROW";
		}
%>

			<tr id="<%=rowId %>" class="<%=rowClassName %>">
<%
		if(dataSlot != null) {
			Date startDate = new Date(dataSlot.getStartTime());
			String startDateStr = DateUtil.sdf.format(startDate);
%>
				<td class="SEARCH_MAIN_TABLE_DATA_GENERAL_CELL"><%=startDateStr %></td>
<%
		}
		for(int j = 0; j < columns.length; j++) {
			String value = "";
			if(dataRow != null) {
				Object obj = dataRow.getValueAt(j);
				if(obj instanceof Number) {
					obj = DEFAULT_NUMBER_FORMAT.format(((Number)obj).doubleValue());
				}
				value = obj.toString();
			}else if(dataSlot != null) {
				Object obj = dataSlot.getValueAt(j);
				if(obj instanceof Number) {
					obj = DEFAULT_NUMBER_FORMAT.format(((Number)obj).doubleValue());
				}
				value = obj.toString();
			}
			value = WebUtil.doHTMLEncoding(value);
			
%>
				<td class="SEARCH_MAIN_TABLE_DATA_GENERAL_CELL <%=j == columns.length - 1 ? "SEARCH_MAIN_TABLE_DATA_RIGHT_CELL" : ""%>"><%=value %></td>
<%
		}
%>
			</tr>
<%
	}
	int colspan = columns.length;
	if(meta instanceof SearchDataModelOverTimeMeta) {
		colspan += 1;
	}
%>
			<tr height="1px">
				<td class="SEARCH_MAIN_TABLE_DATA_BOTTOM_CELL" colspan="<%=colspan %>">&nbsp;</td>
			</tr>
		</table>
	</td>
</tr>
<%
}else {
	String message = "No matching data was found";
	if(logsResultsRunning) {
		message = "Fetching data...";
	}
%>
<tr>
	<td class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_HEADER_CELL"><%=message %></td>
</tr>
<%
}
}catch(Exception e) {
	ErrorModel.log.error("An error occured in searchMainTableRows.jsp", e);
}
%>