<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.data.index.SearchEngineConfiguration"%>
<%@ page import="xpolog.eye.data.index.SearchEngineConfigurationHelper"%>
<%@ page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.search.AutoCompleteCacheRequest"%>
<%@ page import="xpolog.eye.search.SavedSearch"%>
<%@ page import="xpolog.eye.search.SearchContextFilter"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.search.SearchModelHelper"%>
<%@ page import="xpolog.eye.search.ui.SearchNode"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>
<%
	String SEARCH_MODEL = "SearchModel";
	String STATUS_OK = "0";
	String STATUS_NO_ACTION = "1";

	WebSecurityManager securityManager = WebSecurityManager.getInstance();

	UserSecurity user = securityManager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

	String resetModelStr = request.getParameter("resetModel");
	boolean resetModel = resetModelStr != null && resetModelStr.equals("true");
	
	SearchModel model = (SearchModel) session.getAttribute(SEARCH_MODEL);
	if (resetModel && model != null) {
		model.reset();
		model = null;
	}
	if (model == null) {
		model = new SearchModel(true);
		SearchEngineConfiguration searchEngineConfiguration = SearchEngineManager.getInstance().getConfiguration();
		DateFilter defaultDisplayDateFilter = SearchEngineConfigurationHelper.getDefaultDisplayDateFilter(model, searchEngineConfiguration);

		model.setTimeFilter(defaultDisplayDateFilter);
		model.setViewBy(searchEngineConfiguration.getViewBy());
		model.setUserContext(userContext);
		
		session.setAttribute(SEARCH_MODEL, model);
	}

	String status = STATUS_OK;

	String action = request.getParameter("action");
	if (action != null) {
		boolean doUpdateModel = false;
		boolean doUpdateCurrentResult = false;
		boolean isRefresh = false;
		boolean writeAudit = true;
		boolean refreshSearchHistory = false;
		
		boolean isEmptySearchTerm = false;
		String searchTerm = request.getParameter("searchTerm");
		if (searchTerm != null) {
			searchTerm = searchTerm.trim();
		}
		if (searchTerm != null && searchTerm.length() > 0) {
			searchTerm = SearchViewHelper.updateModelBySavedSearch(searchTerm, userContext, model);
			
			model.setSearchTerm(searchTerm);
		}else {
			isEmptySearchTerm = true;
		}
		if (action.equals(SearchModel.ACTION_LOAD_DATA)) {
			//doUpdateModel = !model.hasLogsResults();
		} else if (action.equals(SearchModel.ACTION_SEARCH)) {
			model.clearZoomInDateFilters();
			doUpdateModel = true;
			refreshSearchHistory = true;
		} else if (action.equals(SearchModel.ACTION_REFRESH_DATA)) {
			doUpdateModel = true;
			isRefresh = true;
		} else if (action.equals(SearchModel.ACTION_CHANGE_VIEW_BY)) {
			String viewBy = request.getParameter("viewBy");
			if (viewBy != null && viewBy.length() > 0) {
				model.setViewBy(viewBy);
				//doUpdateModel = true;
			}
		} else if (action.equals(SearchModel.ACTION_CHANGE_VIEW_TYPE)) {
			String viewType = request.getParameter("viewType");
			if (viewType != null && viewType.length() > 0) {
				model.setViewType(viewType);
				writeAudit = false;
			}
		} else if (action.equals(SearchModel.ACTION_CHANGE_VIEW_GROUP_TYPE)) {
			String viewGroupType = request.getParameter("viewGroupType");
			if (viewGroupType != null && viewGroupType.length() > 0) {
				model.setViewGroupType(viewGroupType);
				writeAudit = false;
			}
		} else if (action.equals(SearchModel.ACTION_SET_CURRENT_NODE)) {
			String id = request.getParameter("id");
			if (id != null && id.length() > 0) {
				model.setCurrentNode(id);
				doUpdateCurrentResult = true;
			}
		} else if (action.equals(SearchModel.ACTION_ZOOM_IN_CALENDAR)) {
			model.zoomInCalendar();
			doUpdateModel = true;
		} else if (action.equals(SearchModel.ACTION_ZOOM_OUT_CALENDAR)) {
			model.zoomOutCalendar();
			doUpdateModel = true;
		} else if (action.equals(SearchModel.ACTION_CHANGE_FIXED_INTERVAL)) {
			String fixedInterval = request.getParameter("fixedInterval");
			String roundMinTimeToZeroStr = request.getParameter("roundMinTimeToZero");
			boolean roundMinTimeToZero = roundMinTimeToZeroStr != null && roundMinTimeToZeroStr.equals("true");
			if (fixedInterval != null && fixedInterval.length() > 0) {
				model.setFixedInterval(fixedInterval, roundMinTimeToZero);
				if(!isEmptySearchTerm) {
					doUpdateModel = true;
				}
			}
		} else if (action.equals(SearchModel.ACTION_CHANGE_CALENDAR)) {
			String searchMinDateStr = request.getParameter("searchMinDateStr");
			String searchMaxDateStr = request.getParameter("searchMaxDateStr");
			String searchMinTimeStr = request.getParameter("searchMinTimeStr");
			String searchMaxTimeStr = request.getParameter("searchMaxTimeStr");
			if (searchMinDateStr != null && searchMinDateStr.length() > 0 && searchMaxDateStr != null
					&& searchMaxDateStr.length() > 0 && searchMinTimeStr != null && searchMinTimeStr.length() > 0
					&& searchMaxTimeStr != null && searchMaxTimeStr.length() > 0) {
				searchMinDateStr += (" " + searchMinTimeStr);
				searchMaxDateStr += (" " + searchMaxTimeStr);
				boolean evenIfNull = model.getFixedInterval().equals(DateUtil.FIXED_INTERVAL_ALL_DATA);
				model.updateTimeFilter("MM/dd/yyyy HH:mm", searchMinDateStr, searchMaxDateStr, evenIfNull);
				if(!isEmptySearchTerm) {
					doUpdateModel = true;
				}
			}
		} else if (action.equals(SearchModel.ACTION_ZOOM_IN_GRAPH)) {
			String startTimestampStr = request.getParameter("startTimestamp");
			String endTimestampStr = request.getParameter("endTimestamp");
			if (startTimestampStr != null && startTimestampStr.length() > 0 && endTimestampStr != null && endTimestampStr.length() > 0) {
				model.zoomInGraph(startTimestampStr, endTimestampStr);
				doUpdateModel = true;
			}
			writeAudit = false;
		} else if (action.equals(SearchModel.ACTION_ZOOM_OUT_GRAPH)) {
			model.zoomOutGraph();
			doUpdateModel = true;
			writeAudit = false;
		} else if (action.equals(SearchModel.ACTION_PREVIOUS_GRAPH_TIME)) {
			model.previousGraphTime();
			doUpdateModel = true;
		} else if (action.equals(SearchModel.ACTION_NEXT_GRAPH_TIME)) {
			model.nextGraphTime();
			doUpdateModel = true;
		} else if (action.equals(SearchModel.ACTION_CHANGE_RECORDS_PER_PAGE)) {
			String recordsPerPageStr = request.getParameter("recordsPerPage");
			if(recordsPerPageStr != null) {
				try {
					int recordsPerPage = Integer.parseInt(recordsPerPageStr);
					model.setRecordsPerPage(recordsPerPage);
					doUpdateCurrentResult = true;
				}catch(Exception e) {
				}
			}
		} else if (action.equals(SearchModel.ACTION_TOGGLE_DASHBOARD_ANALYSIS)) {
			String dashboardAnalysisActiveStr = request.getParameter("dashboardAnalysisActive");
			boolean dashboardAnalysisActive = dashboardAnalysisActiveStr != null && dashboardAnalysisActiveStr.equals("true");
			model.setDashboardAnalysisActive(dashboardAnalysisActive);
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_TOGGLE_EVENTS_COLLAPSED)) {
			String eventsCollapsedStr = request.getParameter("eventsCollapsed");
			boolean eventsCollapsed = eventsCollapsedStr != null && eventsCollapsedStr.equals("true");
			model.setEventsCollapsed(eventsCollapsed);
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SELECT_MAIN_TABLE_NODE)) {
			String id = request.getParameter("id");
			String type = request.getParameter("type");
			if (id != null && id.length() > 0 && type != null && type.length() > 0) {
				model.addSelectedNode(id, type);
			}
			writeAudit = false;
		} else if (action.equals(SearchModel.ACTION_UNSELECT_MAIN_TABLE_NODE)) {
			String id = request.getParameter("id");
			String type = request.getParameter("type");
			if (id != null && id.length() > 0 && type != null && type.length() > 0) {
				model.removeSelectedNode(id, type);
			}
			writeAudit = false;
		} else if (action.equals(SearchModel.ACTION_ZOOM_INTO_ELEMENT)) {
			String id = request.getParameter("id");
			String name = request.getParameter("name");
			String type = request.getParameter("type");
			
			if (id != null && id.length() > 0 && name != null && name.length() > 0 && type != null && type.length() > 0) {
				SearchNode newNode = new SearchNode(id, name, type);
				model.addNode(newNode);
				doUpdateModel = true;
				String startTimestampStr = request.getParameter("startTimestamp");
				String endTimestampStr = request.getParameter("endTimestamp");
				if (startTimestampStr != null && startTimestampStr.length() > 0 && endTimestampStr != null && endTimestampStr.length() > 0) {
					model.zoomInGraph(startTimestampStr, endTimestampStr);
				}
				/*HealthViewNode rootNode = model.getCurrentResult().getRootNode();
				if(rootNode != null && rootNode.getType().equals(XpoLogObjectTypes.HOST_TYPE)) {
					if(model.getCurrentResult().getResultElements() == null || model.getCurrentResult().getResultElements().isEmpty()) {
						writeAudit = false;
					}
				}*/
			}
		} else if (action.equals(SearchModel.ACTION_ZOOM_OUT_OF_ELEMENT)) {
			model.removeLastNode();
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SHOW_PREV_RESULTS_GROUP)) {
			model.decreaseCurrentRecordsPageGroup();
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SHOW_PREV_RESULTS)) {
			model.decreaseCurrentRecordsPage();
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SHOW_NEXT_RESULTS)) {
			model.increaseCurrentRecordsPage();
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SHOW_NEXT_RESULTS_GROUP)) {
			model.increaseCurrentRecordsPageGroup();
			doUpdateCurrentResult = true;
		} else if (action.equals(SearchModel.ACTION_SHOW_PAGE_RESULTS)) {
			String pageNumberStr = request.getParameter("pageNumber");
			try {
				int pageNumber = Integer.parseInt(pageNumberStr);
				model.setCurrentRecordsPage(pageNumber);
				doUpdateCurrentResult = true;
			}catch(Exception e) {
				
			}
		} else if (action.equals(SearchModel.ACTION_ACTIVATE_FILTER_BY)) {
			String filterBy = request.getParameter("filterBy");
			if(filterBy != null && filterBy.length() > 0) {
				model.setViewBy(filterBy);
			}
			SearchContextFilter contextFilter = SearchModelHelper.getSearchContextFilter(request, userContext, filterBy);
			model.setContextFilter(contextFilter);
			
			doUpdateModel = true;
		} else if (action.equals(SearchModel.ACTION_CLEAR_FILTER_BY)) {
			model.getContextFilter().reset();
			doUpdateModel = true;
		}

		if (doUpdateModel) {
			model.updateModel(action, userContext);
		} else if (doUpdateCurrentResult) {
			model.updateCurrentResult(action, userContext);
		}
		
		if(writeAudit && !isEmptySearchTerm) {
			String datesString = "";
			if(model.getTimeFilter() != null) {
				String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
				SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
				String minDateStr = sdf.format(model.getTimeFilter().getMinDate());
				String maxDateStr = sdf.format(model.getTimeFilter().getMaxDate());
				datesString = minDateStr + "-" + maxDateStr;
			}else {
				datesString = "all data";
			}
			StringBuffer auditMessage = new StringBuffer();
			auditMessage.append(", search term is " + searchTerm);
			
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					userContext, AuditConstants.VIEW, "update search model", AuditConstants.SEARCH_ENGINE, "search model was updated, action is " + action + ", dates range is " + datesString + auditMessage.toString());
			
		}
		
		if(refreshSearchHistory) {
			// update search history autocomplete cache
			AutoCompleteCacheRequest autoCompleteCacheRequest = new AutoCompleteCacheRequest();
			autoCompleteCacheRequest.setUserContext(userContext);
			autoCompleteCacheRequest.setIncludeSearchHistory(true);
			
			SearchViewHelper.createAutoCompleteCache(session, autoCompleteCacheRequest);
		}
	} else {
		status = STATUS_NO_ACTION;
	}

	String divIds = request.getParameter("divIds");
	if (divIds == null) {
		divIds = "";
	}
	
	String fixedInterval = model.getFixedInterval();
	
	boolean isEmptySearch = model.getSearchTerm() == null || model.getSearchTerm().equals("");
	boolean isErrorQuery = model.isErrorQuery();
	String errorTitle = model.getErrorTitle();
	errorTitle = WebUtil.doHTMLEncoding(errorTitle);
	String errorMessage = model.getErrorMessage();
	errorMessage = WebUtil.doHTMLEncoding(errorMessage);
	String errorQuery = model.getErrorQuery();
	errorQuery = WebUtil.doHTMLEncoding(errorQuery);
	if(errorQuery == null) {
		errorQuery = "";
	}
	
	response.setContentType("text/xml; charset=UTF-8");
%>

<SearchViewResponse>
	<Response status="<%=status %>" action="<%=action %>" divIds="<%=divIds %>" viewBy="<%=model.getViewBy() %>" viewType="<%=model.getViewType() %>" rootNodeId="<%=model.getCurrentNode().getId() %>" rootNodeType="<%=model.getCurrentNode().getType() %>" fixedInterval="<%=fixedInterval %>" runningMode="<%=model.getRunningMode() %>" isEmptySearch="<%=isEmptySearch %>" isErrorQuery="<%=isErrorQuery %>" errorTitle="<%=errorTitle %>" errorMessage="<%=errorMessage %>" errorQuery="<%=errorQuery %>">
	</Response>
</SearchViewResponse>