<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);



  ErrorModel errmodel = new ErrorModel();

  if (security == null){
    errmodel.addError("This operation can't be done.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  String memberId = request.getParameter("id");
  if (memberId == null || memberId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }



  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "security/common/moduleMemberSetOK.jsp";
  }
  
  SiteManagment mgt = SiteManagment.getInstance();
	String memberType = request.getParameter("type");
  XpologNode member = mgt.getXpologNode(memberId,memberType);
  if (member == null){
    errmodel.addError("No permissions entity was found for id - " + memberId);
  }
	
	 if ( !security.isEditable(member)){
    response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp");
    return;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

  XpologNode parent = mgt.getParentXpologNode(member);

  ModuleMemberPermissions currPermission = member.getPermissions();
  ModuleMemberPermissions permissions = mgt.getAllPermissions();

  
  
  if (currPermission != null){
	  request.setAttribute("currPermission",currPermission);
  }
  if (permissions != null){
	  request.setAttribute("permissions",permissions);
  }

  String resetURL = "security/common/moduleMemberPermissions.jsp?id=" + memberId;  
  String actionURL = "security/common/moduleMemberPermissionsAction.jsp";
  memberType = memberType == null ? "" : memberType;
  String name = member == null ? "" : member.getName();
  String parentName = parent == null ? "" : parent.getName();
  boolean ignoreParent = parent == null;
%>

<jsp:forward page="moduleMemberPermissionsIncluder.jsp">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="id" value="<%=memberId%>"/>
 <jsp:param name="type" value="<%=memberType%>"/>
 <jsp:param name="memberName" value="<%=name%>"/>
 <jsp:param name="parentName" value="<%=parentName%>"/>
 <jsp:param name="actionURL" value="<%=actionURL%>"/>
 <jsp:param name="resetURL" value="<%=resetURL%>"/>
 <jsp:param name="forwardURL" value="<%=forwardURL%>"/>
 <jsp:param name="parentExists" value="<%=forwardURL%>"/>
 <jsp:param name="ignoreParent" value="<%=ignoreParent%>"/>
</jsp:forward>

