<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  ErrorModel errmodel = new ErrorModel();
  String memberId = request.getParameter("id");
  if (memberId == null || memberId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }

  SiteManagment mgt = SiteManagment.getInstance();
	String memberType = request.getParameter("type");

  XpologNode member = mgt.getXpologNode(memberId,memberType);
  if (member == null){
    errmodel.addError("No permissions entity was found for id - " + memberId);
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }
  member = (XpologNode)member.clone();
  ModuleMemberPermissions permissions = null;
  String permissionsPolicy = request.getParameter("memberPolicy");
  if (permissionsPolicy != null && permissionsPolicy.equals("current")){
    ModuleMemberPermissions orgPermissions = member.getPermissions();
    Collection orgEditMembers = orgPermissions != null ? orgPermissions.getEditMembers() : null;
    Collection orgViewMembers = orgPermissions != null ? orgPermissions.getViewMembers() : null;
    Collection nonAdministeredEditMembers = null;
    Collection nonAdministeredViewMembers = null;
    if (orgEditMembers != null){
    	nonAdministeredEditMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgEditMembers,false));
    }
    permissions = new ModuleMemberPermissions();
    String [] editNames = request.getParameterValues("selectedEditMembersList");
    HashSet editNamesCol = new HashSet();
		if (editNames != null && editNames.length > 0){
			for (int i=0; i<editNames.length; i++){
				editNamesCol.add(editNames[i]);
			}
		}
		if (nonAdministeredEditMembers != null){
	  	Iterator it = nonAdministeredEditMembers.iterator();
	  	while (it.hasNext()){
	  		XpologPrincipal p = (XpologPrincipal)it.next();
	  		editNamesCol.add(p.getName());
	  	}
		}
		if (!editNamesCol.isEmpty()){
			permissions.setEditMembers(editNamesCol);
		}

    if (orgViewMembers != null){
    	nonAdministeredViewMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgViewMembers,false));
    }
		String [] viewNames = request.getParameterValues("selectedViewMembersList");
    HashSet viewNamesCol = new HashSet();
		if (viewNames != null && viewNames.length > 0){
			for (int i=0; i<viewNames.length; i++){
				viewNamesCol.add(viewNames[i]);
			}
		}
		if (nonAdministeredViewMembers != null){
	  	Iterator it = nonAdministeredViewMembers.iterator();
	  	while (it.hasNext()){
	  		XpologPrincipal p = (XpologPrincipal)it.next();
	  		viewNamesCol.add(p.getName());
	  	}
		}
		if (!viewNamesCol.isEmpty()){
			permissions.setViewMembers(viewNamesCol);
		}
  }

 

  member.setPermissions(permissions);
  try {
    SiteManagment.getAdminInstance().updateXpologNode(member);
  }catch (Exception e){
    //e.printStackTrace();
  }

  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "security/common/moduleMemberSetOK.jsp";
  }
  response.sendRedirect(BASE_DIRECTORY + forwardURL);

%>

