<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%

  String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgt = SiteManagment.getInstance();
  WebSecurityManager manager = WebSecurityManager.getInstance();
  ErrorModel errmodel = new ErrorModel();
  UserSecurity security = manager.getUserSecurity(request);

  
  String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
  if (BASE_DIRECTORY == null){
  	BASE_DIRECTORY = "../../";
  }
  
  String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	XpologNode member = (XpologNode)request.getAttribute("XpologNode");
	XpologNode parent = mgt.getParentXpologNode(member);
  
  ModuleMemberPermissions currPermission = member != null ? member.getPermissions() : (ModuleMemberPermissions)request.getAttribute("currPermission");
  ModuleMemberPermissions permissions = mgt.getAllPermissions();// (ModuleMemberPermissions)request.getAttribute("permissions");
  
  if (permissions == null && currPermission == null){
  	errmodel.addError("No permissions defined.");	
  }
  
  String id = member != null ? member.getId() : request.getParameter("id");
  String memberType = member != null ? member.getType() : request.getParameter("type");
  String resetURL = request.getParameter("resetURL");
  String forwardURL = request.getParameter("forwardURL");
  String actionURL = request.getParameter("actionURL");
  
  String memberName = member != null ? member.getName() : request.getParameter("memberName");
  String parentName = parent != null ? parent.getName() : request.getParameter("parentName");
  
  boolean ignoreParent = request.getParameter("ignoreParent") != null && request.getParameter("ignoreParent").equals("true");
  boolean ignoreName = request.getParameter("ignoreName") != null && request.getParameter("ignoreName").equals("true");
  
  boolean showDefault = request.getParameter("showDefault") != null && request.getParameter("showDefault").equals("true");
  
  if (!embedded){
		if (resetURL == null || resetURL.length() == 0){
			errmodel.addError("No Reset URL.");
		}else {
			resetURL = BASE_DIRECTORY + resetURL;
		}
		
		if (actionURL == null || actionURL.length() == 0){
			errmodel.addError("No action URL.");
		}else {
			actionURL = BASE_DIRECTORY + actionURL;
		}
		
		if (memberName == null || memberName.length() == 0){
			errmodel.addError("No member name.");
		}
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

  XpologGroupMemberPrincipal [] availEditMembers = new XpologGroupMemberPrincipal[0];
  XpologGroupMemberPrincipal [] selectedEditMembers = new XpologGroupMemberPrincipal[0];
  XpologGroupMemberPrincipal [] availViewMembers = new XpologGroupMemberPrincipal[0];
  XpologGroupMemberPrincipal [] selectedViewMembers = new XpologGroupMemberPrincipal[0];

  if (permissions != null){
    Collection editCol = manager.getGroupsMembersByNames(permissions.getEditMembers(),true);
    Collection viewCol = manager.getGroupsMembersByNames(permissions.getViewMembers(),true);
    viewCol.addAll(editCol);
    Collection availableMembersCol = XpologSecurityHelper.getPrincipalsCollectionFromUser(security);
    availViewMembers = availEditMembers = XpologEntitiesHelper.toGroupMembersArray(availableMembersCol);
    Collection userPrincipals = XpologSecurityHelper.getPrincipalsCollectionFromUser(security);
		Collection col;
    if(currPermission != null){
    	col = manager.getGroupsMembersByNames(currPermission.getEditMembers(),false);
    	col.retainAll(userPrincipals);
      selectedEditMembers = XpologEntitiesHelper.toGroupMembersArray(col);
    	col = manager.getGroupsMembersByNames(currPermission.getViewMembers(),false);
    	col.retainAll(userPrincipals);
      selectedViewMembers = XpologEntitiesHelper.toGroupMembersArray(col);
    }else {
      selectedEditMembers = XpologEntitiesHelper.toGroupMembersArray(manager.getGroupsMembersByNames(permissions.getEditMembers(),false));
      selectedViewMembers = XpologEntitiesHelper.toGroupMembersArray(manager.getGroupsMembersByNames(permissions.getViewMembers(),false));
    }
  }


  XpologEntitiesHelper.sort(availEditMembers,true);
  XpologEntitiesHelper.sort(availViewMembers,true);


%>

<%if (!embedded){ %>
<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%}%>
<script>

function doApply(){
  for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
    document.access.selectedEditMembersList.options[j].selected = true;
  }

  for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
    document.access.selectedViewMembersList.options[j].selected = true;
  }
  document.access.submit();
}

function doReset(){
  this.location = "<%=resetURL%>";
}

function doCancel(){
  history.go(-1);
}



function doEditMembersAdd(){
  if(document.access.availableEditMembersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableEditMembersList.options.length;j++){
    if (document.access.availableEditMembersList.options[j].selected){
      var name = document.access.availableEditMembersList.options[j].text;

      var value = document.access.availableEditMembersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.selectedEditMembersList.options.length;i++){
        if(document.access.selectedEditMembersList.options[i].value == value){
          found = true;
          break;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.selectedEditMembersList.options[document.access.selectedEditMembersList.options.length] = option0;
      }
    }
  }
}

function doEditMembersRemove(){
  if(document.access.selectedEditMembersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.selectedEditMembersList.options.length;--i >= 0;){
    if(document.access.selectedEditMembersList.options[i].selected && !(document.access.selectedEditMembersList.options[i].name == "administrators")){
       document.access.selectedEditMembersList.options[i] = null;
    }
  }
}

function doViewMembersAdd(){
  if(document.access.availableViewMembersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableViewMembersList.options.length;j++){
    if (document.access.availableViewMembersList.options[j].selected){
      var name = document.access.availableViewMembersList.options[j].text;

      var value = document.access.availableViewMembersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.selectedViewMembersList.options.length;i++){
        if(document.access.selectedViewMembersList.options[i].value == value){
          found = true;
          break;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.selectedViewMembersList.options[document.access.selectedViewMembersList.options.length] = option0;
      }
    }
  }
}

function doViewMembersRemove(){
  if(document.access.selectedViewMembersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.selectedViewMembersList.options.length;--i >= 0;){
    if(document.access.selectedViewMembersList.options[i].selected){
       document.access.selectedViewMembersList.options[i] = null;
    }
  }
}

function disablePermissions(disable){
   disableList(document.access.availableEditMembersList,disable);
   disableList(document.access.selectedEditMembersList,disable);
   disableList(document.access.availableViewMembersList,disable);
   disableList(document.access.selectedViewMembersList,disable);
}

function disableList(list,disable){
  list.disabled = disable;
  list.selectedIndex = -1;
}

function initPermissions(){
  disablePermissions(<%=(currPermission == null || currPermission.isUsingMetaDataPermissions()) && !ignoreParent?"true" : "false"%>);
}

</script>
<%if (!embedded){ %>
</head>
<body onLoad="javascript:initPermissions();">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=actionURL%>" method="post" style="padding:0;margin:0">
<%}%>
<input type="hidden" name="id" value="<%=id == null ? ""  : id%>">
<input type="hidden" name="type" value="<%=memberType == null ? "" : memberType%>">
<input type="hidden" name="forwardURL" value="<%=forwardURL == null ? "" : forwardURL%>">
<%if(ignoreParent){%>
<input type="hidden" name="memberPolicy" value="<%=currPermission != null && currPermission.isUsingMetaDataPermissions() ? "metadata" : "current" %>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
            	<%if (!embedded){ %>
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Permissions</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3" >&nbsp;</td>
              </tr>
              <%} %>
             </table>
             <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
               <tr>
                   <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <% if (!ignoreName || (!ignoreParent && !showDefault)){ %>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Global</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td width="100%" height="18">
                      <table border="0" width="300">
                        <% if (!ignoreName){ %>
                        <tr>
                          <td width="150"><span class="REGULARTEXT">Name:</span></td>
                          <td width="150">
                            <span class="REGULARTEXT"><%=memberName%> </span></td>                          
                          </tr>
                          <%} %>
                          <%if(!ignoreParent && !showDefault){ %>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Parent Name:</span></td>
                          <td width="150">
                            <span class="REGULARTEXT"><%=parentName == null? "" : parentName%></span></td>                          
                          </tr>
                          <%} %>
                      </table>
                    </td>
                  </tr>
									
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
									<%} %>
                  <%if(!ignoreParent){ %>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Permissions</span><b>&nbsp;</b></td>
                  </tr>
 									<tr>
                    <td width="100%" height="18">
                      <table border="0" width="100%">
                      	<%if(showDefault) { %>
                        <tr>
                    	  	<td>
                            <input type="radio" value="parent" name="memberPolicy" onClick="javascript:disablePermissions(true)" <%=currPermission == null?"checked" : ""%> <%=currPermission != null && currPermission.isUsingMetaDataPermissions() ? "disabled" : ""%>><span class="REGULARTEXT">Use default permissions</span>                            
 			  									</td>
                        </tr>
                        <%}else {%>
                        <tr>
                    	  	<td>
                            <input type="radio" value="parent" name="memberPolicy" onClick="javascript:disablePermissions(true)" <%=currPermission == null?"checked" : ""%> <%=parentName == null ? "disabled" : ""%>><span class="REGULARTEXT">Use parent permissions</span>                            
 			  									</td>
                        </tr>
                        <%}%>
                        <%if (currPermission != null && currPermission.isUsingMetaDataPermissions()){%>
                        <tr>
                    	  	<td>
                            <input type="radio" value="metadata" name="memberPolicy" onClick="javascript:disablePermissions(true)" <%=(currPermission != null && currPermission.isUsingMetaDataPermissions())|| ignoreParent?"checked" : ""%>><span class="REGULARTEXT">Use application permissions</span>
 			  									</td>
                        </tr>
                        <%}%>
                        <tr>
                    	  	<td>
                            <input type="radio" value="current" name="memberPolicy" onClick="javascript:disablePermissions(false)" <%=(currPermission != null && !currPermission.isUsingMetaDataPermissions())|| ignoreParent?"checked" : ""%>><span class="REGULARTEXT">Use specified permissions</span>
 			  									</td>
                        </tr>
                      </table>
                    </td>
                  </tr>
 	          			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <%}else if (currPermission != null && currPermission.isUsingMetaDataPermissions()){%>
                  <tr>
                    <td width="100%" height="18">
                      <table border="0" width="100%">
                        <tr>
                    	  	<td>
                            <input type="radio" value="metadata" name="memberPolicy" onClick="javascript:disablePermissions(true)" <%=currPermission != null || ignoreParent?"checked" : ""%>><span class="REGULARTEXT">Use application permissions</span>
 			  									</td>
                        </tr>
                        <tr>
                    	  	<td>
                            <input type="radio" value="current" name="memberPolicy" onClick="javascript:disablePermissions(false)" <%=currPermission != null || ignoreParent?"checked" : ""%>><span class="REGULARTEXT">Use specified permissions</span>
 			  									</td>
                        </tr>
                      </table>
                    </td>
                  </tr>
 	          			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <%} %>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Edit Group Members</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the members who will be able to view and edit :</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Members</span></td>
				  <td width="100" height="18">&nbsp;</td>
				  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Members</span></td>
                  	</tr>

                        <tr>
                          <td width="200">
                            <select size="5" style="width:200" name="availableEditMembersList" id="availableEditMembersList" multiple>
                               <%for (int i = 0; i < availEditMembers.length; i++) {
                                  String memberDisplayName = availEditMembers[i].getDisplayName();
                                  String type = availEditMembers[i].getType();
                                  if (type.length() > 0){
                                     memberDisplayName += " [ " + type + " ]";
                                  }
                                 %>
                                <option value="<%=availEditMembers[i].getName()%>" class="TEXTBOX" name="<%=availEditMembers[i].getName()%>"><%=memberDisplayName%></option>
                                <%}%>
                              </select>
 				  </td>
                          <td width="100">
                            <table border="0" width="100">
                             <tr><td align="center">
                               <a href="javascript:doEditMembersAdd()" class="LINK">Add</a>
                             </td> </tr>
					<tr><td align="center">
                  	    <a href="javascript:doEditMembersRemove()" class="LINK">Remove</a>
					</td> </tr>

                          </table>
                          <td width="200">
                             <select size="5" style="width:200" name="selectedEditMembersList" id="selectedEditMembersList" multiple>
                                    <%for (int i = 0; i < selectedEditMembers.length; i++) {
                                  String memberDisplayName = selectedEditMembers[i].getDisplayName();
                                  String type = selectedEditMembers[i].getType();
                                  if (type.length() > 0){
                                     memberDisplayName += " [ " + type + " ]";
                                  }
                                 %>
                                <option value="<%=selectedEditMembers[i].getName()%>" class="TEXTBOX" name="<%=selectedEditMembers[i].getName()%>"><%=memberDisplayName%></option>
                                <%}%>
                              </select>
 				  </td>
                          </tr>

                      </table>
                    </td>
                  </tr>


                   <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">View Group Members</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the members who will be able only to view :</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Members</span></td>
				  <td width="100" height="18">&nbsp;</td>
				  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Members</span></td>
                  	</tr>

                        <tr>
                          <td width="200">
                            <select size="5" style="width:200" name="availableViewMembersList" id="availableViewMembersList" multiple>
                               <%for (int i = 0; i < availViewMembers.length; i++) {
                                  String memberDisplayName = availViewMembers[i].getDisplayName();
                                  String type = availViewMembers[i].getType();
                                  if (type.length() > 0){
                                     memberDisplayName += " [ " + type + " ]";
                                  }
                                 %>
                                <option value="<%=availViewMembers[i].getName()%>" class="TEXTBOX" name="<%=availViewMembers[i].getName()%>"><%=memberDisplayName%></option>
                                <%}%>
                              </select>
 				  </td>
                          <td width="100">
                            <table border="0" width="100">
                             <tr><td align="center">
                               <a href="javascript:doViewMembersAdd()" class="LINK">Add</a>
                             </td> </tr>
					<tr><td align="center">
                  	    <a href="javascript:doViewMembersRemove()" class="LINK">Remove</a>
					</td> </tr>

                          </table>
                          <td width="200">
                             <select size="5" style="width:200" name="selectedViewMembersList" id="selectedViewMembersList" multiple>
                                    <%for (int i = 0; i < selectedViewMembers.length; i++) {
                                  String memberDisplayName = selectedViewMembers[i].getDisplayName();
                                  String type = selectedViewMembers[i].getType();
                                  if (type.length() > 0){
                                     memberDisplayName += " [ " + type + " ]";
                                  }
                                 %>
                                <option value="<%=selectedViewMembers[i].getName()%>" class="TEXTBOX" name="<%=selectedViewMembers[i].getName()%>"><%=memberDisplayName%></option>
                                <%}%>
                              </select>
 				  </td>
                          </tr>

                      </table>
                    </td>
                  </tr>



                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <%if (!embedded){%>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="225">
                <tr>
                  <td width="33%"><a href="javascript:doApply()" class="LINK">Apply</a></td>
                  <td width="33%"><a href="javascript:doReset()" class="LINK">Reset</a></td>
                  <td width="33%"><a href="javascript:doCancel()" class="LINK">Cancel</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <%} %>
    </table>
    </td>
  </tr>
</table>
<%if (!embedded){ %>
</form>

</body>
</html>
<%}%>