<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_GROUPS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  String groupStr = request.getParameter("groupname");

  String groupname = "";
  String displayName = "";
  String description = "";
  Collection availGroupsCol = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  XpologGroup [] availGroups = (XpologGroup [])availGroupsCol.toArray(new XpologGroup [availGroupsCol.size()]);
  XpologGroup [] associatedGroups = {manager.getGroup(security,XpologAllGroup.ALL_GROUP_NAME)};
  XpologGroup [] administeredGroups = new XpologGroup[0];
  XpologGroupMemberPrincipal [] availMembers = XpologEntitiesHelper.toGroupMembersArray(XpologSecurityHelper.getUsersCollectionFromUser(security));
  XpologEntitiesHelper.sort(availGroups,true);
  XpologEntitiesHelper.sort(availMembers,true);
  XpologGroupMemberPrincipal [] selectedMembers = new XpologGroupMemberPrincipal[0];
  XpologGroupMemberPrincipal [] selectedAdmins = new XpologGroupMemberPrincipal[0];
  XpologPolicy [] availPolicies = XpologSecurityHelper.getPoliciesFromUser(security,true,true,true);
  boolean policiesAvailable = availPolicies != null && availPolicies.length > 0;
  XpologPolicy policy = null;
  boolean isEditMode = false;
  if (groupStr != null && groupStr.length() > 0){
    XpologGroup group = manager.getGroup(security,groupStr);
    if (group != null){
      isEditMode = true;
      groupname = group.getName();
      displayName = group.getDisplayName();
      description = group.getDescription();
      Collection col = new HashSet(group.getAssociatedGroups());
      Collection userSecurityGroups = XpologSecurityHelper.getGroupsCollectionFromUser(security);
      col.retainAll(userSecurityGroups);
      associatedGroups = (XpologGroup [])col.toArray(new XpologGroup[col.size()]);
      XpologEntitiesHelper.sort(associatedGroups,true);
      col = new HashSet(group.getAdministeredGroups());
      col.retainAll(userSecurityGroups);
      administeredGroups = (XpologGroup [])col.toArray(new XpologGroup[col.size()]);
      XpologEntitiesHelper.sort(administeredGroups,true);
      policy = group.getPolicy();
      selectedMembers = XpologEntitiesHelper.toGroupMembersArray(group.getMembers());
      selectedAdmins = XpologEntitiesHelper.toGroupMembersArray(group.getAdmins());
      XpologEntitiesHelper.sort(selectedMembers,true);
    }
  }

  String isViewOnlyStr = request.getParameter("isViewOnly");
  boolean isViewOnly = isViewOnlyStr != null && isViewOnlyStr.equals("true");


%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>

function doSave(){
  for(var j=0;j<document.access.SelectedGroupsList.options.length;j++){
    document.access.SelectedGroupsList.options[j].selected = true;
  }
  for(var j=0;j<document.access.SelectedAdministeredGroupsList.options.length;j++){
    document.access.SelectedAdministeredGroupsList.options[j].selected = true;
  }
   for(var j=0;j<document.access.SelectedGroupMembersList.options.length;j++){
    document.access.SelectedGroupMembersList.options[j].selected = true;
  }
	for(var j=0;j<document.access.SelectedGroupAdminsList.options.length;j++){
    document.access.SelectedGroupAdminsList.options[j].selected = true;
  }
  document.access.submit();
}

function doReset(){
  this.location = "groupSettings.jsp<%=isEditMode ? "?groupname=" + groupStr : ""%>";
}

function doCancel(){
  this.location = "groupsView.jsp";
}

function doGroupAdd(from,to){
  if(eval("document.access."+from).selectedIndex == -1){
    return;
  }
  for(var j=0;j<eval("document.access."+from).options.length;j++){
    if (eval("document.access."+from).options[j].selected){
      var name = eval("document.access."+from).options[j].text;
      var value = eval("document.access."+from).options[j].value;
      var found = false;
      for(var i=0;i<eval("document.access."+to).options.length;i++){
        if(eval("document.access."+to).options[i].value == value){
          found = true;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        eval("document.access."+to).options[eval("document.access."+to).options.length] = option0;
      }
    }
  }
}

function doGroupRemove(list){
  if(eval("document.access."+list).selectedIndex == -1){
    return;
  }

  for(var i= eval("document.access."+list).options.length ; --i >= 0;){
    if(eval("document.access."+list).options[i].selected){
       eval("document.access."+list).options[i] = null;
    }
  }
}

function doMembersAdd(from,to){
  if(eval("document.access."+from).selectedIndex == -1){
    return;
  }
  for(var j=0;j<eval("document.access."+from).options.length;j++){
    if (eval("document.access."+from).options[j].selected){
      var name = eval("document.access."+from).options[j].text;

      var value = eval("document.access."+from).options[j].value;
      var found = false;
      for(var i=0;i<eval("document.access."+to).options.length;i++){
        if(eval("document.access."+to).options[i].value == value){
          found = true;
          break;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        eval("document.access."+to).options[eval("document.access."+to).options.length] = option0;
      }
    }
  }
}

function doMembersRemove(list){
  if(eval("document.access."+list).selectedIndex == -1){
    return;
  }

  for(var i= eval("document.access."+list).options.length;--i >= 0;){
    if(eval("document.access."+list).options[i].selected){
       eval("document.access."+list).options[i] = null;
    }
  }
}

</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="groupSettingsAction.jsp" method="post" style="padding:0;margin:0">
<input type="hidden" name="isEditMode" value="<%=isEditMode%>">
<%if (isEditMode){%>
  <input type="hidden" name="groupname" value="<%=groupname%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Group Settings</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3" >&nbsp;</td>
              </tr>
             </table>
             <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
               <tr>
                   <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                                    <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Global</span><b>&nbsp;</b></td>
                  </tr>
 			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>

                  <tr>
                    <td width="100%" height="18">
                      <table border="0" width="300">
                        <tr>
                          <td width="150"><span class="REGULARTEXT">Group name:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="groupname" size="20" value="<%=groupname%>" <%=isEditMode?"disabled":""%>>
                          </td>
                          </tr>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Display Name:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="displayName" size="20" value="<%=displayName%>">
                          </td>
                          </tr>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Description:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="description" size="20" value="<%=description%>">
                          </td>
                          </tr>


                      </table>
                    </td>
                  </tr>



                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Groups list</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups which this group Associated to:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  	<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Groups</span></td>
													<td width="100" height="18">&nbsp;</td>
													<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Associated Groups</span></td>
												</tr>
												<tr>
													<td width="200">
														<select size="5" style="width:200" name="availableGroupsList" id="availableGroupsList" multiple>
														<%
															for (int i = 0; i < availGroups.length; i++) {
																if(availGroups[i].getName().equals(groupname)) continue;
														%>
															<option value="<%=availGroups[i].getName()%>" class="TEXTBOX" name="<%=availGroups[i].getName()%>"><%=availGroups[i].getDisplayName()%></option>
														<%}%>
														</select>
													</td>
													<td width="100">
														<table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doGroupAdd('availableGroupsList','SelectedGroupsList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doGroupRemove('SelectedGroupsList')" class="LINK">Remove</a></td>
															</tr>
														</table>
													</td>
													<td width="200">
														<select size="5" style="width:200" name="SelectedGroupsList" id="SelectedGroupsList" multiple>
														<%
															for (int i = 0; i < associatedGroups.length; i++) {
														%>
															<option value="<%=associatedGroups[i].getName()%>" class="TEXTBOX" name="<%=associatedGroups[i].getName()%>"><%=associatedGroups[i].getDisplayName()%></option>
														<%}%>
														</select>
													</td>
												</tr>
											</table>
										</td>
                  </tr>
									<tr>
                    <td width="15%" height="18"></td>
                  </tr>
<!-- administered groups -->
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Administered groups list</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups which this group administers:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
									<tr>
										<td width="100%" height="18">
											<table border="0" width="500">
												<tr>
                    	  	<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Groups</span></td>
				  								<td width="100" height="18">&nbsp;</td>
				  								<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Administered Groups</span></td>
                  			</tr>
                        <tr>
                          <td width="200">
														<select size="5" style="width:200" name="administeredGroupsList" id="administeredGroupsList" multiple>
														<%for (int i = 0; i < availGroups.length; i++) {%>
															<option value="<%=availGroups[i].getName()%>" class="TEXTBOX" name="<%=availGroups[i].getName()%>"><%=availGroups[i].getDisplayName()%></option>
														<%}%>
														</select>
													</td>
                          <td width="100">
                            <table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doGroupAdd('administeredGroupsList','SelectedAdministeredGroupsList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doGroupRemove('SelectedAdministeredGroupsList')" class="LINK">Remove</a></td>
															</tr>
                          	</table>
                          </td>
                          <td width="200">
                            <select size="5" style="width:200" name="SelectedAdministeredGroupsList" id="SelectedAdministeredGroupsList" multiple>
														<%for (int i = 0; i < administeredGroups.length; i++) {%>
															<option value="<%=administeredGroups[i].getName()%>" class="TEXTBOX" name="<%=administeredGroups[i].getName()%>"><%=administeredGroups[i].getDisplayName()%></option>
                              <%}%>
                              </select>
 				  									</td>
                          </tr>
                      </table>
                    </td>
                  </tr>
									<tr>
                    <td width="15%" height="18"></td>
                  </tr>
<!-- end administered groups -->
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Group Members</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups members:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  	<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Members</span></td>
				  								<td width="100" height="18">&nbsp;</td>
				  								<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Members</span></td>
                  			</tr>

                        <tr>
                          <td width="200">
                            <select size="5" style="width:200" name="availableGroupMembersList" id="availableGroupMembersList" multiple>
 															<%for (int i = 0; i < availMembers.length; i++) {
																if(availMembers[i].getName().equals(groupname)) continue;
																String memberDisplayName = availMembers[i].getDisplayName();
																String type = availMembers[i].getType();
																if (type.length() > 0){
																	memberDisplayName += " [ " + type + " ]";
																}
															%>
															<option value="<%=availMembers[i].getName()%>" class="TEXTBOX" name="<%=availMembers[i].getName()%>"><%=memberDisplayName%></option>
															<%}%>
														</select>
													</td>
                          <td width="100">
														<table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doMembersAdd('availableGroupMembersList','SelectedGroupMembersList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doMembersRemove('SelectedGroupMembersList')" class="LINK">Remove</a></td>
															</tr>
														</table>
													</td>
													<td width="200">
														<select size="5" style="width:200" name="SelectedGroupMembersList" id="SelectedGroupMembersList" multiple>
															<%for (int i = 0; i < selectedMembers.length; i++) {
																String memberDisplayName = selectedMembers[i].getDisplayName();
																String type = selectedMembers[i].getType();
																if (type.length() > 0){
																	memberDisplayName += " [ " + type + " ]";
																}
															%>
															<option value="<%=selectedMembers[i].getName()%>" class="TEXTBOX" name="<%=selectedMembers[i].getName()%>"><%=memberDisplayName%></option>
															<%}%>
														</select>
													</td>
												</tr>
											</table>
                    </td>
                  </tr>
<!-- Group admins -->
                  <tr>
                    <td>
                    	<font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
										<td width="15%" height="18"><span class="HEADER">Group Administrators</span><b>&nbsp;</b></td>
									</tr>
									<tr>
										<td>
											<span class="REGULARTEXT">Select the groups administrators:</span>
										</td>
									</tr>
									<tr>
										<td height="100%">&nbsp;</td>
									</tr>
									<tr>
										<td width="100%" height="18">
											<table border="0" width="500">
												<tr>
													<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Members</span></td>
													<td width="100" height="18">&nbsp;</td>
													<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Members</span></td>
												</tr>
												<tr>
													<td width="200">
														<select size="5" style="width:200" name="availableGroupAdminsList" id="availableGroupAdminsList" multiple>
															<%
															for (int i = 0; i < availMembers.length; i++) {
																if(availMembers[i].getName().equals(groupname)) continue;
																String memberDisplayName = availMembers[i].getDisplayName();
																String type = availMembers[i].getType();
																if (type.length() > 0){
																	memberDisplayName += " [ " + type + " ]";
																}
															%>
															<option value="<%=availMembers[i].getName()%>" class="TEXTBOX" name="<%=availMembers[i].getName()%>"><%=memberDisplayName%></option>
															<%}%>
														</select>
													</td>
													<td width="100">
														<table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doMembersAdd('availableGroupAdminsList','SelectedGroupAdminsList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doMembersRemove('SelectedGroupAdminsList')" class="LINK">Remove</a></td>
															</tr>
														</table>
													</td>
													<td width="200">
														<select size="5" style="width:200" name="SelectedGroupAdminsList" id="SelectedGroupAdminsList" multiple>
														<%
															for (int i = 0; i < selectedAdmins.length; i++) {
																String memberDisplayName = selectedAdmins[i].getDisplayName();
																String type = selectedAdmins[i].getType();
																if (type.length() > 0){
																	memberDisplayName += " [ " + type + " ]";
																}
														%>
															<option value="<%=selectedAdmins[i].getName()%>" class="TEXTBOX" name="<%=selectedAdmins[i].getName()%>"><%=memberDisplayName%></option>
														<%}%>
														</select>
													</td>
												</tr>
                      </table>
                    </td>
                  </tr>
<!-- End group adims -->

									<tr <%=policiesAvailable?"":"style=\"display:none\""%>>
										<td>
											<table table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
													<tr>
				                    <td width="15%" height="18"></td>
				                  </tr>
				                  <tr>
				                    <td width="15%" height="18"><span class="HEADER">Policy Settings</span><b>&nbsp;</b></td>
				                  </tr>
				                  <tr>
				                    <td>
				                    <span class="REGULARTEXT">Select If the group will use the associated groups policy or specific policy</span>
				                    </td>
				                  </tr>
				                  <tr>
				                    <td height="100%">
				                    &nbsp;</td>
				                  </tr>
				                   <tr>
				                    <td width="100%" height="18">
				                      <table border="0" width="100%">
				                        <tr>
				                    	  	<td>
				                            <input type="radio" value="sone" name="UserPolicy" <%=policy == null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the policy of the selected groups</span>
												 			  	</td>
															  </tr>
																<tr>
				                    	  	<td>
																		<input type="radio" value="specific" name="UserPolicy" <%=policy != null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the following policy: &nbsp; </span>
									 										<select size="1" name="selectedPolicy" id="selectedPolicy">
				                              <%
				                               String selectedName = policy == null ? "default" : policy.getName();
				                               for (int i = 0; i < availPolicies.length; i++) {
				                                 String selectedStr = selectedName.equals(availPolicies[i].getName())  ? "selected" : "";
				                             	%>
				                                <option value="<%=availPolicies[i].getName()%>" class="REGULARTEXT" name="selectedPolicy" <%=selectedStr%>><%=availPolicies[i].getDisplayName()%></option>
				                              <%}%>
				                       		 		</select>
													 				  </td>
																	</tr>
				                      </table>
				                    </td>
				                  </tr>
			                  </table>
		                  </td>
	                  </tr>
										<tr>
	                    <td>
	                    <font size="2">&nbsp;</font>
	                    </td>
	                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="225">
                <tr>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doSave()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Save</a></td>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doReset()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Reset</a></td>
                  <td width="33%"><a href="javascript:doCancel()" class="LINK">Cancel</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>