<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_GROUPS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String isEditModeStr = request.getParameter("isEditMode");
  boolean isEditMode = isEditModeStr != null && isEditModeStr.equals("true");

  String groupname = request.getParameter("groupname");
  ErrorModel errmodel = new ErrorModel();

  XpologGroup group = null;
  if(groupname == null || groupname.trim().equals("")){
    errmodel.addError("No group name was supplied.");
  }else {
    if(WebUtil.isContainSpecialCharecter(groupname)){
      errmodel.addError("The following charecters are prohibited in the group name field: " +WebUtil.getSpecialCharectersList());
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("errorpage.jsp");
      return;
    }
    group = manager.getGroup(security,groupname);
    if (!isEditMode){
     if(group != null){
       errmodel.addError("A group with the same name already exists.");
     }else if (manager.getUser(security,groupname) != null){
        errmodel.addError("A User with the same name already exists.");
      }
    }
  }

  String description = request.getParameter("description");
  if (description == null ){
    description = "";
  }

  String displayName = request.getParameter("displayName");
  if (displayName == null || displayName.trim().equals("")){
    errmodel.addError("No Display Name was supplied.");
  }


  String [] asscociatedAtt = request.getParameterValues("SelectedGroupsList");
  if (group != null){
  	Collection col = XpologSecurityHelper.getNonAdministeredGroups(security,group.getAdministeredGroups());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; asscociatedAtt != null && i<asscociatedAtt.length; i++){
    		set.add(asscociatedAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologGroup g = (XpologGroup)it.next();
    		set.add(g.getName());
    	}
    	asscociatedAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }
  
  if (asscociatedAtt == null || asscociatedAtt.length == 0){
    errmodel.addError("At least one associated group must be selected.");
  }

  String [] administeredAtt = request.getParameterValues("SelectedAdministeredGroupsList");
  if (group != null){
  	Collection col = XpologSecurityHelper.getNonAdministeredGroups(security,group.getAdministeredGroups());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; administeredAtt != null && i<administeredAtt.length; i++){
    		set.add(administeredAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologGroup g = (XpologGroup)it.next();
    		set.add(g.getName());
    	}
    	administeredAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }
  if (administeredAtt == null){
  	administeredAtt = new String[0];
  }

  String [] membersAtt = request.getParameterValues("SelectedGroupMembersList");
  if (group != null){
  	Collection col = XpologSecurityHelper.getNonAdministeredPrincipals(security,group.getMembers());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; membersAtt != null && i<membersAtt.length; i++){
    		set.add(membersAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologPrincipal p = (XpologPrincipal)it.next();
    		set.add(p.getName());
    	}
    	membersAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }
  if (membersAtt == null){
    membersAtt = new String [0];
  }

  String [] adminsAtt = request.getParameterValues("SelectedGroupAdminsList");
  if (group != null){
  	Collection col = XpologSecurityHelper.getNonAdministeredPrincipals(security,group.getAdmins());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; adminsAtt != null && i<adminsAtt.length; i++){
    		set.add(adminsAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologPrincipal p = (XpologPrincipal)it.next();
    		set.add(p.getName());
    	}
    	adminsAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }
  if (adminsAtt == null){
  	adminsAtt = new String [0];
  }

  String policy = request.getParameter("UserPolicy");
  if (policy != null && policy.equals("specific")){
    policy = request.getParameter("selectedPolicy");
  }else {
    policy = null;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  if (group == null){
    group = new XpologGroup();
  }else {
    group = (XpologGroup)group.clone();
  }
  
  
	 //audit	 
	 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit group details", AuditConstants.SEARCH_ENGINE, "edit group details " + groupname);	 	 	


   manager.fillGroupParameters(group,groupname,displayName,description,asscociatedAtt,administeredAtt,policy,membersAtt,adminsAtt);
   manager.setGroup(security,group);
   response.sendRedirect("addopok.jsp?managementType=group");

%>