<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!

 void addTreeActions(HttpServletRequest request,XpologSecurityManager.XpologPermissionGroup permissions,XpologPolicy policy){
    if (permissions != null){
      addChildsActions(request,permissions,policy,"0");
    }
  }

  void addChildsActions(HttpServletRequest request,XpologSecurityManager.XpologPermissionGroup permissions,XpologPolicy policy, String parentKey){
    for (int i = 0; i < permissions.getPermissionsChildsCount(); i++) {
      XpologSecurityManager.XpologPermissionGroup child = permissions.getPermissionChildAt(i);
      String key = parentKey + "_" + i;
      String logcheck = request.getParameter("PermissionIndex_" + key);
      if(logcheck != null && logcheck.equalsIgnoreCase("on")){
        policy.addAction(child.getName());
      }else {
        addChildsActions(request,child,policy,key);
      }
    }
  }
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_POLICIES_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  boolean isAdmin = security.getUser().isAdmin();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String isEditModeStr = request.getParameter("isEditMode");
  boolean isEditMode = isEditModeStr != null && isEditModeStr.equals("true");

  String policyname = request.getParameter("policyname");
  ErrorModel errmodel = new ErrorModel();

  XpologPolicy policy = null;
  if(policyname == null || policyname.trim().equals("")){
    errmodel.addError("No policy name was supplied.");
  }else {
    if(WebUtil.isContainSpecialCharecter(policyname)){
      errmodel.addError("The following charecters are prohibited in the policy name field: " +WebUtil.getSpecialCharectersList());
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("errorpage.jsp");
      return;
    }
    policy = manager.getPolicy(security,policyname);
    if (!isEditMode && policy != null){
      errmodel.addError("A policy with the same policy name already exists.");
    }
  }

  String description = request.getParameter("description");
  if (description == null ){
    description = "";
  }

  String displayName = request.getParameter("displayName");
  if (displayName == null || displayName.trim().equals("")){
    errmodel.addError("No Display Name was supplied.");
  }


  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  boolean add = false;
  if (policy == null){
    policy = new XpologPolicy();
    add = true;
  }

   manager.fillXpologPrincipalParameters(policy,policyname,displayName,description);
   policy.clearActions();
   addTreeActions(request,XpologSecurityManager.getInstance().getPermissionsRootGroup(),policy);
	 if (add && !isAdmin){
		 Collection availGroups = XpologSecurityHelper.getGroupsCollectionFromUser(security);
		 if (availGroups != null){
			 Iterator it = availGroups.iterator();
			 while (it.hasNext()){
				 XpologGroup g = (XpologGroup)it.next();
				 policy.addAssociatedGroup(g.getName());
			 }
		 }
	 }
	 //audit	 
	 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
     			userContext, AuditConstants.CHANGE, "edit policy details", AuditConstants.SECURITY, "edit policy details " + policyname);	 	 	

	 
   manager.setPolicy(security,policy);
   response.sendRedirect("addopok.jsp?managementType=policy");

%>