<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  String userStr = request.getParameter("username");

  String username = "";
  String displayName = "";
  Collection availGroupsCol = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  XpologGroup [] availGroups = (XpologGroup [])availGroupsCol.toArray(new XpologGroup [availGroupsCol.size()]);
  XpologEntitiesHelper.sort(availGroups,true);
  XpologGroup [] associatedGroups = new XpologGroup[0];
  if (security.getUser().getAdministeredGroup(XpologAllGroup.ALL_GROUP_NAME) != null){
  	associatedGroups = new XpologGroup[1];
  	associatedGroups[0] = manager.getGroup(security,XpologAllGroup.ALL_GROUP_NAME);
  }
  XpologGroup [] administeredGroups = new XpologGroup[0];
  XpologPolicy [] availPolicies = XpologSecurityHelper.getPoliciesFromUser(security,true,true,true);
  XpologPolicy policy = null;
  boolean isEditMode = false;
  if (userStr != null && userStr.length() > 0){
    XpologUser user = manager.getUser(security,userStr);
    if (user != null){
      isEditMode = true;
      username = user.getName();
      displayName = user.getDisplayName();
      Collection col = new HashSet(user.getAssociatedGroups());
      Collection userSecurityGroups = XpologSecurityHelper.getGroupsCollectionFromUser(security);
      col.retainAll(userSecurityGroups);
      associatedGroups = (XpologGroup [])col.toArray(new XpologGroup[col.size()]);
      XpologEntitiesHelper.sort(associatedGroups,true);
      col = new HashSet(user.getAdministeredGroups());
      col.retainAll(userSecurityGroups);
      administeredGroups = (XpologGroup [])col.toArray(new XpologGroup[col.size()]);
      XpologEntitiesHelper.sort(administeredGroups,true);
      policy = user.getPolicy();
    }
  }

  String isViewOnlyStr = request.getParameter("isViewOnly");
  boolean isViewOnly = isViewOnlyStr != null && isViewOnlyStr.equals("true");

  boolean USER_LOCKOUT_IS_ACTIVE = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("xpolog.eye.security.userLockout.isActive", false);
  boolean isUserLockedOut = false;
  if(USER_LOCKOUT_IS_ACTIVE) {
  	isUserLockedOut = manager.isUserLockedOut(username);
  }
  
  boolean isSafeUser = false;
  String safeUsernamesStr = Configuration.getInstance().getPropertiesManager().getProperty("xpolog.eye.security.userLockout.safeUsernames");
	if(safeUsernamesStr != null && safeUsernamesStr.length() > 0) {
	  String[] safeUsernames = safeUsernamesStr.split("\\|");
		String safeUsername = null;
		for (int i = 0; i < safeUsernames.length; i++) {
		  safeUsername = safeUsernames[i];
			if(username.equals(safeUsername)) {
				isSafeUser = true;
			}
		}
	}

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>

function doSave(){
  for(var j=0;j<document.access.SelectedGroupsList.options.length;j++){
    document.access.SelectedGroupsList.options[j].selected = true;
  }
  for(var j=0;j<document.access.SelectedAdministeredGroupsList.options.length;j++){
    document.access.SelectedAdministeredGroupsList.options[j].selected = true;
  }
  document.access.submit();
}

function doReset(){
  this.location = "userSettings.jsp<%=isEditMode ? "?username=" + userStr : ""%>";
}

function doCancel(){
  this.location = "usersView.jsp";
}

function doGroupAdd(from,to){
  if(eval("document.access."+from).selectedIndex == -1){
    return;
  }
  for(var j=0;j<eval("document.access."+from).options.length;j++){
    if (eval("document.access."+from).options[j].selected){
      var name = eval("document.access."+from).options[j].text;
      var value = eval("document.access."+from).options[j].value;
      var found = false;
      for(var i=0;i<eval("document.access."+to).options.length;i++){
        if(eval("document.access."+to).options[i].value == value){
          found = true;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        eval("document.access."+to).options[eval("document.access."+to).options.length] = option0;
      }
    }
  }
}

function doGroupRemove(list){
  if(eval("document.access."+list).selectedIndex == -1){
    return;
  }

  for(var i= eval("document.access."+list).options.length ; --i >= 0;){
    if(eval("document.access."+list).options[i].selected){
       eval("document.access."+list).options[i] = null;
    }
  }
}

</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="userSettingsAction.jsp" method="post" style="padding:0;margin:0">
<input type="hidden" name="isEditMode" value="<%=isEditMode%>">
<%if (isEditMode){%>
  <input type="hidden" name="username" value="<%=username%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">User Settings</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3" >&nbsp;</td>
              </tr>
             </table>
             <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
               <tr>
                   <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                                    <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Global</span><b>&nbsp;</b></td>
                  </tr>
 			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>

                  <tr>
                    <td width="100%" height="18">
                      <table border="0" width="300">
                        <tr>
                          <td width="150"><span class="REGULARTEXT">Username:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="username" size="20" value="<%=username%>" <%=isEditMode?"disabled":""%>>
                          </td>
                          </tr>
                          <% if (!isEditMode){%>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Password:</span></td>
                          <td width="150">
                            <input type="password" class="TEXTBOX" name="password" size="20" value="">
                          </td>
                          </tr>
                          <%}%>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Display Name:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="displayName" size="20" value="<%=displayName%>">
                          </td>
                         </tr>
												 <% if (isEditMode && !isSafeUser && USER_LOCKOUT_IS_ACTIVE){%>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Locked Out:</span></td>
                          <td width="150">
                            <input type="checkbox" class="TEXTBOX" name="lockedOut" value="true" <%=isUserLockedOut ? "checked" : "" %>>
                          </td>
                          </tr>
                          <%}%>

                      </table>
                    </td>
                  </tr>


                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Associated groups list</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups to which this user is associated:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
									<tr>
										<td width="100%" height="18">
											<table border="0" width="500">
												<tr>
                    	  	<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Groups</span></td>
				  								<td width="100" height="18">&nbsp;</td>
				  								<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Associated Groups</span></td>
                  			</tr>
                        <tr>
                          <td width="200">
														<select size="5" style="width:200" name="availableGroupsList" id="availableGroupsList" multiple>
														<%for (int i = 0; i < availGroups.length; i++) {%>
															<option value="<%=availGroups[i].getName()%>" class="TEXTBOX" name="<%=availGroups[i].getName()%>"><%=availGroups[i].getDisplayName()%></option>
														<%}%>
														</select>
													</td>
                          <td width="100">
                            <table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doGroupAdd('availableGroupsList','SelectedGroupsList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doGroupRemove('SelectedGroupsList')" class="LINK">Remove</a></td>
															</tr>
                          	</table>
                          </td>
                          <td width="200">
                            <select size="5" style="width:200" name="SelectedGroupsList" id="SelectedGroupsList" multiple>
														<%for (int i = 0; i < associatedGroups.length; i++) {%>
															<option value="<%=associatedGroups[i].getName()%>" class="TEXTBOX" name="<%=associatedGroups[i].getName()%>"><%=associatedGroups[i].getDisplayName()%></option>
                              <%}%>
                              </select>
 				  									</td>
                          </tr>
                      </table>
                    </td>
                  </tr>
									<tr>
                    <td width="15%" height="18"></td>
                  </tr>
<!-- administered groups -->
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Administered groups list</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups which this user administers:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
									<tr>
										<td width="100%" height="18">
											<table border="0" width="500">
												<tr>
                    	  	<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Groups</span></td>
				  								<td width="100" height="18">&nbsp;</td>
				  								<td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Administered Groups</span></td>
                  			</tr>
                        <tr>
                          <td width="200">
														<select size="5" style="width:200" name="administeredGroupsList" id="administeredGroupsList" multiple>
														<%for (int i = 0; i < availGroups.length; i++) {%>
															<option value="<%=availGroups[i].getName()%>" class="TEXTBOX" name="<%=availGroups[i].getName()%>"><%=availGroups[i].getDisplayName()%></option>
														<%}%>
														</select>
													</td>
                          <td width="100">
                            <table border="0" width="100">
															<tr>
																<td align="center"><a href="javascript:doGroupAdd('administeredGroupsList','SelectedAdministeredGroupsList')" class="LINK">Add</a></td>
															</tr>
															<tr>
																<td align="center"><a href="javascript:doGroupRemove('SelectedAdministeredGroupsList')" class="LINK">Remove</a></td>
															</tr>
                          	</table>
                          </td>
                          <td width="200">
                            <select size="5" style="width:200" name="SelectedAdministeredGroupsList" id="SelectedAdministeredGroupsList" multiple>
														<%for (int i = 0; i < administeredGroups.length; i++) {%>
															<option value="<%=administeredGroups[i].getName()%>" class="TEXTBOX" name="<%=administeredGroups[i].getName()%>"><%=administeredGroups[i].getDisplayName()%></option>
                              <%}%>
                              </select>
 				  									</td>
                          </tr>
                      </table>
                    </td>
                  </tr>
									<tr>
                    <td width="15%" height="18"></td>
                  </tr>
<!-- end administered groups -->
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Policy Settings</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select If the user will use the user's group policy or specific policy</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="100%">
                        <tr>
                    	  <td>
                            <input type="radio" value="sone" name="UserPolicy" <%=policy == null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the policy of the selected groups</span>
 			  </td>
			      </tr>
				<tr>
                    	  <td>
                             <input type="radio" value="specific" name="UserPolicy" <%=policy != null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the following policy: &nbsp; </span>
					 <select size="1" name="selectedPolicy" id="selectedPolicy">
                              <%
                               String selectedName = policy == null ? "default" : policy.getName();
                               for (int i = 0; i < availPolicies.length; i++) {
                                 String selectedStr = selectedName.equals(availPolicies[i].getName())  ? "selected" : "";
                             %>


                                <option value="<%=availPolicies[i].getName()%>" class="REGULARTEXT" name="selectedPolicy" <%=selectedStr%>><%=availPolicies[i].getDisplayName()%></option>
                              <%}%>

                       		 </select>

 				  </td>
			      </tr>


                      </table>
                    </td>
                  </tr>

			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>



                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="225">
                <tr>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doSave()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Save</a></td>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doReset()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Reset</a></td>
                  <td width="33%"><a href="javascript:doCancel()" class="LINK">Cancel</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>