<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String isEditModeStr = request.getParameter("isEditMode");
  boolean isEditMode = isEditModeStr != null && isEditModeStr.equals("true");

  String username = request.getParameter("username");
  ErrorModel errmodel = new ErrorModel();

  XpologUser user = null;
  if(username == null || username.trim().equals("")){
    errmodel.addError("No username was supplied.");
  }else {

    if(WebUtil.isContainSpecialCharecter(username)){
      errmodel.addError("The following charecters are prohibited in the user name field: " +WebUtil.getSpecialCharectersList());
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("errorpage.jsp");
      return;
    }

    user = manager.getUser(security,username);
    if (!isEditMode){
      if (user != null && !user.isTemporery()){
        errmodel.addError("A user with the same username already exists.");
      }else if (manager.getGroup(security,username) != null){
        errmodel.addError("A group with the same name already exists.");
      }
    }
  }

  String password = request.getParameter("password");
  if (password == null || password.trim().equals("")){
    if (!isEditMode){
      errmodel.addError("No password was supplied.");
    }else {
      password = null;
    }
  }

  String displayName = request.getParameter("displayName");
  if (displayName == null || displayName.trim().equals("")){
    errmodel.addError("No Display Name was supplied.");
  }
  
  String lockedOutStr = request.getParameter("lockedOut");
  boolean lockedOut = lockedOutStr != null && lockedOutStr.equals("true");

  String [] asscociatedAtt = request.getParameterValues("SelectedGroupsList");
  if (user != null){
  	user.setTemporery(false);
  	Collection col = XpologSecurityHelper.getNonAdministeredGroups(security,user.getAssociatedGroups());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; asscociatedAtt != null && i<asscociatedAtt.length; i++){
    		set.add(asscociatedAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologGroup group = (XpologGroup)it.next();
    		set.add(group.getName());
    	}
    	asscociatedAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }
  
  String [] administeredAtt = request.getParameterValues("SelectedAdministeredGroupsList");
  if (user != null){
  	Collection col = XpologSecurityHelper.getNonAdministeredGroups(security,user.getAdministeredGroups());
  	if (col != null && col.size() > 0){
    	HashSet set = new HashSet();
    	for (int i=0; administeredAtt != null && i<administeredAtt.length; i++){
    		set.add(administeredAtt[i]);
    	}
    	Iterator it = col.iterator();
    	while (it.hasNext()){
    		XpologGroup group = (XpologGroup)it.next();
    		set.add(group.getName());
    	}
    	administeredAtt = (String[])set.toArray(new String[set.size()]);
  	}
  }

  if (asscociatedAtt == null || asscociatedAtt.length == 0){
    errmodel.addError("At least one associated group must be selected.");
  }
  if (administeredAtt == null || administeredAtt.length == 0){
  	administeredAtt = new String[0];
  }


  String policy = request.getParameter("UserPolicy");
  if (policy != null && policy.equals("specific")){
    policy = request.getParameter("selectedPolicy");
  }else {
    policy = null;
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  if (user == null){
    user = new XpologUser();
  }
  
	 //audit	 
	 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit user settings", AuditConstants.SECURITY, "edit user settings " + username);

  
   manager.fillGroupMemberParameters(user,username,displayName,"",asscociatedAtt,administeredAtt,policy);
   manager.setUser(security,user,password);
   if(lockedOut) {
  	 if(!manager.isUserLockedOut(username)) {
  		 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  	  			userContext, AuditConstants.CHANGE, "lock user ", AuditConstants.SECURITY, "lock user " + username);
  	 }
  	 manager.lockUser(username);
   }else {
  	 if(manager.isUserLockedOut(username)) {
  		 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  	  			userContext, AuditConstants.CHANGE, "release user lock", AuditConstants.SECURITY, "release user lock " + username);
  	 }
  	 manager.releaseUser(username);
   }
   response.sendRedirect("addopok.jsp?managementType=user");

%>