<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.jaas.db.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  ErrorModel err = new ErrorModel();
  
  String dbAccount = request.getParameter("DatabaseAccount");
  String sql = request.getParameter("sql");
  
  if(dbAccount == null || dbAccount.trim().equals("")){
    err.addError("No database account was supplied.");
  }
  
  if(sql == null || sql.trim().equals("")){
    err.addError("No sql was supplied.");
  }
  
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute("ERROR_OBJ",err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=javascript:window.close()");
    return;
  }  
  
  PrincipalSearcherFactory searcherFactory = XpologSecurityManager.getInstance().getSearcherFactory();
  MultiPrincipalSearcherFactory multiSearcherFactory = searcherFactory != null && searcherFactory instanceof MultiPrincipalSearcherFactory ? (MultiPrincipalSearcherFactory)searcherFactory : null;
  DBPrincipalSearcherConfiguration dbConf = null;
  DBPrincipalSearcherFactory dbFactory = null;
  if (searcherFactory != null){
  	dbFactory = (DBPrincipalSearcherFactory)multiSearcherFactory.getSearcherFactoryById("db");
	  if (dbFactory != null ){
	  	dbConf = DBPrincipalSearcherConfiguration.createDBConf(dbFactory.getConfPath());
	  }	  
  }
  
  dbConf.setDbAccount((DBAccount)AddressBook.getInstance().getAccountById(dbAccount));
  dbConf.setSql(sql);
  dbConf.saveConf(dbFactory.getConfPath());
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "edit database searcher configuration", AuditConstants.SECURITY, "edit database searcher configuration");	 	 	

  %>
<script>
window.close();
</script>  