<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.jaas.fs.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  ErrorModel err = new ErrorModel();
  
  String filePath = request.getParameter("filePath");
  String xpologPattern = request.getParameter("xpologPattern");
  
  if(filePath == null || filePath.trim().equals("")){
    err.addError("No file path was supplied.");
  }
  
  if(xpologPattern == null || xpologPattern.trim().equals("")){
    err.addError("No file pattern was supplied.");
  }
  
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute("ERROR_OBJ",err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=javascript:window.close()");
    return;
  }  
  
  PrincipalSearcherFactory searcherFactory = XpologSecurityManager.getInstance().getSearcherFactory();
  MultiPrincipalSearcherFactory multiSearcherFactory = searcherFactory != null && searcherFactory instanceof MultiPrincipalSearcherFactory ? (MultiPrincipalSearcherFactory)searcherFactory : null;
  FilePrincipalSearcherConfiguration fileConf = null;
  FilePrincipalSearcherFactory fileFactory = null;
  if (searcherFactory != null){
  	fileFactory = (FilePrincipalSearcherFactory)multiSearcherFactory.getSearcherFactoryById("file");
	  if (fileFactory != null ){
	  	fileConf = FilePrincipalSearcherConfiguration.createFileConf(fileFactory.getConfPath());
	  }	  
  }
  
  fileConf.setFilePath(filePath);
  fileConf.setXpologPattern(xpologPattern);
  fileConf.saveConf(fileFactory.getConfPath());
  
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "edit file searcher configuration", AuditConstants.SECURITY, "edit file searcher configuration");	 	 	

  %>
<script>
window.close();
</script>  