<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.ldap.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
  

  ErrorModel err = new ErrorModel();
  
  String factoryInit = request.getParameter("java.naming.factory.initial");
  String url = request.getParameter("java.naming.provider.url");
  
  if(factoryInit == null || factoryInit.trim().equals("")){
    err.addError("No context factory was supplied.");
  }
  if(url == null || url.trim().equals("")){
    err.addError("No provider url was supplied.");
  }
  
  
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute("ERROR_OBJ",err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=javascript:window.close()");
    return;
  }  
  
  String masterUser = request.getParameter("manager.java.naming.security.principal");
  String masterPasswd = request.getParameter("manager.java.naming.security.credentials");
  String rootPath = request.getParameter("rootPath");
  String searchFilter = request.getParameter("searchFilter");
  String userPath = request.getParameter("userPath");
  String searchUidAtt = request.getParameter("searchUidAtt");
  String searchDisplayNameAtt = request.getParameter("searchDisplayNameAtt");
  String groupIdPattern = request.getParameter("groupIdPattern");
  String groupsAttribute = request.getParameter("groupsAttribute");
  
  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;

  LdapConfiguration ldapConf = null;
  LdapValidatorFactory ldapFactory = null;
  if (xpologFactory != null){
	  ldapFactory = (LdapValidatorFactory)xpologFactory.getValidatorById("ldap");
	  if (ldapFactory != null ){
	  	ldapConf = LdapConfiguration.createLdapConf(ldapFactory.getLdapConfPath());
	  }	  
  }
  
  Properties initProp = ldapConf == null ? null : ldapConf.getInitProp();
  Properties userProp = ldapConf == null ? new Properties() : ldapConf.getUserProp();
  
  if (ldapConf != null){
  	ldapConf.setRootPath(rootPath);
  	ldapConf.setSearchFilter(searchFilter);
  	ldapConf.setUserPath(userPath);
  	ldapConf.setSearchUid(searchUidAtt);
  	ldapConf.setSearchDisplayName(searchDisplayNameAtt);
  	ldapConf.setGroupIdPattern(groupIdPattern);
  	ldapConf.setGroupsAttribute(groupsAttribute);
  	userProp.setProperty("java.naming.factory.initial",factoryInit);
  	userProp.setProperty("java.naming.provider.url",url);  	
  	
  	if (initProp == null){
  		initProp = new Properties();
  	}
  	initProp.setProperty("java.naming.factory.initial",factoryInit);
  	initProp.setProperty("java.naming.provider.url",url);
  	if (masterUser != null && masterUser.length() > 0){
  		initProp.setProperty("java.naming.security.authentication","simple");
  		initProp.setProperty("java.naming.security.principal",masterUser);
  		initProp.setProperty("java.naming.security.credentials",masterPasswd == null ? "" : masterPasswd);
  	}else {
  		initProp.setProperty("java.naming.security.authentication","none");
    	initProp.remove("java.naming.security.principal");
    	initProp.remove("java.naming.security.credentials");
  	}
  	ldapConf.saveLdapConf(ldapFactory.getLdapConfPath());
  	
	 //audit
	 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.CHANGE, "edit LDAP configuration", AuditConstants.SECURITY, "edit LDAP configuration");
  }
%>
<script>
window.close();
</script>
