<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.siteminder.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  ErrorModel err = new ErrorModel();
  
  String userHeaderKey = request.getParameter("userHeaderKey");
  String clientCookieKey = request.getParameter("clientCookieKey");
  String clientCookieSep = request.getParameter("clientCookieSep");
  String protectedUrls = request.getParameter("protectedUrls");
  String groupHeaderKey = request.getParameter("groupHeaderKey");
  String groupIdPattern = request.getParameter("groupIdPattern");
  String userHttpRequestKey = request.getParameter("userHttpRequestKey");
  
  if((userHeaderKey == null || userHeaderKey.trim().equals("")) && (userHttpRequestKey == null || userHttpRequestKey.trim().equals(""))){
    err.addError("Neither user header key nor user http request key were supplied.");
  }
  
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute("ERROR_OBJ",err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=javascript:window.close()");
    return;
  }  
  
  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  SiteminderConfiguration smConf = null;
  SiteminderValidatorFactory smFactory = null;
  if (xpologFactory != null){
	  smFactory = (SiteminderValidatorFactory)xpologFactory.getValidatorById("siteminder");
	  if (smFactory != null ){
	  	smConf = SiteminderConfiguration.createSMConf(smFactory.getSmConfPath());
	  }	  
  }
  
  smConf.setUserHeaderKey(userHeaderKey);
  smConf.setCookieName(clientCookieKey);
  smConf.setProtectedUrls(protectedUrls);
  smConf.setGroupHeaderKey(groupHeaderKey);
  smConf.setGroupIdPattern(groupIdPattern);
  smConf.setUserHttpRequestKey(userHttpRequestKey);
  smConf.saveSSOConf(smFactory.getSmConfPath());
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "edit SiteMinder configuration", AuditConstants.SECURITY, "edit SiteMinder configuration");	 	 	

  %>
<script>
window.close();
</script>  