<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.webseal.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  ErrorModel err = new ErrorModel();
  
  String userHeaderKey = request.getParameter("userHeaderKey");
  String displayNameHeaderKey = request.getParameter("displayNameHeaderKey");
  String protectedUrls = request.getParameter("protectedUrls");
  String groupHeaderKey = request.getParameter("groupHeaderKey");
  String groupIdPattern = request.getParameter("groupIdPattern");
  String userHttpRequestKey = request.getParameter("userHttpRequestKey");
  String cookieName = request.getParameter("cookieName");
  String cookieUserKey = request.getParameter("cookieUserKey");
  String isAuthStr = request.getParameter("ltpaEnc");
	boolean isAuth = isAuthStr != null && isAuthStr.equals("true");
	String ltpa3DESKey = request.getParameter("ltpa3DESKey");
	String ltpaPassword = request.getParameter("ltpaPassword");
  
  if((userHeaderKey == null || userHeaderKey.trim().equals("")) && (userHttpRequestKey == null || userHttpRequestKey.trim().equals(""))){
    err.addError("Neither user header key nor user http request key were supplied.");
  }
  
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute("ERROR_OBJ",err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=javascript:window.close()");
    return;
  }  
  
  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  WebSealConfiguration websealConf = null;
  WebSealValidatorFactory websealFactory = null;
  if (xpologFactory != null){
	  websealFactory = (WebSealValidatorFactory)xpologFactory.getValidatorById("webseal");
	  if (websealFactory != null ){
	  	websealConf = WebSealConfiguration.createWebSealConf(websealFactory.getWebSealConfPath());
	  }	  
  }
  
  websealConf.setUserHeaderKey(userHeaderKey);
  websealConf.setDisplayNameHeaderKey(displayNameHeaderKey);
  websealConf.setProtectedUrls(protectedUrls);
  websealConf.setGroupHeaderKey(groupHeaderKey);
  websealConf.setGroupIdPattern(groupIdPattern);
  websealConf.setUserHttpRequestKey(userHttpRequestKey);
  websealConf.setCookieName(cookieName);
  websealConf.setCookieUserKey(cookieUserKey);
  websealConf.setEncryptedToken(isAuth);
  websealConf.setLtpa3DESKey(ltpa3DESKey);
  websealConf.setLtpaPassword(ltpaPassword);
  websealConf.saveSSOConf(websealFactory.getWebSealConfPath());
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "edit WebSeal configuration", AuditConstants.SECURITY, "edit WebSeal configuration");	 	 	

  %>
<script>
window.close();
</script>  