<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.run.LogActionsConfiguration"%>
<%@ page import="xpolog.eye.site.TelShActivityManager"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%@ page import="java.io.*"%>

<%!static final String BASE_DIRECTORY = "../";
	static final int PORT_MAX_RANGE = 65535;%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request, response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION, true)) {
		return;
	}

	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	String SMTP_HOST = "SMTPHost";
	String SMTP_PORT = "SMTPProt";
	String SMTP_IS_AUTH = "SmtpIsAuth";
	String SMTP_USERNAME = "SmtpUser";
	String SMTP_PASSWORD = "SmtpPwd";
	String IS_TLS = "isTLS";
	String ERROR_OBJ = "ERROR_OBJ";
	String START_SSL = "startSSL";
	String SESSION_TIME = "SessionTimeOut";
	String ACTIVE_SECURE = "activeSecurity";
	String EXTERNAL_CONF_ACTIVE = "externalConfiguration";
	String EXTERNAL_CONF_PATH = "externalConfigurationPath";
	String LOGIN_URL = "loginUrl";

	AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
	XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
	JobStatus _jobStatus = new JobStatus();
	_jobStatus.setCurrentStatus("Saving General Settings");
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, _jobStatus);
	final JobStatus jobStatus = _jobStatus;

	ErrorModel err = new ErrorModel();
	MailConfig mail = Configuration.getInstance().getMailConfigurationManager();

	String host = request.getParameter(SMTP_HOST);
	String port = request.getParameter(SMTP_PORT);
	String isAuthStr = request.getParameter(SMTP_IS_AUTH);
	boolean isAuth = isAuthStr != null && isAuthStr.equals("true");
	String username = request.getParameter(SMTP_USERNAME);
	String password = request.getParameter(SMTP_PASSWORD);
	String isTLSStr = request.getParameter(IS_TLS);
	boolean isTLS = isTLSStr != null && isTLSStr.equals("true");
	if (host == null || host.trim().equals("")) {
		err.addError("No host was supplied.");
	}
	if (port == null || port.trim().equals("")) {
		err.addError("No port was supplied.");
	}
	if(username == null) {
		username = "";
	}
	if(isAuth && username.length() == 0) {
		err.addError("SMTP username was not specified");
	}
	if(password == null) {
		password = "";
	}

	String systemAddress = request.getParameter("systemMailAddress");
	String adminMail = request.getParameter("adminMail");

	String[] selectedAuthItems = null;
	if (xpologFactory != null) {
		selectedAuthItems = request.getParameterValues("selectedValidatorMembersList");
		if (selectedAuthItems == null || selectedAuthItems.length == 0) {
			err.addError("No authentication type was supplied.");
		}
	}

	String isEexternalConfActive = request.getParameter(EXTERNAL_CONF_ACTIVE);
	final String externalConfPath = request.getParameter(EXTERNAL_CONF_PATH);
	if (isEexternalConfActive != null) {
		boolean validDir = false;
		if (externalConfPath != null || externalConfPath.length() > 0) {
			try {
				File f = new File(externalConfPath);
				if (f.exists() && f.isDirectory()) {
					validDir = true;
				}
			} catch (Exception e) {
			}
		}
		if (!validDir) {
			err.addError("The path to the external configuration directory is not valid, set a valid path or disable this property.");
		}
	}

	if (err.getErrorCount() > 0) {
		request.getSession().setAttribute(ERROR_OBJ, err);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	host = host.trim();
	port = port.trim();
	mail.setSmtpHost(host);
	mail.setSystemMailAddress(systemAddress);
	mail.setAdminMail(adminMail);
	try {
		mail.setSmtpPort(Integer.parseInt(port));
	} catch (Exception e) {
		err.addError("Port must be a valid number.");
		request.getSession().setAttribute(ERROR_OBJ, err);
		response.sendRedirect("errorpage.jsp");
		return;
	}
	mail.setAtuhenticate(isAuth);
	mail.setUser(username);
	mail.setPassword(password);
	mail.setTLS(isTLS);
	mail.setUseEncrypt(true);
	
	err = new ErrorModel();
	//port part
	String HTTP_PORT = "HttpPort";
	String SSL_PORT = "SslProt";
	final ServerAdmin sad = SiteManagment.getAdminInstance().getServerAdministrator();
	int htp = -1;
	String params = "";
	if (!Configuration.isWar()) {
		String hport = request.getParameter(HTTP_PORT);
		String sport = request.getParameter(SSL_PORT);
		if (hport == null || hport.trim().equals("")) {
			err.addError("No HTTP port was supplied.");
		}
		if (sport == null || sport.trim().equals("")) {
			err.addError("No SSL port was supplied.");
		}
		try {
			final int hp = Integer.parseInt(hport);
			htp = hp;
			final int sp = Integer.parseInt(sport);
			if (hp < 0 || sp < 0) {
				throw new Exception("ports are not allowed to be negative");
			}
			if (hp < 1 || hp > PORT_MAX_RANGE) {
				throw new Exception("http port range must be between 1 and " + PORT_MAX_RANGE + ".");
			}
			if (hp != sad.getHttpPort() || sp != sad.getSslPort()) {
				params = "?URL=http://" + request.getServerName() + ":" + hp;
				new Thread() {
					public void run() {
						try {
							Thread.sleep(3000);
							sad.setPorts(hp, sp);
						} catch (Exception e) {
						}
					}
				}.start();
				//perform redirect to a new page
			}
		} catch (Exception e) {
			err.addError(e.getMessage());
		}
		if (err.getErrorCount() > 0) {
			request.getSession().setAttribute(ERROR_OBJ, err);
			response.sendRedirect("errorpage.jsp");
			return;
		}
	}
	
	//new log actions
  LogActionsConfiguration logActionsConf = LogActionsConfiguration.getInstance();
	
	String runIndexingStr = request.getParameter("runIndexing");
	boolean runIndexing = runIndexingStr != null && runIndexingStr.equals("true");
  String runReportsStr = request.getParameter("runReports");
	boolean runReports = runReportsStr != null && runReportsStr.equals("true");
  String runDashboardStr = request.getParameter("runDashboard");
	boolean runDashboard = runDashboardStr != null && runDashboardStr.equals("true");
	boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
	// if dashboard is not valid, maintain the previous value because the checkbox is not displayed
	if(!isDashboardValid) {
		runDashboard = logActionsConf.isRunDashboard();
	}
	String cpuLimitStr = request.getParameter("cpuLimit");
	double cpuLimit = -1;
	if (cpuLimitStr != null && cpuLimitStr.length() > 0){
		try{
			cpuLimit = Integer.parseInt(cpuLimitStr);
		}catch(Exception e){
			err.addError("Wrong CPU limitation entered");
			err.addError("Value should be between 1 - 99. Leave value blank for no CPU limitation");
		}
		if (err.getErrorCount() > 0) {
			request.getSession().setAttribute(ERROR_OBJ, err);
			response.sendRedirect("errorpage.jsp");
			return;
		}
	}
	logActionsConf.setRunIndexing(runIndexing);
	logActionsConf.setRunReports(runReports);
	logActionsConf.setRunDashboard(runDashboard);
	logActionsConf.setCpuLimit(cpuLimit);
	logActionsConf.save();
	
	// default account policies
	long sshPoolTimeoutIntervalValue = 0, sshPoolTimeoutInterval = 0, sshSessionTimeoutInterval = 0;
	String sshPoolTimeoutIntervalValueType = "", sshSessionTimeoutIntervalValueType = "";
	int sshMaxConnections = 0, sshMaxSessionsPerConnection = 0;
	String sshPoolTimeoutIntervalStr = request.getParameter("sshPoolTimeoutInterval");
	sshPoolTimeoutIntervalValueType = request.getParameter("sshPoolTimeoutIntervalValueType");
	if(sshPoolTimeoutIntervalStr != null && sshPoolTimeoutIntervalStr.length() > 0) {
		try{
			sshPoolTimeoutIntervalValue = Integer.parseInt(sshPoolTimeoutIntervalStr);
			if(sshPoolTimeoutIntervalValueType.equals("min")) {
				sshPoolTimeoutInterval = sshPoolTimeoutIntervalValue * 1000 * 60;
			}else if(sshPoolTimeoutIntervalValueType.equals("hour")) {
				sshPoolTimeoutInterval = sshPoolTimeoutIntervalValue * 1000 * 60 * 60;
			}
			if(sshPoolTimeoutInterval < 1 && sshPoolTimeoutIntervalValue != TelnetAccountPolicy.IMMEDIATE_TIMEOUT_INTERVAL) {
				err.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
			}
		}catch(Exception e){
			err.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
		}
	}else {
		err.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
	}
	String sshSessionTimeoutIntervalStr = request.getParameter("sshSessionTimeoutInterval");
	sshSessionTimeoutIntervalValueType = request.getParameter("sshSessionTimeoutIntervalValueType");
	if(sshSessionTimeoutIntervalStr != null && sshSessionTimeoutIntervalStr.length() > 0) {
		long minimumSessionTimeoutInterval = TelShActivityManager.MINIMUM_SESSION_TIMEOUT_INTERVAL;
		try{
			sshSessionTimeoutInterval = Integer.parseInt(sshSessionTimeoutIntervalStr);
			if(sshSessionTimeoutInterval != -1) {
				if(sshSessionTimeoutIntervalValueType.equals("min")) {
					sshSessionTimeoutInterval = sshSessionTimeoutInterval * 1000 * 60;
				}else if(sshSessionTimeoutIntervalValueType.equals("hour")) {
					sshSessionTimeoutInterval = sshSessionTimeoutInterval * 1000 * 60 * 60;
				}
			}
			if(sshSessionTimeoutInterval != -1 && sshSessionTimeoutInterval < minimumSessionTimeoutInterval) {
				err.addError("Wrong session timeout interval entered. Minimum value is " + DateUtil.formatTime(minimumSessionTimeoutInterval) + ", leave blank for no limit");
			}
		}catch(Exception e){
			err.addError("Wrong session timeout interval entered. Minimum value is " + DateUtil.formatTime(minimumSessionTimeoutInterval) + ", leave blank for no limit");
		}
	}else {
		sshSessionTimeoutInterval = -1;
	}
	String sshMaxConnectionsStr = request.getParameter("sshMaxConnections");
	if(sshMaxConnectionsStr != null && sshMaxConnectionsStr.length() > 0) {
		try{
			sshMaxConnections = Integer.parseInt(sshMaxConnectionsStr);
			if(sshMaxConnections != -1 && sshMaxConnections < 1) {
				err.addError("Wrong number of connections allowed to remote machine entered. Value must be a positive number, leave blank for no limit");
			}
		}catch(Exception e){
			err.addError("Wrong number of connections allowed to remote machine entered. Value must be a positive number, leave blank for no limit");
		}
	}else {
		sshMaxConnections = -1;
	}
	String sshMaxSessionsPerConnectionStr = request.getParameter("sshMaxSessionsPerConnection");
	if(sshMaxSessionsPerConnectionStr != null && sshMaxSessionsPerConnectionStr.length() > 0) {
		try{
			sshMaxSessionsPerConnection = Integer.parseInt(sshMaxSessionsPerConnectionStr);
			if(sshMaxSessionsPerConnection < 2 || sshMaxSessionsPerConnection > 7) {
				err.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
			}
		}catch(Exception e){
			err.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
		}
	}else {
		err.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
	}
	if (err.getErrorCount() > 0) {
		request.getSession().setAttribute(ERROR_OBJ, err);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	//security settings
	String isssl = request.getParameter(START_SSL);
	String issecureact = request.getParameter(ACTIVE_SECURE);
	String sestime = request.getParameter(SESSION_TIME);
	String loginUrl = request.getParameter(LOGIN_URL);
	XpologSecurityManager secure = (XpologSecurityManager) Configuration.getInstance().getSecurityConfigurator();
	if(!secure.isEnabled()) {
		secure.setEnablingSecurity(true);
	}
	if (sestime != null) {
		secure.setSesionTimeut(sestime);
	}
	if (isssl != null) {

		boolean seclink = Boolean.valueOf(isssl).booleanValue();
		secure.setIsStartSSL(seclink);
	} else {
		secure.setIsStartSSL(false);
	}
	
	boolean secchang = false;
	if (issecureact != null) {
		boolean sec = Boolean.valueOf(issecureact).booleanValue();
		if (secure.isEnabled() != sec) {
			secchang = true;
			secure.setEnabled(sec);
		}
	} else {
		if (secure.isEnabled()) {
			secchang = true;
			secure.setEnabled(false);
		}
	}
	if (loginUrl != null) {
		secure.setLoginURL(loginUrl);
	}

	if (selectedAuthItems != null) {
		xpologFactory.setSelectedIDs(selectedAuthItems);
	}

	PrincipalSearcherFactory searcherFactory = XpologSecurityManager.getInstance().getSearcherFactory();
	MultiPrincipalSearcherFactory multiSearcherFactory = searcherFactory != null && searcherFactory instanceof MultiPrincipalSearcherFactory ? (MultiPrincipalSearcherFactory) searcherFactory
			: null;

	if (multiSearcherFactory != null) {
		String[] selectedSearcherItems = request.getParameterValues("selectedSearcherMembersList");
		StringBuffer buffer = new StringBuffer();
		if (selectedSearcherItems != null) {
			for (int i = 0; i < selectedSearcherItems.length; i++) {
				if (i > 0) {
					buffer.append(",");
				}
				buffer.append(selectedSearcherItems[i]);
			}
		}
		multiSearcherFactory.setSelectedIds(buffer.toString());
	}

	//runner node
	String isRunnerNodeStr = request.getParameter("isRunnerNode");
	boolean isRunnerNode = isRunnerNodeStr != null && isRunnerNodeStr.equals("true");
	final boolean isRunnerNodeChanged = isRunnerNode != Configuration.getInstance().isRunnerNode();
	Configuration.getInstance().setRunnerNode(isRunnerNode);
	
	
	//clustering
	String useClusterStr = request.getParameter("useCluster");
	boolean useCluster = useClusterStr != null && useClusterStr.equals("true");
	Configuration.getInstance().setCluster(useCluster);
	
	TelnetAccountPolicy defaultTelnetAccountPolicy = TelShActivityManager.getInstance().getDefaultTelnetAccountPolicy();
	if(defaultTelnetAccountPolicy != null) {
		if(sshPoolTimeoutInterval != 0) {
			defaultTelnetAccountPolicy.setPoolTimeoutInterval(sshPoolTimeoutInterval);
			defaultTelnetAccountPolicy.setPoolTimeoutIntervalValueType(sshPoolTimeoutIntervalValueType);
		}
		if(sshSessionTimeoutInterval != 0) {
			defaultTelnetAccountPolicy.setSessionTimeoutInterval(sshSessionTimeoutInterval);
			defaultTelnetAccountPolicy.setSessionTimeoutIntervalValueType(sshSessionTimeoutIntervalValueType);
		}
		if(sshMaxConnections != 0) {
			defaultTelnetAccountPolicy.setMaxConnections(sshMaxConnections);
		}
		if(sshMaxSessionsPerConnection != 0) {
			defaultTelnetAccountPolicy.setMaxSessionsPerConnection(sshMaxSessionsPerConnection);
		}
		defaultTelnetAccountPolicy.setDefault(true);
		TelShActivityManager.getInstance().saveDefaultTelnetAccountPolicy(defaultTelnetAccountPolicy);
	}
	
	//Advance Api Policies
	String apiPolicySelection = request.getParameter("apiPolicySelection");
	if(apiPolicySelection != null || apiPolicySelection.length() > 0){
		Configuration.getInstance().getPropertiesManager().setProperty("api.policy", apiPolicySelection);
	}

	//external configuration
	String userMessage = "";
	final XpologManagment mgmt = new XpologManagment();
	if (isEexternalConfActive != null && externalConfPath != null && externalConfPath.length() > 0) {
		final boolean externalConfPathChanged = Configuration.XPOLOG_ROOT_PATH != null && !Configuration.XPOLOG_ROOT_PATH.equals(externalConfPath);
		if (externalConfPathChanged) {
			userMessage = "You must restart XpoLog in order for the changes to take effect.";
		}
		final boolean logoutAndRemoveUser = secchang && !secure.isEnabled();
		ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "common/actions/nextAction.jsp") {
			public void run(HttpServletRequest request) {
				try {
					long start = System.currentTimeMillis();
					String currentLocation = Configuration.XPOLOG_ROOT_PATH;
					if (externalConfPathChanged) {
						//these are the dirs and files that will be copied to the external conf location
						String[] dirsToInclude = { "conf", "bin", "log", "index", "hsqldb/hsqldbLoader.xml", "hsqldb/server.properties", "temp", "lib", "ant",
								"logexample", "reports", "license", "knowledge", "collection","platform" };
						boolean copied = mgmt.setXpoLogRootPathToDirectory(currentLocation, externalConfPath, dirsToInclude, true, jobStatus);
						if(copied) {
							if(new File(Configuration.XPOLOG_SITE_ROOT, "wizards").exists()) {
								currentLocation = Configuration.XPOLOG_SITE_ROOT;
							}else if(new File(Configuration.XPOLOG_ROOT_PATH, "wizards").exists()) {
								currentLocation = Configuration.XPOLOG_ROOT_PATH;
							}else {
								currentLocation = Configuration.XPOLOG_SITE_ROOT;
							}
							String[] wizardsDir = { "wizards" };
							mgmt.setXpoLogRootPathToDirectory(currentLocation, externalConfPath, wizardsDir, false, jobStatus);
						}
					}else if(isRunnerNodeChanged) {
						Configuration.getInstance().saveXpoLogInitProp(currentLocation);
					}
					long end = System.currentTimeMillis();
					if (end - start < 1000) {
						try {
							Thread.sleep(1000);
						} catch (Exception e) {
						}
					}
					Configuration.getInstance().getMailConfigurationManager().saveMailSettings();
					Configuration.getInstance().saveConfiguration();
					if (logoutAndRemoveUser) {
						WebSecurityManager.getInstance().logout(request);
						UserEnvironment.removeUserContext(request);
					}
				} catch (Exception e) {
					errmodel.addError("Failed to save general settings. " + e);
					createErrorRedirect(request, BASE_DIRECTORY);
					return;
				}finally {
					XpologSecurityManager.getInstance().setEnablingSecurity(false);
				}
			}
		};
		env.setProgressRunner(runner);
	} else {
		//some of the params not valid. Using inner configuration.
		if (Configuration.isExternalConf()) {
			userMessage = "You must restart XpoLog in order for the changes to take effect.";
		}
		mgmt.disableExternalConf();
		secure.setEnablingSecurity(false);
	}
	_jobStatus.setCurrentStatus("Saving General Settings");

	// reports maintenance
	String reportsDeletionIntervalStr = request.getParameter("reportsDeletionInterval");
	int reportsDeletionIntervalUnit = -1;
	if(reportsDeletionIntervalStr == null || reportsDeletionIntervalStr.equals("")) {
		reportsDeletionIntervalStr = "1";
		reportsDeletionIntervalUnit = Constants.TimeUnits.INTERVAL_UNIT_YEAR;
	}else {
		try {
			int reportsDeletionInterval = Integer.parseInt(reportsDeletionIntervalStr);
			if(reportsDeletionInterval <= 0) {
				reportsDeletionIntervalStr = "1";
				reportsDeletionIntervalUnit = Constants.TimeUnits.INTERVAL_UNIT_YEAR;
			}else {
				String reportsDeletionIntervalUnitStr = request.getParameter("reportsDeletionIntervalUnit");
				try {
					reportsDeletionIntervalUnit = Integer.parseInt(reportsDeletionIntervalUnitStr);
				}catch(Exception e) {
					reportsDeletionIntervalStr = "1";
					reportsDeletionIntervalUnit = Constants.TimeUnits.INTERVAL_UNIT_YEAR;
				}
			}
		}catch(Exception e) {
			reportsDeletionIntervalStr = "1";
			reportsDeletionIntervalUnit = Constants.TimeUnits.INTERVAL_UNIT_YEAR;
		}
	}
	
	ReportsManager.getInstance().saveReportsDeletionPolicy(reportsDeletionIntervalStr, reportsDeletionIntervalUnit);
	
	//saving  
	if (isEexternalConfActive == null || externalConfPath == null || externalConfPath.length() == 0) {
		Configuration.getInstance().getMailConfigurationManager().saveMailSettings();
		Configuration.getInstance().saveConfiguration();
	}

	if (secchang) {
		if (params == null || params.equals("")) {
			params = "?refresh=true";
		} else {
			params = params + "&refresh=true";
		}
	}
	//check if external conf was set in order to send a restart notification
	if (userMessage != null) {
		if (params == null || params.equals("")) {
			params = "?userMessage=" + userMessage;
		} else {
			params = params + "&userMessage=" + userMessage;
		}
	}

	/*if (secchang && !secure.isEnabled()) {
		WebSecurityManager.getInstance().logout(request);
		response.sendRedirect(BASE_DIRECTORY + "index.html");
		return;
	}*/
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.CHANGE, "edit general settings configuration",
			AuditConstants.CONFIGURATION, "edit general settings configuration");
	
	env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE, "settings/saveopok.jsp" + params);
	if (isEexternalConfActive == null || externalConfPath == null || externalConfPath.length() == 0) {
		response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
	}
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="message" value="Saving General Settings" />
	<jsp:param name="useStatus" value="true" />
</jsp:include>
