<%@ page language="java"%>

<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  ErrorModel errmodel = new ErrorModel();
  
  String param = null;
  String operation = request.getParameter(OP);
  String operatingSystem = (System.getProperty("os.name"));
  Process proc = null;
  
  boolean xpologAsService = false;
  String xpologAsServiceStr = Configuration.getInstance().getPropertiesManager().getProperty("xpologAsService","false");
  if(xpologAsServiceStr != null && xpologAsServiceStr.equals("true")) {
    xpologAsService = true;
  }
  
  if(operatingSystem == null || !operatingSystem.startsWith("Windows")) {
  	errmodel.addError("Installation as service is possible only on Windows");
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  if(operation != null && operation.equals("INSTALL")) {
  	param = "installation";
	//check if already installed
	if(xpologAsService) {
		errmodel.addError("XpoLog is already installed as service");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("errorpage.jsp");
	    return;
	}

	try {
		File file = new File(new File(Configuration.XPOLOG_ROOT_PATH).getAbsolutePath()+"\\addon\\XpoLogAsService.zip");
		String targetDir = new File(Configuration.XPOLOG_ROOT_PATH).getAbsolutePath();
		ArchiveService zip = new ArchiveService(file);
  	  	zip.extractAllToLocation(targetDir);
  	 
  		String bat = targetDir+"\\installAsService.bat";
  		proc = Runtime.getRuntime().exec(bat);
  	}catch(Exception e) {
  		errmodel.addError("Cannot create service");
  		errmodel.addError(e.getMessage());
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("errorpage.jsp");
	    return;
  	}
  	/*BufferedReader reader = new BufferedReader(new InputStreamReader(proc.getInputStream()));
    String line = null;
    try {
      while ((line = reader.readLine()) != null){
        System.out.println(line);
     }
      reader.close();
    } catch (IOException e) {
     e.printStackTrace();
    }*/
  	Configuration.getInstance().getPropertiesManager().setProperty("xpologAsService","true");
  	Configuration.getInstance().getPropertiesManager().saveProperties();
  }else if(operation != null && operation.equals("UNINSTALL")) {
  	param = "un-installation";
	//check if un-installed
	if(!xpologAsService) {
		errmodel.addError("XpoLog is not installed as service at the moment");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("errorpage.jsp");
	    return;
	}
	
	try {
		String targetDir = new File(Configuration.XPOLOG_ROOT_PATH).getAbsolutePath();
	  	String bat = targetDir+"\\UninstallAsService.bat";
	  	proc = Runtime.getRuntime().exec(bat);
  	}catch(Exception e) {
  		errmodel.addError("Cannot uninstall service");
  		errmodel.addError(e.getMessage());
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("errorpage.jsp");
	    return;
  	} 
  	/*BufferedReader reader = new BufferedReader(new InputStreamReader(proc.getInputStream()));
    String line = null;
    try {
     while ((line = reader.readLine()) != null){
        System.out.println(line);
      }
      reader.close();
    } catch (IOException e) {
      e.printStackTrace();
    }*/
    Configuration.getInstance().getPropertiesManager().setProperty("xpologAsService","false");
  	Configuration.getInstance().getPropertiesManager().saveProperties();
  }else {
  	
    errmodel.addError("Unknown operation");
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  response.sendRedirect("xpologAsServiceResult.jsp?OP="+param);
%>


