<%@page import="xpolog.eye.media.auth.win.WinAuthenticationAccount"%>
<%@page import="java.util.ArrayList"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.startup.*"%>

<%!static final String BASE_DIRECTORY = "../";

	private String verifyApp(NetworkHost networkHost, String appType, String path) {
		String verified = null;

		if (appType == null || appType.equals("")) {
			verified = "No application was selected";
		}else if (path == null || path.equals("")) {
			verified = "Path was not specified";
		}else if(networkHost != null && networkHost.getAccount() instanceof WinAuthenticationAccount && !path.startsWith("\\\\" + networkHost.getHost())) {
			verified = "Path must point to host " + networkHost.getHost(); 
		}else if(networkHost == null && path.startsWith("\\\\")) {
			verified = "Path must point to local machine";
		}
		return verified;
	}
	
	private StartupApplication createpp(StartupViewHelper helper, WizardInfo wizardInfo, NetworkHost networkHost, ArrayList apps, String appType, String path) {
		StartupApplication app = null;
		
		if(wizardInfo != null) {
			app = new StartupApplication();
			app.setWizardId(appType);
			String id = "";
			if(networkHost == null) {
				id = appType;
			}else {
				id = networkHost.getHost() + "_" + appType;
			}
			id = helper.getUniqueId(apps, id);
			app.setId(id);
			app.setName(wizardInfo.getName());
			app.setType(wizardInfo.getMetaData().getApplication());
			app.setPath(path);
			app.setVersion(wizardInfo.getMetaData().getVersion());
			if(helper.isAppMetaDataExists(app, networkHost)) {
				app.setSelected(false);
				if(app.getMessage() == null || app.getMessage().equals("")) {
					app.setMessage("Already exists");
				}
			}
		}
		return app;
	}
	
	private String buildLocalAppXml(int count, StartupApplication app) {
		StringBuffer xml = new StringBuffer();
		
		String path = app.getPath(), tooltip = "";
		if(!app.isCanBeExecuted() || (app.getMessage() != null && !app.getMessage().equals(""))) {
			if(path == null || path.equals("")) {
				path = app.getMessage();
			}else {
				path = (app.getMessage() + ": " + path);
			}
		}
		if (path.length() > 50) {
			tooltip = path;
			path = path.substring(0, 50) + "...";
		}
		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		if (count % 2 == 1) {
			xml.append("<tr class=\"STARTUP_TABLE_COLORED_ROW\">");
		}else {
			xml.append("<tr>");
		}
		xml.append("<td width=\"4%\">");
		xml.append("<input type=\"checkbox\" name=\"local");
		xml.append("_");
		xml.append(app.getId());
		xml.append("_check\" id=\"local");
		xml.append("_");
		xml.append(app.getId());
		xml.append("_check\" onClick=\"javascript:checkLocalApp(this)\"");
		if(app.isCanBeExecuted()) {
			if(app.isSelected()) {
				xml.append(" checked");
			}
		}else {
			xml.append(" disabled");
		}
		xml.append("></td>");
		xml.append("<td width=\"30%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(app.getName());
		xml.append("</span></td>");
		xml.append("<td width=\"60%\" title=\"");
		xml.append(tooltip);
		xml.append("\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(path);
		xml.append("</span></td>");
		xml.append("<td width=\"6%\"></td>");
		xml.append("</tr>");
		xml.append("</table>");
		
		return xml.toString();
	}

	private String buildNetworkAppXml(int count, int index, StartupApplication app) {
		StringBuffer xml = new StringBuffer();
		
		String path = app.getPath(), tooltip = "";
		if(!app.isCanBeExecuted() || (app.getMessage() != null && !app.getMessage().equals(""))) {
			if(path == null || path.equals("")) {
				path = app.getMessage();
			}else {
				path = (app.getMessage() + ": " + path);
			}
		}
		if (path.length() > 50) {
			tooltip = path;
			path = path.substring(0, 50) + "...";
		}
		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		if (count % 2 == 1) {
			xml.append("<tr class=\"STARTUP_TABLE_COLORED_ROW\">");
		}else {
			xml.append("<tr>");
		}
		xml.append("<td width=\"4%\"></td>");
		xml.append("<td width=\"30%\"><input type=\"checkbox\" name=\"network");
		xml.append(index);
		xml.append("_");
		xml.append(app.getId());
		xml.append("_check\" id=\"network");
		xml.append(index);
		xml.append("_");
		xml.append(app.getId());
		xml.append("_check\" onClick=\"javascript:checkNetworkApp(");
		xml.append(index);
		xml.append(", this)\"");
		if(app.isCanBeExecuted()) {
			if(app.isSelected()) {
				xml.append(" checked");
			}
		}else {
			xml.append(" disabled");
		}
		xml.append(">&nbsp;<span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(app.getName());
		xml.append("</span></td>");
		xml.append("<td width=\"60%\" title=\"");
		xml.append(tooltip);
		xml.append("\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(path);
		xml.append("</span></td>");
		xml.append("<td width=\"6%\"></td>");
		xml.append("</tr>");
		xml.append("</table>");
		
		return xml.toString();
	}

	private String buildErrorXml(String error) {
		StringBuffer xml = new StringBuffer();

		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		xml.append("<tr>");
		xml.append("<td width=\"100%\"><span class=\"STARTUP_BODY_ERROR_TEXT\">");
		xml.append("errorMessage:");
		xml.append(error);
		xml.append("</span></td>");
		xml.append("</tr>");
		xml.append("</table>");
		return xml.toString();
	}%>

<%
	String INDEX = "index";
	String APP_TYPE = "appType";
	String PATH = "path";

	SiteManagment mgmt = SiteManagment.getInstance();
	WizardManager wmg = mgmt.getWizardManager(SiteUtil.getBaseDirectory(request));
	
	Object obj = request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
	StartupViewHelper helper = null;
	if(obj != null) {
		helper = (StartupViewHelper)obj;
	}

	if(helper != null) {
		String indexStr = request.getParameter(INDEX);
		String appType = request.getParameter(APP_TYPE);
		String path = request.getParameter(PATH);
		if (indexStr != null && appType != null && path != null) {
			int index = Integer.parseInt(indexStr);
			StartupApplication app = null;
			String error = null, xml = null;
			
			if(path.endsWith("\\") || path.endsWith("/")) {
				path = path.substring(0, path.length() - 1);
			}
			NetworkHost networkHost = null;
			if(index > -1) {
				networkHost = helper.getNetworkHostById(index);
			}
			error = verifyApp(networkHost, appType, path);
			if (error != null) {
				xml = buildErrorXml(error);
			}else {
				if (index == -1 || networkHost != null) {
					WizardInfo wizardInfo = null;
					try {
						wizardInfo = wmg.getWizardById(appType);
					}catch(Exception e) {
					}
					if (wizardInfo != null) {
						StartupViewHelper.HelperResponseWrapper wrapper = helper.validateApp(wizardInfo, networkHost, appType, path);
						if(wrapper == null) {
							if(index == -1) {
								app = createpp(helper, wizardInfo, null, helper.getLocalApps(), appType, path);
							}else {
								app = createpp(helper, wizardInfo, networkHost, networkHost.getNetworkApps(), appType, path);
							}
							if(app != null) {
								if(index == -1) {
									xml = buildLocalAppXml(helper.getLocalApps().size(), app);
									helper.addLocalApp(app);
								}else {
									xml = buildNetworkAppXml(networkHost.getNetworkApps().size(), index, app);
									networkHost.addApp(app);
								}
							}else {
								xml = buildErrorXml("An error occurred, please try again");
							}
						}else {
							xml = buildErrorXml(wrapper.getMessage());
						}
					}
				}else {
					xml = buildErrorXml("An error occurred, please try again");
				}
			}
			response.setContentType("text/xml");
			out.write(xml);
			out.flush();
		}
	}
%>
