<%@page import="java.net.InetAddress"%>
<%@page import="xpolog.eye.util.XpologUtil"%>
<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.auth.win.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.startup.*"%>

<%!static final String BASE_DIRECTORY = "../";

	private String verifyHost(String osType, String host, int port,
					String username, String password) {
		String verified = null;

		if (osType == null || osType.equals("")) {
			verified = "OS Type was not specified";
		}else if (host == null || host.equals("")) {
			verified = "Host was not specified";
		}else if (!osType.equals("windows")) {
			try {
				InetAddress addr = InetAddress.getByName(host);
				if (username == null || username.equals("")) {
					verified = "Username was not specified";
				}else if (password == null || password.equals("")) {
					verified = "Password was not specified";
				}else {
					if (port < 1 || port > 65535) {
						verified = "Port is not valid (should be a number between 1 and 65535)";
					}
				}
			}catch (Exception e) {
				verified = "Unknown host " + host;
			}
		}else {
			try {
				InetAddress addr = InetAddress.getByName(host);
				if (username == null || username.equals("")) {
					if (password == null || password.equals("")) {
						verified = "Username and password were not specified";
					}else {
						verified = "Username was not specified";
					}
				}else if (password == null || password.equals("")) {
					verified = "Password was not specified";
				}
			}catch (Exception e) {
				verified = "Unknown host " + host;
			}
		}

		return verified;
	}

	private NetworkHost createNetworkHost(int index, String osType, String host,
					int port, String username, String password) {
		NetworkHost networkHost = null;
		AddressBook addBook = AddressBook.getInstance();
		Account acc = null;
		if (osType.toLowerCase().startsWith("windows")) { //auth
			List list = addBook
							.getAccountsByFilter(new WinAuthenticationAccountFilter());
			for (int i = 0; list != null && i < list.size(); i++) {
				acc = (WinAuthenticationAccount)list.get(i);
				if (acc != null
								&& username.equals(((WinAuthenticationAccount)acc).getUser())
								&& password.equals(((WinAuthenticationAccount)acc).getPassword())) {
					break;
				}
				acc = null;
			}
			if (acc == null) {
				acc = new WinAuthenticationAccount();
				((WinAuthenticationAccount)acc).setUser(username);
				((WinAuthenticationAccount)acc).setPassword(password);
				if (username != null && !username.equals("") && password != null
								&& !password.equals("")) {
					acc.setAccountName("auth " + username);
					addBook.addAccount(acc);
					addBook.saveAddressBook();
				}
			}
		}else { //ssh
			if (host != null) {
				List list = addBook.getAccountsByFilter(new TelnetAccountFilter());
				for (int i = 0; list != null && i < list.size(); i++) {
					acc = (TelnetAccount)list.get(i);
					if (acc != null && host.equals(((TelnetAccount)acc).getNetAddress())
									&& username.equals(((TelnetAccount)acc).getUserName())
									&& password.equals(((TelnetAccount)acc).getPassword())) {
						break;
					}
					acc = null;
				}
				if (acc == null) {
					acc = new TelnetAccount();
					((TelnetAccount)acc).setUserName(username);
					((TelnetAccount)acc).setPassword(password);
					((TelnetAccount)acc).setIsSsh(true);
					((TelnetAccount)acc).setNetAddress(host);
					if (port != -1) {
						((TelnetAccount)acc).setPort(port);
					}
					acc.setAccountName("ssh " + username + "@" + host);
					addBook.addAccount(acc);
					addBook.saveAddressBook();
				}
			}
		}
		if (acc != null) {
			networkHost = new NetworkHost();
			networkHost.setIndex(index);
			networkHost.setHost(host);
			networkHost.setAccount(acc);
			networkHost.setOsType(osType);
		}
		return networkHost;
	}

	private String buildHostXml(NetworkHost networkHost) {
		StringBuffer xml = new StringBuffer();
		Account account = networkHost.getAccount();

		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		if (networkHost.getIndex() % 2 == 1) {
			xml.append("<tr class=\"STARTUP_TABLE_COLORED_ROW\">");
		}else {
			xml.append("<tr>");
		}
		xml.append("<td width=\"5\" class=\"STARTUP_BODY_TABLE_TEXT\"><input type=\"checkbox\" name=\"network");
		xml.append(networkHost.getIndex());
		xml.append("_check\" id=\"network");
		xml.append(networkHost.getIndex());
		xml.append("_check\" onClick=\"javascript:checkHost(");
		xml.append(networkHost.getIndex());
		xml.append(", this)\" checked></td>");
		xml.append("<td width=\"500\" class=\"STARTUP_BODY_TABLE_TEXT\">Host: ");
		xml.append(networkHost.getHost());
		xml.append(", OS Type: ");
		xml.append(networkHost.getOsType());
		if (!getAccountDetail(account, "username").equals("")) {
			xml.append(", Username: ");
			xml.append(getAccountDetail(account, "username"));
		}
		xml.append("</td>");
		xml.append("<td width=\"14\" align=\"left\" style=\"padding-right:5\"><a id=\"showNetwork");
		xml.append(networkHost.getIndex());
		xml.append("Applications\" href=\"javascript:hideShowHostApplications(");
		xml.append(networkHost.getIndex());
		xml.append(")\" class=\"STARTUP_TABLE_TEXT_LINK\">Hide</a></td>");
		xml.append("</tr>");
		xml.append("<tr>");
		xml.append("<td colspan=\"3\">");
		xml.append("<div id=\"network");
		xml.append(networkHost.getIndex());
		xml.append("ApplicationsDiv\">");
		xml.append("[BODY]");
		xml.append("</div>");
		xml.append("</td>");
		xml.append("</tr>");
		xml.append("</table>");
		return xml.toString();
	}

	private String buildHostAppsXml(NetworkHost networkHost, WizardInfo[] wizards) {
		StringBuffer xml = new StringBuffer();
		ArrayList networkHostApps = null;
		StartupApplication app = null;

		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		xml.append("<tr>");
		xml.append("<td>");
		if (networkHost == null) {
			xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
			xml.append("<tr>");
			xml.append("<td width=\"4%\"></td>");
			xml.append("<td width=\"90%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">Host could not be accessed</span></td>");
			xml.append("<td width=\"6%\"></td>");
			xml.append("</tr>");
			xml.append("</table>");
		}else {
			networkHostApps = networkHost.getNetworkApps();
			if (networkHostApps.size() == 0) {
				xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
				xml.append("<tr>");
				xml.append("<td width=\"4%\"></td>");
				xml.append("<td width=\"90%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">No applications were found</span></td>");
				xml.append("<td width=\"6%\"></td>");
				xml.append("</tr>");
				xml.append("</table>");
			}else {
				xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
				for (int i = 0; i < networkHostApps.size(); i++) {
					app = (StartupApplication)networkHostApps.get(i);
					String path = app.getPath(), tooltip = "";
					if(!app.isCanBeExecuted() || (app.getMessage() != null && !app.getMessage().equals(""))) {
						if(path == null || path.equals("")) {
							path = app.getMessage();
						}else {
							path = (app.getMessage() + ": " + path);
						}
					}
					if (path.length() > 50) {
						tooltip = path;
						path = path.substring(0, 50) + "...";
					}
					if (i % 2 == 1) {
						xml.append("<tr class=\"STARTUP_TABLE_COLORED_ROW\">");
					}else {
						xml.append("<tr>");
					}
					xml.append("<td width=\"4%\"></td>");
					xml.append("<td width=\"30%\"><input type=\"checkbox\" name=\"network");
					xml.append(networkHost.getIndex());
					xml.append("_");
					xml.append(app.getId());
					xml.append("_check\" id=\"network");
					xml.append(networkHost.getIndex());
					xml.append("_");
					xml.append(app.getId());
					xml.append("_check\" onClick=\"javascript:checkNetworkApp(");
					xml.append(networkHost.getIndex());
					xml.append(", this)\"");
					if(app.isCanBeExecuted()) {
						if(app.isSelected()) {
							xml.append(" checked");
						}
					}else {
						xml.append(" disabled");
					}
					xml.append(">&nbsp;<span class=\"STARTUP_BODY_TABLE_TEXT\">");
					xml.append(app.getName());
					xml.append("</span></td>");
					xml.append("<td width=\"60%\" title=\"");
					xml.append(tooltip);
					xml.append("\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
					xml.append(path);
					xml.append("</span></td>");
					xml.append("<td width=\"6%\"></td>");
					xml.append("</tr>");
				}
				xml.append("</table>");
			}
			
			xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
			xml.append("<tr>");
			if(networkHostApps.size() > 0) {
				xml.append("<td colspan=\"4\">");
			}else {
				xml.append("<td colspan=\"3\">");
			}
			xml.append("<div id=\"network");
			xml.append(networkHost.getIndex());
			xml.append("ManualApplicationsDiv\">");
			xml.append("</div>");
			xml.append("</td>");
			xml.append("</tr>");
			xml.append("</table>");
			
			xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
			xml.append("<tr>");
			xml.append("<td width=\"4%\"></td>");
			xml.append("<td ");
			if(networkHostApps.size() > 0) {
				xml.append("colspan=\"2\" ");				
			}
			xml.append("width=\"90%\" align=\"left\" style=\"padding-left:5\"><a id=\"addManualApp");
			xml.append(networkHost.getIndex());
			xml.append("\" href=\"javascript:showHideAddApp(");
			xml.append(networkHost.getIndex());
			xml.append(")\" class=\"STARTUP_TABLE_TEXT_LINK\">Add Application Manually</a></td>");
			xml.append("<td width=\"6%\"></td>");
			xml.append("</tr>");
			
			xml.append("<tr>");
			xml.append("<td width=\"4%\"></td>");
			xml.append("<td ");
			if(networkHostApps.size() == 0) {
				xml.append("colspan=\"3\"");
			}else {
				xml.append("colspan=\"4\"");
			}
			xml.append(" width=\"90%\">");
			xml.append("<div id=\"add");
			xml.append(networkHost.getIndex());
			xml.append("AppDiv\" style=\"display:none\">");
			xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" height=\"20\">");
			xml.append("<tr>");
			xml.append("<td>");
			xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
			xml.append("<tr style=\"padding-top:5\">");
			xml.append("<td width=\"35%\" style=\"padding-left:5\">");
			xml.append("<span class=\"STARTUP_BODY_TABLE_TEXT\">Application:");
			xml.append("<select name=\"appType");
			xml.append("networkHost.getIndex()");
			xml.append("\" id=\"appType");
			xml.append(networkHost.getIndex());
			xml.append("\" class=\"TEXT_BOX\" size=\"1\">");
			for(int k = 0; k < wizards.length; k++) {
				if(!wizards[k].getID().equals("win_event") && networkHost.isWizardSupportedByHost(wizards[k])) {
					xml.append("<option value=\"");
					xml.append(wizards[k].getID());
					xml.append("\">");
					xml.append(wizards[k].getName());
					xml.append("</option>");
				}
			}
			xml.append("</span>");
			xml.append("</td>");
			xml.append("<td width=\"50%\" style=\"padding-left:5\"><span class=\"STARTUP_BODY_TABLE_TEXT\">Path:<input type=\"text\" name=\"path");
			xml.append(networkHost.getIndex());
			xml.append("\" id=\"path");
			xml.append(networkHost.getIndex());
			xml.append("\" class=\"TEXT_BOX\" size=\"40\"></span></td>");
			
			xml.append("<td width=\"15%\">&nbsp;<span class=\"STARTUP_TABLE_LINK\"><a id=\"add");
			xml.append(networkHost.getIndex());
			xml.append("AppLink\" href=\"javascript:addApp(");
			xml.append(networkHost.getIndex());
			xml.append(")\" class=\"STARTUP_TABLE_TEXT_LINK\">Add</a></td>");
			xml.append("</tr>");
			xml.append("</table>");
			xml.append("</td>");
			xml.append("</tr>");
			
			xml.append("<tr height=\"12\">");
			xml.append("<td ");
			if(networkHostApps.size() == 0) {
				xml.append("colspan=\"3\"");
			}else {
				xml.append("colspan=\"4\"");
			}
			xml.append(" style=\"padding-left:5\"><div id=\"addAppMessageDiv");
			xml.append(networkHost.getIndex());
			xml.append("\" style=\"display:none\"></div></td>");
			xml.append("<td width=\"6%\"></td>");
			xml.append("</tr>");
			
			xml.append("</table>");
			xml.append("</div>");
			xml.append("</td>");
			xml.append("</tr>");
			
			xml.append("</table>");
		}
		xml.append("</td>");
		xml.append("</tr>");
		xml.append("</table>");
		return xml.toString();
	}

	private String getAccountDetail(Account account, String detailId) {
		if (account == null) {
			return "";
		}
		if (account instanceof WinAuthenticationAccount) {
			WinAuthenticationAccount winAccount = (WinAuthenticationAccount)account;
			if (detailId != null) {
				if (detailId.equals("port")) {
					return "";
				}else if (detailId.equals("username")) {
					return winAccount.getUser() + "";
				}else if (detailId.equals("password")) {
					if (winAccount.getPassword() != null
									&& !winAccount.getPassword().equals("")) {
						return "********";
					}
				}
			}
		}else {
			TelnetAccount sshAccount = (TelnetAccount)account;
			if (detailId != null) {
				if (detailId.equals("port")) {
					return Integer.toString(sshAccount.getPort());
				}else if (detailId.equals("username")) {
					return sshAccount.getUserName();
				}else if (detailId.equals("password")) {
					return "********";
				}
			}
		}
		return "";
	}
	
	private String buildErrorXml(String error) {
		StringBuffer xml = new StringBuffer();

		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		xml.append("<tr>");
		xml.append("<td width=\"4%\"></td>");
		xml.append("<td width=\"90%\"><span class=\"STARTUP_BODY_ERROR_TEXT\">");
		xml.append("errorMessage:");
		xml.append(error);
		xml.append("</span></td>");
		xml.append("<td width=\"6%\"></td>");
		xml.append("</tr>");
		xml.append("</table>");
		return xml.toString();
	}%>

<%
	String HOST_NUM = "hostNum";

	SiteManagment mgmt = SiteManagment.getInstance();
	WizardManager wmg = mgmt.getWizardManager(SiteUtil.getBaseDirectory(request));
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	final UserContext userContext = env.getUserContext();

	Object obj = request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
	StartupViewHelper helper = null;
	if(obj != null) {
		helper = (StartupViewHelper)obj;
	}
	if(helper != null) {
		final WizardInfo[] wizards = wmg.getStartupWizards(userContext);
	
		String hostNumStr = request.getParameter(HOST_NUM);
		if (hostNumStr != null) {
			int hostNum = Integer.parseInt(hostNumStr);
			String osType = request.getParameter("osType");
			String host = request.getParameter("host");
			String portStr = request.getParameter("port");
			int port = -1;
			try {
				port = Integer.parseInt(portStr);
			}catch (NumberFormatException nfe) {
				port = -1;
			}
			String username = request.getParameter("username");
			String password = request.getParameter("password");
	
			String error = null, xml = null, xmlBody = null;
	
			error = verifyHost(osType, host, port, username, password);
			if (error != null) {
				xml = buildErrorXml(error);
			}else {
				NetworkHost networkHost = createNetworkHost(hostNum, osType, host, port, username, password);
				if (!helper.isNetworkHostExists(networkHost)) {
					if (networkHost != null) {
						helper.detectNetworkApps(userContext, wizards, networkHost);
						helper.setNumberOfSelectedHosts(helper.getNumberOfSelectedHosts() + 1);
					}
				}else {
					networkHost.setMessage("Host already exists");
				}
	
				if (networkHost.getMessage() == null) {
					xml = buildHostXml(networkHost);
					xmlBody = buildHostAppsXml(networkHost, wizards);
					xml = XpologUtil.replaceAll(xml, "[BODY]", xmlBody);
				}else {
					xml = buildErrorXml(networkHost.getMessage());
				}
			}
			response.setContentType("text/xml");
			out.write(xml);
			out.flush();
		}
	}
%>
