<%@ page language="java"%>

<%@ page import="java.util.ArrayList"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.startup.StartupViewHelper"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!

ArrayList getPageLinks(StartupViewHelper helper, UserContext userContext) {
	ArrayList pageLinks = new ArrayList();
	String[] linksArr = null;
	
	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	
	boolean dashboardEnabled = helper.isDashboardEnabled();
	boolean hasDashboardPermissions = userContext.isHavePermission(DashboardPermissionConstants.DashboardPermissions.SYSTEM_HEALTH_VIEW_DATA_PERMISSION);
	if(dashboardEnabled && hasDashboardPermissions) {
		linksArr = new String[3];
		linksArr[0] = analytics;
		linksArr[1] = analyticsH;
		linksArr[2] = " - View system health summary";
		pageLinks.add(linksArr);
	}
	
	linksArr = new String[3];
	linksArr[0] = "viewer";
	linksArr[1] = "Log Viewer";
	linksArr[2] = " - View all logs created";
	pageLinks.add(linksArr);
	
	boolean hasSearchEnginePermissions = SiteManagment.getInstance().getXpologManagment().isComponentValid("SearchEngine");
	if(hasSearchEnginePermissions) {
		linksArr = new String[3];
		linksArr[0] = "search";
		linksArr[1] = "Search Engine";
		linksArr[2] = " - Run searches on logs";
		pageLinks.add(linksArr);
	}
	
	boolean hasReportsPermissions = userContext.isHavePermission(ActionsPermissionConstants.ToolsPermissions.REPORTS_PERMISSION);
	if(hasReportsPermissions) {
		linksArr = new String[3];
		linksArr[0] = "reports";
		linksArr[1] = "Reports";
		linksArr[2] = " - View application reports";
		pageLinks.add(linksArr);
	}
	boolean hasDiagnosticsPermissions = false;
	if(hasDiagnosticsPermissions) {
		linksArr = new String[3];
		linksArr[0] = "diagnostics";
		linksArr[1] = "Diagnostics";
		linksArr[2] = " - Run problem isolation process";
		pageLinks.add(linksArr);
	}
	
	return pageLinks;
}

%>

<%
String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String heightStr = request.getParameter("height");
String bottomHeightStr = "20";
int topHeight = Integer.parseInt(heightStr) - Integer.parseInt(bottomHeightStr); //347

StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
UserContext userContext = UserEnvironment.getUserContext(request);
ArrayList pageLinks = getPageLinks(helper, userContext);

boolean startWizardAutomatically = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("wizard.startAutomatically", true);
%>

<script>

function goTo(target, focusOpener) {
	var location = "";
	
	if(target == 'configure') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp";
	}else if(target == 'analytics') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>&forward=root.jsp?mainPage=dashboard/view/dashboard.jsp";
	}else if(target == 'viewer') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=view/mainView.jsp";
	}else if(target == 'search') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=SearchEngine";
	}else if(target == 'reports') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp";
	}else if(target == 'diagnostics') {
		location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=diagnostics/diagnosticsResult.jsp";
	}
	try {
		if(opener && !opener.closed) {
			if(referer.name == 'main') {
				referer.parent.location = location;
				if(focusOpener) {
					referer.parent.focus();
				}
				referer = referer.parent;
			}else {
				referer.location = location;
				if(focusOpener) {
					referer.focus();
				}
			}
		}else {
			referer = window.open(location,'Xpolog','left=0,top=0,width=' + screen.availWidth + ',height=' + screen.availHeight + ',resizable=yes,toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes');
			if(focusOpener) {
				referer.focus();
			}
		}
	}catch(err) {
		referer = window.open(location,'Xpolog','left=0,top=0,width=' + screen.availWidth + ',height=' + screen.availHeight + ',resizable=yes,toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes');
		if(focusOpener) {
			referer.focus();
		}
	}
}

</script>

<script>
<%
boolean dashboardEnabled = helper.isDashboardEnabled();
boolean hasDashboardPermissions = userContext.isHavePermission(DashboardPermissionConstants.DashboardPermissions.SYSTEM_HEALTH_VIEW_DATA_PERMISSION);
if(dashboardEnabled && hasDashboardPermissions) {
%>
	goTo('analytics', false);
<%
}else {
%>
	goTo('viewer', false);
<%
}
%>
</script>

<td align="center" valign="top">
	<div id="scroller" style="overflow:auto; width:100%; height:<%=topHeight %>;"> 
	<table border="0" width="100%" cellspacing="0" cellpadding="0">
		<tr style="padding-top:10">
			<td width="3%">&nbsp;</td>
			<td colspan="3">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
					<tr>
						<td style="border-right-style: solid; border-right-width: 1px; border-color: #858585">
							<table border="0" width="100%" cellspacing="0" cellpadding="0" valign="top">
								<tr style="padding-top:2">
									<td width="3%">&nbsp;</td>
									<td>
										<span class="STARTUP_END_TEXT">Configuration ended successfully</span>
									</td>
									<td width="3%">&nbsp;</td>
								</tr>
								<tr style="padding-top:2">
									<td width="3%">&nbsp;</td>
									<td>
										<a href="javascript:goTo('configure', true)" class="STARTUP_END_SMALL_LINK">Configure more</a>
									</td>
									<td width="3%">&nbsp;</td>
								</tr>
								<%
								if(pageLinks.size() > 2) {
									for(int i = 0; i < pageLinks.size() - 2; i++) { 
								%>
								<tr style="padding-top:2"><td width="3%">&nbsp;</td><td>&nbsp;</td><td width="3%">&nbsp;</td></tr>								
								<%
									}
								} 
								%>
							</table>
						</td>
						<td>
							<table border="0" width="100%" cellspacing="0" cellpadding="0">
								<tr style="padding-top:2">
									<td width="3%">&nbsp;</td>
									<td align="left" style="padding-left:5">
										<span class="STARTUP_END_TEXT">or go to:</span>
									</td>
									<%
									String[] linksArr = (String[])pageLinks.get(0);
									%>
									<td>
										<a href="javascript:goTo('<%=linksArr[0] %>', true)" class="STARTUP_END_LINK"><%=linksArr[1] %></a><span class="STARTUP_BODY_TABLE_TEXT"><%=linksArr[2] %></span>
									</td>
									<td width="3%">&nbsp;</td>
								</tr>
								
								<%
								for(int i = 1; i < pageLinks.size(); i++) {
									linksArr = (String[])pageLinks.get(i);
								%>
								<tr style="padding-top:2">
									<td width="3%">&nbsp;</td>
									<td align="left" style="padding-left:5">
									</td>
									<td>
										<a href="javascript:goTo('<%=linksArr[0] %>', true)" class="STARTUP_END_LINK"><%=linksArr[1] %></a><span class="STARTUP_BODY_TABLE_TEXT"><%=linksArr[2] %></span>
									</td>
									<td width="3%">&nbsp;</td>
								</tr>
								<%
								}
								%>
							</table>
						</td>
					</tr>
				</table>
			</td>
			<td width="3%">&nbsp;</td>
		</tr>
	</table>
	</div>
	<table border="0" width="100%" height="<%=bottomHeightStr %>" cellspacing="0" cellpadding="0">
		<tr>
			<td width="3%">&nbsp;</td>
			<%
			String checked = "";
			if(!startWizardAutomatically) {
				checked = "checked";
			}
			%>
			<td><input type="checkbox" name="startWizardAutomatically" <%=checked %>/><span class="STARTUP_BODY_TABLE_TEXT">&nbsp;Don't start Automatic Configuration Wizard when Xpolog starts</span></td>
			<td width="3%">&nbsp;</td>
		</tr>
	</table>
</td>
