<%@ page language="java"%>

<%@ page import="java.io.BufferedReader"%>
<%@ page import="java.io.File"%>
<%@ page import="java.io.FileReader"%>

<%@ page import="java.util.Date"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
File outputDir = new File(Configuration.XPOLOG_ROOT_PATH + "/log/dump/");
File outputFile = new File(outputDir, "logSizes.txt");
%>

<html>
<head>

<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>

<script>
function startLogSizesAction() {
	sendAjaxRequest("logSizesAction.jsp", function(req){
		updateLogSizesStatus();
	});
}

function stopLogSizesAction() {
	doBackgroundAction("logSizesActionStop.jsp");
}

function updateLogSizesStatus() {
	sendAjaxRequest("logSizesActionStatus.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
	    var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var isRunning = responseElement.getAttribute("isRunning");
				var numberOfLogs = responseElement.getAttribute("numberOfLogs");
				var numberOfLogsProcessed = responseElement.getAttribute("numberOfLogsProcessed");
				var totalSize = responseElement.getAttribute("totalSize");
				var errorMessage = responseElement.getAttribute("errorMessage");
				
				var	innerHtml = "";
				if(!errorMessage || errorMessage == "") {
					innerHtml = "Processed " + numberOfLogsProcessed + " out of " + numberOfLogs + " logs:<br>";
				
					var logInfos = responseElement.getElementsByTagName("LogInfo");
					var logInfoElement;
					var logId, logName, host, size;
					for(var i = 0; i < logInfos.length; i++) {
						logInfoElement = logInfos[i];
	
						logId = logInfoElement.getAttribute("logId");
						logName = logInfoElement.getAttribute("logName");
						host = logInfoElement.getAttribute("host");
						size = logInfoElement.getAttribute("size");
	
						innerHtml += ((i + 1) + ". " + logName + " (" + logId + ") on host " + host + ": " + size + "<br>");
					}

					innerHtml += "<br>Total Size: " + totalSize;

					if(isRunning && isRunning == "false") {
						innerHtml += "<br><br>Processing completed!";
						innerHtml += "<br><br>Result written to file: <%=outputFile.getAbsolutePath().replaceAll("\\\\", "/") %>";
					}else {
						innerHtml += "<br><br>Processing...";
						innerHtml += "<br><br><a href=\"javascript:stopLogSizesAction()\">Stop processing</a>";
					}
				}else {
					innerHtml = "An error occured:<br>" + errorMessage; 
				}
				document.getElementById("logSizesDiv").innerHTML = innerHtml;
				if(isRunning && isRunning == "true") {
					setTimeout("updateLogSizesStatus()", 1000);
				}
			}
	  }
	});
}
</script>
</head>

<body>
<div id="logSizesDiv" style="font-family:Tahoma,Verdana,Helvetica; font-size:14px; ">
	<a href="javascript:startLogSizesAction()">Activate Log Sizes Inspection</a>
<%
if(outputFile.exists()) {
%>
	<br>
	<br>
	<u>Previous inspection results from <%=new Date(outputFile.lastModified()) %> (read from <%=outputFile.getAbsolutePath().replaceAll("\\\\", "/") %>)</u>
	<br>
	<br>
<%
	BufferedReader reader = null;
	try {
		reader = new BufferedReader(new FileReader(outputFile));
		String line = null;
		while((line = reader.readLine()) != null) {
%>
		<%=line %><br>
<%
		}
	}catch (Exception e) {
		ErrorModel.log.error("Failed to read log sizes file", e);
	}finally {
		if(reader != null) {
			reader.close();
		}
	}
}
%>
</div>
</body>
</html>