<%@ page language="java"%>

<%@ page import="java.io.File"%>
<%@ page import="java.io.FileOutputStream"%>
<%@ page import="java.io.PrintWriter"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.util.hosts.HostInfo"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";

void writeToFile(HashMap logInfos) {
	File outputDir = new File(Configuration.XPOLOG_ROOT_PATH + "/log/dump/");
	if(!outputDir.exists()) {
		outputDir.mkdirs();
	}
	File outputFile = new File(outputDir, "logSizes.txt");
	PrintWriter pw = null;
	try {
		pw = new PrintWriter(outputFile);
		List logInfosList = (List)logInfos.get("logInfosList");
		if(logInfosList != null) {
			HashMap logInfo = null;
			long totalSize = 0;
			for(int i = 0; i < logInfosList.size(); i++) {
				logInfo = (HashMap)logInfosList.get(i);
				
				String logId = (String)logInfo.get("logId");
				String logName = (String)logInfo.get("logName");
				String host = (String)logInfo.get("host");
				long size = ((Long)logInfo.get("size")).longValue();
				
				String line = (i + 1) + ". " + logName + " (" + logId + ") on host " + host + ": " + XpologUtil.formatSize(size);
				pw.println(line);
				
				if(size > 0) {
					totalSize += size;
				}
			}
			
			pw.println();
			pw.println("Total Size: " + XpologUtil.formatSize(totalSize));
		}
	}catch(Exception e) {
		ErrorModel.log.error("Failed to write log sizes file", e);
	}finally {
		if(pw != null) {
			pw.flush();
			pw.close();
		}
	}
}
%>

<%
final String LOG_INFOS = "LOG_INFOS";

WebSecurityManager securityManager = WebSecurityManager.getInstance();
if (!securityManager.checkForPermission(request,response,null,true)){
  return;
}

final HashMap logInfos = new HashMap();
logInfos.put("running", new Boolean(true));
logInfos.put("logInfosList", new ArrayList());
logInfos.put("errorMessage", "");

session.setAttribute(LOG_INFOS, logInfos);
new Thread(new Runnable() {
	public void run() {
		try {
			SiteManagment siteManagement = SiteManagment.getInstance();
			ModuleMember[] logs = siteManagement.getAllLogBrowsersIds();
			logInfos.put("numberOfLogs", new Integer(logs.length));

			HostInfo[] hostInfos = HostsManager.getInstance().getAllHostInfos();
			HostInfo hostInfo = null;
			List logIds = null;
			String logId = null;
			LogBrowsingManager lbm = null;
			long size = -1;
			HashMap logInfo = null;
			boolean stop = false;
			Boolean stopObj = (Boolean)logInfos.get("stop");
			if(stopObj != null) {
				stop = stopObj.booleanValue();
			}
			for(int i = 0; !stop && i < hostInfos.length; i++) {
				hostInfo = hostInfos[i];
				logIds = hostInfo.getLogIds();
				if(logIds == null) {
					continue;
				}
				for(int j = 0; !stop && j < logIds.size(); j++) {
					lbm = null;
					size = -1;
					logInfo = null;
					
					logId = (String)logIds.get(j);
					try {
						lbm = siteManagement.getLogBrowserManager(logId);
						if(lbm == null || lbm.getLinearDataBuilder() == null || lbm.getLinearDataBuilder().getLinearDataSource() == null) {
							continue;
						}
						if(lbm.getType() != null && lbm.getType().equals(MergedLogBrowserBuilder.MERGE_LOG_TYPE)) {
							continue;
						}
						lbm.getLinearDataBuilder().getLinearDataSource().update();
						size = lbm.getLinearDataBuilder().getLinearDataSource().getSize();
						
						logInfo = new HashMap();
						logInfo.put("logId", logId);
						logInfo.put("logName", lbm.getName());
						logInfo.put("host", hostInfo.getName());
						logInfo.put("size", new Long(size));
						
						List logInfosList = (List)logInfos.get("logInfosList");
						logInfosList.add(logInfo);
					}catch(InterruptedException e) {
						logInfos.put("running", new Boolean(false));
						return;
					}catch(Exception e) {
						logInfo = new HashMap();
						logInfo.put("logId", logId);
						logInfo.put("logName", "N/A");
						logInfo.put("host", hostInfo.getName());
						logInfo.put("size", new Long(-1));
						
						List logInfosList = (List)logInfos.get("logInfosList");
						logInfosList.add(logInfo);
					}catch(Throwable t) {
						ErrorModel.log.error("Failed to check log size of " + logId, t);
					}finally {
						if(lbm != null) {
							lbm.dispose();
						}
					}
					
					writeToFile(logInfos);
					
					stopObj = (Boolean)logInfos.get("stop");
					if(stopObj != null) {
						stop = stopObj.booleanValue();
					}
				}
			}
			
			//writeToFile(logInfos);
			
			logInfos.put("running", new Boolean(false));
		}catch(Throwable t) {
			ErrorModel.log.error("Failed to check log sizes", t);
			logInfos.put("running", new Boolean(false));
			logInfos.put("errorMessage", t.getMessage());
		}
	}
}, "LogSizesThread"){}.start();

%>