<%@ page language="java"%>

<%@ page import="java.io.File"%>
<%@ page import="java.util.ArrayList"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.XpoLogClusterNodeInfo"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.Module"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.SiteAdministrator"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%
String PARENT_MODULE_NAME = "XpoLog System Logs";

UserContext userContext = UserEnvironment.getUserContext(request);

boolean success = false;
String message = "";

SiteManagment mgmt = SiteManagment.getInstance();
Module rootModule = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
if(rootModule != null) {
	ModuleMember mm = rootModule.getMemberByName(PARENT_MODULE_NAME);
	if(mm != null) {
		message = "The XpoLog System Logs folder already exists";
		
		String xml = GridModelActionsHelper.getResultXML(success,message);	
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");

		out.write(xml);
		out.flush();
		return;
	}
}

SiteAdministrator admin = SiteManagment.getAdminInstance();

boolean isCluster = Configuration.getInstance().isCluster();

// add the parent module
Module parentModule = new Module();
parentModule.setName(PARENT_MODULE_NAME);
String parentModuleId = admin.addModule(parentModule, rootModule, userContext);
if(parentModuleId != null && parentModuleId.length() > 0) {
	ArrayList list = new ArrayList();
	if (isCluster){
		XpoLogClusterNodeInfo [] nodes = SiteManagment.getInstance().getClusterNodes();
	  if (nodes != null){
	  	for(int i = 0; i < nodes.length;i++){
	  		String clusterNodeName = nodes[i].getName();
	  		
	  		parentModule = mgmt.getModuleFromId(parentModuleId);
	  		
	  		Module currentNodeModule = new Module();
	  		currentNodeModule.setName(clusterNodeName);
	  		admin.addModule(currentNodeModule, parentModule);
	  		
	   		String clustePrefix = clusterNodeName + "_";
	   	  list.add(clustePrefix + "xpologlog");
	   		list.add(clustePrefix + "events");
	   		list.add(clustePrefix + "audit");
	   		list.add(clustePrefix + "systemaudit");
	   		list.add(clustePrefix + "ssh");
	   		list.add(clustePrefix + "XpoLogMemory");
	   		list.add(clustePrefix + "systemalerts");
	   		
	   		Thread.sleep(10);
	    }
	 	}	  
	}else {
		list.add("xpologlog");
		list.add("events");
		list.add("audit");
		list.add("systemaudit");
		list.add("ssh");
		list.add("XpoLogMemory");
		list.add("systemalerts");
	}
	
	list.add("MergeLogs");
	if (!Configuration.isWar()){
		list.add("ServletContainer");
		list.add("Ant.out");
	}
	list.add("localhostCpu");
	list.add("localhostMemory");
	list.add("localhostDiskSpace");
	
	String logId = null;
	File systemLogsDirectory = new File(Configuration.XPOLOG_ROOT_PATH + "conf/systemlogs");
	if(!systemLogsDirectory.exists()) {
		message = "The system logs directory does not exist";
		
		String xml = GridModelActionsHelper.getResultXML(success,message);	
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");

		out.write(xml);
		out.flush();
		return;
	}
	File file = null;
	LogBrowsingManager lbm = null;
	for(int i = 0; i < list.size(); i++) {
		parentModule = mgmt.getModuleFromId(parentModuleId);
		logId = (String)list.get(i);
		
		if(isCluster) {
			int index = logId.lastIndexOf("_");
			if(index > 0) {
				String clusterNodeName = logId.substring(0, index);
				ModuleMember clusterNodeModuleMember = parentModule.getMemberByName(clusterNodeName);
				if(clusterNodeModuleMember != null) {
					Module clusterNodeModule = mgmt.getModuleFromId(clusterNodeModuleMember.getId());
					if(clusterNodeModule != null) {
						parentModule = clusterNodeModule;
					}
				}
			}
		}
		
		file = new File(systemLogsDirectory, logId + ".xml");
		if(!file.exists()) {
			continue;
		}
		try {
			lbm = mgmt.getLogBrowserFromFile(file);
		}catch(Exception e) {
			continue;
		}
		if(lbm != null) {
			lbm.setID(logId + "_" + String.valueOf(System.currentTimeMillis()));
			lbm.setUseIndexing(true);
			admin.addLogBrowser(lbm, parentModule, userContext);
			lbm.dispose();
		}
	}
	success = true;
	message = "Operation completed successfully";
	String xml = GridModelActionsHelper.getResultXML(success,message);	
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");

	out.write(xml);
	out.flush();
}

%>