<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.util.ArrayList"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}
  
	String clusterNode = request.getParameter("clusterNode");
	if (clusterNode == null){
		clusterNode = "";
	}

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null
			&& !user.getUser().isAdmin()) {
		response.sendRedirect(BASE_DIRECTORY
				+ "security/common/accessDenied.jsp");
		return;
	}
	SiteManagment mgmt = SiteManagment.getInstance();
	boolean isUseDasboard = mgmt.getXpologManagment().isDashboardValidAndComponentExists();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.VIEW, "view support", AuditConstants.SUPPORT_CONSOLE, "view data support");
  

%>



<div id="indexingDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="indexingInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>


<%
	if (isUseDasboard) {
%>
<div id="dashboardLogsDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="dashboardLogsInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>
<div id="dashboardHostsDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="dashboardHostsInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>
<%
	}
%>

<div id="monitorsDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="monitorsInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>

<div id="reportsDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="reportsInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>

<div id="collectionsDiv" style="display: none; height: 100%; width: 100%; overflow: auto">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td style="padding: 10"><jsp:include page="collectionsInformation.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
    </jsp:include></td>
  </tr>
</table>
</div>


<%
	ArrayList idsList = new ArrayList();
	ArrayList namesList = new ArrayList();
	ArrayList widthsList = new ArrayList();
	idsList.add("indexingDiv");
	namesList.add("Indexing");
	widthsList.add("120");
	
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

	if (isUseDasboard) {
		idsList.add("dashboardLogsDiv");
		namesList.add(analyticsH + " Logs");
		widthsList.add("150");
    
		idsList.add("dashboardHostsDiv");
		namesList.add(analyticsH + " Hosts");
		widthsList.add("150");
	}
  
	idsList.add("monitorsDiv");
	namesList.add("Monitors");
	widthsList.add("120");
  
	idsList.add("reportsDiv");
	namesList.add("Reports");
	widthsList.add("120");
  
	idsList.add("collectionsDiv");
	namesList.add("Collections");
	widthsList.add("120");
  
  String [] tabIds = (String [])idsList.toArray(new String[idsList.size()]);
  String [] tabNames = (String [])namesList.toArray(new String[namesList.size()]);
  String [] tabWidths = (String [])widthsList.toArray(new String[widthsList.size()]);
  
  request.setAttribute("tabIds",tabIds);
  request.setAttribute("tabNames",tabNames);
  request.setAttribute("tabWidths",tabWidths);
%>
<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>
