<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.managment.XpoLogClusterNodeInfo"%>
<%@page import="xpolog.eye.support.SupportHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%><html>


<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	
	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
		response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
		return;
	}
  SiteManagment mgmt = SiteManagment.getInstance();
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
  
	String selectedTabId = request.getParameter("selectedTabId");
	if (selectedTabId == null || selectedTabId.length() == 0){
		selectedTabId = "0";
	}
	
	String selectedSupportType = request.getParameter("selectedSupportType");	
	if (selectedSupportType == null || selectedSupportType.length() == 0){
		selectedSupportType = "basic";
	}
  
	XpoLogClusterNodeInfo [] clusterNodes = SiteManagment.getInstance().getClusterNodes();
	String selectedCluster = request.getParameter("clusterNode");
  if (clusterNodes != null && clusterNodes.length > 0 ){
    if (selectedCluster == null || selectedCluster.length() == 0){
    	selectedCluster = selectedSupportType.equals("basic") ? "all" :  Configuration.getMachineNameUid(); 
    }	
  }else {
	  selectedCluster = "";
  }
  
  String masterName = "";
  try {
    masterName = Configuration.getMasterName();     
  }catch (Exception e){
     ErrorModel.log.error("failed to get master name",e); 
  }
  
  String curretnName = Configuration.getMachineNameUid();
  
  int keepAliveInterval = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("keepAliveInterval",300000);

%>

<head>
<title>XpoLog Center Support</title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/progress.js" type="text/javascript"></script>
<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="useTree" value="true" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>support/supportExport.js" type="text/javascript"></script>
<script>

  baseDirectory = "<%=BASE_DIRECTORY%>";
	
	function exportAll(fileFromLast,selectedLogs){
		runExportAction("fileFromLast=" + fileFromLast + "&selectedLogs=" + selectedLogs);
	}

	function openExportLight(){
		showGeneralAdminDiv('exportLight');
		document.getElementById("exportSelectedLogs").value = "";
	}

	function hideExportLight(){
		showGeneralAdminDiv('exportLight');
	}

	function exportAllLight(){
    var combo = document.getElementById("filesFromLast");    
    if (combo && combo.value && combo.value != ""){
      var val = combo.value;
      var selectedLogs = document.getElementById("exportSelectedLogs").value;
      hideExportLight();
      exportAll(val,selectedLogs);
    }else {
    	hideExportLight();
    }    
	} 
	
	function refresh(tabNum){
	  this.location =  "index.jsp?selectedTabId=" + tabNum;
	}
	
	function init(){
		initTabs();
		initMenus();
		initTables();
		initSupport();
  }
  
var initSupportFunctions = new Array();

function initSupport(){
   for (var i = 0; i < initSupportFunctions.length;i++){
	    eval(initSupportFunctions[i]);
	  }
}


function addInitSupportFunction(func){
  initSupportFunctions[initSupportFunctions.length] = func;
}

var selectedSupportType = "<%=selectedSupportType%>";
var selectedCluster = "<%=selectedCluster%>";
function changeSupportType(combo){
  if (combo && combo.value && combo.value != "" && selectedSupportType != combo.value){
    var url = "index.jsp?selectedSupportType=" + combo.value;
    <%if (clusterNodes != null && clusterNodes.length > 0){%>
      url = url + "&clusterNode=" + selectedCluster;
    <%}%>
    this.location = url;
    
  }
}

function changeClusterNode(combo){
    if (combo && combo.value && combo.value != "" && selectedCluster != combo.value){
      var url = "index.jsp?selectedSupportType=" + selectedSupportType;
      url = url + "&clusterNode=" + combo.value;
      this.location = url;
      
    }
  }


function showActionMessage(title,gridName,yesFunction,msg){
  var msgWriter = createActionMessage(title,gridName,yesFunction);
	msgWriter.showMessage(msg);
}

function createActionMessage(title,gridName,yesFunction){
	var msgWriter = new messageWriter("mygridMessage",title,"<%=BASE_DIRECTORY%>");
	msgWriter.setYParent(document.getElementById(gridName),50);
	msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:" + yesFunction);
  msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");
  msgWriter.setSize(600,120);  
  return msgWriter;    
}

function showErrorMessage(title,gridName,msg,width,height){
    var msgWriter = new messageWriter("mygridMessage",title,"<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById(gridName),50);
    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
    msgWriter.width = width;
    msgWriter.height = height;
    msgWriter.showMessage(msg);
  }

function workingSupportData(suffix,url,params,func){
    var page = url;
    if (!page || page == ""){
        return;
    }
    
    sendAjaxRequest(page,function(req){
    	  hideLayer('mygridMessage');
        var xmldoc = req.responseXML.documentElement;             
        var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
        var message = xmldoc.getElementsByTagName('message')[0].text;
        if (result == "true"){
          var grid = eval("mygrid" + suffix);
          if (grid){                           
            eval("updateTable" + suffix + "()");                                
          }
          if(func){
              func();
          } 
   
        } else if (xmldoc.getElementsByTagName('message')[0].firstChild){
          var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
          showErrorMessage("Error Information","mygrid_" + suffix,message,500,150);                        
        }
    },'POST',params);
}

function keepAliveBack(){
  doBackgroundAction("../security/common/keepAliveBack.jsp");
  setTimeout("keepAliveBack()",<%=keepAliveInterval %>);
}

setTimeout("keepAliveBack()",<%=keepAliveInterval%>);

  
</script>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
</head>

<jsp:include page="../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
      <jsp:param name="title" value="Export All Information"/> 
      <jsp:param name="suffix" value="exportLight"/> 
      <jsp:param name="includePath" value="support/exportLightEdit.jsp"/>      
      <jsp:param name="width" value="350px"/> 
      <jsp:param name="height" value="100px"/>
      <jsp:param name="zIndex" value="300"/>  
      <jsp:param name="actionsNames" value="Export#Cancel"/> 
      <jsp:param name="actions" value="javascript:exportAllLight()#javascript:hideExportLight()"/> 
      </jsp:include>
<body onLoad="init();" onUnload="destroyTables()" style="margin:0;padding:0;">
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0;" method="POST">
  <input type="hidden" name="doSave">
  <input type="hidden" name="logName">
	<input type="hidden" name="computationType">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr height="1">
		<td>
			<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse: collapse" width="100%"	background="<%=BASE_DIRECTORY%>images/admin/LogAdmin/adminTitle.gif">
	<tr height="24px">
		<td width="30px">&nbsp;</td>
		<td width="9px" background="<%=BASE_DIRECTORY%>images/admin/LogAdmin/adminTitleIcon.gif">&nbsp;</td>
		<td width="100px" style="padding-left:8px" class="WHITE_HEADER">Support</td>
		<td width="100px" style="padding-left:8px" class="WHITE_HEADER">
<select class="TEXTBOX" size="1" name="supportType" id="supportType" style="font-size: 8pt" onChange="javascript:changeSupportType(this)">
			<option value="basic" <%=selectedSupportType.equals("basic") ? "selected" : ""%>>Basic Information</option>
			<option value="activity" <%=selectedSupportType.equals("activity")? "selected" : ""%>>Activity Information</option>
			<option value="data" <%=selectedSupportType.equals("data")? "selected" : ""%>>Data Information</option>			
			<option value="advancedSettings" style="color:red" <%=selectedSupportType.equals("advancedSettings")? "selected" : ""%>>Advanced Settings</option>
		</select>
    </td>
    <% if (clusterNodes != null && clusterNodes.length > 0 && (selectedSupportType.equals("activity") || selectedSupportType.equals("basic"))){ %>    
    <td width="100px" style="padding-left:8px" class="WHITE_HEADER">
<select class="TEXTBOX" size="1" name="supportType" id="supportType" style="font-size: 8pt" onChange="javascript:changeClusterNode(this)">
       <%if (selectedSupportType.equals("activity")){
        for (int i = 0 ; i < clusterNodes.length;i++){%>
        <option value="<%=clusterNodes[i].getName()%>" <%=selectedCluster.equals(clusterNodes[i].getName()) || (selectedCluster.equals("all") && Configuration.getMachineNameUid().equals(clusterNodes[i].getName())) ? "selected" : ""%>><%=clusterNodes[i].getName()%><%=masterName.equals(clusterNodes[i].getName()) ? " (Master)" : ""%></option>
        <%} 
       }else if (selectedSupportType.equals("basic")){ %>
    	   <option value="all" <%=selectedCluster.equals("all") ? "selected" : ""%>>All Cluster Logs (Current - <%=curretnName%>)</option>
        <%for (int i = 0 ; i < clusterNodes.length;i++){%>
        <option value="<%=clusterNodes[i].getName()%>" <%=selectedCluster.equals(clusterNodes[i].getName()) ? "selected" : ""%>><%=clusterNodes[i].getName()%> Logs <%=masterName.equals(clusterNodes[i].getName()) ? " (Master)" : ""%></option>
        <%} 
       }%>
    </select>
    </td>
    <%}else if (selectedSupportType.equals("advancedSettings")){ %>
     <td width="300px" style="padding-left:15px">
     <span class="ERRORMESSAGE" style="font-size:8pt;color:white"><nobr>Advanced settings changes require XpoLog restart. Please consult with XpoLog Support prior to any changes on this section.</nobr></span>
     </td>
    <%} %>
		<td width="*">&nbsp;</td>
	</tr>
</table>									
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0;">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>											
					<tr style="background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;"></div>
							  <% if (selectedSupportType.equals("basic")){ %>
							      <jsp:include page="basic/basicTabs.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
                <jsp:param name="clusterNode" value="<%=selectedCluster%>" />
								</jsp:include>
							  <%} else if (selectedSupportType.equals("activity")){ %>
							      <jsp:include page="activity/activityTabs.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
                <jsp:param name="clusterNode" value="<%=selectedCluster%>" />
								</jsp:include>
							  <%} else if (selectedSupportType.equals("data")){ %>
							      <jsp:include page="data/dataTabs.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
                <jsp:param name="clusterNode" value="<%=selectedCluster%>" />
								</jsp:include>
                 <%} else if (selectedSupportType.equals("advancedSettings")){ %>
                    <jsp:include page="advancedSettings/advancedTabs.jsp" flush="true">
                <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
                <jsp:param name="clusterNode" value="<%=selectedCluster%>" />
                </jsp:include>
							  <%}%>																
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Export All Information#Export All Light" />
				<jsp:param name="actions" value="javascript:exportAll(-1,'')#javascript:openExportLight()" />
			</jsp:include>											
		</td>
	</tr>
</table>

<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr height="20">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" id="messageTitle"></span>
		</td>
	</tr>
	<tr height="*" style="padding:5">
		<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
		</td>
	</tr>											
	<tr height="10">
		<td align="center" style="padding:5"><nobr>
			<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
			</nobr>		  							
		</td>
	</tr>
</table>
</div>
</form>
<form name="downloadFile">
</form>
</body>
</html>
