<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.scan.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String PREFIX = "taskScan_";
	String ERROR_OBJ = "ERROR_OBJ";
	String IS_SSH = "IsSsh";
	
	
	String Name,Description,scanPath,parentModuleId,Id,accountId;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	scanPath = request.getParameter(PREFIX + "fullPath_0");
	Id = request.getParameter("Id");
	parentModuleId = request.getParameter("MODULE_ID");
	
	String isSshStr = request.getParameter(IS_SSH);
	boolean isSsh = (isSshStr != null && isSshStr.equals("true"));
	accountId = request.getParameter(PREFIX + "AccountsList");
	String addOptionalParamsStr = request.getParameter("addOptionalParams");
	boolean addOptionalParams = (addOptionalParamsStr != null && addOptionalParamsStr.equals("on"));
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
 	}
	if(isSsh && (accountId == null || accountId.equals(""))){
   	errmodel.addError("SSH account was not supplied");
 	}
 	if(scanPath == null || scanPath.equals("")){
   	errmodel.addError("Log location scan path was not supplied");
 	}

 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tasks/xpotasksview.jsp");
   	return;
 	}
	
	ScanTask task = null; 
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null){
		task = (ScanTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new ScanTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setScanPath(scanPath);
	task.setParentModuleId(parentModuleId);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "exe task added/edited " + Name);

  if (isSsh){
		response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=sshExe");
  }else{
		response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=exe");
  }
%>	