<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.logic.session.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.DBAccount"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.admin.system.LogicCreatorManager"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	
	String TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";
	
	boolean showMessage = false;
	boolean canContinue = true;
	String message = "";
	
	DBAccount	dbAccount = (DBAccount)AddressBook.getInstance().getAccountById("xpologicDB");
	boolean dbConnected = false;
	if (dbAccount != null){
		dbConnected = LogicCreatorManager.getInstance().getTxExpoConnectionStatus(dbAccount);
	}
	if(!dbConnected) {
		showMessage = true;
		canContinue = false;
    message = "Failed to connect to database, pelase verify its connection";
	}
	
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}
	
 	CtrlMgr ctrl = ConfigMgr.getInstance().getCtrlMgr();
  Workspace[] wslist = ctrl.getWorkspaces();
  int wsCount = 0;
  if(wslist != null) {
	 	for(int i = 0; i < wslist.length; i++) {
  		if(wslist[i] != null && !wslist[i].getId().equals("0")) {
	  		wsCount++;
  		}
  	}
  }
  if(wslist == null || wsCount == 0 || wslist[0] == null){
  	if(!showMessage) {
  		showMessage = true;
  		canContinue = false;
    	message = "There must be at least one existing workspace and project, please add them in <a target=\"_parent\" href=\"" + baseDirectory + "componentAction.jsp?selectedCompId=TransactionExpo\" class=\"LINK\">TxExpo</a>";
  	}
  }
  
  SessionResultTask task = (SessionResultTask)request.getAttribute("CURRENT_TASK");
  String taskId = "";
  if(task != null) {
  	taskId = task.getId();
   	String wsId = task.getWorkspaceId();
   	DataSession[] dsbyws = ctrl.getDataSessionsByWorkspace(wsId);
   	if(dsbyws == null || dsbyws.length == 0){
   		if(!showMessage) {
   			showMessage = true;
   			canContinue = true;
   			message = "The project does not exist, please select another project";
   		}
   	}
	}
  
%>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>

<script>
	function updateTaskDetails() {
		if(typeof wsTree == "undefined") {
			return "Task cannot be saved";
		}
		updateWorkspaces();
		if(!document.access.projects.value || document.access.projects.value == "") {
			return "No project was selected";
		}
		return "";
	}
	
	function updateWorkspaces(){
		document.access.workspaces.value = "";
		document.access.projects.value = "";
		
		list = wsTree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
	  var wsStr = "";
	  var projStr = "";
	  	  
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=TYPE_WORKSPACE%>"){
					if (wsStr != ""){
						wsStr += ",";
					}
					wsStr += id;
					if (wsTree.hasChildren(s) && wsTree.hasChildren(s)==true){
	 				wsStr += "*";
					}
				}else{
					if (type == "<%=TYPE_PROJECT%>"){
						if (projStr != ""){
							projStr += ",";
						}
						projStr += id;
						if (wsTree.hasChildren(s) && wsTree.hasChildren(s)==true){
		 				projStr += "*";
						}
					}
				}
			}
			document.access.workspaces.value = wsStr;
			document.access.projects.value = projStr;
		}
	}
</script>

<input type="hidden" id="workspaces" name="workspaces" value="">
<input type="hidden" id="projects" name="projects" value="">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<%if(showMessage) { %>
	<tr height="10">
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
			  	<td><span class="ERROR_MSG"><%=message %></span></td>
			  </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
<%} %>

<%if(canContinue) {%>
	<tr height="10">
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
			  	<td><span class="REGULARTEXT">Please select the project to be executed</span></td>
			  </tr>
			  <tr height="10">
        	<td width="15%">
          	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
            	<tr>
								<td>&nbsp;</td>
							</tr>  
							<tr>
								<td valign="top">
									<div id="wsLoadingDiv" style="display:none">
										<span class="REGULARTEXT">Loading...</span>
									</div>
								</td>
							</tr>
              <tr>
              	<td class="REGULARTEXT">
                	<div id="treeboxboxWS_tree"></div>
                  </td>
              </tr>
            </table>
          </td>
        </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
<script>
	wsTree=new dhtmlXTreeObject("treeboxboxWS_tree","100%","100%","0");
	wsTree.setOnLoadingStart(startLoading);
	wsTree.setOnLoadingEnd(endLoading);		
	wsTree.setImagePath("<%=baseDirectory %>");
	wsTree.enableRadioButtons(true);
	wsTree.enableSingleRadioMode(true);
	wsTree.setIconSize(12,12);
	wsTree.enableTreeLines(false);
	wsTree.loadingDivName="wsLoadingDiv";
	<%if(dbConnected){ %>
		wsTree.setXMLAutoLoading("<%=baseDirectory %>tasks/session/workspaceTreeXml.jsp?taskId=<%=taskId %>");
		wsTree.loadXML("<%=baseDirectory %>tasks/session/workspaceTreeXml.jsp?taskId=<%=taskId %>");
	<%}%>
</script>
<%}%>
</table>