<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.*"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccount"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,snmpMsg,snmpOid,snmpCommunity,Id,accId ;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	snmpMsg = request.getParameter("snmpMsg");
	snmpOid = request.getParameter("snmpOid");
	snmpCommunity = request.getParameter("snmpCommunity");
	accId = request.getParameter("snmpAccountId");
	Id = request.getParameter("Id");
	
	String numOfVariablesStr = request.getParameter("numOfVariables");
	int numOfVariables = Integer.parseInt(numOfVariablesStr);
	String maxVariableIndexStr = request.getParameter("maxVariableIndex");
	int maxVariableIndex = Integer.parseInt(maxVariableIndexStr);
	SNMPTaskVariable[] snmpTaskVariables = null;
	SNMPTaskVariable snmpTaskVariable = null;
	if(numOfVariables > 0) {
		String variableVisibleStr, oid, name, description, type, message;
		boolean variableVisible;
		snmpTaskVariables = new SNMPTaskVariable[numOfVariables];
		int index = 0;
		for(int i = 1; i <= maxVariableIndex; i++) {
			variableVisibleStr = request.getParameter("variable" + i + "Visible");
			variableVisible = new Boolean(variableVisibleStr).booleanValue();
			if(variableVisible) {
				oid = request.getParameter("variableOid" + i);
				name = request.getParameter("variableName" + i);
				description = request.getParameter("variableDescription" + i);
				type = request.getParameter("variableType" + i);
				message = request.getParameter("variableMessage" + i);
				
				snmpTaskVariable = new SNMPTaskVariable();
				snmpTaskVariable.setOid(oid);
				snmpTaskVariable.setName(name);
				snmpTaskVariable.setDescription(description);
				snmpTaskVariable.setType(type);
				snmpTaskVariable.setMessage(message);
				
				snmpTaskVariables[index++] = snmpTaskVariable;
			}
		}
	}

	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("No Name was supplied.");
 	}

 	/*if(snmpMsg == null || snmpMsg.equals("")){
   	errmodel.addError("SNMP message was not supplied.");
 	}*/
 	
 	SNMPAccount account = null;
 	if(accId == null || accId.equals("")){
   	errmodel.addError("SNMP account was not selected.");
 	}else {
 		account = (SNMPAccount)AddressBook.getInstance().getAccountById(accId);
 	 	if(account == null) {
 	 		errmodel.addError("SNMP account does not exist.");
 	 	}else {
 	 		if(account.getVersion() != SNMPAccount.SNMP_VERSION_1 && (snmpOid == null || snmpOid.length() == 0)) {
	 	 		errmodel.addError("SNMP OID must be specified if the selected account is of version 2.");
 	 		}else if(account.getVersion() == SNMPAccount.SNMP_VERSION_1 && snmpOid != null && snmpOid.length() != 0) {
 		 		int index = snmpOid.indexOf(",");
	 		 	if(index == -1) {
		 			index = snmpOid.indexOf(".");
			 		if(index == -1) {
			 			try {
							int genericTrapId = Integer.parseInt(snmpOid);
							if(genericTrapId < 0 || genericTrapId > 5) {
								errmodel.addError("generic trap id must be between 0 and 5, value is " + genericTrapId);
							}
						}catch(Exception e) {
							errmodel.addError("generic trap id must be between 0 and 5, value is " + snmpOid);
						}
			 		}
	 		 	}
 	 		}
 	 	}
 	}
 	
 	if(snmpTaskVariables != null && snmpTaskVariables.length > 0) {
 		String error = "";
 		for(int i = 0; i < snmpTaskVariables.length; i++) {
 			error = "";
 			snmpTaskVariable = snmpTaskVariables[i];
 			if(snmpTaskVariable != null) {
	 			if(snmpTaskVariable.getOid() == null || snmpTaskVariable.getOid().length() == 0) {
	 				error += "OID was not specified, ";
	 			}
	 			if(snmpTaskVariable.getName() == null || snmpTaskVariable.getName().length() == 0) {
	 				error += "Name was not specified, ";
	 			}
	 			if(snmpTaskVariable.getType() == null || snmpTaskVariable.getType().equals("-1")) {
	 				error += "Type was not specified, ";
	 			}
	 			if(error.length() > 0) {
	 				error = error.substring(0, error.length() - 2);
		 			errmodel.addError("Variable #" + (i + 1) + " is missing the following details: " + error);
	 			}
	 			
	 			if(snmpTaskVariable.getType() != null && !snmpTaskVariable.getType().equals("-1")) {
	 				if(snmpTaskVariable.getType().equals(SNMPTask.VARIABLE_TRAP_TIME_TYPE)) {
	 					String dateFormat = snmpTaskVariable.getMessage();
	 					if(dateFormat == null || dateFormat.length() == 0) {
	 						// do nothing
	 					}else {
	 						try {
			 					SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
	 						}catch(Exception e) {
	 							errmodel.addError("Invalid date format in variable #" + (i + 1) + ", specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)");
	 						}
	 					}
	 				}else if(snmpTaskVariable.getType().equals(SNMPTask.VARIABLE_LOG_TIME_TYPE)) {
	 					String dateFormat = snmpTaskVariable.getMessage();
	 					if(dateFormat == null || dateFormat.length() == 0) {
	 						// do nothing
	 					}else {
	 						try {
			 					SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
	 						}catch(Exception e) {
	 							errmodel.addError("Invalid date format in variable #" + (i + 1) + ", specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)");
	 						}
	 					}	 					
	 				}else if(snmpTaskVariable.getType().equals(SNMPTask.VARIABLE_TIME_TYPE)) {
	 					String message = snmpTaskVariable.getMessage();
						int semicolonIndex = message.lastIndexOf(";");
						if(message == null || message.length() == 0) {
							errmodel.addError("Variable #" + (i + 1) + " must specify the column name from the log in square brackets in the Message column");
	 					}else if(semicolonIndex > 0 && message.charAt(semicolonIndex - 1) != '\'') {
							String dateFormat = message.substring(semicolonIndex + 1, message.length() - 1);
							if(dateFormat == null || dateFormat.length() == 0) {
								// do nothing
		 					}else {
		 						try {
				 					SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
		 						}catch(Exception e) {
		 							errmodel.addError("Invalid date format in variable #" + (i + 1) + ", add the date format after the column name (i.e: [Date;MM/dd/yyyy]) or leave empty for default date format (as configured in the log)");
		 						}
		 					}
						}
	 				}else if(!snmpTaskVariable.getType().equals(SNMPTask.VARIABLE_STATUS_TYPE)) {
	 					if(snmpTaskVariable.getMessage() == null || snmpTaskVariable.getMessage().length() == 0) {
							errmodel.addError("Variable #" + (i + 1) + " must specify the column name from the log in square brackets in the Message column");
	 					}
	 				}
	 			}
 			}
 		}
 	}

 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
   	return;
 	}
	
	SNMPTask task = null; 
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null){
		task = (SNMPTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new SNMPTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	//task.setSnmpMsgStr(snmpMsg);
	task.setSnmpOid(snmpOid);
	task.setSnmpCommunity(snmpCommunity);
	task.setSnmpAccountId(accId);
	task.setSnmpTaskVariables(snmpTaskVariables);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "snmp task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=snmp");
%>