<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.portal.PortalItem"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "";
%>
<%

	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
	}

	UserSecurity user = securityManager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
  
  boolean isPermittedViewReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean isPermittedAddReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
  boolean isPermittedReports = isPermittedViewReports || isPermittedAddReports;
  
  boolean isPermittedIssueTrackingSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.IssueTraqckingPermissions.ISSUE_TRACKING_SETTINGS_PERMISSION);
  
  boolean dashboardEnabled = SiteManagment.getInstance().getApplicationComponentsManager().isComponentExists(XpologManagment.ANALYTICS_COMPONENT);
  
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  env.setUsePage("logEyePortal.jsp");

  boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();

  Properties prop = Configuration.getInstance().getUIData();
  String userImg = prop.getProperty("gate.users.icon.image");
  String logoImg = prop.getProperty("gate.logo.image");
  String lockImg = prop.getProperty("gate.security.secure.image");
  String unlockImg = prop.getProperty("gate.security.unsecure.image");
  int ALLOWED_LOG_NAME_LENGTH = 30;
  
  String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
  	
  ArrayList list = new ArrayList();
  list.add(new PortalItem("Testing<br>Analyses","reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true","Testing Analyses","images/portal/btns/diagnostics.gif","images/portal/btns/diagnostics-on.gif"));
  list.add(PortalItem.SEP_ITEM);
  list.add(new PortalItem("Snapshots","snapshot/snapshotsView.jsp","Snapshots","images/portal/btns/log-viewer.gif","images/portal/btns/log-viewer-on.gif"));
  if(isPermittedIssueTrackingSettings) {
  	list.add(PortalItem.SEP_ITEM);
  	list.add(new PortalItem("Bug Tracking","tools/issuetracking/issueTrackingView.jsp","Bug Tracking","images/portal/btns/search-engine.gif","images/portal/btns/search-engine-on.gif"));
  }
  if(dashboardEnabled) {
  	list.add(PortalItem.SEP_ITEM);
  	list.add(new PortalItem(analyticsH,"javascript:openDashboard()",analyticsH,"images/portal/btns/dashboard.gif","images/portal/btns/dashboard-on.gif"));
  }
   
  request.setAttribute("mainItems",list);
  
  list = new ArrayList();
  if (valid){
    list = new ArrayList();
    if(isPermittedAddLog && isPermittedReports) {
    	list.add(new PortalItem("Add Testing Environment Analysis","reports/agg/aggReportDefinition.jsp?reportTemplateId=Testing","Add Log"));
    }
    if(isPermittedIssueTrackingSettings) {
    	list.add(new PortalItem("Add Bug Tracking System","tools/issuetracking/issueTrackingView.jsp?openIssueTrackerType=true","Add Log"));
    }
    request.setAttribute("linksItems",list);
  }
  String titleMsg = "Testing Environments";
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/portal.js"></script>

<script>
function openDashboard() {
	if(parent) {
		parent.location = "componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>";
	}
}
</script>
</HEAD>
<BODY style="margin: 0; padding: 0; border-width: 0;overflow:auto">
<jsp:include page="portal/portal.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="title" value="<%=titleMsg %>" />
</jsp:include>
</BODY>
</HTML>