<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, DriverName, userName, password, dbName, machineAddress, port, ConnectionString, Id, extraInfo;
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	DriverName = request.getParameter("DriverName");
	userName = request.getParameter("UserName");
	password = request.getParameter("Password");
	dbName = request.getParameter("DBName");
	machineAddress = request.getParameter("MachineAddress");
	port = request.getParameter("Port");
	Id = request.getParameter("Id");
	extraInfo = request.getParameter("extraInfo");
	String type = request.getParameter("type");
	String skipSave = request.getParameter("skipSave");
	boolean doSave = skipSave == null || !skipSave.equals("true");
	String accountBuilderName = request.getParameter("accountBuilderName");
	if (accountBuilderName == null || accountBuilderName.length() == 0){
		accountBuilderName = "AccountBuilder";
	}
	String txExpoAccountStr = request.getParameter("txExpoAccount");
	boolean isTxExpoAccount = txExpoAccountStr != null && txExpoAccountStr.equals("true");
	String txExpoOnlineAccountStr = request.getParameter("txExpoOnlineAccount");
	boolean isTxExpoOnlineAccount = txExpoOnlineAccountStr != null && txExpoOnlineAccountStr.equals("true");
	String forwardUrl = request.getParameter("forwardUrl");
	String defaultAccountStr = request.getParameter("defaultAccount");
	boolean defaultAccount = defaultAccountStr != null && defaultAccountStr.equals("true");
	
	ErrorModel errmodel = new ErrorModel(); 
	DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute(accountBuilderName);
	if (builder == null){
		errmodel.addError("The operation cannot be completed.");
		errmodel.addError("Please try to refresh the browser and repeat the operation.");
		if(isEmbeded){
  		errorMsg += "The operation cannot be completed.<br>";
  		errorMsg += "Please try to refresh the browser and repeat the operation.<br>";
		}
	}
		
	if (builder != null && forwardUrl != null && forwardUrl.length() > 0){
		builder.setForwardUrl(forwardUrl);
	}
	
	
	if(Name != null && Name.equals("")){
    errmodel.addError("Name was not supplied");
    if(isEmbeded){
    	errorMsg += "Name was not supplied<br>";
    }
  }
 	if(DriverName != null && DriverName.equals("")){
 		//incase someone has deleted the driver name and clicked save.
   	errmodel.addError("Driver name was not supplied");
   	if(isEmbeded){
   		errorMsg += "Driver name was not supplied<br>";
   	}
 	}
 	if(machineAddress != null && machineAddress.equals("")){
   	errmodel.addError("Host address was not supplied");
   	if(isEmbeded){
   		errorMsg += "Host address was not supplied<br>";
   	}
 	}
 	if(port != null && port.equals("")){
   	errmodel.addError("Port was not supplied");
   	if(isEmbeded){
   		errorMsg += "Port was not supplied<br>";
   	}
 	}else if(port != null){
   	try{
   		int p = Math.abs(Integer.parseInt(port));
 	  }catch(Exception e) {
 		  errmodel.addError("Port must be a valid number");
 		  if(isEmbeded){
     		errorMsg += "Port must be a valid number<br>";
     	}
 	  }
 	}
 	if(dbName != null && dbName.equals("")){
   	errmodel.addError("Database name was not supplied");
   	if(isEmbeded){
   		errorMsg += "Database name was not supplied<br>";
   	}
 	}
 	if(userName != null && userName.equals("")){
   	errmodel.addError("Username was not supplied");
   	if(isEmbeded){
   		errorMsg += "Username was not supplied<br>";
   	}
 	}
 	if(isEmbeded){
  	String driverTypeSelected = request.getParameter("driversType");
		if(driverTypeSelected == null || driverTypeSelected.equals("none")){
			errmodel.addError("Please select driver.");
			errorMsg += "Please select driver.<br>";				
		}
	}

	if(errmodel.getErrorCount() != 0){
  	if(!isEmbeded){
   		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 	  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
   	}else{
  		result += "error@#" + errorMsg;
  		out.write(result);
  		out.flush();
  	}
   	return;
  }
	
	builder.setTxExpoAccount(isTxExpoAccount);
	builder.setTxExpoOnlineAccount(isTxExpoOnlineAccount);
	
	if (Name != null){
  	builder.setXpoName(Name);
  }
	if (Description != null){
  	builder.setXpoDesc(Description);
  }
  
  if (DriverName != null){
  	builder.setDbDriverName(DriverName);
  }
  if (extraInfo != null){
  	builder.setExtraInfo(extraInfo);
  }
  
  if (machineAddress != null){
  	builder.setHost(machineAddress);
  }
  if (port != null){
  	builder.setPort(port);
  }
  if (dbName != null){
  	builder.setDbName(dbName);
  }
  if (userName != null){
  	builder.setUserName(userName);
  }
  if (password != null){
  	builder.setPassword(password);
  }
  builder.setDefaultAccount(defaultAccount);
  boolean verified = false;
	if (doSave){
  	if(actionType.equals("verify") || verifyBeforeSave){
	  	if(errorMsg.length() == 0){
	  		DBAccount dbAcc = builder.updateDbAccount();
				Media med = MediaManager.newInstace().getMediaByAccount(dbAcc);
			  if (med instanceof AbstractMedia){
			    ((AbstractMedia)med).setLogEnabled(false);
			  }
			  try {
					verified = med.verify(dbAcc);
				  if (!verified){
				  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
				  }else{
				  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
				  }
			  }catch(Throwable t) {
			  	verifyMsg = "An error occured during verification: " + t.getMessage();
			  }
			}
		}
  	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
  		builder.saveAccount(userContext);
  		
  		if(!isEmbeded) {
  			String lastSelectedAccountId = builder.getId();
  			if(lastSelectedAccountId == null) {
  				lastSelectedAccountId = builder.getDbAccount().getId();
  			}
  			if(lastSelectedAccountId != null && lastSelectedAccountId.length() > 0) {
  				request.getSession().setAttribute("lastSelectedAccount",lastSelectedAccountId);
  			}
  		}
	  	
	    //audit
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  	   			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit db account " + Name);
		}
  }
	
	String forward = builder.getForwardUrl();
	if (forward == null || forward.length() == 0){
	  forward = "tools/addresses/addressview.jsp?addressType=db";
	}

	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "db@#";
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			result += builder.getXpoName() + "@#";
			result += builder.getDbAccount().getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
		response.sendRedirect(BASE_DIRECTORY + forward);
	}
%>