<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.io.*" %>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!
    static final String BASE_DIRECTORY = "../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String AUDIT_FILE = Configuration.XPOLOG_ROOT_PATH + "conf/systemlogs/audit.xml";
  String AUDIT_TYPE_LOGIN = "typeLogin";
  String AUDIT_TYPE_VIEW = "typeView";
  String AUDIT_TYPE_CHANGE = "typeChange";
  String USER_NAME = "userName"; 
  String GENERAL_STRING = "generalString"; 
  
  
  
  String auditTypeLogin = request.getParameter(AUDIT_TYPE_LOGIN);
  String auditTypeView = request.getParameter(AUDIT_TYPE_VIEW);
  String auditTypeChange = request.getParameter(AUDIT_TYPE_CHANGE);
  String userName = request.getParameter(USER_NAME);
  String generalString = request.getParameter(GENERAL_STRING);

  AuditObject audit = null;  
  audit = (AuditObject) request.getSession().getAttribute("AUDIT_OBJECT");
  if (audit == null) {
	  audit = new AuditObject();
	  request.getSession().setAttribute("AUDIT_OBJECT", audit);
  }
  
  
  //types settings
  //login
  boolean noTypeSelected = true;
  if(auditTypeLogin != null && auditTypeLogin.equals("on")) {
	  audit.setLoginSelected(true);
	  noTypeSelected = false;
  }else {
	  audit.setLoginSelected(false); 
  }
  //view
  if(auditTypeView != null && auditTypeView.equals("on")) {
	  audit.setViewSelected(true);
	  noTypeSelected = false;
  }else {
	  audit.setViewSelected(false);  
  }
  //change
  if(auditTypeChange != null && auditTypeChange.equals("on")) {
	  audit.setChangeSelected(true);
	  noTypeSelected = false;
  }else {
	  audit.setChangeSelected(false);  
  }
  //user name
  if(userName != null && userName.length() > 0) {
	  audit.setUserName(userName);
  }else {
	  audit.setUserName("");
  }
  //general string
  if(generalString != null && generalString.length() > 0) {
	  audit.setMessage(generalString);
  }else {
	  audit.setMessage("");
  }
  
  ErrorModel errmodel = new ErrorModel();
  if(noTypeSelected) {
	  errmodel.addError("Please select at least one type in order to generate a view");
  }
  
  //load the audit log
  String auditLogId = "audit";
  if(Configuration.getInstance().isCluster() && SiteManagment.getInstance().getClusterNodes().length > 1) {
  	auditLogId = SiteManagment.getInstance().getClusterPrefixLogId("all") + "audit";
  }
  LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager(auditLogId);  
  if(lbm == null) {
	  errmodel.addError("Failed to load the audit log");
  }
  
  //filter issues
  RecordMask mask = lbm.getRecordMask();
  
  FilterCollection fc = null;
  //create the date and number filter
  DateFilter dfilter = null;
  try {
	  dfilter = createDateFilter(request,response,mask);
  }catch(Exception e) {
  	errmodel.addError(e.getMessage());
  }
  
  if(errmodel.getErrorCount() > 0) {
	  response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  return;
  }
  
 
  
  //creating the filter
  fc = new FilterCollection();
  fc.setName("Audit Filter");
  fc.setId("audit_fc");
  if(dfilter != null) {	  
	  fc.addFilter(dfilter);
  }
  //type filter
  ChoiceFilter typesFilter = new ChoiceFilter(lbm.getRecordMask(),3);
  if(audit.isLoginSelected()) typesFilter.addValue(AuditConstants.LOGIN);
  if(audit.isViewSelected()) typesFilter.addValue(AuditConstants.VIEW);
  if(audit.isChangeSelected()) typesFilter.addValue(AuditConstants.CHANGE);
  fc.addFilter(typesFilter);
  
  //user name filter
  if(audit.getUserName() != null && audit.getUserName().length()>0) {
	  StringFilter userNameFilter = new StringFilter(lbm.getRecordMask());
	  userNameFilter.setForColumns(new int[]{2});
	  FilterField field = new FilterField(userName,false,false);
	  userNameFilter.addField(field);
	  userNameFilter.setOperation("contain");
	  fc.addFilter(userNameFilter);
  }
  //general string filter
  if(audit.getMessage() != null && audit.getMessage().length()>0) {
	  StringFilter generalStringFilter = new StringFilter(lbm.getRecordMask());	  
	  FilterField field = new FilterField(generalString,false,false);
	  generalStringFilter.addField(field);
	  generalStringFilter.setOperation("contain");
	  fc.addFilter(generalStringFilter);
  }
  audit.setFc(fc);
  lbm.setTemporary(true);
  FilterManager fltr = lbm.getFilterManager();
  fltr.addFilterCollection(fc);
  
  //set the log on session
  request.getSession().setAttribute(CURRENT_LOG,lbm);  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   			userContext, AuditConstants.VIEW, "view audit reports", AuditConstants.REPORTS, "view audit reports");	 	 	

  response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp");
%>
