<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.verifiers.MultiVerifier"%>
<%!
  static final String BASE_DIRECTORY = "../../";
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>

<%
		String	TYPE_WORKSPACE = "Workspace";
		String TYPE_PROJECT = "DataSession";

		WebSecurityManager securityManager = WebSecurityManager.getInstance();
		if (!securityManager.checkForPermission(request,response,null,true)){
			return;
		}
		
		SiteManagment mgmt = SiteManagment.getInstance();
		
		boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();

		String selectedTabId = request.getParameter("selectedTabId");
		if (selectedTabId == null || selectedTabId.length() == 0){
			selectedTabId = "0";
		}
		
		UserContext userContext = UserEnvironment.getUserContext(request);
		ReportsManager reportMgr = ReportsManager.getInstance();
		String reportType = Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE;
		List environmentAnalysesList = reportMgr.getAllBasicReports(userContext,false,reportType);
		boolean environmentAnalysesExist = environmentAnalysesList != null && environmentAnalysesList.size() > 0;
		boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
		String environmentAnalysisText = "Environment Analyses";
		if(isTestingBuid) {
			environmentAnalysisText = "Testing Analyses";
		}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>

<script>
  function doSave(){
	  updateModAndLogsSelected();	  
	  updateVerifiersSelected();
	  <%if(txExpoViewer){%>
		  updateWorkspaces();
		<%}%>
  	document.access.submit();
  }
  
  	function updateModAndLogsSelected(){
		list = tree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
					if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	 				modsStr += "*";
					}
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}
  function updateVerifiersSelected(){
		list = verTree.getAllChecked();
		arr = list.split(",");
	  var verStr = "";
	  var multiVerStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=MultiVerifier.MULTI_TYPE%>"){
					if (multiVerStr != ""){
						multiVerStr += ",";
					}
					multiVerStr += id;
					if (verTree.hasChildren(s) && verTree.hasChildren(s)==true){
	 				multiVerStr += "*";
					}
				}else{
					if (verStr != ""){
						verStr += ",";
					}
					verStr += id;
				}
			}
		}
		document.access.multiVerifiers.value = multiVerStr;
		document.access.verifiers.value = verStr;
	}
	
  function updateWorkspaces(){
		list = wsTree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
	  var wsStr = "";
	  var projStr = "";
	  var transStr = "";	  
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=TYPE_WORKSPACE%>"){
					if (wsStr != ""){
						wsStr += ",";
					}
					wsStr += id;
					if (wsTree.hasChildren(s) && wsTree.hasChildren(s)==true){
	 				wsStr += "*";
					}
				}else{
					if (type == "<%=TYPE_PROJECT%>"){
						if (projStr != ""){
							projStr += ",";
						}
						projStr += id;
						if (wsTree.hasChildren(s) && wsTree.hasChildren(s)==true){
		 				projStr += "*";
						}
					}else{
							if (transStr != ""){
								transStr += ",";
							}
							transStr += id;
						}
					}
			}
		}
		document.access.workspaces.value = wsStr;
		document.access.projects.value = projStr;
		document.access.transactions.value = transStr;		
	}
  
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="confImageAction.jsp" style="margin:0;padding:0">
<input type="hidden" name="IsAdmin" value="true">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="multiVerifiers">
<input type="hidden" name="verifiers">
<input type="hidden" name="workspaces">
<input type="hidden" name="projects">
<input type="hidden" name="transactions">


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="90%" class="TOPBORDER">
                <span class="PAGEHEADER">Configuration Image </span></td>
                <td width="9%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="3" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createDefaultApplicationTabs("ConfImageMembersTabs");
                  applicationTabs.addTab("General","<nobr>General</nobr>","generalDiv");                          
                  applicationTabs.addTab("Metadata","<nobr>Applications</nobr>","metadDataDiv");                                        
                  applicationTabs.addTab("Logs","<nobr>Logs and folders</nobr>","logsSelectionDiv");                  
                  applicationTabs.addTab("verifiers","<nobr>Monitors</nobr>","verifierSelectionDiv");
                  applicationTabs.addTab("accounts","<nobr>Accounts</nobr>","accountsSelectionDiv");                                   
                  applicationTabs.addTab("reports","<nobr>Reports</nobr>","reportsSelectionDiv");
                  <%if(environmentAnalysesExist) {%>
                  applicationTabs.addTab("environmentAnalyses","<nobr><%=environmentAnalysisText %></nobr>","environmentAnalysesSelectionDiv");
                  <%}%>
                  applicationTabs.addTab("templates","<nobr>Templates</nobr>","templatesSelectionDiv");
                  applicationTabs.addTab("wizards","<nobr>Wizards</nobr>","wizardsSelectionDiv");
                  applicationTabs.addTab("tasks","<nobr>Tasks</nobr>","tasksSelectionDiv");
                  
                  <%if (txExpoViewer){%>
                  applicationTabs.addTab("workspaces","<nobr>TxExpo WS</nobr>","wsSelectionDiv");
//                  applicationTabs.addTab("transactions","<nobr>TxExpo transactions</nobr>","transactionsSelectionDiv");
                  <%}%>			
                </script>     
                  <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" >   
                     <div id="generalDiv" style="display:none">
													<jsp:include page="members/confImageGeneral.jsp" flush="true" />
                      </div>
                      <div id="metadDataDiv" style="display:none">
													<jsp:include page="members/confImageMetaData.jsp" flush="true" />
				  					  </div>
                      <div id="logsSelectionDiv" style="display:none">
													<jsp:include page="members/confImageModulesAndLogs.jsp" flush="true">
													<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
													</jsp:include>
                      </div>
                      <div id="verifierSelectionDiv" style="display:none">
   												<jsp:include page="members/confImageVerifiers.jsp" flush="true">
													<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
													</jsp:include>
                      </div>
                      <div id="accountsSelectionDiv" style="display:none">
													<jsp:include page="members/confImageAccounts.jsp" flush="true" />
                      </div>
                      <div id="reportsSelectionDiv" style="display:none">
													<jsp:include page="members/confImageReports.jsp" flush="true" />
                      </div>
                      <%if(environmentAnalysesExist) {%>
                  		<div id="environmentAnalysesSelectionDiv" style="display:none">
													<jsp:include page="members/confImageEnvironmentAnalyses.jsp" flush="true" />
                      </div>
                      <%}%>
                      <div id="templatesSelectionDiv" style="display:none">
   												<jsp:include page="members/confImageTemplates.jsp" flush="true" />
                      </div>
                      <div id="wizardsSelectionDiv" style="display:none">
													<jsp:include page="members/confImageWizards.jsp" flush="true" />
                      </div>
                      <div id="tasksSelectionDiv" style="display:none">
													<jsp:include page="members/confImageTasks.jsp" flush="true" />
                      </div>
		                  <%if (txExpoViewer){%>
		                  <div id="wsSelectionDiv" style="display:none">
													<jsp:include page="../../logic/tools/confImage/confImageWorkspaces.jsp" flush="true" />
	                    </div>
		                  <%}%>		                                    
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <script>                 
                  applicationTabs.selectTabByIndex(0);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="confImageView.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>