<%@ page language="java"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
    return;
  }
  
	String ERROR_OBJ = "ERROR_OBJ";
	String ID = "ID";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	String id = request.getParameter(ID);
  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
  ConfigurationImage confImgTmp = null;
  if (id != null && id.length() > 0){
  	confImgTmp = confMgr.getConfigurationImageById(id);
  }else {
  	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	  confImgTmp = builder.getConfImage();
	}
  confImgTmp.setImagePackingMode(ConfigurationImagePackingUnit.PUBLISH_MODE); // set publish mode
  final ConfigurationImage confImg = confImgTmp;
  
  boolean ignorePublishers = request.getParameter("ignorePublishers") != null && request.getParameter("ignorePublishers").equals("true");
  if (!ignorePublishers){
    HashSet set = new HashSet();
    String[] publishersSelected = request.getParameterValues("publishers");
    if (publishersSelected != null){
	    for (int i=0; i<publishersSelected.length; i++){	     
	      set.add(publishersSelected[i]);
	    }
    }
    ConfigurationPublisher [] publishers = confImg.getAllConfigurationPublishers();
    for (int i=0; i<publishers.length; i++){
      publishers[i].setSelected(set.contains(publishers[i].getId()));
    }
  }
  
  final String context = request.getContextPath();
  final int localPort = request.getServerPort();
  //System.out.println(request.getLocalAddr());
  //System.out.println(context);

	ErrorModel errmodel = new ErrorModel();
	if(confImg == null){
		errmodel.addError("No Configuration Image was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	JobStatus status = confImg.getJobStatus();
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status);
	env.setTempAttribute("ConfImage",confImg);

	String redirectUrl = (String)request.getSession().getAttribute("redirectURL");
  String _url = "tools/confImage/confImageView.jsp";
  String stopActionUrl = BASE_DIRECTORY + "tools/congImage/presentConfImageStopAction.jsp";
  if (redirectUrl != null && redirectUrl.length() > 0){
  	_url = redirectUrl;
  	stopActionUrl += "?redirectURL="+redirectUrl;
  }
  final String url = _url;

  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + url +"?refreshMenu=true") {
	  public void run(HttpServletRequest request){
	    //if the data source failed or the datasource finished, ends the progress.
	    boolean isFinished = false;
	    try {
	    	confImg.setSourceContext(context);
	    	confImg.setPort(localPort);
		    confImg.publish();
	    }catch (Exception e){
	      e.printStackTrace();
	    }
			env.removeTempAttribute("ConfImage");
	  }
	};
	env.setProgressRunner(runner);
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="<%=stopActionUrl%>"/>
</jsp:include>

