<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.data.transform.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

 	String ACCOUNT_ID = "ACCOUNT_ID";
 	final String DB_TABLE = "DB_TABLE";
	String CREATE_NEW_TABLE = "CREATE_NEW_TABLE";
  	String CURRENT_LOG = "CURRENT_LOG";
	String TRANSFORMER = "TRANSFORMER";
	final String NUM_RECS = "NUM_RECS";
	String SQL_INSERT_STMT = "sqlInsert";
	String SQL_CREATE_STMT = "sqlCreate";
  	String TYPE_EXP = "TYPE_EXP";
  	String DB_MANAGER = "DB_MANAGER";

	//export types
    String XP_DOWN = "download";
    String XP_EMAIL = "email";
    String XP_FTP = "ftp";
    String XP_UPLOAD = "upload";
    String XP_FS = "filesys";
    String XP_TELENET = "telnetssh";
    String XP_SQL_EXECUTE = "execute";
    
	DBManager dbman = (DBManager)request.getSession().getAttribute(DB_MANAGER);
	if (dbman == null){
			LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
			String acc_id = request.getParameter(ACCOUNT_ID);
    		dbman = DBHelper.getDBManager(acc_id, lbm);
    }
  final DBMedia media = dbman.getMedia();


  String exportType = request.getParameter(TYPE_EXP);

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  final String create_table = request.getParameter(CREATE_NEW_TABLE);
  final String db_table = (request.getParameter(SQL_INSERT_STMT).split(" "))[2];
  String insertStatement = request.getParameter(SQL_INSERT_STMT);
  String createStatement = request.getParameter(SQL_CREATE_STMT);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  //error handling
  if(db_table == null || db_table.trim().equals("")){
    errmodel.addError("DB table was not supplied");
  }


  if(errmodel.getErrorCount() > 0){
    env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
    response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
    return; 
  }
  
    String insertStmt = "";
    ExportFlow flow = (ExportFlow)request.getSession().getAttribute(SiteConstants.EXPORT_FLOW_ATTRIBUTE);
   
    String createTableStmt = "";
    LogBrowsingManager lbm = null;
    try{
  	  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	  dbman.setInsertStmtPattern(insertStatement);
      if (create_table.equals("true")) {
      	dbman.setCreateTableStmt(createStatement);
      } else{
     	dbman.setCreateTableStmt("");
      }
	  dbman.updateTransformer();		
	  SQLTransformer sqltrans = dbman.getSqlTrans();
	  if (exportType.equalsIgnoreCase(XP_SQL_EXECUTE)){
		  
		 //	audit
		 String Name = "";
		 if(lbm != null) {
		  		Name = lbm.getName();
		 }
		 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  		  			userContext, AuditConstants.CHANGE, "export log to database", AuditConstants.LOGS, "export log to databse " + Name);

	    final DBManager executeDMMan = dbman;
	  	ProgressRunner runner = new ProgressRunner("exportDBStatus.jsp") {
     	 public void run(HttpServletRequest request){
        	try{
        	  if(!media.isConnected()) {
				  errmodel.addError("Unable to connect to database - Please make sure the database is up.");
				  errmodel.addError("Unable to connect to database - " + media.getLastErrorMessage());
				  createErrorRedirect(request);
				  return;
			  }

			 
	   		  if (create_table.equals("true")){
  	  			executeDMMan.executeCreateTable();
	    	  }
		  	  int numrecs = executeDMMan.executeInsertStatement();
	  		  int errnum = executeDMMan.getErrors().length;
		  	  if (numrecs == 0 && errnum > 0){
				  errmodel.addError("Some errors occured during insert operation");
				  errmodel.addError("No records were written into database table:");
				  for (int i=0; i<errnum; i++){
					errmodel.addError(executeDMMan.getErrors()[i]);
				  }
				  createErrorRedirect(request);
				  return;		
		  	  }
			  //succes page with log view link
			  request.getSession().setAttribute(NUM_RECS,new Integer(numrecs));
			  request.getSession().setAttribute(DB_TABLE,db_table);
             
        	}catch(Exception e){
          		errmodel.addError("The following error occured while export:");
          		errmodel.addError(e.getMessage());
          		createErrorRedirect(request, BASE_DIRECTORY);
          		return;
      		}
  	 	  }
	 	};
     	env.setProgressRunner(runner);
     	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, media);
				
	  } else{
	  	request.getSession().setAttribute(TRANSFORMER, sqltrans);
	  	response.sendRedirect("../exportLogAction.jsp?TYPE_EXP="+exportType+"&TRANSFORMER_TYPE=");
        return;	  	
	  }   
    }finally{
	  	request.getSession().removeAttribute(DB_MANAGER);
    }
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>