<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
   final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
   UserContext userContext = UserEnvironment.getUserContext(request);

   final ExportFlow flow = (ExportFlow)request.getSession().getAttribute(SiteConstants.EXPORT_FLOW_ATTRIBUTE);
   env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, flow);
    boolean isExecute = flow.isExecutation();

  String FROM = "fromId";
  String ALL = "ALL";
  String TO = "toId";
  String TEXT = "Text";
  String CURRENT_LOG = "CURRENT_LOG";
  String SUBJECT = "Subject";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  final String from    = request.getParameter(FROM);
  final String to    = request.getParameter(TO);
  final String subject     = request.getParameter(SUBJECT);
  String text = request.getParameter(TEXT);
  if(text == null){
  	text = "";
  }
  //verify data
  ErrorModel errmodel = new ErrorModel();

  //error handling
  if(from == null || from.trim().equals("")){
    errmodel.addError("From email was not supplied.");
  }
  if(to == null || to.trim().equals("")){
    errmodel.addError("To email(s) were not supplied.");
  }
  if(subject == null || subject.trim().equals("")){
    errmodel.addError("Subject was not supplied");
  }
  if(errmodel.getErrorCount() > 0){
    env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
   response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
   return; 
  }
  
  
 AddressBook adbook = AddressBook.getInstance();
 final MailAccount mafrom = (MailAccount)adbook.getAccountById(from);
 final MailAccount mato = (MailAccount)adbook.getAccountById(to);
     
      
 if (isExecute){
 		//	audit
	 	String Name = "";
 		LogBrowsingManager lbm = flow.getLogBrowsingManager();
	 	if(lbm != null) {
	 		Name = lbm.getName();
	 	}
	 	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	 		  			userContext, AuditConstants.CHANGE, "export log by mail", AuditConstants.CONFIGURATION, "export log by mail " + Name);

   final String msg = text;
   ProgressRunner runner = new ProgressRunner("exportMailStatus.jsp") {
      public void run(HttpServletRequest request){
        try{
          File zipFile = flow.execute();
          Vector v = new Vector();
          v.add(zipFile);      
          PostOffice.sendWithAttachments(mafrom,mato,subject,msg,v);
        }catch(Exception e){
          errmodel.addError("The following error occured while sending the log:");
          //errmodel.addError(e.getMessage());
          String err = XpologUtil.getErrorMessage(e);  
          errmodel.addError(err);
          createErrorRedirect(request, BASE_DIRECTORY);
      }
  	 }
   };
   env.setProgressRunner(runner);
       
  }else {
      MediaManager medm = MediaManager.newInstace();
      PostOffice post = medm.getPostOffice();
      post.setInfo(mafrom,mato,subject,text);
      flow.setMedia(post);
      response.sendRedirect(flow.getActionURL());
      return;         
  }
  
 
  
 
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Sending Mail"/>
 <jsp:param name="useStatus" value="true" />
</jsp:include>
