<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.transform.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String TYPE_EXP = "TYPE_EXP";
  String TRANSFORMER_TYPE = "TRANSFORMER_TYPE";
  String EXPORT_FLOW = "EXPORT_FLOW";
  String TRANSFORMER = "TRANSFORMER";
  String ACT = "ACT";

  //transformer types:
  String XML = "XML";
  String CSV = "CSV";
  String PDF = "PDF";
  String TAB = "TAB";
  String PLAIN = "PLAIN";
  String SQL = "SQL";
  String SIMPLE = "SIMPLE";
  //String SQLPROC = "SQLPROC";

  //export types
  String XP_DOWN = "download";
  String XP_EMAIL = "email";
  String XP_FTP = "ftp";
  String XP_UPLOAD = "upload";
  String XP_FS = "filesys";
  String XP_TELENET = "telnetssh";
  String XP_SQL_EXECUTE = "execute";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String exportType       = request.getParameter(TYPE_EXP);
  String transformType    = request.getParameter(TRANSFORMER_TYPE);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  LogBrowsingManager lbm = null;
  
   String id = request.getParameter("LOG_ID");
   String snapshotId = request.getParameter("SNAPSHOT_ID");
  try{
	  if((id != null) && !(id.trim().equals(""))){
	    lbm = SiteManagment.getInstance().getLogBrowserManager(id);
	  }else if(snapshotId != null && snapshotId.length() > 0){  	  //Export snapshot lbm
			Snapshot snapshot = SnapshotManager.getInstance().getSnapshot(snapshotId);
			if(snapshot != null){
				lbm = snapshot.getLogView();
			}	
	  }else{
	    lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	  } 
  }catch(Exception e){
	  	ErrorModel ermod = new ErrorModel();
	    ermod.addError("XpoLog Failed to load log due to the following error:");
	    ermod.addError(e.getMessage());
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
      return;
  }
  
  if(lbm == null){
    errmodel.addError("You must select a log fist.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  //error handling


  //determine which tansformaer to use.
  Transformer trans = (Transformer)request.getSession().getAttribute(TRANSFORMER);
  boolean addOrigDataToResult = false;
  if (trans == null){
	  if(transformType.equalsIgnoreCase(XML)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_XML);
	  }else if(transformType.equalsIgnoreCase(CSV)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_CSV);
	  }else if(transformType.equalsIgnoreCase(TAB)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_TAB);
	  }else if(transformType.equalsIgnoreCase(PDF)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_TAB);
	  }else if(transformType.equalsIgnoreCase(PLAIN)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_FILE);
	  }else if(transformType.equalsIgnoreCase(SIMPLE)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_SIMPLE_TEXT);
	    addOrigDataToResult = true;
	  }else if(transformType.equalsIgnoreCase(SQL)){
	    trans = TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_SQL);
	  }
	}
	
  if(trans == null){
    errmodel.addError("Did not find a transformer - " + transformType);
  }
  if(errmodel.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  try{
    ExportFlow flow = new ExportFlow();
    if (addOrigDataToResult){
    	lbm.setAddOrigDataToResult(true);
    }
    flow.setLogBrowsingManager(lbm);
    flow.setTransformer(trans);
    request.getSession().setAttribute(EXPORT_FLOW,flow);
    request.getSession().removeAttribute(TRANSFORMER);

    if(transformType.equalsIgnoreCase(SQL)){
      request.getSession().setAttribute(CURRENT_LOG,lbm);
      response.sendRedirect("db/exportLogDB.jsp?TYPE_EXP="+exportType);
      return;
    }else if(exportType.equalsIgnoreCase(XP_DOWN)){
      response.sendRedirect("getLogZipAction.jsp");
      return;
    }else if(exportType.equalsIgnoreCase(XP_EMAIL)){
      response.sendRedirect("email/exportLogMail.jsp");
      return;
    }else if(exportType.equalsIgnoreCase(XP_FTP)){
      List list = AddressBook.getInstance().getAccountsByFilter(new FTPAccountFilter());
       if(list.size() == 0){
      	errmodel.addError("There is no FTP account defined, Please <a href=\"" + BASE_DIRECTORY + "tools/addresses/ftp/accountFtp.jsp\"> create FTP account</a> first.");
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect("errorpage.jsp");
    	return;
      }else{
      	response.sendRedirect("ftp/exportLogFtp.jsp");
      	return;
      }
    }else if(exportType.equalsIgnoreCase(XP_UPLOAD)){
      response.sendRedirect("upload/exportLogUpload.jsp");
      return;
    }else if(exportType.equalsIgnoreCase(XP_FS)){
      response.sendRedirect("fsys/exportLogFS.jsp");
      return;
    }else if(exportType.equalsIgnoreCase(XP_TELENET)){
      List list = AddressBook.getInstance().getAccountsByFilter(new TelnetAccountFilter());
      if(list.size() == 0){
      	errmodel.addError("There is no SSH account defined, Please <a href=\"" + BASE_DIRECTORY + "tools/addresses/ssh/accountSsh.jsp\"> create SSH account</a> first.");
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect("errorpage.jsp");
    	return;
      }else{
      	response.sendRedirect("telnet/exportLogTelnetSsh.jsp");
      	return;
      }
    }
    //succes page with log view link
    response.sendRedirect("exportLog.jsp");
    return;
  }catch(Exception e){
    e.printStackTrace();
  }
%>

<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<html>
	<body>
  	exportType: <%=exportType%><br>
  	transformator Type: <%=trans.getType()%>
	</body>
</html>
