<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
    final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

    final ExportFlow flow = (ExportFlow)request.getSession().getAttribute(SiteConstants.EXPORT_FLOW_ATTRIBUTE);
    boolean isExecute = flow.isExecutation();
    //media
	MediaManager medm = MediaManager.newInstace();
	final FSManager fs = medm.getFSManager();

 
  String FS_DIRECTORY = "FSDirectory";
  String FS_OVERWRITE = "FSOverWrite";
  String CURRENT_LOG = "CURRENT_LOG";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String fs_dir = request.getParameter(FS_DIRECTORY);
  String fs_ovw_str = request.getParameter(FS_OVERWRITE);
  final boolean fs_ovw = fs_ovw_str != null && fs_ovw_str.equalsIgnoreCase("on");

  //verify data
  ErrorModel errmodel = new ErrorModel();
	
	if(fs_dir == null || fs_dir.trim().equals("")){
    errmodel.addError("No fs account was supplied.");
  }
  //error handling

  if(errmodel.getErrorCount() > 0){
   env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
   response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
   return; 
  }
 
  //create temp fs account
  final FSAccount fsac = (FSAccount)AddressBook.getInstance().getAccountById(fs_dir);

  //send it
  if (isExecute){
  		//	audit
  		LogBrowsingManager lbm = flow.getLogBrowsingManager();
	  	String Name = "";
	  	if(lbm != null) {
	  		Name = lbm.getName();
	  	}
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		  			userContext, AuditConstants.CHANGE, "export log to file system", AuditConstants.CONFIGURATION, "export log to file system " + Name);

    ProgressRunner runner = new ProgressRunner("exportFSStatus.jsp") {
      public void run(HttpServletRequest request){
        try{
         File zipFile = flow.execute();
         fs.connect(fsac);  
         fs.send(fsac,zipFile,fs_ovw);
        
        }catch(Exception e){
          errmodel.addError("An error occured while copying the archive");
          //errmodel.addError(e.getMessage());
          String err = XpologUtil.getErrorMessage(e);  
          errmodel.addError(err);
          createErrorRedirect(request, BASE_DIRECTORY);
       }
  	 }
	 };
     env.setProgressRunner(runner);
     env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, fs);
        
  }else {
      fs.setAccount(fsac);
      fs.setOverwrite(fs_ovw);
      flow.setMedia(fs);
      response.sendRedirect(flow.getActionURL());
      return;
  }
    
 
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>