<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
    final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

    final ExportFlow flow = (ExportFlow)request.getSession().getAttribute(SiteConstants.EXPORT_FLOW_ATTRIBUTE);
    boolean isExecute = flow.isExecutation();
    
    //media
    MediaManager medm = MediaManager.newInstace();
    final FTPManager ftp = medm.getFTPManager();

  String ACC_ADD = "addressId";
  String DIRECTORY = "FTPDirectory";
  String CURRENT_LOG = "CURRENT_LOG";


  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String acc_id    = request.getParameter(ACC_ADD);
  final String ftp_dir = request.getParameter(DIRECTORY);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  //error handling

  if(ftp_dir == null || ftp_dir.trim().equals("")){
    errmodel.addError("Directory was not supplied");
  }
  
  if(acc_id == null || acc_id.trim().equals("")){
    errmodel.addError("No ftp account was supplied.");
  }


  if(errmodel.getErrorCount() > 0){
   env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
   response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
   return; 
  }
  
 
  //create temp ftp account
  final FTPAccount ftpac = (FTPAccount)AddressBook.getInstance().getAccountById(acc_id);
      
      
  if (isExecute){
  		//	audit
	  	String Name = "";
  		LogBrowsingManager lbm = flow.getLogBrowsingManager();
	  	if(lbm != null) {
	  		Name = lbm.getName();
	  	}
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		  			userContext, AuditConstants.CHANGE, "export log by ftp", AuditConstants.CONFIGURATION, "export log by ftp " + Name);

    ProgressRunner runner = new ProgressRunner("exportFtpStatus.jsp") {
      public void run(HttpServletRequest request){
        try{
         File zipFile = flow.execute();           
          //send it
         if (!ftp.send(ftpac,new File[]{zipFile},ftp_dir)){
           errmodel.addError("The following error occured while sending the log:");
           errmodel.addError(ftp.getLastErrorMessage());
           createErrorRedirect(request, BASE_DIRECTORY);
         }
        }catch(Exception e){
          errmodel.addError("The following error occured while sending the log:");
          //errmodel.addError(e.getMessage());
          String err = XpologUtil.getErrorMessage(e);  
          errmodel.addError(err);
          createErrorRedirect(request, BASE_DIRECTORY);
        }
  	  }
	 };
   env.setProgressRunner(runner);
   env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, ftp);
        
  }else {
     ftp.setAccount(ftpac);
     ftp.setFTPDirectory(ftp_dir);
     flow.setMedia(ftp);
     response.sendRedirect(flow.getActionURL());
     return;
  }
    
  
%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>
