<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.common.*"%> 
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
 
  String FROM = "FROM";
  String TO = "TO";
  String TEXT = "TEXT";
  String CURRENT_LOG = "CURRENT_LOG";
  String SUBJECT = "SUBJECT";
  final String LAST_TEXT_MAIL = "LAST_TEXT_MAIL";
  String FREE_TEXT = "FREE_TEXT";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  final String from    = request.getParameter(FROM);
  final String to    = request.getParameter(TO);
  final String subject     = request.getParameter(SUBJECT);
  String text = (String)request.getSession().getAttribute(LAST_TEXT_MAIL);
  String freeText = request.getParameter(FREE_TEXT);
  //verify data
  ErrorModel errmodel = new ErrorModel();
  //error handling
  if(from == null || from.trim().equals("")){
    errmodel.addError("From email was not supplied.");
  }
  if(to == null || to.trim().equals("")){
    errmodel.addError("To email(s) were not supplied.");
  }
  if(subject == null || subject.trim().equals("")){
    errmodel.addError("Subject was not supplied");
  }
  if(errmodel.getErrorCount() > 0){
    env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
    response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
    return;
  }
  
  
  if(freeText == null || freeText.trim().equals("")){
    freeText = "";
  }else{
    freeText = freeText + System.getProperty("line.separator");
  }
  final String message = freeText + text;
  ProgressRunner runner = new ProgressRunner("exportMailStatus.jsp") {
    public void run(HttpServletRequest request){
      try{
        //here we send the mail
     	 PostOffice.sendMail(from,to,subject,message);
     	 request.getSession().removeAttribute(LAST_TEXT_MAIL);
      }catch(Exception e){
        errmodel.addError("The following error occured while sending the log:");
        //errmodel.addError(e.getMessage());
        String err = XpologUtil.getErrorMessage(e);  
        errmodel.addError(err);
        createErrorRedirect(request, BASE_DIRECTORY);
      }
  	 }
	};
  env.setProgressRunner(runner);
   
 
  
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Sending Mail"/>
</jsp:include>


