<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  final ExportFlow flow = (ExportFlow)request.getSession().getAttribute(SiteConstants.EXPORT_FLOW_ATTRIBUTE);
  boolean isExecute = flow.isExecutation();

  String ADDRSSH = "addressId";
  String DIRECTORY = "TelnetDirectory";


  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String tel_add_id = request.getParameter(ADDRSSH);
  final String tel_dir = request.getParameter(DIRECTORY);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  //error handling
  if(tel_add_id == null || tel_add_id.trim().equals("")){
    errmodel.addError("Ssh account was not supplied.");
  }
  
  if(tel_dir == null || tel_dir.trim().equals("")){
    errmodel.addError("Directory was not supplied.");
  }

  if(errmodel.getErrorCount() > 0){
   env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,errmodel);
   response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
   return; 
  }
  
 
  //create temp ftp account
  final TelnetAccount tpa = (TelnetAccount)AddressBook.getInstance().getAccountById(tel_add_id);   
  //media
  MediaManager medm = MediaManager.newInstace();
  final TelShManager telssh = (TelShManager)medm.getMediaByAccount(tpa);
  telssh.setAccount(tpa);
  if (isExecute){
  		//	audit
	  	String Name = "";
  		LogBrowsingManager lbm = flow.getLogBrowsingManager();
	  	if(lbm != null) {
	  		Name = lbm.getName();
	  	}
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		  			userContext, AuditConstants.CHANGE, "export log by ssh", AuditConstants.CONFIGURATION, "export log by ssh " + Name);

    ProgressRunner runner = new ProgressRunner("exportTelnetStatus.jsp") {
      public void run(HttpServletRequest request){
        try{
         File zipFile = flow.execute();
         //send it
         telssh.send(tpa,zipFile,tel_dir);
        }catch(Exception e){
          errmodel.addError("The following error occured while sending the log:");
          //errmodel.addError(e.getMessage());
          String err = XpologUtil.getErrorMessage(e);  
          errmodel.addError(err);
          createErrorRedirect(request, BASE_DIRECTORY);
      }
  	 }
	 };
     env.setProgressRunner(runner);
     env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, telssh);
      
       
   }else {
        telssh.setAccount(tpa);
        telssh.setTargetDirectory(tel_dir);
        flow.setMedia(telssh);       
        response.sendRedirect(flow.getActionURL());
        return;
   }  
   
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>

