<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.linear.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.global.custom.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String COL_INDEX = "COL_INDEX_";
  String CURRENT_LOG = "CURRENT_LOG";
  String COLOR_PARAM = "COLOR_PARAM_";

    SiteManagment mgmt = SiteManagment.getInstance();
    GlobalCustomization gcm = GlobalCustomization.getInstance();
  
    LogBrowsingManager lbm = null;
    CustomizationManager cuman = null;
    RecordMask mask = null;
    //name
	String customName = request.getParameter("customName");
	//description
	String customDesc = request.getParameter("customDesc");
	//cusid for edit of exsiting set
	String  customId = request.getParameter("customId");
	//if new set then contain lbmId
	String lbmId= request.getParameter("logbrowser");

	if(customId == null || customId.length() == 0){
		if(lbmId != null && lbmId.length()>0){
			lbm = mgmt.getLogBrowserManager(lbmId);
			if(lbm != null){
				cuman = lbm.getCustomizationManager();
 				mask = lbm.getRecordMask();
 			}
		}
	
	}else{
		CustomizationSet cs =gcm.getCustomizationSetById(customId);
		cuman = cs.custMgr;
		mask = cs.recordMask;
	}
	
  if(customName == null || customName.length()  == 0){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please provide name for the customization");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  CustomizationSet cusSet = new CustomizationSet();
  cusSet.name = customName;
  cusSet.description = customDesc;
  cusSet.id = customId;
  cusSet.custMgr = cuman;
  cusSet.recordMask = mask;
  cusSet.maskKey = mask.buildKeyForMask();
 
  if(cuman == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Failed to load Customization Set, please verify configuration data.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  CustomizationSet ct = gcm.getCustomizationSetByKey(cusSet.maskKey);
  if( ct != null && !(ct.id.equals(cusSet.id))){
 	ErrorModel ermod = new ErrorModel();
    ermod.addError("You are trying to create a customization set with a schema already exsits.");
    ermod.addError("For each schema only one set can be used. The exsiting set is - " + cusSet.name);
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  //lines number issue
  boolean lineNumberChanged = false;
  String logId = null;
  

   
  //search and filter issue
  String searchAndFilterDefStr = request.getParameter("searchAndFilterDefStr");
  boolean searchAndFilterDef = searchAndFilterDefStr != null && searchAndFilterDefStr.equalsIgnoreCase("on");
  if(searchAndFilterDef) {
  	searchAndFilterDefStr = "START";
  }else {
  	searchAndFilterDefStr = "CURRENT";
  }
  //lbm.setSearchAndFilterDef(searchAndFilterDefStr);
  


  int[] indexs = new int[mask.getCulomnsNumber()];
  int[] cols = new int[mask.getCulomnsNumber()];
  String clp = null;
  boolean atLeatOne = false;
  for(int i=0;i<indexs.length;i++){
    cols[i] = i;
    clp = request.getParameter(COL_INDEX + i);
    if((clp == null) || (clp.trim().equals(""))){
      indexs[i] = -1;
      continue;
    }
    indexs[i] = Integer.parseInt(clp);
    atLeatOne = true;
  }
  if(!atLeatOne){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("You must specify at least one visible column.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  cuman.setCustomizationColumns(cols,indexs);
 
   
  //Priorities color handling if exsit
  String[] priorities = null;
  int cnum = mask.getCulomnsNumber();
  int pindex = -1;
  for(int i=0;i<cnum;++i){
    if((mask.getMaskColumn(i) instanceof PriorityMask)){
      pindex = i;
      priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
    }
  }

  if(priorities != null){
  	String usePriorityColorsStr = request.getParameter("usePriorityColors");
  	boolean usePriorityColors = usePriorityColorsStr != null && usePriorityColorsStr.equals("true");
    HashMap pToColor = new HashMap();
    String color = "";
    for(int i=0;i<priorities.length;++i){
      color = request.getParameter(COLOR_PARAM + i);
      if(color == null){
        color = "";
      }
      pToColor.put(priorities[i],color);
    }
    cuman.setUsePriorityBgColor(usePriorityColors);
    cuman.setPriorityColorMap(pToColor);
    cuman.setPriorityIndex(pindex);
  }

  String startOperation = request.getParameter("startOperation");
  if (startOperation != null && startOperation.trim().length() > 0){
    cuman.setStartOperation(startOperation);
  }



  gcm.putCustomizationSet(cusSet);

	//	audit
  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "add/edit global customization", AuditConstants.CONFIGURATION, "add/edit global customization " + customName);

  response.sendRedirect("globalCustom.jsp");
%>


