<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.global.filters.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  //constants

  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";

  String FILTER_NAME = "filterName";
  String FILTER_DESC = "filterDesc";
  String FILTER_LOGOP_OP = "LogicalOp";
  String FILTER_COL_IDS = "ToUse";

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String NEGATE = "Negate";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  GlobalFilters gbl = GlobalFilters.getInstance();
  //check state
  FilterSet fset = null;
  FilterCollection fcman = null;
 
  String filterSetId = request.getParameter("filterSetId");
  if(filterSetId == null || filterSetId.length() == 0){
	 //do not use flm from log, since have more filters
	 fman = new FilterManager();
	 fcman = new FilterCollection();
   }else{
	 FilterSet cs = gbl.getFilterSetById(filterSetId);
	 fman = cs.filterMgr;
	 fcman = (FilterCollection)fman.getFilterCollections().get(0);
   }


  String[] colids = request.getParameterValues(FILTER_COL_IDS);
  //check validyt for name
  String filterName = request.getParameter(FILTER_NAME);
  String filterDesc = request.getParameter(FILTER_DESC);
  String logicOp = request.getParameter(FILTER_LOGOP_OP);
  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));

  ErrorModel ermo = new ErrorModel();
  if(filterName == null || filterName.trim().equals("")){
    ermo.addError("You must name the filter.");
  }
  if(filterDesc == null || filterDesc.trim().equals("")){
   filterDesc = "";
  }
  if(colids == null || (negate && colids.length < 1) || (!negate && colids.length < 2)){
    ermo.addError("You must select at least two filters.");
  }
  if(ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  fcman.setName(filterName);
  fcman.clearAllFromName(MULTI_FILTER);
  MultiFilter multiFilter = new MultiFilter(fman);
  //setting the ids
  for(int i=0;i<colids.length;++i){
    multiFilter.addFilteCollection(colids[i]);
  }
  //setting boolean op
  if(logicOp.equalsIgnoreCase("OR")){
    multiFilter.setBooleanOpAsOR();
  }else{
    multiFilter.setBooleanOpAsAND();
  }
  multiFilter.setNegateFilter(negate);

  fcman.addFilter(multiFilter);

  //Health Settings
	ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
	HashMap defUnitsMap = new HashMap();
  if (healthConfigs != null && healthConfigs.length > 0){
		for(int i = 0 ; i < healthConfigs.length;i++){
   		String type = healthConfigs[i].getType();
   		String healthWeight = request.getParameter("healthWeight" + type);
     	double weight = -1;
     	if (healthWeight != null && healthWeight.length() > 0){
     		try {
     			weight = Double.parseDouble(healthWeight);
     		}catch (Exception e){}  	
     	}
     
   		FilterComputationDefUnit defUnit = null;
    	if (weight >= 0){
 	  		defUnit = new FilterComputationDefUnit();
 	  	  defUnitsMap.put(type,defUnit);
   			defUnit.setType(type);
   			defUnit.setWeight(weight);
   			String healthAmountType = request.getParameter("healthAmountType" + type);
    		int amountType = -1;
 	  		if (healthAmountType != null && healthAmountType.length() > 0){
   	  		try {
     				amountType = Integer.parseInt(healthAmountType);
     				defUnit.setAmountType(amountType);
      		}catch (Exception e){}  	
  	    }
 	  		String healthAmount = request.getParameter("healthAmount" + type);
   			int amount = -1;
   			if (healthAmount != null && healthAmount.length() > 0){
     			try {
     				amount = Integer.parseInt(healthAmount);
     				defUnit.setAmount(amount);
      		}catch (Exception e){}  	
 	    	}    			    			
   		}
   	}
  }
	fcman.setDefUnits(defUnitsMap);
  
  fman.addFilterCollection(fcman);

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  fset = new FilterSet();
  fset.id = filterSetId;
  fset.name = filterName;
  fset.description = filterDesc;
  fset.filterMgr = fman;
  fset.recordMask = new RecordMask();
  fset.type = GlobalFilters.MULTI_FILTER_TYPE;
  gbl.putFilterSet(fset);
  
  //	audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "add/edit global multi filter", AuditConstants.CONFIGURATION, "add/edit global multi filter " + fset.name);

  //update log browser
  response.sendRedirect("globalFilters.jsp");
%>
