<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  //constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String DATE_FILTER = "DateFilter";
  String TIME_FILTER = "TimeEventsFilter";
  String FILTER_COL_IDS = "FilterCollectionIds";
  String NEGATE = "Negate";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm == null || lbm.getId() == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  if (lbm.isHavingLastFilterView()){
    fman = lbm.getLastFilterManager();
  }else {
    fman = lbm.getFilterManager();
  }


  String filterId = request.getParameter(EDIT_FILTER_ID);
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
  }
  String filterName = "EventsTimeFilter_" + String.valueOf(numFilterc);
  String paramToPass = "";
  FilterCollection fc = null;
  String editFilterId = "";
  if(filterId != null){
    if(filterId.equals("none")){
      fman.setActiveFilterId(null);
    }else{
      fman.setActiveFilterId(filterId);
      fc = fman.getFilterCollectionById(filterId);
      if(fc != null){
        filterName = fc.getName();
        filterName = filterName.replaceAll("\"", "&quot;");
      }
      editFilterId = filterId;
    }
  }else{
    filterId = "";
    paramToPass = "&OP=ADD";
  }
  String op = request.getParameter(ADD);
  List filters = null;
  if(fc != null){
    filters = fc.getByName(TIME_FILTER);
  }else{
    filters = new ArrayList();
  }

  TimeEventsFilter eventsFilter = null;
  List filterCollectionIds = null;
  List allcol = fman.getFilterCollections();

  if(allcol.size() < 2){
    ErrorModel erm = new ErrorModel();
    erm.addError("There must be at least two exsiting filters in order to create a Multi Filter.");
    request.getSession().setAttribute(ERROR_OBJ,erm);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  String numop = "";
	String val = "";
	long unit = 1;
  if(filters != null && filters.size()>0){
  	eventsFilter = (TimeEventsFilter)filters.get(0);
    filterCollectionIds = eventsFilter.getFilterCollectionList();
    numop = eventsFilter.getOperation();
    val = eventsFilter.getStringValue();
    unit = eventsFilter.getUnit();
  }else{
  	eventsFilter = new TimeEventsFilter(lbm.getRecordMask(),fman,"",0,unit);
    filterCollectionIds = new ArrayList();
    numop = "equals";
    val = "";
  }
  
  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());

  String[] operations = TimeEventsFilter.getSupportedOperations();
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function doApply(){    
    for(var i=0;i<document.access.ToUse.options.length;i++){
      document.access.ToUse.options[i].selected = true;
    }

    document.access.submit();
  }

  function trim(a){
      while(''+a.charAt(a.length-1)==' '){
       a=a.substring(0,a.length-1);
      }
      return a;
  }
  
  function showText(obj){
		var op = obj.options[obj.selectedIndex].text;
		var elem = document.getElementById("example");
		if (op == "between" || op == "not equals" || op == "equals"){
			elem.style.display = "";
		} else {
			elem.style.display = "none";
		}
	}
	
	function init(){
	  document.access.ToUse.multiple=true;
	}


</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

<title></title>
</head>
<body style="font-size: 8pt" onLoad="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" action="eventsTimeFilterAction.jsp">
<input type="hidden" name="EDIT_FILTER_ID" value="<%=editFilterId%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Events Time Filter definition</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name: </span><input class="TEXTBOX" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">

                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Filters</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="filterSelect.jsp"%></td>
                                            </tr>
					    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%">
                                              <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                              <tr>
                                              <td width="50" nowrap>
                                              <span class="REGULARTEXT"><nobr>Time between events that will &nbsp;&nbsp;</nobr></span>
                                              
                                              </td>
                                              <td nowrap width="30">
                                              <span class="REGULARTEXT">
							<select name="numberOperation" onChange="javascript:showText(this)">
								<%
								for (int i=0; i<operations.length; i++){
								%>
									<option value="<%=i%>" <%=numop.equals(operations[i])?"selected":""%>><%=operations[i]%></option>
								<%}%>
							</select>
						</span>
						</td>						
						<td width="20" style="padding-left:5">
							<input type="text" name="numberValue" value="<%=val%>" size="5">
						</td>
						<td width="*" style="padding-left:5">
						  <select name="unitValue">
						  <option value="1" <%=unit == 1 ? "selected" : "" %>>Milliseconds</option>
						  <option value="1000" <%=unit == 1000 ? "selected" : "" %>>Seconds</option>
						  <option value="60000" <%=unit == 60000 ? "selected" : "" %>>Minutes</option>
						  <option value="3600000" <%=unit == 3600000 ? "selected" : "" %>>Hours</option>
						  </select>
							
						</td>
						<td width="20">&nbsp;</td>
						<td nowrap >
							<div id="example" class="SMALLTEXT" <%if(!numop.equals("between")&&!numop.equals("not equals")&&!numop.equals("equals")){%>style="display:none"<%}%>>example: 1-6,33,55-66</div></td>
                                              </tr>
                                              </table>
                                              </td>
                                            </tr>
                                            
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doApply()" class="LINK"><%=isEditable?"save" : "apply"%></a></td>
                                                    <td width="33%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</table>
</form>
</body>

