<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.config.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  //constants

  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";



  String FILTER_NAME = "filterName";
  String FILTER_COL_IDS = "FilterCollectionIds";

  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  
  //page data
  LogBrowsingManager lbm = null;
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  lbm.clearLastFilterView();
  fman = lbm.getFilterManager();

  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  String calStr = "calls=";
  if (calls != null){
      calStr += calls.intValue() + 1;
  }else {
  	calStr += "0";
  }
  
  String searchAndFilterDef = lbm.getSearchAndFilterDef();
  if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
  	searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
  }

  String[] colids = request.getParameterValues("ToUse");
  //check validyt for name
  String filterName = request.getParameter(FILTER_NAME);
  
  ErrorModel ermo = new ErrorModel();
  if(filterName == null || filterName.trim().equals("")){
    ermo.addError("You must name the filter.");
  }
  if(colids == null || (colids.length < 2)){
    ermo.addError("You must select at least two filters.");
  }
  
  long unit = 1;
  String value = request.getParameter("numberValue");
  if(value == null || value.equals("")){
  	ermo.addError("You must select a time unit.");
  }else {
  	try {
  		double val = Double.parseDouble(value);
  		String unitStr = request.getParameter("unitValue");
    	
    	if (unitStr != null && unitStr.length() > 0){
    		try {
    			unit = Long.parseLong(unitStr);
    		}catch (Exception e){}
    	}
    	value = String.valueOf(val);
  	}catch (Exception e){
  		ermo.addError("Invalid time unit - " + value);
  	}
  	
  }
  
  String op = request.getParameter("numberOperation");
  if(op == null || op.equals("")){
  	ermo.addError("You must select an operation.");
  }
  
  if(ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  FilterCollection fcman = null;
  String filterId = request.getParameter(EDIT_FILTER_ID);
  if(filterId == null || filterId.length() == 0){
    fcman = new FilterCollection();
  }else{
    fcman = fman.getFilterCollectionById(filterId);
    if(fcman == null){
      fcman = new FilterCollection();
    }else{
      fcman = (FilterCollection)fcman.clone();
    }
  }

  fcman.setName(filterName);
  TimeEventsFilter eventsTimeFilter = new TimeEventsFilter(lbm.getRecordMask(),fman,value,Integer.parseInt(op),unit);
  //setting the ids
  for(int i=0;i<colids.length;++i){
  	eventsTimeFilter.addFilteCollection(colids[i]);
  }
 
  fcman.addFilter(eventsTimeFilter);
  fman.addFilterCollection(fcman);

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
   if (security == null || security.isModuleMemberEditable(lbm.getId())){
    Module parent = mgmt.getParentModule(lbm.getId());
    admin.addLogBrowser(lbm,parent);
  }
   

   //audit
   AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   	   			userContext, AuditConstants.CHANGE, "add/edit events time filter", AuditConstants.LOGS, "add/edit events time filter " + filterName + " , on log " + lbm.getName());	 	 	

  //update log browser
  response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + calStr + "&opdirect=" + searchAndFilterDef);
%>
