<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
  boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");
%>
<%
  //constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String DATE_FILTER = "DateFilter";
  String MULTI_FILTER = "MultiFilter";
  String FILTER_COL_IDS = "FilterCollectionIds";
  String NEGATE = "Negate";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm == null || lbm.getId() == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  if (lbm.isHavingLastFilterView()){
    fman = lbm.getLastFilterManager();
  }else {
    fman = lbm.getFilterManager();
  }


  String filterId = request.getParameter(EDIT_FILTER_ID);
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
  }
  String operation = null;
  String editFilterId = null;
  String filterName = "GenMultiFilterName_" + String.valueOf(numFilterc);
  FilterCollection fc = null;
  if(filterId != null){
    if(filterId.equals("none")){
      fman.setActiveFilterId(null);
      operation = "ADD";
    }else{
      fman.setActiveFilterId(filterId);
      fc = fman.getFilterCollectionById(filterId);
      if(fc != null){
        filterName = fc.getName();
        filterName = filterName.replaceAll("\"", "&quot;");
      }
      editFilterId = filterId;
    }
  }else{
    filterId = "";
    operation = "ADD";
  }
  String op = request.getParameter(ADD);
  List filters = null;
  if(fc != null){
    filters = fc.getByName(MULTI_FILTER);
  }else{
    filters = new ArrayList();
  }

  MultiFilter multiFilter = null;
  List filterCollectionIds = null;
  List allcol = fman.getFilterCollections();

  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));

  if(!negate && allcol.size() < 2){
    ErrorModel erm = new ErrorModel();
    erm.addError("There must be at least two exsiting filters in order to create a Multi Filter.");
    request.getSession().setAttribute(ERROR_OBJ,erm);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  if(filters != null && filters.size()>0){
    multiFilter = (MultiFilter)filters.get(0);
    filterCollectionIds = multiFilter.getFilterCollectionList();
  }else{
    multiFilter = new MultiFilter(fman);
    filterCollectionIds = new ArrayList();
  }
  negate = negate || (multiFilter != null && multiFilter.isNegateFilter());

  String orselected="",andselected="";
  if(multiFilter.isBooleanOpOR()){
    orselected = "selected";
  }else{
    andselected = "selected";
  }

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());

  ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  boolean displaySystemHealth = showHealth;
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function doApply(){
    for(var i=0;i<document.access.ToUse.options.length;i++){
      document.access.ToUse.options[i].selected = true;
      
    }
    var filterName = document.access.filterName.value;
    var re1 = new RegExp("[&]", 'gi');
  	filterName = filterName.replace(re1,"%26");
  	document.access.filterName.value = filterName;
    
    document.access.submit();
  }

  function trim(a){
      while(''+a.charAt(a.length-1)==' '){
       a=a.substring(0,a.length-1);
      }
      return a;
  }


</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

<title></title>
</head>
<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="multiFilterAction.jsp" method="post">
<%if (operation != null){%>
<input type="hidden" name="OP" value="<%=operation%>">
<%}%>
<%if (editFilterId != null){%>
<input type="hidden" name="EDIT_FILTER_ID" value="<%=editFilterId%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Multi Filter definition</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name: </span><input class="TEXTBOX" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">

                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Filters</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="filterSelect.jsp"%></td>
                                            </tr>
					    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><span class="REGULARTEXT">Logical operation between filters</span>
                                                <select class="TEXTBOX" size="1" name="LogicalOp">
                                                  <option <%=orselected%> value="OR">OR</option>
                                                  <option <%=andselected%> value="AND">AND</option>
                                                </select></td>
                                            </tr>
                                            <%if (negate){ %>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><input type="checkbox" name="Negate" value="true" checked><span class="REGULARTEXT"> negate filter</span>
                                              </td>
                                            </tr>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="SMALLTEXT">Click this option in order to negate the result of the filter (e.g. (A AND B) => (NOT A OR NOT B))</td>
                                            </tr>
                                            <%}%>
                                            <% 
                                         String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
                                         String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
                                         HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
                                         if (healthConfigs != null && healthConfigs.length > 0 && SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists()){
                                         %>
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER"><%=analyticsH %></span></td>
                                            </tr>
                                            
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><span class="MEDIUMTEXT">Set the severity of this filter rule if you wish the <%=analytics %> to analyze and monitor it. Leave none otherwise.</span></td>
                                            </tr>
                                            <%
                                            for(int j = 0; j < healthConfigs.length ; j++){
                                            	String type = healthConfigs[j].getType();
                                            	FilterComputationDefUnit defUnit = fc == null ? null : fc.getDefUnit(type);
                                            	
                                            %>
                                            <tr style="padding-top:5" style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%">
                                              <table brder="0" cellspacing="0" cellpadding="0">
                                              <tr>
																								<td nowrap width="150"><span class="REGULARTEXT">Filter Rule Severity: &nbsp;</span></td>
																								<td width="20">
																								<select name="healthWeight<%=type%>">
																								<option value="-1">None</option>
																								<%
																								HealthViewRiskModel riskModel = HealthViewRiskModel.getInstance();
																								int riskType = -1;
																								if (defUnit != null && defUnit.getWeight() > 0){
																									riskType = riskModel.getRiskType(defUnit.getWeight());
																								}
																								int  [] values = riskModel.getRiskValues();
																								for (int i = 1; values != null && i < values.length;i++){
																									if (values[i] <= 0) continue;
																									
																									String name = riskModel.getRiskName(values[i]);
																								%>
																								<option value="<%=String.valueOf(values[i])%>" <%=(riskType == i ?"selected" : "")%>><%=name%></option>
																								<%
																								}
																								%>
																								
																								</select>
																								<input type="hidden" name="healthAmountType<%=type%>" value="1"> 
																								<input type="hidden" name="healthAmount<%=type%>" value="0">
																								</td>																								
																								<td width="*" >&nbsp;</td>	
																							</tr>
                                              </table>
                                              </td>
                                            </tr>
																							<%} %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                         <%
                                         }
                                         %>
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
						  <tr>&nbsp;</tr>
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doApply()" class="LINK"><%=isEditable?"save" : "apply"%></a></td>
                                                    <td width="33%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
</table>
</body>

