<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  //constants

  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";



  String FILTER_NAME = "filterName";
  String FILTER_LOGOP_OP = "LogicalOp";
  String FILTER_COL_IDS = "ToUse";

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String NEGATE = "Negate";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  lbm.clearLastFilterView();
  fman = lbm.getFilterManager();

  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  String calStr = "calls=";
  if (calls != null){
      calStr += calls.intValue() + 1;
  }

  String[] colids = request.getParameterValues(FILTER_COL_IDS);
  //check validyt for name
  String filterName = request.getParameter(FILTER_NAME);
  String logicOp = request.getParameter(FILTER_LOGOP_OP);
  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));

  ErrorModel ermo = new ErrorModel();
  if(filterName == null || filterName.trim().equals("")){
    ermo.addError("You must name the filter.");
  }
  if(colids == null || (negate && colids.length < 1) || (!negate && colids.length < 2)){
    ermo.addError("You must select at least two filters.");
  }
  if(ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  FilterCollection fcman = null;
  String filterId = request.getParameter(EDIT_FILTER_ID);
  if(filterId == null){
    fcman = new FilterCollection();
  }else{
    fcman = fman.getFilterCollectionById(filterId);
    if(fcman == null){
      fcman = new FilterCollection();
    }else{
      fcman = (FilterCollection)fcman.clone();
    }
  }

  fcman.setName(filterName);
  fcman.clearAllFromName(MULTI_FILTER);
  MultiFilter multiFilter = new MultiFilter(fman);
  //setting the ids
  for(int i=0;i<colids.length;++i){
    multiFilter.addFilteCollection(colids[i]);
  }
  //setting boolean op
  if(logicOp.equalsIgnoreCase("OR")){
    multiFilter.setBooleanOpAsOR();
  }else{
    multiFilter.setBooleanOpAsAND();
  }
  multiFilter.setNegateFilter(negate);

  fcman.addFilter(multiFilter);

  //Health Settings
	ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
	HashMap defUnitsMap = new HashMap();
  if (healthConfigs != null && healthConfigs.length > 0){
		for(int i = 0 ; i < healthConfigs.length;i++){
   		String type = healthConfigs[i].getType();
   		String healthWeight = request.getParameter("healthWeight" + type);
     	double weight = -1;
     	if (healthWeight != null && healthWeight.length() > 0){
     		try {
     			weight = Double.parseDouble(healthWeight);
     		}catch (Exception e){}  	
     	}
     
   		FilterComputationDefUnit defUnit = null;
    	if (weight >= 0){
 	  		defUnit = new FilterComputationDefUnit();
 	  	  defUnitsMap.put(type,defUnit);
   			defUnit.setType(type);
   			defUnit.setWeight(weight);
   			String healthAmountType = request.getParameter("healthAmountType" + type);
    		int amountType = -1;
 	  		if (healthAmountType != null && healthAmountType.length() > 0){
   	  		try {
     				amountType = Integer.parseInt(healthAmountType);
     				defUnit.setAmountType(amountType);
      		}catch (Exception e){}  	
  	    }
 	  		String healthAmount = request.getParameter("healthAmount" + type);
   			int amount = -1;
   			if (healthAmount != null && healthAmount.length() > 0){
     			try {
     				amount = Integer.parseInt(healthAmount);
     				defUnit.setAmount(amount);
      		}catch (Exception e){}  	
 	    	}    			    			
   		}
   	}
  }
	fcman.setDefUnits(defUnitsMap);
    
  
  fman.addFilterCollection(fcman);

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
   if (security == null || security.isModuleMemberEditable(lbm.getId())){
    Module parent = mgmt.getParentModule(lbm.getId());
    admin.addLogBrowser(lbm,parent);
  }
   

   //audit
   AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   	   			userContext, AuditConstants.CHANGE, "add/edit multi filter", AuditConstants.LOGS, "add/edit multi filter " + filterName + " , on log " + lbm.getName());	 	 	

  //update log browser
  response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + calStr);
%>
