<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.global.filters.GlobalFilters"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.computation.impl.*" %>
<%@ page import="xpolog.eye.computation.conf.*" %>
<%@ page import="xpolog.config.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.regex.*"%>

<%@ include file="textFilterAction.jsp"%>
<%@ include file="prioFilterAction.jsp"%>
<%@ include file="dateFilterAction.jsp"%>
<%@ include file="choiceFilterAction.jsp"%>
<%@ include file="numberFilterAction.jsp"%>
<%@ include file="queryFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  //constants

  String LOG_ID = "logid";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String NUMBER_FILTER = "NumberFilter";
  String QUERY_FILTER = "QueryFilter";

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  
  String RUN_INDEXING = "RUN_INDEXING";
  String REMEMBER_ANSWER = "REMEMBER_ANSWER";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;
  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  
   //id handling
  String id = request.getParameter(LOG_ID);

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  if(id != null && id.trim().length() > 0){
    try{
      lbm = mgmt.getLogBrowserManager(id);    
    }catch(Exception e){
      ErrorModel ermod = new ErrorModel();
      ermod.addError("Can not find the log!");
      ermod.addError("It is possible the session time out were activated or,");
      ermod.addError("It is probable that the log was deleted by another user.");
      ermod.addError("You can refresh your browser in oreder to get an updated view.");
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
      return;
    }
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    request.getSession().setAttribute("logid",id);
  }
  
  if(lbm == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());
  String forward = request.getParameter("forward");

  String charset = lbm.getCharset();
  if(charset == null) {
		charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
  if (charset != null){
    request.setCharacterEncoding(charset);
  }
  lbm.clearLastFilterView();
  fman = lbm.getFilterManager();

  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  String calStr = "calls=";
  if (calls != null){
      calStr += calls.intValue() + 1;
  }
  
  //search and filter definition
  String searchAndFilterDef = lbm.getSearchAndFilterDef();
  if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
  	searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
  }
  String runIndexing = request.getParameter(RUN_INDEXING);
  String filterEntries = "";
  String rememberIndexingAnswer = request.getParameter(REMEMBER_ANSWER);
  if (rememberIndexingAnswer != null && rememberIndexingAnswer.equals("true") && runIndexing != null){
	  //System.out.println("rememberIndexingAnswer="+rememberIndexingAnswer+"; runIndexing="+runIndexing);
  	env.setTempAttribute("INDEX_"+lbm.getId(),runIndexing);
  }
  String quickFilterUsed = request.getParameter("quickFilterUsed");
  boolean quickFilter = quickFilterUsed != null && quickFilterUsed.equals("true");

  
  
 
  

  //removing a filter
  String removeId = request.getParameter(REMOVE_FILTER_ID);
  if(removeId != null){
	//name for audit
	String name = "";
	FilterCollection fltr = fman.getFilterCollectionById(removeId);
	if(fltr != null) {
		name = fltr.getName();
	}	  
    fman.removeFilterCollection(removeId);    
   	//audit
   	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    	   			userContext, AuditConstants.CHANGE, "remove filter", AuditConstants.LOGS, "remove filter " + name + " , from log " + lbm.getName());	 	 	

    //update log browser
    if (isEditable){
      Module parent = mgmt.getParentModule(lbm.getId());
      admin.addLogBrowser(lbm,parent);
    }
    fman.setActiveFilterId(null);
    runIndexing = "false";
	  if (forward != null && !forward.equals("")){
	  	response.sendRedirect(BASE_DIRECTORY + forward + (forward.indexOf("?") ==-1 ? "?" : "&") + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing +"&refreshMenu=true&quickFilterUsed=" + quickFilter);
	  }else {
		  response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing +"&refreshMenu=true&quickFilterUsed=" + quickFilter);
		}
    return;
  }
  
  String activeId = request.getParameter(ACTIVATE_FILTER_ID);
  if(activeId != null){
    if(activeId.equalsIgnoreCase("none")){
      fman.setActiveFilterId(null);
    }else{
      fman.setActiveFilterId(activeId);
    }
    filterEntries = fman.getFilterEntries();
    if (filterEntries == null || filterEntries.equals("")){
    	runIndexing = "false";
    }
	  if (forward != null && !forward.equals("")){
	  	response.sendRedirect(BASE_DIRECTORY + forward + (forward.indexOf("?") ==-1 ? "?" : "&") + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing + "&quickFilterUsed=" + quickFilter);
	  }else {
	    response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing + "&quickFilterUsed=" + quickFilter);
	  }
    return;
  }

  
  //check validty for name
  String filterName = request.getParameter("filterName");
	if (filterName != null && enc != null){
		filterName = new String(filterName.getBytes("8859_1") ,enc);
	}
  

  if(filterName == null || filterName.trim().equals("")){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must name the filter.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }else if(filterName.startsWith(GlobalFilters.GLOBAL_FILTER_NAME_PREFIX)) {
  	ErrorModel ermo = new ErrorModel();
    ermo.addError("Filter name cannot start with " + GlobalFilters.GLOBAL_FILTER_NAME_PREFIX);
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }
  
  String description = request.getParameter("filterDescription");
  if(description == null) {
	description = "";  
  }
  
  //filter uses search engine
  String useIndexingStr = request.getParameter("filterUsesIndexing");
  boolean useIndexing = (useIndexingStr != null && useIndexingStr.equals("true"));

  FilterCollection fcman = null;
  String filterId = request.getParameter(EDIT_FILTER_ID);
  if(filterId == null || filterId.equals("")){
    fcman = new FilterCollection();
  }else{
    fcman = fman.getFilterCollectionById(filterId);
    if(fcman == null){
      fcman = new FilterCollection();
    }else{
      //clonneing because of the cache mechanism
      fcman = (FilterCollection)fcman.clone();
    }
  }

  
  String tempFilter = request.getParameter("tempFilter");
	fcman.setTransientFilter(tempFilter != null && tempFilter.equals("true"));
  fcman.setName(filterName);
  fcman.setDescription(description);
  fcman.setUseIndexing(useIndexing);
  fcman.clearAllFromName(STRING_FILTER);
  fcman.clearAllFromName(PRIORITY_FILTER);
  fcman.clearAllFromName(DATE_FILTER);
  fcman.clearAllFromName(CHOICE_FILTER);
  fcman.clearAllFromName(NUMBER_FILTER);
  fcman.clearAllFromName(QUERY_FILTER);
  RecordMask mask = lbm.getRecordMask();
  try{
    StringFilter[] strfilters = createStringFilters(request,response,mask);
    if((strfilters != null) && (strfilters.length > 0)){
      for(int i=0;i<strfilters.length;++i){
        fcman.addFilter(strfilters[i]);
      }
    }

    ChoiceFilter[] chfilters = createChoiceFilters(request,response,mask);
    if((chfilters != null) && (chfilters.length > 0)){
      for(int i=0;i<chfilters.length;++i){
        fcman.addFilter(chfilters[i]);
      }
    }

    PriorityFilter pfilter = createPriorityFilter(request,response,mask);
    if(pfilter != null){
        fcman.addFilter(pfilter);

    }
    DateFilter dfilter = createDateFilter(request,response,mask);
    if(dfilter != null){
        fcman.addFilter(dfilter);
    }
    NumberFilter[] numfilters = createNumberFilters(request,response,mask);
    if(numfilters != null && numfilters.length > 0){
      for(int i=0;i<numfilters.length;++i){
        fcman.addFilter(numfilters[i]);
      }
    }
    
    QueryFilter queryFilter = createQueryFilter(request,response,mask);
    if (queryFilter != null){
    	fcman.addFilter(queryFilter);
    }
    
    ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
    HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
    HashMap defUnitsMap = new HashMap();
    if (healthConfigs != null && healthConfigs.length > 0){
    	for(int i = 0 ; i < healthConfigs.length;i++){
    		String type = healthConfigs[i].getType();
    		String healthWeight = request.getParameter("healthWeight" + type);
      	double weight = -1;
      	if (healthWeight != null && healthWeight.length() > 0){
      		try {
      			weight = Double.parseDouble(healthWeight);
      		}catch (Exception e){}  	
      	}
      
    		FilterComputationDefUnit defUnit = null;
	    	if (weight >= 0){
  	  		defUnit = new FilterComputationDefUnit();
  	  	    defUnitsMap.put(type,defUnit);
    			defUnit.setType(type);
    			defUnit.setWeight(weight);
    			String healthAmountType = request.getParameter("healthAmountType" + type);
	    		int amountType = -1;
  	  		if (healthAmountType != null && healthAmountType.length() > 0){
    	  		try {
      				amountType = Integer.parseInt(healthAmountType);
      				defUnit.setAmountType(amountType);
	      		}catch (Exception e){}  	
	  	    }
  	  		String healthAmount = request.getParameter("healthAmount" + type);
    			int amount = -1;
    			if (healthAmount != null && healthAmount.length() > 0){
      			try {
      				amount = Integer.parseInt(healthAmount);
      				defUnit.setAmount(amount);
	      		}catch (Exception e){}  	
  	    	}    			    			
    	
    		}
    	}
    }
	fcman.setDefUnits(defUnitsMap);
    

  }catch(Exception e){
//    e.printStackTrace();
    ErrorModel ermo = new ErrorModel();
    ermo.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

	filterEntries = fman.getFilterEntries();
	if (filterEntries == null || filterEntries.equals("")){
		runIndexing = "false";
	}
  fman.addFilterCollection(fcman);


  	//audit
  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  	   			userContext, AuditConstants.CHANGE, "add/edit filter", AuditConstants.LOGS, "add/edit filter " + filterName + " , on log " + lbm.getName());	 	 	

  
  if (isEditable){
    Module parent = mgmt.getParentModule(lbm.getId());
    admin.addLogBrowser(lbm,parent);
  }
  //update log browser
  if (forward != null && !forward.equals("")){
  	response.sendRedirect(BASE_DIRECTORY + forward + (forward.indexOf("?")== -1 ? "?" : "&") + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing + "&quickFilterUsed=" + quickFilter);
  }else {
	  response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + calStr + "&opdirect=" + searchAndFilterDef + "&runIndexing=" + runIndexing + "&quickFilterUsed=" + quickFilter);
	}
%>