<%!
 public StringFilter[] createStringFilters(HttpServletRequest request,HttpServletResponse response,RecordMask mask) throws Exception{

  String ERROR_OBJ = "ERROR_OBJ";
  String STRING_FILTER = "StringFilter";
  int STR_FILTER_NUMBER = 4;
  String FILTER_CHECK_ACTIVE = "FILTER_CHECK_ACTIVE_";
  String FILTER_VALUE        = "FILTER_VALUE_";
  String FILTER_OP           = "FILTER_OP_";
  String COL_IND           = "ToCol_Select";
  String FILTER_VALUE_PARAM  = "StringFilterValue_";
  String FILTER_CHECK_PARAM  = "StringFilterCheck_";
  String FILTER_OP_PARAM     = "StringFilterOp_";
	String FILTER_CASE_SENSITIVE_PARAM = "StringFilterCaseSensitive_";
	String FILTER_REG_EXP_PARAM = "StringFilterRegExp_";
	String FILTER_MATCH_WHOLE_WORDS_PARAM = "StringFilterMatchWholeWords_";

  String filterVal = null;
  String filterOp = null;
  String isActive = null;
  String caseSensitiveStr = null;
  String regExpStr = null;
  String matchWholeWordsStr = null;
  boolean caseSensitive;
  boolean regExp;
  boolean matchWholeWords;

  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }
  
  String useIndexingStr = request.getParameter("filterUsesIndexing");
  boolean useIndexing = (useIndexingStr != null && useIndexingStr.equals("true"));
  boolean isColInd = useIndexing && mask.isUseIgnoreColIndex();
  
  String strFilterNumberStr = request.getParameter("strFilterNumber");
  if (strFilterNumberStr != null && strFilterNumberStr.length() > 0){
  	try{
  		STR_FILTER_NUMBER = Integer.parseInt(strFilterNumberStr);
  	}catch(Exception e){
  		STR_FILTER_NUMBER = 4;
  	}
  }

  String[] colVal = isColInd ? request.getParameterValues("ToColInd_Select") : request.getParameterValues(COL_IND);
    int[] filterforCol = null;
    if(colVal != null && colVal.length>0){
      filterforCol = new int[colVal.length];
      for(int i=0;i<colVal.length;++i){
        filterforCol[i] = Integer.parseInt(colVal[i]);
      }
    }
    
    if (isColInd && filterforCol == null){
    	filterforCol = mask.getUseIndexColumns();
    }

  ArrayList list = new ArrayList();
  for(int i=0;i<STR_FILTER_NUMBER;++i){
      filterVal = request.getParameter(FILTER_VALUE_PARAM + i);
      filterOp  = request.getParameter(FILTER_OP_PARAM + i);
      if(filterVal == null || (filterVal.trim().equals(""))){
        continue;
      }
			if (filterVal != null && enc != null){
				filterVal = new String(filterVal.getBytes("8859_1") ,enc);
			}
      filterOp = request.getParameter(FILTER_OP_PARAM + i);
      caseSensitiveStr = request.getParameter(FILTER_CASE_SENSITIVE_PARAM + i);
      caseSensitive = (caseSensitiveStr != null && caseSensitiveStr.equals("true"));
      regExpStr = request.getParameter(FILTER_REG_EXP_PARAM + i);
      regExp = (regExpStr != null && regExpStr.equals("true"));
      matchWholeWordsStr = request.getParameter(FILTER_MATCH_WHOLE_WORDS_PARAM + i);
      matchWholeWords = (matchWholeWordsStr != null && matchWholeWordsStr.equals("true"));
      if (regExp){
      	if (!(FilterFieldHelper.checkPattern(filterVal,true))){
		      ErrorModel ermod = new ErrorModel();
		      ermod.addError("Illegal regular expression.");
		      ermod.addError("Please check your input again.");
		      request.getSession().setAttribute(ERROR_OBJ,ermod);
		      throw new Exception("Illegal regular expression pattern");
      	}
      }
      StringFilter filter = new StringFilter(mask);
      FilterField filterField = new FilterField();
      filterField.setEntry(filterVal.trim());
      filterField.setCaseSensitive(caseSensitive);
      filterField.setRegExp(regExp);
      if (regExp){
      	String s = FilterFieldHelper.updatePattern(filterVal);
      	filterField.setPattern(filterField.createPattern(filterVal));
      }
      filterField.setMatchWholeWords(matchWholeWords);

      filter.setField(filterField);
      //filter.setValue(filterVal.trim());
      filter.setOperation(filterOp);
      filter.setForColumns(filterforCol);
      list.add(filter);
  }
  StringFilter[] srrFArr = new StringFilter[list.size()];
  srrFArr = (StringFilter[])list.toArray(srrFArr);
  return srrFArr;
}
%>