<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%@ include file="tasksVerifierAction.jsp"%>
 
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	 String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	ErrorModel errmodel = new ErrorModel();
		
  String id = request.getParameter("id");
	
	String name = request.getParameter("name");
	 if (name == null || name.trim().equals("")){
     errmodel.addError("No Name was supplied.");
   }
	 if(WebUtil.isContainSpecialCharecter(name)){
     errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	 
  HashMap filters = new HashMap();
  HashMap logsFilters = new HashMap();
  
  
	String logId = null;
	String filterId = null;

	String [] filtersArr = null;
 	String filtersList = request.getParameter("filters");
 	if (filtersList != null && filtersList.length() > 0){
 		filtersArr = filtersList.split(",");
 	}
  if (filtersArr != null){
		String f;
		int index;	    			
    for (int i = 0;i< filtersArr.length;i++){
			f = filtersArr[i];	    	 	
			index = f.lastIndexOf("#");
			if (index == -1 || index == f.length()-1){
				continue;
			}
			logId = f.substring(0,index);
			filterId = f.substring(index+1);
			LinkedList list = (LinkedList)logsFilters.get(logId);
			if (list == null){
				list = new LinkedList();
				logsFilters.put(logId,list);
			}
			list.add(filterId);
  	}
  }
  
	if (logId == null || logId.trim().equals("")){
	  errmodel.addError("No logs were supplied. If no logs are available please check your permissions");
	}
	 
	if (filterId == null || filterId.trim().equals("")){
	  errmodel.addError("No Filters were supplied");
	}
  
 
	int ruleType = Integer.parseInt(request.getParameter("rulesType"));
	int recordsAmount = -1;
	try {
	  recordsAmount = Integer.parseInt(request.getParameter("recordsAmount"));
		if (recordsAmount < 0){
	  	errmodel.addError("Records amount must be positive");
	  }
	}catch (Exception e){
		errmodel.addError("Records amount must be a number");
	}
	
	String failTaskExecutionPolicyStr = request.getParameter("eventExecution");
	int failTaskExecutionPolicy = -1;
	if (failTaskExecutionPolicyStr != null){
		try{
			failTaskExecutionPolicy = Integer.parseInt(failTaskExecutionPolicyStr);
		}catch(Exception e){
			errmodel.addError("Wrong fail task execution policy");
		}
	}
	
	String posAlertPolicyStr = request.getParameter("posAlertPolicy");
	int posAlertPolicy = -1;
	if (posAlertPolicyStr != null){
		try{
			posAlertPolicy = Integer.parseInt(posAlertPolicyStr);
		}catch(Exception e){
			errmodel.addError("Wrong positive alert execution policy");
		}
	}
	
	if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
	
	boolean edit = true;
	LogVerifier verifier = null;
	if (id == null || id.trim().length() == 0){
	  id = XpologUtil.generateID(name);
	  edit = false;
	}else {
	  verifier = (LogVerifier)verManager.getVerfierFromId(id);
	}
	
	if (edit){
	  verifier = (LogVerifier)verifier.clone();
		String fromLast = request.getParameter("runFromLastLocation");
		verifier.setId(id);
		verifier.setName(name);
		verifier.setLogId(logId);
		verifier.setLogFilterId(filterId);
		verifier.setRuleType(ruleType);
		verifier.setRecordsAmount(recordsAmount);
		verifier.setRunFromLastLocation(fromLast != null);
		verifier.setDataRef("");
		verifier.setPrevDataRef("");
		verifier.setFailTaskExecPolicy(failTaskExecutionPolicy);
		verifier.setPositiveAlertPolicy(posAlertPolicy);
		
		ErrorModel errmod = new ErrorModel();
		try{
			createTasksForVerifier(request,response,verifier);
		}catch(Exception e){
			errmod.addError(e.getMessage());
	  	request.getSession().setAttribute(ERROR_OBJ,errmod);
	  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  	return;
		}
		VerifierTasksListener listener = (VerifierTasksListener)verifier.getListeners().get(0);
		if (listener != null){
			listener.setFailedToExeFailureTasks(false);
			listener.setFailedToExeSuccessTasks(false);
			if ((listener.getPositiveAlertInterval() != -1 && listener.getIntervalTimeUnit() == -1 ) ||
					(listener.getPositiveAlertInterval() == -1 && listener.getIntervalTimeUnit() != -1 )
				 ){
				errmod.addError("Positive alert time setting is not complete");
				errmod.addError("Please check your entries again");
		  	request.getSession().setAttribute(ERROR_OBJ,errmod);
		  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		  	return;
			}
		}
		
		SiteManagment.getInstance().getVerifierManager().addVerifier(verifier,null,userContext);
		SiteManagment.getInstance().getVerifierManager().removeVerifierTempDir(verifier.getId());
	   	//audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			   			userContext, AuditConstants.CHANGE, "add/edit log verifier", AuditConstants.VERIFIERS, "add/edit log verifier " + name);	 	 	
		request.getSession().removeAttribute("CURRENT_VERIFIER_RESULT");
		request.getSession().setAttribute("CURRENT_VERIFIER",verifier);
	}else{
		ErrorModel errmod = VerifiersHelper.addVerifiers(request, logsFilters);
		if (errmod != null && errmod.getErrorCount() > 0){
	  	request.getSession().setAttribute(ERROR_OBJ,errmod);
	  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  	return;
		}
	}
	
	response.sendRedirect("addopok.jsp?refreshMenu=true");
	
%>