<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%@ include file="tasksVerifierAction.jsp"%>
 
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	String REPORT_ID = "reportId";
	String ERROR_OBJ = "ERROR_OBJ";
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	ErrorModel errmodel = new ErrorModel();
		
	String id = request.getParameter("id");
	
	String name = request.getParameter("name");
	if (name == null || name.trim().equals("")){
		errmodel.addError("No Name was supplied.");
	}
	
	ReportsManager reportsMgr = ReportsManager.getInstance();
	String reportId = request.getParameter(REPORT_ID);
	if (reportId == null || reportId.trim().equals("")){
		errmodel.addError("No report id was supplied.");
	}
	
	Report report = null;
	if (reportId != null && reportId.length() > 0){
		report = reportsMgr.getReportById(reportId,true);
	}
	if (report == null){
		errmodel.addError("Error loading report");
	}
	 
	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	ReportVerifier verifier = report.getDefaultReportVerifier();
	
	if (verifier == null) {
	   verifier = new ReportVerifier();
	}else {
	  verifier = (ReportVerifier)verifier.clone();
	}
	
	if (id == null || id.length() == 0){
		id = Report.DEFAULT_VERIFIER_ID;
	}
	verifier.setId(id);
	verifier.setName(name);
	verifier.setReportRuntimeId(reportId);
	report.setReportVerifierId(id);
	
	createTasksForVerifier(request,response,verifier);
	
	String verifierFile = report.getBaseFile().getAbsolutePath() + "/conf/" + id + ".xml";
	SiteManagment.getInstance().getVerifierManager().addVerifier(verifier,verifierFile,userContext);
	
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		 			userContext, AuditConstants.CHANGE, "add/edit report verifier", AuditConstants.VERIFIERS, "add/edit report verifier " + name + " , to report " + report.getReportName());	 	 	


	response.sendRedirect(BASE_DIRECTORY+"reports/reportsDefinitionView.jsp");
	
%>