<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.ui.grid.*"%>
<%@page import="xpolog.eye.site.ui.grid.filters.*"%>
<%@page import="xpolog.eye.site.ui.grid.types.ActionGridValue"%>
<%@page import="xpolog.eye.site.ui.grid.types.LinkGridValue"%>
<%@page import="xpolog.eye.site.ui.grid.types.TreeGridValue"%>

<%!static final String BASE_DIRECTORY = "../../../";

  String createCell(GridTableModel model, GridRow row,int rowIndex,int colIndex,GridValue val,boolean isXml){
	  StringBuffer buffer = new StringBuffer();  	
	  
		String typeText = "";
		int type = model.getColumnType(colIndex);
		if (type == GridColumn.ACTION_TYPE && !(val instanceof ActionGridValue)) {
			typeText = "type=\"ro\"";
		}else if (type == GridColumn.IMG_TYPE && (val == null || val.getGridText().length() == 0)){
			typeText = "type=\"ro\"";			
		}
		// if the column data type is checkbox and value is null, don't display a checkbox
		if(model.getColumnAt(colIndex).getDataType().equals("ch") && val == null) {
			typeText = "type=\"ro\"";
		}
		
		boolean isHTML = model.isColumnHTML(colIndex);
		String value = val == null ? "" : val.getGridText();
		if (!isHTML) {
			if (isXml){	
				 value = value.replaceAll("<", "&lt;");
				 value = value.replaceAll(">", "&gt;");
			}else {
			  value = value.replaceAll("<", "&amp;lt;");
			  value = value.replaceAll(">", "&amp;gt;");
			}
		}

		String imageText = "";
		if (type == GridColumn.TREE_TYPE && val instanceof TreeGridValue) {
			TreeGridValue treeVal = (TreeGridValue)val;
			if (treeVal.getImage() != null && treeVal.getImage().length() > 0){
			  imageText = "image=\"" + "../../../../" + treeVal.getImage() + "\"";
			}else if (!treeVal.isLeaf()){
				imageText = "image=\"folder.gif\"";
			}
			
		}
		value = value.replaceAll("\\[GRID_ROW_ID\\]",row.getId());		

		buffer.append("<cell ");
		buffer.append(typeText);
		buffer.append(" ");
		buffer.append(imageText);
		buffer.append(">");	
		buffer.append("<![CDATA[");
		buffer.append(value);
		buffer.append("]]>");
		buffer.append("</cell>");
		
	  return buffer.toString();
  }

	String createRow(GridTableModel model, int rowIndex,boolean isXml){
		return createRow(model,rowIndex,null,isXml);
	}
	
	String createRow(GridTableModel model, int rowIndex,TreeGridValue treeValue,boolean isXml){
  	StringBuffer buffer = new StringBuffer();  	
  	GridRow row = treeValue == null ? model.getRowAt(rowIndex) : treeValue.getRowAt(rowIndex);
  	buffer.append("<row id=\"").append(row.getId()).append("\" ");
  	if (row.isDynamicFolder()){
    	buffer.append("selected=\"1\" call=\"1\" xmlkids=\"1\"");
  	}
  	buffer.append(">");
  	Properties userData = row.getUserData();
  	if (userData != null && userData.size() > 0){
  		for (Iterator iter = userData.entrySet().iterator();iter.hasNext();){
				Map.Entry entry = (Map.Entry)iter.next();
				buffer.append("<userdata name=\"").append(entry.getKey()).append("\" >");
				buffer.append("<![CDATA[");
				buffer.append(entry.getValue());
				buffer.append("]]>");
				buffer.append("</userdata>");
  		}
  	}
  	
  	TreeGridValue childVal = null;
  	for (int j = 0; j < model.getColumnsCount(); j++) {
  		GridValue val = treeValue == null ? model.getValueAt(rowIndex, j) : treeValue.getValueAt(rowIndex, j);
  		if (val instanceof TreeGridValue){
  			childVal = (TreeGridValue)val;
  		}
			buffer.append(createCell(model,row,rowIndex,j,val,isXml));
  	}
  	if (!row.isDynamicFolder() && childVal != null){			
			if (childVal.getData() != null){
				GridValue [][] data = childVal.getData();
				for(int i = 0; i < data.length;i++){
					buffer.append(createRow(model,i,childVal,isXml));
				}
			}
		}
  	buffer.append("</row>");
  	return buffer.toString();
  }
	
  
  %>

<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}

	String suffix = request.getParameter("suffix");
	if (suffix == null) {
		suffix = "";
	}

	String initHeaderUrl = request.getParameter("initHeaderUrl");
	if (initHeaderUrl == null) {
		initHeaderUrl = "";
	}

	String dataOnlyStr = request.getParameter("dataOnly");
	boolean dataOnly = dataOnlyStr != null && dataOnlyStr.equals("true");
	GridTable table = (GridTable) request.getAttribute("gridTable" + suffix);
	if (table == null) {
		table = (GridTable) session.getAttribute("gridTable" + suffix);
	}
	GridTableModel model = table == null ? null : table.getModel();

	String isPrintStr = request.getParameter("isPrint");
	boolean isPrint = isPrintStr != null && isPrintStr.equals("true");

	String xml = request.getParameter("xml");
	boolean isXml = xml == null || !xml.equals("false");
	if (!isPrint && isXml) {
		response.setContentType("text/xml; charset=UTF-8");
		response.setHeader("Cache-Control", "no-cache");
	}

	String parentText = "";
	if (model != null && model.getParentId() != null) {
		parentText = "parent=\"" + model.getParentId() + "\"";
	}
	try {
%>


<%
	if (!isPrint) {
%>

<%@page import="java.util.Map.Entry"%>
<rows <%=parentText%>>
<%
	if (model != null) {
				GridColumn[] columns = model.getColumns();
				GridColumnFilter[] filters = model.getFilters();
%>
<head>    
  <%
      	if (initHeaderUrl.length() > 0) {
      %>
      <jsp:include page="<%=initHeaderUrl%>" flush="true" >
           <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
       </jsp:include>
   <%
   	} else if (columns != null && !dataOnly && model.isShowHeader()) {

   					if (model.useFilters()) {
   						boolean startActions = false;
   						StringBuffer attachHeaderParam = new StringBuffer();
   						StringBuffer attachHeaderStyles = new StringBuffer();
   						for (int i = 0; i < columns.length; i++) {
   							if (attachHeaderParam.length() > 0) {
   								attachHeaderParam.append(",");
   							}
   							if (attachHeaderStyles.length() > 0) {
   								attachHeaderStyles.append(",");
   							}
   							attachHeaderStyles.append("background-color:#d9dae7");
   							
   							GridColumnFilter filter = null;
   							for (int j = 0; filters != null && j < filters.length; j++) {
   								if (filters[j].getColumn() == i) {
   									filter = filters[j];
   									break;
   								}
   							}
   							if (filter != null) {
   								if (filter instanceof ContainGridColumnFilter) {
   									attachHeaderParam.append("#text_filter");
   								} else if (filter instanceof EqualsGridColumnFilter) {
   									attachHeaderParam.append("#select_filter");
   								} else {
   									attachHeaderParam.append("<div id='filterDiv" + i + suffix + "'></div>");
   								}
   							} else {
   								String clientFilter = columns[i].getClientColumnFilter();
   								if (clientFilter != null && clientFilter.length() > 0) {
   									if (clientFilter.equals(GridColumn.TEXT_CLIENT_FILTER)) {
   										attachHeaderParam.append("#text_filter");
   									} else if (clientFilter.equals(GridColumn.COMBO_CLIENT_FILTER)) {
   										attachHeaderParam.append("#combo_filter");
   									} else if (clientFilter.equals(GridColumn.SELECT_CLIENT_FILTER)) {
   										attachHeaderParam.append("#select_filter");
   									} else if (clientFilter.equals(GridColumn.NUMBER_CLIENT_FILTER)) {
   										attachHeaderParam.append("#numeric_filter");
   									} else {
   										attachHeaderParam.append(clientFilter);
   									}
   								} else if (model.getColumnType(i) == GridColumn.ACTION_TYPE) {
   									if (startActions) {
   										attachHeaderParam.append("#cspan");
   									} else {
   										attachHeaderParam.append("&nbsp;");
   										startActions = true;
   									}
   								} else if (model.getColumnAt(i).getName().equals(GridTableHelper.COLUMN_SPAN_STR)) {
   									attachHeaderParam.append("#cspan");
   									startActions = false;
   								} else {
   									attachHeaderParam.append("&nbsp;");
   									startActions = false;
   								}
   							}
   						}
   %> 
  	 <beforeInit>
            <call command="attachHeader">
                <param><![CDATA[<%=attachHeaderParam.toString()%>]]></param>
                <param><![CDATA[<%=attachHeaderStyles.toString()%>]]></param>                                               
            </call>
        </beforeInit>   
  	 <%
     	 	}
     	 					for (int i = 0; i < columns.length; i++) {
     	 %>
     <column width="<%=columns[i].getWidth()%>" type="<%=columns[i].getDataType()%>" align="<%=columns[i].getAlign()%>"  sort="<%=columns[i].getSortType()%>"><![CDATA[<%=columns[i].getName()%>]]></column>     
   <%
        	}
        				}
        %>
  </head>
 
 <%
  	for (int i = 0; i < model.getRowsCount(); i++) {
  		String rowStr = createRow(model,i,isXml);
  %>
	<%=rowStr%>	
	<%
		}
	%>
<%
	}
%>	
</rows>
<%
	} else if (model != null) {
%>

<style>
.tableprinttd {
	font-family:Tahoma;
	font-size:11px;
	padding-right:4px;
	padding-left:4px;
	padding-top:2px;
	padding-bottom:2px;
}

.tableprinthdr {
border: 1px solid;
	border-color : #FDFDFD #93AFBA #93AFBA #FDFDFD;
	background-color:transparent;
	font-family:Tahoma;
	font-size:11px;
	font-weight:bold;
	color:#055A78;
	vertical-align:top;
	text-align:left;
	padding-right:4px;
	padding-left:4px;
	padding-top:2px;
	padding-bottom:2px;
	background-color:lightgrey
	}
</style>
<table border="1" width="100%" cellpadding="0" cellspacing="0" height="100%">
<tr>
<%
	for (int i = 0; i < model.getColumnsCount(); i++) {
				GridColumn col = model.getColumnAt(i);
				String w = col.getWidth();
%>
<th class="tableprinthdr" width="<%=w%>" align="<%=col.getAlign()%>"><span class="REGULARTEXT"> <%=col.getName()%></span> </th>
<%
	}
%>
</tr>

<%
	for (int j = 0; j < model.getRowsCount(); j++) {
%>

<tr>
<%
	for (int i = 0; i < model.getColumnsCount(); i++) {
					GridColumn col = model.getColumnAt(i);
					String w = col.getWidth();
					GridValue value = model.getValueAt(j, i);
					String text = value == null ? "" : value.getGridText();
					String tooltip = value == null ? "" : value.getTooltip();
					boolean isHtml = col.isHTML();
					if (value instanceof LinkGridValue) {
						text = ((LinkGridValue) value).getName();
						text = "<a href=\"" + ((LinkGridValue) value).getLink() + "\" style=\"text-decoration: none\" " + (tooltip != null && tooltip.length() > 0 ? "title=\"" + tooltip + "\"" : "") + ">" + ((LinkGridValue) value).getName() + "</a>";
					}else if (col.getType() == GridColumn.IMG_TYPE){
						String [] args = text.split("\\^");
						text = "<img src=\"" + args[0] + "\">";
						isHtml = true;
					}
					if (text.length() == 0) {
						text = "&nbsp;";
					}else if (!isHtml && !(value instanceof LinkGridValue)){
						text = text.replaceAll("<", "&lt;");
						text = text.replaceAll(">", "&gt;");
					}
%>
		<td width="<%=w%>" align="<%=col.getAlign()%>"  class="tableprinttd"> <%=text%> </td>
<%
	}
%>
</tr>
<%
	}
%>
</table>

<%
	}

	} catch (Throwable e) {
		e.printStackTrace();
	}
%>