<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	static final String SCANNER_TYPE = "scanner";
%>

<%

	String PREFIX = "applicationWizard_";


  WebSecurityManager securityManager = WebSecurityManager.getInstance();
  if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,true)){
    return;
  }

	int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
	DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
	WizardApplicationViewControl view = (WizardApplicationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
	WizardInfo wizardInfo = builder.getWizardInfo();
	String wizardType = view.getWizardInfo().getType();
	
  String isEmbededStr = request.getParameter("isEmbeded");
  boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	String title = view.getProperty("title");
	if(title == null) {
		title = "Application Wizard";
	}
	
	String locationTypeDesc = view.getProperty("logTypeDesc","Select Application Location");
  String locationType = view.getLocationType();
	if(locationType == null || locationType.length() == 0) {
		locationType = "none";
	}
	
  String displayAccDiv = "none";
  Account account = view.getAccount();
  String accountId = "";
  if(account != null) {
  	accountId = account.getId();
  	displayAccDiv = "";
  }
  if(locationType.equals("auth") || locationType.equals("ssh")) {
  	displayAccDiv = "";
  }
  
  String displayLocationsDiv = "none";
  int locationsCntr = 1;
  String locationDesc = view.getProperty("locationDesc","Specify Application Path");
  String locationsPathsStr = "";
  File rootDir = view.getRootDirectory();
  if (rootDir == null && !wizardType.equals(SCANNER_TYPE)){
  	if (wizardInfo.getWizardSignatures() != null){
			String rootDirStr = null;
		 	if(XpologSystemInfo.isWindows()) {
			 	rootDirStr = wizardInfo.getFileLocationFromSignature("windows");
		 	}else {
			 	rootDirStr = wizardInfo.getFileLocationFromSignature("unix");
		 	}
		 	if (rootDirStr != null){
			 	rootDir = new File(rootDirStr);
		 	}
  	}
 	}
  if(rootDir != null) {
  	if(!locationType.equals("none")) {
  		displayLocationsDiv = "";
  	}
  	if(view.isMultiDir() && view.getMultiDirOrigRootDirString() != null) {
  		locationsPathsStr += view.getMultiDirOrigRootDirString();
  	}else {
  		locationsPathsStr += rootDir.getPath();
  	}
  	
  	if(wizardInfo.getAccount() != null && wizardInfo.getAccount() instanceof TelnetAccount){
  		locationsPathsStr = locationsPathsStr.replaceAll("\\\\","/");
 	  }
  }

  String displayAdvancedDiv = "none";
  if(!locationType.equals("none")) {
  	displayAdvancedDiv = "";
  }
  
  String filesToIncludeStr = "";
  String filesToExcludeStr = "";
  
  int scanLevel = -1;
  int scanMethod = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.admin.wizards.common.scanner.scanMethodDefault",WizardScannerViewControl.SCAN_METHOD_ALL);
  int namePatternLogic = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.admin.wizards.common.scanner.namePatternLogicDefault",WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO);
  if(view instanceof WizardScannerViewControl){
		WizardScannerViewControl _view = (WizardScannerViewControl)view;
	 	filesToIncludeStr = _view.getFilesToInclude();
	 	if(filesToIncludeStr == null) {
	 		filesToIncludeStr = "";
	 	}
	 	filesToExcludeStr = _view.getFilesToExclude();
	 	if(filesToExcludeStr == null) {
	 		filesToExcludeStr = "";
	 	}
	 	scanLevel = _view.getSubdirsScanLevel();
 		scanMethod = _view.getScanMethod();
 		namePatternLogic = _view.getNamePatternLogic();
  }
  
  boolean hideSSHType = false;
  if(wizardInfo.getID().equals("Microsoft_IIS")) {
  	hideSSHType = true;
  }
  
  UserContext userContext = UserEnvironment.getUserContext(request);

%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/wizards/common.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/wizards/locations.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/admin.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>

<script>
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
	var SCANNER_TYPE = "<%=SCANNER_TYPE%>";
	var PREFIX = "<%=PREFIX%>";
	var LOCATIONS_CNTR = <%=locationsCntr%>;
	var ON_CHANGE_ACTION = "updateHostFromAccount()";
	var DISPLAY_ACCOUNTS_DIV = "<%=displayAccDiv%>";
	var ACCOUNT_ID = "<%=accountId == null ? "" : accountId %>";
	
	// instantiate hasAddressBookPermissions - it is declared in accounts.js
	hasAddressBookPermissions = <%=userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)%>
	
	function init() {
		if(DISPLAY_ACCOUNTS_DIV == '' && ACCOUNT_ID == '') {
			changeLocationType(PREFIX,PREFIX + 'locationType',BASE_DIRECTORY)
		}
	}
	
	function doNext(){
		var wizardType = 'application';
		<%if(wizardType != null && wizardType.equals(SCANNER_TYPE)){ %>
			wizardType = 'scanner';
		<%}%>
		var isOk = checkWizardParams(wizardType);
		if(isOk) {
			clearFormErrors();
			updateHostFromPath();
			var path ="<%=view.getActionURL()%>&applicationDir=" + encodeURIComponent(document.getElementById(PREFIX + "fullPath_0").value);
	    <%
	    if (view.isUseAccount()){
	    %>
	    	var AccountsListElement = eval("document.access." + PREFIX + "AccountsList");
	    	if(AccountsListElement) {
	    		path = path + "&accountId=" + AccountsListElement.value;
		    }else {
		    	path = path + "&accountId=";
		    }
	    <%
	    }
	    %>
	    path = path + "&host=" + document.access.host.value;
	    path = path + "&prefix=" + document.access.prefix.value;
	    path = path + "&" + PREFIX + "locationType=" + eval("document.access." + PREFIX + "locationType").value;
	    <%
	    if (isEmbeded){
	    %>
	    	path = path + "&isEmbeded=true";
	    <%
	    }
	    %>
	    <%
	    if(wizardType != null && wizardType.equals(SCANNER_TYPE)){ 
	    %>
	    	var scanMethodValue;
	    	for(var i=0; i < document.access.scanMethod.length; i++) {
				   if(document.access.scanMethod[i].checked) {
				     scanMethodValue = document.access.scanMethod[i].value;
				   }
				}
				
				var namePatternLogic = "";
	    	for(var i=0; i < document.access.namePatternLogic.length; i++) {
				   if(document.access.namePatternLogic[i].checked) {
				     namePatternLogic = document.access.namePatternLogic[i].value;
				   }
				}
	    	path = path + "&includeFiles=" + document.access.includeFiles.value + "&excludeFiles=" + document.access.excludeFiles.value +
	     				 "&subdirScanLevel=" + document.access.subDirLevel.value + "&scanMethod=" + scanMethodValue + "&namePatternLogic=" + namePatternLogic;
	    <%
	    }
	    %>
	 		document.location = path;
	 	}
	}
	
	function updateHostFromPath(){
		var p = eval("document.access." + PREFIX + "fullPath_0").value;
		if (p && p.indexOf("\\\\") == 0){
			s = p.substr(2);
			var endIndex1 = s.indexOf("\\");
			var endIndex2 = p.indexOf("/");
			var endIndex = 0;
			if (endIndex1 != -1 || endIndex2 != -1){
				if (endIndex1 != -1 && (endIndex2 < 0 || endIndex1+2 < endIndex2)){
					endIndex = endIndex1 + 2;
				}else{
					endIndex = endIndex2;
				}
				if (endIndex > 0){
					document.access.host.value = p.substring(2,endIndex);
				}
			}
		}else if(p == ""){
			document.access.host.value = "";
		}
	}
	
	function updateHostFromAccount(){
		var accountsList = document.getElementById(PREFIX+"AccountsList");
		if(accountsList) {
			var accountId = accountsList.options[accountsList.selectedIndex].value;
			document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accountId;
		}
	}
	
	function handleNewAcc(accId){
	  document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accId;
  }
	
	function updateHostName(hostName)	{
		document.access.host.value = hostName;
	}
	
</script>

</head>

<body style="margin:0;padding:0" onLoad="javascript:init()">

<div id="addAccDiv" style="display:none">
</div>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input type="hidden" name="rootDir" id="rootDir">
<input type="hidden" name="host" id="host">
<input type="hidden" name="prefix" id="prefix" value="<%=PREFIX %>">

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../common/sysFilesBrowser.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="file_filter" value="dirOnly"/> 
</jsp:include>
			
<jsp:include page="../../common/addAccount.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="accDiv" value="accountId"/> 
</jsp:include>
			
<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=title%>" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td class="ADMIN_SECTION_HEADER" style="padding-left:5">Wizard Settings</td>
							</tr>
							<tr>
								<td>
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
												
													<tr>
														<td>
															<div id="<%=PREFIX%>locationTypeDiv" style="visibility:"> 			                    			                   
															<table border="0" cellpadding="0" cellspacing="0" width="100%">
																<tr>
																	<td width="23%"><span class="REGULARTEXT"><%=locationTypeDesc %></span></td>
																	<td width="77%">
																		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																			<tr>
																				<td>
																					<select class="TEXTBOX" id="<%=PREFIX%>locationType" name="<%=PREFIX%>locationType" onChange="javascript:changeLocationType('<%=PREFIX %>',this.name,'<%=BASE_DIRECTORY%>');">
																						<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>-- Select Location --</option>														
																						<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>
																						<%if (XpologSystemInfo.isWindows()){%>														
																						<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
																						<%}%>
																						<%if (!hideSSHType){%>														
																						<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
																						<%}%>
																					</select>			
																				</td>
																			</tr>																																															
																		</table>
																	</td>
																</tr>
																<tr>
																	<td colspan="2" style="padding-top:3">
																		<div id="<%=PREFIX%>locationTypeErrorMsg" style="display:none;" class="ERROR_MSG">
																		</div>
																	</td>
																</tr>
															</table>
															</div>
														</td>
													</tr>
													
													<tr>
														<td style="padding-top:10">
															<div id="<%=PREFIX%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
															<table border="0" cellpadding="0" cellspacing="0" width="100%">                                        
																<tr>
																	<td width="23%"><span class="REGULARTEXT">Connection Details</span></td>
																	<td width="77%">
																		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																			<tr>
																				<td width="100px">
																					<div id="<%=PREFIX%>accountsListDiv">
																						<%
																						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
																						%>
																						<jsp:include flush="true" page="<%=accountsListUrl %>">
																							<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
																							<jsp:param name="ACC_ID" value="<%=accountId%>"/>
																							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																							<jsp:param name="ON_CHANGE_ACTION" value="updateHostFromAccount()"/>
																							<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																						</jsp:include> 																								
																					</div>														                        
																				</td>
																				<%if(userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)) { %>
																				<td style="padding-left:5">
																					<div id="<%=PREFIX%>newAccountDiv">
																						<span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv('../../')" class="BUTTON_MEDIUMLINK">new</a></span>
																					</div>	
																				</td>
																				<%} %>
																				<td width="*">&nbsp;</td>
																			</tr>
																		</table>
																	</td>
																</tr>
																<tr>
																	<td colspan="2" style="padding-top:3">
																		<div id="<%=PREFIX%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
																		</div>
																	</td>
																</tr>
															</table>
															</div>  
														</td>
													</tr>
													
													<tr>
														<td style="padding-top:10">
															<div id="<%=PREFIX%>locationPathsDiv" style="display:<%=displayLocationsDiv%>"> 
																<jsp:include flush="true" page="locationPath.jsp">
																	<jsp:param name="baseDirectory" value="" />
																	<jsp:param name="LOCATIONS_CNTR" value="<%=locationsCntr%>"/>
																	<jsp:param name="LOCATION_DESC0" value="<%=locationDesc%>"/>
																	<jsp:param name="LOCATIONS_PATH_ARR" value="<%=locationsPathsStr%>"/>
																	<jsp:param name="PREFIX" value="<%=PREFIX%>"/>										
																</jsp:include>	                      
															</div>
														</td>
													</tr>
													
													<%
													if(wizardType != null && wizardType.equals(SCANNER_TYPE)){ 
													%>
													<tr>
														<td style="padding-top:30">
															<div id="<%=PREFIX%>advancedSettingsDiv" style="display:<%=displayAdvancedDiv%>">																				
																<table border="0" cellpadding="0" cellspacing="0" width="100%">
																	<tr>
																		<td>																										
																			<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR_HEADER">
																				<tr>
																					<td>																										
																						<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																							<jsp:param name="baseDirectory" value="../../" />
																							<jsp:param name="suffix" value="advancedSettings" />				
																							<jsp:param name="headerName" value="Advanced Settings" />
																							<jsp:param name="startOpen" value="false" />
																							<jsp:param name="showCheckBox" value="false" />
																							<jsp:param name="closeOthers" value="false" />
																							<jsp:param name="openOnClick" value="true" />
																						</jsp:include>
																					</td>
																				</tr>
																			</table>
																		</td>
																	</tr>
																	<tr>
																		<td>
																			<table border="0" id="adminHeaderContentadvancedSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">																				
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="<%=PREFIX%>advFilesFilters">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../" />
																														<jsp:param name="suffix" value="FilesFilters" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="Files Filters" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentFilesFilters" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																												<td width="24" style="padding-top:5">&nbsp;</td>
																												<td width="200"><span class="REGULARTEXT">Include files:</span></td>
																												<td width="200">
																													<input class="TEXTBOX" type="text" id="includeFiles" name="includeFiles" size="30" value="<%=filesToIncludeStr%>">
																												</td>
																												<td width="*">&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																											</tr>
																											<tr>
																												<td style="padding-top:5">&nbsp;</td>
																												<td><span class="REGULARTEXT">Exclude files:</span></td>
																												<td>
																													<input class="TEXTBOX" type="text" id="excludeFiles" name="excludeFiles" size="30" value="<%=filesToExcludeStr%>">
																												</td>
																												<td>&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																											</tr>
																											<tr>
																												<td style="padding-top:5">&nbsp;</td>
																												<td><span class="REGULARTEXT">Subdirectories levels to scan:</span></td>
																												<td>
																													<select id="subDirLevel" name="subDirLevel" class="TEXT_BOX" size="1">
																														<option value="1000" selected>Unlimited</option>
																														<%
																														for(int i=1 ; i < 11 ; i++){
																															String selected = i == scanLevel ? "selected" : "";
																														%>
																															<option value="<%=String.valueOf(i)%>" <%=selected%>><%=String.valueOf(i)%></option>
																														<%
																														}
																														%>
																													</select>	
																												</td>
																												<td>&nbsp;</td>
																											</tr>
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="<%=PREFIX%>advScanMethod">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../" />
																														<jsp:param name="suffix" value="ScanMethod" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="Scan Method" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentScanMethod" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td width="*">
																													<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ALL %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ALL ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names and content) and automatic matching</span>
																												</td>
																											</tr>
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td width="*">
																													<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ONLY_TEMPLATES %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ONLY_TEMPLATES ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names and content)</span>
																												</td>
																											</tr>
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td width="*">
																													<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ONLY_FILE_NAME %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ONLY_FILE_NAME ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names only)</span>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				
																				
																				
																				
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="<%=PREFIX%>advNamePattern">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../" />
																														<jsp:param name="suffix" value="NamePattern" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="Files Name Pattern" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentNamePattern" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td width="*">
																													<input id="namePatternLogic" name="namePatternLogic" type="radio" value="<%=WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO %>" <%=namePatternLogic == WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO ? "checked" : "" %>><span class="REGULARTEXT">Unite files with similar names (apply name pattern automatically)</span>
																												</td>
																											</tr>
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td width="*">
																													<input id="namePatternLogic" name="namePatternLogic" type="radio" value="<%=WizardScannerViewControl.NAME_PATTERN_LOGIC_NONE %>" <%=namePatternLogic == WizardScannerViewControl.NAME_PATTERN_LOGIC_NONE ? "checked" : "" %>><span class="REGULARTEXT">Capture each file separately &nbsp;(without name pattern)</span>
																												</td>
																											</tr>																											
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				
																				
																			</table>
																		</td>
																	</tr>
																</table>
															</div>
														</td>
													</tr>
													<%
													}
													%>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=wizards/wizardsview.jsp";
			if(wizardType != null && wizardType.equals(SCANNER_TYPE)){
				cancelAction = "common/actions/cancelAction.jsp";
			}
			String actions = "javascript:doNext()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Next#Cancel" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>