<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>

<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

	String PREFIX = "configurationFileWizard_";

	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,true)){
    return;
  }

	int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
	DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
	WizardConfigurationViewControl view = (WizardConfigurationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
  WizardInfo wizardInfo = builder.getWizardInfo();
	
  String isEmbededStr = request.getParameter("isEmbeded");
  boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

	String title = view.getProperty("title");
	if(title == null) {
		title = "Configuration File Wizard";
	}
	
	String locationTypeDesc = view.getProperty("logTypeDesc","Select Configuration Location");
	String locationType = view.getLocationType();
	if(locationType == null || locationType.length() == 0) {
		locationType = "none";
	}
	
	String displayAccDiv = "none";
  Account account = view.getAccount();
  String accountId = "";
  if(account != null) {
  	accountId = account.getId();
  	displayAccDiv = "";
  }
  if(locationType.equals("auth") || locationType.equals("ssh")) {
  	displayAccDiv = "";
  }
  
  String displayLocationsDiv = "none";
  int locationsCntr = 2;
  String locationDesc0 = view.getProperty("fileDesc","Configuration File Path");
  String locationDesc1 = view.getProperty("rootDirDesc","Configuration File Path");
  String locationsPathsStr = "";
  String configurationFile = view.getConfigFileStr();
  if(configurationFile != null) {
  	displayLocationsDiv = "";
  	locationsPathsStr += configurationFile + "@";
  }else {
  	locationsPathsStr += "empty@";
  }
  File rootDir = view.getRootDirectory();
  if(rootDir != null) {
  	displayLocationsDiv = "";
  	locationsPathsStr += rootDir.getPath();
  }else {
  	locationsPathsStr += "empty";
  }
  if(wizardInfo.getAccount() != null && wizardInfo.getAccount() instanceof TelnetAccount){
		locationsPathsStr = locationsPathsStr.replaceAll("\\\\","/");
	}

  UserContext userContext = UserEnvironment.getUserContext(request);
  
%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/wizards/common.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/wizards/locations.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>

<script>
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
	var PREFIX = "<%=PREFIX%>";
	var LOCATIONS_CNTR = <%=locationsCntr%>;
	var ON_CHANGE_ACTION = "updateHostFromAccount()";
	var DISPLAY_ACCOUNTS_DIV = "<%=displayAccDiv%>";
	var ACCOUNT_ID = "<%=accountId == null ? "" : accountId %>";
	
	// instantiate hasAddressBookPermissions - it is declared in accounts.js
	hasAddressBookPermissions = <%=userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)%>
	
	function init() {
		if(DISPLAY_ACCOUNTS_DIV == '' && ACCOUNT_ID == '') {
			changeLocationType(PREFIX,PREFIX + 'locationType',BASE_DIRECTORY)
		}
	}
	
	function doNext(){
		var isOk = checkWizardParams('configurationFile');
		if(isOk) {
			clearFormErrors();
			updateHostFromPath();
			var path ="<%=view.getActionURL()%>&configurationFile=" + document.getElementById(PREFIX + "fullPath_0").value + "&rootDir=" + document.getElementById(PREFIX + "fullPath_1").value;
	    <%
	    if (view.isUseAccount()){
	    %>
	    	var AccountsListElement = eval("document.access." + PREFIX + "AccountsList");
	    	if(AccountsListElement) {
	    		path = path + "&accountId=" + AccountsListElement.value;
		    }else {
		    	path = path + "&accountId=";
		    }
	    <%
	    }
	    %>
	    path = path + "&host=" + document.access.host.value;
	    path = path + "&prefix=" + document.access.prefix.value;
	    path = path + "&" + PREFIX + "locationType=" + eval("document.access." + PREFIX + "locationType").value;
	    <%
	    if (isEmbeded){
	    %>
	    	path = path + "&isEmbeded=true";
	    <%
	    }
	    %>
	 		document.location = path;
	 	}
	}
	
	function updateHostFromPath(){
		var p = eval("document.access." + PREFIX + "fullPath_0").value;
		if (p && p.indexOf("\\\\") == 0){
			s = p.substr(2);
			var endIndex1 = s.indexOf("\\");
			var endIndex2 = p.indexOf("/");
			var endIndex = 0;
			if (endIndex1 != -1 || endIndex2 != -1){
				if (endIndex1 != -1 && (endIndex2 < 0 || endIndex1+2 < endIndex2)){
					endIndex = endIndex1 + 2;
				}else{
					endIndex = endIndex2;
				}
				if (endIndex > 0){
					document.access.host.value = p.substring(2,endIndex);
				}
			}
		}else if(p == ""){
			document.access.host.value = "";
		}
	}
	
	function updateHostFromAccount(){
		var accountsList = document.getElementById(PREFIX+"AccountsList");
		if(accountsList) {
			var accountId = accountsList.options[accountsList.selectedIndex].value;
			document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accountId;
		}
	}
	
	function handleNewAcc(accId){
	  document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accId;
  }
	
	function updateHostName(hostName)	{
		document.access.host.value = hostName;
	}
	
</script>

</head>

<body style="margin:0;padding:0" onLoad="javascript:init()">

<div id="addAccDiv" style="display:none">
</div> 

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input type="hidden" name="rootDir" id="rootDir">
<input type="hidden" name="host" id="host">
<input type="hidden" name="prefix" id="prefix" value="<%=PREFIX %>">

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../common/sysFilesBrowser.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
</jsp:include>
			
<jsp:include page="../../common/addAccount.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="accDiv" value="accountId"/> 
</jsp:include>
			
<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=title%>" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td class="ADMIN_SECTION_HEADER" style="padding-left:5">Wizard Settings</td>
							</tr>
							<tr>
								<td>
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
												
													<tr>
														<td>
															<div id="<%=PREFIX%>locationTypeDiv" style="visibility:"> 			                    			                   
															<table border="0" cellpadding="0" cellspacing="0" width="100%">
																<tr>
																	<td width="26%"><span class="REGULARTEXT"><%=locationTypeDesc %></span></td>
																	<td width="74%">
																		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																			<tr>
																				<td>
																					<select class="TEXTBOX" id="<%=PREFIX%>locationType" name="<%=PREFIX%>locationType" onChange="javascript:changeLocationType('<%=PREFIX %>',this.name,'<%=BASE_DIRECTORY%>');">
																						<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>-- Select Location --</option>														
																						<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>														
																						<%if (XpologSystemInfo.isWindows()){%>														
																						<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
																						<%}%>
																						<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
																					</select>			
																				</td>
																			</tr>																																																	
																		</table>
																	</td>
																</tr>		
																<tr>
																	<td colspan="2" style="padding-top:3">
																		<div id="<%=PREFIX%>locationTypeErrorMsg" style="display:none;" class="ERROR_MSG">
																		</div>
																	</td>
																</tr>			                      
															</table>
															</div>
														</td>
													</tr>
													
													<tr>
														<td style="padding-top:10">
															<div id="<%=PREFIX%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
															<table border="0" cellpadding="0" cellspacing="0" width="100%">                                        
																<tr>
																	<td width="26%"><span class="REGULARTEXT">Connection Details</span></td>
																	<td width="74%">
																		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																			<tr>
																				<td width="100px">
																					<div id="<%=PREFIX%>accountsListDiv">
																						<%
																						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
																						%>
																						<jsp:include flush="true" page="<%=accountsListUrl %>">
																							<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
																							<jsp:param name="ACC_ID" value="<%=accountId%>"/>
																							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																							<jsp:param name="ON_CHANGE_ACTION" value="updateHostFromAccount()"/>
																							<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																						</jsp:include> 																								
																					</div>														                        
																				</td>
																				<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    															<td style="padding-left:5">
																					<div id="<%=PREFIX%>newAccountDiv">
																						<span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv('../../')" class="BUTTON_MEDIUMLINK">new</a></span>
																					</div>	
																				</td>
																				<%} %>
																				<td width="*">&nbsp;</td>
																			</tr>
																		</table>
																	</td>
																</tr>
																<tr>
																	<td colspan="2" style="padding-top:3">
																		<div id="<%=PREFIX%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
																		</div>
																	</td>
																</tr>
															</table>
															</div>  
														</td>
													</tr>
													
													<tr>
														<td style="padding-top:10">
															<div id="<%=PREFIX%>locationPathsDiv" style="display:<%=displayLocationsDiv%>"> 
																<jsp:include flush="true" page="locationPath.jsp">
																	<jsp:param name="baseDirectory" value="" />
																	<jsp:param name="LOCATIONS_CNTR" value="<%=locationsCntr%>"/>
																	<jsp:param name="LOCATION_DESC0" value="<%=locationDesc0%>"/>
																	<jsp:param name="LOCATION_DESC1" value="<%=locationDesc1%>"/>
																	<jsp:param name="LOCATIONS_PATH_ARR" value="<%=locationsPathsStr%>"/>
																	<jsp:param name="FILE_FILTER0" value=""/>
																	<jsp:param name="FILE_FILTER1" value="dirOnly"/>
																	<jsp:param name="LOCATION_DESC_MULTI_LINE" value="true"/>
																	<jsp:param name="PREFIX" value="<%=PREFIX%>"/>										
																</jsp:include>	                      
															</div>
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=wizards/wizardsview.jsp";
			
			String actions = "javascript:doNext()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Next#Cancel" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>