<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	
	String PREFIX = "listWizard_";

	int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
	DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
	WizardListViewControl view = (WizardListViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
	request.getSession().setAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT,builder);
	
	boolean isScanner = view.getPrev() instanceof WizardScannerViewControl;
	boolean showTagToApplication = false;
	if(view.getPrev() instanceof WizardScannerViewControl || view.getPrev() instanceof WizardConfigurationViewControl) {
		showTagToApplication = true;
	}
	
	WizardNode rootNode = view.getRootNode();
	List nodesList = new ArrayList();
	boolean hasResult = true;
	if (rootNode != null){
	   nodesList = WizardUtil.getNodesAsList(rootNode);
	   if(rootNode.getChildsCount() == 0) {
	  	 hasResult = false;
	   }
	}else {
		hasResult = false;
	}
	
	String title = view.getProperty("title","Wizard Admin");
	String listTitle = view.getProperty("listTitle","Wizard list");
	String listDesc = view.getProperty("listDesc","Select items to add and press next:");

	UserContext userContext = UserEnvironment.getUserContext(request);
	boolean allowNewFolder = true;
  if (userContext != null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION)){
  	allowNewFolder = false;
  }
	
	boolean allowNewApplication = true;
  if (userContext != null && !userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION)){
  	allowNewApplication = false;
  }
%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/wizards/common.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>

<script>
	var NodesList = new Array();

  <%
  for (int i = 0; i < nodesList.size(); i++) {
  	WizardUtil.NodeInfo info = (WizardUtil.NodeInfo)nodesList.get(i);
    if(info.node.getID() != null && info.node.getID().equals(WizardInfo.INTERNAL_ROOT_NODE_ID)) {
    	continue;
    }
  %>
    NodesList[NodesList.length] = "<%=info.key%>";
  <%
  }
  %>

  function selectChilds(node,preffix){
  	//if (!node.checked) return;
    var key = node.id.substring(preffix.length,node.id.length);
    for (var i = 0; i < NodesList.length; i++) {
    	if (NodesList[i].indexOf(key) == 0){
      	var n = document.getElementById(preffix + NodesList[i]);
        n.checked = node.checked;
      }
    }
    if (node.checked){
      markNodeParentsToRoot(node,preffix,true);
    }
   }
   
	function markNodeParentsToRoot(node,prefix,selected){
		if (!node || node == null){
	  	return;
	  }
    var key = node.id.substring(prefix.length,node.id.length);
    var ind = key.lastIndexOf("_");
    if (ind != -1){
     	key = key.substring(0,ind);
    }
		p = document.getElementById(prefix + key);
		if (!p) return;
		if (p.checked) return;
		
		p.checked = true;
		markNodeParentsToRoot(p,prefix,selected);
	}

	function doNext(){
		updateModAndLogsSelected();
		if (updateParentModule){
	  	updateParentModule(modtree,"MODULE_ID");
	  }
	  <%
	  if(showTagToApplication) {
	  %>
	  if(prepareApplicationToSubmit) {
	  	prepareApplicationToSubmit();
	  }
	  <%
	  }
	  %>
	  var isOk = checkListParams();
	  if(isOk) {
	    document.access.submit();
		}
	}
    
  function updateModAndLogsSelected(){
	  tree.dlmtr = "<<>>";
	  list = tree.getAllCheckedAndPartiallyChecked();  
		arr = list.split("<<>>");
		var selectedIds = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	 			s += "*";
			}
			if(selectedIds != "") {
				selectedIds += "<<>>";
			}
			selectedIds += s;
		}
		document.access.selectedIds.value = selectedIds;
	}
	
  function doPrevious(){
  	document.location = "<%=builder.getControler().getCurrent().getPrev().getViewURL()%>";
  } 
	
</script>

</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=view.getActionURL()%>" method="post" style="margin:0;padding:0">
<input type="hidden" name="selectedIds" id="selectedIds">
<input type="hidden" name="MODULE_ID" id="MODULE_ID" value="">
<input type="hidden" name="parentApplication" id="parentApplication">

<%
if (nodesList.size() > 0){
 WizardUtil.NodeInfo nodeInfo = (WizardUtil.NodeInfo)nodesList.get(0);
%>
<input type="hidden" name="LogIndex_<%=nodeInfo.key%>" id="LogIndex_<%=nodeInfo.key%>" value="on">
<%
}
Properties prop = view.getFormProperties();

for (Enumeration e = prop.propertyNames(); e.hasMoreElements();) {
  String key = e.nextElement().toString();
%>
  <input type="hidden" name="<%=key%>" id="<%=key%>" value="<%=prop.getProperty(key)%>">
<%
}
%>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=title%>" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td class="ADMIN_SECTION_HEADER" style="padding-left:5">General</td>
							</tr>
							<tr>
								<td>
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td>
															<jsp:include page="../../common/selectParentModule.jsp" flush="true">
																<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
																<jsp:param name="PARENT_MODULE_ID" value="" />
																<jsp:param name="treeName" value="modtree" />																
																<jsp:param name="titleColWidth" value="140" />
																<jsp:param name="useTextBox" value="true" />
																<jsp:param name="textBoxSize" value="50" />	
																<jsp:param name="allowNewFolder" value="<%=allowNewFolder %>" />
															</jsp:include>
														</td>
													</tr>
													<tr>
														<td style="padding-top:3">
															<div id="parentModuleErrorMsg" style="display:none;" class="ERROR_MSG">
															</div>
														</td>
													</tr>
													<%
													if(showTagToApplication) {
													%>
													<tr>
														<td style="padding-top:10">
															<jsp:include page="../../common/selectParentApplication.jsp" flush="true">
																<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
																<jsp:param name="OBJECT_TYPE" value="<%=XpoLogObjectTypes.LOG_TYPE%>" />
																<jsp:param name="titleColWidth" value="140" />
																<jsp:param name="useTextBox" value="true" />
																<jsp:param name="textBoxSize" value="50" />
																<jsp:param name="allowNewApplication" value="<%=allowNewApplication %>" />																																																																																																
															</jsp:include>
														</td>
													</tr>
													<%
													}
													%>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							
							<tr>
								<td class="ADMIN_SECTION_HEADER" style="padding-left:5;padding-top:10"><%=listTitle%></td>
							</tr>
							
							<tr>
								<td>
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
												  <tr>
				                    <td style="padding-top:10"><span class="REGULARTEXT"><%=listDesc%></span></td>
				                  </tr>
				                  
				                  <tr>
				                    <td style="padding-top:10">
				                    	<table border="0" cellpadding="0" cellspacing="0" width="100%">
				                    		<tr>
				                    			<td>
					                    			<div id="<%=PREFIX %>loadingDiv" style="display:none">
																			<span class="REGULARTEXT">Loading...</span>
																		</div>
				                    			</td>
				                    		</tr>
				                    	</table>
				                    </td>
				                  </tr>
				                  
				                  <tr>
				                    <td>
				                    	<table border="0" cellpadding="0" cellspacing="0" width="100%">
				                    		<tr>
				                    			<td class="REGULARTEXT">
					                    			<div id="treebox_tree"></div>
				                    			</td>
				                    		</tr>
				                    	</table>
				                    </td>
				                  </tr>
													<tr>
														<td style="padding-top:3">
															<div id="selectedIdsErrorMsg" style="display:none;" class="ERROR_MSG">
															</div>
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String saveAction = hasResult ? "javascript:doNext()#" : "";
			String cancelAction = "common/actions/cancelAction.jsp?forward=wizards/wizardsview.jsp";
			if(isScanner) {
				cancelAction = "common/actions/cancelAction.jsp";
			}
			String actionNames = hasResult ? "Previous#Save#Cancel" : "Previous#Cancel";
			String actions = "javascript:doPrevious()#" + saveAction + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="<%=actionNames %>" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>

<script>
	var tree=new dhtmlXTreeObject("treebox_tree","100%","100%","0");
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);		
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setIconSize(13,13);
	tree.enableTreeLines(false);
	tree.loadingDiv="<%=PREFIX%>loadingDiv";
	tree.setXMLAutoLoading("wizardLogsTreeXML.jsp?position=<%=String.valueOf(position)%>");
	tree.loadXML("wizardLogsTreeXML.jsp?position=<%=String.valueOf(position)%>");
	
</script>

</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>